import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AcmCertificateValidationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly certificateArn: string;
    /**
     * @stability stable
     */
    readonly validationRecordFqdns?: string[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: AcmCertificateValidationTimeouts;
}
/**
 * @stability stable
 */
export interface AcmCertificateValidationTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
}
/**
 * @stability stable
 */
export declare class AcmCertificateValidation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AcmCertificateValidationConfig);
    private _certificateArn;
    /**
     * @stability stable
     */
    get certificateArn(): string;
    /**
     * @stability stable
     */
    set certificateArn(value: string);
    /**
     * @stability stable
     */
    get certificateArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _validationRecordFqdns?;
    /**
     * @stability stable
     */
    get validationRecordFqdns(): string[];
    /**
     * @stability stable
     */
    set validationRecordFqdns(value: string[]);
    /**
     * @stability stable
     */
    resetValidationRecordFqdns(): void;
    /**
     * @stability stable
     */
    get validationRecordFqdnsInput(): string[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): AcmCertificateValidationTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: AcmCertificateValidationTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): AcmCertificateValidationTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
