import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AcmCertificateConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly certificateAuthorityArn?: string;
    /**
     * @stability stable
     */
    readonly certificateBody?: string;
    /**
     * @stability stable
     */
    readonly certificateChain?: string;
    /**
     * @stability stable
     */
    readonly domainName?: string;
    /**
     * @stability stable
     */
    readonly privateKey?: string;
    /**
     * @stability stable
     */
    readonly subjectAlternativeNames?: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly validationMethod?: string;
    /**
     * options block.
     *
     * @stability stable
     */
    readonly options?: AcmCertificateOptions[];
}
/**
 * @stability stable
 */
export declare class AcmCertificateDomainValidationOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    get resourceRecordName(): string;
    /**
     * @stability stable
     */
    get resourceRecordType(): string;
    /**
     * @stability stable
     */
    get resourceRecordValue(): string;
}
/**
 * @stability stable
 */
export interface AcmCertificateOptions {
    /**
     * @stability stable
     */
    readonly certificateTransparencyLoggingPreference?: string;
}
/**
 * @stability stable
 */
export declare class AcmCertificate extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: AcmCertificateConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _certificateAuthorityArn?;
    /**
     * @stability stable
     */
    get certificateAuthorityArn(): string;
    /**
     * @stability stable
     */
    set certificateAuthorityArn(value: string);
    /**
     * @stability stable
     */
    resetCertificateAuthorityArn(): void;
    /**
     * @stability stable
     */
    get certificateAuthorityArnInput(): string | undefined;
    private _certificateBody?;
    /**
     * @stability stable
     */
    get certificateBody(): string;
    /**
     * @stability stable
     */
    set certificateBody(value: string);
    /**
     * @stability stable
     */
    resetCertificateBody(): void;
    /**
     * @stability stable
     */
    get certificateBodyInput(): string | undefined;
    private _certificateChain?;
    /**
     * @stability stable
     */
    get certificateChain(): string;
    /**
     * @stability stable
     */
    set certificateChain(value: string);
    /**
     * @stability stable
     */
    resetCertificateChain(): void;
    /**
     * @stability stable
     */
    get certificateChainInput(): string | undefined;
    private _domainName?;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    resetDomainName(): void;
    /**
     * @stability stable
     */
    get domainNameInput(): string | undefined;
    /**
     * @stability stable
     */
    domainValidationOptions(index: string): AcmCertificateDomainValidationOptions;
    /**
     * @stability stable
     */
    get id(): string;
    private _privateKey?;
    /**
     * @stability stable
     */
    get privateKey(): string;
    /**
     * @stability stable
     */
    set privateKey(value: string);
    /**
     * @stability stable
     */
    resetPrivateKey(): void;
    /**
     * @stability stable
     */
    get privateKeyInput(): string | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    private _subjectAlternativeNames?;
    /**
     * @stability stable
     */
    get subjectAlternativeNames(): string[];
    /**
     * @stability stable
     */
    set subjectAlternativeNames(value: string[]);
    /**
     * @stability stable
     */
    resetSubjectAlternativeNames(): void;
    /**
     * @stability stable
     */
    get subjectAlternativeNamesInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get validationEmails(): string[];
    private _validationMethod?;
    /**
     * @stability stable
     */
    get validationMethod(): string;
    /**
     * @stability stable
     */
    set validationMethod(value: string);
    /**
     * @stability stable
     */
    resetValidationMethod(): void;
    /**
     * @stability stable
     */
    get validationMethodInput(): string | undefined;
    private _options?;
    /**
     * @stability stable
     */
    get options(): AcmCertificateOptions[];
    /**
     * @stability stable
     */
    set options(value: AcmCertificateOptions[]);
    /**
     * @stability stable
     */
    resetOptions(): void;
    /**
     * @stability stable
     */
    get optionsInput(): AcmCertificateOptions[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
