import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AcmpcaCertificateAuthorityConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly permanentDeletionTimeInDays?: number;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly type?: string;
    /**
     * certificate_authority_configuration block.
     *
     * @stability stable
     */
    readonly certificateAuthorityConfiguration: AcmpcaCertificateAuthorityCertificateAuthorityConfiguration[];
    /**
     * revocation_configuration block.
     *
     * @stability stable
     */
    readonly revocationConfiguration?: AcmpcaCertificateAuthorityRevocationConfiguration[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: AcmpcaCertificateAuthorityTimeouts;
}
/**
 * @stability stable
 */
export interface AcmpcaCertificateAuthorityCertificateAuthorityConfigurationSubject {
    /**
     * @stability stable
     */
    readonly commonName?: string;
    /**
     * @stability stable
     */
    readonly country?: string;
    /**
     * @stability stable
     */
    readonly distinguishedNameQualifier?: string;
    /**
     * @stability stable
     */
    readonly generationQualifier?: string;
    /**
     * @stability stable
     */
    readonly givenName?: string;
    /**
     * @stability stable
     */
    readonly initials?: string;
    /**
     * @stability stable
     */
    readonly locality?: string;
    /**
     * @stability stable
     */
    readonly organization?: string;
    /**
     * @stability stable
     */
    readonly organizationalUnit?: string;
    /**
     * @stability stable
     */
    readonly pseudonym?: string;
    /**
     * @stability stable
     */
    readonly state?: string;
    /**
     * @stability stable
     */
    readonly surname?: string;
    /**
     * @stability stable
     */
    readonly title?: string;
}
/**
 * @stability stable
 */
export interface AcmpcaCertificateAuthorityCertificateAuthorityConfiguration {
    /**
     * @stability stable
     */
    readonly keyAlgorithm: string;
    /**
     * @stability stable
     */
    readonly signingAlgorithm: string;
    /**
     * subject block.
     *
     * @stability stable
     */
    readonly subject: AcmpcaCertificateAuthorityCertificateAuthorityConfigurationSubject[];
}
/**
 * @stability stable
 */
export interface AcmpcaCertificateAuthorityRevocationConfigurationCrlConfiguration {
    /**
     * @stability stable
     */
    readonly customCname?: string;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly expirationInDays: number;
    /**
     * @stability stable
     */
    readonly s3BucketName?: string;
}
/**
 * @stability stable
 */
export interface AcmpcaCertificateAuthorityRevocationConfiguration {
    /**
     * crl_configuration block.
     *
     * @stability stable
     */
    readonly crlConfiguration?: AcmpcaCertificateAuthorityRevocationConfigurationCrlConfiguration[];
}
/**
 * @stability stable
 */
export interface AcmpcaCertificateAuthorityTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
}
/**
 * @stability stable
 */
export declare class AcmpcaCertificateAuthority extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AcmpcaCertificateAuthorityConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get certificate(): string;
    /**
     * @stability stable
     */
    get certificateChain(): string;
    /**
     * @stability stable
     */
    get certificateSigningRequest(): string;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get notAfter(): string;
    /**
     * @stability stable
     */
    get notBefore(): string;
    private _permanentDeletionTimeInDays?;
    /**
     * @stability stable
     */
    get permanentDeletionTimeInDays(): number;
    /**
     * @stability stable
     */
    set permanentDeletionTimeInDays(value: number);
    /**
     * @stability stable
     */
    resetPermanentDeletionTimeInDays(): void;
    /**
     * @stability stable
     */
    get permanentDeletionTimeInDaysInput(): number | undefined;
    /**
     * @stability stable
     */
    get serial(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _certificateAuthorityConfiguration;
    /**
     * @stability stable
     */
    get certificateAuthorityConfiguration(): AcmpcaCertificateAuthorityCertificateAuthorityConfiguration[];
    /**
     * @stability stable
     */
    set certificateAuthorityConfiguration(value: AcmpcaCertificateAuthorityCertificateAuthorityConfiguration[]);
    /**
     * @stability stable
     */
    get certificateAuthorityConfigurationInput(): AcmpcaCertificateAuthorityCertificateAuthorityConfiguration[];
    private _revocationConfiguration?;
    /**
     * @stability stable
     */
    get revocationConfiguration(): AcmpcaCertificateAuthorityRevocationConfiguration[];
    /**
     * @stability stable
     */
    set revocationConfiguration(value: AcmpcaCertificateAuthorityRevocationConfiguration[]);
    /**
     * @stability stable
     */
    resetRevocationConfiguration(): void;
    /**
     * @stability stable
     */
    get revocationConfigurationInput(): AcmpcaCertificateAuthorityRevocationConfiguration[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): AcmpcaCertificateAuthorityTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: AcmpcaCertificateAuthorityTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): AcmpcaCertificateAuthorityTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
