import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AcmpcaCertificateConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly certificateAuthorityArn: string;
    /**
     * @stability stable
     */
    readonly certificateSigningRequest: string;
    /**
     * @stability stable
     */
    readonly signingAlgorithm: string;
    /**
     * @stability stable
     */
    readonly templateArn?: string;
    /**
     * validity block.
     *
     * @stability stable
     */
    readonly validity: AcmpcaCertificateValidity[];
}
/**
 * @stability stable
 */
export interface AcmpcaCertificateValidity {
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export declare class AcmpcaCertificate extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AcmpcaCertificateConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get certificate(): string;
    private _certificateAuthorityArn;
    /**
     * @stability stable
     */
    get certificateAuthorityArn(): string;
    /**
     * @stability stable
     */
    set certificateAuthorityArn(value: string);
    /**
     * @stability stable
     */
    get certificateAuthorityArnInput(): string;
    /**
     * @stability stable
     */
    get certificateChain(): string;
    private _certificateSigningRequest;
    /**
     * @stability stable
     */
    get certificateSigningRequest(): string;
    /**
     * @stability stable
     */
    set certificateSigningRequest(value: string);
    /**
     * @stability stable
     */
    get certificateSigningRequestInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _signingAlgorithm;
    /**
     * @stability stable
     */
    get signingAlgorithm(): string;
    /**
     * @stability stable
     */
    set signingAlgorithm(value: string);
    /**
     * @stability stable
     */
    get signingAlgorithmInput(): string;
    private _templateArn?;
    /**
     * @stability stable
     */
    get templateArn(): string;
    /**
     * @stability stable
     */
    set templateArn(value: string);
    /**
     * @stability stable
     */
    resetTemplateArn(): void;
    /**
     * @stability stable
     */
    get templateArnInput(): string | undefined;
    private _validity;
    /**
     * @stability stable
     */
    get validity(): AcmpcaCertificateValidity[];
    /**
     * @stability stable
     */
    set validity(value: AcmpcaCertificateValidity[]);
    /**
     * @stability stable
     */
    get validityInput(): AcmpcaCertificateValidity[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
