import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AlbListenerRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly listenerArn: string;
    /**
     * @stability stable
     */
    readonly priority?: number;
    /**
     * action block.
     *
     * @stability stable
     */
    readonly action: AlbListenerRuleAction[];
    /**
     * condition block.
     *
     * @stability stable
     */
    readonly condition: AlbListenerRuleCondition[];
}
/**
 * @stability stable
 */
export interface AlbListenerRuleActionAuthenticateCognito {
    /**
     * @stability stable
     */
    readonly authenticationRequestExtraParams?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly onUnauthenticatedRequest?: string;
    /**
     * @stability stable
     */
    readonly scope?: string;
    /**
     * @stability stable
     */
    readonly sessionCookieName?: string;
    /**
     * @stability stable
     */
    readonly sessionTimeout?: number;
    /**
     * @stability stable
     */
    readonly userPoolArn: string;
    /**
     * @stability stable
     */
    readonly userPoolClientId: string;
    /**
     * @stability stable
     */
    readonly userPoolDomain: string;
}
/**
 * @stability stable
 */
export interface AlbListenerRuleActionAuthenticateOidc {
    /**
     * @stability stable
     */
    readonly authenticationRequestExtraParams?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly authorizationEndpoint: string;
    /**
     * @stability stable
     */
    readonly clientId: string;
    /**
     * @stability stable
     */
    readonly clientSecret: string;
    /**
     * @stability stable
     */
    readonly issuer: string;
    /**
     * @stability stable
     */
    readonly onUnauthenticatedRequest?: string;
    /**
     * @stability stable
     */
    readonly scope?: string;
    /**
     * @stability stable
     */
    readonly sessionCookieName?: string;
    /**
     * @stability stable
     */
    readonly sessionTimeout?: number;
    /**
     * @stability stable
     */
    readonly tokenEndpoint: string;
    /**
     * @stability stable
     */
    readonly userInfoEndpoint: string;
}
/**
 * @stability stable
 */
export interface AlbListenerRuleActionFixedResponse {
    /**
     * @stability stable
     */
    readonly contentType: string;
    /**
     * @stability stable
     */
    readonly messageBody?: string;
    /**
     * @stability stable
     */
    readonly statusCode?: string;
}
/**
 * @stability stable
 */
export interface AlbListenerRuleActionForwardStickiness {
    /**
     * @stability stable
     */
    readonly duration: number;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
}
/**
 * @stability stable
 */
export interface AlbListenerRuleActionForwardTargetGroup {
    /**
     * @stability stable
     */
    readonly arn: string;
    /**
     * @stability stable
     */
    readonly weight?: number;
}
/**
 * @stability stable
 */
export interface AlbListenerRuleActionForward {
    /**
     * stickiness block.
     *
     * @stability stable
     */
    readonly stickiness?: AlbListenerRuleActionForwardStickiness[];
    /**
     * target_group block.
     *
     * @stability stable
     */
    readonly targetGroup: AlbListenerRuleActionForwardTargetGroup[];
}
/**
 * @stability stable
 */
export interface AlbListenerRuleActionRedirect {
    /**
     * @stability stable
     */
    readonly host?: string;
    /**
     * @stability stable
     */
    readonly path?: string;
    /**
     * @stability stable
     */
    readonly port?: string;
    /**
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * @stability stable
     */
    readonly query?: string;
    /**
     * @stability stable
     */
    readonly statusCode: string;
}
/**
 * @stability stable
 */
export interface AlbListenerRuleAction {
    /**
     * @stability stable
     */
    readonly order?: number;
    /**
     * @stability stable
     */
    readonly targetGroupArn?: string;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * authenticate_cognito block.
     *
     * @stability stable
     */
    readonly authenticateCognito?: AlbListenerRuleActionAuthenticateCognito[];
    /**
     * authenticate_oidc block.
     *
     * @stability stable
     */
    readonly authenticateOidc?: AlbListenerRuleActionAuthenticateOidc[];
    /**
     * fixed_response block.
     *
     * @stability stable
     */
    readonly fixedResponse?: AlbListenerRuleActionFixedResponse[];
    /**
     * forward block.
     *
     * @stability stable
     */
    readonly forward?: AlbListenerRuleActionForward[];
    /**
     * redirect block.
     *
     * @stability stable
     */
    readonly redirect?: AlbListenerRuleActionRedirect[];
}
/**
 * @stability stable
 */
export interface AlbListenerRuleConditionHostHeader {
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface AlbListenerRuleConditionHttpHeader {
    /**
     * @stability stable
     */
    readonly httpHeaderName: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface AlbListenerRuleConditionHttpRequestMethod {
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface AlbListenerRuleConditionPathPattern {
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface AlbListenerRuleConditionQueryString {
    /**
     * @stability stable
     */
    readonly key?: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface AlbListenerRuleConditionSourceIp {
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface AlbListenerRuleCondition {
    /**
     * host_header block.
     *
     * @stability stable
     */
    readonly hostHeader?: AlbListenerRuleConditionHostHeader[];
    /**
     * http_header block.
     *
     * @stability stable
     */
    readonly httpHeader?: AlbListenerRuleConditionHttpHeader[];
    /**
     * http_request_method block.
     *
     * @stability stable
     */
    readonly httpRequestMethod?: AlbListenerRuleConditionHttpRequestMethod[];
    /**
     * path_pattern block.
     *
     * @stability stable
     */
    readonly pathPattern?: AlbListenerRuleConditionPathPattern[];
    /**
     * query_string block.
     *
     * @stability stable
     */
    readonly queryString?: AlbListenerRuleConditionQueryString[];
    /**
     * source_ip block.
     *
     * @stability stable
     */
    readonly sourceIp?: AlbListenerRuleConditionSourceIp[];
}
/**
 * @stability stable
 */
export declare class AlbListenerRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AlbListenerRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _listenerArn;
    /**
     * @stability stable
     */
    get listenerArn(): string;
    /**
     * @stability stable
     */
    set listenerArn(value: string);
    /**
     * @stability stable
     */
    get listenerArnInput(): string;
    private _priority?;
    /**
     * @stability stable
     */
    get priority(): number;
    /**
     * @stability stable
     */
    set priority(value: number);
    /**
     * @stability stable
     */
    resetPriority(): void;
    /**
     * @stability stable
     */
    get priorityInput(): number | undefined;
    private _action;
    /**
     * @stability stable
     */
    get action(): AlbListenerRuleAction[];
    /**
     * @stability stable
     */
    set action(value: AlbListenerRuleAction[]);
    /**
     * @stability stable
     */
    get actionInput(): AlbListenerRuleAction[];
    private _condition;
    /**
     * @stability stable
     */
    get condition(): AlbListenerRuleCondition[];
    /**
     * @stability stable
     */
    set condition(value: AlbListenerRuleCondition[]);
    /**
     * @stability stable
     */
    get conditionInput(): AlbListenerRuleCondition[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
