import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AlbConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly customerOwnedIpv4Pool?: string;
    /**
     * @stability stable
     */
    readonly dropInvalidHeaderFields?: boolean;
    /**
     * @stability stable
     */
    readonly enableCrossZoneLoadBalancing?: boolean;
    /**
     * @stability stable
     */
    readonly enableDeletionProtection?: boolean;
    /**
     * @stability stable
     */
    readonly enableHttp2?: boolean;
    /**
     * @stability stable
     */
    readonly idleTimeout?: number;
    /**
     * @stability stable
     */
    readonly internal?: boolean;
    /**
     * @stability stable
     */
    readonly ipAddressType?: string;
    /**
     * @stability stable
     */
    readonly loadBalancerType?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * @stability stable
     */
    readonly subnets?: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * access_logs block.
     *
     * @stability stable
     */
    readonly accessLogs?: AlbAccessLogs[];
    /**
     * subnet_mapping block.
     *
     * @stability stable
     */
    readonly subnetMapping?: AlbSubnetMapping[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: AlbTimeouts;
}
/**
 * @stability stable
 */
export interface AlbAccessLogs {
    /**
     * @stability stable
     */
    readonly bucket: string;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly prefix?: string;
}
/**
 * @stability stable
 */
export interface AlbSubnetMapping {
    /**
     * @stability stable
     */
    readonly allocationId?: string;
    /**
     * @stability stable
     */
    readonly ipv6Address?: string;
    /**
     * @stability stable
     */
    readonly privateIpv4Address?: string;
    /**
     * @stability stable
     */
    readonly subnetId: string;
}
/**
 * @stability stable
 */
export interface AlbTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class Alb extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: AlbConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get arnSuffix(): string;
    private _customerOwnedIpv4Pool?;
    /**
     * @stability stable
     */
    get customerOwnedIpv4Pool(): string;
    /**
     * @stability stable
     */
    set customerOwnedIpv4Pool(value: string);
    /**
     * @stability stable
     */
    resetCustomerOwnedIpv4Pool(): void;
    /**
     * @stability stable
     */
    get customerOwnedIpv4PoolInput(): string | undefined;
    /**
     * @stability stable
     */
    get dnsName(): string;
    private _dropInvalidHeaderFields?;
    /**
     * @stability stable
     */
    get dropInvalidHeaderFields(): boolean;
    /**
     * @stability stable
     */
    set dropInvalidHeaderFields(value: boolean);
    /**
     * @stability stable
     */
    resetDropInvalidHeaderFields(): void;
    /**
     * @stability stable
     */
    get dropInvalidHeaderFieldsInput(): boolean | undefined;
    private _enableCrossZoneLoadBalancing?;
    /**
     * @stability stable
     */
    get enableCrossZoneLoadBalancing(): boolean;
    /**
     * @stability stable
     */
    set enableCrossZoneLoadBalancing(value: boolean);
    /**
     * @stability stable
     */
    resetEnableCrossZoneLoadBalancing(): void;
    /**
     * @stability stable
     */
    get enableCrossZoneLoadBalancingInput(): boolean | undefined;
    private _enableDeletionProtection?;
    /**
     * @stability stable
     */
    get enableDeletionProtection(): boolean;
    /**
     * @stability stable
     */
    set enableDeletionProtection(value: boolean);
    /**
     * @stability stable
     */
    resetEnableDeletionProtection(): void;
    /**
     * @stability stable
     */
    get enableDeletionProtectionInput(): boolean | undefined;
    private _enableHttp2?;
    /**
     * @stability stable
     */
    get enableHttp2(): boolean;
    /**
     * @stability stable
     */
    set enableHttp2(value: boolean);
    /**
     * @stability stable
     */
    resetEnableHttp2(): void;
    /**
     * @stability stable
     */
    get enableHttp2Input(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _idleTimeout?;
    /**
     * @stability stable
     */
    get idleTimeout(): number;
    /**
     * @stability stable
     */
    set idleTimeout(value: number);
    /**
     * @stability stable
     */
    resetIdleTimeout(): void;
    /**
     * @stability stable
     */
    get idleTimeoutInput(): number | undefined;
    private _internal?;
    /**
     * @stability stable
     */
    get internal(): boolean;
    /**
     * @stability stable
     */
    set internal(value: boolean);
    /**
     * @stability stable
     */
    resetInternal(): void;
    /**
     * @stability stable
     */
    get internalInput(): boolean | undefined;
    private _ipAddressType?;
    /**
     * @stability stable
     */
    get ipAddressType(): string;
    /**
     * @stability stable
     */
    set ipAddressType(value: string);
    /**
     * @stability stable
     */
    resetIpAddressType(): void;
    /**
     * @stability stable
     */
    get ipAddressTypeInput(): string | undefined;
    private _loadBalancerType?;
    /**
     * @stability stable
     */
    get loadBalancerType(): string;
    /**
     * @stability stable
     */
    set loadBalancerType(value: string);
    /**
     * @stability stable
     */
    resetLoadBalancerType(): void;
    /**
     * @stability stable
     */
    get loadBalancerTypeInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _securityGroups?;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    set securityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroups(): void;
    /**
     * @stability stable
     */
    get securityGroupsInput(): string[] | undefined;
    private _subnets?;
    /**
     * @stability stable
     */
    get subnets(): string[];
    /**
     * @stability stable
     */
    set subnets(value: string[]);
    /**
     * @stability stable
     */
    resetSubnets(): void;
    /**
     * @stability stable
     */
    get subnetsInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    get zoneId(): string;
    private _accessLogs?;
    /**
     * @stability stable
     */
    get accessLogs(): AlbAccessLogs[];
    /**
     * @stability stable
     */
    set accessLogs(value: AlbAccessLogs[]);
    /**
     * @stability stable
     */
    resetAccessLogs(): void;
    /**
     * @stability stable
     */
    get accessLogsInput(): AlbAccessLogs[] | undefined;
    private _subnetMapping?;
    /**
     * @stability stable
     */
    get subnetMapping(): AlbSubnetMapping[];
    /**
     * @stability stable
     */
    set subnetMapping(value: AlbSubnetMapping[]);
    /**
     * @stability stable
     */
    resetSubnetMapping(): void;
    /**
     * @stability stable
     */
    get subnetMappingInput(): AlbSubnetMapping[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): AlbTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: AlbTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): AlbTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
