import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AmiCopyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly sourceAmiId: string;
    /**
     * @stability stable
     */
    readonly sourceAmiRegion: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * ebs_block_device block.
     *
     * @stability stable
     */
    readonly ebsBlockDevice?: AmiCopyEbsBlockDevice[];
    /**
     * ephemeral_block_device block.
     *
     * @stability stable
     */
    readonly ephemeralBlockDevice?: AmiCopyEphemeralBlockDevice[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: AmiCopyTimeouts;
}
/**
 * @stability stable
 */
export interface AmiCopyEbsBlockDevice {
}
/**
 * @stability stable
 */
export interface AmiCopyEphemeralBlockDevice {
}
/**
 * @stability stable
 */
export interface AmiCopyTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class AmiCopy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AmiCopyConfig);
    /**
     * @stability stable
     */
    get architecture(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get enaSupport(): boolean;
    private _encrypted?;
    /**
     * @stability stable
     */
    get encrypted(): boolean;
    /**
     * @stability stable
     */
    set encrypted(value: boolean);
    /**
     * @stability stable
     */
    resetEncrypted(): void;
    /**
     * @stability stable
     */
    get encryptedInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get hypervisor(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get imageLocation(): string;
    /**
     * @stability stable
     */
    get imageOwnerAlias(): string;
    /**
     * @stability stable
     */
    get imageType(): string;
    /**
     * @stability stable
     */
    get kernelId(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get manageEbsSnapshots(): boolean;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    get platform(): string;
    /**
     * @stability stable
     */
    get platformDetails(): string;
    /**
     * @stability stable
     */
    get public(): boolean;
    /**
     * @stability stable
     */
    get ramdiskId(): string;
    /**
     * @stability stable
     */
    get rootDeviceName(): string;
    /**
     * @stability stable
     */
    get rootSnapshotId(): string;
    private _sourceAmiId;
    /**
     * @stability stable
     */
    get sourceAmiId(): string;
    /**
     * @stability stable
     */
    set sourceAmiId(value: string);
    /**
     * @stability stable
     */
    get sourceAmiIdInput(): string;
    private _sourceAmiRegion;
    /**
     * @stability stable
     */
    get sourceAmiRegion(): string;
    /**
     * @stability stable
     */
    set sourceAmiRegion(value: string);
    /**
     * @stability stable
     */
    get sourceAmiRegionInput(): string;
    /**
     * @stability stable
     */
    get sriovNetSupport(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get usageOperation(): string;
    /**
     * @stability stable
     */
    get virtualizationType(): string;
    private _ebsBlockDevice?;
    /**
     * @stability stable
     */
    get ebsBlockDevice(): AmiCopyEbsBlockDevice[];
    /**
     * @stability stable
     */
    set ebsBlockDevice(value: AmiCopyEbsBlockDevice[]);
    /**
     * @stability stable
     */
    resetEbsBlockDevice(): void;
    /**
     * @stability stable
     */
    get ebsBlockDeviceInput(): AmiCopyEbsBlockDevice[] | undefined;
    private _ephemeralBlockDevice?;
    /**
     * @stability stable
     */
    get ephemeralBlockDevice(): AmiCopyEphemeralBlockDevice[];
    /**
     * @stability stable
     */
    set ephemeralBlockDevice(value: AmiCopyEphemeralBlockDevice[]);
    /**
     * @stability stable
     */
    resetEphemeralBlockDevice(): void;
    /**
     * @stability stable
     */
    get ephemeralBlockDeviceInput(): AmiCopyEphemeralBlockDevice[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): AmiCopyTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: AmiCopyTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): AmiCopyTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
