import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AmiFromInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly snapshotWithoutReboot?: boolean;
    /**
     * @stability stable
     */
    readonly sourceInstanceId: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * ebs_block_device block.
     *
     * @stability stable
     */
    readonly ebsBlockDevice?: AmiFromInstanceEbsBlockDevice[];
    /**
     * ephemeral_block_device block.
     *
     * @stability stable
     */
    readonly ephemeralBlockDevice?: AmiFromInstanceEphemeralBlockDevice[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: AmiFromInstanceTimeouts;
}
/**
 * @stability stable
 */
export interface AmiFromInstanceEbsBlockDevice {
}
/**
 * @stability stable
 */
export interface AmiFromInstanceEphemeralBlockDevice {
}
/**
 * @stability stable
 */
export interface AmiFromInstanceTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class AmiFromInstance extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AmiFromInstanceConfig);
    /**
     * @stability stable
     */
    get architecture(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get enaSupport(): boolean;
    /**
     * @stability stable
     */
    get hypervisor(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get imageLocation(): string;
    /**
     * @stability stable
     */
    get imageOwnerAlias(): string;
    /**
     * @stability stable
     */
    get imageType(): string;
    /**
     * @stability stable
     */
    get kernelId(): string;
    /**
     * @stability stable
     */
    get manageEbsSnapshots(): boolean;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    get platform(): string;
    /**
     * @stability stable
     */
    get platformDetails(): string;
    /**
     * @stability stable
     */
    get public(): boolean;
    /**
     * @stability stable
     */
    get ramdiskId(): string;
    /**
     * @stability stable
     */
    get rootDeviceName(): string;
    /**
     * @stability stable
     */
    get rootSnapshotId(): string;
    private _snapshotWithoutReboot?;
    /**
     * @stability stable
     */
    get snapshotWithoutReboot(): boolean;
    /**
     * @stability stable
     */
    set snapshotWithoutReboot(value: boolean);
    /**
     * @stability stable
     */
    resetSnapshotWithoutReboot(): void;
    /**
     * @stability stable
     */
    get snapshotWithoutRebootInput(): boolean | undefined;
    private _sourceInstanceId;
    /**
     * @stability stable
     */
    get sourceInstanceId(): string;
    /**
     * @stability stable
     */
    set sourceInstanceId(value: string);
    /**
     * @stability stable
     */
    get sourceInstanceIdInput(): string;
    /**
     * @stability stable
     */
    get sriovNetSupport(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get usageOperation(): string;
    /**
     * @stability stable
     */
    get virtualizationType(): string;
    private _ebsBlockDevice?;
    /**
     * @stability stable
     */
    get ebsBlockDevice(): AmiFromInstanceEbsBlockDevice[];
    /**
     * @stability stable
     */
    set ebsBlockDevice(value: AmiFromInstanceEbsBlockDevice[]);
    /**
     * @stability stable
     */
    resetEbsBlockDevice(): void;
    /**
     * @stability stable
     */
    get ebsBlockDeviceInput(): AmiFromInstanceEbsBlockDevice[] | undefined;
    private _ephemeralBlockDevice?;
    /**
     * @stability stable
     */
    get ephemeralBlockDevice(): AmiFromInstanceEphemeralBlockDevice[];
    /**
     * @stability stable
     */
    set ephemeralBlockDevice(value: AmiFromInstanceEphemeralBlockDevice[]);
    /**
     * @stability stable
     */
    resetEphemeralBlockDevice(): void;
    /**
     * @stability stable
     */
    get ephemeralBlockDeviceInput(): AmiFromInstanceEphemeralBlockDevice[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): AmiFromInstanceTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: AmiFromInstanceTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): AmiFromInstanceTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
