import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayAccountConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly cloudwatchRoleArn?: string;
}
/**
 * @stability stable
 */
export declare class ApiGatewayAccountThrottleSettings extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get burstLimit(): number;
    /**
     * @stability stable
     */
    get rateLimit(): number;
}
/**
 * @stability stable
 */
export declare class ApiGatewayAccount extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: ApiGatewayAccountConfig);
    private _cloudwatchRoleArn?;
    /**
     * @stability stable
     */
    get cloudwatchRoleArn(): string;
    /**
     * @stability stable
     */
    set cloudwatchRoleArn(value: string);
    /**
     * @stability stable
     */
    resetCloudwatchRoleArn(): void;
    /**
     * @stability stable
     */
    get cloudwatchRoleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    throttleSettings(index: string): ApiGatewayAccountThrottleSettings;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
