import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayAuthorizerConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly authorizerCredentials?: string;
    /**
     * @stability stable
     */
    readonly authorizerResultTtlInSeconds?: number;
    /**
     * @stability stable
     */
    readonly authorizerUri?: string;
    /**
     * @stability stable
     */
    readonly identitySource?: string;
    /**
     * @stability stable
     */
    readonly identityValidationExpression?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly providerArns?: string[];
    /**
     * @stability stable
     */
    readonly restApiId: string;
    /**
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export declare class ApiGatewayAuthorizer extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayAuthorizerConfig);
    private _authorizerCredentials?;
    /**
     * @stability stable
     */
    get authorizerCredentials(): string;
    /**
     * @stability stable
     */
    set authorizerCredentials(value: string);
    /**
     * @stability stable
     */
    resetAuthorizerCredentials(): void;
    /**
     * @stability stable
     */
    get authorizerCredentialsInput(): string | undefined;
    private _authorizerResultTtlInSeconds?;
    /**
     * @stability stable
     */
    get authorizerResultTtlInSeconds(): number;
    /**
     * @stability stable
     */
    set authorizerResultTtlInSeconds(value: number);
    /**
     * @stability stable
     */
    resetAuthorizerResultTtlInSeconds(): void;
    /**
     * @stability stable
     */
    get authorizerResultTtlInSecondsInput(): number | undefined;
    private _authorizerUri?;
    /**
     * @stability stable
     */
    get authorizerUri(): string;
    /**
     * @stability stable
     */
    set authorizerUri(value: string);
    /**
     * @stability stable
     */
    resetAuthorizerUri(): void;
    /**
     * @stability stable
     */
    get authorizerUriInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _identitySource?;
    /**
     * @stability stable
     */
    get identitySource(): string;
    /**
     * @stability stable
     */
    set identitySource(value: string);
    /**
     * @stability stable
     */
    resetIdentitySource(): void;
    /**
     * @stability stable
     */
    get identitySourceInput(): string | undefined;
    private _identityValidationExpression?;
    /**
     * @stability stable
     */
    get identityValidationExpression(): string;
    /**
     * @stability stable
     */
    set identityValidationExpression(value: string);
    /**
     * @stability stable
     */
    resetIdentityValidationExpression(): void;
    /**
     * @stability stable
     */
    get identityValidationExpressionInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _providerArns?;
    /**
     * @stability stable
     */
    get providerArns(): string[];
    /**
     * @stability stable
     */
    set providerArns(value: string[]);
    /**
     * @stability stable
     */
    resetProviderArns(): void;
    /**
     * @stability stable
     */
    get providerArnsInput(): string[] | undefined;
    private _restApiId;
    /**
     * @stability stable
     */
    get restApiId(): string;
    /**
     * @stability stable
     */
    set restApiId(value: string);
    /**
     * @stability stable
     */
    get restApiIdInput(): string;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
