import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayBasePathMappingConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly apiId: string;
    /**
     * @stability stable
     */
    readonly basePath?: string;
    /**
     * @stability stable
     */
    readonly domainName: string;
    /**
     * @stability stable
     */
    readonly stageName?: string;
}
/**
 * @stability stable
 */
export declare class ApiGatewayBasePathMapping extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayBasePathMappingConfig);
    private _apiId;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string;
    private _basePath?;
    /**
     * @stability stable
     */
    get basePath(): string;
    /**
     * @stability stable
     */
    set basePath(value: string);
    /**
     * @stability stable
     */
    resetBasePath(): void;
    /**
     * @stability stable
     */
    get basePathInput(): string | undefined;
    private _domainName;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _stageName?;
    /**
     * @stability stable
     */
    get stageName(): string;
    /**
     * @stability stable
     */
    set stageName(value: string);
    /**
     * @stability stable
     */
    resetStageName(): void;
    /**
     * @stability stable
     */
    get stageNameInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
