import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayDeploymentConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly restApiId: string;
    /**
     * @stability stable
     */
    readonly stageDescription?: string;
    /**
     * @stability stable
     */
    readonly stageName?: string;
    /**
     * @stability stable
     */
    readonly triggers?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly variables?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class ApiGatewayDeployment extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayDeploymentConfig);
    /**
     * @stability stable
     */
    get createdDate(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get executionArn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get invokeUrl(): string;
    private _restApiId;
    /**
     * @stability stable
     */
    get restApiId(): string;
    /**
     * @stability stable
     */
    set restApiId(value: string);
    /**
     * @stability stable
     */
    get restApiIdInput(): string;
    private _stageDescription?;
    /**
     * @stability stable
     */
    get stageDescription(): string;
    /**
     * @stability stable
     */
    set stageDescription(value: string);
    /**
     * @stability stable
     */
    resetStageDescription(): void;
    /**
     * @stability stable
     */
    get stageDescriptionInput(): string | undefined;
    private _stageName?;
    /**
     * @stability stable
     */
    get stageName(): string;
    /**
     * @stability stable
     */
    set stageName(value: string);
    /**
     * @stability stable
     */
    resetStageName(): void;
    /**
     * @stability stable
     */
    get stageNameInput(): string | undefined;
    private _triggers?;
    /**
     * @stability stable
     */
    get triggers(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set triggers(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTriggers(): void;
    /**
     * @stability stable
     */
    get triggersInput(): {
        [key: string]: string;
    } | undefined;
    private _variables?;
    /**
     * @stability stable
     */
    get variables(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set variables(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetVariables(): void;
    /**
     * @stability stable
     */
    get variablesInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
