import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayDocumentationPartConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly properties: string;
    /**
     * @stability stable
     */
    readonly restApiId: string;
    /**
     * location block.
     *
     * @stability stable
     */
    readonly location: ApiGatewayDocumentationPartLocation[];
}
/**
 * @stability stable
 */
export interface ApiGatewayDocumentationPartLocation {
    /**
     * @stability stable
     */
    readonly method?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly path?: string;
    /**
     * @stability stable
     */
    readonly statusCode?: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export declare class ApiGatewayDocumentationPart extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayDocumentationPartConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _properties;
    /**
     * @stability stable
     */
    get properties(): string;
    /**
     * @stability stable
     */
    set properties(value: string);
    /**
     * @stability stable
     */
    get propertiesInput(): string;
    private _restApiId;
    /**
     * @stability stable
     */
    get restApiId(): string;
    /**
     * @stability stable
     */
    set restApiId(value: string);
    /**
     * @stability stable
     */
    get restApiIdInput(): string;
    private _location;
    /**
     * @stability stable
     */
    get location(): ApiGatewayDocumentationPartLocation[];
    /**
     * @stability stable
     */
    set location(value: ApiGatewayDocumentationPartLocation[]);
    /**
     * @stability stable
     */
    get locationInput(): ApiGatewayDocumentationPartLocation[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
