import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayDomainNameConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly certificateArn?: string;
    /**
     * @stability stable
     */
    readonly certificateBody?: string;
    /**
     * @stability stable
     */
    readonly certificateChain?: string;
    /**
     * @stability stable
     */
    readonly certificateName?: string;
    /**
     * @stability stable
     */
    readonly certificatePrivateKey?: string;
    /**
     * @stability stable
     */
    readonly domainName: string;
    /**
     * @stability stable
     */
    readonly regionalCertificateArn?: string;
    /**
     * @stability stable
     */
    readonly regionalCertificateName?: string;
    /**
     * @stability stable
     */
    readonly securityPolicy?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * endpoint_configuration block.
     *
     * @stability stable
     */
    readonly endpointConfiguration?: ApiGatewayDomainNameEndpointConfiguration[];
    /**
     * mutual_tls_authentication block.
     *
     * @stability stable
     */
    readonly mutualTlsAuthentication?: ApiGatewayDomainNameMutualTlsAuthentication[];
}
/**
 * @stability stable
 */
export interface ApiGatewayDomainNameEndpointConfiguration {
    /**
     * @stability stable
     */
    readonly types: string[];
}
/**
 * @stability stable
 */
export interface ApiGatewayDomainNameMutualTlsAuthentication {
    /**
     * @stability stable
     */
    readonly truststoreUri: string;
    /**
     * @stability stable
     */
    readonly truststoreVersion?: string;
}
/**
 * @stability stable
 */
export declare class ApiGatewayDomainName extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayDomainNameConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _certificateArn?;
    /**
     * @stability stable
     */
    get certificateArn(): string;
    /**
     * @stability stable
     */
    set certificateArn(value: string);
    /**
     * @stability stable
     */
    resetCertificateArn(): void;
    /**
     * @stability stable
     */
    get certificateArnInput(): string | undefined;
    private _certificateBody?;
    /**
     * @stability stable
     */
    get certificateBody(): string;
    /**
     * @stability stable
     */
    set certificateBody(value: string);
    /**
     * @stability stable
     */
    resetCertificateBody(): void;
    /**
     * @stability stable
     */
    get certificateBodyInput(): string | undefined;
    private _certificateChain?;
    /**
     * @stability stable
     */
    get certificateChain(): string;
    /**
     * @stability stable
     */
    set certificateChain(value: string);
    /**
     * @stability stable
     */
    resetCertificateChain(): void;
    /**
     * @stability stable
     */
    get certificateChainInput(): string | undefined;
    private _certificateName?;
    /**
     * @stability stable
     */
    get certificateName(): string;
    /**
     * @stability stable
     */
    set certificateName(value: string);
    /**
     * @stability stable
     */
    resetCertificateName(): void;
    /**
     * @stability stable
     */
    get certificateNameInput(): string | undefined;
    private _certificatePrivateKey?;
    /**
     * @stability stable
     */
    get certificatePrivateKey(): string;
    /**
     * @stability stable
     */
    set certificatePrivateKey(value: string);
    /**
     * @stability stable
     */
    resetCertificatePrivateKey(): void;
    /**
     * @stability stable
     */
    get certificatePrivateKeyInput(): string | undefined;
    /**
     * @stability stable
     */
    get certificateUploadDate(): string;
    /**
     * @stability stable
     */
    get cloudfrontDomainName(): string;
    /**
     * @stability stable
     */
    get cloudfrontZoneId(): string;
    private _domainName;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _regionalCertificateArn?;
    /**
     * @stability stable
     */
    get regionalCertificateArn(): string;
    /**
     * @stability stable
     */
    set regionalCertificateArn(value: string);
    /**
     * @stability stable
     */
    resetRegionalCertificateArn(): void;
    /**
     * @stability stable
     */
    get regionalCertificateArnInput(): string | undefined;
    private _regionalCertificateName?;
    /**
     * @stability stable
     */
    get regionalCertificateName(): string;
    /**
     * @stability stable
     */
    set regionalCertificateName(value: string);
    /**
     * @stability stable
     */
    resetRegionalCertificateName(): void;
    /**
     * @stability stable
     */
    get regionalCertificateNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get regionalDomainName(): string;
    /**
     * @stability stable
     */
    get regionalZoneId(): string;
    private _securityPolicy?;
    /**
     * @stability stable
     */
    get securityPolicy(): string;
    /**
     * @stability stable
     */
    set securityPolicy(value: string);
    /**
     * @stability stable
     */
    resetSecurityPolicy(): void;
    /**
     * @stability stable
     */
    get securityPolicyInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _endpointConfiguration?;
    /**
     * @stability stable
     */
    get endpointConfiguration(): ApiGatewayDomainNameEndpointConfiguration[];
    /**
     * @stability stable
     */
    set endpointConfiguration(value: ApiGatewayDomainNameEndpointConfiguration[]);
    /**
     * @stability stable
     */
    resetEndpointConfiguration(): void;
    /**
     * @stability stable
     */
    get endpointConfigurationInput(): ApiGatewayDomainNameEndpointConfiguration[] | undefined;
    private _mutualTlsAuthentication?;
    /**
     * @stability stable
     */
    get mutualTlsAuthentication(): ApiGatewayDomainNameMutualTlsAuthentication[];
    /**
     * @stability stable
     */
    set mutualTlsAuthentication(value: ApiGatewayDomainNameMutualTlsAuthentication[]);
    /**
     * @stability stable
     */
    resetMutualTlsAuthentication(): void;
    /**
     * @stability stable
     */
    get mutualTlsAuthenticationInput(): ApiGatewayDomainNameMutualTlsAuthentication[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
