import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayGatewayResponseConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly responseParameters?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly responseTemplates?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly responseType: string;
    /**
     * @stability stable
     */
    readonly restApiId: string;
    /**
     * @stability stable
     */
    readonly statusCode?: string;
}
/**
 * @stability stable
 */
export declare class ApiGatewayGatewayResponse extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayGatewayResponseConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _responseParameters?;
    /**
     * @stability stable
     */
    get responseParameters(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set responseParameters(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetResponseParameters(): void;
    /**
     * @stability stable
     */
    get responseParametersInput(): {
        [key: string]: string;
    } | undefined;
    private _responseTemplates?;
    /**
     * @stability stable
     */
    get responseTemplates(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set responseTemplates(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetResponseTemplates(): void;
    /**
     * @stability stable
     */
    get responseTemplatesInput(): {
        [key: string]: string;
    } | undefined;
    private _responseType;
    /**
     * @stability stable
     */
    get responseType(): string;
    /**
     * @stability stable
     */
    set responseType(value: string);
    /**
     * @stability stable
     */
    get responseTypeInput(): string;
    private _restApiId;
    /**
     * @stability stable
     */
    get restApiId(): string;
    /**
     * @stability stable
     */
    set restApiId(value: string);
    /**
     * @stability stable
     */
    get restApiIdInput(): string;
    private _statusCode?;
    /**
     * @stability stable
     */
    get statusCode(): string;
    /**
     * @stability stable
     */
    set statusCode(value: string);
    /**
     * @stability stable
     */
    resetStatusCode(): void;
    /**
     * @stability stable
     */
    get statusCodeInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
