import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayIntegrationResponseConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly contentHandling?: string;
    /**
     * @stability stable
     */
    readonly httpMethod: string;
    /**
     * @stability stable
     */
    readonly resourceId: string;
    /**
     * @stability stable
     */
    readonly responseParameters?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly responseTemplates?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly restApiId: string;
    /**
     * @stability stable
     */
    readonly selectionPattern?: string;
    /**
     * @stability stable
     */
    readonly statusCode: string;
}
/**
 * @stability stable
 */
export declare class ApiGatewayIntegrationResponse extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayIntegrationResponseConfig);
    private _contentHandling?;
    /**
     * @stability stable
     */
    get contentHandling(): string;
    /**
     * @stability stable
     */
    set contentHandling(value: string);
    /**
     * @stability stable
     */
    resetContentHandling(): void;
    /**
     * @stability stable
     */
    get contentHandlingInput(): string | undefined;
    private _httpMethod;
    /**
     * @stability stable
     */
    get httpMethod(): string;
    /**
     * @stability stable
     */
    set httpMethod(value: string);
    /**
     * @stability stable
     */
    get httpMethodInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _resourceId;
    /**
     * @stability stable
     */
    get resourceId(): string;
    /**
     * @stability stable
     */
    set resourceId(value: string);
    /**
     * @stability stable
     */
    get resourceIdInput(): string;
    private _responseParameters?;
    /**
     * @stability stable
     */
    get responseParameters(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set responseParameters(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetResponseParameters(): void;
    /**
     * @stability stable
     */
    get responseParametersInput(): {
        [key: string]: string;
    } | undefined;
    private _responseTemplates?;
    /**
     * @stability stable
     */
    get responseTemplates(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set responseTemplates(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetResponseTemplates(): void;
    /**
     * @stability stable
     */
    get responseTemplatesInput(): {
        [key: string]: string;
    } | undefined;
    private _restApiId;
    /**
     * @stability stable
     */
    get restApiId(): string;
    /**
     * @stability stable
     */
    set restApiId(value: string);
    /**
     * @stability stable
     */
    get restApiIdInput(): string;
    private _selectionPattern?;
    /**
     * @stability stable
     */
    get selectionPattern(): string;
    /**
     * @stability stable
     */
    set selectionPattern(value: string);
    /**
     * @stability stable
     */
    resetSelectionPattern(): void;
    /**
     * @stability stable
     */
    get selectionPatternInput(): string | undefined;
    private _statusCode;
    /**
     * @stability stable
     */
    get statusCode(): string;
    /**
     * @stability stable
     */
    set statusCode(value: string);
    /**
     * @stability stable
     */
    get statusCodeInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
