import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayMethodResponseConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly httpMethod: string;
    /**
     * @stability stable
     */
    readonly resourceId: string;
    /**
     * @stability stable
     */
    readonly responseModels?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly responseParameters?: {
        [key: string]: boolean;
    };
    /**
     * @stability stable
     */
    readonly restApiId: string;
    /**
     * @stability stable
     */
    readonly statusCode: string;
}
/**
 * @stability stable
 */
export declare class ApiGatewayMethodResponse extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayMethodResponseConfig);
    private _httpMethod;
    /**
     * @stability stable
     */
    get httpMethod(): string;
    /**
     * @stability stable
     */
    set httpMethod(value: string);
    /**
     * @stability stable
     */
    get httpMethodInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _resourceId;
    /**
     * @stability stable
     */
    get resourceId(): string;
    /**
     * @stability stable
     */
    set resourceId(value: string);
    /**
     * @stability stable
     */
    get resourceIdInput(): string;
    private _responseModels?;
    /**
     * @stability stable
     */
    get responseModels(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set responseModels(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetResponseModels(): void;
    /**
     * @stability stable
     */
    get responseModelsInput(): {
        [key: string]: string;
    } | undefined;
    private _responseParameters?;
    /**
     * @stability stable
     */
    get responseParameters(): {
        [key: string]: boolean;
    };
    /**
     * @stability stable
     */
    set responseParameters(value: {
        [key: string]: boolean;
    });
    /**
     * @stability stable
     */
    resetResponseParameters(): void;
    /**
     * @stability stable
     */
    get responseParametersInput(): {
        [key: string]: boolean;
    } | undefined;
    private _restApiId;
    /**
     * @stability stable
     */
    get restApiId(): string;
    /**
     * @stability stable
     */
    set restApiId(value: string);
    /**
     * @stability stable
     */
    get restApiIdInput(): string;
    private _statusCode;
    /**
     * @stability stable
     */
    get statusCode(): string;
    /**
     * @stability stable
     */
    set statusCode(value: string);
    /**
     * @stability stable
     */
    get statusCodeInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
