import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayMethodSettingsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly methodPath: string;
    /**
     * @stability stable
     */
    readonly restApiId: string;
    /**
     * @stability stable
     */
    readonly stageName: string;
    /**
     * settings block.
     *
     * @stability stable
     */
    readonly settings: ApiGatewayMethodSettingsSettings[];
}
/**
 * @stability stable
 */
export interface ApiGatewayMethodSettingsSettings {
    /**
     * @stability stable
     */
    readonly cacheDataEncrypted?: boolean;
    /**
     * @stability stable
     */
    readonly cacheTtlInSeconds?: number;
    /**
     * @stability stable
     */
    readonly cachingEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly dataTraceEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly loggingLevel?: string;
    /**
     * @stability stable
     */
    readonly metricsEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly requireAuthorizationForCacheControl?: boolean;
    /**
     * @stability stable
     */
    readonly throttlingBurstLimit?: number;
    /**
     * @stability stable
     */
    readonly throttlingRateLimit?: number;
    /**
     * @stability stable
     */
    readonly unauthorizedCacheControlHeaderStrategy?: string;
}
/**
 * @stability stable
 */
export declare class ApiGatewayMethodSettings extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayMethodSettingsConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _methodPath;
    /**
     * @stability stable
     */
    get methodPath(): string;
    /**
     * @stability stable
     */
    set methodPath(value: string);
    /**
     * @stability stable
     */
    get methodPathInput(): string;
    private _restApiId;
    /**
     * @stability stable
     */
    get restApiId(): string;
    /**
     * @stability stable
     */
    set restApiId(value: string);
    /**
     * @stability stable
     */
    get restApiIdInput(): string;
    private _stageName;
    /**
     * @stability stable
     */
    get stageName(): string;
    /**
     * @stability stable
     */
    set stageName(value: string);
    /**
     * @stability stable
     */
    get stageNameInput(): string;
    private _settings;
    /**
     * @stability stable
     */
    get settings(): ApiGatewayMethodSettingsSettings[];
    /**
     * @stability stable
     */
    set settings(value: ApiGatewayMethodSettingsSettings[]);
    /**
     * @stability stable
     */
    get settingsInput(): ApiGatewayMethodSettingsSettings[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
