import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayMethodConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly apiKeyRequired?: boolean;
    /**
     * @stability stable
     */
    readonly authorization: string;
    /**
     * @stability stable
     */
    readonly authorizationScopes?: string[];
    /**
     * @stability stable
     */
    readonly authorizerId?: string;
    /**
     * @stability stable
     */
    readonly httpMethod: string;
    /**
     * @stability stable
     */
    readonly operationName?: string;
    /**
     * @stability stable
     */
    readonly requestModels?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly requestParameters?: {
        [key: string]: boolean;
    };
    /**
     * @stability stable
     */
    readonly requestValidatorId?: string;
    /**
     * @stability stable
     */
    readonly resourceId: string;
    /**
     * @stability stable
     */
    readonly restApiId: string;
}
/**
 * @stability stable
 */
export declare class ApiGatewayMethod extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayMethodConfig);
    private _apiKeyRequired?;
    /**
     * @stability stable
     */
    get apiKeyRequired(): boolean;
    /**
     * @stability stable
     */
    set apiKeyRequired(value: boolean);
    /**
     * @stability stable
     */
    resetApiKeyRequired(): void;
    /**
     * @stability stable
     */
    get apiKeyRequiredInput(): boolean | undefined;
    private _authorization;
    /**
     * @stability stable
     */
    get authorization(): string;
    /**
     * @stability stable
     */
    set authorization(value: string);
    /**
     * @stability stable
     */
    get authorizationInput(): string;
    private _authorizationScopes?;
    /**
     * @stability stable
     */
    get authorizationScopes(): string[];
    /**
     * @stability stable
     */
    set authorizationScopes(value: string[]);
    /**
     * @stability stable
     */
    resetAuthorizationScopes(): void;
    /**
     * @stability stable
     */
    get authorizationScopesInput(): string[] | undefined;
    private _authorizerId?;
    /**
     * @stability stable
     */
    get authorizerId(): string;
    /**
     * @stability stable
     */
    set authorizerId(value: string);
    /**
     * @stability stable
     */
    resetAuthorizerId(): void;
    /**
     * @stability stable
     */
    get authorizerIdInput(): string | undefined;
    private _httpMethod;
    /**
     * @stability stable
     */
    get httpMethod(): string;
    /**
     * @stability stable
     */
    set httpMethod(value: string);
    /**
     * @stability stable
     */
    get httpMethodInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _operationName?;
    /**
     * @stability stable
     */
    get operationName(): string;
    /**
     * @stability stable
     */
    set operationName(value: string);
    /**
     * @stability stable
     */
    resetOperationName(): void;
    /**
     * @stability stable
     */
    get operationNameInput(): string | undefined;
    private _requestModels?;
    /**
     * @stability stable
     */
    get requestModels(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set requestModels(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetRequestModels(): void;
    /**
     * @stability stable
     */
    get requestModelsInput(): {
        [key: string]: string;
    } | undefined;
    private _requestParameters?;
    /**
     * @stability stable
     */
    get requestParameters(): {
        [key: string]: boolean;
    };
    /**
     * @stability stable
     */
    set requestParameters(value: {
        [key: string]: boolean;
    });
    /**
     * @stability stable
     */
    resetRequestParameters(): void;
    /**
     * @stability stable
     */
    get requestParametersInput(): {
        [key: string]: boolean;
    } | undefined;
    private _requestValidatorId?;
    /**
     * @stability stable
     */
    get requestValidatorId(): string;
    /**
     * @stability stable
     */
    set requestValidatorId(value: string);
    /**
     * @stability stable
     */
    resetRequestValidatorId(): void;
    /**
     * @stability stable
     */
    get requestValidatorIdInput(): string | undefined;
    private _resourceId;
    /**
     * @stability stable
     */
    get resourceId(): string;
    /**
     * @stability stable
     */
    set resourceId(value: string);
    /**
     * @stability stable
     */
    get resourceIdInput(): string;
    private _restApiId;
    /**
     * @stability stable
     */
    get restApiId(): string;
    /**
     * @stability stable
     */
    set restApiId(value: string);
    /**
     * @stability stable
     */
    get restApiIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
