import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayRequestValidatorConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly restApiId: string;
    /**
     * @stability stable
     */
    readonly validateRequestBody?: boolean;
    /**
     * @stability stable
     */
    readonly validateRequestParameters?: boolean;
}
/**
 * @stability stable
 */
export declare class ApiGatewayRequestValidator extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayRequestValidatorConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _restApiId;
    /**
     * @stability stable
     */
    get restApiId(): string;
    /**
     * @stability stable
     */
    set restApiId(value: string);
    /**
     * @stability stable
     */
    get restApiIdInput(): string;
    private _validateRequestBody?;
    /**
     * @stability stable
     */
    get validateRequestBody(): boolean;
    /**
     * @stability stable
     */
    set validateRequestBody(value: boolean);
    /**
     * @stability stable
     */
    resetValidateRequestBody(): void;
    /**
     * @stability stable
     */
    get validateRequestBodyInput(): boolean | undefined;
    private _validateRequestParameters?;
    /**
     * @stability stable
     */
    get validateRequestParameters(): boolean;
    /**
     * @stability stable
     */
    set validateRequestParameters(value: boolean);
    /**
     * @stability stable
     */
    resetValidateRequestParameters(): void;
    /**
     * @stability stable
     */
    get validateRequestParametersInput(): boolean | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
