import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayRestApiConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly apiKeySource?: string;
    /**
     * @stability stable
     */
    readonly binaryMediaTypes?: string[];
    /**
     * @stability stable
     */
    readonly body?: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly disableExecuteApiEndpoint?: boolean;
    /**
     * @stability stable
     */
    readonly minimumCompressionSize?: number;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly parameters?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly policy?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * endpoint_configuration block.
     *
     * @stability stable
     */
    readonly endpointConfiguration?: ApiGatewayRestApiEndpointConfiguration[];
}
/**
 * @stability stable
 */
export interface ApiGatewayRestApiEndpointConfiguration {
    /**
     * @stability stable
     */
    readonly types: string[];
    /**
     * @stability stable
     */
    readonly vpcEndpointIds?: string[];
}
/**
 * @stability stable
 */
export declare class ApiGatewayRestApi extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayRestApiConfig);
    private _apiKeySource?;
    /**
     * @stability stable
     */
    get apiKeySource(): string;
    /**
     * @stability stable
     */
    set apiKeySource(value: string);
    /**
     * @stability stable
     */
    resetApiKeySource(): void;
    /**
     * @stability stable
     */
    get apiKeySourceInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _binaryMediaTypes?;
    /**
     * @stability stable
     */
    get binaryMediaTypes(): string[];
    /**
     * @stability stable
     */
    set binaryMediaTypes(value: string[]);
    /**
     * @stability stable
     */
    resetBinaryMediaTypes(): void;
    /**
     * @stability stable
     */
    get binaryMediaTypesInput(): string[] | undefined;
    private _body?;
    /**
     * @stability stable
     */
    get body(): string;
    /**
     * @stability stable
     */
    set body(value: string);
    /**
     * @stability stable
     */
    resetBody(): void;
    /**
     * @stability stable
     */
    get bodyInput(): string | undefined;
    /**
     * @stability stable
     */
    get createdDate(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _disableExecuteApiEndpoint?;
    /**
     * @stability stable
     */
    get disableExecuteApiEndpoint(): boolean;
    /**
     * @stability stable
     */
    set disableExecuteApiEndpoint(value: boolean);
    /**
     * @stability stable
     */
    resetDisableExecuteApiEndpoint(): void;
    /**
     * @stability stable
     */
    get disableExecuteApiEndpointInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get executionArn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _minimumCompressionSize?;
    /**
     * @stability stable
     */
    get minimumCompressionSize(): number;
    /**
     * @stability stable
     */
    set minimumCompressionSize(value: number);
    /**
     * @stability stable
     */
    resetMinimumCompressionSize(): void;
    /**
     * @stability stable
     */
    get minimumCompressionSizeInput(): number | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _parameters?;
    /**
     * @stability stable
     */
    get parameters(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set parameters(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetParameters(): void;
    /**
     * @stability stable
     */
    get parametersInput(): {
        [key: string]: string;
    } | undefined;
    private _policy?;
    /**
     * @stability stable
     */
    get policy(): string;
    /**
     * @stability stable
     */
    set policy(value: string);
    /**
     * @stability stable
     */
    resetPolicy(): void;
    /**
     * @stability stable
     */
    get policyInput(): string | undefined;
    /**
     * @stability stable
     */
    get rootResourceId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _endpointConfiguration?;
    /**
     * @stability stable
     */
    get endpointConfiguration(): ApiGatewayRestApiEndpointConfiguration[];
    /**
     * @stability stable
     */
    set endpointConfiguration(value: ApiGatewayRestApiEndpointConfiguration[]);
    /**
     * @stability stable
     */
    resetEndpointConfiguration(): void;
    /**
     * @stability stable
     */
    get endpointConfigurationInput(): ApiGatewayRestApiEndpointConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
