import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayStageConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly cacheClusterEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly cacheClusterSize?: string;
    /**
     * @stability stable
     */
    readonly clientCertificateId?: string;
    /**
     * @stability stable
     */
    readonly deploymentId: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly documentationVersion?: string;
    /**
     * @stability stable
     */
    readonly restApiId: string;
    /**
     * @stability stable
     */
    readonly stageName: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly variables?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly xrayTracingEnabled?: boolean;
    /**
     * access_log_settings block.
     *
     * @stability stable
     */
    readonly accessLogSettings?: ApiGatewayStageAccessLogSettings[];
}
/**
 * @stability stable
 */
export interface ApiGatewayStageAccessLogSettings {
    /**
     * @stability stable
     */
    readonly destinationArn: string;
    /**
     * @stability stable
     */
    readonly format: string;
}
/**
 * @stability stable
 */
export declare class ApiGatewayStage extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayStageConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _cacheClusterEnabled?;
    /**
     * @stability stable
     */
    get cacheClusterEnabled(): boolean;
    /**
     * @stability stable
     */
    set cacheClusterEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetCacheClusterEnabled(): void;
    /**
     * @stability stable
     */
    get cacheClusterEnabledInput(): boolean | undefined;
    private _cacheClusterSize?;
    /**
     * @stability stable
     */
    get cacheClusterSize(): string;
    /**
     * @stability stable
     */
    set cacheClusterSize(value: string);
    /**
     * @stability stable
     */
    resetCacheClusterSize(): void;
    /**
     * @stability stable
     */
    get cacheClusterSizeInput(): string | undefined;
    private _clientCertificateId?;
    /**
     * @stability stable
     */
    get clientCertificateId(): string;
    /**
     * @stability stable
     */
    set clientCertificateId(value: string);
    /**
     * @stability stable
     */
    resetClientCertificateId(): void;
    /**
     * @stability stable
     */
    get clientCertificateIdInput(): string | undefined;
    private _deploymentId;
    /**
     * @stability stable
     */
    get deploymentId(): string;
    /**
     * @stability stable
     */
    set deploymentId(value: string);
    /**
     * @stability stable
     */
    get deploymentIdInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _documentationVersion?;
    /**
     * @stability stable
     */
    get documentationVersion(): string;
    /**
     * @stability stable
     */
    set documentationVersion(value: string);
    /**
     * @stability stable
     */
    resetDocumentationVersion(): void;
    /**
     * @stability stable
     */
    get documentationVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get executionArn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get invokeUrl(): string;
    private _restApiId;
    /**
     * @stability stable
     */
    get restApiId(): string;
    /**
     * @stability stable
     */
    set restApiId(value: string);
    /**
     * @stability stable
     */
    get restApiIdInput(): string;
    private _stageName;
    /**
     * @stability stable
     */
    get stageName(): string;
    /**
     * @stability stable
     */
    set stageName(value: string);
    /**
     * @stability stable
     */
    get stageNameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _variables?;
    /**
     * @stability stable
     */
    get variables(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set variables(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetVariables(): void;
    /**
     * @stability stable
     */
    get variablesInput(): {
        [key: string]: string;
    } | undefined;
    private _xrayTracingEnabled?;
    /**
     * @stability stable
     */
    get xrayTracingEnabled(): boolean;
    /**
     * @stability stable
     */
    set xrayTracingEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetXrayTracingEnabled(): void;
    /**
     * @stability stable
     */
    get xrayTracingEnabledInput(): boolean | undefined;
    private _accessLogSettings?;
    /**
     * @stability stable
     */
    get accessLogSettings(): ApiGatewayStageAccessLogSettings[];
    /**
     * @stability stable
     */
    set accessLogSettings(value: ApiGatewayStageAccessLogSettings[]);
    /**
     * @stability stable
     */
    resetAccessLogSettings(): void;
    /**
     * @stability stable
     */
    get accessLogSettingsInput(): ApiGatewayStageAccessLogSettings[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
