import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayUsagePlanConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly productCode?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * api_stages block.
     *
     * @stability stable
     */
    readonly apiStages?: ApiGatewayUsagePlanApiStages[];
    /**
     * quota_settings block.
     *
     * @stability stable
     */
    readonly quotaSettings?: ApiGatewayUsagePlanQuotaSettings[];
    /**
     * throttle_settings block.
     *
     * @stability stable
     */
    readonly throttleSettings?: ApiGatewayUsagePlanThrottleSettings[];
}
/**
 * @stability stable
 */
export interface ApiGatewayUsagePlanApiStages {
    /**
     * @stability stable
     */
    readonly apiId: string;
    /**
     * @stability stable
     */
    readonly stage: string;
}
/**
 * @stability stable
 */
export interface ApiGatewayUsagePlanQuotaSettings {
    /**
     * @stability stable
     */
    readonly limit: number;
    /**
     * @stability stable
     */
    readonly offset?: number;
    /**
     * @stability stable
     */
    readonly period: string;
}
/**
 * @stability stable
 */
export interface ApiGatewayUsagePlanThrottleSettings {
    /**
     * @stability stable
     */
    readonly burstLimit?: number;
    /**
     * @stability stable
     */
    readonly rateLimit?: number;
}
/**
 * @stability stable
 */
export declare class ApiGatewayUsagePlan extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ApiGatewayUsagePlanConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _productCode?;
    /**
     * @stability stable
     */
    get productCode(): string;
    /**
     * @stability stable
     */
    set productCode(value: string);
    /**
     * @stability stable
     */
    resetProductCode(): void;
    /**
     * @stability stable
     */
    get productCodeInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _apiStages?;
    /**
     * @stability stable
     */
    get apiStages(): ApiGatewayUsagePlanApiStages[];
    /**
     * @stability stable
     */
    set apiStages(value: ApiGatewayUsagePlanApiStages[]);
    /**
     * @stability stable
     */
    resetApiStages(): void;
    /**
     * @stability stable
     */
    get apiStagesInput(): ApiGatewayUsagePlanApiStages[] | undefined;
    private _quotaSettings?;
    /**
     * @stability stable
     */
    get quotaSettings(): ApiGatewayUsagePlanQuotaSettings[];
    /**
     * @stability stable
     */
    set quotaSettings(value: ApiGatewayUsagePlanQuotaSettings[]);
    /**
     * @stability stable
     */
    resetQuotaSettings(): void;
    /**
     * @stability stable
     */
    get quotaSettingsInput(): ApiGatewayUsagePlanQuotaSettings[] | undefined;
    private _throttleSettings?;
    /**
     * @stability stable
     */
    get throttleSettings(): ApiGatewayUsagePlanThrottleSettings[];
    /**
     * @stability stable
     */
    set throttleSettings(value: ApiGatewayUsagePlanThrottleSettings[]);
    /**
     * @stability stable
     */
    resetThrottleSettings(): void;
    /**
     * @stability stable
     */
    get throttleSettingsInput(): ApiGatewayUsagePlanThrottleSettings[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
