import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Apigatewayv2ApiConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly apiKeySelectionExpression?: string;
    /**
     * @stability stable
     */
    readonly body?: string;
    /**
     * @stability stable
     */
    readonly credentialsArn?: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly disableExecuteApiEndpoint?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly protocolType: string;
    /**
     * @stability stable
     */
    readonly routeKey?: string;
    /**
     * @stability stable
     */
    readonly routeSelectionExpression?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly target?: string;
    /**
     * @stability stable
     */
    readonly version?: string;
    /**
     * cors_configuration block.
     *
     * @stability stable
     */
    readonly corsConfiguration?: Apigatewayv2ApiCorsConfiguration[];
}
/**
 * @stability stable
 */
export interface Apigatewayv2ApiCorsConfiguration {
    /**
     * @stability stable
     */
    readonly allowCredentials?: boolean;
    /**
     * @stability stable
     */
    readonly allowHeaders?: string[];
    /**
     * @stability stable
     */
    readonly allowMethods?: string[];
    /**
     * @stability stable
     */
    readonly allowOrigins?: string[];
    /**
     * @stability stable
     */
    readonly exposeHeaders?: string[];
    /**
     * @stability stable
     */
    readonly maxAge?: number;
}
/**
 * @stability stable
 */
export declare class Apigatewayv2Api extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2ApiConfig);
    /**
     * @stability stable
     */
    get apiEndpoint(): string;
    private _apiKeySelectionExpression?;
    /**
     * @stability stable
     */
    get apiKeySelectionExpression(): string;
    /**
     * @stability stable
     */
    set apiKeySelectionExpression(value: string);
    /**
     * @stability stable
     */
    resetApiKeySelectionExpression(): void;
    /**
     * @stability stable
     */
    get apiKeySelectionExpressionInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _body?;
    /**
     * @stability stable
     */
    get body(): string;
    /**
     * @stability stable
     */
    set body(value: string);
    /**
     * @stability stable
     */
    resetBody(): void;
    /**
     * @stability stable
     */
    get bodyInput(): string | undefined;
    private _credentialsArn?;
    /**
     * @stability stable
     */
    get credentialsArn(): string;
    /**
     * @stability stable
     */
    set credentialsArn(value: string);
    /**
     * @stability stable
     */
    resetCredentialsArn(): void;
    /**
     * @stability stable
     */
    get credentialsArnInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _disableExecuteApiEndpoint?;
    /**
     * @stability stable
     */
    get disableExecuteApiEndpoint(): boolean;
    /**
     * @stability stable
     */
    set disableExecuteApiEndpoint(value: boolean);
    /**
     * @stability stable
     */
    resetDisableExecuteApiEndpoint(): void;
    /**
     * @stability stable
     */
    get disableExecuteApiEndpointInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get executionArn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _protocolType;
    /**
     * @stability stable
     */
    get protocolType(): string;
    /**
     * @stability stable
     */
    set protocolType(value: string);
    /**
     * @stability stable
     */
    get protocolTypeInput(): string;
    private _routeKey?;
    /**
     * @stability stable
     */
    get routeKey(): string;
    /**
     * @stability stable
     */
    set routeKey(value: string);
    /**
     * @stability stable
     */
    resetRouteKey(): void;
    /**
     * @stability stable
     */
    get routeKeyInput(): string | undefined;
    private _routeSelectionExpression?;
    /**
     * @stability stable
     */
    get routeSelectionExpression(): string;
    /**
     * @stability stable
     */
    set routeSelectionExpression(value: string);
    /**
     * @stability stable
     */
    resetRouteSelectionExpression(): void;
    /**
     * @stability stable
     */
    get routeSelectionExpressionInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _target?;
    /**
     * @stability stable
     */
    get target(): string;
    /**
     * @stability stable
     */
    set target(value: string);
    /**
     * @stability stable
     */
    resetTarget(): void;
    /**
     * @stability stable
     */
    get targetInput(): string | undefined;
    private _version?;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): string | undefined;
    private _corsConfiguration?;
    /**
     * @stability stable
     */
    get corsConfiguration(): Apigatewayv2ApiCorsConfiguration[];
    /**
     * @stability stable
     */
    set corsConfiguration(value: Apigatewayv2ApiCorsConfiguration[]);
    /**
     * @stability stable
     */
    resetCorsConfiguration(): void;
    /**
     * @stability stable
     */
    get corsConfigurationInput(): Apigatewayv2ApiCorsConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
