import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Apigatewayv2AuthorizerConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly apiId: string;
    /**
     * @stability stable
     */
    readonly authorizerCredentialsArn?: string;
    /**
     * @stability stable
     */
    readonly authorizerPayloadFormatVersion?: string;
    /**
     * @stability stable
     */
    readonly authorizerResultTtlInSeconds?: number;
    /**
     * @stability stable
     */
    readonly authorizerType: string;
    /**
     * @stability stable
     */
    readonly authorizerUri?: string;
    /**
     * @stability stable
     */
    readonly enableSimpleResponses?: boolean;
    /**
     * @stability stable
     */
    readonly identitySources?: string[];
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * jwt_configuration block.
     *
     * @stability stable
     */
    readonly jwtConfiguration?: Apigatewayv2AuthorizerJwtConfiguration[];
}
/**
 * @stability stable
 */
export interface Apigatewayv2AuthorizerJwtConfiguration {
    /**
     * @stability stable
     */
    readonly audience?: string[];
    /**
     * @stability stable
     */
    readonly issuer?: string;
}
/**
 * @stability stable
 */
export declare class Apigatewayv2Authorizer extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2AuthorizerConfig);
    private _apiId;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string;
    private _authorizerCredentialsArn?;
    /**
     * @stability stable
     */
    get authorizerCredentialsArn(): string;
    /**
     * @stability stable
     */
    set authorizerCredentialsArn(value: string);
    /**
     * @stability stable
     */
    resetAuthorizerCredentialsArn(): void;
    /**
     * @stability stable
     */
    get authorizerCredentialsArnInput(): string | undefined;
    private _authorizerPayloadFormatVersion?;
    /**
     * @stability stable
     */
    get authorizerPayloadFormatVersion(): string;
    /**
     * @stability stable
     */
    set authorizerPayloadFormatVersion(value: string);
    /**
     * @stability stable
     */
    resetAuthorizerPayloadFormatVersion(): void;
    /**
     * @stability stable
     */
    get authorizerPayloadFormatVersionInput(): string | undefined;
    private _authorizerResultTtlInSeconds?;
    /**
     * @stability stable
     */
    get authorizerResultTtlInSeconds(): number;
    /**
     * @stability stable
     */
    set authorizerResultTtlInSeconds(value: number);
    /**
     * @stability stable
     */
    resetAuthorizerResultTtlInSeconds(): void;
    /**
     * @stability stable
     */
    get authorizerResultTtlInSecondsInput(): number | undefined;
    private _authorizerType;
    /**
     * @stability stable
     */
    get authorizerType(): string;
    /**
     * @stability stable
     */
    set authorizerType(value: string);
    /**
     * @stability stable
     */
    get authorizerTypeInput(): string;
    private _authorizerUri?;
    /**
     * @stability stable
     */
    get authorizerUri(): string;
    /**
     * @stability stable
     */
    set authorizerUri(value: string);
    /**
     * @stability stable
     */
    resetAuthorizerUri(): void;
    /**
     * @stability stable
     */
    get authorizerUriInput(): string | undefined;
    private _enableSimpleResponses?;
    /**
     * @stability stable
     */
    get enableSimpleResponses(): boolean;
    /**
     * @stability stable
     */
    set enableSimpleResponses(value: boolean);
    /**
     * @stability stable
     */
    resetEnableSimpleResponses(): void;
    /**
     * @stability stable
     */
    get enableSimpleResponsesInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _identitySources?;
    /**
     * @stability stable
     */
    get identitySources(): string[];
    /**
     * @stability stable
     */
    set identitySources(value: string[]);
    /**
     * @stability stable
     */
    resetIdentitySources(): void;
    /**
     * @stability stable
     */
    get identitySourcesInput(): string[] | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _jwtConfiguration?;
    /**
     * @stability stable
     */
    get jwtConfiguration(): Apigatewayv2AuthorizerJwtConfiguration[];
    /**
     * @stability stable
     */
    set jwtConfiguration(value: Apigatewayv2AuthorizerJwtConfiguration[]);
    /**
     * @stability stable
     */
    resetJwtConfiguration(): void;
    /**
     * @stability stable
     */
    get jwtConfigurationInput(): Apigatewayv2AuthorizerJwtConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
