import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Apigatewayv2DomainNameConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly domainName: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * domain_name_configuration block.
     *
     * @stability stable
     */
    readonly domainNameConfiguration: Apigatewayv2DomainNameDomainNameConfiguration[];
    /**
     * mutual_tls_authentication block.
     *
     * @stability stable
     */
    readonly mutualTlsAuthentication?: Apigatewayv2DomainNameMutualTlsAuthentication[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: Apigatewayv2DomainNameTimeouts;
}
/**
 * @stability stable
 */
export interface Apigatewayv2DomainNameDomainNameConfiguration {
    /**
     * @stability stable
     */
    readonly certificateArn: string;
    /**
     * @stability stable
     */
    readonly endpointType: string;
    /**
     * @stability stable
     */
    readonly securityPolicy: string;
}
/**
 * @stability stable
 */
export interface Apigatewayv2DomainNameMutualTlsAuthentication {
    /**
     * @stability stable
     */
    readonly truststoreUri: string;
    /**
     * @stability stable
     */
    readonly truststoreVersion?: string;
}
/**
 * @stability stable
 */
export interface Apigatewayv2DomainNameTimeouts {
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class Apigatewayv2DomainName extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2DomainNameConfig);
    /**
     * @stability stable
     */
    get apiMappingSelectionExpression(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _domainName;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _domainNameConfiguration;
    /**
     * @stability stable
     */
    get domainNameConfiguration(): Apigatewayv2DomainNameDomainNameConfiguration[];
    /**
     * @stability stable
     */
    set domainNameConfiguration(value: Apigatewayv2DomainNameDomainNameConfiguration[]);
    /**
     * @stability stable
     */
    get domainNameConfigurationInput(): Apigatewayv2DomainNameDomainNameConfiguration[];
    private _mutualTlsAuthentication?;
    /**
     * @stability stable
     */
    get mutualTlsAuthentication(): Apigatewayv2DomainNameMutualTlsAuthentication[];
    /**
     * @stability stable
     */
    set mutualTlsAuthentication(value: Apigatewayv2DomainNameMutualTlsAuthentication[]);
    /**
     * @stability stable
     */
    resetMutualTlsAuthentication(): void;
    /**
     * @stability stable
     */
    get mutualTlsAuthenticationInput(): Apigatewayv2DomainNameMutualTlsAuthentication[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): Apigatewayv2DomainNameTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: Apigatewayv2DomainNameTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): Apigatewayv2DomainNameTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
