import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Apigatewayv2IntegrationResponseConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly apiId: string;
    /**
     * @stability stable
     */
    readonly contentHandlingStrategy?: string;
    /**
     * @stability stable
     */
    readonly integrationId: string;
    /**
     * @stability stable
     */
    readonly integrationResponseKey: string;
    /**
     * @stability stable
     */
    readonly responseTemplates?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly templateSelectionExpression?: string;
}
/**
 * @stability stable
 */
export declare class Apigatewayv2IntegrationResponse extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2IntegrationResponseConfig);
    private _apiId;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string;
    private _contentHandlingStrategy?;
    /**
     * @stability stable
     */
    get contentHandlingStrategy(): string;
    /**
     * @stability stable
     */
    set contentHandlingStrategy(value: string);
    /**
     * @stability stable
     */
    resetContentHandlingStrategy(): void;
    /**
     * @stability stable
     */
    get contentHandlingStrategyInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _integrationId;
    /**
     * @stability stable
     */
    get integrationId(): string;
    /**
     * @stability stable
     */
    set integrationId(value: string);
    /**
     * @stability stable
     */
    get integrationIdInput(): string;
    private _integrationResponseKey;
    /**
     * @stability stable
     */
    get integrationResponseKey(): string;
    /**
     * @stability stable
     */
    set integrationResponseKey(value: string);
    /**
     * @stability stable
     */
    get integrationResponseKeyInput(): string;
    private _responseTemplates?;
    /**
     * @stability stable
     */
    get responseTemplates(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set responseTemplates(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetResponseTemplates(): void;
    /**
     * @stability stable
     */
    get responseTemplatesInput(): {
        [key: string]: string;
    } | undefined;
    private _templateSelectionExpression?;
    /**
     * @stability stable
     */
    get templateSelectionExpression(): string;
    /**
     * @stability stable
     */
    set templateSelectionExpression(value: string);
    /**
     * @stability stable
     */
    resetTemplateSelectionExpression(): void;
    /**
     * @stability stable
     */
    get templateSelectionExpressionInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
