import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Apigatewayv2IntegrationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly apiId: string;
    /**
     * @stability stable
     */
    readonly connectionId?: string;
    /**
     * @stability stable
     */
    readonly connectionType?: string;
    /**
     * @stability stable
     */
    readonly contentHandlingStrategy?: string;
    /**
     * @stability stable
     */
    readonly credentialsArn?: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly integrationMethod?: string;
    /**
     * @stability stable
     */
    readonly integrationSubtype?: string;
    /**
     * @stability stable
     */
    readonly integrationType: string;
    /**
     * @stability stable
     */
    readonly integrationUri?: string;
    /**
     * @stability stable
     */
    readonly passthroughBehavior?: string;
    /**
     * @stability stable
     */
    readonly payloadFormatVersion?: string;
    /**
     * @stability stable
     */
    readonly requestParameters?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly requestTemplates?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly templateSelectionExpression?: string;
    /**
     * @stability stable
     */
    readonly timeoutMilliseconds?: number;
    /**
     * response_parameters block.
     *
     * @stability stable
     */
    readonly responseParameters?: Apigatewayv2IntegrationResponseParameters[];
    /**
     * tls_config block.
     *
     * @stability stable
     */
    readonly tlsConfig?: Apigatewayv2IntegrationTlsConfig[];
}
/**
 * @stability stable
 */
export interface Apigatewayv2IntegrationResponseParameters {
    /**
     * @stability stable
     */
    readonly mappings: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly statusCode: string;
}
/**
 * @stability stable
 */
export interface Apigatewayv2IntegrationTlsConfig {
    /**
     * @stability stable
     */
    readonly serverNameToVerify?: string;
}
/**
 * @stability stable
 */
export declare class Apigatewayv2Integration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2IntegrationConfig);
    private _apiId;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string;
    private _connectionId?;
    /**
     * @stability stable
     */
    get connectionId(): string;
    /**
     * @stability stable
     */
    set connectionId(value: string);
    /**
     * @stability stable
     */
    resetConnectionId(): void;
    /**
     * @stability stable
     */
    get connectionIdInput(): string | undefined;
    private _connectionType?;
    /**
     * @stability stable
     */
    get connectionType(): string;
    /**
     * @stability stable
     */
    set connectionType(value: string);
    /**
     * @stability stable
     */
    resetConnectionType(): void;
    /**
     * @stability stable
     */
    get connectionTypeInput(): string | undefined;
    private _contentHandlingStrategy?;
    /**
     * @stability stable
     */
    get contentHandlingStrategy(): string;
    /**
     * @stability stable
     */
    set contentHandlingStrategy(value: string);
    /**
     * @stability stable
     */
    resetContentHandlingStrategy(): void;
    /**
     * @stability stable
     */
    get contentHandlingStrategyInput(): string | undefined;
    private _credentialsArn?;
    /**
     * @stability stable
     */
    get credentialsArn(): string;
    /**
     * @stability stable
     */
    set credentialsArn(value: string);
    /**
     * @stability stable
     */
    resetCredentialsArn(): void;
    /**
     * @stability stable
     */
    get credentialsArnInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _integrationMethod?;
    /**
     * @stability stable
     */
    get integrationMethod(): string;
    /**
     * @stability stable
     */
    set integrationMethod(value: string);
    /**
     * @stability stable
     */
    resetIntegrationMethod(): void;
    /**
     * @stability stable
     */
    get integrationMethodInput(): string | undefined;
    /**
     * @stability stable
     */
    get integrationResponseSelectionExpression(): string;
    private _integrationSubtype?;
    /**
     * @stability stable
     */
    get integrationSubtype(): string;
    /**
     * @stability stable
     */
    set integrationSubtype(value: string);
    /**
     * @stability stable
     */
    resetIntegrationSubtype(): void;
    /**
     * @stability stable
     */
    get integrationSubtypeInput(): string | undefined;
    private _integrationType;
    /**
     * @stability stable
     */
    get integrationType(): string;
    /**
     * @stability stable
     */
    set integrationType(value: string);
    /**
     * @stability stable
     */
    get integrationTypeInput(): string;
    private _integrationUri?;
    /**
     * @stability stable
     */
    get integrationUri(): string;
    /**
     * @stability stable
     */
    set integrationUri(value: string);
    /**
     * @stability stable
     */
    resetIntegrationUri(): void;
    /**
     * @stability stable
     */
    get integrationUriInput(): string | undefined;
    private _passthroughBehavior?;
    /**
     * @stability stable
     */
    get passthroughBehavior(): string;
    /**
     * @stability stable
     */
    set passthroughBehavior(value: string);
    /**
     * @stability stable
     */
    resetPassthroughBehavior(): void;
    /**
     * @stability stable
     */
    get passthroughBehaviorInput(): string | undefined;
    private _payloadFormatVersion?;
    /**
     * @stability stable
     */
    get payloadFormatVersion(): string;
    /**
     * @stability stable
     */
    set payloadFormatVersion(value: string);
    /**
     * @stability stable
     */
    resetPayloadFormatVersion(): void;
    /**
     * @stability stable
     */
    get payloadFormatVersionInput(): string | undefined;
    private _requestParameters?;
    /**
     * @stability stable
     */
    get requestParameters(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set requestParameters(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetRequestParameters(): void;
    /**
     * @stability stable
     */
    get requestParametersInput(): {
        [key: string]: string;
    } | undefined;
    private _requestTemplates?;
    /**
     * @stability stable
     */
    get requestTemplates(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set requestTemplates(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetRequestTemplates(): void;
    /**
     * @stability stable
     */
    get requestTemplatesInput(): {
        [key: string]: string;
    } | undefined;
    private _templateSelectionExpression?;
    /**
     * @stability stable
     */
    get templateSelectionExpression(): string;
    /**
     * @stability stable
     */
    set templateSelectionExpression(value: string);
    /**
     * @stability stable
     */
    resetTemplateSelectionExpression(): void;
    /**
     * @stability stable
     */
    get templateSelectionExpressionInput(): string | undefined;
    private _timeoutMilliseconds?;
    /**
     * @stability stable
     */
    get timeoutMilliseconds(): number;
    /**
     * @stability stable
     */
    set timeoutMilliseconds(value: number);
    /**
     * @stability stable
     */
    resetTimeoutMilliseconds(): void;
    /**
     * @stability stable
     */
    get timeoutMillisecondsInput(): number | undefined;
    private _responseParameters?;
    /**
     * @stability stable
     */
    get responseParameters(): Apigatewayv2IntegrationResponseParameters[];
    /**
     * @stability stable
     */
    set responseParameters(value: Apigatewayv2IntegrationResponseParameters[]);
    /**
     * @stability stable
     */
    resetResponseParameters(): void;
    /**
     * @stability stable
     */
    get responseParametersInput(): Apigatewayv2IntegrationResponseParameters[] | undefined;
    private _tlsConfig?;
    /**
     * @stability stable
     */
    get tlsConfig(): Apigatewayv2IntegrationTlsConfig[];
    /**
     * @stability stable
     */
    set tlsConfig(value: Apigatewayv2IntegrationTlsConfig[]);
    /**
     * @stability stable
     */
    resetTlsConfig(): void;
    /**
     * @stability stable
     */
    get tlsConfigInput(): Apigatewayv2IntegrationTlsConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
