import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Apigatewayv2RouteResponseConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly apiId: string;
    /**
     * @stability stable
     */
    readonly modelSelectionExpression?: string;
    /**
     * @stability stable
     */
    readonly responseModels?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly routeId: string;
    /**
     * @stability stable
     */
    readonly routeResponseKey: string;
}
/**
 * @stability stable
 */
export declare class Apigatewayv2RouteResponse extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2RouteResponseConfig);
    private _apiId;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _modelSelectionExpression?;
    /**
     * @stability stable
     */
    get modelSelectionExpression(): string;
    /**
     * @stability stable
     */
    set modelSelectionExpression(value: string);
    /**
     * @stability stable
     */
    resetModelSelectionExpression(): void;
    /**
     * @stability stable
     */
    get modelSelectionExpressionInput(): string | undefined;
    private _responseModels?;
    /**
     * @stability stable
     */
    get responseModels(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set responseModels(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetResponseModels(): void;
    /**
     * @stability stable
     */
    get responseModelsInput(): {
        [key: string]: string;
    } | undefined;
    private _routeId;
    /**
     * @stability stable
     */
    get routeId(): string;
    /**
     * @stability stable
     */
    set routeId(value: string);
    /**
     * @stability stable
     */
    get routeIdInput(): string;
    private _routeResponseKey;
    /**
     * @stability stable
     */
    get routeResponseKey(): string;
    /**
     * @stability stable
     */
    set routeResponseKey(value: string);
    /**
     * @stability stable
     */
    get routeResponseKeyInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
