import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Apigatewayv2RouteConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly apiId: string;
    /**
     * @stability stable
     */
    readonly apiKeyRequired?: boolean;
    /**
     * @stability stable
     */
    readonly authorizationScopes?: string[];
    /**
     * @stability stable
     */
    readonly authorizationType?: string;
    /**
     * @stability stable
     */
    readonly authorizerId?: string;
    /**
     * @stability stable
     */
    readonly modelSelectionExpression?: string;
    /**
     * @stability stable
     */
    readonly operationName?: string;
    /**
     * @stability stable
     */
    readonly requestModels?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly routeKey: string;
    /**
     * @stability stable
     */
    readonly routeResponseSelectionExpression?: string;
    /**
     * @stability stable
     */
    readonly target?: string;
}
/**
 * @stability stable
 */
export declare class Apigatewayv2Route extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2RouteConfig);
    private _apiId;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string;
    private _apiKeyRequired?;
    /**
     * @stability stable
     */
    get apiKeyRequired(): boolean;
    /**
     * @stability stable
     */
    set apiKeyRequired(value: boolean);
    /**
     * @stability stable
     */
    resetApiKeyRequired(): void;
    /**
     * @stability stable
     */
    get apiKeyRequiredInput(): boolean | undefined;
    private _authorizationScopes?;
    /**
     * @stability stable
     */
    get authorizationScopes(): string[];
    /**
     * @stability stable
     */
    set authorizationScopes(value: string[]);
    /**
     * @stability stable
     */
    resetAuthorizationScopes(): void;
    /**
     * @stability stable
     */
    get authorizationScopesInput(): string[] | undefined;
    private _authorizationType?;
    /**
     * @stability stable
     */
    get authorizationType(): string;
    /**
     * @stability stable
     */
    set authorizationType(value: string);
    /**
     * @stability stable
     */
    resetAuthorizationType(): void;
    /**
     * @stability stable
     */
    get authorizationTypeInput(): string | undefined;
    private _authorizerId?;
    /**
     * @stability stable
     */
    get authorizerId(): string;
    /**
     * @stability stable
     */
    set authorizerId(value: string);
    /**
     * @stability stable
     */
    resetAuthorizerId(): void;
    /**
     * @stability stable
     */
    get authorizerIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _modelSelectionExpression?;
    /**
     * @stability stable
     */
    get modelSelectionExpression(): string;
    /**
     * @stability stable
     */
    set modelSelectionExpression(value: string);
    /**
     * @stability stable
     */
    resetModelSelectionExpression(): void;
    /**
     * @stability stable
     */
    get modelSelectionExpressionInput(): string | undefined;
    private _operationName?;
    /**
     * @stability stable
     */
    get operationName(): string;
    /**
     * @stability stable
     */
    set operationName(value: string);
    /**
     * @stability stable
     */
    resetOperationName(): void;
    /**
     * @stability stable
     */
    get operationNameInput(): string | undefined;
    private _requestModels?;
    /**
     * @stability stable
     */
    get requestModels(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set requestModels(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetRequestModels(): void;
    /**
     * @stability stable
     */
    get requestModelsInput(): {
        [key: string]: string;
    } | undefined;
    private _routeKey;
    /**
     * @stability stable
     */
    get routeKey(): string;
    /**
     * @stability stable
     */
    set routeKey(value: string);
    /**
     * @stability stable
     */
    get routeKeyInput(): string;
    private _routeResponseSelectionExpression?;
    /**
     * @stability stable
     */
    get routeResponseSelectionExpression(): string;
    /**
     * @stability stable
     */
    set routeResponseSelectionExpression(value: string);
    /**
     * @stability stable
     */
    resetRouteResponseSelectionExpression(): void;
    /**
     * @stability stable
     */
    get routeResponseSelectionExpressionInput(): string | undefined;
    private _target?;
    /**
     * @stability stable
     */
    get target(): string;
    /**
     * @stability stable
     */
    set target(value: string);
    /**
     * @stability stable
     */
    resetTarget(): void;
    /**
     * @stability stable
     */
    get targetInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
