import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Apigatewayv2StageConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly apiId: string;
    /**
     * @stability stable
     */
    readonly autoDeploy?: boolean;
    /**
     * @stability stable
     */
    readonly clientCertificateId?: string;
    /**
     * @stability stable
     */
    readonly deploymentId?: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly stageVariables?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * access_log_settings block.
     *
     * @stability stable
     */
    readonly accessLogSettings?: Apigatewayv2StageAccessLogSettings[];
    /**
     * default_route_settings block.
     *
     * @stability stable
     */
    readonly defaultRouteSettings?: Apigatewayv2StageDefaultRouteSettings[];
    /**
     * route_settings block.
     *
     * @stability stable
     */
    readonly routeSettings?: Apigatewayv2StageRouteSettings[];
}
/**
 * @stability stable
 */
export interface Apigatewayv2StageAccessLogSettings {
    /**
     * @stability stable
     */
    readonly destinationArn: string;
    /**
     * @stability stable
     */
    readonly format: string;
}
/**
 * @stability stable
 */
export interface Apigatewayv2StageDefaultRouteSettings {
    /**
     * @stability stable
     */
    readonly dataTraceEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly detailedMetricsEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly loggingLevel?: string;
    /**
     * @stability stable
     */
    readonly throttlingBurstLimit?: number;
    /**
     * @stability stable
     */
    readonly throttlingRateLimit?: number;
}
/**
 * @stability stable
 */
export interface Apigatewayv2StageRouteSettings {
    /**
     * @stability stable
     */
    readonly dataTraceEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly detailedMetricsEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly loggingLevel?: string;
    /**
     * @stability stable
     */
    readonly routeKey: string;
    /**
     * @stability stable
     */
    readonly throttlingBurstLimit?: number;
    /**
     * @stability stable
     */
    readonly throttlingRateLimit?: number;
}
/**
 * @stability stable
 */
export declare class Apigatewayv2Stage extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Apigatewayv2StageConfig);
    private _apiId;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoDeploy?;
    /**
     * @stability stable
     */
    get autoDeploy(): boolean;
    /**
     * @stability stable
     */
    set autoDeploy(value: boolean);
    /**
     * @stability stable
     */
    resetAutoDeploy(): void;
    /**
     * @stability stable
     */
    get autoDeployInput(): boolean | undefined;
    private _clientCertificateId?;
    /**
     * @stability stable
     */
    get clientCertificateId(): string;
    /**
     * @stability stable
     */
    set clientCertificateId(value: string);
    /**
     * @stability stable
     */
    resetClientCertificateId(): void;
    /**
     * @stability stable
     */
    get clientCertificateIdInput(): string | undefined;
    private _deploymentId?;
    /**
     * @stability stable
     */
    get deploymentId(): string;
    /**
     * @stability stable
     */
    set deploymentId(value: string);
    /**
     * @stability stable
     */
    resetDeploymentId(): void;
    /**
     * @stability stable
     */
    get deploymentIdInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get executionArn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get invokeUrl(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _stageVariables?;
    /**
     * @stability stable
     */
    get stageVariables(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set stageVariables(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetStageVariables(): void;
    /**
     * @stability stable
     */
    get stageVariablesInput(): {
        [key: string]: string;
    } | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _accessLogSettings?;
    /**
     * @stability stable
     */
    get accessLogSettings(): Apigatewayv2StageAccessLogSettings[];
    /**
     * @stability stable
     */
    set accessLogSettings(value: Apigatewayv2StageAccessLogSettings[]);
    /**
     * @stability stable
     */
    resetAccessLogSettings(): void;
    /**
     * @stability stable
     */
    get accessLogSettingsInput(): Apigatewayv2StageAccessLogSettings[] | undefined;
    private _defaultRouteSettings?;
    /**
     * @stability stable
     */
    get defaultRouteSettings(): Apigatewayv2StageDefaultRouteSettings[];
    /**
     * @stability stable
     */
    set defaultRouteSettings(value: Apigatewayv2StageDefaultRouteSettings[]);
    /**
     * @stability stable
     */
    resetDefaultRouteSettings(): void;
    /**
     * @stability stable
     */
    get defaultRouteSettingsInput(): Apigatewayv2StageDefaultRouteSettings[] | undefined;
    private _routeSettings?;
    /**
     * @stability stable
     */
    get routeSettings(): Apigatewayv2StageRouteSettings[];
    /**
     * @stability stable
     */
    set routeSettings(value: Apigatewayv2StageRouteSettings[]);
    /**
     * @stability stable
     */
    resetRouteSettings(): void;
    /**
     * @stability stable
     */
    get routeSettingsInput(): Apigatewayv2StageRouteSettings[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
