import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppautoscalingPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly policyType?: string;
    /**
     * @stability stable
     */
    readonly resourceId: string;
    /**
     * @stability stable
     */
    readonly scalableDimension: string;
    /**
     * @stability stable
     */
    readonly serviceNamespace: string;
    /**
     * step_scaling_policy_configuration block.
     *
     * @stability stable
     */
    readonly stepScalingPolicyConfiguration?: AppautoscalingPolicyStepScalingPolicyConfiguration[];
    /**
     * target_tracking_scaling_policy_configuration block.
     *
     * @stability stable
     */
    readonly targetTrackingScalingPolicyConfiguration?: AppautoscalingPolicyTargetTrackingScalingPolicyConfiguration[];
}
/**
 * @stability stable
 */
export interface AppautoscalingPolicyStepScalingPolicyConfigurationStepAdjustment {
    /**
     * @stability stable
     */
    readonly metricIntervalLowerBound?: string;
    /**
     * @stability stable
     */
    readonly metricIntervalUpperBound?: string;
    /**
     * @stability stable
     */
    readonly scalingAdjustment: number;
}
/**
 * @stability stable
 */
export interface AppautoscalingPolicyStepScalingPolicyConfiguration {
    /**
     * @stability stable
     */
    readonly adjustmentType?: string;
    /**
     * @stability stable
     */
    readonly cooldown?: number;
    /**
     * @stability stable
     */
    readonly metricAggregationType?: string;
    /**
     * @stability stable
     */
    readonly minAdjustmentMagnitude?: number;
    /**
     * step_adjustment block.
     *
     * @stability stable
     */
    readonly stepAdjustment?: AppautoscalingPolicyStepScalingPolicyConfigurationStepAdjustment[];
}
/**
 * @stability stable
 */
export interface AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationCustomizedMetricSpecificationDimensions {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationCustomizedMetricSpecification {
    /**
     * @stability stable
     */
    readonly metricName: string;
    /**
     * @stability stable
     */
    readonly namespace: string;
    /**
     * @stability stable
     */
    readonly statistic: string;
    /**
     * @stability stable
     */
    readonly unit?: string;
    /**
     * dimensions block.
     *
     * @stability stable
     */
    readonly dimensions?: AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationCustomizedMetricSpecificationDimensions[];
}
/**
 * @stability stable
 */
export interface AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationPredefinedMetricSpecification {
    /**
     * @stability stable
     */
    readonly predefinedMetricType: string;
    /**
     * @stability stable
     */
    readonly resourceLabel?: string;
}
/**
 * @stability stable
 */
export interface AppautoscalingPolicyTargetTrackingScalingPolicyConfiguration {
    /**
     * @stability stable
     */
    readonly disableScaleIn?: boolean;
    /**
     * @stability stable
     */
    readonly scaleInCooldown?: number;
    /**
     * @stability stable
     */
    readonly scaleOutCooldown?: number;
    /**
     * @stability stable
     */
    readonly targetValue: number;
    /**
     * customized_metric_specification block.
     *
     * @stability stable
     */
    readonly customizedMetricSpecification?: AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationCustomizedMetricSpecification[];
    /**
     * predefined_metric_specification block.
     *
     * @stability stable
     */
    readonly predefinedMetricSpecification?: AppautoscalingPolicyTargetTrackingScalingPolicyConfigurationPredefinedMetricSpecification[];
}
/**
 * @stability stable
 */
export declare class AppautoscalingPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppautoscalingPolicyConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _policyType?;
    /**
     * @stability stable
     */
    get policyType(): string;
    /**
     * @stability stable
     */
    set policyType(value: string);
    /**
     * @stability stable
     */
    resetPolicyType(): void;
    /**
     * @stability stable
     */
    get policyTypeInput(): string | undefined;
    private _resourceId;
    /**
     * @stability stable
     */
    get resourceId(): string;
    /**
     * @stability stable
     */
    set resourceId(value: string);
    /**
     * @stability stable
     */
    get resourceIdInput(): string;
    private _scalableDimension;
    /**
     * @stability stable
     */
    get scalableDimension(): string;
    /**
     * @stability stable
     */
    set scalableDimension(value: string);
    /**
     * @stability stable
     */
    get scalableDimensionInput(): string;
    private _serviceNamespace;
    /**
     * @stability stable
     */
    get serviceNamespace(): string;
    /**
     * @stability stable
     */
    set serviceNamespace(value: string);
    /**
     * @stability stable
     */
    get serviceNamespaceInput(): string;
    private _stepScalingPolicyConfiguration?;
    /**
     * @stability stable
     */
    get stepScalingPolicyConfiguration(): AppautoscalingPolicyStepScalingPolicyConfiguration[];
    /**
     * @stability stable
     */
    set stepScalingPolicyConfiguration(value: AppautoscalingPolicyStepScalingPolicyConfiguration[]);
    /**
     * @stability stable
     */
    resetStepScalingPolicyConfiguration(): void;
    /**
     * @stability stable
     */
    get stepScalingPolicyConfigurationInput(): AppautoscalingPolicyStepScalingPolicyConfiguration[] | undefined;
    private _targetTrackingScalingPolicyConfiguration?;
    /**
     * @stability stable
     */
    get targetTrackingScalingPolicyConfiguration(): AppautoscalingPolicyTargetTrackingScalingPolicyConfiguration[];
    /**
     * @stability stable
     */
    set targetTrackingScalingPolicyConfiguration(value: AppautoscalingPolicyTargetTrackingScalingPolicyConfiguration[]);
    /**
     * @stability stable
     */
    resetTargetTrackingScalingPolicyConfiguration(): void;
    /**
     * @stability stable
     */
    get targetTrackingScalingPolicyConfigurationInput(): AppautoscalingPolicyTargetTrackingScalingPolicyConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
