import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppautoscalingScheduledActionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly endTime?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly resourceId: string;
    /**
     * @stability stable
     */
    readonly scalableDimension: string;
    /**
     * @stability stable
     */
    readonly schedule: string;
    /**
     * @stability stable
     */
    readonly serviceNamespace: string;
    /**
     * @stability stable
     */
    readonly startTime?: string;
    /**
     * @stability stable
     */
    readonly timezone?: string;
    /**
     * scalable_target_action block.
     *
     * @stability stable
     */
    readonly scalableTargetAction: AppautoscalingScheduledActionScalableTargetAction[];
}
/**
 * @stability stable
 */
export interface AppautoscalingScheduledActionScalableTargetAction {
    /**
     * @stability stable
     */
    readonly maxCapacity?: string;
    /**
     * @stability stable
     */
    readonly minCapacity?: string;
}
/**
 * @stability stable
 */
export declare class AppautoscalingScheduledAction extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppautoscalingScheduledActionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _endTime?;
    /**
     * @stability stable
     */
    get endTime(): string;
    /**
     * @stability stable
     */
    set endTime(value: string);
    /**
     * @stability stable
     */
    resetEndTime(): void;
    /**
     * @stability stable
     */
    get endTimeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _resourceId;
    /**
     * @stability stable
     */
    get resourceId(): string;
    /**
     * @stability stable
     */
    set resourceId(value: string);
    /**
     * @stability stable
     */
    get resourceIdInput(): string;
    private _scalableDimension;
    /**
     * @stability stable
     */
    get scalableDimension(): string;
    /**
     * @stability stable
     */
    set scalableDimension(value: string);
    /**
     * @stability stable
     */
    get scalableDimensionInput(): string;
    private _schedule;
    /**
     * @stability stable
     */
    get schedule(): string;
    /**
     * @stability stable
     */
    set schedule(value: string);
    /**
     * @stability stable
     */
    get scheduleInput(): string;
    private _serviceNamespace;
    /**
     * @stability stable
     */
    get serviceNamespace(): string;
    /**
     * @stability stable
     */
    set serviceNamespace(value: string);
    /**
     * @stability stable
     */
    get serviceNamespaceInput(): string;
    private _startTime?;
    /**
     * @stability stable
     */
    get startTime(): string;
    /**
     * @stability stable
     */
    set startTime(value: string);
    /**
     * @stability stable
     */
    resetStartTime(): void;
    /**
     * @stability stable
     */
    get startTimeInput(): string | undefined;
    private _timezone?;
    /**
     * @stability stable
     */
    get timezone(): string;
    /**
     * @stability stable
     */
    set timezone(value: string);
    /**
     * @stability stable
     */
    resetTimezone(): void;
    /**
     * @stability stable
     */
    get timezoneInput(): string | undefined;
    private _scalableTargetAction;
    /**
     * @stability stable
     */
    get scalableTargetAction(): AppautoscalingScheduledActionScalableTargetAction[];
    /**
     * @stability stable
     */
    set scalableTargetAction(value: AppautoscalingScheduledActionScalableTargetAction[]);
    /**
     * @stability stable
     */
    get scalableTargetActionInput(): AppautoscalingScheduledActionScalableTargetAction[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
