import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly meshName: string;
    /**
     * @stability stable
     */
    readonly meshOwner?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly virtualGatewayName: string;
    /**
     * spec block.
     *
     * @stability stable
     */
    readonly spec: AppmeshGatewayRouteSpec[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecGrpcRouteActionTargetVirtualService {
    /**
     * @stability stable
     */
    readonly virtualServiceName: string;
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecGrpcRouteActionTarget {
    /**
     * virtual_service block.
     *
     * @stability stable
     */
    readonly virtualService: AppmeshGatewayRouteSpecGrpcRouteActionTargetVirtualService[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecGrpcRouteAction {
    /**
     * target block.
     *
     * @stability stable
     */
    readonly target: AppmeshGatewayRouteSpecGrpcRouteActionTarget[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecGrpcRouteMatch {
    /**
     * @stability stable
     */
    readonly serviceName: string;
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecGrpcRoute {
    /**
     * action block.
     *
     * @stability stable
     */
    readonly action: AppmeshGatewayRouteSpecGrpcRouteAction[];
    /**
     * match block.
     *
     * @stability stable
     */
    readonly match: AppmeshGatewayRouteSpecGrpcRouteMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttp2RouteActionTargetVirtualService {
    /**
     * @stability stable
     */
    readonly virtualServiceName: string;
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttp2RouteActionTarget {
    /**
     * virtual_service block.
     *
     * @stability stable
     */
    readonly virtualService: AppmeshGatewayRouteSpecHttp2RouteActionTargetVirtualService[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttp2RouteAction {
    /**
     * target block.
     *
     * @stability stable
     */
    readonly target: AppmeshGatewayRouteSpecHttp2RouteActionTarget[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttp2RouteMatch {
    /**
     * @stability stable
     */
    readonly prefix: string;
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttp2Route {
    /**
     * action block.
     *
     * @stability stable
     */
    readonly action: AppmeshGatewayRouteSpecHttp2RouteAction[];
    /**
     * match block.
     *
     * @stability stable
     */
    readonly match: AppmeshGatewayRouteSpecHttp2RouteMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttpRouteActionTargetVirtualService {
    /**
     * @stability stable
     */
    readonly virtualServiceName: string;
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttpRouteActionTarget {
    /**
     * virtual_service block.
     *
     * @stability stable
     */
    readonly virtualService: AppmeshGatewayRouteSpecHttpRouteActionTargetVirtualService[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttpRouteAction {
    /**
     * target block.
     *
     * @stability stable
     */
    readonly target: AppmeshGatewayRouteSpecHttpRouteActionTarget[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttpRouteMatch {
    /**
     * @stability stable
     */
    readonly prefix: string;
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpecHttpRoute {
    /**
     * action block.
     *
     * @stability stable
     */
    readonly action: AppmeshGatewayRouteSpecHttpRouteAction[];
    /**
     * match block.
     *
     * @stability stable
     */
    readonly match: AppmeshGatewayRouteSpecHttpRouteMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshGatewayRouteSpec {
    /**
     * grpc_route block.
     *
     * @stability stable
     */
    readonly grpcRoute?: AppmeshGatewayRouteSpecGrpcRoute[];
    /**
     * http2_route block.
     *
     * @stability stable
     */
    readonly http2Route?: AppmeshGatewayRouteSpecHttp2Route[];
    /**
     * http_route block.
     *
     * @stability stable
     */
    readonly httpRoute?: AppmeshGatewayRouteSpecHttpRoute[];
}
/**
 * @stability stable
 */
export declare class AppmeshGatewayRoute extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppmeshGatewayRouteConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdDate(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _meshName;
    /**
     * @stability stable
     */
    get meshName(): string;
    /**
     * @stability stable
     */
    set meshName(value: string);
    /**
     * @stability stable
     */
    get meshNameInput(): string;
    private _meshOwner?;
    /**
     * @stability stable
     */
    get meshOwner(): string;
    /**
     * @stability stable
     */
    set meshOwner(value: string);
    /**
     * @stability stable
     */
    resetMeshOwner(): void;
    /**
     * @stability stable
     */
    get meshOwnerInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get resourceOwner(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _virtualGatewayName;
    /**
     * @stability stable
     */
    get virtualGatewayName(): string;
    /**
     * @stability stable
     */
    set virtualGatewayName(value: string);
    /**
     * @stability stable
     */
    get virtualGatewayNameInput(): string;
    private _spec;
    /**
     * @stability stable
     */
    get spec(): AppmeshGatewayRouteSpec[];
    /**
     * @stability stable
     */
    set spec(value: AppmeshGatewayRouteSpec[]);
    /**
     * @stability stable
     */
    get specInput(): AppmeshGatewayRouteSpec[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
