import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppmeshRouteConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly meshName: string;
    /**
     * @stability stable
     */
    readonly meshOwner?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly virtualRouterName: string;
    /**
     * spec block.
     *
     * @stability stable
     */
    readonly spec: AppmeshRouteSpec[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteActionWeightedTarget {
    /**
     * @stability stable
     */
    readonly virtualNode: string;
    /**
     * @stability stable
     */
    readonly weight: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteAction {
    /**
     * weighted_target block.
     *
     * @stability stable
     */
    readonly weightedTarget: AppmeshRouteSpecGrpcRouteActionWeightedTarget[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteMatchMetadataMatchRange {
    /**
     * @stability stable
     */
    readonly end: number;
    /**
     * @stability stable
     */
    readonly start: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteMatchMetadataMatch {
    /**
     * @stability stable
     */
    readonly exact?: string;
    /**
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * @stability stable
     */
    readonly regex?: string;
    /**
     * @stability stable
     */
    readonly suffix?: string;
    /**
     * range block.
     *
     * @stability stable
     */
    readonly range?: AppmeshRouteSpecGrpcRouteMatchMetadataMatchRange[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteMatchMetadata {
    /**
     * @stability stable
     */
    readonly invert?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * match block.
     *
     * @stability stable
     */
    readonly match?: AppmeshRouteSpecGrpcRouteMatchMetadataMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteMatch {
    /**
     * @stability stable
     */
    readonly methodName?: string;
    /**
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * @stability stable
     */
    readonly serviceName?: string;
    /**
     * metadata block.
     *
     * @stability stable
     */
    readonly metadata?: AppmeshRouteSpecGrpcRouteMatchMetadata[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeout {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteRetryPolicy {
    /**
     * @stability stable
     */
    readonly grpcRetryEvents?: string[];
    /**
     * @stability stable
     */
    readonly httpRetryEvents?: string[];
    /**
     * @stability stable
     */
    readonly maxRetries: number;
    /**
     * @stability stable
     */
    readonly tcpRetryEvents?: string[];
    /**
     * per_retry_timeout block.
     *
     * @stability stable
     */
    readonly perRetryTimeout: AppmeshRouteSpecGrpcRouteRetryPolicyPerRetryTimeout[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteTimeoutIdle {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteTimeoutPerRequest {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRouteTimeout {
    /**
     * idle block.
     *
     * @stability stable
     */
    readonly idle?: AppmeshRouteSpecGrpcRouteTimeoutIdle[];
    /**
     * per_request block.
     *
     * @stability stable
     */
    readonly perRequest?: AppmeshRouteSpecGrpcRouteTimeoutPerRequest[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecGrpcRoute {
    /**
     * action block.
     *
     * @stability stable
     */
    readonly action: AppmeshRouteSpecGrpcRouteAction[];
    /**
     * match block.
     *
     * @stability stable
     */
    readonly match?: AppmeshRouteSpecGrpcRouteMatch[];
    /**
     * retry_policy block.
     *
     * @stability stable
     */
    readonly retryPolicy?: AppmeshRouteSpecGrpcRouteRetryPolicy[];
    /**
     * timeout block.
     *
     * @stability stable
     */
    readonly timeout?: AppmeshRouteSpecGrpcRouteTimeout[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteActionWeightedTarget {
    /**
     * @stability stable
     */
    readonly virtualNode: string;
    /**
     * @stability stable
     */
    readonly weight: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteAction {
    /**
     * weighted_target block.
     *
     * @stability stable
     */
    readonly weightedTarget: AppmeshRouteSpecHttp2RouteActionWeightedTarget[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteMatchHeaderMatchRange {
    /**
     * @stability stable
     */
    readonly end: number;
    /**
     * @stability stable
     */
    readonly start: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteMatchHeaderMatch {
    /**
     * @stability stable
     */
    readonly exact?: string;
    /**
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * @stability stable
     */
    readonly regex?: string;
    /**
     * @stability stable
     */
    readonly suffix?: string;
    /**
     * range block.
     *
     * @stability stable
     */
    readonly range?: AppmeshRouteSpecHttp2RouteMatchHeaderMatchRange[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteMatchHeader {
    /**
     * @stability stable
     */
    readonly invert?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * match block.
     *
     * @stability stable
     */
    readonly match?: AppmeshRouteSpecHttp2RouteMatchHeaderMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteMatch {
    /**
     * @stability stable
     */
    readonly method?: string;
    /**
     * @stability stable
     */
    readonly prefix: string;
    /**
     * @stability stable
     */
    readonly scheme?: string;
    /**
     * header block.
     *
     * @stability stable
     */
    readonly header?: AppmeshRouteSpecHttp2RouteMatchHeader[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeout {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteRetryPolicy {
    /**
     * @stability stable
     */
    readonly httpRetryEvents?: string[];
    /**
     * @stability stable
     */
    readonly maxRetries: number;
    /**
     * @stability stable
     */
    readonly tcpRetryEvents?: string[];
    /**
     * per_retry_timeout block.
     *
     * @stability stable
     */
    readonly perRetryTimeout: AppmeshRouteSpecHttp2RouteRetryPolicyPerRetryTimeout[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteTimeoutIdle {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteTimeoutPerRequest {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2RouteTimeout {
    /**
     * idle block.
     *
     * @stability stable
     */
    readonly idle?: AppmeshRouteSpecHttp2RouteTimeoutIdle[];
    /**
     * per_request block.
     *
     * @stability stable
     */
    readonly perRequest?: AppmeshRouteSpecHttp2RouteTimeoutPerRequest[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttp2Route {
    /**
     * action block.
     *
     * @stability stable
     */
    readonly action: AppmeshRouteSpecHttp2RouteAction[];
    /**
     * match block.
     *
     * @stability stable
     */
    readonly match: AppmeshRouteSpecHttp2RouteMatch[];
    /**
     * retry_policy block.
     *
     * @stability stable
     */
    readonly retryPolicy?: AppmeshRouteSpecHttp2RouteRetryPolicy[];
    /**
     * timeout block.
     *
     * @stability stable
     */
    readonly timeout?: AppmeshRouteSpecHttp2RouteTimeout[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteActionWeightedTarget {
    /**
     * @stability stable
     */
    readonly virtualNode: string;
    /**
     * @stability stable
     */
    readonly weight: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteAction {
    /**
     * weighted_target block.
     *
     * @stability stable
     */
    readonly weightedTarget: AppmeshRouteSpecHttpRouteActionWeightedTarget[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteMatchHeaderMatchRange {
    /**
     * @stability stable
     */
    readonly end: number;
    /**
     * @stability stable
     */
    readonly start: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteMatchHeaderMatch {
    /**
     * @stability stable
     */
    readonly exact?: string;
    /**
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * @stability stable
     */
    readonly regex?: string;
    /**
     * @stability stable
     */
    readonly suffix?: string;
    /**
     * range block.
     *
     * @stability stable
     */
    readonly range?: AppmeshRouteSpecHttpRouteMatchHeaderMatchRange[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteMatchHeader {
    /**
     * @stability stable
     */
    readonly invert?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * match block.
     *
     * @stability stable
     */
    readonly match?: AppmeshRouteSpecHttpRouteMatchHeaderMatch[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteMatch {
    /**
     * @stability stable
     */
    readonly method?: string;
    /**
     * @stability stable
     */
    readonly prefix: string;
    /**
     * @stability stable
     */
    readonly scheme?: string;
    /**
     * header block.
     *
     * @stability stable
     */
    readonly header?: AppmeshRouteSpecHttpRouteMatchHeader[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeout {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteRetryPolicy {
    /**
     * @stability stable
     */
    readonly httpRetryEvents?: string[];
    /**
     * @stability stable
     */
    readonly maxRetries: number;
    /**
     * @stability stable
     */
    readonly tcpRetryEvents?: string[];
    /**
     * per_retry_timeout block.
     *
     * @stability stable
     */
    readonly perRetryTimeout: AppmeshRouteSpecHttpRouteRetryPolicyPerRetryTimeout[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteTimeoutIdle {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteTimeoutPerRequest {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRouteTimeout {
    /**
     * idle block.
     *
     * @stability stable
     */
    readonly idle?: AppmeshRouteSpecHttpRouteTimeoutIdle[];
    /**
     * per_request block.
     *
     * @stability stable
     */
    readonly perRequest?: AppmeshRouteSpecHttpRouteTimeoutPerRequest[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecHttpRoute {
    /**
     * action block.
     *
     * @stability stable
     */
    readonly action: AppmeshRouteSpecHttpRouteAction[];
    /**
     * match block.
     *
     * @stability stable
     */
    readonly match: AppmeshRouteSpecHttpRouteMatch[];
    /**
     * retry_policy block.
     *
     * @stability stable
     */
    readonly retryPolicy?: AppmeshRouteSpecHttpRouteRetryPolicy[];
    /**
     * timeout block.
     *
     * @stability stable
     */
    readonly timeout?: AppmeshRouteSpecHttpRouteTimeout[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecTcpRouteActionWeightedTarget {
    /**
     * @stability stable
     */
    readonly virtualNode: string;
    /**
     * @stability stable
     */
    readonly weight: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecTcpRouteAction {
    /**
     * weighted_target block.
     *
     * @stability stable
     */
    readonly weightedTarget: AppmeshRouteSpecTcpRouteActionWeightedTarget[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecTcpRouteTimeoutIdle {
    /**
     * @stability stable
     */
    readonly unit: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecTcpRouteTimeout {
    /**
     * idle block.
     *
     * @stability stable
     */
    readonly idle?: AppmeshRouteSpecTcpRouteTimeoutIdle[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpecTcpRoute {
    /**
     * action block.
     *
     * @stability stable
     */
    readonly action: AppmeshRouteSpecTcpRouteAction[];
    /**
     * timeout block.
     *
     * @stability stable
     */
    readonly timeout?: AppmeshRouteSpecTcpRouteTimeout[];
}
/**
 * @stability stable
 */
export interface AppmeshRouteSpec {
    /**
     * @stability stable
     */
    readonly priority?: number;
    /**
     * grpc_route block.
     *
     * @stability stable
     */
    readonly grpcRoute?: AppmeshRouteSpecGrpcRoute[];
    /**
     * http2_route block.
     *
     * @stability stable
     */
    readonly http2Route?: AppmeshRouteSpecHttp2Route[];
    /**
     * http_route block.
     *
     * @stability stable
     */
    readonly httpRoute?: AppmeshRouteSpecHttpRoute[];
    /**
     * tcp_route block.
     *
     * @stability stable
     */
    readonly tcpRoute?: AppmeshRouteSpecTcpRoute[];
}
/**
 * @stability stable
 */
export declare class AppmeshRoute extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppmeshRouteConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdDate(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _meshName;
    /**
     * @stability stable
     */
    get meshName(): string;
    /**
     * @stability stable
     */
    set meshName(value: string);
    /**
     * @stability stable
     */
    get meshNameInput(): string;
    private _meshOwner?;
    /**
     * @stability stable
     */
    get meshOwner(): string;
    /**
     * @stability stable
     */
    set meshOwner(value: string);
    /**
     * @stability stable
     */
    resetMeshOwner(): void;
    /**
     * @stability stable
     */
    get meshOwnerInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get resourceOwner(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _virtualRouterName;
    /**
     * @stability stable
     */
    get virtualRouterName(): string;
    /**
     * @stability stable
     */
    set virtualRouterName(value: string);
    /**
     * @stability stable
     */
    get virtualRouterNameInput(): string;
    private _spec;
    /**
     * @stability stable
     */
    get spec(): AppmeshRouteSpec[];
    /**
     * @stability stable
     */
    set spec(value: AppmeshRouteSpec[]);
    /**
     * @stability stable
     */
    get specInput(): AppmeshRouteSpec[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
