import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewayConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly meshName: string;
    /**
     * @stability stable
     */
    readonly meshOwner?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * spec block.
     *
     * @stability stable
     */
    readonly spec: AppmeshVirtualGatewaySpec[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustAcm {
    /**
     * @stability stable
     */
    readonly certificateAuthorityArns: string[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustFile {
    /**
     * @stability stable
     */
    readonly certificateChain: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrust {
    /**
     * acm block.
     *
     * @stability stable
     */
    readonly acm?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustAcm[];
    /**
     * file block.
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrustFile[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidation {
    /**
     * trust block.
     *
     * @stability stable
     */
    readonly trust: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidationTrust[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTls {
    /**
     * @stability stable
     */
    readonly enforce?: boolean;
    /**
     * @stability stable
     */
    readonly ports?: number[];
    /**
     * validation block.
     *
     * @stability stable
     */
    readonly validation: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTlsValidation[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaultsClientPolicy {
    /**
     * tls block.
     *
     * @stability stable
     */
    readonly tls?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicyTls[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecBackendDefaults {
    /**
     * client_policy block.
     *
     * @stability stable
     */
    readonly clientPolicy?: AppmeshVirtualGatewaySpecBackendDefaultsClientPolicy[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerConnectionPoolGrpc {
    /**
     * @stability stable
     */
    readonly maxRequests: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerConnectionPoolHttp {
    /**
     * @stability stable
     */
    readonly maxConnections: number;
    /**
     * @stability stable
     */
    readonly maxPendingRequests?: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerConnectionPoolHttp2 {
    /**
     * @stability stable
     */
    readonly maxRequests: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerConnectionPool {
    /**
     * grpc block.
     *
     * @stability stable
     */
    readonly grpc?: AppmeshVirtualGatewaySpecListenerConnectionPoolGrpc[];
    /**
     * http block.
     *
     * @stability stable
     */
    readonly http?: AppmeshVirtualGatewaySpecListenerConnectionPoolHttp[];
    /**
     * http2 block.
     *
     * @stability stable
     */
    readonly http2?: AppmeshVirtualGatewaySpecListenerConnectionPoolHttp2[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerHealthCheck {
    /**
     * @stability stable
     */
    readonly healthyThreshold: number;
    /**
     * @stability stable
     */
    readonly intervalMillis: number;
    /**
     * @stability stable
     */
    readonly path?: string;
    /**
     * @stability stable
     */
    readonly port?: number;
    /**
     * @stability stable
     */
    readonly protocol: string;
    /**
     * @stability stable
     */
    readonly timeoutMillis: number;
    /**
     * @stability stable
     */
    readonly unhealthyThreshold: number;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerPortMapping {
    /**
     * @stability stable
     */
    readonly port: number;
    /**
     * @stability stable
     */
    readonly protocol: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerTlsCertificateAcm {
    /**
     * @stability stable
     */
    readonly certificateArn: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerTlsCertificateFile {
    /**
     * @stability stable
     */
    readonly certificateChain: string;
    /**
     * @stability stable
     */
    readonly privateKey: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerTlsCertificate {
    /**
     * acm block.
     *
     * @stability stable
     */
    readonly acm?: AppmeshVirtualGatewaySpecListenerTlsCertificateAcm[];
    /**
     * file block.
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualGatewaySpecListenerTlsCertificateFile[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListenerTls {
    /**
     * @stability stable
     */
    readonly mode: string;
    /**
     * certificate block.
     *
     * @stability stable
     */
    readonly certificate: AppmeshVirtualGatewaySpecListenerTlsCertificate[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecListener {
    /**
     * connection_pool block.
     *
     * @stability stable
     */
    readonly connectionPool?: AppmeshVirtualGatewaySpecListenerConnectionPool[];
    /**
     * health_check block.
     *
     * @stability stable
     */
    readonly healthCheck?: AppmeshVirtualGatewaySpecListenerHealthCheck[];
    /**
     * port_mapping block.
     *
     * @stability stable
     */
    readonly portMapping: AppmeshVirtualGatewaySpecListenerPortMapping[];
    /**
     * tls block.
     *
     * @stability stable
     */
    readonly tls?: AppmeshVirtualGatewaySpecListenerTls[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecLoggingAccessLogFile {
    /**
     * @stability stable
     */
    readonly path: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecLoggingAccessLog {
    /**
     * file block.
     *
     * @stability stable
     */
    readonly file?: AppmeshVirtualGatewaySpecLoggingAccessLogFile[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpecLogging {
    /**
     * access_log block.
     *
     * @stability stable
     */
    readonly accessLog?: AppmeshVirtualGatewaySpecLoggingAccessLog[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualGatewaySpec {
    /**
     * backend_defaults block.
     *
     * @stability stable
     */
    readonly backendDefaults?: AppmeshVirtualGatewaySpecBackendDefaults[];
    /**
     * listener block.
     *
     * @stability stable
     */
    readonly listener: AppmeshVirtualGatewaySpecListener[];
    /**
     * logging block.
     *
     * @stability stable
     */
    readonly logging?: AppmeshVirtualGatewaySpecLogging[];
}
/**
 * @stability stable
 */
export declare class AppmeshVirtualGateway extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppmeshVirtualGatewayConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdDate(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _meshName;
    /**
     * @stability stable
     */
    get meshName(): string;
    /**
     * @stability stable
     */
    set meshName(value: string);
    /**
     * @stability stable
     */
    get meshNameInput(): string;
    private _meshOwner?;
    /**
     * @stability stable
     */
    get meshOwner(): string;
    /**
     * @stability stable
     */
    set meshOwner(value: string);
    /**
     * @stability stable
     */
    resetMeshOwner(): void;
    /**
     * @stability stable
     */
    get meshOwnerInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get resourceOwner(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _spec;
    /**
     * @stability stable
     */
    get spec(): AppmeshVirtualGatewaySpec[];
    /**
     * @stability stable
     */
    set spec(value: AppmeshVirtualGatewaySpec[]);
    /**
     * @stability stable
     */
    get specInput(): AppmeshVirtualGatewaySpec[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
