import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppmeshVirtualRouterConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly meshName: string;
    /**
     * @stability stable
     */
    readonly meshOwner?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * spec block.
     *
     * @stability stable
     */
    readonly spec: AppmeshVirtualRouterSpec[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualRouterSpecListenerPortMapping {
    /**
     * @stability stable
     */
    readonly port: number;
    /**
     * @stability stable
     */
    readonly protocol: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualRouterSpecListener {
    /**
     * port_mapping block.
     *
     * @stability stable
     */
    readonly portMapping: AppmeshVirtualRouterSpecListenerPortMapping[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualRouterSpec {
    /**
     * listener block.
     *
     * @stability stable
     */
    readonly listener: AppmeshVirtualRouterSpecListener[];
}
/**
 * @stability stable
 */
export declare class AppmeshVirtualRouter extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppmeshVirtualRouterConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdDate(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _meshName;
    /**
     * @stability stable
     */
    get meshName(): string;
    /**
     * @stability stable
     */
    set meshName(value: string);
    /**
     * @stability stable
     */
    get meshNameInput(): string;
    private _meshOwner?;
    /**
     * @stability stable
     */
    get meshOwner(): string;
    /**
     * @stability stable
     */
    set meshOwner(value: string);
    /**
     * @stability stable
     */
    resetMeshOwner(): void;
    /**
     * @stability stable
     */
    get meshOwnerInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get resourceOwner(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _spec;
    /**
     * @stability stable
     */
    get spec(): AppmeshVirtualRouterSpec[];
    /**
     * @stability stable
     */
    set spec(value: AppmeshVirtualRouterSpec[]);
    /**
     * @stability stable
     */
    get specInput(): AppmeshVirtualRouterSpec[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
