import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppmeshVirtualServiceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly meshName: string;
    /**
     * @stability stable
     */
    readonly meshOwner?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * spec block.
     *
     * @stability stable
     */
    readonly spec: AppmeshVirtualServiceSpec[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualServiceSpecProviderVirtualNode {
    /**
     * @stability stable
     */
    readonly virtualNodeName: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualServiceSpecProviderVirtualRouter {
    /**
     * @stability stable
     */
    readonly virtualRouterName: string;
}
/**
 * @stability stable
 */
export interface AppmeshVirtualServiceSpecProvider {
    /**
     * virtual_node block.
     *
     * @stability stable
     */
    readonly virtualNode?: AppmeshVirtualServiceSpecProviderVirtualNode[];
    /**
     * virtual_router block.
     *
     * @stability stable
     */
    readonly virtualRouter?: AppmeshVirtualServiceSpecProviderVirtualRouter[];
}
/**
 * @stability stable
 */
export interface AppmeshVirtualServiceSpec {
    /**
     * provider block.
     *
     * @stability stable
     */
    readonly provider?: AppmeshVirtualServiceSpecProvider[];
}
/**
 * @stability stable
 */
export declare class AppmeshVirtualService extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppmeshVirtualServiceConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createdDate(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _meshName;
    /**
     * @stability stable
     */
    get meshName(): string;
    /**
     * @stability stable
     */
    set meshName(value: string);
    /**
     * @stability stable
     */
    get meshNameInput(): string;
    private _meshOwner?;
    /**
     * @stability stable
     */
    get meshOwner(): string;
    /**
     * @stability stable
     */
    set meshOwner(value: string);
    /**
     * @stability stable
     */
    resetMeshOwner(): void;
    /**
     * @stability stable
     */
    get meshOwnerInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get resourceOwner(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _spec;
    /**
     * @stability stable
     */
    get spec(): AppmeshVirtualServiceSpec[];
    /**
     * @stability stable
     */
    set spec(value: AppmeshVirtualServiceSpec[]);
    /**
     * @stability stable
     */
    get specInput(): AppmeshVirtualServiceSpec[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
