import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppsyncDatasourceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly apiId: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly serviceRoleArn?: string;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * dynamodb_config block.
     *
     * @stability stable
     */
    readonly dynamodbConfig?: AppsyncDatasourceDynamodbConfig[];
    /**
     * elasticsearch_config block.
     *
     * @stability stable
     */
    readonly elasticsearchConfig?: AppsyncDatasourceElasticsearchConfig[];
    /**
     * http_config block.
     *
     * @stability stable
     */
    readonly httpConfig?: AppsyncDatasourceHttpConfig[];
    /**
     * lambda_config block.
     *
     * @stability stable
     */
    readonly lambdaConfig?: AppsyncDatasourceLambdaConfig[];
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceDynamodbConfig {
    /**
     * @stability stable
     */
    readonly region?: string;
    /**
     * @stability stable
     */
    readonly tableName: string;
    /**
     * @stability stable
     */
    readonly useCallerCredentials?: boolean;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceElasticsearchConfig {
    /**
     * @stability stable
     */
    readonly endpoint: string;
    /**
     * @stability stable
     */
    readonly region?: string;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceHttpConfig {
    /**
     * @stability stable
     */
    readonly endpoint: string;
}
/**
 * @stability stable
 */
export interface AppsyncDatasourceLambdaConfig {
    /**
     * @stability stable
     */
    readonly functionArn: string;
}
/**
 * @stability stable
 */
export declare class AppsyncDatasource extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppsyncDatasourceConfig);
    private _apiId;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _serviceRoleArn?;
    /**
     * @stability stable
     */
    get serviceRoleArn(): string;
    /**
     * @stability stable
     */
    set serviceRoleArn(value: string);
    /**
     * @stability stable
     */
    resetServiceRoleArn(): void;
    /**
     * @stability stable
     */
    get serviceRoleArnInput(): string | undefined;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    private _dynamodbConfig?;
    /**
     * @stability stable
     */
    get dynamodbConfig(): AppsyncDatasourceDynamodbConfig[];
    /**
     * @stability stable
     */
    set dynamodbConfig(value: AppsyncDatasourceDynamodbConfig[]);
    /**
     * @stability stable
     */
    resetDynamodbConfig(): void;
    /**
     * @stability stable
     */
    get dynamodbConfigInput(): AppsyncDatasourceDynamodbConfig[] | undefined;
    private _elasticsearchConfig?;
    /**
     * @stability stable
     */
    get elasticsearchConfig(): AppsyncDatasourceElasticsearchConfig[];
    /**
     * @stability stable
     */
    set elasticsearchConfig(value: AppsyncDatasourceElasticsearchConfig[]);
    /**
     * @stability stable
     */
    resetElasticsearchConfig(): void;
    /**
     * @stability stable
     */
    get elasticsearchConfigInput(): AppsyncDatasourceElasticsearchConfig[] | undefined;
    private _httpConfig?;
    /**
     * @stability stable
     */
    get httpConfig(): AppsyncDatasourceHttpConfig[];
    /**
     * @stability stable
     */
    set httpConfig(value: AppsyncDatasourceHttpConfig[]);
    /**
     * @stability stable
     */
    resetHttpConfig(): void;
    /**
     * @stability stable
     */
    get httpConfigInput(): AppsyncDatasourceHttpConfig[] | undefined;
    private _lambdaConfig?;
    /**
     * @stability stable
     */
    get lambdaConfig(): AppsyncDatasourceLambdaConfig[];
    /**
     * @stability stable
     */
    set lambdaConfig(value: AppsyncDatasourceLambdaConfig[]);
    /**
     * @stability stable
     */
    resetLambdaConfig(): void;
    /**
     * @stability stable
     */
    get lambdaConfigInput(): AppsyncDatasourceLambdaConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
