import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppsyncFunctionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly apiId: string;
    /**
     * @stability stable
     */
    readonly dataSource: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly functionVersion?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly requestMappingTemplate: string;
    /**
     * @stability stable
     */
    readonly responseMappingTemplate: string;
}
/**
 * @stability stable
 */
export declare class AppsyncFunction extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppsyncFunctionConfig);
    private _apiId;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _dataSource;
    /**
     * @stability stable
     */
    get dataSource(): string;
    /**
     * @stability stable
     */
    set dataSource(value: string);
    /**
     * @stability stable
     */
    get dataSourceInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get functionId(): string;
    private _functionVersion?;
    /**
     * @stability stable
     */
    get functionVersion(): string;
    /**
     * @stability stable
     */
    set functionVersion(value: string);
    /**
     * @stability stable
     */
    resetFunctionVersion(): void;
    /**
     * @stability stable
     */
    get functionVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _requestMappingTemplate;
    /**
     * @stability stable
     */
    get requestMappingTemplate(): string;
    /**
     * @stability stable
     */
    set requestMappingTemplate(value: string);
    /**
     * @stability stable
     */
    get requestMappingTemplateInput(): string;
    private _responseMappingTemplate;
    /**
     * @stability stable
     */
    get responseMappingTemplate(): string;
    /**
     * @stability stable
     */
    set responseMappingTemplate(value: string);
    /**
     * @stability stable
     */
    get responseMappingTemplateInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
