import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AppsyncResolverConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly apiId: string;
    /**
     * @stability stable
     */
    readonly dataSource?: string;
    /**
     * @stability stable
     */
    readonly field: string;
    /**
     * @stability stable
     */
    readonly kind?: string;
    /**
     * @stability stable
     */
    readonly requestTemplate: string;
    /**
     * @stability stable
     */
    readonly responseTemplate: string;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * caching_config block.
     *
     * @stability stable
     */
    readonly cachingConfig?: AppsyncResolverCachingConfig[];
    /**
     * pipeline_config block.
     *
     * @stability stable
     */
    readonly pipelineConfig?: AppsyncResolverPipelineConfig[];
}
/**
 * @stability stable
 */
export interface AppsyncResolverCachingConfig {
    /**
     * @stability stable
     */
    readonly cachingKeys?: string[];
    /**
     * @stability stable
     */
    readonly ttl?: number;
}
/**
 * @stability stable
 */
export interface AppsyncResolverPipelineConfig {
    /**
     * @stability stable
     */
    readonly functions?: string[];
}
/**
 * @stability stable
 */
export declare class AppsyncResolver extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AppsyncResolverConfig);
    private _apiId;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _dataSource?;
    /**
     * @stability stable
     */
    get dataSource(): string;
    /**
     * @stability stable
     */
    set dataSource(value: string);
    /**
     * @stability stable
     */
    resetDataSource(): void;
    /**
     * @stability stable
     */
    get dataSourceInput(): string | undefined;
    private _field;
    /**
     * @stability stable
     */
    get field(): string;
    /**
     * @stability stable
     */
    set field(value: string);
    /**
     * @stability stable
     */
    get fieldInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _kind?;
    /**
     * @stability stable
     */
    get kind(): string;
    /**
     * @stability stable
     */
    set kind(value: string);
    /**
     * @stability stable
     */
    resetKind(): void;
    /**
     * @stability stable
     */
    get kindInput(): string | undefined;
    private _requestTemplate;
    /**
     * @stability stable
     */
    get requestTemplate(): string;
    /**
     * @stability stable
     */
    set requestTemplate(value: string);
    /**
     * @stability stable
     */
    get requestTemplateInput(): string;
    private _responseTemplate;
    /**
     * @stability stable
     */
    get responseTemplate(): string;
    /**
     * @stability stable
     */
    set responseTemplate(value: string);
    /**
     * @stability stable
     */
    get responseTemplateInput(): string;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    private _cachingConfig?;
    /**
     * @stability stable
     */
    get cachingConfig(): AppsyncResolverCachingConfig[];
    /**
     * @stability stable
     */
    set cachingConfig(value: AppsyncResolverCachingConfig[]);
    /**
     * @stability stable
     */
    resetCachingConfig(): void;
    /**
     * @stability stable
     */
    get cachingConfigInput(): AppsyncResolverCachingConfig[] | undefined;
    private _pipelineConfig?;
    /**
     * @stability stable
     */
    get pipelineConfig(): AppsyncResolverPipelineConfig[];
    /**
     * @stability stable
     */
    set pipelineConfig(value: AppsyncResolverPipelineConfig[]);
    /**
     * @stability stable
     */
    resetPipelineConfig(): void;
    /**
     * @stability stable
     */
    get pipelineConfigInput(): AppsyncResolverPipelineConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
