import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AthenaWorkgroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly forceDestroy?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly state?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * configuration block.
     *
     * @stability stable
     */
    readonly configuration?: AthenaWorkgroupConfiguration[];
}
/**
 * @stability stable
 */
export interface AthenaWorkgroupConfigurationResultConfigurationEncryptionConfiguration {
    /**
     * @stability stable
     */
    readonly encryptionOption?: string;
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
}
/**
 * @stability stable
 */
export interface AthenaWorkgroupConfigurationResultConfiguration {
    /**
     * @stability stable
     */
    readonly outputLocation?: string;
    /**
     * encryption_configuration block.
     *
     * @stability stable
     */
    readonly encryptionConfiguration?: AthenaWorkgroupConfigurationResultConfigurationEncryptionConfiguration[];
}
/**
 * @stability stable
 */
export interface AthenaWorkgroupConfiguration {
    /**
     * @stability stable
     */
    readonly bytesScannedCutoffPerQuery?: number;
    /**
     * @stability stable
     */
    readonly enforceWorkgroupConfiguration?: boolean;
    /**
     * @stability stable
     */
    readonly publishCloudwatchMetricsEnabled?: boolean;
    /**
     * result_configuration block.
     *
     * @stability stable
     */
    readonly resultConfiguration?: AthenaWorkgroupConfigurationResultConfiguration[];
}
/**
 * @stability stable
 */
export declare class AthenaWorkgroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AthenaWorkgroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _forceDestroy?;
    /**
     * @stability stable
     */
    get forceDestroy(): boolean;
    /**
     * @stability stable
     */
    set forceDestroy(value: boolean);
    /**
     * @stability stable
     */
    resetForceDestroy(): void;
    /**
     * @stability stable
     */
    get forceDestroyInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _state?;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    set state(value: string);
    /**
     * @stability stable
     */
    resetState(): void;
    /**
     * @stability stable
     */
    get stateInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _configuration?;
    /**
     * @stability stable
     */
    get configuration(): AthenaWorkgroupConfiguration[];
    /**
     * @stability stable
     */
    set configuration(value: AthenaWorkgroupConfiguration[]);
    /**
     * @stability stable
     */
    resetConfiguration(): void;
    /**
     * @stability stable
     */
    get configurationInput(): AthenaWorkgroupConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
