import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AutoscalingAttachmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly albTargetGroupArn?: string;
    /**
     * @stability stable
     */
    readonly autoscalingGroupName: string;
    /**
     * @stability stable
     */
    readonly elb?: string;
}
/**
 * @stability stable
 */
export declare class AutoscalingAttachment extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AutoscalingAttachmentConfig);
    private _albTargetGroupArn?;
    /**
     * @stability stable
     */
    get albTargetGroupArn(): string;
    /**
     * @stability stable
     */
    set albTargetGroupArn(value: string);
    /**
     * @stability stable
     */
    resetAlbTargetGroupArn(): void;
    /**
     * @stability stable
     */
    get albTargetGroupArnInput(): string | undefined;
    private _autoscalingGroupName;
    /**
     * @stability stable
     */
    get autoscalingGroupName(): string;
    /**
     * @stability stable
     */
    set autoscalingGroupName(value: string);
    /**
     * @stability stable
     */
    get autoscalingGroupNameInput(): string;
    private _elb?;
    /**
     * @stability stable
     */
    get elb(): string;
    /**
     * @stability stable
     */
    set elb(value: string);
    /**
     * @stability stable
     */
    resetElb(): void;
    /**
     * @stability stable
     */
    get elbInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
