import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AutoscalingGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly availabilityZones?: string[];
    /**
     * @stability stable
     */
    readonly capacityRebalance?: boolean;
    /**
     * @stability stable
     */
    readonly defaultCooldown?: number;
    /**
     * @stability stable
     */
    readonly desiredCapacity?: number;
    /**
     * @stability stable
     */
    readonly enabledMetrics?: string[];
    /**
     * @stability stable
     */
    readonly forceDelete?: boolean;
    /**
     * @stability stable
     */
    readonly healthCheckGracePeriod?: number;
    /**
     * @stability stable
     */
    readonly healthCheckType?: string;
    /**
     * @stability stable
     */
    readonly launchConfiguration?: string;
    /**
     * @stability stable
     */
    readonly loadBalancers?: string[];
    /**
     * @stability stable
     */
    readonly maxInstanceLifetime?: number;
    /**
     * @stability stable
     */
    readonly maxSize: number;
    /**
     * @stability stable
     */
    readonly metricsGranularity?: string;
    /**
     * @stability stable
     */
    readonly minElbCapacity?: number;
    /**
     * @stability stable
     */
    readonly minSize: number;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly placementGroup?: string;
    /**
     * @stability stable
     */
    readonly protectFromScaleIn?: boolean;
    /**
     * @stability stable
     */
    readonly serviceLinkedRoleArn?: string;
    /**
     * @stability stable
     */
    readonly suspendedProcesses?: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly targetGroupArns?: string[];
    /**
     * @stability stable
     */
    readonly terminationPolicies?: string[];
    /**
     * @stability stable
     */
    readonly vpcZoneIdentifier?: string[];
    /**
     * @stability stable
     */
    readonly waitForCapacityTimeout?: string;
    /**
     * @stability stable
     */
    readonly waitForElbCapacity?: number;
    /**
     * initial_lifecycle_hook block.
     *
     * @stability stable
     */
    readonly initialLifecycleHook?: AutoscalingGroupInitialLifecycleHook[];
    /**
     * instance_refresh block.
     *
     * @stability stable
     */
    readonly instanceRefresh?: AutoscalingGroupInstanceRefresh[];
    /**
     * launch_template block.
     *
     * @stability stable
     */
    readonly launchTemplate?: AutoscalingGroupLaunchTemplate[];
    /**
     * mixed_instances_policy block.
     *
     * @stability stable
     */
    readonly mixedInstancesPolicy?: AutoscalingGroupMixedInstancesPolicy[];
    /**
     * tag block.
     *
     * @stability stable
     */
    readonly tag?: AutoscalingGroupTag[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: AutoscalingGroupTimeouts;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupInitialLifecycleHook {
    /**
     * @stability stable
     */
    readonly defaultResult?: string;
    /**
     * @stability stable
     */
    readonly heartbeatTimeout?: number;
    /**
     * @stability stable
     */
    readonly lifecycleTransition: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly notificationMetadata?: string;
    /**
     * @stability stable
     */
    readonly notificationTargetArn?: string;
    /**
     * @stability stable
     */
    readonly roleArn?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupInstanceRefreshPreferences {
    /**
     * @stability stable
     */
    readonly instanceWarmup?: string;
    /**
     * @stability stable
     */
    readonly minHealthyPercentage?: number;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupInstanceRefresh {
    /**
     * @stability stable
     */
    readonly strategy: string;
    /**
     * @stability stable
     */
    readonly triggers?: string[];
    /**
     * preferences block.
     *
     * @stability stable
     */
    readonly preferences?: AutoscalingGroupInstanceRefreshPreferences[];
}
/**
 * @stability stable
 */
export interface AutoscalingGroupLaunchTemplate {
    /**
     * @stability stable
     */
    readonly id?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly version?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicyInstancesDistribution {
    /**
     * @stability stable
     */
    readonly onDemandAllocationStrategy?: string;
    /**
     * @stability stable
     */
    readonly onDemandBaseCapacity?: number;
    /**
     * @stability stable
     */
    readonly onDemandPercentageAboveBaseCapacity?: number;
    /**
     * @stability stable
     */
    readonly spotAllocationStrategy?: string;
    /**
     * @stability stable
     */
    readonly spotInstancePools?: number;
    /**
     * @stability stable
     */
    readonly spotMaxPrice?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecification {
    /**
     * @stability stable
     */
    readonly launchTemplateId?: string;
    /**
     * @stability stable
     */
    readonly launchTemplateName?: string;
    /**
     * @stability stable
     */
    readonly version?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverrideLaunchTemplateSpecification {
    /**
     * @stability stable
     */
    readonly launchTemplateId?: string;
    /**
     * @stability stable
     */
    readonly launchTemplateName?: string;
    /**
     * @stability stable
     */
    readonly version?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverride {
    /**
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * @stability stable
     */
    readonly weightedCapacity?: string;
    /**
     * launch_template_specification block.
     *
     * @stability stable
     */
    readonly launchTemplateSpecification?: AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverrideLaunchTemplateSpecification[];
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicyLaunchTemplate {
    /**
     * launch_template_specification block.
     *
     * @stability stable
     */
    readonly launchTemplateSpecification: AutoscalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecification[];
    /**
     * override block.
     *
     * @stability stable
     */
    readonly override?: AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverride[];
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicy {
    /**
     * instances_distribution block.
     *
     * @stability stable
     */
    readonly instancesDistribution?: AutoscalingGroupMixedInstancesPolicyInstancesDistribution[];
    /**
     * launch_template block.
     *
     * @stability stable
     */
    readonly launchTemplate: AutoscalingGroupMixedInstancesPolicyLaunchTemplate[];
}
/**
 * @stability stable
 */
export interface AutoscalingGroupTag {
    /**
     * @stability stable
     */
    readonly key: string;
    /**
     * @stability stable
     */
    readonly propagateAtLaunch: boolean;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupTimeouts {
    /**
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export declare class AutoscalingGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AutoscalingGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _availabilityZones?;
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    /**
     * @stability stable
     */
    set availabilityZones(value: string[]);
    /**
     * @stability stable
     */
    resetAvailabilityZones(): void;
    /**
     * @stability stable
     */
    get availabilityZonesInput(): string[] | undefined;
    private _capacityRebalance?;
    /**
     * @stability stable
     */
    get capacityRebalance(): boolean;
    /**
     * @stability stable
     */
    set capacityRebalance(value: boolean);
    /**
     * @stability stable
     */
    resetCapacityRebalance(): void;
    /**
     * @stability stable
     */
    get capacityRebalanceInput(): boolean | undefined;
    private _defaultCooldown?;
    /**
     * @stability stable
     */
    get defaultCooldown(): number;
    /**
     * @stability stable
     */
    set defaultCooldown(value: number);
    /**
     * @stability stable
     */
    resetDefaultCooldown(): void;
    /**
     * @stability stable
     */
    get defaultCooldownInput(): number | undefined;
    private _desiredCapacity?;
    /**
     * @stability stable
     */
    get desiredCapacity(): number;
    /**
     * @stability stable
     */
    set desiredCapacity(value: number);
    /**
     * @stability stable
     */
    resetDesiredCapacity(): void;
    /**
     * @stability stable
     */
    get desiredCapacityInput(): number | undefined;
    private _enabledMetrics?;
    /**
     * @stability stable
     */
    get enabledMetrics(): string[];
    /**
     * @stability stable
     */
    set enabledMetrics(value: string[]);
    /**
     * @stability stable
     */
    resetEnabledMetrics(): void;
    /**
     * @stability stable
     */
    get enabledMetricsInput(): string[] | undefined;
    private _forceDelete?;
    /**
     * @stability stable
     */
    get forceDelete(): boolean;
    /**
     * @stability stable
     */
    set forceDelete(value: boolean);
    /**
     * @stability stable
     */
    resetForceDelete(): void;
    /**
     * @stability stable
     */
    get forceDeleteInput(): boolean | undefined;
    private _healthCheckGracePeriod?;
    /**
     * @stability stable
     */
    get healthCheckGracePeriod(): number;
    /**
     * @stability stable
     */
    set healthCheckGracePeriod(value: number);
    /**
     * @stability stable
     */
    resetHealthCheckGracePeriod(): void;
    /**
     * @stability stable
     */
    get healthCheckGracePeriodInput(): number | undefined;
    private _healthCheckType?;
    /**
     * @stability stable
     */
    get healthCheckType(): string;
    /**
     * @stability stable
     */
    set healthCheckType(value: string);
    /**
     * @stability stable
     */
    resetHealthCheckType(): void;
    /**
     * @stability stable
     */
    get healthCheckTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _launchConfiguration?;
    /**
     * @stability stable
     */
    get launchConfiguration(): string;
    /**
     * @stability stable
     */
    set launchConfiguration(value: string);
    /**
     * @stability stable
     */
    resetLaunchConfiguration(): void;
    /**
     * @stability stable
     */
    get launchConfigurationInput(): string | undefined;
    private _loadBalancers?;
    /**
     * @stability stable
     */
    get loadBalancers(): string[];
    /**
     * @stability stable
     */
    set loadBalancers(value: string[]);
    /**
     * @stability stable
     */
    resetLoadBalancers(): void;
    /**
     * @stability stable
     */
    get loadBalancersInput(): string[] | undefined;
    private _maxInstanceLifetime?;
    /**
     * @stability stable
     */
    get maxInstanceLifetime(): number;
    /**
     * @stability stable
     */
    set maxInstanceLifetime(value: number);
    /**
     * @stability stable
     */
    resetMaxInstanceLifetime(): void;
    /**
     * @stability stable
     */
    get maxInstanceLifetimeInput(): number | undefined;
    private _maxSize;
    /**
     * @stability stable
     */
    get maxSize(): number;
    /**
     * @stability stable
     */
    set maxSize(value: number);
    /**
     * @stability stable
     */
    get maxSizeInput(): number;
    private _metricsGranularity?;
    /**
     * @stability stable
     */
    get metricsGranularity(): string;
    /**
     * @stability stable
     */
    set metricsGranularity(value: string);
    /**
     * @stability stable
     */
    resetMetricsGranularity(): void;
    /**
     * @stability stable
     */
    get metricsGranularityInput(): string | undefined;
    private _minElbCapacity?;
    /**
     * @stability stable
     */
    get minElbCapacity(): number;
    /**
     * @stability stable
     */
    set minElbCapacity(value: number);
    /**
     * @stability stable
     */
    resetMinElbCapacity(): void;
    /**
     * @stability stable
     */
    get minElbCapacityInput(): number | undefined;
    private _minSize;
    /**
     * @stability stable
     */
    get minSize(): number;
    /**
     * @stability stable
     */
    set minSize(value: number);
    /**
     * @stability stable
     */
    get minSizeInput(): number;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _placementGroup?;
    /**
     * @stability stable
     */
    get placementGroup(): string;
    /**
     * @stability stable
     */
    set placementGroup(value: string);
    /**
     * @stability stable
     */
    resetPlacementGroup(): void;
    /**
     * @stability stable
     */
    get placementGroupInput(): string | undefined;
    private _protectFromScaleIn?;
    /**
     * @stability stable
     */
    get protectFromScaleIn(): boolean;
    /**
     * @stability stable
     */
    set protectFromScaleIn(value: boolean);
    /**
     * @stability stable
     */
    resetProtectFromScaleIn(): void;
    /**
     * @stability stable
     */
    get protectFromScaleInInput(): boolean | undefined;
    private _serviceLinkedRoleArn?;
    /**
     * @stability stable
     */
    get serviceLinkedRoleArn(): string;
    /**
     * @stability stable
     */
    set serviceLinkedRoleArn(value: string);
    /**
     * @stability stable
     */
    resetServiceLinkedRoleArn(): void;
    /**
     * @stability stable
     */
    get serviceLinkedRoleArnInput(): string | undefined;
    private _suspendedProcesses?;
    /**
     * @stability stable
     */
    get suspendedProcesses(): string[];
    /**
     * @stability stable
     */
    set suspendedProcesses(value: string[]);
    /**
     * @stability stable
     */
    resetSuspendedProcesses(): void;
    /**
     * @stability stable
     */
    get suspendedProcessesInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _targetGroupArns?;
    /**
     * @stability stable
     */
    get targetGroupArns(): string[];
    /**
     * @stability stable
     */
    set targetGroupArns(value: string[]);
    /**
     * @stability stable
     */
    resetTargetGroupArns(): void;
    /**
     * @stability stable
     */
    get targetGroupArnsInput(): string[] | undefined;
    private _terminationPolicies?;
    /**
     * @stability stable
     */
    get terminationPolicies(): string[];
    /**
     * @stability stable
     */
    set terminationPolicies(value: string[]);
    /**
     * @stability stable
     */
    resetTerminationPolicies(): void;
    /**
     * @stability stable
     */
    get terminationPoliciesInput(): string[] | undefined;
    private _vpcZoneIdentifier?;
    /**
     * @stability stable
     */
    get vpcZoneIdentifier(): string[];
    /**
     * @stability stable
     */
    set vpcZoneIdentifier(value: string[]);
    /**
     * @stability stable
     */
    resetVpcZoneIdentifier(): void;
    /**
     * @stability stable
     */
    get vpcZoneIdentifierInput(): string[] | undefined;
    private _waitForCapacityTimeout?;
    /**
     * @stability stable
     */
    get waitForCapacityTimeout(): string;
    /**
     * @stability stable
     */
    set waitForCapacityTimeout(value: string);
    /**
     * @stability stable
     */
    resetWaitForCapacityTimeout(): void;
    /**
     * @stability stable
     */
    get waitForCapacityTimeoutInput(): string | undefined;
    private _waitForElbCapacity?;
    /**
     * @stability stable
     */
    get waitForElbCapacity(): number;
    /**
     * @stability stable
     */
    set waitForElbCapacity(value: number);
    /**
     * @stability stable
     */
    resetWaitForElbCapacity(): void;
    /**
     * @stability stable
     */
    get waitForElbCapacityInput(): number | undefined;
    private _initialLifecycleHook?;
    /**
     * @stability stable
     */
    get initialLifecycleHook(): AutoscalingGroupInitialLifecycleHook[];
    /**
     * @stability stable
     */
    set initialLifecycleHook(value: AutoscalingGroupInitialLifecycleHook[]);
    /**
     * @stability stable
     */
    resetInitialLifecycleHook(): void;
    /**
     * @stability stable
     */
    get initialLifecycleHookInput(): AutoscalingGroupInitialLifecycleHook[] | undefined;
    private _instanceRefresh?;
    /**
     * @stability stable
     */
    get instanceRefresh(): AutoscalingGroupInstanceRefresh[];
    /**
     * @stability stable
     */
    set instanceRefresh(value: AutoscalingGroupInstanceRefresh[]);
    /**
     * @stability stable
     */
    resetInstanceRefresh(): void;
    /**
     * @stability stable
     */
    get instanceRefreshInput(): AutoscalingGroupInstanceRefresh[] | undefined;
    private _launchTemplate?;
    /**
     * @stability stable
     */
    get launchTemplate(): AutoscalingGroupLaunchTemplate[];
    /**
     * @stability stable
     */
    set launchTemplate(value: AutoscalingGroupLaunchTemplate[]);
    /**
     * @stability stable
     */
    resetLaunchTemplate(): void;
    /**
     * @stability stable
     */
    get launchTemplateInput(): AutoscalingGroupLaunchTemplate[] | undefined;
    private _mixedInstancesPolicy?;
    /**
     * @stability stable
     */
    get mixedInstancesPolicy(): AutoscalingGroupMixedInstancesPolicy[];
    /**
     * @stability stable
     */
    set mixedInstancesPolicy(value: AutoscalingGroupMixedInstancesPolicy[]);
    /**
     * @stability stable
     */
    resetMixedInstancesPolicy(): void;
    /**
     * @stability stable
     */
    get mixedInstancesPolicyInput(): AutoscalingGroupMixedInstancesPolicy[] | undefined;
    private _tag?;
    /**
     * @stability stable
     */
    get tag(): AutoscalingGroupTag[];
    /**
     * @stability stable
     */
    set tag(value: AutoscalingGroupTag[]);
    /**
     * @stability stable
     */
    resetTag(): void;
    /**
     * @stability stable
     */
    get tagInput(): AutoscalingGroupTag[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): AutoscalingGroupTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: AutoscalingGroupTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): AutoscalingGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
