import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AutoscalingLifecycleHookConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly autoscalingGroupName: string;
    /**
     * @stability stable
     */
    readonly defaultResult?: string;
    /**
     * @stability stable
     */
    readonly heartbeatTimeout?: number;
    /**
     * @stability stable
     */
    readonly lifecycleTransition: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly notificationMetadata?: string;
    /**
     * @stability stable
     */
    readonly notificationTargetArn?: string;
    /**
     * @stability stable
     */
    readonly roleArn?: string;
}
/**
 * @stability stable
 */
export declare class AutoscalingLifecycleHook extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AutoscalingLifecycleHookConfig);
    private _autoscalingGroupName;
    /**
     * @stability stable
     */
    get autoscalingGroupName(): string;
    /**
     * @stability stable
     */
    set autoscalingGroupName(value: string);
    /**
     * @stability stable
     */
    get autoscalingGroupNameInput(): string;
    private _defaultResult?;
    /**
     * @stability stable
     */
    get defaultResult(): string;
    /**
     * @stability stable
     */
    set defaultResult(value: string);
    /**
     * @stability stable
     */
    resetDefaultResult(): void;
    /**
     * @stability stable
     */
    get defaultResultInput(): string | undefined;
    private _heartbeatTimeout?;
    /**
     * @stability stable
     */
    get heartbeatTimeout(): number;
    /**
     * @stability stable
     */
    set heartbeatTimeout(value: number);
    /**
     * @stability stable
     */
    resetHeartbeatTimeout(): void;
    /**
     * @stability stable
     */
    get heartbeatTimeoutInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _lifecycleTransition;
    /**
     * @stability stable
     */
    get lifecycleTransition(): string;
    /**
     * @stability stable
     */
    set lifecycleTransition(value: string);
    /**
     * @stability stable
     */
    get lifecycleTransitionInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _notificationMetadata?;
    /**
     * @stability stable
     */
    get notificationMetadata(): string;
    /**
     * @stability stable
     */
    set notificationMetadata(value: string);
    /**
     * @stability stable
     */
    resetNotificationMetadata(): void;
    /**
     * @stability stable
     */
    get notificationMetadataInput(): string | undefined;
    private _notificationTargetArn?;
    /**
     * @stability stable
     */
    get notificationTargetArn(): string;
    /**
     * @stability stable
     */
    set notificationTargetArn(value: string);
    /**
     * @stability stable
     */
    resetNotificationTargetArn(): void;
    /**
     * @stability stable
     */
    get notificationTargetArnInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    resetRoleArn(): void;
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
