import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AutoscalingNotificationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly groupNames: string[];
    /**
     * @stability stable
     */
    readonly notifications: string[];
    /**
     * @stability stable
     */
    readonly topicArn: string;
}
/**
 * @stability stable
 */
export declare class AutoscalingNotification extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AutoscalingNotificationConfig);
    private _groupNames;
    /**
     * @stability stable
     */
    get groupNames(): string[];
    /**
     * @stability stable
     */
    set groupNames(value: string[]);
    /**
     * @stability stable
     */
    get groupNamesInput(): string[];
    /**
     * @stability stable
     */
    get id(): string;
    private _notifications;
    /**
     * @stability stable
     */
    get notifications(): string[];
    /**
     * @stability stable
     */
    set notifications(value: string[]);
    /**
     * @stability stable
     */
    get notificationsInput(): string[];
    private _topicArn;
    /**
     * @stability stable
     */
    get topicArn(): string;
    /**
     * @stability stable
     */
    set topicArn(value: string);
    /**
     * @stability stable
     */
    get topicArnInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
