import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AutoscalingPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly adjustmentType?: string;
    /**
     * @stability stable
     */
    readonly autoscalingGroupName: string;
    /**
     * @stability stable
     */
    readonly cooldown?: number;
    /**
     * @stability stable
     */
    readonly estimatedInstanceWarmup?: number;
    /**
     * @stability stable
     */
    readonly metricAggregationType?: string;
    /**
     * @stability stable
     */
    readonly minAdjustmentMagnitude?: number;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly policyType?: string;
    /**
     * @stability stable
     */
    readonly scalingAdjustment?: number;
    /**
     * step_adjustment block.
     *
     * @stability stable
     */
    readonly stepAdjustment?: AutoscalingPolicyStepAdjustment[];
    /**
     * target_tracking_configuration block.
     *
     * @stability stable
     */
    readonly targetTrackingConfiguration?: AutoscalingPolicyTargetTrackingConfiguration[];
}
/**
 * @stability stable
 */
export interface AutoscalingPolicyStepAdjustment {
    /**
     * @stability stable
     */
    readonly metricIntervalLowerBound?: string;
    /**
     * @stability stable
     */
    readonly metricIntervalUpperBound?: string;
    /**
     * @stability stable
     */
    readonly scalingAdjustment: number;
}
/**
 * @stability stable
 */
export interface AutoscalingPolicyTargetTrackingConfigurationCustomizedMetricSpecificationMetricDimension {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface AutoscalingPolicyTargetTrackingConfigurationCustomizedMetricSpecification {
    /**
     * @stability stable
     */
    readonly metricName: string;
    /**
     * @stability stable
     */
    readonly namespace: string;
    /**
     * @stability stable
     */
    readonly statistic: string;
    /**
     * @stability stable
     */
    readonly unit?: string;
    /**
     * metric_dimension block.
     *
     * @stability stable
     */
    readonly metricDimension?: AutoscalingPolicyTargetTrackingConfigurationCustomizedMetricSpecificationMetricDimension[];
}
/**
 * @stability stable
 */
export interface AutoscalingPolicyTargetTrackingConfigurationPredefinedMetricSpecification {
    /**
     * @stability stable
     */
    readonly predefinedMetricType: string;
    /**
     * @stability stable
     */
    readonly resourceLabel?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingPolicyTargetTrackingConfiguration {
    /**
     * @stability stable
     */
    readonly disableScaleIn?: boolean;
    /**
     * @stability stable
     */
    readonly targetValue: number;
    /**
     * customized_metric_specification block.
     *
     * @stability stable
     */
    readonly customizedMetricSpecification?: AutoscalingPolicyTargetTrackingConfigurationCustomizedMetricSpecification[];
    /**
     * predefined_metric_specification block.
     *
     * @stability stable
     */
    readonly predefinedMetricSpecification?: AutoscalingPolicyTargetTrackingConfigurationPredefinedMetricSpecification[];
}
/**
 * @stability stable
 */
export declare class AutoscalingPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AutoscalingPolicyConfig);
    private _adjustmentType?;
    /**
     * @stability stable
     */
    get adjustmentType(): string;
    /**
     * @stability stable
     */
    set adjustmentType(value: string);
    /**
     * @stability stable
     */
    resetAdjustmentType(): void;
    /**
     * @stability stable
     */
    get adjustmentTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoscalingGroupName;
    /**
     * @stability stable
     */
    get autoscalingGroupName(): string;
    /**
     * @stability stable
     */
    set autoscalingGroupName(value: string);
    /**
     * @stability stable
     */
    get autoscalingGroupNameInput(): string;
    private _cooldown?;
    /**
     * @stability stable
     */
    get cooldown(): number;
    /**
     * @stability stable
     */
    set cooldown(value: number);
    /**
     * @stability stable
     */
    resetCooldown(): void;
    /**
     * @stability stable
     */
    get cooldownInput(): number | undefined;
    private _estimatedInstanceWarmup?;
    /**
     * @stability stable
     */
    get estimatedInstanceWarmup(): number;
    /**
     * @stability stable
     */
    set estimatedInstanceWarmup(value: number);
    /**
     * @stability stable
     */
    resetEstimatedInstanceWarmup(): void;
    /**
     * @stability stable
     */
    get estimatedInstanceWarmupInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _metricAggregationType?;
    /**
     * @stability stable
     */
    get metricAggregationType(): string;
    /**
     * @stability stable
     */
    set metricAggregationType(value: string);
    /**
     * @stability stable
     */
    resetMetricAggregationType(): void;
    /**
     * @stability stable
     */
    get metricAggregationTypeInput(): string | undefined;
    private _minAdjustmentMagnitude?;
    /**
     * @stability stable
     */
    get minAdjustmentMagnitude(): number;
    /**
     * @stability stable
     */
    set minAdjustmentMagnitude(value: number);
    /**
     * @stability stable
     */
    resetMinAdjustmentMagnitude(): void;
    /**
     * @stability stable
     */
    get minAdjustmentMagnitudeInput(): number | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _policyType?;
    /**
     * @stability stable
     */
    get policyType(): string;
    /**
     * @stability stable
     */
    set policyType(value: string);
    /**
     * @stability stable
     */
    resetPolicyType(): void;
    /**
     * @stability stable
     */
    get policyTypeInput(): string | undefined;
    private _scalingAdjustment?;
    /**
     * @stability stable
     */
    get scalingAdjustment(): number;
    /**
     * @stability stable
     */
    set scalingAdjustment(value: number);
    /**
     * @stability stable
     */
    resetScalingAdjustment(): void;
    /**
     * @stability stable
     */
    get scalingAdjustmentInput(): number | undefined;
    private _stepAdjustment?;
    /**
     * @stability stable
     */
    get stepAdjustment(): AutoscalingPolicyStepAdjustment[];
    /**
     * @stability stable
     */
    set stepAdjustment(value: AutoscalingPolicyStepAdjustment[]);
    /**
     * @stability stable
     */
    resetStepAdjustment(): void;
    /**
     * @stability stable
     */
    get stepAdjustmentInput(): AutoscalingPolicyStepAdjustment[] | undefined;
    private _targetTrackingConfiguration?;
    /**
     * @stability stable
     */
    get targetTrackingConfiguration(): AutoscalingPolicyTargetTrackingConfiguration[];
    /**
     * @stability stable
     */
    set targetTrackingConfiguration(value: AutoscalingPolicyTargetTrackingConfiguration[]);
    /**
     * @stability stable
     */
    resetTargetTrackingConfiguration(): void;
    /**
     * @stability stable
     */
    get targetTrackingConfigurationInput(): AutoscalingPolicyTargetTrackingConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
