import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AutoscalingScheduleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly autoscalingGroupName: string;
    /**
     * @stability stable
     */
    readonly desiredCapacity?: number;
    /**
     * @stability stable
     */
    readonly endTime?: string;
    /**
     * @stability stable
     */
    readonly maxSize?: number;
    /**
     * @stability stable
     */
    readonly minSize?: number;
    /**
     * @stability stable
     */
    readonly recurrence?: string;
    /**
     * @stability stable
     */
    readonly scheduledActionName: string;
    /**
     * @stability stable
     */
    readonly startTime?: string;
}
/**
 * @stability stable
 */
export declare class AutoscalingSchedule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AutoscalingScheduleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoscalingGroupName;
    /**
     * @stability stable
     */
    get autoscalingGroupName(): string;
    /**
     * @stability stable
     */
    set autoscalingGroupName(value: string);
    /**
     * @stability stable
     */
    get autoscalingGroupNameInput(): string;
    private _desiredCapacity?;
    /**
     * @stability stable
     */
    get desiredCapacity(): number;
    /**
     * @stability stable
     */
    set desiredCapacity(value: number);
    /**
     * @stability stable
     */
    resetDesiredCapacity(): void;
    /**
     * @stability stable
     */
    get desiredCapacityInput(): number | undefined;
    private _endTime?;
    /**
     * @stability stable
     */
    get endTime(): string;
    /**
     * @stability stable
     */
    set endTime(value: string);
    /**
     * @stability stable
     */
    resetEndTime(): void;
    /**
     * @stability stable
     */
    get endTimeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _maxSize?;
    /**
     * @stability stable
     */
    get maxSize(): number;
    /**
     * @stability stable
     */
    set maxSize(value: number);
    /**
     * @stability stable
     */
    resetMaxSize(): void;
    /**
     * @stability stable
     */
    get maxSizeInput(): number | undefined;
    private _minSize?;
    /**
     * @stability stable
     */
    get minSize(): number;
    /**
     * @stability stable
     */
    set minSize(value: number);
    /**
     * @stability stable
     */
    resetMinSize(): void;
    /**
     * @stability stable
     */
    get minSizeInput(): number | undefined;
    private _recurrence?;
    /**
     * @stability stable
     */
    get recurrence(): string;
    /**
     * @stability stable
     */
    set recurrence(value: string);
    /**
     * @stability stable
     */
    resetRecurrence(): void;
    /**
     * @stability stable
     */
    get recurrenceInput(): string | undefined;
    private _scheduledActionName;
    /**
     * @stability stable
     */
    get scheduledActionName(): string;
    /**
     * @stability stable
     */
    set scheduledActionName(value: string);
    /**
     * @stability stable
     */
    get scheduledActionNameInput(): string;
    private _startTime?;
    /**
     * @stability stable
     */
    get startTime(): string;
    /**
     * @stability stable
     */
    set startTime(value: string);
    /**
     * @stability stable
     */
    resetStartTime(): void;
    /**
     * @stability stable
     */
    get startTimeInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
