import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AutoscalingplansScalingPlanConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * application_source block.
     *
     * @stability stable
     */
    readonly applicationSource: AutoscalingplansScalingPlanApplicationSource[];
    /**
     * scaling_instruction block.
     *
     * @stability stable
     */
    readonly scalingInstruction: AutoscalingplansScalingPlanScalingInstruction[];
}
/**
 * @stability stable
 */
export interface AutoscalingplansScalingPlanApplicationSourceTagFilter {
    /**
     * @stability stable
     */
    readonly key: string;
    /**
     * @stability stable
     */
    readonly values?: string[];
}
/**
 * @stability stable
 */
export interface AutoscalingplansScalingPlanApplicationSource {
    /**
     * @stability stable
     */
    readonly cloudformationStackArn?: string;
    /**
     * tag_filter block.
     *
     * @stability stable
     */
    readonly tagFilter?: AutoscalingplansScalingPlanApplicationSourceTagFilter[];
}
/**
 * @stability stable
 */
export interface AutoscalingplansScalingPlanScalingInstructionCustomizedLoadMetricSpecification {
    /**
     * @stability stable
     */
    readonly dimensions?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly metricName: string;
    /**
     * @stability stable
     */
    readonly namespace: string;
    /**
     * @stability stable
     */
    readonly statistic: string;
    /**
     * @stability stable
     */
    readonly unit?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingplansScalingPlanScalingInstructionPredefinedLoadMetricSpecification {
    /**
     * @stability stable
     */
    readonly predefinedLoadMetricType: string;
    /**
     * @stability stable
     */
    readonly resourceLabel?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingplansScalingPlanScalingInstructionTargetTrackingConfigurationCustomizedScalingMetricSpecification {
    /**
     * @stability stable
     */
    readonly dimensions?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly metricName: string;
    /**
     * @stability stable
     */
    readonly namespace: string;
    /**
     * @stability stable
     */
    readonly statistic: string;
    /**
     * @stability stable
     */
    readonly unit?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingplansScalingPlanScalingInstructionTargetTrackingConfigurationPredefinedScalingMetricSpecification {
    /**
     * @stability stable
     */
    readonly predefinedScalingMetricType: string;
    /**
     * @stability stable
     */
    readonly resourceLabel?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingplansScalingPlanScalingInstructionTargetTrackingConfiguration {
    /**
     * @stability stable
     */
    readonly disableScaleIn?: boolean;
    /**
     * @stability stable
     */
    readonly estimatedInstanceWarmup?: number;
    /**
     * @stability stable
     */
    readonly scaleInCooldown?: number;
    /**
     * @stability stable
     */
    readonly scaleOutCooldown?: number;
    /**
     * @stability stable
     */
    readonly targetValue: number;
    /**
     * customized_scaling_metric_specification block.
     *
     * @stability stable
     */
    readonly customizedScalingMetricSpecification?: AutoscalingplansScalingPlanScalingInstructionTargetTrackingConfigurationCustomizedScalingMetricSpecification[];
    /**
     * predefined_scaling_metric_specification block.
     *
     * @stability stable
     */
    readonly predefinedScalingMetricSpecification?: AutoscalingplansScalingPlanScalingInstructionTargetTrackingConfigurationPredefinedScalingMetricSpecification[];
}
/**
 * @stability stable
 */
export interface AutoscalingplansScalingPlanScalingInstruction {
    /**
     * @stability stable
     */
    readonly disableDynamicScaling?: boolean;
    /**
     * @stability stable
     */
    readonly maxCapacity: number;
    /**
     * @stability stable
     */
    readonly minCapacity: number;
    /**
     * @stability stable
     */
    readonly predictiveScalingMaxCapacityBehavior?: string;
    /**
     * @stability stable
     */
    readonly predictiveScalingMaxCapacityBuffer?: number;
    /**
     * @stability stable
     */
    readonly predictiveScalingMode?: string;
    /**
     * @stability stable
     */
    readonly resourceId: string;
    /**
     * @stability stable
     */
    readonly scalableDimension: string;
    /**
     * @stability stable
     */
    readonly scalingPolicyUpdateBehavior?: string;
    /**
     * @stability stable
     */
    readonly scheduledActionBufferTime?: number;
    /**
     * @stability stable
     */
    readonly serviceNamespace: string;
    /**
     * customized_load_metric_specification block.
     *
     * @stability stable
     */
    readonly customizedLoadMetricSpecification?: AutoscalingplansScalingPlanScalingInstructionCustomizedLoadMetricSpecification[];
    /**
     * predefined_load_metric_specification block.
     *
     * @stability stable
     */
    readonly predefinedLoadMetricSpecification?: AutoscalingplansScalingPlanScalingInstructionPredefinedLoadMetricSpecification[];
    /**
     * target_tracking_configuration block.
     *
     * @stability stable
     */
    readonly targetTrackingConfiguration: AutoscalingplansScalingPlanScalingInstructionTargetTrackingConfiguration[];
}
/**
 * @stability stable
 */
export declare class AutoscalingplansScalingPlan extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AutoscalingplansScalingPlanConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get scalingPlanVersion(): number;
    private _applicationSource;
    /**
     * @stability stable
     */
    get applicationSource(): AutoscalingplansScalingPlanApplicationSource[];
    /**
     * @stability stable
     */
    set applicationSource(value: AutoscalingplansScalingPlanApplicationSource[]);
    /**
     * @stability stable
     */
    get applicationSourceInput(): AutoscalingplansScalingPlanApplicationSource[];
    private _scalingInstruction;
    /**
     * @stability stable
     */
    get scalingInstruction(): AutoscalingplansScalingPlanScalingInstruction[];
    /**
     * @stability stable
     */
    set scalingInstruction(value: AutoscalingplansScalingPlanScalingInstruction[]);
    /**
     * @stability stable
     */
    get scalingInstructionInput(): AutoscalingplansScalingPlanScalingInstruction[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
