import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface BackupSelectionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly iamRoleArn: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly planId: string;
    /**
     * @stability stable
     */
    readonly resources?: string[];
    /**
     * selection_tag block.
     *
     * @stability stable
     */
    readonly selectionTag?: BackupSelectionSelectionTag[];
}
/**
 * @stability stable
 */
export interface BackupSelectionSelectionTag {
    /**
     * @stability stable
     */
    readonly key: string;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export declare class BackupSelection extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BackupSelectionConfig);
    private _iamRoleArn;
    /**
     * @stability stable
     */
    get iamRoleArn(): string;
    /**
     * @stability stable
     */
    set iamRoleArn(value: string);
    /**
     * @stability stable
     */
    get iamRoleArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _planId;
    /**
     * @stability stable
     */
    get planId(): string;
    /**
     * @stability stable
     */
    set planId(value: string);
    /**
     * @stability stable
     */
    get planIdInput(): string;
    private _resources?;
    /**
     * @stability stable
     */
    get resources(): string[];
    /**
     * @stability stable
     */
    set resources(value: string[]);
    /**
     * @stability stable
     */
    resetResources(): void;
    /**
     * @stability stable
     */
    get resourcesInput(): string[] | undefined;
    private _selectionTag?;
    /**
     * @stability stable
     */
    get selectionTag(): BackupSelectionSelectionTag[];
    /**
     * @stability stable
     */
    set selectionTag(value: BackupSelectionSelectionTag[]);
    /**
     * @stability stable
     */
    resetSelectionTag(): void;
    /**
     * @stability stable
     */
    get selectionTagInput(): BackupSelectionSelectionTag[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
