import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface BackupVaultNotificationsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly backupVaultEvents: string[];
    /**
     * @stability stable
     */
    readonly backupVaultName: string;
    /**
     * @stability stable
     */
    readonly snsTopicArn: string;
}
/**
 * @stability stable
 */
export declare class BackupVaultNotifications extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BackupVaultNotificationsConfig);
    /**
     * @stability stable
     */
    get backupVaultArn(): string;
    private _backupVaultEvents;
    /**
     * @stability stable
     */
    get backupVaultEvents(): string[];
    /**
     * @stability stable
     */
    set backupVaultEvents(value: string[]);
    /**
     * @stability stable
     */
    get backupVaultEventsInput(): string[];
    private _backupVaultName;
    /**
     * @stability stable
     */
    get backupVaultName(): string;
    /**
     * @stability stable
     */
    set backupVaultName(value: string);
    /**
     * @stability stable
     */
    get backupVaultNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _snsTopicArn;
    /**
     * @stability stable
     */
    get snsTopicArn(): string;
    /**
     * @stability stable
     */
    set snsTopicArn(value: string);
    /**
     * @stability stable
     */
    get snsTopicArnInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
