import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface BatchComputeEnvironmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly computeEnvironmentName?: string;
    /**
     * @stability stable
     */
    readonly computeEnvironmentNamePrefix?: string;
    /**
     * @stability stable
     */
    readonly serviceRole: string;
    /**
     * @stability stable
     */
    readonly state?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * compute_resources block.
     *
     * @stability stable
     */
    readonly computeResources?: BatchComputeEnvironmentComputeResources[];
}
/**
 * @stability stable
 */
export interface BatchComputeEnvironmentComputeResourcesLaunchTemplate {
    /**
     * @stability stable
     */
    readonly launchTemplateId?: string;
    /**
     * @stability stable
     */
    readonly launchTemplateName?: string;
    /**
     * @stability stable
     */
    readonly version?: string;
}
/**
 * @stability stable
 */
export interface BatchComputeEnvironmentComputeResources {
    /**
     * @stability stable
     */
    readonly allocationStrategy?: string;
    /**
     * @stability stable
     */
    readonly bidPercentage?: number;
    /**
     * @stability stable
     */
    readonly desiredVcpus?: number;
    /**
     * @stability stable
     */
    readonly ec2KeyPair?: string;
    /**
     * @stability stable
     */
    readonly imageId?: string;
    /**
     * @stability stable
     */
    readonly instanceRole: string;
    /**
     * @stability stable
     */
    readonly instanceType: string[];
    /**
     * @stability stable
     */
    readonly maxVcpus: number;
    /**
     * @stability stable
     */
    readonly minVcpus: number;
    /**
     * @stability stable
     */
    readonly securityGroupIds: string[];
    /**
     * @stability stable
     */
    readonly spotIamFleetRole?: string;
    /**
     * @stability stable
     */
    readonly subnets: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * launch_template block.
     *
     * @stability stable
     */
    readonly launchTemplate?: BatchComputeEnvironmentComputeResourcesLaunchTemplate[];
}
/**
 * @stability stable
 */
export declare class BatchComputeEnvironment extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BatchComputeEnvironmentConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _computeEnvironmentName?;
    /**
     * @stability stable
     */
    get computeEnvironmentName(): string;
    /**
     * @stability stable
     */
    set computeEnvironmentName(value: string);
    /**
     * @stability stable
     */
    resetComputeEnvironmentName(): void;
    /**
     * @stability stable
     */
    get computeEnvironmentNameInput(): string | undefined;
    private _computeEnvironmentNamePrefix?;
    /**
     * @stability stable
     */
    get computeEnvironmentNamePrefix(): string;
    /**
     * @stability stable
     */
    set computeEnvironmentNamePrefix(value: string);
    /**
     * @stability stable
     */
    resetComputeEnvironmentNamePrefix(): void;
    /**
     * @stability stable
     */
    get computeEnvironmentNamePrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    get ecsClusterArn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _serviceRole;
    /**
     * @stability stable
     */
    get serviceRole(): string;
    /**
     * @stability stable
     */
    set serviceRole(value: string);
    /**
     * @stability stable
     */
    get serviceRoleInput(): string;
    private _state?;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    set state(value: string);
    /**
     * @stability stable
     */
    resetState(): void;
    /**
     * @stability stable
     */
    get stateInput(): string | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get statusReason(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    private _computeResources?;
    /**
     * @stability stable
     */
    get computeResources(): BatchComputeEnvironmentComputeResources[];
    /**
     * @stability stable
     */
    set computeResources(value: BatchComputeEnvironmentComputeResources[]);
    /**
     * @stability stable
     */
    resetComputeResources(): void;
    /**
     * @stability stable
     */
    get computeResourcesInput(): BatchComputeEnvironmentComputeResources[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
