import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface BudgetsBudgetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly accountId?: string;
    /**
     * @stability stable
     */
    readonly budgetType: string;
    /**
     * @stability stable
     */
    readonly costFilters?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly limitAmount: string;
    /**
     * @stability stable
     */
    readonly limitUnit: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly timePeriodEnd?: string;
    /**
     * @stability stable
     */
    readonly timePeriodStart: string;
    /**
     * @stability stable
     */
    readonly timeUnit: string;
    /**
     * cost_types block.
     *
     * @stability stable
     */
    readonly costTypes?: BudgetsBudgetCostTypes[];
    /**
     * notification block.
     *
     * @stability stable
     */
    readonly notification?: BudgetsBudgetNotification[];
}
/**
 * @stability stable
 */
export interface BudgetsBudgetCostTypes {
    /**
     * @stability stable
     */
    readonly includeCredit?: boolean;
    /**
     * @stability stable
     */
    readonly includeDiscount?: boolean;
    /**
     * @stability stable
     */
    readonly includeOtherSubscription?: boolean;
    /**
     * @stability stable
     */
    readonly includeRecurring?: boolean;
    /**
     * @stability stable
     */
    readonly includeRefund?: boolean;
    /**
     * @stability stable
     */
    readonly includeSubscription?: boolean;
    /**
     * @stability stable
     */
    readonly includeSupport?: boolean;
    /**
     * @stability stable
     */
    readonly includeTax?: boolean;
    /**
     * @stability stable
     */
    readonly includeUpfront?: boolean;
    /**
     * @stability stable
     */
    readonly useAmortized?: boolean;
    /**
     * @stability stable
     */
    readonly useBlended?: boolean;
}
/**
 * @stability stable
 */
export interface BudgetsBudgetNotification {
    /**
     * @stability stable
     */
    readonly comparisonOperator: string;
    /**
     * @stability stable
     */
    readonly notificationType: string;
    /**
     * @stability stable
     */
    readonly subscriberEmailAddresses?: string[];
    /**
     * @stability stable
     */
    readonly subscriberSnsTopicArns?: string[];
    /**
     * @stability stable
     */
    readonly threshold: number;
    /**
     * @stability stable
     */
    readonly thresholdType: string;
}
/**
 * @stability stable
 */
export declare class BudgetsBudget extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BudgetsBudgetConfig);
    private _accountId?;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    resetAccountId(): void;
    /**
     * @stability stable
     */
    get accountIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _budgetType;
    /**
     * @stability stable
     */
    get budgetType(): string;
    /**
     * @stability stable
     */
    set budgetType(value: string);
    /**
     * @stability stable
     */
    get budgetTypeInput(): string;
    private _costFilters?;
    /**
     * @stability stable
     */
    get costFilters(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set costFilters(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetCostFilters(): void;
    /**
     * @stability stable
     */
    get costFiltersInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _limitAmount;
    /**
     * @stability stable
     */
    get limitAmount(): string;
    /**
     * @stability stable
     */
    set limitAmount(value: string);
    /**
     * @stability stable
     */
    get limitAmountInput(): string;
    private _limitUnit;
    /**
     * @stability stable
     */
    get limitUnit(): string;
    /**
     * @stability stable
     */
    set limitUnit(value: string);
    /**
     * @stability stable
     */
    get limitUnitInput(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _timePeriodEnd?;
    /**
     * @stability stable
     */
    get timePeriodEnd(): string;
    /**
     * @stability stable
     */
    set timePeriodEnd(value: string);
    /**
     * @stability stable
     */
    resetTimePeriodEnd(): void;
    /**
     * @stability stable
     */
    get timePeriodEndInput(): string | undefined;
    private _timePeriodStart;
    /**
     * @stability stable
     */
    get timePeriodStart(): string;
    /**
     * @stability stable
     */
    set timePeriodStart(value: string);
    /**
     * @stability stable
     */
    get timePeriodStartInput(): string;
    private _timeUnit;
    /**
     * @stability stable
     */
    get timeUnit(): string;
    /**
     * @stability stable
     */
    set timeUnit(value: string);
    /**
     * @stability stable
     */
    get timeUnitInput(): string;
    private _costTypes?;
    /**
     * @stability stable
     */
    get costTypes(): BudgetsBudgetCostTypes[];
    /**
     * @stability stable
     */
    set costTypes(value: BudgetsBudgetCostTypes[]);
    /**
     * @stability stable
     */
    resetCostTypes(): void;
    /**
     * @stability stable
     */
    get costTypesInput(): BudgetsBudgetCostTypes[] | undefined;
    private _notification?;
    /**
     * @stability stable
     */
    get notification(): BudgetsBudgetNotification[];
    /**
     * @stability stable
     */
    set notification(value: BudgetsBudgetNotification[]);
    /**
     * @stability stable
     */
    resetNotification(): void;
    /**
     * @stability stable
     */
    get notificationInput(): BudgetsBudgetNotification[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
