import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudformationStackSetInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly accountId?: string;
    /**
     * @stability stable
     */
    readonly parameterOverrides?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly region?: string;
    /**
     * @stability stable
     */
    readonly retainStack?: boolean;
    /**
     * @stability stable
     */
    readonly stackSetName: string;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: CloudformationStackSetInstanceTimeouts;
}
/**
 * @stability stable
 */
export interface CloudformationStackSetInstanceTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class CloudformationStackSetInstance extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudformationStackSetInstanceConfig);
    private _accountId?;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    resetAccountId(): void;
    /**
     * @stability stable
     */
    get accountIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _parameterOverrides?;
    /**
     * @stability stable
     */
    get parameterOverrides(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set parameterOverrides(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetParameterOverrides(): void;
    /**
     * @stability stable
     */
    get parameterOverridesInput(): {
        [key: string]: string;
    } | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    private _retainStack?;
    /**
     * @stability stable
     */
    get retainStack(): boolean;
    /**
     * @stability stable
     */
    set retainStack(value: boolean);
    /**
     * @stability stable
     */
    resetRetainStack(): void;
    /**
     * @stability stable
     */
    get retainStackInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get stackId(): string;
    private _stackSetName;
    /**
     * @stability stable
     */
    get stackSetName(): string;
    /**
     * @stability stable
     */
    set stackSetName(value: string);
    /**
     * @stability stable
     */
    get stackSetNameInput(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): CloudformationStackSetInstanceTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: CloudformationStackSetInstanceTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): CloudformationStackSetInstanceTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
