import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudformationStackConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly capabilities?: string[];
    /**
     * @stability stable
     */
    readonly disableRollback?: boolean;
    /**
     * @stability stable
     */
    readonly iamRoleArn?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly notificationArns?: string[];
    /**
     * @stability stable
     */
    readonly onFailure?: string;
    /**
     * @stability stable
     */
    readonly parameters?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly policyBody?: string;
    /**
     * @stability stable
     */
    readonly policyUrl?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly templateBody?: string;
    /**
     * @stability stable
     */
    readonly templateUrl?: string;
    /**
     * @stability stable
     */
    readonly timeoutInMinutes?: number;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: CloudformationStackTimeouts;
}
/**
 * @stability stable
 */
export interface CloudformationStackTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class CloudformationStack extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudformationStackConfig);
    private _capabilities?;
    /**
     * @stability stable
     */
    get capabilities(): string[];
    /**
     * @stability stable
     */
    set capabilities(value: string[]);
    /**
     * @stability stable
     */
    resetCapabilities(): void;
    /**
     * @stability stable
     */
    get capabilitiesInput(): string[] | undefined;
    private _disableRollback?;
    /**
     * @stability stable
     */
    get disableRollback(): boolean;
    /**
     * @stability stable
     */
    set disableRollback(value: boolean);
    /**
     * @stability stable
     */
    resetDisableRollback(): void;
    /**
     * @stability stable
     */
    get disableRollbackInput(): boolean | undefined;
    private _iamRoleArn?;
    /**
     * @stability stable
     */
    get iamRoleArn(): string;
    /**
     * @stability stable
     */
    set iamRoleArn(value: string);
    /**
     * @stability stable
     */
    resetIamRoleArn(): void;
    /**
     * @stability stable
     */
    get iamRoleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _notificationArns?;
    /**
     * @stability stable
     */
    get notificationArns(): string[];
    /**
     * @stability stable
     */
    set notificationArns(value: string[]);
    /**
     * @stability stable
     */
    resetNotificationArns(): void;
    /**
     * @stability stable
     */
    get notificationArnsInput(): string[] | undefined;
    private _onFailure?;
    /**
     * @stability stable
     */
    get onFailure(): string;
    /**
     * @stability stable
     */
    set onFailure(value: string);
    /**
     * @stability stable
     */
    resetOnFailure(): void;
    /**
     * @stability stable
     */
    get onFailureInput(): string | undefined;
    /**
     * @stability stable
     */
    outputs(key: string): string;
    private _parameters?;
    /**
     * @stability stable
     */
    get parameters(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set parameters(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetParameters(): void;
    /**
     * @stability stable
     */
    get parametersInput(): {
        [key: string]: string;
    } | undefined;
    private _policyBody?;
    /**
     * @stability stable
     */
    get policyBody(): string;
    /**
     * @stability stable
     */
    set policyBody(value: string);
    /**
     * @stability stable
     */
    resetPolicyBody(): void;
    /**
     * @stability stable
     */
    get policyBodyInput(): string | undefined;
    private _policyUrl?;
    /**
     * @stability stable
     */
    get policyUrl(): string;
    /**
     * @stability stable
     */
    set policyUrl(value: string);
    /**
     * @stability stable
     */
    resetPolicyUrl(): void;
    /**
     * @stability stable
     */
    get policyUrlInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _templateBody?;
    /**
     * @stability stable
     */
    get templateBody(): string;
    /**
     * @stability stable
     */
    set templateBody(value: string);
    /**
     * @stability stable
     */
    resetTemplateBody(): void;
    /**
     * @stability stable
     */
    get templateBodyInput(): string | undefined;
    private _templateUrl?;
    /**
     * @stability stable
     */
    get templateUrl(): string;
    /**
     * @stability stable
     */
    set templateUrl(value: string);
    /**
     * @stability stable
     */
    resetTemplateUrl(): void;
    /**
     * @stability stable
     */
    get templateUrlInput(): string | undefined;
    private _timeoutInMinutes?;
    /**
     * @stability stable
     */
    get timeoutInMinutes(): number;
    /**
     * @stability stable
     */
    set timeoutInMinutes(value: number);
    /**
     * @stability stable
     */
    resetTimeoutInMinutes(): void;
    /**
     * @stability stable
     */
    get timeoutInMinutesInput(): number | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): CloudformationStackTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: CloudformationStackTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): CloudformationStackTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
