import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudfrontCachePolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly comment?: string;
    /**
     * @stability stable
     */
    readonly defaultTtl?: number;
    /**
     * @stability stable
     */
    readonly etag?: string;
    /**
     * @stability stable
     */
    readonly maxTtl?: number;
    /**
     * @stability stable
     */
    readonly minTtl?: number;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * parameters_in_cache_key_and_forwarded_to_origin block.
     *
     * @stability stable
     */
    readonly parametersInCacheKeyAndForwardedToOrigin?: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOrigin[];
}
/**
 * @stability stable
 */
export interface CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfigCookies {
    /**
     * @stability stable
     */
    readonly items?: string[];
}
/**
 * @stability stable
 */
export interface CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfig {
    /**
     * @stability stable
     */
    readonly cookieBehavior: string;
    /**
     * cookies block.
     *
     * @stability stable
     */
    readonly cookies?: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfigCookies[];
}
/**
 * @stability stable
 */
export interface CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfigHeaders {
    /**
     * @stability stable
     */
    readonly items?: string[];
}
/**
 * @stability stable
 */
export interface CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfig {
    /**
     * @stability stable
     */
    readonly headerBehavior?: string;
    /**
     * headers block.
     *
     * @stability stable
     */
    readonly headers?: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfigHeaders[];
}
/**
 * @stability stable
 */
export interface CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfigQueryStrings {
    /**
     * @stability stable
     */
    readonly items?: string[];
}
/**
 * @stability stable
 */
export interface CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfig {
    /**
     * @stability stable
     */
    readonly queryStringBehavior: string;
    /**
     * query_strings block.
     *
     * @stability stable
     */
    readonly queryStrings?: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfigQueryStrings[];
}
/**
 * @stability stable
 */
export interface CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOrigin {
    /**
     * @stability stable
     */
    readonly enableAcceptEncodingBrotli?: boolean;
    /**
     * @stability stable
     */
    readonly enableAcceptEncodingGzip?: boolean;
    /**
     * cookies_config block.
     *
     * @stability stable
     */
    readonly cookiesConfig: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfig[];
    /**
     * headers_config block.
     *
     * @stability stable
     */
    readonly headersConfig: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfig[];
    /**
     * query_strings_config block.
     *
     * @stability stable
     */
    readonly queryStringsConfig: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfig[];
}
/**
 * @stability stable
 */
export declare class CloudfrontCachePolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudfrontCachePolicyConfig);
    private _comment?;
    /**
     * @stability stable
     */
    get comment(): string;
    /**
     * @stability stable
     */
    set comment(value: string);
    /**
     * @stability stable
     */
    resetComment(): void;
    /**
     * @stability stable
     */
    get commentInput(): string | undefined;
    private _defaultTtl?;
    /**
     * @stability stable
     */
    get defaultTtl(): number;
    /**
     * @stability stable
     */
    set defaultTtl(value: number);
    /**
     * @stability stable
     */
    resetDefaultTtl(): void;
    /**
     * @stability stable
     */
    get defaultTtlInput(): number | undefined;
    private _etag?;
    /**
     * @stability stable
     */
    get etag(): string;
    /**
     * @stability stable
     */
    set etag(value: string);
    /**
     * @stability stable
     */
    resetEtag(): void;
    /**
     * @stability stable
     */
    get etagInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _maxTtl?;
    /**
     * @stability stable
     */
    get maxTtl(): number;
    /**
     * @stability stable
     */
    set maxTtl(value: number);
    /**
     * @stability stable
     */
    resetMaxTtl(): void;
    /**
     * @stability stable
     */
    get maxTtlInput(): number | undefined;
    private _minTtl?;
    /**
     * @stability stable
     */
    get minTtl(): number;
    /**
     * @stability stable
     */
    set minTtl(value: number);
    /**
     * @stability stable
     */
    resetMinTtl(): void;
    /**
     * @stability stable
     */
    get minTtlInput(): number | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _parametersInCacheKeyAndForwardedToOrigin?;
    /**
     * @stability stable
     */
    get parametersInCacheKeyAndForwardedToOrigin(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOrigin[];
    /**
     * @stability stable
     */
    set parametersInCacheKeyAndForwardedToOrigin(value: CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOrigin[]);
    /**
     * @stability stable
     */
    resetParametersInCacheKeyAndForwardedToOrigin(): void;
    /**
     * @stability stable
     */
    get parametersInCacheKeyAndForwardedToOriginInput(): CloudfrontCachePolicyParametersInCacheKeyAndForwardedToOrigin[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
