import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudfrontDistributionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly aliases?: string[];
    /**
     * @stability stable
     */
    readonly comment?: string;
    /**
     * @stability stable
     */
    readonly defaultRootObject?: string;
    /**
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * @stability stable
     */
    readonly httpVersion?: string;
    /**
     * @stability stable
     */
    readonly isIpv6Enabled?: boolean;
    /**
     * @stability stable
     */
    readonly priceClass?: string;
    /**
     * @stability stable
     */
    readonly retainOnDelete?: boolean;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly waitForDeployment?: boolean;
    /**
     * @stability stable
     */
    readonly webAclId?: string;
    /**
     * custom_error_response block.
     *
     * @stability stable
     */
    readonly customErrorResponse?: CloudfrontDistributionCustomErrorResponse[];
    /**
     * default_cache_behavior block.
     *
     * @stability stable
     */
    readonly defaultCacheBehavior: CloudfrontDistributionDefaultCacheBehavior[];
    /**
     * logging_config block.
     *
     * @stability stable
     */
    readonly loggingConfig?: CloudfrontDistributionLoggingConfig[];
    /**
     * ordered_cache_behavior block.
     *
     * @stability stable
     */
    readonly orderedCacheBehavior?: CloudfrontDistributionOrderedCacheBehavior[];
    /**
     * origin block.
     *
     * @stability stable
     */
    readonly origin: CloudfrontDistributionOrigin[];
    /**
     * origin_group block.
     *
     * @stability stable
     */
    readonly originGroup?: CloudfrontDistributionOriginGroup[];
    /**
     * restrictions block.
     *
     * @stability stable
     */
    readonly restrictions: CloudfrontDistributionRestrictions[];
    /**
     * viewer_certificate block.
     *
     * @stability stable
     */
    readonly viewerCertificate: CloudfrontDistributionViewerCertificate[];
}
/**
 * @stability stable
 */
export declare class CloudfrontDistributionTrustedSignersItems extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get awsAccountNumber(): string;
    /**
     * @stability stable
     */
    get keyPairIds(): string[];
}
/**
 * @stability stable
 */
export declare class CloudfrontDistributionTrustedSigners extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    get items(): any;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionCustomErrorResponse {
    /**
     * @stability stable
     */
    readonly errorCachingMinTtl?: number;
    /**
     * @stability stable
     */
    readonly errorCode: number;
    /**
     * @stability stable
     */
    readonly responseCode?: number;
    /**
     * @stability stable
     */
    readonly responsePagePath?: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionDefaultCacheBehaviorForwardedValuesCookies {
    /**
     * @stability stable
     */
    readonly forward: string;
    /**
     * @stability stable
     */
    readonly whitelistedNames?: string[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionDefaultCacheBehaviorForwardedValues {
    /**
     * @stability stable
     */
    readonly headers?: string[];
    /**
     * @stability stable
     */
    readonly queryString: boolean;
    /**
     * @stability stable
     */
    readonly queryStringCacheKeys?: string[];
    /**
     * cookies block.
     *
     * @stability stable
     */
    readonly cookies: CloudfrontDistributionDefaultCacheBehaviorForwardedValuesCookies[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionDefaultCacheBehaviorLambdaFunctionAssociation {
    /**
     * @stability stable
     */
    readonly eventType: string;
    /**
     * @stability stable
     */
    readonly includeBody?: boolean;
    /**
     * @stability stable
     */
    readonly lambdaArn: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionDefaultCacheBehavior {
    /**
     * @stability stable
     */
    readonly allowedMethods: string[];
    /**
     * @stability stable
     */
    readonly cachePolicyId?: string;
    /**
     * @stability stable
     */
    readonly cachedMethods: string[];
    /**
     * @stability stable
     */
    readonly compress?: boolean;
    /**
     * @stability stable
     */
    readonly defaultTtl?: number;
    /**
     * @stability stable
     */
    readonly fieldLevelEncryptionId?: string;
    /**
     * @stability stable
     */
    readonly maxTtl?: number;
    /**
     * @stability stable
     */
    readonly minTtl?: number;
    /**
     * @stability stable
     */
    readonly originRequestPolicyId?: string;
    /**
     * @stability stable
     */
    readonly realtimeLogConfigArn?: string;
    /**
     * @stability stable
     */
    readonly smoothStreaming?: boolean;
    /**
     * @stability stable
     */
    readonly targetOriginId: string;
    /**
     * @stability stable
     */
    readonly trustedSigners?: string[];
    /**
     * @stability stable
     */
    readonly viewerProtocolPolicy: string;
    /**
     * forwarded_values block.
     *
     * @stability stable
     */
    readonly forwardedValues?: CloudfrontDistributionDefaultCacheBehaviorForwardedValues[];
    /**
     * lambda_function_association block.
     *
     * @stability stable
     */
    readonly lambdaFunctionAssociation?: CloudfrontDistributionDefaultCacheBehaviorLambdaFunctionAssociation[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionLoggingConfig {
    /**
     * @stability stable
     */
    readonly bucket: string;
    /**
     * @stability stable
     */
    readonly includeCookies?: boolean;
    /**
     * @stability stable
     */
    readonly prefix?: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOrderedCacheBehaviorForwardedValuesCookies {
    /**
     * @stability stable
     */
    readonly forward: string;
    /**
     * @stability stable
     */
    readonly whitelistedNames?: string[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOrderedCacheBehaviorForwardedValues {
    /**
     * @stability stable
     */
    readonly headers?: string[];
    /**
     * @stability stable
     */
    readonly queryString: boolean;
    /**
     * @stability stable
     */
    readonly queryStringCacheKeys?: string[];
    /**
     * cookies block.
     *
     * @stability stable
     */
    readonly cookies: CloudfrontDistributionOrderedCacheBehaviorForwardedValuesCookies[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOrderedCacheBehaviorLambdaFunctionAssociation {
    /**
     * @stability stable
     */
    readonly eventType: string;
    /**
     * @stability stable
     */
    readonly includeBody?: boolean;
    /**
     * @stability stable
     */
    readonly lambdaArn: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOrderedCacheBehavior {
    /**
     * @stability stable
     */
    readonly allowedMethods: string[];
    /**
     * @stability stable
     */
    readonly cachePolicyId?: string;
    /**
     * @stability stable
     */
    readonly cachedMethods: string[];
    /**
     * @stability stable
     */
    readonly compress?: boolean;
    /**
     * @stability stable
     */
    readonly defaultTtl?: number;
    /**
     * @stability stable
     */
    readonly fieldLevelEncryptionId?: string;
    /**
     * @stability stable
     */
    readonly maxTtl?: number;
    /**
     * @stability stable
     */
    readonly minTtl?: number;
    /**
     * @stability stable
     */
    readonly originRequestPolicyId?: string;
    /**
     * @stability stable
     */
    readonly pathPattern: string;
    /**
     * @stability stable
     */
    readonly realtimeLogConfigArn?: string;
    /**
     * @stability stable
     */
    readonly smoothStreaming?: boolean;
    /**
     * @stability stable
     */
    readonly targetOriginId: string;
    /**
     * @stability stable
     */
    readonly trustedSigners?: string[];
    /**
     * @stability stable
     */
    readonly viewerProtocolPolicy: string;
    /**
     * forwarded_values block.
     *
     * @stability stable
     */
    readonly forwardedValues?: CloudfrontDistributionOrderedCacheBehaviorForwardedValues[];
    /**
     * lambda_function_association block.
     *
     * @stability stable
     */
    readonly lambdaFunctionAssociation?: CloudfrontDistributionOrderedCacheBehaviorLambdaFunctionAssociation[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOriginCustomHeader {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOriginCustomOriginConfig {
    /**
     * @stability stable
     */
    readonly httpPort: number;
    /**
     * @stability stable
     */
    readonly httpsPort: number;
    /**
     * @stability stable
     */
    readonly originKeepaliveTimeout?: number;
    /**
     * @stability stable
     */
    readonly originProtocolPolicy: string;
    /**
     * @stability stable
     */
    readonly originReadTimeout?: number;
    /**
     * @stability stable
     */
    readonly originSslProtocols: string[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOriginS3OriginConfig {
    /**
     * @stability stable
     */
    readonly originAccessIdentity: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOrigin {
    /**
     * @stability stable
     */
    readonly domainName: string;
    /**
     * @stability stable
     */
    readonly originId: string;
    /**
     * @stability stable
     */
    readonly originPath?: string;
    /**
     * custom_header block.
     *
     * @stability stable
     */
    readonly customHeader?: CloudfrontDistributionOriginCustomHeader[];
    /**
     * custom_origin_config block.
     *
     * @stability stable
     */
    readonly customOriginConfig?: CloudfrontDistributionOriginCustomOriginConfig[];
    /**
     * s3_origin_config block.
     *
     * @stability stable
     */
    readonly s3OriginConfig?: CloudfrontDistributionOriginS3OriginConfig[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOriginGroupFailoverCriteria {
    /**
     * @stability stable
     */
    readonly statusCodes: number[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOriginGroupMember {
    /**
     * @stability stable
     */
    readonly originId: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionOriginGroup {
    /**
     * @stability stable
     */
    readonly originId: string;
    /**
     * failover_criteria block.
     *
     * @stability stable
     */
    readonly failoverCriteria: CloudfrontDistributionOriginGroupFailoverCriteria[];
    /**
     * member block.
     *
     * @stability stable
     */
    readonly member: CloudfrontDistributionOriginGroupMember[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionRestrictionsGeoRestriction {
    /**
     * @stability stable
     */
    readonly locations?: string[];
    /**
     * @stability stable
     */
    readonly restrictionType: string;
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionRestrictions {
    /**
     * geo_restriction block.
     *
     * @stability stable
     */
    readonly geoRestriction: CloudfrontDistributionRestrictionsGeoRestriction[];
}
/**
 * @stability stable
 */
export interface CloudfrontDistributionViewerCertificate {
    /**
     * @stability stable
     */
    readonly acmCertificateArn?: string;
    /**
     * @stability stable
     */
    readonly cloudfrontDefaultCertificate?: boolean;
    /**
     * @stability stable
     */
    readonly iamCertificateId?: string;
    /**
     * @stability stable
     */
    readonly minimumProtocolVersion?: string;
    /**
     * @stability stable
     */
    readonly sslSupportMethod?: string;
}
/**
 * @stability stable
 */
export declare class CloudfrontDistribution extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudfrontDistributionConfig);
    private _aliases?;
    /**
     * @stability stable
     */
    get aliases(): string[];
    /**
     * @stability stable
     */
    set aliases(value: string[]);
    /**
     * @stability stable
     */
    resetAliases(): void;
    /**
     * @stability stable
     */
    get aliasesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get callerReference(): string;
    private _comment?;
    /**
     * @stability stable
     */
    get comment(): string;
    /**
     * @stability stable
     */
    set comment(value: string);
    /**
     * @stability stable
     */
    resetComment(): void;
    /**
     * @stability stable
     */
    get commentInput(): string | undefined;
    private _defaultRootObject?;
    /**
     * @stability stable
     */
    get defaultRootObject(): string;
    /**
     * @stability stable
     */
    set defaultRootObject(value: string);
    /**
     * @stability stable
     */
    resetDefaultRootObject(): void;
    /**
     * @stability stable
     */
    get defaultRootObjectInput(): string | undefined;
    /**
     * @stability stable
     */
    get domainName(): string;
    private _enabled;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    get enabledInput(): boolean;
    /**
     * @stability stable
     */
    get etag(): string;
    /**
     * @stability stable
     */
    get hostedZoneId(): string;
    private _httpVersion?;
    /**
     * @stability stable
     */
    get httpVersion(): string;
    /**
     * @stability stable
     */
    set httpVersion(value: string);
    /**
     * @stability stable
     */
    resetHttpVersion(): void;
    /**
     * @stability stable
     */
    get httpVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get inProgressValidationBatches(): number;
    private _isIpv6Enabled?;
    /**
     * @stability stable
     */
    get isIpv6Enabled(): boolean;
    /**
     * @stability stable
     */
    set isIpv6Enabled(value: boolean);
    /**
     * @stability stable
     */
    resetIsIpv6Enabled(): void;
    /**
     * @stability stable
     */
    get isIpv6EnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get lastModifiedTime(): string;
    private _priceClass?;
    /**
     * @stability stable
     */
    get priceClass(): string;
    /**
     * @stability stable
     */
    set priceClass(value: string);
    /**
     * @stability stable
     */
    resetPriceClass(): void;
    /**
     * @stability stable
     */
    get priceClassInput(): string | undefined;
    private _retainOnDelete?;
    /**
     * @stability stable
     */
    get retainOnDelete(): boolean;
    /**
     * @stability stable
     */
    set retainOnDelete(value: boolean);
    /**
     * @stability stable
     */
    resetRetainOnDelete(): void;
    /**
     * @stability stable
     */
    get retainOnDeleteInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    trustedSigners(index: string): CloudfrontDistributionTrustedSigners;
    private _waitForDeployment?;
    /**
     * @stability stable
     */
    get waitForDeployment(): boolean;
    /**
     * @stability stable
     */
    set waitForDeployment(value: boolean);
    /**
     * @stability stable
     */
    resetWaitForDeployment(): void;
    /**
     * @stability stable
     */
    get waitForDeploymentInput(): boolean | undefined;
    private _webAclId?;
    /**
     * @stability stable
     */
    get webAclId(): string;
    /**
     * @stability stable
     */
    set webAclId(value: string);
    /**
     * @stability stable
     */
    resetWebAclId(): void;
    /**
     * @stability stable
     */
    get webAclIdInput(): string | undefined;
    private _customErrorResponse?;
    /**
     * @stability stable
     */
    get customErrorResponse(): CloudfrontDistributionCustomErrorResponse[];
    /**
     * @stability stable
     */
    set customErrorResponse(value: CloudfrontDistributionCustomErrorResponse[]);
    /**
     * @stability stable
     */
    resetCustomErrorResponse(): void;
    /**
     * @stability stable
     */
    get customErrorResponseInput(): CloudfrontDistributionCustomErrorResponse[] | undefined;
    private _defaultCacheBehavior;
    /**
     * @stability stable
     */
    get defaultCacheBehavior(): CloudfrontDistributionDefaultCacheBehavior[];
    /**
     * @stability stable
     */
    set defaultCacheBehavior(value: CloudfrontDistributionDefaultCacheBehavior[]);
    /**
     * @stability stable
     */
    get defaultCacheBehaviorInput(): CloudfrontDistributionDefaultCacheBehavior[];
    private _loggingConfig?;
    /**
     * @stability stable
     */
    get loggingConfig(): CloudfrontDistributionLoggingConfig[];
    /**
     * @stability stable
     */
    set loggingConfig(value: CloudfrontDistributionLoggingConfig[]);
    /**
     * @stability stable
     */
    resetLoggingConfig(): void;
    /**
     * @stability stable
     */
    get loggingConfigInput(): CloudfrontDistributionLoggingConfig[] | undefined;
    private _orderedCacheBehavior?;
    /**
     * @stability stable
     */
    get orderedCacheBehavior(): CloudfrontDistributionOrderedCacheBehavior[];
    /**
     * @stability stable
     */
    set orderedCacheBehavior(value: CloudfrontDistributionOrderedCacheBehavior[]);
    /**
     * @stability stable
     */
    resetOrderedCacheBehavior(): void;
    /**
     * @stability stable
     */
    get orderedCacheBehaviorInput(): CloudfrontDistributionOrderedCacheBehavior[] | undefined;
    private _origin;
    /**
     * @stability stable
     */
    get origin(): CloudfrontDistributionOrigin[];
    /**
     * @stability stable
     */
    set origin(value: CloudfrontDistributionOrigin[]);
    /**
     * @stability stable
     */
    get originInput(): CloudfrontDistributionOrigin[];
    private _originGroup?;
    /**
     * @stability stable
     */
    get originGroup(): CloudfrontDistributionOriginGroup[];
    /**
     * @stability stable
     */
    set originGroup(value: CloudfrontDistributionOriginGroup[]);
    /**
     * @stability stable
     */
    resetOriginGroup(): void;
    /**
     * @stability stable
     */
    get originGroupInput(): CloudfrontDistributionOriginGroup[] | undefined;
    private _restrictions;
    /**
     * @stability stable
     */
    get restrictions(): CloudfrontDistributionRestrictions[];
    /**
     * @stability stable
     */
    set restrictions(value: CloudfrontDistributionRestrictions[]);
    /**
     * @stability stable
     */
    get restrictionsInput(): CloudfrontDistributionRestrictions[];
    private _viewerCertificate;
    /**
     * @stability stable
     */
    get viewerCertificate(): CloudfrontDistributionViewerCertificate[];
    /**
     * @stability stable
     */
    set viewerCertificate(value: CloudfrontDistributionViewerCertificate[]);
    /**
     * @stability stable
     */
    get viewerCertificateInput(): CloudfrontDistributionViewerCertificate[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
