import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly comment?: string;
    /**
     * @stability stable
     */
    readonly etag?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * cookies_config block.
     *
     * @stability stable
     */
    readonly cookiesConfig: CloudfrontOriginRequestPolicyCookiesConfig[];
    /**
     * headers_config block.
     *
     * @stability stable
     */
    readonly headersConfig: CloudfrontOriginRequestPolicyHeadersConfig[];
    /**
     * query_strings_config block.
     *
     * @stability stable
     */
    readonly queryStringsConfig: CloudfrontOriginRequestPolicyQueryStringsConfig[];
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyCookiesConfigCookies {
    /**
     * @stability stable
     */
    readonly items?: string[];
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyCookiesConfig {
    /**
     * @stability stable
     */
    readonly cookieBehavior: string;
    /**
     * cookies block.
     *
     * @stability stable
     */
    readonly cookies?: CloudfrontOriginRequestPolicyCookiesConfigCookies[];
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyHeadersConfigHeaders {
    /**
     * @stability stable
     */
    readonly items?: string[];
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyHeadersConfig {
    /**
     * @stability stable
     */
    readonly headerBehavior?: string;
    /**
     * headers block.
     *
     * @stability stable
     */
    readonly headers?: CloudfrontOriginRequestPolicyHeadersConfigHeaders[];
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings {
    /**
     * @stability stable
     */
    readonly items?: string[];
}
/**
 * @stability stable
 */
export interface CloudfrontOriginRequestPolicyQueryStringsConfig {
    /**
     * @stability stable
     */
    readonly queryStringBehavior: string;
    /**
     * query_strings block.
     *
     * @stability stable
     */
    readonly queryStrings?: CloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings[];
}
/**
 * @stability stable
 */
export declare class CloudfrontOriginRequestPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudfrontOriginRequestPolicyConfig);
    private _comment?;
    /**
     * @stability stable
     */
    get comment(): string;
    /**
     * @stability stable
     */
    set comment(value: string);
    /**
     * @stability stable
     */
    resetComment(): void;
    /**
     * @stability stable
     */
    get commentInput(): string | undefined;
    private _etag?;
    /**
     * @stability stable
     */
    get etag(): string;
    /**
     * @stability stable
     */
    set etag(value: string);
    /**
     * @stability stable
     */
    resetEtag(): void;
    /**
     * @stability stable
     */
    get etagInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _cookiesConfig;
    /**
     * @stability stable
     */
    get cookiesConfig(): CloudfrontOriginRequestPolicyCookiesConfig[];
    /**
     * @stability stable
     */
    set cookiesConfig(value: CloudfrontOriginRequestPolicyCookiesConfig[]);
    /**
     * @stability stable
     */
    get cookiesConfigInput(): CloudfrontOriginRequestPolicyCookiesConfig[];
    private _headersConfig;
    /**
     * @stability stable
     */
    get headersConfig(): CloudfrontOriginRequestPolicyHeadersConfig[];
    /**
     * @stability stable
     */
    set headersConfig(value: CloudfrontOriginRequestPolicyHeadersConfig[]);
    /**
     * @stability stable
     */
    get headersConfigInput(): CloudfrontOriginRequestPolicyHeadersConfig[];
    private _queryStringsConfig;
    /**
     * @stability stable
     */
    get queryStringsConfig(): CloudfrontOriginRequestPolicyQueryStringsConfig[];
    /**
     * @stability stable
     */
    set queryStringsConfig(value: CloudfrontOriginRequestPolicyQueryStringsConfig[]);
    /**
     * @stability stable
     */
    get queryStringsConfigInput(): CloudfrontOriginRequestPolicyQueryStringsConfig[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
