import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudfrontRealtimeLogConfigConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly fields: string[];
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly samplingRate: number;
    /**
     * endpoint block.
     *
     * @stability stable
     */
    readonly endpoint: CloudfrontRealtimeLogConfigEndpoint[];
}
/**
 * @stability stable
 */
export interface CloudfrontRealtimeLogConfigEndpointKinesisStreamConfig {
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly streamArn: string;
}
/**
 * @stability stable
 */
export interface CloudfrontRealtimeLogConfigEndpoint {
    /**
     * @stability stable
     */
    readonly streamType: string;
    /**
     * kinesis_stream_config block.
     *
     * @stability stable
     */
    readonly kinesisStreamConfig: CloudfrontRealtimeLogConfigEndpointKinesisStreamConfig[];
}
/**
 * @stability stable
 */
export declare class CloudfrontRealtimeLogConfig extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudfrontRealtimeLogConfigConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _fields;
    /**
     * @stability stable
     */
    get fields(): string[];
    /**
     * @stability stable
     */
    set fields(value: string[]);
    /**
     * @stability stable
     */
    get fieldsInput(): string[];
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _samplingRate;
    /**
     * @stability stable
     */
    get samplingRate(): number;
    /**
     * @stability stable
     */
    set samplingRate(value: number);
    /**
     * @stability stable
     */
    get samplingRateInput(): number;
    private _endpoint;
    /**
     * @stability stable
     */
    get endpoint(): CloudfrontRealtimeLogConfigEndpoint[];
    /**
     * @stability stable
     */
    set endpoint(value: CloudfrontRealtimeLogConfigEndpoint[]);
    /**
     * @stability stable
     */
    get endpointInput(): CloudfrontRealtimeLogConfigEndpoint[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
