import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudhsmV2ClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly hsmType: string;
    /**
     * @stability stable
     */
    readonly sourceBackupIdentifier?: string;
    /**
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: CloudhsmV2ClusterTimeouts;
}
/**
 * @stability stable
 */
export declare class CloudhsmV2ClusterClusterCertificates extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get awsHardwareCertificate(): string;
    /**
     * @stability stable
     */
    get clusterCertificate(): string;
    /**
     * @stability stable
     */
    get clusterCsr(): string;
    /**
     * @stability stable
     */
    get hsmCertificate(): string;
    /**
     * @stability stable
     */
    get manufacturerHardwareCertificate(): string;
}
/**
 * @stability stable
 */
export interface CloudhsmV2ClusterTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class CloudhsmV2Cluster extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudhsmV2ClusterConfig);
    /**
     * @stability stable
     */
    clusterCertificates(index: string): CloudhsmV2ClusterClusterCertificates;
    /**
     * @stability stable
     */
    get clusterId(): string;
    /**
     * @stability stable
     */
    get clusterState(): string;
    private _hsmType;
    /**
     * @stability stable
     */
    get hsmType(): string;
    /**
     * @stability stable
     */
    set hsmType(value: string);
    /**
     * @stability stable
     */
    get hsmTypeInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get securityGroupId(): string;
    private _sourceBackupIdentifier?;
    /**
     * @stability stable
     */
    get sourceBackupIdentifier(): string;
    /**
     * @stability stable
     */
    set sourceBackupIdentifier(value: string);
    /**
     * @stability stable
     */
    resetSourceBackupIdentifier(): void;
    /**
     * @stability stable
     */
    get sourceBackupIdentifierInput(): string | undefined;
    private _subnetIds;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get vpcId(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): CloudhsmV2ClusterTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: CloudhsmV2ClusterTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): CloudhsmV2ClusterTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
