import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudhsmV2HsmConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * @stability stable
     */
    readonly clusterId: string;
    /**
     * @stability stable
     */
    readonly ipAddress?: string;
    /**
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: CloudhsmV2HsmTimeouts;
}
/**
 * @stability stable
 */
export interface CloudhsmV2HsmTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export declare class CloudhsmV2Hsm extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudhsmV2HsmConfig);
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    private _clusterId;
    /**
     * @stability stable
     */
    get clusterId(): string;
    /**
     * @stability stable
     */
    set clusterId(value: string);
    /**
     * @stability stable
     */
    get clusterIdInput(): string;
    /**
     * @stability stable
     */
    get hsmEniId(): string;
    /**
     * @stability stable
     */
    get hsmId(): string;
    /**
     * @stability stable
     */
    get hsmState(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _ipAddress?;
    /**
     * @stability stable
     */
    get ipAddress(): string;
    /**
     * @stability stable
     */
    set ipAddress(value: string);
    /**
     * @stability stable
     */
    resetIpAddress(): void;
    /**
     * @stability stable
     */
    get ipAddressInput(): string | undefined;
    private _subnetId?;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    resetSubnetId(): void;
    /**
     * @stability stable
     */
    get subnetIdInput(): string | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): CloudhsmV2HsmTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: CloudhsmV2HsmTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): CloudhsmV2HsmTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
