import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudtrailConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly cloudWatchLogsGroupArn?: string;
    /**
     * @stability stable
     */
    readonly cloudWatchLogsRoleArn?: string;
    /**
     * @stability stable
     */
    readonly enableLogFileValidation?: boolean;
    /**
     * @stability stable
     */
    readonly enableLogging?: boolean;
    /**
     * @stability stable
     */
    readonly includeGlobalServiceEvents?: boolean;
    /**
     * @stability stable
     */
    readonly isMultiRegionTrail?: boolean;
    /**
     * @stability stable
     */
    readonly isOrganizationTrail?: boolean;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly s3BucketName: string;
    /**
     * @stability stable
     */
    readonly s3KeyPrefix?: string;
    /**
     * @stability stable
     */
    readonly snsTopicName?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * event_selector block.
     *
     * @stability stable
     */
    readonly eventSelector?: CloudtrailEventSelector[];
    /**
     * insight_selector block.
     *
     * @stability stable
     */
    readonly insightSelector?: CloudtrailInsightSelector[];
}
/**
 * @stability stable
 */
export interface CloudtrailEventSelectorDataResource {
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface CloudtrailEventSelector {
    /**
     * @stability stable
     */
    readonly includeManagementEvents?: boolean;
    /**
     * @stability stable
     */
    readonly readWriteType?: string;
    /**
     * data_resource block.
     *
     * @stability stable
     */
    readonly dataResource?: CloudtrailEventSelectorDataResource[];
}
/**
 * @stability stable
 */
export interface CloudtrailInsightSelector {
    /**
     * @stability stable
     */
    readonly insightType: string;
}
/**
 * @stability stable
 */
export declare class Cloudtrail extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudtrailConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _cloudWatchLogsGroupArn?;
    /**
     * @stability stable
     */
    get cloudWatchLogsGroupArn(): string;
    /**
     * @stability stable
     */
    set cloudWatchLogsGroupArn(value: string);
    /**
     * @stability stable
     */
    resetCloudWatchLogsGroupArn(): void;
    /**
     * @stability stable
     */
    get cloudWatchLogsGroupArnInput(): string | undefined;
    private _cloudWatchLogsRoleArn?;
    /**
     * @stability stable
     */
    get cloudWatchLogsRoleArn(): string;
    /**
     * @stability stable
     */
    set cloudWatchLogsRoleArn(value: string);
    /**
     * @stability stable
     */
    resetCloudWatchLogsRoleArn(): void;
    /**
     * @stability stable
     */
    get cloudWatchLogsRoleArnInput(): string | undefined;
    private _enableLogFileValidation?;
    /**
     * @stability stable
     */
    get enableLogFileValidation(): boolean;
    /**
     * @stability stable
     */
    set enableLogFileValidation(value: boolean);
    /**
     * @stability stable
     */
    resetEnableLogFileValidation(): void;
    /**
     * @stability stable
     */
    get enableLogFileValidationInput(): boolean | undefined;
    private _enableLogging?;
    /**
     * @stability stable
     */
    get enableLogging(): boolean;
    /**
     * @stability stable
     */
    set enableLogging(value: boolean);
    /**
     * @stability stable
     */
    resetEnableLogging(): void;
    /**
     * @stability stable
     */
    get enableLoggingInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get homeRegion(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _includeGlobalServiceEvents?;
    /**
     * @stability stable
     */
    get includeGlobalServiceEvents(): boolean;
    /**
     * @stability stable
     */
    set includeGlobalServiceEvents(value: boolean);
    /**
     * @stability stable
     */
    resetIncludeGlobalServiceEvents(): void;
    /**
     * @stability stable
     */
    get includeGlobalServiceEventsInput(): boolean | undefined;
    private _isMultiRegionTrail?;
    /**
     * @stability stable
     */
    get isMultiRegionTrail(): boolean;
    /**
     * @stability stable
     */
    set isMultiRegionTrail(value: boolean);
    /**
     * @stability stable
     */
    resetIsMultiRegionTrail(): void;
    /**
     * @stability stable
     */
    get isMultiRegionTrailInput(): boolean | undefined;
    private _isOrganizationTrail?;
    /**
     * @stability stable
     */
    get isOrganizationTrail(): boolean;
    /**
     * @stability stable
     */
    set isOrganizationTrail(value: boolean);
    /**
     * @stability stable
     */
    resetIsOrganizationTrail(): void;
    /**
     * @stability stable
     */
    get isOrganizationTrailInput(): boolean | undefined;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _s3BucketName;
    /**
     * @stability stable
     */
    get s3BucketName(): string;
    /**
     * @stability stable
     */
    set s3BucketName(value: string);
    /**
     * @stability stable
     */
    get s3BucketNameInput(): string;
    private _s3KeyPrefix?;
    /**
     * @stability stable
     */
    get s3KeyPrefix(): string;
    /**
     * @stability stable
     */
    set s3KeyPrefix(value: string);
    /**
     * @stability stable
     */
    resetS3KeyPrefix(): void;
    /**
     * @stability stable
     */
    get s3KeyPrefixInput(): string | undefined;
    private _snsTopicName?;
    /**
     * @stability stable
     */
    get snsTopicName(): string;
    /**
     * @stability stable
     */
    set snsTopicName(value: string);
    /**
     * @stability stable
     */
    resetSnsTopicName(): void;
    /**
     * @stability stable
     */
    get snsTopicNameInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _eventSelector?;
    /**
     * @stability stable
     */
    get eventSelector(): CloudtrailEventSelector[];
    /**
     * @stability stable
     */
    set eventSelector(value: CloudtrailEventSelector[]);
    /**
     * @stability stable
     */
    resetEventSelector(): void;
    /**
     * @stability stable
     */
    get eventSelectorInput(): CloudtrailEventSelector[] | undefined;
    private _insightSelector?;
    /**
     * @stability stable
     */
    get insightSelector(): CloudtrailInsightSelector[];
    /**
     * @stability stable
     */
    set insightSelector(value: CloudtrailInsightSelector[]);
    /**
     * @stability stable
     */
    resetInsightSelector(): void;
    /**
     * @stability stable
     */
    get insightSelectorInput(): CloudtrailInsightSelector[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
