import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudwatchCompositeAlarmConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly actionsEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly alarmActions?: string[];
    /**
     * @stability stable
     */
    readonly alarmDescription?: string;
    /**
     * @stability stable
     */
    readonly alarmName: string;
    /**
     * @stability stable
     */
    readonly alarmRule: string;
    /**
     * @stability stable
     */
    readonly insufficientDataActions?: string[];
    /**
     * @stability stable
     */
    readonly okActions?: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class CloudwatchCompositeAlarm extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudwatchCompositeAlarmConfig);
    private _actionsEnabled?;
    /**
     * @stability stable
     */
    get actionsEnabled(): boolean;
    /**
     * @stability stable
     */
    set actionsEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetActionsEnabled(): void;
    /**
     * @stability stable
     */
    get actionsEnabledInput(): boolean | undefined;
    private _alarmActions?;
    /**
     * @stability stable
     */
    get alarmActions(): string[];
    /**
     * @stability stable
     */
    set alarmActions(value: string[]);
    /**
     * @stability stable
     */
    resetAlarmActions(): void;
    /**
     * @stability stable
     */
    get alarmActionsInput(): string[] | undefined;
    private _alarmDescription?;
    /**
     * @stability stable
     */
    get alarmDescription(): string;
    /**
     * @stability stable
     */
    set alarmDescription(value: string);
    /**
     * @stability stable
     */
    resetAlarmDescription(): void;
    /**
     * @stability stable
     */
    get alarmDescriptionInput(): string | undefined;
    private _alarmName;
    /**
     * @stability stable
     */
    get alarmName(): string;
    /**
     * @stability stable
     */
    set alarmName(value: string);
    /**
     * @stability stable
     */
    get alarmNameInput(): string;
    private _alarmRule;
    /**
     * @stability stable
     */
    get alarmRule(): string;
    /**
     * @stability stable
     */
    set alarmRule(value: string);
    /**
     * @stability stable
     */
    get alarmRuleInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _insufficientDataActions?;
    /**
     * @stability stable
     */
    get insufficientDataActions(): string[];
    /**
     * @stability stable
     */
    set insufficientDataActions(value: string[]);
    /**
     * @stability stable
     */
    resetInsufficientDataActions(): void;
    /**
     * @stability stable
     */
    get insufficientDataActionsInput(): string[] | undefined;
    private _okActions?;
    /**
     * @stability stable
     */
    get okActions(): string[];
    /**
     * @stability stable
     */
    set okActions(value: string[]);
    /**
     * @stability stable
     */
    resetOkActions(): void;
    /**
     * @stability stable
     */
    get okActionsInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
