import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudwatchEventArchiveConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly eventPattern?: string;
    /**
     * @stability stable
     */
    readonly eventSourceArn: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly retentionDays?: number;
}
/**
 * @stability stable
 */
export declare class CloudwatchEventArchive extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudwatchEventArchiveConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _eventPattern?;
    /**
     * @stability stable
     */
    get eventPattern(): string;
    /**
     * @stability stable
     */
    set eventPattern(value: string);
    /**
     * @stability stable
     */
    resetEventPattern(): void;
    /**
     * @stability stable
     */
    get eventPatternInput(): string | undefined;
    private _eventSourceArn;
    /**
     * @stability stable
     */
    get eventSourceArn(): string;
    /**
     * @stability stable
     */
    set eventSourceArn(value: string);
    /**
     * @stability stable
     */
    get eventSourceArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _retentionDays?;
    /**
     * @stability stable
     */
    get retentionDays(): number;
    /**
     * @stability stable
     */
    set retentionDays(value: number);
    /**
     * @stability stable
     */
    resetRetentionDays(): void;
    /**
     * @stability stable
     */
    get retentionDaysInput(): number | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
