import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudwatchEventPermissionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly action?: string;
    /**
     * @stability stable
     */
    readonly eventBusName?: string;
    /**
     * @stability stable
     */
    readonly principal: string;
    /**
     * @stability stable
     */
    readonly statementId: string;
    /**
     * condition block.
     *
     * @stability stable
     */
    readonly condition?: CloudwatchEventPermissionCondition[];
}
/**
 * @stability stable
 */
export interface CloudwatchEventPermissionCondition {
    /**
     * @stability stable
     */
    readonly key: string;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export declare class CloudwatchEventPermission extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudwatchEventPermissionConfig);
    private _action?;
    /**
     * @stability stable
     */
    get action(): string;
    /**
     * @stability stable
     */
    set action(value: string);
    /**
     * @stability stable
     */
    resetAction(): void;
    /**
     * @stability stable
     */
    get actionInput(): string | undefined;
    private _eventBusName?;
    /**
     * @stability stable
     */
    get eventBusName(): string;
    /**
     * @stability stable
     */
    set eventBusName(value: string);
    /**
     * @stability stable
     */
    resetEventBusName(): void;
    /**
     * @stability stable
     */
    get eventBusNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _principal;
    /**
     * @stability stable
     */
    get principal(): string;
    /**
     * @stability stable
     */
    set principal(value: string);
    /**
     * @stability stable
     */
    get principalInput(): string;
    private _statementId;
    /**
     * @stability stable
     */
    get statementId(): string;
    /**
     * @stability stable
     */
    set statementId(value: string);
    /**
     * @stability stable
     */
    get statementIdInput(): string;
    private _condition?;
    /**
     * @stability stable
     */
    get condition(): CloudwatchEventPermissionCondition[];
    /**
     * @stability stable
     */
    set condition(value: CloudwatchEventPermissionCondition[]);
    /**
     * @stability stable
     */
    resetCondition(): void;
    /**
     * @stability stable
     */
    get conditionInput(): CloudwatchEventPermissionCondition[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
