import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudwatchEventTargetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly arn: string;
    /**
     * @stability stable
     */
    readonly eventBusName?: string;
    /**
     * @stability stable
     */
    readonly input?: string;
    /**
     * @stability stable
     */
    readonly inputPath?: string;
    /**
     * @stability stable
     */
    readonly roleArn?: string;
    /**
     * @stability stable
     */
    readonly rule: string;
    /**
     * @stability stable
     */
    readonly targetId?: string;
    /**
     * batch_target block.
     *
     * @stability stable
     */
    readonly batchTarget?: CloudwatchEventTargetBatchTarget[];
    /**
     * dead_letter_config block.
     *
     * @stability stable
     */
    readonly deadLetterConfig?: CloudwatchEventTargetDeadLetterConfig[];
    /**
     * ecs_target block.
     *
     * @stability stable
     */
    readonly ecsTarget?: CloudwatchEventTargetEcsTarget[];
    /**
     * input_transformer block.
     *
     * @stability stable
     */
    readonly inputTransformer?: CloudwatchEventTargetInputTransformer[];
    /**
     * kinesis_target block.
     *
     * @stability stable
     */
    readonly kinesisTarget?: CloudwatchEventTargetKinesisTarget[];
    /**
     * retry_policy block.
     *
     * @stability stable
     */
    readonly retryPolicy?: CloudwatchEventTargetRetryPolicy[];
    /**
     * run_command_targets block.
     *
     * @stability stable
     */
    readonly runCommandTargets?: CloudwatchEventTargetRunCommandTargets[];
    /**
     * sqs_target block.
     *
     * @stability stable
     */
    readonly sqsTarget?: CloudwatchEventTargetSqsTarget[];
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetBatchTarget {
    /**
     * @stability stable
     */
    readonly arraySize?: number;
    /**
     * @stability stable
     */
    readonly jobAttempts?: number;
    /**
     * @stability stable
     */
    readonly jobDefinition: string;
    /**
     * @stability stable
     */
    readonly jobName: string;
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetDeadLetterConfig {
    /**
     * @stability stable
     */
    readonly arn?: string;
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetEcsTargetNetworkConfiguration {
    /**
     * @stability stable
     */
    readonly assignPublicIp?: boolean;
    /**
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * @stability stable
     */
    readonly subnets: string[];
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetEcsTarget {
    /**
     * @stability stable
     */
    readonly group?: string;
    /**
     * @stability stable
     */
    readonly launchType?: string;
    /**
     * @stability stable
     */
    readonly platformVersion?: string;
    /**
     * @stability stable
     */
    readonly taskCount?: number;
    /**
     * @stability stable
     */
    readonly taskDefinitionArn: string;
    /**
     * network_configuration block.
     *
     * @stability stable
     */
    readonly networkConfiguration?: CloudwatchEventTargetEcsTargetNetworkConfiguration[];
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetInputTransformer {
    /**
     * @stability stable
     */
    readonly inputPaths?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly inputTemplate: string;
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetKinesisTarget {
    /**
     * @stability stable
     */
    readonly partitionKeyPath?: string;
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetRetryPolicy {
    /**
     * @stability stable
     */
    readonly maximumEventAgeInSeconds?: number;
    /**
     * @stability stable
     */
    readonly maximumRetryAttempts?: number;
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetRunCommandTargets {
    /**
     * @stability stable
     */
    readonly key: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface CloudwatchEventTargetSqsTarget {
    /**
     * @stability stable
     */
    readonly messageGroupId?: string;
}
/**
 * @stability stable
 */
export declare class CloudwatchEventTarget extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudwatchEventTargetConfig);
    private _arn;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    set arn(value: string);
    /**
     * @stability stable
     */
    get arnInput(): string;
    private _eventBusName?;
    /**
     * @stability stable
     */
    get eventBusName(): string;
    /**
     * @stability stable
     */
    set eventBusName(value: string);
    /**
     * @stability stable
     */
    resetEventBusName(): void;
    /**
     * @stability stable
     */
    get eventBusNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _input?;
    /**
     * @stability stable
     */
    get input(): string;
    /**
     * @stability stable
     */
    set input(value: string);
    /**
     * @stability stable
     */
    resetInput(): void;
    /**
     * @stability stable
     */
    get inputInput(): string | undefined;
    private _inputPath?;
    /**
     * @stability stable
     */
    get inputPath(): string;
    /**
     * @stability stable
     */
    set inputPath(value: string);
    /**
     * @stability stable
     */
    resetInputPath(): void;
    /**
     * @stability stable
     */
    get inputPathInput(): string | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    resetRoleArn(): void;
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _rule;
    /**
     * @stability stable
     */
    get rule(): string;
    /**
     * @stability stable
     */
    set rule(value: string);
    /**
     * @stability stable
     */
    get ruleInput(): string;
    private _targetId?;
    /**
     * @stability stable
     */
    get targetId(): string;
    /**
     * @stability stable
     */
    set targetId(value: string);
    /**
     * @stability stable
     */
    resetTargetId(): void;
    /**
     * @stability stable
     */
    get targetIdInput(): string | undefined;
    private _batchTarget?;
    /**
     * @stability stable
     */
    get batchTarget(): CloudwatchEventTargetBatchTarget[];
    /**
     * @stability stable
     */
    set batchTarget(value: CloudwatchEventTargetBatchTarget[]);
    /**
     * @stability stable
     */
    resetBatchTarget(): void;
    /**
     * @stability stable
     */
    get batchTargetInput(): CloudwatchEventTargetBatchTarget[] | undefined;
    private _deadLetterConfig?;
    /**
     * @stability stable
     */
    get deadLetterConfig(): CloudwatchEventTargetDeadLetterConfig[];
    /**
     * @stability stable
     */
    set deadLetterConfig(value: CloudwatchEventTargetDeadLetterConfig[]);
    /**
     * @stability stable
     */
    resetDeadLetterConfig(): void;
    /**
     * @stability stable
     */
    get deadLetterConfigInput(): CloudwatchEventTargetDeadLetterConfig[] | undefined;
    private _ecsTarget?;
    /**
     * @stability stable
     */
    get ecsTarget(): CloudwatchEventTargetEcsTarget[];
    /**
     * @stability stable
     */
    set ecsTarget(value: CloudwatchEventTargetEcsTarget[]);
    /**
     * @stability stable
     */
    resetEcsTarget(): void;
    /**
     * @stability stable
     */
    get ecsTargetInput(): CloudwatchEventTargetEcsTarget[] | undefined;
    private _inputTransformer?;
    /**
     * @stability stable
     */
    get inputTransformer(): CloudwatchEventTargetInputTransformer[];
    /**
     * @stability stable
     */
    set inputTransformer(value: CloudwatchEventTargetInputTransformer[]);
    /**
     * @stability stable
     */
    resetInputTransformer(): void;
    /**
     * @stability stable
     */
    get inputTransformerInput(): CloudwatchEventTargetInputTransformer[] | undefined;
    private _kinesisTarget?;
    /**
     * @stability stable
     */
    get kinesisTarget(): CloudwatchEventTargetKinesisTarget[];
    /**
     * @stability stable
     */
    set kinesisTarget(value: CloudwatchEventTargetKinesisTarget[]);
    /**
     * @stability stable
     */
    resetKinesisTarget(): void;
    /**
     * @stability stable
     */
    get kinesisTargetInput(): CloudwatchEventTargetKinesisTarget[] | undefined;
    private _retryPolicy?;
    /**
     * @stability stable
     */
    get retryPolicy(): CloudwatchEventTargetRetryPolicy[];
    /**
     * @stability stable
     */
    set retryPolicy(value: CloudwatchEventTargetRetryPolicy[]);
    /**
     * @stability stable
     */
    resetRetryPolicy(): void;
    /**
     * @stability stable
     */
    get retryPolicyInput(): CloudwatchEventTargetRetryPolicy[] | undefined;
    private _runCommandTargets?;
    /**
     * @stability stable
     */
    get runCommandTargets(): CloudwatchEventTargetRunCommandTargets[];
    /**
     * @stability stable
     */
    set runCommandTargets(value: CloudwatchEventTargetRunCommandTargets[]);
    /**
     * @stability stable
     */
    resetRunCommandTargets(): void;
    /**
     * @stability stable
     */
    get runCommandTargetsInput(): CloudwatchEventTargetRunCommandTargets[] | undefined;
    private _sqsTarget?;
    /**
     * @stability stable
     */
    get sqsTarget(): CloudwatchEventTargetSqsTarget[];
    /**
     * @stability stable
     */
    set sqsTarget(value: CloudwatchEventTargetSqsTarget[]);
    /**
     * @stability stable
     */
    resetSqsTarget(): void;
    /**
     * @stability stable
     */
    get sqsTargetInput(): CloudwatchEventTargetSqsTarget[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
