import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudwatchLogMetricFilterConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly logGroupName: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly pattern: string;
    /**
     * metric_transformation block.
     *
     * @stability stable
     */
    readonly metricTransformation: CloudwatchLogMetricFilterMetricTransformation[];
}
/**
 * @stability stable
 */
export interface CloudwatchLogMetricFilterMetricTransformation {
    /**
     * @stability stable
     */
    readonly defaultValue?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly namespace: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export declare class CloudwatchLogMetricFilter extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudwatchLogMetricFilterConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _logGroupName;
    /**
     * @stability stable
     */
    get logGroupName(): string;
    /**
     * @stability stable
     */
    set logGroupName(value: string);
    /**
     * @stability stable
     */
    get logGroupNameInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _pattern;
    /**
     * @stability stable
     */
    get pattern(): string;
    /**
     * @stability stable
     */
    set pattern(value: string);
    /**
     * @stability stable
     */
    get patternInput(): string;
    private _metricTransformation;
    /**
     * @stability stable
     */
    get metricTransformation(): CloudwatchLogMetricFilterMetricTransformation[];
    /**
     * @stability stable
     */
    set metricTransformation(value: CloudwatchLogMetricFilterMetricTransformation[]);
    /**
     * @stability stable
     */
    get metricTransformationInput(): CloudwatchLogMetricFilterMetricTransformation[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
