import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudwatchLogSubscriptionFilterConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly destinationArn: string;
    /**
     * @stability stable
     */
    readonly distribution?: string;
    /**
     * @stability stable
     */
    readonly filterPattern: string;
    /**
     * @stability stable
     */
    readonly logGroupName: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly roleArn?: string;
}
/**
 * @stability stable
 */
export declare class CloudwatchLogSubscriptionFilter extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudwatchLogSubscriptionFilterConfig);
    private _destinationArn;
    /**
     * @stability stable
     */
    get destinationArn(): string;
    /**
     * @stability stable
     */
    set destinationArn(value: string);
    /**
     * @stability stable
     */
    get destinationArnInput(): string;
    private _distribution?;
    /**
     * @stability stable
     */
    get distribution(): string;
    /**
     * @stability stable
     */
    set distribution(value: string);
    /**
     * @stability stable
     */
    resetDistribution(): void;
    /**
     * @stability stable
     */
    get distributionInput(): string | undefined;
    private _filterPattern;
    /**
     * @stability stable
     */
    get filterPattern(): string;
    /**
     * @stability stable
     */
    set filterPattern(value: string);
    /**
     * @stability stable
     */
    get filterPatternInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _logGroupName;
    /**
     * @stability stable
     */
    get logGroupName(): string;
    /**
     * @stability stable
     */
    set logGroupName(value: string);
    /**
     * @stability stable
     */
    get logGroupNameInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    resetRoleArn(): void;
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
