import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudwatchMetricAlarmConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly actionsEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly alarmActions?: string[];
    /**
     * @stability stable
     */
    readonly alarmDescription?: string;
    /**
     * @stability stable
     */
    readonly alarmName: string;
    /**
     * @stability stable
     */
    readonly comparisonOperator: string;
    /**
     * @stability stable
     */
    readonly datapointsToAlarm?: number;
    /**
     * @stability stable
     */
    readonly dimensions?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly evaluateLowSampleCountPercentiles?: string;
    /**
     * @stability stable
     */
    readonly evaluationPeriods: number;
    /**
     * @stability stable
     */
    readonly extendedStatistic?: string;
    /**
     * @stability stable
     */
    readonly insufficientDataActions?: string[];
    /**
     * @stability stable
     */
    readonly metricName?: string;
    /**
     * @stability stable
     */
    readonly namespace?: string;
    /**
     * @stability stable
     */
    readonly okActions?: string[];
    /**
     * @stability stable
     */
    readonly period?: number;
    /**
     * @stability stable
     */
    readonly statistic?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly threshold?: number;
    /**
     * @stability stable
     */
    readonly thresholdMetricId?: string;
    /**
     * @stability stable
     */
    readonly treatMissingData?: string;
    /**
     * @stability stable
     */
    readonly unit?: string;
    /**
     * metric_query block.
     *
     * @stability stable
     */
    readonly metricQuery?: CloudwatchMetricAlarmMetricQuery[];
}
/**
 * @stability stable
 */
export interface CloudwatchMetricAlarmMetricQueryMetric {
    /**
     * @stability stable
     */
    readonly dimensions?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly metricName: string;
    /**
     * @stability stable
     */
    readonly namespace?: string;
    /**
     * @stability stable
     */
    readonly period: number;
    /**
     * @stability stable
     */
    readonly stat: string;
    /**
     * @stability stable
     */
    readonly unit?: string;
}
/**
 * @stability stable
 */
export interface CloudwatchMetricAlarmMetricQuery {
    /**
     * @stability stable
     */
    readonly expression?: string;
    /**
     * @stability stable
     */
    readonly id: string;
    /**
     * @stability stable
     */
    readonly label?: string;
    /**
     * @stability stable
     */
    readonly returnData?: boolean;
    /**
     * metric block.
     *
     * @stability stable
     */
    readonly metric?: CloudwatchMetricAlarmMetricQueryMetric[];
}
/**
 * @stability stable
 */
export declare class CloudwatchMetricAlarm extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudwatchMetricAlarmConfig);
    private _actionsEnabled?;
    /**
     * @stability stable
     */
    get actionsEnabled(): boolean;
    /**
     * @stability stable
     */
    set actionsEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetActionsEnabled(): void;
    /**
     * @stability stable
     */
    get actionsEnabledInput(): boolean | undefined;
    private _alarmActions?;
    /**
     * @stability stable
     */
    get alarmActions(): string[];
    /**
     * @stability stable
     */
    set alarmActions(value: string[]);
    /**
     * @stability stable
     */
    resetAlarmActions(): void;
    /**
     * @stability stable
     */
    get alarmActionsInput(): string[] | undefined;
    private _alarmDescription?;
    /**
     * @stability stable
     */
    get alarmDescription(): string;
    /**
     * @stability stable
     */
    set alarmDescription(value: string);
    /**
     * @stability stable
     */
    resetAlarmDescription(): void;
    /**
     * @stability stable
     */
    get alarmDescriptionInput(): string | undefined;
    private _alarmName;
    /**
     * @stability stable
     */
    get alarmName(): string;
    /**
     * @stability stable
     */
    set alarmName(value: string);
    /**
     * @stability stable
     */
    get alarmNameInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _comparisonOperator;
    /**
     * @stability stable
     */
    get comparisonOperator(): string;
    /**
     * @stability stable
     */
    set comparisonOperator(value: string);
    /**
     * @stability stable
     */
    get comparisonOperatorInput(): string;
    private _datapointsToAlarm?;
    /**
     * @stability stable
     */
    get datapointsToAlarm(): number;
    /**
     * @stability stable
     */
    set datapointsToAlarm(value: number);
    /**
     * @stability stable
     */
    resetDatapointsToAlarm(): void;
    /**
     * @stability stable
     */
    get datapointsToAlarmInput(): number | undefined;
    private _dimensions?;
    /**
     * @stability stable
     */
    get dimensions(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set dimensions(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetDimensions(): void;
    /**
     * @stability stable
     */
    get dimensionsInput(): {
        [key: string]: string;
    } | undefined;
    private _evaluateLowSampleCountPercentiles?;
    /**
     * @stability stable
     */
    get evaluateLowSampleCountPercentiles(): string;
    /**
     * @stability stable
     */
    set evaluateLowSampleCountPercentiles(value: string);
    /**
     * @stability stable
     */
    resetEvaluateLowSampleCountPercentiles(): void;
    /**
     * @stability stable
     */
    get evaluateLowSampleCountPercentilesInput(): string | undefined;
    private _evaluationPeriods;
    /**
     * @stability stable
     */
    get evaluationPeriods(): number;
    /**
     * @stability stable
     */
    set evaluationPeriods(value: number);
    /**
     * @stability stable
     */
    get evaluationPeriodsInput(): number;
    private _extendedStatistic?;
    /**
     * @stability stable
     */
    get extendedStatistic(): string;
    /**
     * @stability stable
     */
    set extendedStatistic(value: string);
    /**
     * @stability stable
     */
    resetExtendedStatistic(): void;
    /**
     * @stability stable
     */
    get extendedStatisticInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _insufficientDataActions?;
    /**
     * @stability stable
     */
    get insufficientDataActions(): string[];
    /**
     * @stability stable
     */
    set insufficientDataActions(value: string[]);
    /**
     * @stability stable
     */
    resetInsufficientDataActions(): void;
    /**
     * @stability stable
     */
    get insufficientDataActionsInput(): string[] | undefined;
    private _metricName?;
    /**
     * @stability stable
     */
    get metricName(): string;
    /**
     * @stability stable
     */
    set metricName(value: string);
    /**
     * @stability stable
     */
    resetMetricName(): void;
    /**
     * @stability stable
     */
    get metricNameInput(): string | undefined;
    private _namespace?;
    /**
     * @stability stable
     */
    get namespace(): string;
    /**
     * @stability stable
     */
    set namespace(value: string);
    /**
     * @stability stable
     */
    resetNamespace(): void;
    /**
     * @stability stable
     */
    get namespaceInput(): string | undefined;
    private _okActions?;
    /**
     * @stability stable
     */
    get okActions(): string[];
    /**
     * @stability stable
     */
    set okActions(value: string[]);
    /**
     * @stability stable
     */
    resetOkActions(): void;
    /**
     * @stability stable
     */
    get okActionsInput(): string[] | undefined;
    private _period?;
    /**
     * @stability stable
     */
    get period(): number;
    /**
     * @stability stable
     */
    set period(value: number);
    /**
     * @stability stable
     */
    resetPeriod(): void;
    /**
     * @stability stable
     */
    get periodInput(): number | undefined;
    private _statistic?;
    /**
     * @stability stable
     */
    get statistic(): string;
    /**
     * @stability stable
     */
    set statistic(value: string);
    /**
     * @stability stable
     */
    resetStatistic(): void;
    /**
     * @stability stable
     */
    get statisticInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _threshold?;
    /**
     * @stability stable
     */
    get threshold(): number;
    /**
     * @stability stable
     */
    set threshold(value: number);
    /**
     * @stability stable
     */
    resetThreshold(): void;
    /**
     * @stability stable
     */
    get thresholdInput(): number | undefined;
    private _thresholdMetricId?;
    /**
     * @stability stable
     */
    get thresholdMetricId(): string;
    /**
     * @stability stable
     */
    set thresholdMetricId(value: string);
    /**
     * @stability stable
     */
    resetThresholdMetricId(): void;
    /**
     * @stability stable
     */
    get thresholdMetricIdInput(): string | undefined;
    private _treatMissingData?;
    /**
     * @stability stable
     */
    get treatMissingData(): string;
    /**
     * @stability stable
     */
    set treatMissingData(value: string);
    /**
     * @stability stable
     */
    resetTreatMissingData(): void;
    /**
     * @stability stable
     */
    get treatMissingDataInput(): string | undefined;
    private _unit?;
    /**
     * @stability stable
     */
    get unit(): string;
    /**
     * @stability stable
     */
    set unit(value: string);
    /**
     * @stability stable
     */
    resetUnit(): void;
    /**
     * @stability stable
     */
    get unitInput(): string | undefined;
    private _metricQuery?;
    /**
     * @stability stable
     */
    get metricQuery(): CloudwatchMetricAlarmMetricQuery[];
    /**
     * @stability stable
     */
    set metricQuery(value: CloudwatchMetricAlarmMetricQuery[]);
    /**
     * @stability stable
     */
    resetMetricQuery(): void;
    /**
     * @stability stable
     */
    get metricQueryInput(): CloudwatchMetricAlarmMetricQuery[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
