import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodeartifactRepositoryPermissionsPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly domain: string;
    /**
     * @stability stable
     */
    readonly domainOwner?: string;
    /**
     * @stability stable
     */
    readonly policyDocument: string;
    /**
     * @stability stable
     */
    readonly policyRevision?: string;
    /**
     * @stability stable
     */
    readonly repository: string;
}
/**
 * @stability stable
 */
export declare class CodeartifactRepositoryPermissionsPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodeartifactRepositoryPermissionsPolicyConfig);
    private _domain;
    /**
     * @stability stable
     */
    get domain(): string;
    /**
     * @stability stable
     */
    set domain(value: string);
    /**
     * @stability stable
     */
    get domainInput(): string;
    private _domainOwner?;
    /**
     * @stability stable
     */
    get domainOwner(): string;
    /**
     * @stability stable
     */
    set domainOwner(value: string);
    /**
     * @stability stable
     */
    resetDomainOwner(): void;
    /**
     * @stability stable
     */
    get domainOwnerInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _policyDocument;
    /**
     * @stability stable
     */
    get policyDocument(): string;
    /**
     * @stability stable
     */
    set policyDocument(value: string);
    /**
     * @stability stable
     */
    get policyDocumentInput(): string;
    private _policyRevision?;
    /**
     * @stability stable
     */
    get policyRevision(): string;
    /**
     * @stability stable
     */
    set policyRevision(value: string);
    /**
     * @stability stable
     */
    resetPolicyRevision(): void;
    /**
     * @stability stable
     */
    get policyRevisionInput(): string | undefined;
    private _repository;
    /**
     * @stability stable
     */
    get repository(): string;
    /**
     * @stability stable
     */
    set repository(value: string);
    /**
     * @stability stable
     */
    get repositoryInput(): string;
    /**
     * @stability stable
     */
    get resourceArn(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
