import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodeartifactRepositoryConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly domain: string;
    /**
     * @stability stable
     */
    readonly domainOwner?: string;
    /**
     * @stability stable
     */
    readonly repository: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * external_connections block.
     *
     * @stability stable
     */
    readonly externalConnections?: CodeartifactRepositoryExternalConnections[];
    /**
     * upstream block.
     *
     * @stability stable
     */
    readonly upstream?: CodeartifactRepositoryUpstream[];
}
/**
 * @stability stable
 */
export interface CodeartifactRepositoryExternalConnections {
    /**
     * @stability stable
     */
    readonly externalConnectionName: string;
}
/**
 * @stability stable
 */
export interface CodeartifactRepositoryUpstream {
    /**
     * @stability stable
     */
    readonly repositoryName: string;
}
/**
 * @stability stable
 */
export declare class CodeartifactRepository extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodeartifactRepositoryConfig);
    /**
     * @stability stable
     */
    get administratorAccount(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _domain;
    /**
     * @stability stable
     */
    get domain(): string;
    /**
     * @stability stable
     */
    set domain(value: string);
    /**
     * @stability stable
     */
    get domainInput(): string;
    private _domainOwner?;
    /**
     * @stability stable
     */
    get domainOwner(): string;
    /**
     * @stability stable
     */
    set domainOwner(value: string);
    /**
     * @stability stable
     */
    resetDomainOwner(): void;
    /**
     * @stability stable
     */
    get domainOwnerInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _repository;
    /**
     * @stability stable
     */
    get repository(): string;
    /**
     * @stability stable
     */
    set repository(value: string);
    /**
     * @stability stable
     */
    get repositoryInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _externalConnections?;
    /**
     * @stability stable
     */
    get externalConnections(): CodeartifactRepositoryExternalConnections[];
    /**
     * @stability stable
     */
    set externalConnections(value: CodeartifactRepositoryExternalConnections[]);
    /**
     * @stability stable
     */
    resetExternalConnections(): void;
    /**
     * @stability stable
     */
    get externalConnectionsInput(): CodeartifactRepositoryExternalConnections[] | undefined;
    private _upstream?;
    /**
     * @stability stable
     */
    get upstream(): CodeartifactRepositoryUpstream[];
    /**
     * @stability stable
     */
    set upstream(value: CodeartifactRepositoryUpstream[]);
    /**
     * @stability stable
     */
    resetUpstream(): void;
    /**
     * @stability stable
     */
    get upstreamInput(): CodeartifactRepositoryUpstream[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
