import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodebuildReportGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly deleteReports?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * export_config block.
     *
     * @stability stable
     */
    readonly exportConfig: CodebuildReportGroupExportConfig[];
}
/**
 * @stability stable
 */
export interface CodebuildReportGroupExportConfigS3Destination {
    /**
     * @stability stable
     */
    readonly bucket: string;
    /**
     * @stability stable
     */
    readonly encryptionDisabled?: boolean;
    /**
     * @stability stable
     */
    readonly encryptionKey: string;
    /**
     * @stability stable
     */
    readonly packaging?: string;
    /**
     * @stability stable
     */
    readonly path?: string;
}
/**
 * @stability stable
 */
export interface CodebuildReportGroupExportConfig {
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * s3_destination block.
     *
     * @stability stable
     */
    readonly s3Destination?: CodebuildReportGroupExportConfigS3Destination[];
}
/**
 * @stability stable
 */
export declare class CodebuildReportGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodebuildReportGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get created(): string;
    private _deleteReports?;
    /**
     * @stability stable
     */
    get deleteReports(): boolean;
    /**
     * @stability stable
     */
    set deleteReports(value: boolean);
    /**
     * @stability stable
     */
    resetDeleteReports(): void;
    /**
     * @stability stable
     */
    get deleteReportsInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    private _exportConfig;
    /**
     * @stability stable
     */
    get exportConfig(): CodebuildReportGroupExportConfig[];
    /**
     * @stability stable
     */
    set exportConfig(value: CodebuildReportGroupExportConfig[]);
    /**
     * @stability stable
     */
    get exportConfigInput(): CodebuildReportGroupExportConfig[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
