import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodebuildSourceCredentialConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly authType: string;
    /**
     * @stability stable
     */
    readonly serverType: string;
    /**
     * @stability stable
     */
    readonly token: string;
    /**
     * @stability stable
     */
    readonly userName?: string;
}
/**
 * @stability stable
 */
export declare class CodebuildSourceCredential extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodebuildSourceCredentialConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _authType;
    /**
     * @stability stable
     */
    get authType(): string;
    /**
     * @stability stable
     */
    set authType(value: string);
    /**
     * @stability stable
     */
    get authTypeInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _serverType;
    /**
     * @stability stable
     */
    get serverType(): string;
    /**
     * @stability stable
     */
    set serverType(value: string);
    /**
     * @stability stable
     */
    get serverTypeInput(): string;
    private _token;
    /**
     * @stability stable
     */
    get token(): string;
    /**
     * @stability stable
     */
    set token(value: string);
    /**
     * @stability stable
     */
    get tokenInput(): string;
    private _userName?;
    /**
     * @stability stable
     */
    get userName(): string;
    /**
     * @stability stable
     */
    set userName(value: string);
    /**
     * @stability stable
     */
    resetUserName(): void;
    /**
     * @stability stable
     */
    get userNameInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
