import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodebuildWebhookConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly branchFilter?: string;
    /**
     * @stability stable
     */
    readonly projectName: string;
    /**
     * filter_group block.
     *
     * @stability stable
     */
    readonly filterGroup?: CodebuildWebhookFilterGroup[];
}
/**
 * @stability stable
 */
export interface CodebuildWebhookFilterGroupFilter {
    /**
     * @stability stable
     */
    readonly excludeMatchedPattern?: boolean;
    /**
     * @stability stable
     */
    readonly pattern: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface CodebuildWebhookFilterGroup {
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: CodebuildWebhookFilterGroupFilter[];
}
/**
 * @stability stable
 */
export declare class CodebuildWebhook extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodebuildWebhookConfig);
    private _branchFilter?;
    /**
     * @stability stable
     */
    get branchFilter(): string;
    /**
     * @stability stable
     */
    set branchFilter(value: string);
    /**
     * @stability stable
     */
    resetBranchFilter(): void;
    /**
     * @stability stable
     */
    get branchFilterInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get payloadUrl(): string;
    private _projectName;
    /**
     * @stability stable
     */
    get projectName(): string;
    /**
     * @stability stable
     */
    set projectName(value: string);
    /**
     * @stability stable
     */
    get projectNameInput(): string;
    /**
     * @stability stable
     */
    get secret(): string;
    /**
     * @stability stable
     */
    get url(): string;
    private _filterGroup?;
    /**
     * @stability stable
     */
    get filterGroup(): CodebuildWebhookFilterGroup[];
    /**
     * @stability stable
     */
    set filterGroup(value: CodebuildWebhookFilterGroup[]);
    /**
     * @stability stable
     */
    resetFilterGroup(): void;
    /**
     * @stability stable
     */
    get filterGroupInput(): CodebuildWebhookFilterGroup[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
