import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodecommitTriggerConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly repositoryName: string;
    /**
     * trigger block.
     *
     * @stability stable
     */
    readonly trigger: CodecommitTriggerTrigger[];
}
/**
 * @stability stable
 */
export interface CodecommitTriggerTrigger {
    /**
     * @stability stable
     */
    readonly branches?: string[];
    /**
     * @stability stable
     */
    readonly customData?: string;
    /**
     * @stability stable
     */
    readonly destinationArn: string;
    /**
     * @stability stable
     */
    readonly events: string[];
    /**
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export declare class CodecommitTrigger extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodecommitTriggerConfig);
    /**
     * @stability stable
     */
    get configurationId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _repositoryName;
    /**
     * @stability stable
     */
    get repositoryName(): string;
    /**
     * @stability stable
     */
    set repositoryName(value: string);
    /**
     * @stability stable
     */
    get repositoryNameInput(): string;
    private _trigger;
    /**
     * @stability stable
     */
    get trigger(): CodecommitTriggerTrigger[];
    /**
     * @stability stable
     */
    set trigger(value: CodecommitTriggerTrigger[]);
    /**
     * @stability stable
     */
    get triggerInput(): CodecommitTriggerTrigger[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
