import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodedeployDeploymentConfigConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly computePlatform?: string;
    /**
     * @stability stable
     */
    readonly deploymentConfigName: string;
    /**
     * minimum_healthy_hosts block.
     *
     * @stability stable
     */
    readonly minimumHealthyHosts?: CodedeployDeploymentConfigMinimumHealthyHosts[];
    /**
     * traffic_routing_config block.
     *
     * @stability stable
     */
    readonly trafficRoutingConfig?: CodedeployDeploymentConfigTrafficRoutingConfig[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentConfigMinimumHealthyHosts {
    /**
     * @stability stable
     */
    readonly type?: string;
    /**
     * @stability stable
     */
    readonly value?: number;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentConfigTrafficRoutingConfigTimeBasedCanary {
    /**
     * @stability stable
     */
    readonly interval?: number;
    /**
     * @stability stable
     */
    readonly percentage?: number;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentConfigTrafficRoutingConfigTimeBasedLinear {
    /**
     * @stability stable
     */
    readonly interval?: number;
    /**
     * @stability stable
     */
    readonly percentage?: number;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentConfigTrafficRoutingConfig {
    /**
     * @stability stable
     */
    readonly type?: string;
    /**
     * time_based_canary block.
     *
     * @stability stable
     */
    readonly timeBasedCanary?: CodedeployDeploymentConfigTrafficRoutingConfigTimeBasedCanary[];
    /**
     * time_based_linear block.
     *
     * @stability stable
     */
    readonly timeBasedLinear?: CodedeployDeploymentConfigTrafficRoutingConfigTimeBasedLinear[];
}
/**
 * @stability stable
 */
export declare class CodedeployDeploymentConfig extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodedeployDeploymentConfigConfig);
    private _computePlatform?;
    /**
     * @stability stable
     */
    get computePlatform(): string;
    /**
     * @stability stable
     */
    set computePlatform(value: string);
    /**
     * @stability stable
     */
    resetComputePlatform(): void;
    /**
     * @stability stable
     */
    get computePlatformInput(): string | undefined;
    /**
     * @stability stable
     */
    get deploymentConfigId(): string;
    private _deploymentConfigName;
    /**
     * @stability stable
     */
    get deploymentConfigName(): string;
    /**
     * @stability stable
     */
    set deploymentConfigName(value: string);
    /**
     * @stability stable
     */
    get deploymentConfigNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _minimumHealthyHosts?;
    /**
     * @stability stable
     */
    get minimumHealthyHosts(): CodedeployDeploymentConfigMinimumHealthyHosts[];
    /**
     * @stability stable
     */
    set minimumHealthyHosts(value: CodedeployDeploymentConfigMinimumHealthyHosts[]);
    /**
     * @stability stable
     */
    resetMinimumHealthyHosts(): void;
    /**
     * @stability stable
     */
    get minimumHealthyHostsInput(): CodedeployDeploymentConfigMinimumHealthyHosts[] | undefined;
    private _trafficRoutingConfig?;
    /**
     * @stability stable
     */
    get trafficRoutingConfig(): CodedeployDeploymentConfigTrafficRoutingConfig[];
    /**
     * @stability stable
     */
    set trafficRoutingConfig(value: CodedeployDeploymentConfigTrafficRoutingConfig[]);
    /**
     * @stability stable
     */
    resetTrafficRoutingConfig(): void;
    /**
     * @stability stable
     */
    get trafficRoutingConfigInput(): CodedeployDeploymentConfigTrafficRoutingConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
