import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly appName: string;
    /**
     * @stability stable
     */
    readonly autoscalingGroups?: string[];
    /**
     * @stability stable
     */
    readonly deploymentConfigName?: string;
    /**
     * @stability stable
     */
    readonly deploymentGroupName: string;
    /**
     * @stability stable
     */
    readonly serviceRoleArn: string;
    /**
     * alarm_configuration block.
     *
     * @stability stable
     */
    readonly alarmConfiguration?: CodedeployDeploymentGroupAlarmConfiguration[];
    /**
     * auto_rollback_configuration block.
     *
     * @stability stable
     */
    readonly autoRollbackConfiguration?: CodedeployDeploymentGroupAutoRollbackConfiguration[];
    /**
     * blue_green_deployment_config block.
     *
     * @stability stable
     */
    readonly blueGreenDeploymentConfig?: CodedeployDeploymentGroupBlueGreenDeploymentConfig[];
    /**
     * deployment_style block.
     *
     * @stability stable
     */
    readonly deploymentStyle?: CodedeployDeploymentGroupDeploymentStyle[];
    /**
     * ec2_tag_filter block.
     *
     * @stability stable
     */
    readonly ec2TagFilter?: CodedeployDeploymentGroupEc2TagFilter[];
    /**
     * ec2_tag_set block.
     *
     * @stability stable
     */
    readonly ec2TagSet?: CodedeployDeploymentGroupEc2TagSet[];
    /**
     * ecs_service block.
     *
     * @stability stable
     */
    readonly ecsService?: CodedeployDeploymentGroupEcsService[];
    /**
     * load_balancer_info block.
     *
     * @stability stable
     */
    readonly loadBalancerInfo?: CodedeployDeploymentGroupLoadBalancerInfo[];
    /**
     * on_premises_instance_tag_filter block.
     *
     * @stability stable
     */
    readonly onPremisesInstanceTagFilter?: CodedeployDeploymentGroupOnPremisesInstanceTagFilter[];
    /**
     * trigger_configuration block.
     *
     * @stability stable
     */
    readonly triggerConfiguration?: CodedeployDeploymentGroupTriggerConfiguration[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupAlarmConfiguration {
    /**
     * @stability stable
     */
    readonly alarms?: string[];
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly ignorePollAlarmFailure?: boolean;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupAutoRollbackConfiguration {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly events?: string[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupBlueGreenDeploymentConfigDeploymentReadyOption {
    /**
     * @stability stable
     */
    readonly actionOnTimeout?: string;
    /**
     * @stability stable
     */
    readonly waitTimeInMinutes?: number;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupBlueGreenDeploymentConfigGreenFleetProvisioningOption {
    /**
     * @stability stable
     */
    readonly action?: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupBlueGreenDeploymentConfigTerminateBlueInstancesOnDeploymentSuccess {
    /**
     * @stability stable
     */
    readonly action?: string;
    /**
     * @stability stable
     */
    readonly terminationWaitTimeInMinutes?: number;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupBlueGreenDeploymentConfig {
    /**
     * deployment_ready_option block.
     *
     * @stability stable
     */
    readonly deploymentReadyOption?: CodedeployDeploymentGroupBlueGreenDeploymentConfigDeploymentReadyOption[];
    /**
     * green_fleet_provisioning_option block.
     *
     * @stability stable
     */
    readonly greenFleetProvisioningOption?: CodedeployDeploymentGroupBlueGreenDeploymentConfigGreenFleetProvisioningOption[];
    /**
     * terminate_blue_instances_on_deployment_success block.
     *
     * @stability stable
     */
    readonly terminateBlueInstancesOnDeploymentSuccess?: CodedeployDeploymentGroupBlueGreenDeploymentConfigTerminateBlueInstancesOnDeploymentSuccess[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupDeploymentStyle {
    /**
     * @stability stable
     */
    readonly deploymentOption?: string;
    /**
     * @stability stable
     */
    readonly deploymentType?: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupEc2TagFilter {
    /**
     * @stability stable
     */
    readonly key?: string;
    /**
     * @stability stable
     */
    readonly type?: string;
    /**
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupEc2TagSetEc2TagFilter {
    /**
     * @stability stable
     */
    readonly key?: string;
    /**
     * @stability stable
     */
    readonly type?: string;
    /**
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupEc2TagSet {
    /**
     * ec2_tag_filter block.
     *
     * @stability stable
     */
    readonly ec2TagFilter?: CodedeployDeploymentGroupEc2TagSetEc2TagFilter[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupEcsService {
    /**
     * @stability stable
     */
    readonly clusterName: string;
    /**
     * @stability stable
     */
    readonly serviceName: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupLoadBalancerInfoElbInfo {
    /**
     * @stability stable
     */
    readonly name?: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupLoadBalancerInfoTargetGroupInfo {
    /**
     * @stability stable
     */
    readonly name?: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfoProdTrafficRoute {
    /**
     * @stability stable
     */
    readonly listenerArns: string[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfoTargetGroup {
    /**
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfoTestTrafficRoute {
    /**
     * @stability stable
     */
    readonly listenerArns: string[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfo {
    /**
     * prod_traffic_route block.
     *
     * @stability stable
     */
    readonly prodTrafficRoute: CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfoProdTrafficRoute[];
    /**
     * target_group block.
     *
     * @stability stable
     */
    readonly targetGroup: CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfoTargetGroup[];
    /**
     * test_traffic_route block.
     *
     * @stability stable
     */
    readonly testTrafficRoute?: CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfoTestTrafficRoute[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupLoadBalancerInfo {
    /**
     * elb_info block.
     *
     * @stability stable
     */
    readonly elbInfo?: CodedeployDeploymentGroupLoadBalancerInfoElbInfo[];
    /**
     * target_group_info block.
     *
     * @stability stable
     */
    readonly targetGroupInfo?: CodedeployDeploymentGroupLoadBalancerInfoTargetGroupInfo[];
    /**
     * target_group_pair_info block.
     *
     * @stability stable
     */
    readonly targetGroupPairInfo?: CodedeployDeploymentGroupLoadBalancerInfoTargetGroupPairInfo[];
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupOnPremisesInstanceTagFilter {
    /**
     * @stability stable
     */
    readonly key?: string;
    /**
     * @stability stable
     */
    readonly type?: string;
    /**
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export interface CodedeployDeploymentGroupTriggerConfiguration {
    /**
     * @stability stable
     */
    readonly triggerEvents: string[];
    /**
     * @stability stable
     */
    readonly triggerName: string;
    /**
     * @stability stable
     */
    readonly triggerTargetArn: string;
}
/**
 * @stability stable
 */
export declare class CodedeployDeploymentGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodedeployDeploymentGroupConfig);
    private _appName;
    /**
     * @stability stable
     */
    get appName(): string;
    /**
     * @stability stable
     */
    set appName(value: string);
    /**
     * @stability stable
     */
    get appNameInput(): string;
    private _autoscalingGroups?;
    /**
     * @stability stable
     */
    get autoscalingGroups(): string[];
    /**
     * @stability stable
     */
    set autoscalingGroups(value: string[]);
    /**
     * @stability stable
     */
    resetAutoscalingGroups(): void;
    /**
     * @stability stable
     */
    get autoscalingGroupsInput(): string[] | undefined;
    private _deploymentConfigName?;
    /**
     * @stability stable
     */
    get deploymentConfigName(): string;
    /**
     * @stability stable
     */
    set deploymentConfigName(value: string);
    /**
     * @stability stable
     */
    resetDeploymentConfigName(): void;
    /**
     * @stability stable
     */
    get deploymentConfigNameInput(): string | undefined;
    private _deploymentGroupName;
    /**
     * @stability stable
     */
    get deploymentGroupName(): string;
    /**
     * @stability stable
     */
    set deploymentGroupName(value: string);
    /**
     * @stability stable
     */
    get deploymentGroupNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _serviceRoleArn;
    /**
     * @stability stable
     */
    get serviceRoleArn(): string;
    /**
     * @stability stable
     */
    set serviceRoleArn(value: string);
    /**
     * @stability stable
     */
    get serviceRoleArnInput(): string;
    private _alarmConfiguration?;
    /**
     * @stability stable
     */
    get alarmConfiguration(): CodedeployDeploymentGroupAlarmConfiguration[];
    /**
     * @stability stable
     */
    set alarmConfiguration(value: CodedeployDeploymentGroupAlarmConfiguration[]);
    /**
     * @stability stable
     */
    resetAlarmConfiguration(): void;
    /**
     * @stability stable
     */
    get alarmConfigurationInput(): CodedeployDeploymentGroupAlarmConfiguration[] | undefined;
    private _autoRollbackConfiguration?;
    /**
     * @stability stable
     */
    get autoRollbackConfiguration(): CodedeployDeploymentGroupAutoRollbackConfiguration[];
    /**
     * @stability stable
     */
    set autoRollbackConfiguration(value: CodedeployDeploymentGroupAutoRollbackConfiguration[]);
    /**
     * @stability stable
     */
    resetAutoRollbackConfiguration(): void;
    /**
     * @stability stable
     */
    get autoRollbackConfigurationInput(): CodedeployDeploymentGroupAutoRollbackConfiguration[] | undefined;
    private _blueGreenDeploymentConfig?;
    /**
     * @stability stable
     */
    get blueGreenDeploymentConfig(): CodedeployDeploymentGroupBlueGreenDeploymentConfig[];
    /**
     * @stability stable
     */
    set blueGreenDeploymentConfig(value: CodedeployDeploymentGroupBlueGreenDeploymentConfig[]);
    /**
     * @stability stable
     */
    resetBlueGreenDeploymentConfig(): void;
    /**
     * @stability stable
     */
    get blueGreenDeploymentConfigInput(): CodedeployDeploymentGroupBlueGreenDeploymentConfig[] | undefined;
    private _deploymentStyle?;
    /**
     * @stability stable
     */
    get deploymentStyle(): CodedeployDeploymentGroupDeploymentStyle[];
    /**
     * @stability stable
     */
    set deploymentStyle(value: CodedeployDeploymentGroupDeploymentStyle[]);
    /**
     * @stability stable
     */
    resetDeploymentStyle(): void;
    /**
     * @stability stable
     */
    get deploymentStyleInput(): CodedeployDeploymentGroupDeploymentStyle[] | undefined;
    private _ec2TagFilter?;
    /**
     * @stability stable
     */
    get ec2TagFilter(): CodedeployDeploymentGroupEc2TagFilter[];
    /**
     * @stability stable
     */
    set ec2TagFilter(value: CodedeployDeploymentGroupEc2TagFilter[]);
    /**
     * @stability stable
     */
    resetEc2TagFilter(): void;
    /**
     * @stability stable
     */
    get ec2TagFilterInput(): CodedeployDeploymentGroupEc2TagFilter[] | undefined;
    private _ec2TagSet?;
    /**
     * @stability stable
     */
    get ec2TagSet(): CodedeployDeploymentGroupEc2TagSet[];
    /**
     * @stability stable
     */
    set ec2TagSet(value: CodedeployDeploymentGroupEc2TagSet[]);
    /**
     * @stability stable
     */
    resetEc2TagSet(): void;
    /**
     * @stability stable
     */
    get ec2TagSetInput(): CodedeployDeploymentGroupEc2TagSet[] | undefined;
    private _ecsService?;
    /**
     * @stability stable
     */
    get ecsService(): CodedeployDeploymentGroupEcsService[];
    /**
     * @stability stable
     */
    set ecsService(value: CodedeployDeploymentGroupEcsService[]);
    /**
     * @stability stable
     */
    resetEcsService(): void;
    /**
     * @stability stable
     */
    get ecsServiceInput(): CodedeployDeploymentGroupEcsService[] | undefined;
    private _loadBalancerInfo?;
    /**
     * @stability stable
     */
    get loadBalancerInfo(): CodedeployDeploymentGroupLoadBalancerInfo[];
    /**
     * @stability stable
     */
    set loadBalancerInfo(value: CodedeployDeploymentGroupLoadBalancerInfo[]);
    /**
     * @stability stable
     */
    resetLoadBalancerInfo(): void;
    /**
     * @stability stable
     */
    get loadBalancerInfoInput(): CodedeployDeploymentGroupLoadBalancerInfo[] | undefined;
    private _onPremisesInstanceTagFilter?;
    /**
     * @stability stable
     */
    get onPremisesInstanceTagFilter(): CodedeployDeploymentGroupOnPremisesInstanceTagFilter[];
    /**
     * @stability stable
     */
    set onPremisesInstanceTagFilter(value: CodedeployDeploymentGroupOnPremisesInstanceTagFilter[]);
    /**
     * @stability stable
     */
    resetOnPremisesInstanceTagFilter(): void;
    /**
     * @stability stable
     */
    get onPremisesInstanceTagFilterInput(): CodedeployDeploymentGroupOnPremisesInstanceTagFilter[] | undefined;
    private _triggerConfiguration?;
    /**
     * @stability stable
     */
    get triggerConfiguration(): CodedeployDeploymentGroupTriggerConfiguration[];
    /**
     * @stability stable
     */
    set triggerConfiguration(value: CodedeployDeploymentGroupTriggerConfiguration[]);
    /**
     * @stability stable
     */
    resetTriggerConfiguration(): void;
    /**
     * @stability stable
     */
    get triggerConfigurationInput(): CodedeployDeploymentGroupTriggerConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
