import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodepipelineWebhookConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly authentication: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly targetAction: string;
    /**
     * @stability stable
     */
    readonly targetPipeline: string;
    /**
     * authentication_configuration block.
     *
     * @stability stable
     */
    readonly authenticationConfiguration?: CodepipelineWebhookAuthenticationConfiguration[];
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter: CodepipelineWebhookFilter[];
}
/**
 * @stability stable
 */
export interface CodepipelineWebhookAuthenticationConfiguration {
    /**
     * @stability stable
     */
    readonly allowedIpRange?: string;
    /**
     * @stability stable
     */
    readonly secretToken?: string;
}
/**
 * @stability stable
 */
export interface CodepipelineWebhookFilter {
    /**
     * @stability stable
     */
    readonly jsonPath: string;
    /**
     * @stability stable
     */
    readonly matchEquals: string;
}
/**
 * @stability stable
 */
export declare class CodepipelineWebhook extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodepipelineWebhookConfig);
    private _authentication;
    /**
     * @stability stable
     */
    get authentication(): string;
    /**
     * @stability stable
     */
    set authentication(value: string);
    /**
     * @stability stable
     */
    get authenticationInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _targetAction;
    /**
     * @stability stable
     */
    get targetAction(): string;
    /**
     * @stability stable
     */
    set targetAction(value: string);
    /**
     * @stability stable
     */
    get targetActionInput(): string;
    private _targetPipeline;
    /**
     * @stability stable
     */
    get targetPipeline(): string;
    /**
     * @stability stable
     */
    set targetPipeline(value: string);
    /**
     * @stability stable
     */
    get targetPipelineInput(): string;
    /**
     * @stability stable
     */
    get url(): string;
    private _authenticationConfiguration?;
    /**
     * @stability stable
     */
    get authenticationConfiguration(): CodepipelineWebhookAuthenticationConfiguration[];
    /**
     * @stability stable
     */
    set authenticationConfiguration(value: CodepipelineWebhookAuthenticationConfiguration[]);
    /**
     * @stability stable
     */
    resetAuthenticationConfiguration(): void;
    /**
     * @stability stable
     */
    get authenticationConfigurationInput(): CodepipelineWebhookAuthenticationConfiguration[] | undefined;
    private _filter;
    /**
     * @stability stable
     */
    get filter(): CodepipelineWebhookFilter[];
    /**
     * @stability stable
     */
    set filter(value: CodepipelineWebhookFilter[]);
    /**
     * @stability stable
     */
    get filterInput(): CodepipelineWebhookFilter[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
