import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CodestarnotificationsNotificationRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly detailType: string;
    /**
     * @stability stable
     */
    readonly eventTypeIds: string[];
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly resource: string;
    /**
     * @stability stable
     */
    readonly status?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * target block.
     *
     * @stability stable
     */
    readonly target?: CodestarnotificationsNotificationRuleTarget[];
}
/**
 * @stability stable
 */
export interface CodestarnotificationsNotificationRuleTarget {
    /**
     * @stability stable
     */
    readonly address: string;
    /**
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export declare class CodestarnotificationsNotificationRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CodestarnotificationsNotificationRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _detailType;
    /**
     * @stability stable
     */
    get detailType(): string;
    /**
     * @stability stable
     */
    set detailType(value: string);
    /**
     * @stability stable
     */
    get detailTypeInput(): string;
    private _eventTypeIds;
    /**
     * @stability stable
     */
    get eventTypeIds(): string[];
    /**
     * @stability stable
     */
    set eventTypeIds(value: string[]);
    /**
     * @stability stable
     */
    get eventTypeIdsInput(): string[];
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _resource;
    /**
     * @stability stable
     */
    get resource(): string;
    /**
     * @stability stable
     */
    set resource(value: string);
    /**
     * @stability stable
     */
    get resourceInput(): string;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    set status(value: string);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _target?;
    /**
     * @stability stable
     */
    get target(): CodestarnotificationsNotificationRuleTarget[];
    /**
     * @stability stable
     */
    set target(value: CodestarnotificationsNotificationRuleTarget[]);
    /**
     * @stability stable
     */
    resetTarget(): void;
    /**
     * @stability stable
     */
    get targetInput(): CodestarnotificationsNotificationRuleTarget[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
