import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CognitoIdentityPoolRolesAttachmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly identityPoolId: string;
    /**
     * @stability stable
     */
    readonly roles: {
        [key: string]: string;
    };
    /**
     * role_mapping block.
     *
     * @stability stable
     */
    readonly roleMapping?: CognitoIdentityPoolRolesAttachmentRoleMapping[];
}
/**
 * @stability stable
 */
export interface CognitoIdentityPoolRolesAttachmentRoleMappingMappingRule {
    /**
     * @stability stable
     */
    readonly claim: string;
    /**
     * @stability stable
     */
    readonly matchType: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface CognitoIdentityPoolRolesAttachmentRoleMapping {
    /**
     * @stability stable
     */
    readonly ambiguousRoleResolution?: string;
    /**
     * @stability stable
     */
    readonly identityProvider: string;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * mapping_rule block.
     *
     * @stability stable
     */
    readonly mappingRule?: CognitoIdentityPoolRolesAttachmentRoleMappingMappingRule[];
}
/**
 * @stability stable
 */
export declare class CognitoIdentityPoolRolesAttachment extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CognitoIdentityPoolRolesAttachmentConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _identityPoolId;
    /**
     * @stability stable
     */
    get identityPoolId(): string;
    /**
     * @stability stable
     */
    set identityPoolId(value: string);
    /**
     * @stability stable
     */
    get identityPoolIdInput(): string;
    private _roles;
    /**
     * @stability stable
     */
    get roles(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set roles(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    get rolesInput(): {
        [key: string]: string;
    };
    private _roleMapping?;
    /**
     * @stability stable
     */
    get roleMapping(): CognitoIdentityPoolRolesAttachmentRoleMapping[];
    /**
     * @stability stable
     */
    set roleMapping(value: CognitoIdentityPoolRolesAttachmentRoleMapping[]);
    /**
     * @stability stable
     */
    resetRoleMapping(): void;
    /**
     * @stability stable
     */
    get roleMappingInput(): CognitoIdentityPoolRolesAttachmentRoleMapping[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
