import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CognitoIdentityPoolConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly allowUnauthenticatedIdentities?: boolean;
    /**
     * @stability stable
     */
    readonly developerProviderName?: string;
    /**
     * @stability stable
     */
    readonly identityPoolName: string;
    /**
     * @stability stable
     */
    readonly openidConnectProviderArns?: string[];
    /**
     * @stability stable
     */
    readonly samlProviderArns?: string[];
    /**
     * @stability stable
     */
    readonly supportedLoginProviders?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * cognito_identity_providers block.
     *
     * @stability stable
     */
    readonly cognitoIdentityProviders?: CognitoIdentityPoolCognitoIdentityProviders[];
}
/**
 * @stability stable
 */
export interface CognitoIdentityPoolCognitoIdentityProviders {
    /**
     * @stability stable
     */
    readonly clientId?: string;
    /**
     * @stability stable
     */
    readonly providerName?: string;
    /**
     * @stability stable
     */
    readonly serverSideTokenCheck?: boolean;
}
/**
 * @stability stable
 */
export declare class CognitoIdentityPool extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CognitoIdentityPoolConfig);
    private _allowUnauthenticatedIdentities?;
    /**
     * @stability stable
     */
    get allowUnauthenticatedIdentities(): boolean;
    /**
     * @stability stable
     */
    set allowUnauthenticatedIdentities(value: boolean);
    /**
     * @stability stable
     */
    resetAllowUnauthenticatedIdentities(): void;
    /**
     * @stability stable
     */
    get allowUnauthenticatedIdentitiesInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _developerProviderName?;
    /**
     * @stability stable
     */
    get developerProviderName(): string;
    /**
     * @stability stable
     */
    set developerProviderName(value: string);
    /**
     * @stability stable
     */
    resetDeveloperProviderName(): void;
    /**
     * @stability stable
     */
    get developerProviderNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _identityPoolName;
    /**
     * @stability stable
     */
    get identityPoolName(): string;
    /**
     * @stability stable
     */
    set identityPoolName(value: string);
    /**
     * @stability stable
     */
    get identityPoolNameInput(): string;
    private _openidConnectProviderArns?;
    /**
     * @stability stable
     */
    get openidConnectProviderArns(): string[];
    /**
     * @stability stable
     */
    set openidConnectProviderArns(value: string[]);
    /**
     * @stability stable
     */
    resetOpenidConnectProviderArns(): void;
    /**
     * @stability stable
     */
    get openidConnectProviderArnsInput(): string[] | undefined;
    private _samlProviderArns?;
    /**
     * @stability stable
     */
    get samlProviderArns(): string[];
    /**
     * @stability stable
     */
    set samlProviderArns(value: string[]);
    /**
     * @stability stable
     */
    resetSamlProviderArns(): void;
    /**
     * @stability stable
     */
    get samlProviderArnsInput(): string[] | undefined;
    private _supportedLoginProviders?;
    /**
     * @stability stable
     */
    get supportedLoginProviders(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set supportedLoginProviders(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetSupportedLoginProviders(): void;
    /**
     * @stability stable
     */
    get supportedLoginProvidersInput(): {
        [key: string]: string;
    } | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _cognitoIdentityProviders?;
    /**
     * @stability stable
     */
    get cognitoIdentityProviders(): CognitoIdentityPoolCognitoIdentityProviders[];
    /**
     * @stability stable
     */
    set cognitoIdentityProviders(value: CognitoIdentityPoolCognitoIdentityProviders[]);
    /**
     * @stability stable
     */
    resetCognitoIdentityProviders(): void;
    /**
     * @stability stable
     */
    get cognitoIdentityProvidersInput(): CognitoIdentityPoolCognitoIdentityProviders[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
