import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CognitoResourceServerConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly identifier: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly userPoolId: string;
    /**
     * scope block.
     *
     * @stability stable
     */
    readonly scope?: CognitoResourceServerScope[];
}
/**
 * @stability stable
 */
export interface CognitoResourceServerScope {
    /**
     * @stability stable
     */
    readonly scopeDescription: string;
    /**
     * @stability stable
     */
    readonly scopeName: string;
}
/**
 * @stability stable
 */
export declare class CognitoResourceServer extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CognitoResourceServerConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _identifier;
    /**
     * @stability stable
     */
    get identifier(): string;
    /**
     * @stability stable
     */
    set identifier(value: string);
    /**
     * @stability stable
     */
    get identifierInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get scopeIdentifiers(): string[];
    private _userPoolId;
    /**
     * @stability stable
     */
    get userPoolId(): string;
    /**
     * @stability stable
     */
    set userPoolId(value: string);
    /**
     * @stability stable
     */
    get userPoolIdInput(): string;
    private _scope?;
    /**
     * @stability stable
     */
    get scope(): CognitoResourceServerScope[];
    /**
     * @stability stable
     */
    set scope(value: CognitoResourceServerScope[]);
    /**
     * @stability stable
     */
    resetScope(): void;
    /**
     * @stability stable
     */
    get scopeInput(): CognitoResourceServerScope[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
