import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CognitoUserGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly precedence?: number;
    /**
     * @stability stable
     */
    readonly roleArn?: string;
    /**
     * @stability stable
     */
    readonly userPoolId: string;
}
/**
 * @stability stable
 */
export declare class CognitoUserGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CognitoUserGroupConfig);
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _precedence?;
    /**
     * @stability stable
     */
    get precedence(): number;
    /**
     * @stability stable
     */
    set precedence(value: number);
    /**
     * @stability stable
     */
    resetPrecedence(): void;
    /**
     * @stability stable
     */
    get precedenceInput(): number | undefined;
    private _roleArn?;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    resetRoleArn(): void;
    /**
     * @stability stable
     */
    get roleArnInput(): string | undefined;
    private _userPoolId;
    /**
     * @stability stable
     */
    get userPoolId(): string;
    /**
     * @stability stable
     */
    set userPoolId(value: string);
    /**
     * @stability stable
     */
    get userPoolIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
