import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CognitoUserPoolUiCustomizationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly clientId?: string;
    /**
     * @stability stable
     */
    readonly css?: string;
    /**
     * @stability stable
     */
    readonly imageFile?: string;
    /**
     * @stability stable
     */
    readonly userPoolId: string;
}
/**
 * @stability stable
 */
export declare class CognitoUserPoolUiCustomization extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CognitoUserPoolUiCustomizationConfig);
    private _clientId?;
    /**
     * @stability stable
     */
    get clientId(): string;
    /**
     * @stability stable
     */
    set clientId(value: string);
    /**
     * @stability stable
     */
    resetClientId(): void;
    /**
     * @stability stable
     */
    get clientIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get creationDate(): string;
    private _css?;
    /**
     * @stability stable
     */
    get css(): string;
    /**
     * @stability stable
     */
    set css(value: string);
    /**
     * @stability stable
     */
    resetCss(): void;
    /**
     * @stability stable
     */
    get cssInput(): string | undefined;
    /**
     * @stability stable
     */
    get cssVersion(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _imageFile?;
    /**
     * @stability stable
     */
    get imageFile(): string;
    /**
     * @stability stable
     */
    set imageFile(value: string);
    /**
     * @stability stable
     */
    resetImageFile(): void;
    /**
     * @stability stable
     */
    get imageFileInput(): string | undefined;
    /**
     * @stability stable
     */
    get imageUrl(): string;
    /**
     * @stability stable
     */
    get lastModifiedDate(): string;
    private _userPoolId;
    /**
     * @stability stable
     */
    get userPoolId(): string;
    /**
     * @stability stable
     */
    set userPoolId(value: string);
    /**
     * @stability stable
     */
    get userPoolIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
