import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CognitoUserPoolConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly aliasAttributes?: string[];
    /**
     * @stability stable
     */
    readonly autoVerifiedAttributes?: string[];
    /**
     * @stability stable
     */
    readonly emailVerificationMessage?: string;
    /**
     * @stability stable
     */
    readonly emailVerificationSubject?: string;
    /**
     * @stability stable
     */
    readonly mfaConfiguration?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly smsAuthenticationMessage?: string;
    /**
     * @stability stable
     */
    readonly smsVerificationMessage?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly usernameAttributes?: string[];
    /**
     * account_recovery_setting block.
     *
     * @stability stable
     */
    readonly accountRecoverySetting?: CognitoUserPoolAccountRecoverySetting[];
    /**
     * admin_create_user_config block.
     *
     * @stability stable
     */
    readonly adminCreateUserConfig?: CognitoUserPoolAdminCreateUserConfig[];
    /**
     * device_configuration block.
     *
     * @stability stable
     */
    readonly deviceConfiguration?: CognitoUserPoolDeviceConfiguration[];
    /**
     * email_configuration block.
     *
     * @stability stable
     */
    readonly emailConfiguration?: CognitoUserPoolEmailConfiguration[];
    /**
     * lambda_config block.
     *
     * @stability stable
     */
    readonly lambdaConfig?: CognitoUserPoolLambdaConfig[];
    /**
     * password_policy block.
     *
     * @stability stable
     */
    readonly passwordPolicy?: CognitoUserPoolPasswordPolicy[];
    /**
     * schema block.
     *
     * @stability stable
     */
    readonly schema?: CognitoUserPoolSchema[];
    /**
     * sms_configuration block.
     *
     * @stability stable
     */
    readonly smsConfiguration?: CognitoUserPoolSmsConfiguration[];
    /**
     * software_token_mfa_configuration block.
     *
     * @stability stable
     */
    readonly softwareTokenMfaConfiguration?: CognitoUserPoolSoftwareTokenMfaConfiguration[];
    /**
     * user_pool_add_ons block.
     *
     * @stability stable
     */
    readonly userPoolAddOns?: CognitoUserPoolUserPoolAddOns[];
    /**
     * username_configuration block.
     *
     * @stability stable
     */
    readonly usernameConfiguration?: CognitoUserPoolUsernameConfiguration[];
    /**
     * verification_message_template block.
     *
     * @stability stable
     */
    readonly verificationMessageTemplate?: CognitoUserPoolVerificationMessageTemplate[];
}
/**
 * @stability stable
 */
export interface CognitoUserPoolAccountRecoverySettingRecoveryMechanism {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly priority: number;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolAccountRecoverySetting {
    /**
     * recovery_mechanism block.
     *
     * @stability stable
     */
    readonly recoveryMechanism: CognitoUserPoolAccountRecoverySettingRecoveryMechanism[];
}
/**
 * @stability stable
 */
export interface CognitoUserPoolAdminCreateUserConfigInviteMessageTemplate {
    /**
     * @stability stable
     */
    readonly emailMessage?: string;
    /**
     * @stability stable
     */
    readonly emailSubject?: string;
    /**
     * @stability stable
     */
    readonly smsMessage?: string;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolAdminCreateUserConfig {
    /**
     * @stability stable
     */
    readonly allowAdminCreateUserOnly?: boolean;
    /**
     * invite_message_template block.
     *
     * @stability stable
     */
    readonly inviteMessageTemplate?: CognitoUserPoolAdminCreateUserConfigInviteMessageTemplate[];
}
/**
 * @stability stable
 */
export interface CognitoUserPoolDeviceConfiguration {
    /**
     * @stability stable
     */
    readonly challengeRequiredOnNewDevice?: boolean;
    /**
     * @stability stable
     */
    readonly deviceOnlyRememberedOnUserPrompt?: boolean;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolEmailConfiguration {
    /**
     * @stability stable
     */
    readonly configurationSet?: string;
    /**
     * @stability stable
     */
    readonly emailSendingAccount?: string;
    /**
     * @stability stable
     */
    readonly fromEmailAddress?: string;
    /**
     * @stability stable
     */
    readonly replyToEmailAddress?: string;
    /**
     * @stability stable
     */
    readonly sourceArn?: string;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolLambdaConfig {
    /**
     * @stability stable
     */
    readonly createAuthChallenge?: string;
    /**
     * @stability stable
     */
    readonly customMessage?: string;
    /**
     * @stability stable
     */
    readonly defineAuthChallenge?: string;
    /**
     * @stability stable
     */
    readonly postAuthentication?: string;
    /**
     * @stability stable
     */
    readonly postConfirmation?: string;
    /**
     * @stability stable
     */
    readonly preAuthentication?: string;
    /**
     * @stability stable
     */
    readonly preSignUp?: string;
    /**
     * @stability stable
     */
    readonly preTokenGeneration?: string;
    /**
     * @stability stable
     */
    readonly userMigration?: string;
    /**
     * @stability stable
     */
    readonly verifyAuthChallengeResponse?: string;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolPasswordPolicy {
    /**
     * @stability stable
     */
    readonly minimumLength?: number;
    /**
     * @stability stable
     */
    readonly requireLowercase?: boolean;
    /**
     * @stability stable
     */
    readonly requireNumbers?: boolean;
    /**
     * @stability stable
     */
    readonly requireSymbols?: boolean;
    /**
     * @stability stable
     */
    readonly requireUppercase?: boolean;
    /**
     * @stability stable
     */
    readonly temporaryPasswordValidityDays?: number;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolSchemaNumberAttributeConstraints {
    /**
     * @stability stable
     */
    readonly maxValue?: string;
    /**
     * @stability stable
     */
    readonly minValue?: string;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolSchemaStringAttributeConstraints {
    /**
     * @stability stable
     */
    readonly maxLength?: string;
    /**
     * @stability stable
     */
    readonly minLength?: string;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolSchema {
    /**
     * @stability stable
     */
    readonly attributeDataType: string;
    /**
     * @stability stable
     */
    readonly developerOnlyAttribute?: boolean;
    /**
     * @stability stable
     */
    readonly mutable?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly required?: boolean;
    /**
     * number_attribute_constraints block.
     *
     * @stability stable
     */
    readonly numberAttributeConstraints?: CognitoUserPoolSchemaNumberAttributeConstraints[];
    /**
     * string_attribute_constraints block.
     *
     * @stability stable
     */
    readonly stringAttributeConstraints?: CognitoUserPoolSchemaStringAttributeConstraints[];
}
/**
 * @stability stable
 */
export interface CognitoUserPoolSmsConfiguration {
    /**
     * @stability stable
     */
    readonly externalId: string;
    /**
     * @stability stable
     */
    readonly snsCallerArn: string;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolSoftwareTokenMfaConfiguration {
    /**
     * @stability stable
     */
    readonly enabled: boolean;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolUserPoolAddOns {
    /**
     * @stability stable
     */
    readonly advancedSecurityMode: string;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolUsernameConfiguration {
    /**
     * @stability stable
     */
    readonly caseSensitive: boolean;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolVerificationMessageTemplate {
    /**
     * @stability stable
     */
    readonly defaultEmailOption?: string;
    /**
     * @stability stable
     */
    readonly emailMessage?: string;
    /**
     * @stability stable
     */
    readonly emailMessageByLink?: string;
    /**
     * @stability stable
     */
    readonly emailSubject?: string;
    /**
     * @stability stable
     */
    readonly emailSubjectByLink?: string;
    /**
     * @stability stable
     */
    readonly smsMessage?: string;
}
/**
 * @stability stable
 */
export declare class CognitoUserPool extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CognitoUserPoolConfig);
    private _aliasAttributes?;
    /**
     * @stability stable
     */
    get aliasAttributes(): string[];
    /**
     * @stability stable
     */
    set aliasAttributes(value: string[]);
    /**
     * @stability stable
     */
    resetAliasAttributes(): void;
    /**
     * @stability stable
     */
    get aliasAttributesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoVerifiedAttributes?;
    /**
     * @stability stable
     */
    get autoVerifiedAttributes(): string[];
    /**
     * @stability stable
     */
    set autoVerifiedAttributes(value: string[]);
    /**
     * @stability stable
     */
    resetAutoVerifiedAttributes(): void;
    /**
     * @stability stable
     */
    get autoVerifiedAttributesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get creationDate(): string;
    private _emailVerificationMessage?;
    /**
     * @stability stable
     */
    get emailVerificationMessage(): string;
    /**
     * @stability stable
     */
    set emailVerificationMessage(value: string);
    /**
     * @stability stable
     */
    resetEmailVerificationMessage(): void;
    /**
     * @stability stable
     */
    get emailVerificationMessageInput(): string | undefined;
    private _emailVerificationSubject?;
    /**
     * @stability stable
     */
    get emailVerificationSubject(): string;
    /**
     * @stability stable
     */
    set emailVerificationSubject(value: string);
    /**
     * @stability stable
     */
    resetEmailVerificationSubject(): void;
    /**
     * @stability stable
     */
    get emailVerificationSubjectInput(): string | undefined;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastModifiedDate(): string;
    private _mfaConfiguration?;
    /**
     * @stability stable
     */
    get mfaConfiguration(): string;
    /**
     * @stability stable
     */
    set mfaConfiguration(value: string);
    /**
     * @stability stable
     */
    resetMfaConfiguration(): void;
    /**
     * @stability stable
     */
    get mfaConfigurationInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _smsAuthenticationMessage?;
    /**
     * @stability stable
     */
    get smsAuthenticationMessage(): string;
    /**
     * @stability stable
     */
    set smsAuthenticationMessage(value: string);
    /**
     * @stability stable
     */
    resetSmsAuthenticationMessage(): void;
    /**
     * @stability stable
     */
    get smsAuthenticationMessageInput(): string | undefined;
    private _smsVerificationMessage?;
    /**
     * @stability stable
     */
    get smsVerificationMessage(): string;
    /**
     * @stability stable
     */
    set smsVerificationMessage(value: string);
    /**
     * @stability stable
     */
    resetSmsVerificationMessage(): void;
    /**
     * @stability stable
     */
    get smsVerificationMessageInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _usernameAttributes?;
    /**
     * @stability stable
     */
    get usernameAttributes(): string[];
    /**
     * @stability stable
     */
    set usernameAttributes(value: string[]);
    /**
     * @stability stable
     */
    resetUsernameAttributes(): void;
    /**
     * @stability stable
     */
    get usernameAttributesInput(): string[] | undefined;
    private _accountRecoverySetting?;
    /**
     * @stability stable
     */
    get accountRecoverySetting(): CognitoUserPoolAccountRecoverySetting[];
    /**
     * @stability stable
     */
    set accountRecoverySetting(value: CognitoUserPoolAccountRecoverySetting[]);
    /**
     * @stability stable
     */
    resetAccountRecoverySetting(): void;
    /**
     * @stability stable
     */
    get accountRecoverySettingInput(): CognitoUserPoolAccountRecoverySetting[] | undefined;
    private _adminCreateUserConfig?;
    /**
     * @stability stable
     */
    get adminCreateUserConfig(): CognitoUserPoolAdminCreateUserConfig[];
    /**
     * @stability stable
     */
    set adminCreateUserConfig(value: CognitoUserPoolAdminCreateUserConfig[]);
    /**
     * @stability stable
     */
    resetAdminCreateUserConfig(): void;
    /**
     * @stability stable
     */
    get adminCreateUserConfigInput(): CognitoUserPoolAdminCreateUserConfig[] | undefined;
    private _deviceConfiguration?;
    /**
     * @stability stable
     */
    get deviceConfiguration(): CognitoUserPoolDeviceConfiguration[];
    /**
     * @stability stable
     */
    set deviceConfiguration(value: CognitoUserPoolDeviceConfiguration[]);
    /**
     * @stability stable
     */
    resetDeviceConfiguration(): void;
    /**
     * @stability stable
     */
    get deviceConfigurationInput(): CognitoUserPoolDeviceConfiguration[] | undefined;
    private _emailConfiguration?;
    /**
     * @stability stable
     */
    get emailConfiguration(): CognitoUserPoolEmailConfiguration[];
    /**
     * @stability stable
     */
    set emailConfiguration(value: CognitoUserPoolEmailConfiguration[]);
    /**
     * @stability stable
     */
    resetEmailConfiguration(): void;
    /**
     * @stability stable
     */
    get emailConfigurationInput(): CognitoUserPoolEmailConfiguration[] | undefined;
    private _lambdaConfig?;
    /**
     * @stability stable
     */
    get lambdaConfig(): CognitoUserPoolLambdaConfig[];
    /**
     * @stability stable
     */
    set lambdaConfig(value: CognitoUserPoolLambdaConfig[]);
    /**
     * @stability stable
     */
    resetLambdaConfig(): void;
    /**
     * @stability stable
     */
    get lambdaConfigInput(): CognitoUserPoolLambdaConfig[] | undefined;
    private _passwordPolicy?;
    /**
     * @stability stable
     */
    get passwordPolicy(): CognitoUserPoolPasswordPolicy[];
    /**
     * @stability stable
     */
    set passwordPolicy(value: CognitoUserPoolPasswordPolicy[]);
    /**
     * @stability stable
     */
    resetPasswordPolicy(): void;
    /**
     * @stability stable
     */
    get passwordPolicyInput(): CognitoUserPoolPasswordPolicy[] | undefined;
    private _schema?;
    /**
     * @stability stable
     */
    get schema(): CognitoUserPoolSchema[];
    /**
     * @stability stable
     */
    set schema(value: CognitoUserPoolSchema[]);
    /**
     * @stability stable
     */
    resetSchema(): void;
    /**
     * @stability stable
     */
    get schemaInput(): CognitoUserPoolSchema[] | undefined;
    private _smsConfiguration?;
    /**
     * @stability stable
     */
    get smsConfiguration(): CognitoUserPoolSmsConfiguration[];
    /**
     * @stability stable
     */
    set smsConfiguration(value: CognitoUserPoolSmsConfiguration[]);
    /**
     * @stability stable
     */
    resetSmsConfiguration(): void;
    /**
     * @stability stable
     */
    get smsConfigurationInput(): CognitoUserPoolSmsConfiguration[] | undefined;
    private _softwareTokenMfaConfiguration?;
    /**
     * @stability stable
     */
    get softwareTokenMfaConfiguration(): CognitoUserPoolSoftwareTokenMfaConfiguration[];
    /**
     * @stability stable
     */
    set softwareTokenMfaConfiguration(value: CognitoUserPoolSoftwareTokenMfaConfiguration[]);
    /**
     * @stability stable
     */
    resetSoftwareTokenMfaConfiguration(): void;
    /**
     * @stability stable
     */
    get softwareTokenMfaConfigurationInput(): CognitoUserPoolSoftwareTokenMfaConfiguration[] | undefined;
    private _userPoolAddOns?;
    /**
     * @stability stable
     */
    get userPoolAddOns(): CognitoUserPoolUserPoolAddOns[];
    /**
     * @stability stable
     */
    set userPoolAddOns(value: CognitoUserPoolUserPoolAddOns[]);
    /**
     * @stability stable
     */
    resetUserPoolAddOns(): void;
    /**
     * @stability stable
     */
    get userPoolAddOnsInput(): CognitoUserPoolUserPoolAddOns[] | undefined;
    private _usernameConfiguration?;
    /**
     * @stability stable
     */
    get usernameConfiguration(): CognitoUserPoolUsernameConfiguration[];
    /**
     * @stability stable
     */
    set usernameConfiguration(value: CognitoUserPoolUsernameConfiguration[]);
    /**
     * @stability stable
     */
    resetUsernameConfiguration(): void;
    /**
     * @stability stable
     */
    get usernameConfigurationInput(): CognitoUserPoolUsernameConfiguration[] | undefined;
    private _verificationMessageTemplate?;
    /**
     * @stability stable
     */
    get verificationMessageTemplate(): CognitoUserPoolVerificationMessageTemplate[];
    /**
     * @stability stable
     */
    set verificationMessageTemplate(value: CognitoUserPoolVerificationMessageTemplate[]);
    /**
     * @stability stable
     */
    resetVerificationMessageTemplate(): void;
    /**
     * @stability stable
     */
    get verificationMessageTemplateInput(): CognitoUserPoolVerificationMessageTemplate[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
