import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ConfigConfigRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly inputParameters?: string;
    /**
     * @stability stable
     */
    readonly maximumExecutionFrequency?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * scope block.
     *
     * @stability stable
     */
    readonly scope?: ConfigConfigRuleScope[];
    /**
     * source block.
     *
     * @stability stable
     */
    readonly source: ConfigConfigRuleSource[];
}
/**
 * @stability stable
 */
export interface ConfigConfigRuleScope {
    /**
     * @stability stable
     */
    readonly complianceResourceId?: string;
    /**
     * @stability stable
     */
    readonly complianceResourceTypes?: string[];
    /**
     * @stability stable
     */
    readonly tagKey?: string;
    /**
     * @stability stable
     */
    readonly tagValue?: string;
}
/**
 * @stability stable
 */
export interface ConfigConfigRuleSourceSourceDetail {
    /**
     * @stability stable
     */
    readonly eventSource?: string;
    /**
     * @stability stable
     */
    readonly maximumExecutionFrequency?: string;
    /**
     * @stability stable
     */
    readonly messageType?: string;
}
/**
 * @stability stable
 */
export interface ConfigConfigRuleSource {
    /**
     * @stability stable
     */
    readonly owner: string;
    /**
     * @stability stable
     */
    readonly sourceIdentifier: string;
    /**
     * source_detail block.
     *
     * @stability stable
     */
    readonly sourceDetail?: ConfigConfigRuleSourceSourceDetail[];
}
/**
 * @stability stable
 */
export declare class ConfigConfigRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConfigConfigRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _inputParameters?;
    /**
     * @stability stable
     */
    get inputParameters(): string;
    /**
     * @stability stable
     */
    set inputParameters(value: string);
    /**
     * @stability stable
     */
    resetInputParameters(): void;
    /**
     * @stability stable
     */
    get inputParametersInput(): string | undefined;
    private _maximumExecutionFrequency?;
    /**
     * @stability stable
     */
    get maximumExecutionFrequency(): string;
    /**
     * @stability stable
     */
    set maximumExecutionFrequency(value: string);
    /**
     * @stability stable
     */
    resetMaximumExecutionFrequency(): void;
    /**
     * @stability stable
     */
    get maximumExecutionFrequencyInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get ruleId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _scope?;
    /**
     * @stability stable
     */
    get scope(): ConfigConfigRuleScope[];
    /**
     * @stability stable
     */
    set scope(value: ConfigConfigRuleScope[]);
    /**
     * @stability stable
     */
    resetScope(): void;
    /**
     * @stability stable
     */
    get scopeInput(): ConfigConfigRuleScope[] | undefined;
    private _source;
    /**
     * @stability stable
     */
    get source(): ConfigConfigRuleSource[];
    /**
     * @stability stable
     */
    set source(value: ConfigConfigRuleSource[]);
    /**
     * @stability stable
     */
    get sourceInput(): ConfigConfigRuleSource[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
