import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ConfigConfigurationAggregatorConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * account_aggregation_source block.
     *
     * @stability stable
     */
    readonly accountAggregationSource?: ConfigConfigurationAggregatorAccountAggregationSource[];
    /**
     * organization_aggregation_source block.
     *
     * @stability stable
     */
    readonly organizationAggregationSource?: ConfigConfigurationAggregatorOrganizationAggregationSource[];
}
/**
 * @stability stable
 */
export interface ConfigConfigurationAggregatorAccountAggregationSource {
    /**
     * @stability stable
     */
    readonly accountIds: string[];
    /**
     * @stability stable
     */
    readonly allRegions?: boolean;
    /**
     * @stability stable
     */
    readonly regions?: string[];
}
/**
 * @stability stable
 */
export interface ConfigConfigurationAggregatorOrganizationAggregationSource {
    /**
     * @stability stable
     */
    readonly allRegions?: boolean;
    /**
     * @stability stable
     */
    readonly regions?: string[];
    /**
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export declare class ConfigConfigurationAggregator extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConfigConfigurationAggregatorConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _accountAggregationSource?;
    /**
     * @stability stable
     */
    get accountAggregationSource(): ConfigConfigurationAggregatorAccountAggregationSource[];
    /**
     * @stability stable
     */
    set accountAggregationSource(value: ConfigConfigurationAggregatorAccountAggregationSource[]);
    /**
     * @stability stable
     */
    resetAccountAggregationSource(): void;
    /**
     * @stability stable
     */
    get accountAggregationSourceInput(): ConfigConfigurationAggregatorAccountAggregationSource[] | undefined;
    private _organizationAggregationSource?;
    /**
     * @stability stable
     */
    get organizationAggregationSource(): ConfigConfigurationAggregatorOrganizationAggregationSource[];
    /**
     * @stability stable
     */
    set organizationAggregationSource(value: ConfigConfigurationAggregatorOrganizationAggregationSource[]);
    /**
     * @stability stable
     */
    resetOrganizationAggregationSource(): void;
    /**
     * @stability stable
     */
    get organizationAggregationSourceInput(): ConfigConfigurationAggregatorOrganizationAggregationSource[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
