import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ConfigConfigurationRecorderConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * recording_group block.
     *
     * @stability stable
     */
    readonly recordingGroup?: ConfigConfigurationRecorderRecordingGroup[];
}
/**
 * @stability stable
 */
export interface ConfigConfigurationRecorderRecordingGroup {
    /**
     * @stability stable
     */
    readonly allSupported?: boolean;
    /**
     * @stability stable
     */
    readonly includeGlobalResourceTypes?: boolean;
    /**
     * @stability stable
     */
    readonly resourceTypes?: string[];
}
/**
 * @stability stable
 */
export declare class ConfigConfigurationRecorder extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConfigConfigurationRecorderConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _roleArn;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string;
    private _recordingGroup?;
    /**
     * @stability stable
     */
    get recordingGroup(): ConfigConfigurationRecorderRecordingGroup[];
    /**
     * @stability stable
     */
    set recordingGroup(value: ConfigConfigurationRecorderRecordingGroup[]);
    /**
     * @stability stable
     */
    resetRecordingGroup(): void;
    /**
     * @stability stable
     */
    get recordingGroupInput(): ConfigConfigurationRecorderRecordingGroup[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
