import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ConfigConformancePackConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly deliveryS3Bucket?: string;
    /**
     * @stability stable
     */
    readonly deliveryS3KeyPrefix?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly templateBody?: string;
    /**
     * @stability stable
     */
    readonly templateS3Uri?: string;
    /**
     * input_parameter block.
     *
     * @stability stable
     */
    readonly inputParameter?: ConfigConformancePackInputParameter[];
}
/**
 * @stability stable
 */
export interface ConfigConformancePackInputParameter {
    /**
     * @stability stable
     */
    readonly parameterName: string;
    /**
     * @stability stable
     */
    readonly parameterValue: string;
}
/**
 * @stability stable
 */
export declare class ConfigConformancePack extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConfigConformancePackConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _deliveryS3Bucket?;
    /**
     * @stability stable
     */
    get deliveryS3Bucket(): string;
    /**
     * @stability stable
     */
    set deliveryS3Bucket(value: string);
    /**
     * @stability stable
     */
    resetDeliveryS3Bucket(): void;
    /**
     * @stability stable
     */
    get deliveryS3BucketInput(): string | undefined;
    private _deliveryS3KeyPrefix?;
    /**
     * @stability stable
     */
    get deliveryS3KeyPrefix(): string;
    /**
     * @stability stable
     */
    set deliveryS3KeyPrefix(value: string);
    /**
     * @stability stable
     */
    resetDeliveryS3KeyPrefix(): void;
    /**
     * @stability stable
     */
    get deliveryS3KeyPrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _templateBody?;
    /**
     * @stability stable
     */
    get templateBody(): string;
    /**
     * @stability stable
     */
    set templateBody(value: string);
    /**
     * @stability stable
     */
    resetTemplateBody(): void;
    /**
     * @stability stable
     */
    get templateBodyInput(): string | undefined;
    private _templateS3Uri?;
    /**
     * @stability stable
     */
    get templateS3Uri(): string;
    /**
     * @stability stable
     */
    set templateS3Uri(value: string);
    /**
     * @stability stable
     */
    resetTemplateS3Uri(): void;
    /**
     * @stability stable
     */
    get templateS3UriInput(): string | undefined;
    private _inputParameter?;
    /**
     * @stability stable
     */
    get inputParameter(): ConfigConformancePackInputParameter[];
    /**
     * @stability stable
     */
    set inputParameter(value: ConfigConformancePackInputParameter[]);
    /**
     * @stability stable
     */
    resetInputParameter(): void;
    /**
     * @stability stable
     */
    get inputParameterInput(): ConfigConformancePackInputParameter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
