import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ConfigDeliveryChannelConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly s3BucketName: string;
    /**
     * @stability stable
     */
    readonly s3KeyPrefix?: string;
    /**
     * @stability stable
     */
    readonly snsTopicArn?: string;
    /**
     * snapshot_delivery_properties block.
     *
     * @stability stable
     */
    readonly snapshotDeliveryProperties?: ConfigDeliveryChannelSnapshotDeliveryProperties[];
}
/**
 * @stability stable
 */
export interface ConfigDeliveryChannelSnapshotDeliveryProperties {
    /**
     * @stability stable
     */
    readonly deliveryFrequency?: string;
}
/**
 * @stability stable
 */
export declare class ConfigDeliveryChannel extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConfigDeliveryChannelConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _s3BucketName;
    /**
     * @stability stable
     */
    get s3BucketName(): string;
    /**
     * @stability stable
     */
    set s3BucketName(value: string);
    /**
     * @stability stable
     */
    get s3BucketNameInput(): string;
    private _s3KeyPrefix?;
    /**
     * @stability stable
     */
    get s3KeyPrefix(): string;
    /**
     * @stability stable
     */
    set s3KeyPrefix(value: string);
    /**
     * @stability stable
     */
    resetS3KeyPrefix(): void;
    /**
     * @stability stable
     */
    get s3KeyPrefixInput(): string | undefined;
    private _snsTopicArn?;
    /**
     * @stability stable
     */
    get snsTopicArn(): string;
    /**
     * @stability stable
     */
    set snsTopicArn(value: string);
    /**
     * @stability stable
     */
    resetSnsTopicArn(): void;
    /**
     * @stability stable
     */
    get snsTopicArnInput(): string | undefined;
    private _snapshotDeliveryProperties?;
    /**
     * @stability stable
     */
    get snapshotDeliveryProperties(): ConfigDeliveryChannelSnapshotDeliveryProperties[];
    /**
     * @stability stable
     */
    set snapshotDeliveryProperties(value: ConfigDeliveryChannelSnapshotDeliveryProperties[]);
    /**
     * @stability stable
     */
    resetSnapshotDeliveryProperties(): void;
    /**
     * @stability stable
     */
    get snapshotDeliveryPropertiesInput(): ConfigDeliveryChannelSnapshotDeliveryProperties[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
