import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ConfigOrganizationCustomRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly excludedAccounts?: string[];
    /**
     * @stability stable
     */
    readonly inputParameters?: string;
    /**
     * @stability stable
     */
    readonly lambdaFunctionArn: string;
    /**
     * @stability stable
     */
    readonly maximumExecutionFrequency?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly resourceIdScope?: string;
    /**
     * @stability stable
     */
    readonly resourceTypesScope?: string[];
    /**
     * @stability stable
     */
    readonly tagKeyScope?: string;
    /**
     * @stability stable
     */
    readonly tagValueScope?: string;
    /**
     * @stability stable
     */
    readonly triggerTypes: string[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: ConfigOrganizationCustomRuleTimeouts;
}
/**
 * @stability stable
 */
export interface ConfigOrganizationCustomRuleTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class ConfigOrganizationCustomRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConfigOrganizationCustomRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _excludedAccounts?;
    /**
     * @stability stable
     */
    get excludedAccounts(): string[];
    /**
     * @stability stable
     */
    set excludedAccounts(value: string[]);
    /**
     * @stability stable
     */
    resetExcludedAccounts(): void;
    /**
     * @stability stable
     */
    get excludedAccountsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _inputParameters?;
    /**
     * @stability stable
     */
    get inputParameters(): string;
    /**
     * @stability stable
     */
    set inputParameters(value: string);
    /**
     * @stability stable
     */
    resetInputParameters(): void;
    /**
     * @stability stable
     */
    get inputParametersInput(): string | undefined;
    private _lambdaFunctionArn;
    /**
     * @stability stable
     */
    get lambdaFunctionArn(): string;
    /**
     * @stability stable
     */
    set lambdaFunctionArn(value: string);
    /**
     * @stability stable
     */
    get lambdaFunctionArnInput(): string;
    private _maximumExecutionFrequency?;
    /**
     * @stability stable
     */
    get maximumExecutionFrequency(): string;
    /**
     * @stability stable
     */
    set maximumExecutionFrequency(value: string);
    /**
     * @stability stable
     */
    resetMaximumExecutionFrequency(): void;
    /**
     * @stability stable
     */
    get maximumExecutionFrequencyInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _resourceIdScope?;
    /**
     * @stability stable
     */
    get resourceIdScope(): string;
    /**
     * @stability stable
     */
    set resourceIdScope(value: string);
    /**
     * @stability stable
     */
    resetResourceIdScope(): void;
    /**
     * @stability stable
     */
    get resourceIdScopeInput(): string | undefined;
    private _resourceTypesScope?;
    /**
     * @stability stable
     */
    get resourceTypesScope(): string[];
    /**
     * @stability stable
     */
    set resourceTypesScope(value: string[]);
    /**
     * @stability stable
     */
    resetResourceTypesScope(): void;
    /**
     * @stability stable
     */
    get resourceTypesScopeInput(): string[] | undefined;
    private _tagKeyScope?;
    /**
     * @stability stable
     */
    get tagKeyScope(): string;
    /**
     * @stability stable
     */
    set tagKeyScope(value: string);
    /**
     * @stability stable
     */
    resetTagKeyScope(): void;
    /**
     * @stability stable
     */
    get tagKeyScopeInput(): string | undefined;
    private _tagValueScope?;
    /**
     * @stability stable
     */
    get tagValueScope(): string;
    /**
     * @stability stable
     */
    set tagValueScope(value: string);
    /**
     * @stability stable
     */
    resetTagValueScope(): void;
    /**
     * @stability stable
     */
    get tagValueScopeInput(): string | undefined;
    private _triggerTypes;
    /**
     * @stability stable
     */
    get triggerTypes(): string[];
    /**
     * @stability stable
     */
    set triggerTypes(value: string[]);
    /**
     * @stability stable
     */
    get triggerTypesInput(): string[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): ConfigOrganizationCustomRuleTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: ConfigOrganizationCustomRuleTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ConfigOrganizationCustomRuleTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
