import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ConfigRemediationConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly configRuleName: string;
    /**
     * @stability stable
     */
    readonly resourceType?: string;
    /**
     * @stability stable
     */
    readonly targetId: string;
    /**
     * @stability stable
     */
    readonly targetType: string;
    /**
     * @stability stable
     */
    readonly targetVersion?: string;
    /**
     * parameter block.
     *
     * @stability stable
     */
    readonly parameter?: ConfigRemediationConfigurationParameter[];
}
/**
 * @stability stable
 */
export interface ConfigRemediationConfigurationParameter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly resourceValue?: string;
    /**
     * @stability stable
     */
    readonly staticValue?: string;
}
/**
 * @stability stable
 */
export declare class ConfigRemediationConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConfigRemediationConfigurationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _configRuleName;
    /**
     * @stability stable
     */
    get configRuleName(): string;
    /**
     * @stability stable
     */
    set configRuleName(value: string);
    /**
     * @stability stable
     */
    get configRuleNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _resourceType?;
    /**
     * @stability stable
     */
    get resourceType(): string;
    /**
     * @stability stable
     */
    set resourceType(value: string);
    /**
     * @stability stable
     */
    resetResourceType(): void;
    /**
     * @stability stable
     */
    get resourceTypeInput(): string | undefined;
    private _targetId;
    /**
     * @stability stable
     */
    get targetId(): string;
    /**
     * @stability stable
     */
    set targetId(value: string);
    /**
     * @stability stable
     */
    get targetIdInput(): string;
    private _targetType;
    /**
     * @stability stable
     */
    get targetType(): string;
    /**
     * @stability stable
     */
    set targetType(value: string);
    /**
     * @stability stable
     */
    get targetTypeInput(): string;
    private _targetVersion?;
    /**
     * @stability stable
     */
    get targetVersion(): string;
    /**
     * @stability stable
     */
    set targetVersion(value: string);
    /**
     * @stability stable
     */
    resetTargetVersion(): void;
    /**
     * @stability stable
     */
    get targetVersionInput(): string | undefined;
    private _parameter?;
    /**
     * @stability stable
     */
    get parameter(): ConfigRemediationConfigurationParameter[];
    /**
     * @stability stable
     */
    set parameter(value: ConfigRemediationConfigurationParameter[]);
    /**
     * @stability stable
     */
    resetParameter(): void;
    /**
     * @stability stable
     */
    get parameterInput(): ConfigRemediationConfigurationParameter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
