import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsAcmCertificateConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly domain: string;
    /**
     * @stability stable
     */
    readonly keyTypes?: string[];
    /**
     * @stability stable
     */
    readonly mostRecent?: boolean;
    /**
     * @stability stable
     */
    readonly statuses?: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly types?: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsAcmCertificate extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsAcmCertificateConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _domain;
    /**
     * @stability stable
     */
    get domain(): string;
    /**
     * @stability stable
     */
    set domain(value: string);
    /**
     * @stability stable
     */
    get domainInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _keyTypes?;
    /**
     * @stability stable
     */
    get keyTypes(): string[];
    /**
     * @stability stable
     */
    set keyTypes(value: string[]);
    /**
     * @stability stable
     */
    resetKeyTypes(): void;
    /**
     * @stability stable
     */
    get keyTypesInput(): string[] | undefined;
    private _mostRecent?;
    /**
     * @stability stable
     */
    get mostRecent(): boolean;
    /**
     * @stability stable
     */
    set mostRecent(value: boolean);
    /**
     * @stability stable
     */
    resetMostRecent(): void;
    /**
     * @stability stable
     */
    get mostRecentInput(): boolean | undefined;
    private _statuses?;
    /**
     * @stability stable
     */
    get statuses(): string[];
    /**
     * @stability stable
     */
    set statuses(value: string[]);
    /**
     * @stability stable
     */
    resetStatuses(): void;
    /**
     * @stability stable
     */
    get statusesInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _types?;
    /**
     * @stability stable
     */
    get types(): string[];
    /**
     * @stability stable
     */
    set types(value: string[]);
    /**
     * @stability stable
     */
    resetTypes(): void;
    /**
     * @stability stable
     */
    get typesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
