import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsAcmpcaCertificateAuthorityConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly arn: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * revocation_configuration block.
     *
     * @stability stable
     */
    readonly revocationConfiguration?: DataAwsAcmpcaCertificateAuthorityRevocationConfiguration[];
}
/**
 * @stability stable
 */
export interface DataAwsAcmpcaCertificateAuthorityRevocationConfigurationCrlConfiguration {
}
/**
 * @stability stable
 */
export interface DataAwsAcmpcaCertificateAuthorityRevocationConfiguration {
    /**
     * crl_configuration block.
     *
     * @stability stable
     */
    readonly crlConfiguration?: DataAwsAcmpcaCertificateAuthorityRevocationConfigurationCrlConfiguration[];
}
/**
 * @stability stable
 */
export declare class DataAwsAcmpcaCertificateAuthority extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsAcmpcaCertificateAuthorityConfig);
    private _arn;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    set arn(value: string);
    /**
     * @stability stable
     */
    get arnInput(): string;
    /**
     * @stability stable
     */
    get certificate(): string;
    /**
     * @stability stable
     */
    get certificateChain(): string;
    /**
     * @stability stable
     */
    get certificateSigningRequest(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get notAfter(): string;
    /**
     * @stability stable
     */
    get notBefore(): string;
    /**
     * @stability stable
     */
    get serial(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get type(): string;
    private _revocationConfiguration?;
    /**
     * @stability stable
     */
    get revocationConfiguration(): DataAwsAcmpcaCertificateAuthorityRevocationConfiguration[];
    /**
     * @stability stable
     */
    set revocationConfiguration(value: DataAwsAcmpcaCertificateAuthorityRevocationConfiguration[]);
    /**
     * @stability stable
     */
    resetRevocationConfiguration(): void;
    /**
     * @stability stable
     */
    get revocationConfigurationInput(): DataAwsAcmpcaCertificateAuthorityRevocationConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
