import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsAlbListenerConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly loadBalancerArn?: string;
    /**
     * @stability stable
     */
    readonly port?: number;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultActionAuthenticateCognito extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get authenticationRequestExtraParams(): any;
    /**
     * @stability stable
     */
    get onUnauthenticatedRequest(): string;
    /**
     * @stability stable
     */
    get scope(): string;
    /**
     * @stability stable
     */
    get sessionCookieName(): string;
    /**
     * @stability stable
     */
    get sessionTimeout(): number;
    /**
     * @stability stable
     */
    get userPoolArn(): string;
    /**
     * @stability stable
     */
    get userPoolClientId(): string;
    /**
     * @stability stable
     */
    get userPoolDomain(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultActionAuthenticateOidc extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get authenticationRequestExtraParams(): any;
    /**
     * @stability stable
     */
    get authorizationEndpoint(): string;
    /**
     * @stability stable
     */
    get clientId(): string;
    /**
     * @stability stable
     */
    get clientSecret(): string;
    /**
     * @stability stable
     */
    get issuer(): string;
    /**
     * @stability stable
     */
    get onUnauthenticatedRequest(): string;
    /**
     * @stability stable
     */
    get scope(): string;
    /**
     * @stability stable
     */
    get sessionCookieName(): string;
    /**
     * @stability stable
     */
    get sessionTimeout(): number;
    /**
     * @stability stable
     */
    get tokenEndpoint(): string;
    /**
     * @stability stable
     */
    get userInfoEndpoint(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultActionFixedResponse extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get contentType(): string;
    /**
     * @stability stable
     */
    get messageBody(): string;
    /**
     * @stability stable
     */
    get statusCode(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultActionForwardStickiness extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get duration(): number;
    /**
     * @stability stable
     */
    get enabled(): boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultActionForwardTargetGroup extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get weight(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultActionForward extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get stickiness(): any;
    /**
     * @stability stable
     */
    get targetGroup(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultActionRedirect extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get host(): string;
    /**
     * @stability stable
     */
    get path(): string;
    /**
     * @stability stable
     */
    get port(): string;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    get query(): string;
    /**
     * @stability stable
     */
    get statusCode(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListenerDefaultAction extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get authenticateCognito(): any;
    /**
     * @stability stable
     */
    get authenticateOidc(): any;
    /**
     * @stability stable
     */
    get fixedResponse(): any;
    /**
     * @stability stable
     */
    get forward(): any;
    /**
     * @stability stable
     */
    get order(): number;
    /**
     * @stability stable
     */
    get redirect(): any;
    /**
     * @stability stable
     */
    get targetGroupArn(): string;
    /**
     * @stability stable
     */
    get type(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbListener extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsAlbListenerConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get certificateArn(): string;
    /**
     * @stability stable
     */
    defaultAction(index: string): DataAwsAlbListenerDefaultAction;
    /**
     * @stability stable
     */
    get id(): string;
    private _loadBalancerArn?;
    /**
     * @stability stable
     */
    get loadBalancerArn(): string;
    /**
     * @stability stable
     */
    set loadBalancerArn(value: string);
    /**
     * @stability stable
     */
    resetLoadBalancerArn(): void;
    /**
     * @stability stable
     */
    get loadBalancerArnInput(): string | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    get sslPolicy(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
