import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsAlbTargetGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsAlbTargetGroupHealthCheck extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    get healthyThreshold(): number;
    /**
     * @stability stable
     */
    get interval(): number;
    /**
     * @stability stable
     */
    get matcher(): string;
    /**
     * @stability stable
     */
    get path(): string;
    /**
     * @stability stable
     */
    get port(): string;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    get timeout(): number;
    /**
     * @stability stable
     */
    get unhealthyThreshold(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbTargetGroupStickiness extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cookieDuration(): number;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    get type(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsAlbTargetGroup extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsAlbTargetGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get arnSuffix(): string;
    /**
     * @stability stable
     */
    get deregistrationDelay(): number;
    /**
     * @stability stable
     */
    healthCheck(index: string): DataAwsAlbTargetGroupHealthCheck;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lambdaMultiValueHeadersEnabled(): boolean;
    /**
     * @stability stable
     */
    get loadBalancingAlgorithmType(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    get protocolVersion(): string;
    /**
     * @stability stable
     */
    get proxyProtocolV2(): boolean;
    /**
     * @stability stable
     */
    get slowStart(): number;
    /**
     * @stability stable
     */
    stickiness(index: string): DataAwsAlbTargetGroupStickiness;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get targetType(): string;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
