import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsAmiIdsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly executableUsers?: string[];
    /**
     * @stability stable
     */
    readonly nameRegex?: string;
    /**
     * @stability stable
     */
    readonly owners: string[];
    /**
     * @stability stable
     */
    readonly sortAscending?: boolean;
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsAmiIdsFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsAmiIdsFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsAmiIds extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsAmiIdsConfig);
    private _executableUsers?;
    /**
     * @stability stable
     */
    get executableUsers(): string[];
    /**
     * @stability stable
     */
    set executableUsers(value: string[]);
    /**
     * @stability stable
     */
    resetExecutableUsers(): void;
    /**
     * @stability stable
     */
    get executableUsersInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ids(): string[];
    private _nameRegex?;
    /**
     * @stability stable
     */
    get nameRegex(): string;
    /**
     * @stability stable
     */
    set nameRegex(value: string);
    /**
     * @stability stable
     */
    resetNameRegex(): void;
    /**
     * @stability stable
     */
    get nameRegexInput(): string | undefined;
    private _owners;
    /**
     * @stability stable
     */
    get owners(): string[];
    /**
     * @stability stable
     */
    set owners(value: string[]);
    /**
     * @stability stable
     */
    get ownersInput(): string[];
    private _sortAscending?;
    /**
     * @stability stable
     */
    get sortAscending(): boolean;
    /**
     * @stability stable
     */
    set sortAscending(value: boolean);
    /**
     * @stability stable
     */
    resetSortAscending(): void;
    /**
     * @stability stable
     */
    get sortAscendingInput(): boolean | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsAmiIdsFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsAmiIdsFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsAmiIdsFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
