import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsAmiConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly executableUsers?: string[];
    /**
     * @stability stable
     */
    readonly mostRecent?: boolean;
    /**
     * @stability stable
     */
    readonly nameRegex?: string;
    /**
     * @stability stable
     */
    readonly owners: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsAmiFilter[];
}
/**
 * @stability stable
 */
export declare class DataAwsAmiBlockDeviceMappings extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get deviceName(): string;
    /**
     * @stability stable
     */
    get ebs(): any;
    /**
     * @stability stable
     */
    get noDevice(): string;
    /**
     * @stability stable
     */
    get virtualName(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsAmiProductCodes extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get productCodeId(): string;
    /**
     * @stability stable
     */
    get productCodeType(): string;
}
/**
 * @stability stable
 */
export interface DataAwsAmiFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsAmi extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsAmiConfig);
    /**
     * @stability stable
     */
    get architecture(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    blockDeviceMappings(index: string): DataAwsAmiBlockDeviceMappings;
    /**
     * @stability stable
     */
    get creationDate(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get enaSupport(): boolean;
    private _executableUsers?;
    /**
     * @stability stable
     */
    get executableUsers(): string[];
    /**
     * @stability stable
     */
    set executableUsers(value: string[]);
    /**
     * @stability stable
     */
    resetExecutableUsers(): void;
    /**
     * @stability stable
     */
    get executableUsersInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get hypervisor(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get imageId(): string;
    /**
     * @stability stable
     */
    get imageLocation(): string;
    /**
     * @stability stable
     */
    get imageOwnerAlias(): string;
    /**
     * @stability stable
     */
    get imageType(): string;
    /**
     * @stability stable
     */
    get kernelId(): string;
    private _mostRecent?;
    /**
     * @stability stable
     */
    get mostRecent(): boolean;
    /**
     * @stability stable
     */
    set mostRecent(value: boolean);
    /**
     * @stability stable
     */
    resetMostRecent(): void;
    /**
     * @stability stable
     */
    get mostRecentInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get name(): string;
    private _nameRegex?;
    /**
     * @stability stable
     */
    get nameRegex(): string;
    /**
     * @stability stable
     */
    set nameRegex(value: string);
    /**
     * @stability stable
     */
    resetNameRegex(): void;
    /**
     * @stability stable
     */
    get nameRegexInput(): string | undefined;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _owners;
    /**
     * @stability stable
     */
    get owners(): string[];
    /**
     * @stability stable
     */
    set owners(value: string[]);
    /**
     * @stability stable
     */
    get ownersInput(): string[];
    /**
     * @stability stable
     */
    get platform(): string;
    /**
     * @stability stable
     */
    get platformDetails(): string;
    /**
     * @stability stable
     */
    productCodes(index: string): DataAwsAmiProductCodes;
    /**
     * @stability stable
     */
    get public(): boolean;
    /**
     * @stability stable
     */
    get ramdiskId(): string;
    /**
     * @stability stable
     */
    get rootDeviceName(): string;
    /**
     * @stability stable
     */
    get rootDeviceType(): string;
    /**
     * @stability stable
     */
    get rootSnapshotId(): string;
    /**
     * @stability stable
     */
    get sriovNetSupport(): string;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    stateReason(key: string): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get usageOperation(): string;
    /**
     * @stability stable
     */
    get virtualizationType(): string;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsAmiFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsAmiFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsAmiFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
