import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsApiGatewayDomainNameConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly domainName: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsApiGatewayDomainNameEndpointConfiguration extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get types(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsApiGatewayDomainName extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsApiGatewayDomainNameConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get certificateArn(): string;
    /**
     * @stability stable
     */
    get certificateName(): string;
    /**
     * @stability stable
     */
    get certificateUploadDate(): string;
    /**
     * @stability stable
     */
    get cloudfrontDomainName(): string;
    /**
     * @stability stable
     */
    get cloudfrontZoneId(): string;
    private _domainName;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string;
    /**
     * @stability stable
     */
    endpointConfiguration(index: string): DataAwsApiGatewayDomainNameEndpointConfiguration;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get regionalCertificateArn(): string;
    /**
     * @stability stable
     */
    get regionalCertificateName(): string;
    /**
     * @stability stable
     */
    get regionalDomainName(): string;
    /**
     * @stability stable
     */
    get regionalZoneId(): string;
    /**
     * @stability stable
     */
    get securityPolicy(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
