import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsApigatewayv2ApiConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly apiId: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsApigatewayv2ApiCorsConfiguration extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get allowCredentials(): boolean;
    /**
     * @stability stable
     */
    get allowHeaders(): string[];
    /**
     * @stability stable
     */
    get allowMethods(): string[];
    /**
     * @stability stable
     */
    get allowOrigins(): string[];
    /**
     * @stability stable
     */
    get exposeHeaders(): string[];
    /**
     * @stability stable
     */
    get maxAge(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsApigatewayv2Api extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsApigatewayv2ApiConfig);
    /**
     * @stability stable
     */
    get apiEndpoint(): string;
    private _apiId;
    /**
     * @stability stable
     */
    get apiId(): string;
    /**
     * @stability stable
     */
    set apiId(value: string);
    /**
     * @stability stable
     */
    get apiIdInput(): string;
    /**
     * @stability stable
     */
    get apiKeySelectionExpression(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    corsConfiguration(index: string): DataAwsApigatewayv2ApiCorsConfiguration;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get disableExecuteApiEndpoint(): boolean;
    /**
     * @stability stable
     */
    get executionArn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get protocolType(): string;
    /**
     * @stability stable
     */
    get routeSelectionExpression(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
