import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsAvailabilityZoneConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly allAvailabilityZones?: boolean;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly state?: string;
    /**
     * @stability stable
     */
    readonly zoneId?: string;
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsAvailabilityZoneFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsAvailabilityZoneFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsAvailabilityZone extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsAvailabilityZoneConfig);
    private _allAvailabilityZones?;
    /**
     * @stability stable
     */
    get allAvailabilityZones(): boolean;
    /**
     * @stability stable
     */
    set allAvailabilityZones(value: boolean);
    /**
     * @stability stable
     */
    resetAllAvailabilityZones(): void;
    /**
     * @stability stable
     */
    get allAvailabilityZonesInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get groupName(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get nameSuffix(): string;
    /**
     * @stability stable
     */
    get networkBorderGroup(): string;
    /**
     * @stability stable
     */
    get optInStatus(): string;
    /**
     * @stability stable
     */
    get parentZoneId(): string;
    /**
     * @stability stable
     */
    get parentZoneName(): string;
    /**
     * @stability stable
     */
    get region(): string;
    private _state?;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    set state(value: string);
    /**
     * @stability stable
     */
    resetState(): void;
    /**
     * @stability stable
     */
    get stateInput(): string | undefined;
    private _zoneId?;
    /**
     * @stability stable
     */
    get zoneId(): string;
    /**
     * @stability stable
     */
    set zoneId(value: string);
    /**
     * @stability stable
     */
    resetZoneId(): void;
    /**
     * @stability stable
     */
    get zoneIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get zoneType(): string;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsAvailabilityZoneFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsAvailabilityZoneFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsAvailabilityZoneFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
