import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsAvailabilityZonesConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly allAvailabilityZones?: boolean;
    /**
     * @stability stable
     */
    readonly excludeNames?: string[];
    /**
     * @stability stable
     */
    readonly excludeZoneIds?: string[];
    /**
     * @stability stable
     */
    readonly state?: string;
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsAvailabilityZonesFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsAvailabilityZonesFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsAvailabilityZones extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsAvailabilityZonesConfig);
    private _allAvailabilityZones?;
    /**
     * @stability stable
     */
    get allAvailabilityZones(): boolean;
    /**
     * @stability stable
     */
    set allAvailabilityZones(value: boolean);
    /**
     * @stability stable
     */
    resetAllAvailabilityZones(): void;
    /**
     * @stability stable
     */
    get allAvailabilityZonesInput(): boolean | undefined;
    private _excludeNames?;
    /**
     * @stability stable
     */
    get excludeNames(): string[];
    /**
     * @stability stable
     */
    set excludeNames(value: string[]);
    /**
     * @stability stable
     */
    resetExcludeNames(): void;
    /**
     * @stability stable
     */
    get excludeNamesInput(): string[] | undefined;
    private _excludeZoneIds?;
    /**
     * @stability stable
     */
    get excludeZoneIds(): string[];
    /**
     * @stability stable
     */
    set excludeZoneIds(value: string[]);
    /**
     * @stability stable
     */
    resetExcludeZoneIds(): void;
    /**
     * @stability stable
     */
    get excludeZoneIdsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get groupNames(): string[];
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get names(): string[];
    private _state?;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    set state(value: string);
    /**
     * @stability stable
     */
    resetState(): void;
    /**
     * @stability stable
     */
    get stateInput(): string | undefined;
    /**
     * @stability stable
     */
    get zoneIds(): string[];
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsAvailabilityZonesFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsAvailabilityZonesFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsAvailabilityZonesFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
