import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsCloudfrontCachePolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly id?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfigCookies extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get items(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginCookiesConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cookieBehavior(): string;
    /**
     * @stability stable
     */
    get cookies(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfigHeaders extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get items(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginHeadersConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get headerBehavior(): string;
    /**
     * @stability stable
     */
    get headers(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfigQueryStrings extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get items(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOriginQueryStringsConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get queryStringBehavior(): string;
    /**
     * @stability stable
     */
    get queryStrings(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOrigin extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cookiesConfig(): any;
    /**
     * @stability stable
     */
    get enableAcceptEncodingBrotli(): boolean;
    /**
     * @stability stable
     */
    get enableAcceptEncodingGzip(): boolean;
    /**
     * @stability stable
     */
    get headersConfig(): any;
    /**
     * @stability stable
     */
    get queryStringsConfig(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontCachePolicy extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsCloudfrontCachePolicyConfig);
    /**
     * @stability stable
     */
    get comment(): string;
    /**
     * @stability stable
     */
    get defaultTtl(): number;
    /**
     * @stability stable
     */
    get etag(): string;
    private _id?;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    set id(value: string);
    /**
     * @stability stable
     */
    resetId(): void;
    /**
     * @stability stable
     */
    get idInput(): string | undefined;
    /**
     * @stability stable
     */
    get maxTtl(): number;
    /**
     * @stability stable
     */
    get minTtl(): number;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    parametersInCacheKeyAndForwardedToOrigin(index: string): DataAwsCloudfrontCachePolicyParametersInCacheKeyAndForwardedToOrigin;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
