import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsCloudfrontOriginRequestPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly id?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontOriginRequestPolicyCookiesConfigCookies extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get items(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontOriginRequestPolicyCookiesConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cookieBehavior(): string;
    /**
     * @stability stable
     */
    get cookies(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontOriginRequestPolicyHeadersConfigHeaders extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get items(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontOriginRequestPolicyHeadersConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get headerBehavior(): string;
    /**
     * @stability stable
     */
    get headers(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontOriginRequestPolicyQueryStringsConfigQueryStrings extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get items(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontOriginRequestPolicyQueryStringsConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get queryStringBehavior(): string;
    /**
     * @stability stable
     */
    get queryStrings(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsCloudfrontOriginRequestPolicy extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsCloudfrontOriginRequestPolicyConfig);
    /**
     * @stability stable
     */
    get comment(): string;
    /**
     * @stability stable
     */
    cookiesConfig(index: string): DataAwsCloudfrontOriginRequestPolicyCookiesConfig;
    /**
     * @stability stable
     */
    get etag(): string;
    /**
     * @stability stable
     */
    headersConfig(index: string): DataAwsCloudfrontOriginRequestPolicyHeadersConfig;
    private _id?;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    set id(value: string);
    /**
     * @stability stable
     */
    resetId(): void;
    /**
     * @stability stable
     */
    get idInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    queryStringsConfig(index: string): DataAwsCloudfrontOriginRequestPolicyQueryStringsConfig;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
