import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsCodeartifactAuthorizationTokenConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly domain: string;
    /**
     * @stability stable
     */
    readonly domainOwner?: string;
    /**
     * @stability stable
     */
    readonly durationSeconds?: number;
}
/**
 * @stability stable
 */
export declare class DataAwsCodeartifactAuthorizationToken extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsCodeartifactAuthorizationTokenConfig);
    /**
     * @stability stable
     */
    get authorizationToken(): string;
    private _domain;
    /**
     * @stability stable
     */
    get domain(): string;
    /**
     * @stability stable
     */
    set domain(value: string);
    /**
     * @stability stable
     */
    get domainInput(): string;
    private _domainOwner?;
    /**
     * @stability stable
     */
    get domainOwner(): string;
    /**
     * @stability stable
     */
    set domainOwner(value: string);
    /**
     * @stability stable
     */
    resetDomainOwner(): void;
    /**
     * @stability stable
     */
    get domainOwnerInput(): string | undefined;
    private _durationSeconds?;
    /**
     * @stability stable
     */
    get durationSeconds(): number;
    /**
     * @stability stable
     */
    set durationSeconds(value: number);
    /**
     * @stability stable
     */
    resetDurationSeconds(): void;
    /**
     * @stability stable
     */
    get durationSecondsInput(): number | undefined;
    /**
     * @stability stable
     */
    get expiration(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
