import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsCodeartifactRepositoryEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly domain: string;
    /**
     * @stability stable
     */
    readonly domainOwner?: string;
    /**
     * @stability stable
     */
    readonly format: string;
    /**
     * @stability stable
     */
    readonly repository: string;
}
/**
 * @stability stable
 */
export declare class DataAwsCodeartifactRepositoryEndpoint extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsCodeartifactRepositoryEndpointConfig);
    private _domain;
    /**
     * @stability stable
     */
    get domain(): string;
    /**
     * @stability stable
     */
    set domain(value: string);
    /**
     * @stability stable
     */
    get domainInput(): string;
    private _domainOwner?;
    /**
     * @stability stable
     */
    get domainOwner(): string;
    /**
     * @stability stable
     */
    set domainOwner(value: string);
    /**
     * @stability stable
     */
    resetDomainOwner(): void;
    /**
     * @stability stable
     */
    get domainOwnerInput(): string | undefined;
    private _format;
    /**
     * @stability stable
     */
    get format(): string;
    /**
     * @stability stable
     */
    set format(value: string);
    /**
     * @stability stable
     */
    get formatInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _repository;
    /**
     * @stability stable
     */
    get repository(): string;
    /**
     * @stability stable
     */
    set repository(value: string);
    /**
     * @stability stable
     */
    get repositoryInput(): string;
    /**
     * @stability stable
     */
    get repositoryEndpoint(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
