import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsCurReportDefinitionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly reportName: string;
}
/**
 * @stability stable
 */
export declare class DataAwsCurReportDefinition extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsCurReportDefinitionConfig);
    /**
     * @stability stable
     */
    get additionalArtifacts(): string[];
    /**
     * @stability stable
     */
    get additionalSchemaElements(): string[];
    /**
     * @stability stable
     */
    get compression(): string;
    /**
     * @stability stable
     */
    get format(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get refreshClosedReports(): boolean;
    private _reportName;
    /**
     * @stability stable
     */
    get reportName(): string;
    /**
     * @stability stable
     */
    set reportName(value: string);
    /**
     * @stability stable
     */
    get reportNameInput(): string;
    /**
     * @stability stable
     */
    get reportVersioning(): string;
    /**
     * @stability stable
     */
    get s3Bucket(): string;
    /**
     * @stability stable
     */
    get s3Prefix(): string;
    /**
     * @stability stable
     */
    get s3Region(): string;
    /**
     * @stability stable
     */
    get timeUnit(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
