import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsDbClusterSnapshotConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly dbClusterIdentifier?: string;
    /**
     * @stability stable
     */
    readonly dbClusterSnapshotIdentifier?: string;
    /**
     * @stability stable
     */
    readonly includePublic?: boolean;
    /**
     * @stability stable
     */
    readonly includeShared?: boolean;
    /**
     * @stability stable
     */
    readonly mostRecent?: boolean;
    /**
     * @stability stable
     */
    readonly snapshotType?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsDbClusterSnapshot extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsDbClusterSnapshotConfig);
    /**
     * @stability stable
     */
    get allocatedStorage(): number;
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    private _dbClusterIdentifier?;
    /**
     * @stability stable
     */
    get dbClusterIdentifier(): string;
    /**
     * @stability stable
     */
    set dbClusterIdentifier(value: string);
    /**
     * @stability stable
     */
    resetDbClusterIdentifier(): void;
    /**
     * @stability stable
     */
    get dbClusterIdentifierInput(): string | undefined;
    /**
     * @stability stable
     */
    get dbClusterSnapshotArn(): string;
    private _dbClusterSnapshotIdentifier?;
    /**
     * @stability stable
     */
    get dbClusterSnapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set dbClusterSnapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    resetDbClusterSnapshotIdentifier(): void;
    /**
     * @stability stable
     */
    get dbClusterSnapshotIdentifierInput(): string | undefined;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _includePublic?;
    /**
     * @stability stable
     */
    get includePublic(): boolean;
    /**
     * @stability stable
     */
    set includePublic(value: boolean);
    /**
     * @stability stable
     */
    resetIncludePublic(): void;
    /**
     * @stability stable
     */
    get includePublicInput(): boolean | undefined;
    private _includeShared?;
    /**
     * @stability stable
     */
    get includeShared(): boolean;
    /**
     * @stability stable
     */
    set includeShared(value: boolean);
    /**
     * @stability stable
     */
    resetIncludeShared(): void;
    /**
     * @stability stable
     */
    get includeSharedInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    get licenseModel(): string;
    private _mostRecent?;
    /**
     * @stability stable
     */
    get mostRecent(): boolean;
    /**
     * @stability stable
     */
    set mostRecent(value: boolean);
    /**
     * @stability stable
     */
    resetMostRecent(): void;
    /**
     * @stability stable
     */
    get mostRecentInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    get snapshotCreateTime(): string;
    private _snapshotType?;
    /**
     * @stability stable
     */
    get snapshotType(): string;
    /**
     * @stability stable
     */
    set snapshotType(value: string);
    /**
     * @stability stable
     */
    resetSnapshotType(): void;
    /**
     * @stability stable
     */
    get snapshotTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get sourceDbClusterSnapshotArn(): string;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get storageEncrypted(): boolean;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
