import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsDbInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly dbInstanceIdentifier: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsDbInstance extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsDbInstanceConfig);
    /**
     * @stability stable
     */
    get address(): string;
    /**
     * @stability stable
     */
    get allocatedStorage(): number;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgrade(): boolean;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    get backupRetentionPeriod(): number;
    /**
     * @stability stable
     */
    get caCertIdentifier(): string;
    /**
     * @stability stable
     */
    get dbClusterIdentifier(): string;
    /**
     * @stability stable
     */
    get dbInstanceArn(): string;
    /**
     * @stability stable
     */
    get dbInstanceClass(): string;
    private _dbInstanceIdentifier;
    /**
     * @stability stable
     */
    get dbInstanceIdentifier(): string;
    /**
     * @stability stable
     */
    set dbInstanceIdentifier(value: string);
    /**
     * @stability stable
     */
    get dbInstanceIdentifierInput(): string;
    /**
     * @stability stable
     */
    get dbInstancePort(): number;
    /**
     * @stability stable
     */
    get dbName(): string;
    /**
     * @stability stable
     */
    get dbParameterGroups(): string[];
    /**
     * @stability stable
     */
    get dbSecurityGroups(): string[];
    /**
     * @stability stable
     */
    get dbSubnetGroup(): string;
    /**
     * @stability stable
     */
    get enabledCloudwatchLogsExports(): string[];
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    get hostedZoneId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get iops(): number;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    get licenseModel(): string;
    /**
     * @stability stable
     */
    get masterUsername(): string;
    /**
     * @stability stable
     */
    get monitoringInterval(): number;
    /**
     * @stability stable
     */
    get monitoringRoleArn(): string;
    /**
     * @stability stable
     */
    get multiAz(): boolean;
    /**
     * @stability stable
     */
    get optionGroupMemberships(): string[];
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    get preferredBackupWindow(): string;
    /**
     * @stability stable
     */
    get preferredMaintenanceWindow(): string;
    /**
     * @stability stable
     */
    get publiclyAccessible(): boolean;
    /**
     * @stability stable
     */
    get replicateSourceDb(): string;
    /**
     * @stability stable
     */
    get resourceId(): string;
    /**
     * @stability stable
     */
    get storageEncrypted(): boolean;
    /**
     * @stability stable
     */
    get storageType(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get timezone(): string;
    /**
     * @stability stable
     */
    get vpcSecurityGroups(): string[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
