import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsDbSnapshotConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly dbInstanceIdentifier?: string;
    /**
     * @stability stable
     */
    readonly dbSnapshotIdentifier?: string;
    /**
     * @stability stable
     */
    readonly includePublic?: boolean;
    /**
     * @stability stable
     */
    readonly includeShared?: boolean;
    /**
     * @stability stable
     */
    readonly mostRecent?: boolean;
    /**
     * @stability stable
     */
    readonly snapshotType?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsDbSnapshot extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsDbSnapshotConfig);
    /**
     * @stability stable
     */
    get allocatedStorage(): number;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    private _dbInstanceIdentifier?;
    /**
     * @stability stable
     */
    get dbInstanceIdentifier(): string;
    /**
     * @stability stable
     */
    set dbInstanceIdentifier(value: string);
    /**
     * @stability stable
     */
    resetDbInstanceIdentifier(): void;
    /**
     * @stability stable
     */
    get dbInstanceIdentifierInput(): string | undefined;
    /**
     * @stability stable
     */
    get dbSnapshotArn(): string;
    private _dbSnapshotIdentifier?;
    /**
     * @stability stable
     */
    get dbSnapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set dbSnapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    resetDbSnapshotIdentifier(): void;
    /**
     * @stability stable
     */
    get dbSnapshotIdentifierInput(): string | undefined;
    /**
     * @stability stable
     */
    get encrypted(): boolean;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _includePublic?;
    /**
     * @stability stable
     */
    get includePublic(): boolean;
    /**
     * @stability stable
     */
    set includePublic(value: boolean);
    /**
     * @stability stable
     */
    resetIncludePublic(): void;
    /**
     * @stability stable
     */
    get includePublicInput(): boolean | undefined;
    private _includeShared?;
    /**
     * @stability stable
     */
    get includeShared(): boolean;
    /**
     * @stability stable
     */
    set includeShared(value: boolean);
    /**
     * @stability stable
     */
    resetIncludeShared(): void;
    /**
     * @stability stable
     */
    get includeSharedInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get iops(): number;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    get licenseModel(): string;
    private _mostRecent?;
    /**
     * @stability stable
     */
    get mostRecent(): boolean;
    /**
     * @stability stable
     */
    set mostRecent(value: boolean);
    /**
     * @stability stable
     */
    resetMostRecent(): void;
    /**
     * @stability stable
     */
    get mostRecentInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get optionGroupName(): string;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    get snapshotCreateTime(): string;
    private _snapshotType?;
    /**
     * @stability stable
     */
    get snapshotType(): string;
    /**
     * @stability stable
     */
    set snapshotType(value: string);
    /**
     * @stability stable
     */
    resetSnapshotType(): void;
    /**
     * @stability stable
     */
    get snapshotTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get sourceDbSnapshotIdentifier(): string;
    /**
     * @stability stable
     */
    get sourceRegion(): string;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
