import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsDocdbEngineVersionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly engine?: string;
    /**
     * @stability stable
     */
    readonly parameterGroupFamily?: string;
    /**
     * @stability stable
     */
    readonly preferredVersions?: string[];
    /**
     * @stability stable
     */
    readonly version?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsDocdbEngineVersion extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsDocdbEngineVersionConfig);
    private _engine?;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    resetEngine(): void;
    /**
     * @stability stable
     */
    get engineInput(): string | undefined;
    /**
     * @stability stable
     */
    get engineDescription(): string;
    /**
     * @stability stable
     */
    get exportableLogTypes(): string[];
    /**
     * @stability stable
     */
    get id(): string;
    private _parameterGroupFamily?;
    /**
     * @stability stable
     */
    get parameterGroupFamily(): string;
    /**
     * @stability stable
     */
    set parameterGroupFamily(value: string);
    /**
     * @stability stable
     */
    resetParameterGroupFamily(): void;
    /**
     * @stability stable
     */
    get parameterGroupFamilyInput(): string | undefined;
    private _preferredVersions?;
    /**
     * @stability stable
     */
    get preferredVersions(): string[];
    /**
     * @stability stable
     */
    set preferredVersions(value: string[]);
    /**
     * @stability stable
     */
    resetPreferredVersions(): void;
    /**
     * @stability stable
     */
    get preferredVersionsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get supportsLogExportsToCloudwatch(): boolean;
    /**
     * @stability stable
     */
    get validUpgradeTargets(): string[];
    private _version?;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): string | undefined;
    /**
     * @stability stable
     */
    get versionDescription(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
