import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsDocdbOrderableDbInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly engine?: string;
    /**
     * @stability stable
     */
    readonly engineVersion?: string;
    /**
     * @stability stable
     */
    readonly instanceClass?: string;
    /**
     * @stability stable
     */
    readonly licenseModel?: string;
    /**
     * @stability stable
     */
    readonly preferredInstanceClasses?: string[];
    /**
     * @stability stable
     */
    readonly vpc?: boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsDocdbOrderableDbInstance extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsDocdbOrderableDbInstanceConfig);
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    private _engine?;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    resetEngine(): void;
    /**
     * @stability stable
     */
    get engineInput(): string | undefined;
    private _engineVersion?;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    set engineVersion(value: string);
    /**
     * @stability stable
     */
    resetEngineVersion(): void;
    /**
     * @stability stable
     */
    get engineVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceClass?;
    /**
     * @stability stable
     */
    get instanceClass(): string;
    /**
     * @stability stable
     */
    set instanceClass(value: string);
    /**
     * @stability stable
     */
    resetInstanceClass(): void;
    /**
     * @stability stable
     */
    get instanceClassInput(): string | undefined;
    private _licenseModel?;
    /**
     * @stability stable
     */
    get licenseModel(): string;
    /**
     * @stability stable
     */
    set licenseModel(value: string);
    /**
     * @stability stable
     */
    resetLicenseModel(): void;
    /**
     * @stability stable
     */
    get licenseModelInput(): string | undefined;
    private _preferredInstanceClasses?;
    /**
     * @stability stable
     */
    get preferredInstanceClasses(): string[];
    /**
     * @stability stable
     */
    set preferredInstanceClasses(value: string[]);
    /**
     * @stability stable
     */
    resetPreferredInstanceClasses(): void;
    /**
     * @stability stable
     */
    get preferredInstanceClassesInput(): string[] | undefined;
    private _vpc?;
    /**
     * @stability stable
     */
    get vpc(): boolean;
    /**
     * @stability stable
     */
    set vpc(value: boolean);
    /**
     * @stability stable
     */
    resetVpc(): void;
    /**
     * @stability stable
     */
    get vpcInput(): boolean | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
