import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsDynamodbTableConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * server_side_encryption block.
     *
     * @stability stable
     */
    readonly serverSideEncryption?: DataAwsDynamodbTableServerSideEncryption[];
}
/**
 * @stability stable
 */
export declare class DataAwsDynamodbTableAttribute extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get type(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsDynamodbTableGlobalSecondaryIndex extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get hashKey(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get nonKeyAttributes(): string[];
    /**
     * @stability stable
     */
    get projectionType(): string;
    /**
     * @stability stable
     */
    get rangeKey(): string;
    /**
     * @stability stable
     */
    get readCapacity(): number;
    /**
     * @stability stable
     */
    get writeCapacity(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsDynamodbTableLocalSecondaryIndex extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get nonKeyAttributes(): string[];
    /**
     * @stability stable
     */
    get projectionType(): string;
    /**
     * @stability stable
     */
    get rangeKey(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsDynamodbTablePointInTimeRecovery extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsDynamodbTableReplica extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get regionName(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsDynamodbTableTtl extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get attributeName(): string;
    /**
     * @stability stable
     */
    get enabled(): boolean;
}
/**
 * @stability stable
 */
export interface DataAwsDynamodbTableServerSideEncryption {
}
/**
 * @stability stable
 */
export declare class DataAwsDynamodbTable extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsDynamodbTableConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    attribute(index: string): DataAwsDynamodbTableAttribute;
    /**
     * @stability stable
     */
    get billingMode(): string;
    /**
     * @stability stable
     */
    globalSecondaryIndex(index: string): DataAwsDynamodbTableGlobalSecondaryIndex;
    /**
     * @stability stable
     */
    get hashKey(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    localSecondaryIndex(index: string): DataAwsDynamodbTableLocalSecondaryIndex;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    pointInTimeRecovery(index: string): DataAwsDynamodbTablePointInTimeRecovery;
    /**
     * @stability stable
     */
    get rangeKey(): string;
    /**
     * @stability stable
     */
    get readCapacity(): number;
    /**
     * @stability stable
     */
    replica(index: string): DataAwsDynamodbTableReplica;
    /**
     * @stability stable
     */
    get streamArn(): string;
    /**
     * @stability stable
     */
    get streamEnabled(): boolean;
    /**
     * @stability stable
     */
    get streamLabel(): string;
    /**
     * @stability stable
     */
    get streamViewType(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    ttl(index: string): DataAwsDynamodbTableTtl;
    /**
     * @stability stable
     */
    get writeCapacity(): number;
    private _serverSideEncryption?;
    /**
     * @stability stable
     */
    get serverSideEncryption(): DataAwsDynamodbTableServerSideEncryption[];
    /**
     * @stability stable
     */
    set serverSideEncryption(value: DataAwsDynamodbTableServerSideEncryption[]);
    /**
     * @stability stable
     */
    resetServerSideEncryption(): void;
    /**
     * @stability stable
     */
    get serverSideEncryptionInput(): DataAwsDynamodbTableServerSideEncryption[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
