import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEbsSnapshotIdsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly owners?: string[];
    /**
     * @stability stable
     */
    readonly restorableByUserIds?: string[];
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsEbsSnapshotIdsFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEbsSnapshotIdsFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEbsSnapshotIds extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEbsSnapshotIdsConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ids(): string[];
    private _owners?;
    /**
     * @stability stable
     */
    get owners(): string[];
    /**
     * @stability stable
     */
    set owners(value: string[]);
    /**
     * @stability stable
     */
    resetOwners(): void;
    /**
     * @stability stable
     */
    get ownersInput(): string[] | undefined;
    private _restorableByUserIds?;
    /**
     * @stability stable
     */
    get restorableByUserIds(): string[];
    /**
     * @stability stable
     */
    set restorableByUserIds(value: string[]);
    /**
     * @stability stable
     */
    resetRestorableByUserIds(): void;
    /**
     * @stability stable
     */
    get restorableByUserIdsInput(): string[] | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEbsSnapshotIdsFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEbsSnapshotIdsFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEbsSnapshotIdsFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
