import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEbsSnapshotConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly mostRecent?: boolean;
    /**
     * @stability stable
     */
    readonly owners?: string[];
    /**
     * @stability stable
     */
    readonly restorableByUserIds?: string[];
    /**
     * @stability stable
     */
    readonly snapshotIds?: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsEbsSnapshotFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEbsSnapshotFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEbsSnapshot extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEbsSnapshotConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get dataEncryptionKeyId(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get encrypted(): boolean;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    private _mostRecent?;
    /**
     * @stability stable
     */
    get mostRecent(): boolean;
    /**
     * @stability stable
     */
    set mostRecent(value: boolean);
    /**
     * @stability stable
     */
    resetMostRecent(): void;
    /**
     * @stability stable
     */
    get mostRecentInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get ownerAlias(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _owners?;
    /**
     * @stability stable
     */
    get owners(): string[];
    /**
     * @stability stable
     */
    set owners(value: string[]);
    /**
     * @stability stable
     */
    resetOwners(): void;
    /**
     * @stability stable
     */
    get ownersInput(): string[] | undefined;
    private _restorableByUserIds?;
    /**
     * @stability stable
     */
    get restorableByUserIds(): string[];
    /**
     * @stability stable
     */
    set restorableByUserIds(value: string[]);
    /**
     * @stability stable
     */
    resetRestorableByUserIds(): void;
    /**
     * @stability stable
     */
    get restorableByUserIdsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get snapshotId(): string;
    private _snapshotIds?;
    /**
     * @stability stable
     */
    get snapshotIds(): string[];
    /**
     * @stability stable
     */
    set snapshotIds(value: string[]);
    /**
     * @stability stable
     */
    resetSnapshotIds(): void;
    /**
     * @stability stable
     */
    get snapshotIdsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get state(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get volumeId(): string;
    /**
     * @stability stable
     */
    get volumeSize(): number;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEbsSnapshotFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEbsSnapshotFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEbsSnapshotFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
