import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEbsVolumesConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsEbsVolumesFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEbsVolumesFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEbsVolumes extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEbsVolumesConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ids(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEbsVolumesFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEbsVolumesFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEbsVolumesFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
