import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEc2CoipPoolConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly localGatewayRouteTableId?: string;
    /**
     * @stability stable
     */
    readonly poolId?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsEc2CoipPoolFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEc2CoipPoolFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEc2CoipPool extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEc2CoipPoolConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _localGatewayRouteTableId?;
    /**
     * @stability stable
     */
    get localGatewayRouteTableId(): string;
    /**
     * @stability stable
     */
    set localGatewayRouteTableId(value: string);
    /**
     * @stability stable
     */
    resetLocalGatewayRouteTableId(): void;
    /**
     * @stability stable
     */
    get localGatewayRouteTableIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get poolCidrs(): string[];
    private _poolId?;
    /**
     * @stability stable
     */
    get poolId(): string;
    /**
     * @stability stable
     */
    set poolId(value: string);
    /**
     * @stability stable
     */
    resetPoolId(): void;
    /**
     * @stability stable
     */
    get poolIdInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEc2CoipPoolFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEc2CoipPoolFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEc2CoipPoolFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
