import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEc2CoipPoolsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsEc2CoipPoolsFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEc2CoipPoolsFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEc2CoipPools extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEc2CoipPoolsConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get poolIds(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEc2CoipPoolsFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEc2CoipPoolsFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEc2CoipPoolsFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
