import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEc2InstanceTypeOfferingConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly locationType?: string;
    /**
     * @stability stable
     */
    readonly preferredInstanceTypes?: string[];
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsEc2InstanceTypeOfferingFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEc2InstanceTypeOfferingFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEc2InstanceTypeOffering extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEc2InstanceTypeOfferingConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get instanceType(): string;
    private _locationType?;
    /**
     * @stability stable
     */
    get locationType(): string;
    /**
     * @stability stable
     */
    set locationType(value: string);
    /**
     * @stability stable
     */
    resetLocationType(): void;
    /**
     * @stability stable
     */
    get locationTypeInput(): string | undefined;
    private _preferredInstanceTypes?;
    /**
     * @stability stable
     */
    get preferredInstanceTypes(): string[];
    /**
     * @stability stable
     */
    set preferredInstanceTypes(value: string[]);
    /**
     * @stability stable
     */
    resetPreferredInstanceTypes(): void;
    /**
     * @stability stable
     */
    get preferredInstanceTypesInput(): string[] | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEc2InstanceTypeOfferingFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEc2InstanceTypeOfferingFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEc2InstanceTypeOfferingFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
