import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEc2InstanceTypeOfferingsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly locationType?: string;
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsEc2InstanceTypeOfferingsFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEc2InstanceTypeOfferingsFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEc2InstanceTypeOfferings extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEc2InstanceTypeOfferingsConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get instanceTypes(): string[];
    private _locationType?;
    /**
     * @stability stable
     */
    get locationType(): string;
    /**
     * @stability stable
     */
    set locationType(value: string);
    /**
     * @stability stable
     */
    resetLocationType(): void;
    /**
     * @stability stable
     */
    get locationTypeInput(): string | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEc2InstanceTypeOfferingsFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEc2InstanceTypeOfferingsFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEc2InstanceTypeOfferingsFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
