import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEc2LocalGatewayRouteTableConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly localGatewayId?: string;
    /**
     * @stability stable
     */
    readonly localGatewayRouteTableId?: string;
    /**
     * @stability stable
     */
    readonly outpostArn?: string;
    /**
     * @stability stable
     */
    readonly state?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsEc2LocalGatewayRouteTableFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEc2LocalGatewayRouteTableFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEc2LocalGatewayRouteTable extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEc2LocalGatewayRouteTableConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _localGatewayId?;
    /**
     * @stability stable
     */
    get localGatewayId(): string;
    /**
     * @stability stable
     */
    set localGatewayId(value: string);
    /**
     * @stability stable
     */
    resetLocalGatewayId(): void;
    /**
     * @stability stable
     */
    get localGatewayIdInput(): string | undefined;
    private _localGatewayRouteTableId?;
    /**
     * @stability stable
     */
    get localGatewayRouteTableId(): string;
    /**
     * @stability stable
     */
    set localGatewayRouteTableId(value: string);
    /**
     * @stability stable
     */
    resetLocalGatewayRouteTableId(): void;
    /**
     * @stability stable
     */
    get localGatewayRouteTableIdInput(): string | undefined;
    private _outpostArn?;
    /**
     * @stability stable
     */
    get outpostArn(): string;
    /**
     * @stability stable
     */
    set outpostArn(value: string);
    /**
     * @stability stable
     */
    resetOutpostArn(): void;
    /**
     * @stability stable
     */
    get outpostArnInput(): string | undefined;
    private _state?;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    set state(value: string);
    /**
     * @stability stable
     */
    resetState(): void;
    /**
     * @stability stable
     */
    get stateInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEc2LocalGatewayRouteTableFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEc2LocalGatewayRouteTableFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEc2LocalGatewayRouteTableFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
