import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEc2LocalGatewayVirtualInterfaceGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly localGatewayId?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsEc2LocalGatewayVirtualInterfaceGroupFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEc2LocalGatewayVirtualInterfaceGroupFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEc2LocalGatewayVirtualInterfaceGroup extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEc2LocalGatewayVirtualInterfaceGroupConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _localGatewayId?;
    /**
     * @stability stable
     */
    get localGatewayId(): string;
    /**
     * @stability stable
     */
    set localGatewayId(value: string);
    /**
     * @stability stable
     */
    resetLocalGatewayId(): void;
    /**
     * @stability stable
     */
    get localGatewayIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get localGatewayVirtualInterfaceIds(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEc2LocalGatewayVirtualInterfaceGroupFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEc2LocalGatewayVirtualInterfaceGroupFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEc2LocalGatewayVirtualInterfaceGroupFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
