import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEc2LocalGatewayVirtualInterfaceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsEc2LocalGatewayVirtualInterfaceFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEc2LocalGatewayVirtualInterfaceFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEc2LocalGatewayVirtualInterface extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEc2LocalGatewayVirtualInterfaceConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get localAddress(): string;
    /**
     * @stability stable
     */
    get localBgpAsn(): number;
    /**
     * @stability stable
     */
    get localGatewayId(): string;
    /**
     * @stability stable
     */
    get localGatewayVirtualInterfaceIds(): string[];
    /**
     * @stability stable
     */
    get peerAddress(): string;
    /**
     * @stability stable
     */
    get peerBgpAsn(): number;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get vlan(): number;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEc2LocalGatewayVirtualInterfaceFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEc2LocalGatewayVirtualInterfaceFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEc2LocalGatewayVirtualInterfaceFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
