import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEc2ManagedPrefixListConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsEc2ManagedPrefixListFilter[];
}
/**
 * @stability stable
 */
export declare class DataAwsEc2ManagedPrefixListEntries extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cidr(): string;
    /**
     * @stability stable
     */
    get description(): string;
}
/**
 * @stability stable
 */
export interface DataAwsEc2ManagedPrefixListFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEc2ManagedPrefixList extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEc2ManagedPrefixListConfig);
    /**
     * @stability stable
     */
    get addressFamily(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    entries(index: string): DataAwsEc2ManagedPrefixListEntries;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get maxEntries(): number;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get version(): number;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEc2ManagedPrefixListFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEc2ManagedPrefixListFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEc2ManagedPrefixListFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
