import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEc2SpotPriceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsEc2SpotPriceFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEc2SpotPriceFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEc2SpotPrice extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEc2SpotPriceConfig);
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    resetInstanceType(): void;
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get spotPrice(): string;
    /**
     * @stability stable
     */
    get spotPriceTimestamp(): string;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEc2SpotPriceFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEc2SpotPriceFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEc2SpotPriceFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
