import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEc2TransitGatewayVpcAttachmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsEc2TransitGatewayVpcAttachmentFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEc2TransitGatewayVpcAttachmentFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEc2TransitGatewayVpcAttachment extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEc2TransitGatewayVpcAttachmentConfig);
    /**
     * @stability stable
     */
    get applianceModeSupport(): string;
    /**
     * @stability stable
     */
    get dnsSupport(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ipv6Support(): string;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get transitGatewayId(): string;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    get vpcOwnerId(): string;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEc2TransitGatewayVpcAttachmentFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEc2TransitGatewayVpcAttachmentFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEc2TransitGatewayVpcAttachmentFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
