import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEc2TransitGatewayConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsEc2TransitGatewayFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEc2TransitGatewayFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEc2TransitGateway extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEc2TransitGatewayConfig);
    /**
     * @stability stable
     */
    get amazonSideAsn(): number;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get associationDefaultRouteTableId(): string;
    /**
     * @stability stable
     */
    get autoAcceptSharedAttachments(): string;
    /**
     * @stability stable
     */
    get defaultRouteTableAssociation(): string;
    /**
     * @stability stable
     */
    get defaultRouteTablePropagation(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get dnsSupport(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    get propagationDefaultRouteTableId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get vpnEcmpSupport(): string;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEc2TransitGatewayFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEc2TransitGatewayFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEc2TransitGatewayFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
