import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEcrAuthorizationTokenConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly registryId?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsEcrAuthorizationToken extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEcrAuthorizationTokenConfig);
    /**
     * @stability stable
     */
    get authorizationToken(): string;
    /**
     * @stability stable
     */
    get expiresAt(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get password(): string;
    /**
     * @stability stable
     */
    get proxyEndpoint(): string;
    private _registryId?;
    /**
     * @stability stable
     */
    get registryId(): string;
    /**
     * @stability stable
     */
    set registryId(value: string);
    /**
     * @stability stable
     */
    resetRegistryId(): void;
    /**
     * @stability stable
     */
    get registryIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get userName(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
