import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEcrImageConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly imageDigest?: string;
    /**
     * @stability stable
     */
    readonly imageTag?: string;
    /**
     * @stability stable
     */
    readonly registryId?: string;
    /**
     * @stability stable
     */
    readonly repositoryName: string;
}
/**
 * @stability stable
 */
export declare class DataAwsEcrImage extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsEcrImageConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _imageDigest?;
    /**
     * @stability stable
     */
    get imageDigest(): string;
    /**
     * @stability stable
     */
    set imageDigest(value: string);
    /**
     * @stability stable
     */
    resetImageDigest(): void;
    /**
     * @stability stable
     */
    get imageDigestInput(): string | undefined;
    /**
     * @stability stable
     */
    get imagePushedAt(): number;
    /**
     * @stability stable
     */
    get imageSizeInBytes(): number;
    private _imageTag?;
    /**
     * @stability stable
     */
    get imageTag(): string;
    /**
     * @stability stable
     */
    set imageTag(value: string);
    /**
     * @stability stable
     */
    resetImageTag(): void;
    /**
     * @stability stable
     */
    get imageTagInput(): string | undefined;
    /**
     * @stability stable
     */
    get imageTags(): string[];
    private _registryId?;
    /**
     * @stability stable
     */
    get registryId(): string;
    /**
     * @stability stable
     */
    set registryId(value: string);
    /**
     * @stability stable
     */
    resetRegistryId(): void;
    /**
     * @stability stable
     */
    get registryIdInput(): string | undefined;
    private _repositoryName;
    /**
     * @stability stable
     */
    get repositoryName(): string;
    /**
     * @stability stable
     */
    set repositoryName(value: string);
    /**
     * @stability stable
     */
    get repositoryNameInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
