import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEcsContainerDefinitionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly containerName: string;
    /**
     * @stability stable
     */
    readonly taskDefinition: string;
}
/**
 * @stability stable
 */
export declare class DataAwsEcsContainerDefinition extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsEcsContainerDefinitionConfig);
    private _containerName;
    /**
     * @stability stable
     */
    get containerName(): string;
    /**
     * @stability stable
     */
    set containerName(value: string);
    /**
     * @stability stable
     */
    get containerNameInput(): string;
    /**
     * @stability stable
     */
    get cpu(): number;
    /**
     * @stability stable
     */
    get disableNetworking(): boolean;
    /**
     * @stability stable
     */
    dockerLabels(key: string): string;
    /**
     * @stability stable
     */
    environment(key: string): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get image(): string;
    /**
     * @stability stable
     */
    get imageDigest(): string;
    /**
     * @stability stable
     */
    get memory(): number;
    /**
     * @stability stable
     */
    get memoryReservation(): number;
    private _taskDefinition;
    /**
     * @stability stable
     */
    get taskDefinition(): string;
    /**
     * @stability stable
     */
    set taskDefinition(value: string);
    /**
     * @stability stable
     */
    get taskDefinitionInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
