import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEfsAccessPointConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly accessPointId: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsEfsAccessPointPosixUser extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get gid(): number;
    /**
     * @stability stable
     */
    get secondaryGids(): any;
    /**
     * @stability stable
     */
    get uid(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsEfsAccessPointRootDirectoryCreationInfo extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get ownerGid(): number;
    /**
     * @stability stable
     */
    get ownerUid(): number;
    /**
     * @stability stable
     */
    get permissions(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsEfsAccessPointRootDirectory extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get creationInfo(): any;
    /**
     * @stability stable
     */
    get path(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsEfsAccessPoint extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsEfsAccessPointConfig);
    private _accessPointId;
    /**
     * @stability stable
     */
    get accessPointId(): string;
    /**
     * @stability stable
     */
    set accessPointId(value: string);
    /**
     * @stability stable
     */
    get accessPointIdInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get fileSystemArn(): string;
    /**
     * @stability stable
     */
    get fileSystemId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    posixUser(index: string): DataAwsEfsAccessPointPosixUser;
    /**
     * @stability stable
     */
    rootDirectory(index: string): DataAwsEfsAccessPointRootDirectory;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
