import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEfsFileSystemConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly creationToken?: string;
    /**
     * @stability stable
     */
    readonly fileSystemId?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsEfsFileSystemLifecyclePolicy extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get transitionToIa(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsEfsFileSystem extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEfsFileSystemConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _creationToken?;
    /**
     * @stability stable
     */
    get creationToken(): string;
    /**
     * @stability stable
     */
    set creationToken(value: string);
    /**
     * @stability stable
     */
    resetCreationToken(): void;
    /**
     * @stability stable
     */
    get creationTokenInput(): string | undefined;
    /**
     * @stability stable
     */
    get dnsName(): string;
    /**
     * @stability stable
     */
    get encrypted(): boolean;
    private _fileSystemId?;
    /**
     * @stability stable
     */
    get fileSystemId(): string;
    /**
     * @stability stable
     */
    set fileSystemId(value: string);
    /**
     * @stability stable
     */
    resetFileSystemId(): void;
    /**
     * @stability stable
     */
    get fileSystemIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    lifecyclePolicy(index: string): DataAwsEfsFileSystemLifecyclePolicy;
    /**
     * @stability stable
     */
    get performanceMode(): string;
    /**
     * @stability stable
     */
    get provisionedThroughputInMibps(): number;
    /**
     * @stability stable
     */
    get sizeInBytes(): number;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get throughputMode(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
