import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEfsMountTargetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly mountTargetId: string;
}
/**
 * @stability stable
 */
export declare class DataAwsEfsMountTarget extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsEfsMountTargetConfig);
    /**
     * @stability stable
     */
    get availabilityZoneId(): string;
    /**
     * @stability stable
     */
    get availabilityZoneName(): string;
    /**
     * @stability stable
     */
    get dnsName(): string;
    /**
     * @stability stable
     */
    get fileSystemArn(): string;
    /**
     * @stability stable
     */
    get fileSystemId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ipAddress(): string;
    /**
     * @stability stable
     */
    get mountTargetDnsName(): string;
    private _mountTargetId;
    /**
     * @stability stable
     */
    get mountTargetId(): string;
    /**
     * @stability stable
     */
    set mountTargetId(value: string);
    /**
     * @stability stable
     */
    get mountTargetIdInput(): string;
    /**
     * @stability stable
     */
    get networkInterfaceId(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
