import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsEipConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly publicIp?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsEipFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsEipFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsEip extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsEipConfig);
    /**
     * @stability stable
     */
    get associationId(): string;
    /**
     * @stability stable
     */
    get carrierIp(): string;
    /**
     * @stability stable
     */
    get customerOwnedIp(): string;
    /**
     * @stability stable
     */
    get customerOwnedIpv4Pool(): string;
    /**
     * @stability stable
     */
    get domain(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get instanceId(): string;
    /**
     * @stability stable
     */
    get networkInterfaceId(): string;
    /**
     * @stability stable
     */
    get networkInterfaceOwnerId(): string;
    /**
     * @stability stable
     */
    get privateDns(): string;
    /**
     * @stability stable
     */
    get privateIp(): string;
    /**
     * @stability stable
     */
    get publicDns(): string;
    private _publicIp?;
    /**
     * @stability stable
     */
    get publicIp(): string;
    /**
     * @stability stable
     */
    set publicIp(value: string);
    /**
     * @stability stable
     */
    resetPublicIp(): void;
    /**
     * @stability stable
     */
    get publicIpInput(): string | undefined;
    /**
     * @stability stable
     */
    get publicIpv4Pool(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsEipFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsEipFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsEipFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
