import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsElasticacheReplicationGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly replicationGroupId: string;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticacheReplicationGroup extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsElasticacheReplicationGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get authTokenEnabled(): boolean;
    /**
     * @stability stable
     */
    get automaticFailoverEnabled(): boolean;
    /**
     * @stability stable
     */
    get configurationEndpointAddress(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get memberClusters(): string[];
    /**
     * @stability stable
     */
    get multiAzEnabled(): boolean;
    /**
     * @stability stable
     */
    get nodeType(): string;
    /**
     * @stability stable
     */
    get numberCacheClusters(): number;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    get primaryEndpointAddress(): string;
    /**
     * @stability stable
     */
    get readerEndpointAddress(): string;
    /**
     * @stability stable
     */
    get replicationGroupDescription(): string;
    private _replicationGroupId;
    /**
     * @stability stable
     */
    get replicationGroupId(): string;
    /**
     * @stability stable
     */
    set replicationGroupId(value: string);
    /**
     * @stability stable
     */
    get replicationGroupIdInput(): string;
    /**
     * @stability stable
     */
    get snapshotRetentionLimit(): number;
    /**
     * @stability stable
     */
    get snapshotWindow(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
