import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsElasticsearchDomainConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly domainName: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainAdvancedSecurityOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    get internalUserDatabaseEnabled(): boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainClusterConfigZoneAwarenessConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get availabilityZoneCount(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainClusterConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get dedicatedMasterCount(): number;
    /**
     * @stability stable
     */
    get dedicatedMasterEnabled(): boolean;
    /**
     * @stability stable
     */
    get dedicatedMasterType(): string;
    /**
     * @stability stable
     */
    get instanceCount(): number;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    get warmCount(): number;
    /**
     * @stability stable
     */
    get warmEnabled(): boolean;
    /**
     * @stability stable
     */
    get warmType(): string;
    /**
     * @stability stable
     */
    get zoneAwarenessConfig(): any;
    /**
     * @stability stable
     */
    get zoneAwarenessEnabled(): boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainCognitoOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    get identityPoolId(): string;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    get userPoolId(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainEbsOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get ebsEnabled(): boolean;
    /**
     * @stability stable
     */
    get iops(): number;
    /**
     * @stability stable
     */
    get volumeSize(): number;
    /**
     * @stability stable
     */
    get volumeType(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainEncryptionAtRest extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainLogPublishingOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cloudwatchLogGroupArn(): string;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    get logType(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainNodeToNodeEncryption extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainSnapshotOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get automatedSnapshotStartHour(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomainVpcOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    get vpcId(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsElasticsearchDomain extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsElasticsearchDomainConfig);
    /**
     * @stability stable
     */
    get accessPolicies(): string;
    /**
     * @stability stable
     */
    advancedOptions(key: string): string;
    /**
     * @stability stable
     */
    advancedSecurityOptions(index: string): DataAwsElasticsearchDomainAdvancedSecurityOptions;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    clusterConfig(index: string): DataAwsElasticsearchDomainClusterConfig;
    /**
     * @stability stable
     */
    cognitoOptions(index: string): DataAwsElasticsearchDomainCognitoOptions;
    /**
     * @stability stable
     */
    get created(): boolean;
    /**
     * @stability stable
     */
    get deleted(): boolean;
    /**
     * @stability stable
     */
    get domainId(): string;
    private _domainName;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string;
    /**
     * @stability stable
     */
    ebsOptions(index: string): DataAwsElasticsearchDomainEbsOptions;
    /**
     * @stability stable
     */
    get elasticsearchVersion(): string;
    /**
     * @stability stable
     */
    encryptionAtRest(index: string): DataAwsElasticsearchDomainEncryptionAtRest;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get kibanaEndpoint(): string;
    /**
     * @stability stable
     */
    logPublishingOptions(index: string): DataAwsElasticsearchDomainLogPublishingOptions;
    /**
     * @stability stable
     */
    nodeToNodeEncryption(index: string): DataAwsElasticsearchDomainNodeToNodeEncryption;
    /**
     * @stability stable
     */
    get processing(): boolean;
    /**
     * @stability stable
     */
    snapshotOptions(index: string): DataAwsElasticsearchDomainSnapshotOptions;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    vpcOptions(index: string): DataAwsElasticsearchDomainVpcOptions;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
