import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsElbConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsElbAccessLogs extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    get bucketPrefix(): string;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    get interval(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsElbHealthCheck extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get healthyThreshold(): number;
    /**
     * @stability stable
     */
    get interval(): number;
    /**
     * @stability stable
     */
    get target(): string;
    /**
     * @stability stable
     */
    get timeout(): number;
    /**
     * @stability stable
     */
    get unhealthyThreshold(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsElbListener extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get instancePort(): number;
    /**
     * @stability stable
     */
    get instanceProtocol(): string;
    /**
     * @stability stable
     */
    get lbPort(): number;
    /**
     * @stability stable
     */
    get lbProtocol(): string;
    /**
     * @stability stable
     */
    get sslCertificateId(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsElb extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsElbConfig);
    /**
     * @stability stable
     */
    accessLogs(index: string): DataAwsElbAccessLogs;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    /**
     * @stability stable
     */
    get connectionDraining(): boolean;
    /**
     * @stability stable
     */
    get connectionDrainingTimeout(): number;
    /**
     * @stability stable
     */
    get crossZoneLoadBalancing(): boolean;
    /**
     * @stability stable
     */
    get dnsName(): string;
    /**
     * @stability stable
     */
    healthCheck(index: string): DataAwsElbHealthCheck;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get idleTimeout(): number;
    /**
     * @stability stable
     */
    get instances(): string[];
    /**
     * @stability stable
     */
    get internal(): boolean;
    /**
     * @stability stable
     */
    listener(index: string): DataAwsElbListener;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    get sourceSecurityGroup(): string;
    /**
     * @stability stable
     */
    get sourceSecurityGroupId(): string;
    /**
     * @stability stable
     */
    get subnets(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get zoneId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
