import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsGlueScriptConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly language?: string;
    /**
     * dag_edge block.
     *
     * @stability stable
     */
    readonly dagEdge: DataAwsGlueScriptDagEdge[];
    /**
     * dag_node block.
     *
     * @stability stable
     */
    readonly dagNode: DataAwsGlueScriptDagNode[];
}
/**
 * @stability stable
 */
export interface DataAwsGlueScriptDagEdge {
    /**
     * @stability stable
     */
    readonly source: string;
    /**
     * @stability stable
     */
    readonly target: string;
    /**
     * @stability stable
     */
    readonly targetParameter?: string;
}
/**
 * @stability stable
 */
export interface DataAwsGlueScriptDagNodeArgs {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly param?: boolean;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface DataAwsGlueScriptDagNode {
    /**
     * @stability stable
     */
    readonly id: string;
    /**
     * @stability stable
     */
    readonly lineNumber?: number;
    /**
     * @stability stable
     */
    readonly nodeType: string;
    /**
     * args block.
     *
     * @stability stable
     */
    readonly args: DataAwsGlueScriptDagNodeArgs[];
}
/**
 * @stability stable
 */
export declare class DataAwsGlueScript extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsGlueScriptConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _language?;
    /**
     * @stability stable
     */
    get language(): string;
    /**
     * @stability stable
     */
    set language(value: string);
    /**
     * @stability stable
     */
    resetLanguage(): void;
    /**
     * @stability stable
     */
    get languageInput(): string | undefined;
    /**
     * @stability stable
     */
    get pythonScript(): string;
    /**
     * @stability stable
     */
    get scalaCode(): string;
    private _dagEdge;
    /**
     * @stability stable
     */
    get dagEdge(): DataAwsGlueScriptDagEdge[];
    /**
     * @stability stable
     */
    set dagEdge(value: DataAwsGlueScriptDagEdge[]);
    /**
     * @stability stable
     */
    get dagEdgeInput(): DataAwsGlueScriptDagEdge[];
    private _dagNode;
    /**
     * @stability stable
     */
    get dagNode(): DataAwsGlueScriptDagNode[];
    /**
     * @stability stable
     */
    set dagNode(value: DataAwsGlueScriptDagNode[]);
    /**
     * @stability stable
     */
    get dagNodeInput(): DataAwsGlueScriptDagNode[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
