import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsIamPolicyDocumentConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly overrideJson?: string;
    /**
     * @stability stable
     */
    readonly overridePolicyDocuments?: string[];
    /**
     * @stability stable
     */
    readonly policyId?: string;
    /**
     * @stability stable
     */
    readonly sourceJson?: string;
    /**
     * @stability stable
     */
    readonly sourcePolicyDocuments?: string[];
    /**
     * @stability stable
     */
    readonly version?: string;
    /**
     * statement block.
     *
     * @stability stable
     */
    readonly statement?: DataAwsIamPolicyDocumentStatement[];
}
/**
 * @stability stable
 */
export interface DataAwsIamPolicyDocumentStatementCondition {
    /**
     * @stability stable
     */
    readonly test: string;
    /**
     * @stability stable
     */
    readonly values: string[];
    /**
     * @stability stable
     */
    readonly variable: string;
}
/**
 * @stability stable
 */
export interface DataAwsIamPolicyDocumentStatementNotPrincipals {
    /**
     * @stability stable
     */
    readonly identifiers: string[];
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface DataAwsIamPolicyDocumentStatementPrincipals {
    /**
     * @stability stable
     */
    readonly identifiers: string[];
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface DataAwsIamPolicyDocumentStatement {
    /**
     * @stability stable
     */
    readonly actions?: string[];
    /**
     * @stability stable
     */
    readonly effect?: string;
    /**
     * @stability stable
     */
    readonly notActions?: string[];
    /**
     * @stability stable
     */
    readonly notResources?: string[];
    /**
     * @stability stable
     */
    readonly resources?: string[];
    /**
     * @stability stable
     */
    readonly sid?: string;
    /**
     * condition block.
     *
     * @stability stable
     */
    readonly condition?: DataAwsIamPolicyDocumentStatementCondition[];
    /**
     * not_principals block.
     *
     * @stability stable
     */
    readonly notPrincipals?: DataAwsIamPolicyDocumentStatementNotPrincipals[];
    /**
     * principals block.
     *
     * @stability stable
     */
    readonly principals?: DataAwsIamPolicyDocumentStatementPrincipals[];
}
/**
 * @stability stable
 */
export declare class DataAwsIamPolicyDocument extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsIamPolicyDocumentConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get json(): string;
    private _overrideJson?;
    /**
     * @stability stable
     */
    get overrideJson(): string;
    /**
     * @stability stable
     */
    set overrideJson(value: string);
    /**
     * @stability stable
     */
    resetOverrideJson(): void;
    /**
     * @stability stable
     */
    get overrideJsonInput(): string | undefined;
    private _overridePolicyDocuments?;
    /**
     * @stability stable
     */
    get overridePolicyDocuments(): string[];
    /**
     * @stability stable
     */
    set overridePolicyDocuments(value: string[]);
    /**
     * @stability stable
     */
    resetOverridePolicyDocuments(): void;
    /**
     * @stability stable
     */
    get overridePolicyDocumentsInput(): string[] | undefined;
    private _policyId?;
    /**
     * @stability stable
     */
    get policyId(): string;
    /**
     * @stability stable
     */
    set policyId(value: string);
    /**
     * @stability stable
     */
    resetPolicyId(): void;
    /**
     * @stability stable
     */
    get policyIdInput(): string | undefined;
    private _sourceJson?;
    /**
     * @stability stable
     */
    get sourceJson(): string;
    /**
     * @stability stable
     */
    set sourceJson(value: string);
    /**
     * @stability stable
     */
    resetSourceJson(): void;
    /**
     * @stability stable
     */
    get sourceJsonInput(): string | undefined;
    private _sourcePolicyDocuments?;
    /**
     * @stability stable
     */
    get sourcePolicyDocuments(): string[];
    /**
     * @stability stable
     */
    set sourcePolicyDocuments(value: string[]);
    /**
     * @stability stable
     */
    resetSourcePolicyDocuments(): void;
    /**
     * @stability stable
     */
    get sourcePolicyDocumentsInput(): string[] | undefined;
    private _version?;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): string | undefined;
    private _statement?;
    /**
     * @stability stable
     */
    get statement(): DataAwsIamPolicyDocumentStatement[];
    /**
     * @stability stable
     */
    set statement(value: DataAwsIamPolicyDocumentStatement[]);
    /**
     * @stability stable
     */
    resetStatement(): void;
    /**
     * @stability stable
     */
    get statementInput(): DataAwsIamPolicyDocumentStatement[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
