import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsIamServerCertificateConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly latest?: boolean;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly pathPrefix?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsIamServerCertificate extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsIamServerCertificateConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get certificateBody(): string;
    /**
     * @stability stable
     */
    get certificateChain(): string;
    /**
     * @stability stable
     */
    get expirationDate(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _latest?;
    /**
     * @stability stable
     */
    get latest(): boolean;
    /**
     * @stability stable
     */
    set latest(value: boolean);
    /**
     * @stability stable
     */
    resetLatest(): void;
    /**
     * @stability stable
     */
    get latestInput(): boolean | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    get path(): string;
    private _pathPrefix?;
    /**
     * @stability stable
     */
    get pathPrefix(): string;
    /**
     * @stability stable
     */
    set pathPrefix(value: string);
    /**
     * @stability stable
     */
    resetPathPrefix(): void;
    /**
     * @stability stable
     */
    get pathPrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    get uploadDate(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
