import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsIdentitystoreGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly groupId?: string;
    /**
     * @stability stable
     */
    readonly identityStoreId: string;
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter: DataAwsIdentitystoreGroupFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsIdentitystoreGroupFilter {
    /**
     * @stability stable
     */
    readonly attributePath: string;
    /**
     * @stability stable
     */
    readonly attributeValue: string;
}
/**
 * @stability stable
 */
export declare class DataAwsIdentitystoreGroup extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsIdentitystoreGroupConfig);
    /**
     * @stability stable
     */
    get displayName(): string;
    private _groupId?;
    /**
     * @stability stable
     */
    get groupId(): string;
    /**
     * @stability stable
     */
    set groupId(value: string);
    /**
     * @stability stable
     */
    resetGroupId(): void;
    /**
     * @stability stable
     */
    get groupIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _identityStoreId;
    /**
     * @stability stable
     */
    get identityStoreId(): string;
    /**
     * @stability stable
     */
    set identityStoreId(value: string);
    /**
     * @stability stable
     */
    get identityStoreIdInput(): string;
    private _filter;
    /**
     * @stability stable
     */
    get filter(): DataAwsIdentitystoreGroupFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsIdentitystoreGroupFilter[]);
    /**
     * @stability stable
     */
    get filterInput(): DataAwsIdentitystoreGroupFilter[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
