import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsIdentitystoreUserConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly identityStoreId: string;
    /**
     * @stability stable
     */
    readonly userId?: string;
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter: DataAwsIdentitystoreUserFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsIdentitystoreUserFilter {
    /**
     * @stability stable
     */
    readonly attributePath: string;
    /**
     * @stability stable
     */
    readonly attributeValue: string;
}
/**
 * @stability stable
 */
export declare class DataAwsIdentitystoreUser extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsIdentitystoreUserConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _identityStoreId;
    /**
     * @stability stable
     */
    get identityStoreId(): string;
    /**
     * @stability stable
     */
    set identityStoreId(value: string);
    /**
     * @stability stable
     */
    get identityStoreIdInput(): string;
    private _userId?;
    /**
     * @stability stable
     */
    get userId(): string;
    /**
     * @stability stable
     */
    set userId(value: string);
    /**
     * @stability stable
     */
    resetUserId(): void;
    /**
     * @stability stable
     */
    get userIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get userName(): string;
    private _filter;
    /**
     * @stability stable
     */
    get filter(): DataAwsIdentitystoreUserFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsIdentitystoreUserFilter[]);
    /**
     * @stability stable
     */
    get filterInput(): DataAwsIdentitystoreUserFilter[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
