import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsImagebuilderDistributionConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly arn: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsImagebuilderDistributionConfigurationDistributionAmiDistributionConfigurationLaunchPermission extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get userGroups(): string[];
    /**
     * @stability stable
     */
    get userIds(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsImagebuilderDistributionConfigurationDistributionAmiDistributionConfiguration extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get amiTags(): any;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    get launchPermission(): any;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get targetAccountIds(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsImagebuilderDistributionConfigurationDistribution extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get amiDistributionConfiguration(): any;
    /**
     * @stability stable
     */
    get licenseConfigurationArns(): string[];
    /**
     * @stability stable
     */
    get region(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsImagebuilderDistributionConfiguration extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsImagebuilderDistributionConfigurationConfig);
    private _arn;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    set arn(value: string);
    /**
     * @stability stable
     */
    get arnInput(): string;
    /**
     * @stability stable
     */
    get dateCreated(): string;
    /**
     * @stability stable
     */
    get dateUpdated(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    distribution(index: string): DataAwsImagebuilderDistributionConfigurationDistribution;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
