import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsImagebuilderImagePipelineConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly arn: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsImagebuilderImagePipelineImageTestsConfiguration extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get imageTestsEnabled(): boolean;
    /**
     * @stability stable
     */
    get timeoutMinutes(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsImagebuilderImagePipelineSchedule extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get pipelineExecutionStartCondition(): string;
    /**
     * @stability stable
     */
    get scheduleExpression(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsImagebuilderImagePipeline extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsImagebuilderImagePipelineConfig);
    private _arn;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    set arn(value: string);
    /**
     * @stability stable
     */
    get arnInput(): string;
    /**
     * @stability stable
     */
    get dateCreated(): string;
    /**
     * @stability stable
     */
    get dateLastRun(): string;
    /**
     * @stability stable
     */
    get dateNextRun(): string;
    /**
     * @stability stable
     */
    get dateUpdated(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get distributionConfigurationArn(): string;
    /**
     * @stability stable
     */
    get enhancedImageMetadataEnabled(): boolean;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get imageRecipeArn(): string;
    /**
     * @stability stable
     */
    imageTestsConfiguration(index: string): DataAwsImagebuilderImagePipelineImageTestsConfiguration;
    /**
     * @stability stable
     */
    get infrastructureConfigurationArn(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get platform(): string;
    /**
     * @stability stable
     */
    schedule(index: string): DataAwsImagebuilderImagePipelineSchedule;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
