import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsImagebuilderInfrastructureConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly arn: string;
    /**
     * @stability stable
     */
    readonly resourceTags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsImagebuilderInfrastructureConfigurationLoggingS3Logs extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get s3BucketName(): string;
    /**
     * @stability stable
     */
    get s3KeyPrefix(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsImagebuilderInfrastructureConfigurationLogging extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get s3Logs(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsImagebuilderInfrastructureConfiguration extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsImagebuilderInfrastructureConfigurationConfig);
    private _arn;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    set arn(value: string);
    /**
     * @stability stable
     */
    get arnInput(): string;
    /**
     * @stability stable
     */
    get dateCreated(): string;
    /**
     * @stability stable
     */
    get dateUpdated(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get instanceProfileName(): string;
    /**
     * @stability stable
     */
    get instanceTypes(): string[];
    /**
     * @stability stable
     */
    get keyPair(): string;
    /**
     * @stability stable
     */
    logging(index: string): DataAwsImagebuilderInfrastructureConfigurationLogging;
    /**
     * @stability stable
     */
    get name(): string;
    private _resourceTags?;
    /**
     * @stability stable
     */
    get resourceTags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set resourceTags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetResourceTags(): void;
    /**
     * @stability stable
     */
    get resourceTagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    get snsTopicArn(): string;
    /**
     * @stability stable
     */
    get subnetId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get terminateInstanceOnFailure(): boolean;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
