import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly fetchPasswordData?: boolean;
    /**
     * @stability stable
     */
    readonly fetchUserData?: boolean;
    /**
     * @stability stable
     */
    readonly instanceId?: string;
    /**
     * @stability stable
     */
    readonly instanceTags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsInstanceFilter[];
}
/**
 * @stability stable
 */
export declare class DataAwsInstanceCreditSpecification extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cpuCredits(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsInstanceEbsBlockDevice extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get deleteOnTermination(): boolean;
    /**
     * @stability stable
     */
    get deviceName(): string;
    /**
     * @stability stable
     */
    get encrypted(): boolean;
    /**
     * @stability stable
     */
    get iops(): number;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    get snapshotId(): string;
    /**
     * @stability stable
     */
    get tags(): any;
    /**
     * @stability stable
     */
    get throughput(): number;
    /**
     * @stability stable
     */
    get volumeId(): string;
    /**
     * @stability stable
     */
    get volumeSize(): number;
    /**
     * @stability stable
     */
    get volumeType(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsInstanceEnclaveOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsInstanceEphemeralBlockDevice extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get deviceName(): string;
    /**
     * @stability stable
     */
    get noDevice(): boolean;
    /**
     * @stability stable
     */
    get virtualName(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsInstanceMetadataOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get httpEndpoint(): string;
    /**
     * @stability stable
     */
    get httpPutResponseHopLimit(): number;
    /**
     * @stability stable
     */
    get httpTokens(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsInstanceRootBlockDevice extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get deleteOnTermination(): boolean;
    /**
     * @stability stable
     */
    get deviceName(): string;
    /**
     * @stability stable
     */
    get encrypted(): boolean;
    /**
     * @stability stable
     */
    get iops(): number;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    get tags(): any;
    /**
     * @stability stable
     */
    get throughput(): number;
    /**
     * @stability stable
     */
    get volumeId(): string;
    /**
     * @stability stable
     */
    get volumeSize(): number;
    /**
     * @stability stable
     */
    get volumeType(): string;
}
/**
 * @stability stable
 */
export interface DataAwsInstanceFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsInstance extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsInstanceConfig);
    /**
     * @stability stable
     */
    get ami(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get associatePublicIpAddress(): boolean;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    creditSpecification(index: string): DataAwsInstanceCreditSpecification;
    /**
     * @stability stable
     */
    get disableApiTermination(): boolean;
    /**
     * @stability stable
     */
    ebsBlockDevice(index: string): DataAwsInstanceEbsBlockDevice;
    /**
     * @stability stable
     */
    get ebsOptimized(): boolean;
    /**
     * @stability stable
     */
    enclaveOptions(index: string): DataAwsInstanceEnclaveOptions;
    /**
     * @stability stable
     */
    ephemeralBlockDevice(index: string): DataAwsInstanceEphemeralBlockDevice;
    private _getPasswordData?;
    /**
     * @stability stable
     */
    get fetchPasswordData(): boolean;
    /**
     * @stability stable
     */
    set fetchPasswordData(value: boolean);
    /**
     * @stability stable
     */
    resetFetchPasswordData(): void;
    /**
     * @stability stable
     */
    get fetchPasswordDataInput(): boolean | undefined;
    private _getUserData?;
    /**
     * @stability stable
     */
    get fetchUserData(): boolean;
    /**
     * @stability stable
     */
    set fetchUserData(value: boolean);
    /**
     * @stability stable
     */
    resetFetchUserData(): void;
    /**
     * @stability stable
     */
    get fetchUserDataInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get hostId(): string;
    /**
     * @stability stable
     */
    get iamInstanceProfile(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceId?;
    /**
     * @stability stable
     */
    get instanceId(): string;
    /**
     * @stability stable
     */
    set instanceId(value: string);
    /**
     * @stability stable
     */
    resetInstanceId(): void;
    /**
     * @stability stable
     */
    get instanceIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get instanceState(): string;
    private _instanceTags?;
    /**
     * @stability stable
     */
    get instanceTags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set instanceTags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetInstanceTags(): void;
    /**
     * @stability stable
     */
    get instanceTagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    get keyName(): string;
    /**
     * @stability stable
     */
    metadataOptions(index: string): DataAwsInstanceMetadataOptions;
    /**
     * @stability stable
     */
    get monitoring(): boolean;
    /**
     * @stability stable
     */
    get networkInterfaceId(): string;
    /**
     * @stability stable
     */
    get outpostArn(): string;
    /**
     * @stability stable
     */
    get passwordData(): string;
    /**
     * @stability stable
     */
    get placementGroup(): string;
    /**
     * @stability stable
     */
    get privateDns(): string;
    /**
     * @stability stable
     */
    get privateIp(): string;
    /**
     * @stability stable
     */
    get publicDns(): string;
    /**
     * @stability stable
     */
    get publicIp(): string;
    /**
     * @stability stable
     */
    rootBlockDevice(index: string): DataAwsInstanceRootBlockDevice;
    /**
     * @stability stable
     */
    get secondaryPrivateIps(): string[];
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    get sourceDestCheck(): boolean;
    /**
     * @stability stable
     */
    get subnetId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get tenancy(): string;
    /**
     * @stability stable
     */
    get userData(): string;
    /**
     * @stability stable
     */
    get userDataBase64(): string;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIds(): string[];
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsInstanceFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsInstanceFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsInstanceFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
