import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsInstancesConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly instanceStateNames?: string[];
    /**
     * @stability stable
     */
    readonly instanceTags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsInstancesFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsInstancesFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsInstances extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsInstancesConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ids(): string[];
    private _instanceStateNames?;
    /**
     * @stability stable
     */
    get instanceStateNames(): string[];
    /**
     * @stability stable
     */
    set instanceStateNames(value: string[]);
    /**
     * @stability stable
     */
    resetInstanceStateNames(): void;
    /**
     * @stability stable
     */
    get instanceStateNamesInput(): string[] | undefined;
    private _instanceTags?;
    /**
     * @stability stable
     */
    get instanceTags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set instanceTags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetInstanceTags(): void;
    /**
     * @stability stable
     */
    get instanceTagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get privateIps(): string[];
    /**
     * @stability stable
     */
    get publicIps(): string[];
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsInstancesFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsInstancesFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsInstancesFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
