import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsInternetGatewayConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly internetGatewayId?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsInternetGatewayFilter[];
}
/**
 * @stability stable
 */
export declare class DataAwsInternetGatewayAttachments extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    get vpcId(): string;
}
/**
 * @stability stable
 */
export interface DataAwsInternetGatewayFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsInternetGateway extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsInternetGatewayConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    attachments(index: string): DataAwsInternetGatewayAttachments;
    /**
     * @stability stable
     */
    get id(): string;
    private _internetGatewayId?;
    /**
     * @stability stable
     */
    get internetGatewayId(): string;
    /**
     * @stability stable
     */
    set internetGatewayId(value: string);
    /**
     * @stability stable
     */
    resetInternetGatewayId(): void;
    /**
     * @stability stable
     */
    get internetGatewayIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsInternetGatewayFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsInternetGatewayFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsInternetGatewayFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
