import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsKmsKeyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly grantTokens?: string[];
    /**
     * @stability stable
     */
    readonly keyId: string;
}
/**
 * @stability stable
 */
export declare class DataAwsKmsKey extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsKmsKeyConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get awsAccountId(): string;
    /**
     * @stability stable
     */
    get creationDate(): string;
    /**
     * @stability stable
     */
    get customerMasterKeySpec(): string;
    /**
     * @stability stable
     */
    get deletionDate(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    get expirationModel(): string;
    private _grantTokens?;
    /**
     * @stability stable
     */
    get grantTokens(): string[];
    /**
     * @stability stable
     */
    set grantTokens(value: string[]);
    /**
     * @stability stable
     */
    resetGrantTokens(): void;
    /**
     * @stability stable
     */
    get grantTokensInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _keyId;
    /**
     * @stability stable
     */
    get keyId(): string;
    /**
     * @stability stable
     */
    set keyId(value: string);
    /**
     * @stability stable
     */
    get keyIdInput(): string;
    /**
     * @stability stable
     */
    get keyManager(): string;
    /**
     * @stability stable
     */
    get keyState(): string;
    /**
     * @stability stable
     */
    get keyUsage(): string;
    /**
     * @stability stable
     */
    get origin(): string;
    /**
     * @stability stable
     */
    get validTo(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
