import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsKmsSecretConfig extends cdktf.TerraformMetaArguments {
    /**
     * secret block.
     *
     * @stability stable
     */
    readonly secret: DataAwsKmsSecretSecret[];
}
/**
 * @stability stable
 */
export interface DataAwsKmsSecretSecret {
    /**
     * @stability stable
     */
    readonly context?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly grantTokens?: string[];
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly payload: string;
}
/**
 * @stability stable
 */
export declare class DataAwsKmsSecret extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsKmsSecretConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _secret;
    /**
     * @stability stable
     */
    get secret(): DataAwsKmsSecretSecret[];
    /**
     * @stability stable
     */
    set secret(value: DataAwsKmsSecretSecret[]);
    /**
     * @stability stable
     */
    get secretInput(): DataAwsKmsSecretSecret[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
