import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsLakeformationPermissionsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * @stability stable
     */
    readonly catalogResource?: boolean;
    /**
     * @stability stable
     */
    readonly principal: string;
    /**
     * data_location block.
     *
     * @stability stable
     */
    readonly dataLocation?: DataAwsLakeformationPermissionsDataLocation[];
    /**
     * database block.
     *
     * @stability stable
     */
    readonly database?: DataAwsLakeformationPermissionsDatabase[];
    /**
     * table block.
     *
     * @stability stable
     */
    readonly table?: DataAwsLakeformationPermissionsTable[];
    /**
     * table_with_columns block.
     *
     * @stability stable
     */
    readonly tableWithColumns?: DataAwsLakeformationPermissionsTableWithColumns[];
}
/**
 * @stability stable
 */
export interface DataAwsLakeformationPermissionsDataLocation {
    /**
     * @stability stable
     */
    readonly arn: string;
    /**
     * @stability stable
     */
    readonly catalogId?: string;
}
/**
 * @stability stable
 */
export interface DataAwsLakeformationPermissionsDatabase {
    /**
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface DataAwsLakeformationPermissionsTable {
    /**
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly wildcard?: boolean;
}
/**
 * @stability stable
 */
export interface DataAwsLakeformationPermissionsTableWithColumns {
    /**
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * @stability stable
     */
    readonly columnNames?: string[];
    /**
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * @stability stable
     */
    readonly excludedColumnNames?: string[];
    /**
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export declare class DataAwsLakeformationPermissions extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsLakeformationPermissionsConfig);
    private _catalogId?;
    /**
     * @stability stable
     */
    get catalogId(): string;
    /**
     * @stability stable
     */
    set catalogId(value: string);
    /**
     * @stability stable
     */
    resetCatalogId(): void;
    /**
     * @stability stable
     */
    get catalogIdInput(): string | undefined;
    private _catalogResource?;
    /**
     * @stability stable
     */
    get catalogResource(): boolean;
    /**
     * @stability stable
     */
    set catalogResource(value: boolean);
    /**
     * @stability stable
     */
    resetCatalogResource(): void;
    /**
     * @stability stable
     */
    get catalogResourceInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get permissions(): string[];
    /**
     * @stability stable
     */
    get permissionsWithGrantOption(): string[];
    private _principal;
    /**
     * @stability stable
     */
    get principal(): string;
    /**
     * @stability stable
     */
    set principal(value: string);
    /**
     * @stability stable
     */
    get principalInput(): string;
    private _dataLocation?;
    /**
     * @stability stable
     */
    get dataLocation(): DataAwsLakeformationPermissionsDataLocation[];
    /**
     * @stability stable
     */
    set dataLocation(value: DataAwsLakeformationPermissionsDataLocation[]);
    /**
     * @stability stable
     */
    resetDataLocation(): void;
    /**
     * @stability stable
     */
    get dataLocationInput(): DataAwsLakeformationPermissionsDataLocation[] | undefined;
    private _database?;
    /**
     * @stability stable
     */
    get database(): DataAwsLakeformationPermissionsDatabase[];
    /**
     * @stability stable
     */
    set database(value: DataAwsLakeformationPermissionsDatabase[]);
    /**
     * @stability stable
     */
    resetDatabase(): void;
    /**
     * @stability stable
     */
    get databaseInput(): DataAwsLakeformationPermissionsDatabase[] | undefined;
    private _table?;
    /**
     * @stability stable
     */
    get table(): DataAwsLakeformationPermissionsTable[];
    /**
     * @stability stable
     */
    set table(value: DataAwsLakeformationPermissionsTable[]);
    /**
     * @stability stable
     */
    resetTable(): void;
    /**
     * @stability stable
     */
    get tableInput(): DataAwsLakeformationPermissionsTable[] | undefined;
    private _tableWithColumns?;
    /**
     * @stability stable
     */
    get tableWithColumns(): DataAwsLakeformationPermissionsTableWithColumns[];
    /**
     * @stability stable
     */
    set tableWithColumns(value: DataAwsLakeformationPermissionsTableWithColumns[]);
    /**
     * @stability stable
     */
    resetTableWithColumns(): void;
    /**
     * @stability stable
     */
    get tableWithColumnsInput(): DataAwsLakeformationPermissionsTableWithColumns[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
