import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsLambdaCodeSigningConfigConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly arn: string;
}
/**
 * @stability stable
 */
export declare class DataAwsLambdaCodeSigningConfigAllowedPublishers extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get signingProfileVersionArns(): string[];
}
/**
 * @stability stable
 */
export declare class DataAwsLambdaCodeSigningConfigPolicies extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get untrustedArtifactOnDeployment(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLambdaCodeSigningConfig extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsLambdaCodeSigningConfigConfig);
    /**
     * @stability stable
     */
    allowedPublishers(index: string): DataAwsLambdaCodeSigningConfigAllowedPublishers;
    private _arn;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    set arn(value: string);
    /**
     * @stability stable
     */
    get arnInput(): string;
    /**
     * @stability stable
     */
    get configId(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastModified(): string;
    /**
     * @stability stable
     */
    policies(index: string): DataAwsLambdaCodeSigningConfigPolicies;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
