import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsLambdaFunctionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly functionName: string;
    /**
     * @stability stable
     */
    readonly qualifier?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsLambdaFunctionDeadLetterConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get targetArn(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLambdaFunctionEnvironment extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get variables(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsLambdaFunctionFileSystemConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get localMountPath(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLambdaFunctionTracingConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get mode(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLambdaFunctionVpcConfig extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    get vpcId(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLambdaFunction extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsLambdaFunctionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get codeSigningConfigArn(): string;
    /**
     * @stability stable
     */
    deadLetterConfig(index: string): DataAwsLambdaFunctionDeadLetterConfig;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    environment(index: string): DataAwsLambdaFunctionEnvironment;
    /**
     * @stability stable
     */
    fileSystemConfig(index: string): DataAwsLambdaFunctionFileSystemConfig;
    private _functionName;
    /**
     * @stability stable
     */
    get functionName(): string;
    /**
     * @stability stable
     */
    set functionName(value: string);
    /**
     * @stability stable
     */
    get functionNameInput(): string;
    /**
     * @stability stable
     */
    get handler(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get invokeArn(): string;
    /**
     * @stability stable
     */
    get kmsKeyArn(): string;
    /**
     * @stability stable
     */
    get lastModified(): string;
    /**
     * @stability stable
     */
    get layers(): string[];
    /**
     * @stability stable
     */
    get memorySize(): number;
    /**
     * @stability stable
     */
    get qualifiedArn(): string;
    private _qualifier?;
    /**
     * @stability stable
     */
    get qualifier(): string;
    /**
     * @stability stable
     */
    set qualifier(value: string);
    /**
     * @stability stable
     */
    resetQualifier(): void;
    /**
     * @stability stable
     */
    get qualifierInput(): string | undefined;
    /**
     * @stability stable
     */
    get reservedConcurrentExecutions(): number;
    /**
     * @stability stable
     */
    get role(): string;
    /**
     * @stability stable
     */
    get runtime(): string;
    /**
     * @stability stable
     */
    get signingJobArn(): string;
    /**
     * @stability stable
     */
    get signingProfileVersionArn(): string;
    /**
     * @stability stable
     */
    get sourceCodeHash(): string;
    /**
     * @stability stable
     */
    get sourceCodeSize(): number;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get timeout(): number;
    /**
     * @stability stable
     */
    tracingConfig(index: string): DataAwsLambdaFunctionTracingConfig;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    vpcConfig(index: string): DataAwsLambdaFunctionVpcConfig;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
