import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsLambdaLayerVersionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly compatibleRuntime?: string;
    /**
     * @stability stable
     */
    readonly layerName: string;
    /**
     * @stability stable
     */
    readonly version?: number;
}
/**
 * @stability stable
 */
export declare class DataAwsLambdaLayerVersion extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsLambdaLayerVersionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _compatibleRuntime?;
    /**
     * @stability stable
     */
    get compatibleRuntime(): string;
    /**
     * @stability stable
     */
    set compatibleRuntime(value: string);
    /**
     * @stability stable
     */
    resetCompatibleRuntime(): void;
    /**
     * @stability stable
     */
    get compatibleRuntimeInput(): string | undefined;
    /**
     * @stability stable
     */
    get compatibleRuntimes(): string[];
    /**
     * @stability stable
     */
    get createdDate(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get layerArn(): string;
    private _layerName;
    /**
     * @stability stable
     */
    get layerName(): string;
    /**
     * @stability stable
     */
    set layerName(value: string);
    /**
     * @stability stable
     */
    get layerNameInput(): string;
    /**
     * @stability stable
     */
    get licenseInfo(): string;
    /**
     * @stability stable
     */
    get signingJobArn(): string;
    /**
     * @stability stable
     */
    get signingProfileVersionArn(): string;
    /**
     * @stability stable
     */
    get sourceCodeHash(): string;
    /**
     * @stability stable
     */
    get sourceCodeSize(): number;
    private _version?;
    /**
     * @stability stable
     */
    get version(): number;
    /**
     * @stability stable
     */
    set version(value: number);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): number | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
