import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsLaunchTemplateConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsLaunchTemplateFilter[];
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchTemplateBlockDeviceMappingsEbs extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get deleteOnTermination(): string;
    /**
     * @stability stable
     */
    get encrypted(): string;
    /**
     * @stability stable
     */
    get iops(): number;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    get snapshotId(): string;
    /**
     * @stability stable
     */
    get throughput(): number;
    /**
     * @stability stable
     */
    get volumeSize(): number;
    /**
     * @stability stable
     */
    get volumeType(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchTemplateBlockDeviceMappings extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get deviceName(): string;
    /**
     * @stability stable
     */
    get ebs(): any;
    /**
     * @stability stable
     */
    get noDevice(): string;
    /**
     * @stability stable
     */
    get virtualName(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchTemplateCreditSpecification extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cpuCredits(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchTemplateElasticGpuSpecifications extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get type(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchTemplateEnclaveOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchTemplateHibernationOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get configured(): boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchTemplateIamInstanceProfile extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get name(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchTemplateInstanceMarketOptionsSpotOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get blockDurationMinutes(): number;
    /**
     * @stability stable
     */
    get instanceInterruptionBehavior(): string;
    /**
     * @stability stable
     */
    get maxPrice(): string;
    /**
     * @stability stable
     */
    get spotInstanceType(): string;
    /**
     * @stability stable
     */
    get validUntil(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchTemplateInstanceMarketOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get marketType(): string;
    /**
     * @stability stable
     */
    get spotOptions(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchTemplateMetadataOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get httpEndpoint(): string;
    /**
     * @stability stable
     */
    get httpPutResponseHopLimit(): number;
    /**
     * @stability stable
     */
    get httpTokens(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchTemplateMonitoring extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get enabled(): boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchTemplateNetworkInterfaces extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get associateCarrierIpAddress(): string;
    /**
     * @stability stable
     */
    get associatePublicIpAddress(): string;
    /**
     * @stability stable
     */
    get deleteOnTermination(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get deviceIndex(): number;
    /**
     * @stability stable
     */
    get ipv4AddressCount(): number;
    /**
     * @stability stable
     */
    get ipv4Addresses(): string[];
    /**
     * @stability stable
     */
    get ipv6AddressCount(): number;
    /**
     * @stability stable
     */
    get ipv6Addresses(): string[];
    /**
     * @stability stable
     */
    get networkInterfaceId(): string;
    /**
     * @stability stable
     */
    get privateIpAddress(): string;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    get subnetId(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchTemplatePlacement extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get affinity(): string;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    get groupName(): string;
    /**
     * @stability stable
     */
    get hostId(): string;
    /**
     * @stability stable
     */
    get partitionNumber(): number;
    /**
     * @stability stable
     */
    get spreadDomain(): string;
    /**
     * @stability stable
     */
    get tenancy(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchTemplateTagSpecifications extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get resourceType(): string;
    /**
     * @stability stable
     */
    get tags(): any;
}
/**
 * @stability stable
 */
export interface DataAwsLaunchTemplateFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchTemplate extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsLaunchTemplateConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    blockDeviceMappings(index: string): DataAwsLaunchTemplateBlockDeviceMappings;
    /**
     * @stability stable
     */
    creditSpecification(index: string): DataAwsLaunchTemplateCreditSpecification;
    /**
     * @stability stable
     */
    get defaultVersion(): number;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get disableApiTermination(): boolean;
    /**
     * @stability stable
     */
    get ebsOptimized(): string;
    /**
     * @stability stable
     */
    elasticGpuSpecifications(index: string): DataAwsLaunchTemplateElasticGpuSpecifications;
    /**
     * @stability stable
     */
    enclaveOptions(index: string): DataAwsLaunchTemplateEnclaveOptions;
    /**
     * @stability stable
     */
    hibernationOptions(index: string): DataAwsLaunchTemplateHibernationOptions;
    /**
     * @stability stable
     */
    iamInstanceProfile(index: string): DataAwsLaunchTemplateIamInstanceProfile;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get imageId(): string;
    /**
     * @stability stable
     */
    get instanceInitiatedShutdownBehavior(): string;
    /**
     * @stability stable
     */
    instanceMarketOptions(index: string): DataAwsLaunchTemplateInstanceMarketOptions;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    get kernelId(): string;
    /**
     * @stability stable
     */
    get keyName(): string;
    /**
     * @stability stable
     */
    get latestVersion(): number;
    /**
     * @stability stable
     */
    metadataOptions(index: string): DataAwsLaunchTemplateMetadataOptions;
    /**
     * @stability stable
     */
    monitoring(index: string): DataAwsLaunchTemplateMonitoring;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    networkInterfaces(index: string): DataAwsLaunchTemplateNetworkInterfaces;
    /**
     * @stability stable
     */
    placement(index: string): DataAwsLaunchTemplatePlacement;
    /**
     * @stability stable
     */
    get ramDiskId(): string;
    /**
     * @stability stable
     */
    get securityGroupNames(): string[];
    /**
     * @stability stable
     */
    tagSpecifications(index: string): DataAwsLaunchTemplateTagSpecifications;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get userData(): string;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIds(): string[];
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsLaunchTemplateFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsLaunchTemplateFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsLaunchTemplateFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
