import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsMqBrokerConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly brokerId?: string;
    /**
     * @stability stable
     */
    readonly brokerName?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * logs block.
     *
     * @stability stable
     */
    readonly logs?: DataAwsMqBrokerLogs[];
}
/**
 * @stability stable
 */
export declare class DataAwsMqBrokerConfiguration extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get revision(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsMqBrokerEncryptionOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    get useAwsOwnedKey(): boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsMqBrokerInstances extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get consoleUrl(): string;
    /**
     * @stability stable
     */
    get endpoints(): string[];
    /**
     * @stability stable
     */
    get ipAddress(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsMqBrokerLdapServerMetadata extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get hosts(): string[];
    /**
     * @stability stable
     */
    get roleBase(): string;
    /**
     * @stability stable
     */
    get roleName(): string;
    /**
     * @stability stable
     */
    get roleSearchMatching(): string;
    /**
     * @stability stable
     */
    get roleSearchSubtree(): boolean;
    /**
     * @stability stable
     */
    get serviceAccountPassword(): string;
    /**
     * @stability stable
     */
    get serviceAccountUsername(): string;
    /**
     * @stability stable
     */
    get userBase(): string;
    /**
     * @stability stable
     */
    get userRoleName(): string;
    /**
     * @stability stable
     */
    get userSearchMatching(): string;
    /**
     * @stability stable
     */
    get userSearchSubtree(): boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsMqBrokerMaintenanceWindowStartTime extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get dayOfWeek(): string;
    /**
     * @stability stable
     */
    get timeOfDay(): string;
    /**
     * @stability stable
     */
    get timeZone(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsMqBrokerUser extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get consoleAccess(): boolean;
    /**
     * @stability stable
     */
    get groups(): string[];
    /**
     * @stability stable
     */
    get username(): string;
}
/**
 * @stability stable
 */
export interface DataAwsMqBrokerLogs {
}
/**
 * @stability stable
 */
export declare class DataAwsMqBroker extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsMqBrokerConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get authenticationStrategy(): string;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgrade(): boolean;
    private _brokerId?;
    /**
     * @stability stable
     */
    get brokerId(): string;
    /**
     * @stability stable
     */
    set brokerId(value: string);
    /**
     * @stability stable
     */
    resetBrokerId(): void;
    /**
     * @stability stable
     */
    get brokerIdInput(): string | undefined;
    private _brokerName?;
    /**
     * @stability stable
     */
    get brokerName(): string;
    /**
     * @stability stable
     */
    set brokerName(value: string);
    /**
     * @stability stable
     */
    resetBrokerName(): void;
    /**
     * @stability stable
     */
    get brokerNameInput(): string | undefined;
    /**
     * @stability stable
     */
    configuration(index: string): DataAwsMqBrokerConfiguration;
    /**
     * @stability stable
     */
    get deploymentMode(): string;
    /**
     * @stability stable
     */
    encryptionOptions(index: string): DataAwsMqBrokerEncryptionOptions;
    /**
     * @stability stable
     */
    get engineType(): string;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    get hostInstanceType(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    instances(index: string): DataAwsMqBrokerInstances;
    /**
     * @stability stable
     */
    ldapServerMetadata(index: string): DataAwsMqBrokerLdapServerMetadata;
    /**
     * @stability stable
     */
    maintenanceWindowStartTime(index: string): DataAwsMqBrokerMaintenanceWindowStartTime;
    /**
     * @stability stable
     */
    get publiclyAccessible(): boolean;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    user(index: string): DataAwsMqBrokerUser;
    private _logs?;
    /**
     * @stability stable
     */
    get logs(): DataAwsMqBrokerLogs[];
    /**
     * @stability stable
     */
    set logs(value: DataAwsMqBrokerLogs[]);
    /**
     * @stability stable
     */
    resetLogs(): void;
    /**
     * @stability stable
     */
    get logsInput(): DataAwsMqBrokerLogs[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
