import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsOrganizationsOrganizationConfig extends cdktf.TerraformMetaArguments {
}
/**
 * @stability stable
 */
export declare class DataAwsOrganizationsOrganizationAccounts extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get email(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get status(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsOrganizationsOrganizationNonMasterAccounts extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get email(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get status(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsOrganizationsOrganizationRootsPolicyTypes extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get type(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsOrganizationsOrganizationRoots extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get policyTypes(): any;
}
/**
 * @stability stable
 */
export declare class DataAwsOrganizationsOrganization extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsOrganizationsOrganizationConfig);
    /**
     * @stability stable
     */
    accounts(index: string): DataAwsOrganizationsOrganizationAccounts;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get awsServiceAccessPrincipals(): string[];
    /**
     * @stability stable
     */
    get enabledPolicyTypes(): string[];
    /**
     * @stability stable
     */
    get featureSet(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get masterAccountArn(): string;
    /**
     * @stability stable
     */
    get masterAccountEmail(): string;
    /**
     * @stability stable
     */
    get masterAccountId(): string;
    /**
     * @stability stable
     */
    nonMasterAccounts(index: string): DataAwsOrganizationsOrganizationNonMasterAccounts;
    /**
     * @stability stable
     */
    roots(index: string): DataAwsOrganizationsOrganizationRoots;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
