import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsPrefixListConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly prefixListId?: string;
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsPrefixListFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsPrefixListFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsPrefixList extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsPrefixListConfig);
    /**
     * @stability stable
     */
    get cidrBlocks(): string[];
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _prefixListId?;
    /**
     * @stability stable
     */
    get prefixListId(): string;
    /**
     * @stability stable
     */
    set prefixListId(value: string);
    /**
     * @stability stable
     */
    resetPrefixListId(): void;
    /**
     * @stability stable
     */
    get prefixListIdInput(): string | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsPrefixListFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsPrefixListFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsPrefixListFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
