import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsRdsCertificateConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly latestValidTill?: boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsRdsCertificate extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsRdsCertificateConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get certificateType(): string;
    /**
     * @stability stable
     */
    get customerOverride(): boolean;
    /**
     * @stability stable
     */
    get customerOverrideValidTill(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _latestValidTill?;
    /**
     * @stability stable
     */
    get latestValidTill(): boolean;
    /**
     * @stability stable
     */
    set latestValidTill(value: boolean);
    /**
     * @stability stable
     */
    resetLatestValidTill(): void;
    /**
     * @stability stable
     */
    get latestValidTillInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get thumbprint(): string;
    /**
     * @stability stable
     */
    get validFrom(): string;
    /**
     * @stability stable
     */
    get validTill(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
