import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsRdsOrderableDbInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly availabilityZoneGroup?: string;
    /**
     * @stability stable
     */
    readonly engine: string;
    /**
     * @stability stable
     */
    readonly engineVersion?: string;
    /**
     * @stability stable
     */
    readonly instanceClass?: string;
    /**
     * @stability stable
     */
    readonly licenseModel?: string;
    /**
     * @stability stable
     */
    readonly preferredEngineVersions?: string[];
    /**
     * @stability stable
     */
    readonly preferredInstanceClasses?: string[];
    /**
     * @stability stable
     */
    readonly storageType?: string;
    /**
     * @stability stable
     */
    readonly supportsEnhancedMonitoring?: boolean;
    /**
     * @stability stable
     */
    readonly supportsGlobalDatabases?: boolean;
    /**
     * @stability stable
     */
    readonly supportsIamDatabaseAuthentication?: boolean;
    /**
     * @stability stable
     */
    readonly supportsIops?: boolean;
    /**
     * @stability stable
     */
    readonly supportsKerberosAuthentication?: boolean;
    /**
     * @stability stable
     */
    readonly supportsPerformanceInsights?: boolean;
    /**
     * @stability stable
     */
    readonly supportsStorageAutoscaling?: boolean;
    /**
     * @stability stable
     */
    readonly supportsStorageEncryption?: boolean;
    /**
     * @stability stable
     */
    readonly vpc?: boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsRdsOrderableDbInstance extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsRdsOrderableDbInstanceConfig);
    private _availabilityZoneGroup?;
    /**
     * @stability stable
     */
    get availabilityZoneGroup(): string;
    /**
     * @stability stable
     */
    set availabilityZoneGroup(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZoneGroup(): void;
    /**
     * @stability stable
     */
    get availabilityZoneGroupInput(): string | undefined;
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    private _engine;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    get engineInput(): string;
    private _engineVersion?;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    set engineVersion(value: string);
    /**
     * @stability stable
     */
    resetEngineVersion(): void;
    /**
     * @stability stable
     */
    get engineVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceClass?;
    /**
     * @stability stable
     */
    get instanceClass(): string;
    /**
     * @stability stable
     */
    set instanceClass(value: string);
    /**
     * @stability stable
     */
    resetInstanceClass(): void;
    /**
     * @stability stable
     */
    get instanceClassInput(): string | undefined;
    private _licenseModel?;
    /**
     * @stability stable
     */
    get licenseModel(): string;
    /**
     * @stability stable
     */
    set licenseModel(value: string);
    /**
     * @stability stable
     */
    resetLicenseModel(): void;
    /**
     * @stability stable
     */
    get licenseModelInput(): string | undefined;
    /**
     * @stability stable
     */
    get maxIopsPerDbInstance(): number;
    /**
     * @stability stable
     */
    get maxIopsPerGib(): number;
    /**
     * @stability stable
     */
    get maxStorageSize(): number;
    /**
     * @stability stable
     */
    get minIopsPerDbInstance(): number;
    /**
     * @stability stable
     */
    get minIopsPerGib(): number;
    /**
     * @stability stable
     */
    get minStorageSize(): number;
    /**
     * @stability stable
     */
    get multiAzCapable(): boolean;
    /**
     * @stability stable
     */
    get outpostCapable(): boolean;
    private _preferredEngineVersions?;
    /**
     * @stability stable
     */
    get preferredEngineVersions(): string[];
    /**
     * @stability stable
     */
    set preferredEngineVersions(value: string[]);
    /**
     * @stability stable
     */
    resetPreferredEngineVersions(): void;
    /**
     * @stability stable
     */
    get preferredEngineVersionsInput(): string[] | undefined;
    private _preferredInstanceClasses?;
    /**
     * @stability stable
     */
    get preferredInstanceClasses(): string[];
    /**
     * @stability stable
     */
    set preferredInstanceClasses(value: string[]);
    /**
     * @stability stable
     */
    resetPreferredInstanceClasses(): void;
    /**
     * @stability stable
     */
    get preferredInstanceClassesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get readReplicaCapable(): boolean;
    private _storageType?;
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    set storageType(value: string);
    /**
     * @stability stable
     */
    resetStorageType(): void;
    /**
     * @stability stable
     */
    get storageTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get supportedEngineModes(): string[];
    private _supportsEnhancedMonitoring?;
    /**
     * @stability stable
     */
    get supportsEnhancedMonitoring(): boolean;
    /**
     * @stability stable
     */
    set supportsEnhancedMonitoring(value: boolean);
    /**
     * @stability stable
     */
    resetSupportsEnhancedMonitoring(): void;
    /**
     * @stability stable
     */
    get supportsEnhancedMonitoringInput(): boolean | undefined;
    private _supportsGlobalDatabases?;
    /**
     * @stability stable
     */
    get supportsGlobalDatabases(): boolean;
    /**
     * @stability stable
     */
    set supportsGlobalDatabases(value: boolean);
    /**
     * @stability stable
     */
    resetSupportsGlobalDatabases(): void;
    /**
     * @stability stable
     */
    get supportsGlobalDatabasesInput(): boolean | undefined;
    private _supportsIamDatabaseAuthentication?;
    /**
     * @stability stable
     */
    get supportsIamDatabaseAuthentication(): boolean;
    /**
     * @stability stable
     */
    set supportsIamDatabaseAuthentication(value: boolean);
    /**
     * @stability stable
     */
    resetSupportsIamDatabaseAuthentication(): void;
    /**
     * @stability stable
     */
    get supportsIamDatabaseAuthenticationInput(): boolean | undefined;
    private _supportsIops?;
    /**
     * @stability stable
     */
    get supportsIops(): boolean;
    /**
     * @stability stable
     */
    set supportsIops(value: boolean);
    /**
     * @stability stable
     */
    resetSupportsIops(): void;
    /**
     * @stability stable
     */
    get supportsIopsInput(): boolean | undefined;
    private _supportsKerberosAuthentication?;
    /**
     * @stability stable
     */
    get supportsKerberosAuthentication(): boolean;
    /**
     * @stability stable
     */
    set supportsKerberosAuthentication(value: boolean);
    /**
     * @stability stable
     */
    resetSupportsKerberosAuthentication(): void;
    /**
     * @stability stable
     */
    get supportsKerberosAuthenticationInput(): boolean | undefined;
    private _supportsPerformanceInsights?;
    /**
     * @stability stable
     */
    get supportsPerformanceInsights(): boolean;
    /**
     * @stability stable
     */
    set supportsPerformanceInsights(value: boolean);
    /**
     * @stability stable
     */
    resetSupportsPerformanceInsights(): void;
    /**
     * @stability stable
     */
    get supportsPerformanceInsightsInput(): boolean | undefined;
    private _supportsStorageAutoscaling?;
    /**
     * @stability stable
     */
    get supportsStorageAutoscaling(): boolean;
    /**
     * @stability stable
     */
    set supportsStorageAutoscaling(value: boolean);
    /**
     * @stability stable
     */
    resetSupportsStorageAutoscaling(): void;
    /**
     * @stability stable
     */
    get supportsStorageAutoscalingInput(): boolean | undefined;
    private _supportsStorageEncryption?;
    /**
     * @stability stable
     */
    get supportsStorageEncryption(): boolean;
    /**
     * @stability stable
     */
    set supportsStorageEncryption(value: boolean);
    /**
     * @stability stable
     */
    resetSupportsStorageEncryption(): void;
    /**
     * @stability stable
     */
    get supportsStorageEncryptionInput(): boolean | undefined;
    private _vpc?;
    /**
     * @stability stable
     */
    get vpc(): boolean;
    /**
     * @stability stable
     */
    set vpc(value: boolean);
    /**
     * @stability stable
     */
    resetVpc(): void;
    /**
     * @stability stable
     */
    get vpcInput(): boolean | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
