import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsRedshiftOrderableClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly clusterType?: string;
    /**
     * @stability stable
     */
    readonly clusterVersion?: string;
    /**
     * @stability stable
     */
    readonly nodeType?: string;
    /**
     * @stability stable
     */
    readonly preferredNodeTypes?: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsRedshiftOrderableCluster extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsRedshiftOrderableClusterConfig);
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    private _clusterType?;
    /**
     * @stability stable
     */
    get clusterType(): string;
    /**
     * @stability stable
     */
    set clusterType(value: string);
    /**
     * @stability stable
     */
    resetClusterType(): void;
    /**
     * @stability stable
     */
    get clusterTypeInput(): string | undefined;
    private _clusterVersion?;
    /**
     * @stability stable
     */
    get clusterVersion(): string;
    /**
     * @stability stable
     */
    set clusterVersion(value: string);
    /**
     * @stability stable
     */
    resetClusterVersion(): void;
    /**
     * @stability stable
     */
    get clusterVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _nodeType?;
    /**
     * @stability stable
     */
    get nodeType(): string;
    /**
     * @stability stable
     */
    set nodeType(value: string);
    /**
     * @stability stable
     */
    resetNodeType(): void;
    /**
     * @stability stable
     */
    get nodeTypeInput(): string | undefined;
    private _preferredNodeTypes?;
    /**
     * @stability stable
     */
    get preferredNodeTypes(): string[];
    /**
     * @stability stable
     */
    set preferredNodeTypes(value: string[]);
    /**
     * @stability stable
     */
    resetPreferredNodeTypes(): void;
    /**
     * @stability stable
     */
    get preferredNodeTypesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
