import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsRouteConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly destinationCidrBlock?: string;
    /**
     * @stability stable
     */
    readonly destinationIpv6CidrBlock?: string;
    /**
     * @stability stable
     */
    readonly egressOnlyGatewayId?: string;
    /**
     * @stability stable
     */
    readonly gatewayId?: string;
    /**
     * @stability stable
     */
    readonly instanceId?: string;
    /**
     * @stability stable
     */
    readonly localGatewayId?: string;
    /**
     * @stability stable
     */
    readonly natGatewayId?: string;
    /**
     * @stability stable
     */
    readonly networkInterfaceId?: string;
    /**
     * @stability stable
     */
    readonly routeTableId: string;
    /**
     * @stability stable
     */
    readonly transitGatewayId?: string;
    /**
     * @stability stable
     */
    readonly vpcPeeringConnectionId?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsRoute extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsRouteConfig);
    private _destinationCidrBlock?;
    /**
     * @stability stable
     */
    get destinationCidrBlock(): string;
    /**
     * @stability stable
     */
    set destinationCidrBlock(value: string);
    /**
     * @stability stable
     */
    resetDestinationCidrBlock(): void;
    /**
     * @stability stable
     */
    get destinationCidrBlockInput(): string | undefined;
    private _destinationIpv6CidrBlock?;
    /**
     * @stability stable
     */
    get destinationIpv6CidrBlock(): string;
    /**
     * @stability stable
     */
    set destinationIpv6CidrBlock(value: string);
    /**
     * @stability stable
     */
    resetDestinationIpv6CidrBlock(): void;
    /**
     * @stability stable
     */
    get destinationIpv6CidrBlockInput(): string | undefined;
    private _egressOnlyGatewayId?;
    /**
     * @stability stable
     */
    get egressOnlyGatewayId(): string;
    /**
     * @stability stable
     */
    set egressOnlyGatewayId(value: string);
    /**
     * @stability stable
     */
    resetEgressOnlyGatewayId(): void;
    /**
     * @stability stable
     */
    get egressOnlyGatewayIdInput(): string | undefined;
    private _gatewayId?;
    /**
     * @stability stable
     */
    get gatewayId(): string;
    /**
     * @stability stable
     */
    set gatewayId(value: string);
    /**
     * @stability stable
     */
    resetGatewayId(): void;
    /**
     * @stability stable
     */
    get gatewayIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceId?;
    /**
     * @stability stable
     */
    get instanceId(): string;
    /**
     * @stability stable
     */
    set instanceId(value: string);
    /**
     * @stability stable
     */
    resetInstanceId(): void;
    /**
     * @stability stable
     */
    get instanceIdInput(): string | undefined;
    private _localGatewayId?;
    /**
     * @stability stable
     */
    get localGatewayId(): string;
    /**
     * @stability stable
     */
    set localGatewayId(value: string);
    /**
     * @stability stable
     */
    resetLocalGatewayId(): void;
    /**
     * @stability stable
     */
    get localGatewayIdInput(): string | undefined;
    private _natGatewayId?;
    /**
     * @stability stable
     */
    get natGatewayId(): string;
    /**
     * @stability stable
     */
    set natGatewayId(value: string);
    /**
     * @stability stable
     */
    resetNatGatewayId(): void;
    /**
     * @stability stable
     */
    get natGatewayIdInput(): string | undefined;
    private _networkInterfaceId?;
    /**
     * @stability stable
     */
    get networkInterfaceId(): string;
    /**
     * @stability stable
     */
    set networkInterfaceId(value: string);
    /**
     * @stability stable
     */
    resetNetworkInterfaceId(): void;
    /**
     * @stability stable
     */
    get networkInterfaceIdInput(): string | undefined;
    private _routeTableId;
    /**
     * @stability stable
     */
    get routeTableId(): string;
    /**
     * @stability stable
     */
    set routeTableId(value: string);
    /**
     * @stability stable
     */
    get routeTableIdInput(): string;
    private _transitGatewayId?;
    /**
     * @stability stable
     */
    get transitGatewayId(): string;
    /**
     * @stability stable
     */
    set transitGatewayId(value: string);
    /**
     * @stability stable
     */
    resetTransitGatewayId(): void;
    /**
     * @stability stable
     */
    get transitGatewayIdInput(): string | undefined;
    private _vpcPeeringConnectionId?;
    /**
     * @stability stable
     */
    get vpcPeeringConnectionId(): string;
    /**
     * @stability stable
     */
    set vpcPeeringConnectionId(value: string);
    /**
     * @stability stable
     */
    resetVpcPeeringConnectionId(): void;
    /**
     * @stability stable
     */
    get vpcPeeringConnectionIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
