import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsRoute53ResolverRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly domainName?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly resolverEndpointId?: string;
    /**
     * @stability stable
     */
    readonly resolverRuleId?: string;
    /**
     * @stability stable
     */
    readonly ruleType?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsRoute53ResolverRule extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsRoute53ResolverRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _domainName?;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    resetDomainName(): void;
    /**
     * @stability stable
     */
    get domainNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _resolverEndpointId?;
    /**
     * @stability stable
     */
    get resolverEndpointId(): string;
    /**
     * @stability stable
     */
    set resolverEndpointId(value: string);
    /**
     * @stability stable
     */
    resetResolverEndpointId(): void;
    /**
     * @stability stable
     */
    get resolverEndpointIdInput(): string | undefined;
    private _resolverRuleId?;
    /**
     * @stability stable
     */
    get resolverRuleId(): string;
    /**
     * @stability stable
     */
    set resolverRuleId(value: string);
    /**
     * @stability stable
     */
    resetResolverRuleId(): void;
    /**
     * @stability stable
     */
    get resolverRuleIdInput(): string | undefined;
    private _ruleType?;
    /**
     * @stability stable
     */
    get ruleType(): string;
    /**
     * @stability stable
     */
    set ruleType(value: string);
    /**
     * @stability stable
     */
    resetRuleType(): void;
    /**
     * @stability stable
     */
    get ruleTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get shareStatus(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
