import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsRoute53ResolverRulesConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly ownerId?: string;
    /**
     * @stability stable
     */
    readonly resolverEndpointId?: string;
    /**
     * @stability stable
     */
    readonly ruleType?: string;
    /**
     * @stability stable
     */
    readonly shareStatus?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsRoute53ResolverRules extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsRoute53ResolverRulesConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _ownerId?;
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    set ownerId(value: string);
    /**
     * @stability stable
     */
    resetOwnerId(): void;
    /**
     * @stability stable
     */
    get ownerIdInput(): string | undefined;
    private _resolverEndpointId?;
    /**
     * @stability stable
     */
    get resolverEndpointId(): string;
    /**
     * @stability stable
     */
    set resolverEndpointId(value: string);
    /**
     * @stability stable
     */
    resetResolverEndpointId(): void;
    /**
     * @stability stable
     */
    get resolverEndpointIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get resolverRuleIds(): string[];
    private _ruleType?;
    /**
     * @stability stable
     */
    get ruleType(): string;
    /**
     * @stability stable
     */
    set ruleType(value: string);
    /**
     * @stability stable
     */
    resetRuleType(): void;
    /**
     * @stability stable
     */
    get ruleTypeInput(): string | undefined;
    private _shareStatus?;
    /**
     * @stability stable
     */
    get shareStatus(): string;
    /**
     * @stability stable
     */
    set shareStatus(value: string);
    /**
     * @stability stable
     */
    resetShareStatus(): void;
    /**
     * @stability stable
     */
    get shareStatusInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
