import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsRoute53ZoneConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly privateZone?: boolean;
    /**
     * @stability stable
     */
    readonly resourceRecordSetCount?: number;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcId?: string;
    /**
     * @stability stable
     */
    readonly zoneId?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsRoute53Zone extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsRoute53ZoneConfig);
    /**
     * @stability stable
     */
    get callerReference(): string;
    /**
     * @stability stable
     */
    get comment(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get linkedServiceDescription(): string;
    /**
     * @stability stable
     */
    get linkedServicePrincipal(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get nameServers(): string[];
    private _privateZone?;
    /**
     * @stability stable
     */
    get privateZone(): boolean;
    /**
     * @stability stable
     */
    set privateZone(value: boolean);
    /**
     * @stability stable
     */
    resetPrivateZone(): void;
    /**
     * @stability stable
     */
    get privateZoneInput(): boolean | undefined;
    private _resourceRecordSetCount?;
    /**
     * @stability stable
     */
    get resourceRecordSetCount(): number;
    /**
     * @stability stable
     */
    set resourceRecordSetCount(value: number);
    /**
     * @stability stable
     */
    resetResourceRecordSetCount(): void;
    /**
     * @stability stable
     */
    get resourceRecordSetCountInput(): number | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    resetVpcId(): void;
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    private _zoneId?;
    /**
     * @stability stable
     */
    get zoneId(): string;
    /**
     * @stability stable
     */
    set zoneId(value: string);
    /**
     * @stability stable
     */
    resetZoneId(): void;
    /**
     * @stability stable
     */
    get zoneIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
