import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsS3BucketObjectsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly bucket: string;
    /**
     * @stability stable
     */
    readonly delimiter?: string;
    /**
     * @stability stable
     */
    readonly encodingType?: string;
    /**
     * @stability stable
     */
    readonly fetchOwner?: boolean;
    /**
     * @stability stable
     */
    readonly maxKeys?: number;
    /**
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * @stability stable
     */
    readonly startAfter?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsS3BucketObjects extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsS3BucketObjectsConfig);
    private _bucket;
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    set bucket(value: string);
    /**
     * @stability stable
     */
    get bucketInput(): string;
    /**
     * @stability stable
     */
    get commonPrefixes(): string[];
    private _delimiter?;
    /**
     * @stability stable
     */
    get delimiter(): string;
    /**
     * @stability stable
     */
    set delimiter(value: string);
    /**
     * @stability stable
     */
    resetDelimiter(): void;
    /**
     * @stability stable
     */
    get delimiterInput(): string | undefined;
    private _encodingType?;
    /**
     * @stability stable
     */
    get encodingType(): string;
    /**
     * @stability stable
     */
    set encodingType(value: string);
    /**
     * @stability stable
     */
    resetEncodingType(): void;
    /**
     * @stability stable
     */
    get encodingTypeInput(): string | undefined;
    private _fetchOwner?;
    /**
     * @stability stable
     */
    get fetchOwner(): boolean;
    /**
     * @stability stable
     */
    set fetchOwner(value: boolean);
    /**
     * @stability stable
     */
    resetFetchOwner(): void;
    /**
     * @stability stable
     */
    get fetchOwnerInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get keys(): string[];
    private _maxKeys?;
    /**
     * @stability stable
     */
    get maxKeys(): number;
    /**
     * @stability stable
     */
    set maxKeys(value: number);
    /**
     * @stability stable
     */
    resetMaxKeys(): void;
    /**
     * @stability stable
     */
    get maxKeysInput(): number | undefined;
    /**
     * @stability stable
     */
    get owners(): string[];
    private _prefix?;
    /**
     * @stability stable
     */
    get prefix(): string;
    /**
     * @stability stable
     */
    set prefix(value: string);
    /**
     * @stability stable
     */
    resetPrefix(): void;
    /**
     * @stability stable
     */
    get prefixInput(): string | undefined;
    private _startAfter?;
    /**
     * @stability stable
     */
    get startAfter(): string;
    /**
     * @stability stable
     */
    set startAfter(value: string);
    /**
     * @stability stable
     */
    resetStartAfter(): void;
    /**
     * @stability stable
     */
    get startAfterInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
