import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsSagemakerPrebuiltEcrImageConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly dnsSuffix?: string;
    /**
     * @stability stable
     */
    readonly imageTag?: string;
    /**
     * @stability stable
     */
    readonly region?: string;
    /**
     * @stability stable
     */
    readonly repositoryName: string;
}
/**
 * @stability stable
 */
export declare class DataAwsSagemakerPrebuiltEcrImage extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsSagemakerPrebuiltEcrImageConfig);
    private _dnsSuffix?;
    /**
     * @stability stable
     */
    get dnsSuffix(): string;
    /**
     * @stability stable
     */
    set dnsSuffix(value: string);
    /**
     * @stability stable
     */
    resetDnsSuffix(): void;
    /**
     * @stability stable
     */
    get dnsSuffixInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _imageTag?;
    /**
     * @stability stable
     */
    get imageTag(): string;
    /**
     * @stability stable
     */
    set imageTag(value: string);
    /**
     * @stability stable
     */
    resetImageTag(): void;
    /**
     * @stability stable
     */
    get imageTagInput(): string | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    /**
     * @stability stable
     */
    get registryId(): string;
    /**
     * @stability stable
     */
    get registryPath(): string;
    private _repositoryName;
    /**
     * @stability stable
     */
    get repositoryName(): string;
    /**
     * @stability stable
     */
    set repositoryName(value: string);
    /**
     * @stability stable
     */
    get repositoryNameInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
