import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsSecretsmanagerSecretVersionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly secretId: string;
    /**
     * @stability stable
     */
    readonly versionId?: string;
    /**
     * @stability stable
     */
    readonly versionStage?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsSecretsmanagerSecretVersion extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsSecretsmanagerSecretVersionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get secretBinary(): string;
    private _secretId;
    /**
     * @stability stable
     */
    get secretId(): string;
    /**
     * @stability stable
     */
    set secretId(value: string);
    /**
     * @stability stable
     */
    get secretIdInput(): string;
    /**
     * @stability stable
     */
    get secretString(): string;
    private _versionId?;
    /**
     * @stability stable
     */
    get versionId(): string;
    /**
     * @stability stable
     */
    set versionId(value: string);
    /**
     * @stability stable
     */
    resetVersionId(): void;
    /**
     * @stability stable
     */
    get versionIdInput(): string | undefined;
    private _versionStage?;
    /**
     * @stability stable
     */
    get versionStage(): string;
    /**
     * @stability stable
     */
    set versionStage(value: string);
    /**
     * @stability stable
     */
    resetVersionStage(): void;
    /**
     * @stability stable
     */
    get versionStageInput(): string | undefined;
    /**
     * @stability stable
     */
    get versionStages(): string[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
