import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsSecretsmanagerSecretConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsSecretsmanagerSecretRotationRules extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get automaticallyAfterDays(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsSecretsmanagerSecret extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsSecretsmanagerSecretConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get policy(): string;
    /**
     * @stability stable
     */
    get rotationEnabled(): boolean;
    /**
     * @stability stable
     */
    get rotationLambdaArn(): string;
    /**
     * @stability stable
     */
    rotationRules(index: string): DataAwsSecretsmanagerSecretRotationRules;
    /**
     * @stability stable
     */
    tags(key: string): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
