import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsSignerSigningProfileConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsSignerSigningProfileRevocationRecord extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get revocationEffectiveFrom(): string;
    /**
     * @stability stable
     */
    get revokedAt(): string;
    /**
     * @stability stable
     */
    get revokedBy(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsSignerSigningProfileSignatureValidityPeriod extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    get value(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsSignerSigningProfile extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsSignerSigningProfileConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get platformDisplayName(): string;
    /**
     * @stability stable
     */
    get platformId(): string;
    /**
     * @stability stable
     */
    revocationRecord(index: string): DataAwsSignerSigningProfileRevocationRecord;
    /**
     * @stability stable
     */
    signatureValidityPeriod(index: string): DataAwsSignerSigningProfileSignatureValidityPeriod;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    get versionArn(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
