import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsSsmDocumentConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly documentFormat?: string;
    /**
     * @stability stable
     */
    readonly documentVersion?: string;
    /**
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export declare class DataAwsSsmDocument extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsSsmDocumentConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get content(): string;
    private _documentFormat?;
    /**
     * @stability stable
     */
    get documentFormat(): string;
    /**
     * @stability stable
     */
    set documentFormat(value: string);
    /**
     * @stability stable
     */
    resetDocumentFormat(): void;
    /**
     * @stability stable
     */
    get documentFormatInput(): string | undefined;
    /**
     * @stability stable
     */
    get documentType(): string;
    private _documentVersion?;
    /**
     * @stability stable
     */
    get documentVersion(): string;
    /**
     * @stability stable
     */
    set documentVersion(value: string);
    /**
     * @stability stable
     */
    resetDocumentVersion(): void;
    /**
     * @stability stable
     */
    get documentVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
