import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsSsmPatchBaselineConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly defaultBaseline?: boolean;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly operatingSystem?: string;
    /**
     * @stability stable
     */
    readonly owner: string;
}
/**
 * @stability stable
 */
export declare class DataAwsSsmPatchBaseline extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsSsmPatchBaselineConfig);
    private _defaultBaseline?;
    /**
     * @stability stable
     */
    get defaultBaseline(): boolean;
    /**
     * @stability stable
     */
    set defaultBaseline(value: boolean);
    /**
     * @stability stable
     */
    resetDefaultBaseline(): void;
    /**
     * @stability stable
     */
    get defaultBaselineInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _operatingSystem?;
    /**
     * @stability stable
     */
    get operatingSystem(): string;
    /**
     * @stability stable
     */
    set operatingSystem(value: string);
    /**
     * @stability stable
     */
    resetOperatingSystem(): void;
    /**
     * @stability stable
     */
    get operatingSystemInput(): string | undefined;
    private _owner;
    /**
     * @stability stable
     */
    get owner(): string;
    /**
     * @stability stable
     */
    set owner(value: string);
    /**
     * @stability stable
     */
    get ownerInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
