import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsSubnetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * @stability stable
     */
    readonly availabilityZoneId?: string;
    /**
     * @stability stable
     */
    readonly cidrBlock?: string;
    /**
     * @stability stable
     */
    readonly defaultForAz?: boolean;
    /**
     * @stability stable
     */
    readonly ipv6CidrBlock?: string;
    /**
     * @stability stable
     */
    readonly state?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcId?: string;
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsSubnetFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsSubnetFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsSubnet extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsSubnetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get assignIpv6AddressOnCreation(): boolean;
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    private _availabilityZoneId?;
    /**
     * @stability stable
     */
    get availabilityZoneId(): string;
    /**
     * @stability stable
     */
    set availabilityZoneId(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZoneId(): void;
    /**
     * @stability stable
     */
    get availabilityZoneIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get availableIpAddressCount(): number;
    private _cidrBlock?;
    /**
     * @stability stable
     */
    get cidrBlock(): string;
    /**
     * @stability stable
     */
    set cidrBlock(value: string);
    /**
     * @stability stable
     */
    resetCidrBlock(): void;
    /**
     * @stability stable
     */
    get cidrBlockInput(): string | undefined;
    /**
     * @stability stable
     */
    get customerOwnedIpv4Pool(): string;
    private _defaultForAz?;
    /**
     * @stability stable
     */
    get defaultForAz(): boolean;
    /**
     * @stability stable
     */
    set defaultForAz(value: boolean);
    /**
     * @stability stable
     */
    resetDefaultForAz(): void;
    /**
     * @stability stable
     */
    get defaultForAzInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _ipv6CidrBlock?;
    /**
     * @stability stable
     */
    get ipv6CidrBlock(): string;
    /**
     * @stability stable
     */
    set ipv6CidrBlock(value: string);
    /**
     * @stability stable
     */
    resetIpv6CidrBlock(): void;
    /**
     * @stability stable
     */
    get ipv6CidrBlockInput(): string | undefined;
    /**
     * @stability stable
     */
    get ipv6CidrBlockAssociationId(): string;
    /**
     * @stability stable
     */
    get mapCustomerOwnedIpOnLaunch(): boolean;
    /**
     * @stability stable
     */
    get mapPublicIpOnLaunch(): boolean;
    /**
     * @stability stable
     */
    get outpostArn(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _state?;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    set state(value: string);
    /**
     * @stability stable
     */
    resetState(): void;
    /**
     * @stability stable
     */
    get stateInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    resetVpcId(): void;
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsSubnetFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsSubnetFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsSubnetFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
