import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsVpcEndpointServiceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly service?: string;
    /**
     * @stability stable
     */
    readonly serviceName?: string;
    /**
     * @stability stable
     */
    readonly serviceType?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsVpcEndpointServiceFilter[];
}
/**
 * @stability stable
 */
export interface DataAwsVpcEndpointServiceFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsVpcEndpointService extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsVpcEndpointServiceConfig);
    /**
     * @stability stable
     */
    get acceptanceRequired(): boolean;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    /**
     * @stability stable
     */
    get baseEndpointDnsNames(): string[];
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get managesVpcEndpoints(): boolean;
    /**
     * @stability stable
     */
    get owner(): string;
    /**
     * @stability stable
     */
    get privateDnsName(): string;
    private _service?;
    /**
     * @stability stable
     */
    get service(): string;
    /**
     * @stability stable
     */
    set service(value: string);
    /**
     * @stability stable
     */
    resetService(): void;
    /**
     * @stability stable
     */
    get serviceInput(): string | undefined;
    /**
     * @stability stable
     */
    get serviceId(): string;
    private _serviceName?;
    /**
     * @stability stable
     */
    get serviceName(): string;
    /**
     * @stability stable
     */
    set serviceName(value: string);
    /**
     * @stability stable
     */
    resetServiceName(): void;
    /**
     * @stability stable
     */
    get serviceNameInput(): string | undefined;
    private _serviceType?;
    /**
     * @stability stable
     */
    get serviceType(): string;
    /**
     * @stability stable
     */
    set serviceType(value: string);
    /**
     * @stability stable
     */
    resetServiceType(): void;
    /**
     * @stability stable
     */
    get serviceTypeInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get vpcEndpointPolicySupported(): boolean;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsVpcEndpointServiceFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsVpcEndpointServiceFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsVpcEndpointServiceFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
