import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsVpcPeeringConnectionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly cidrBlock?: string;
    /**
     * @stability stable
     */
    readonly ownerId?: string;
    /**
     * @stability stable
     */
    readonly peerCidrBlock?: string;
    /**
     * @stability stable
     */
    readonly peerOwnerId?: string;
    /**
     * @stability stable
     */
    readonly peerRegion?: string;
    /**
     * @stability stable
     */
    readonly peerVpcId?: string;
    /**
     * @stability stable
     */
    readonly region?: string;
    /**
     * @stability stable
     */
    readonly status?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcId?: string;
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: DataAwsVpcPeeringConnectionFilter[];
}
/**
 * @stability stable
 */
export declare class DataAwsVpcPeeringConnectionCidrBlockSet extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cidrBlock(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsVpcPeeringConnectionPeerCidrBlockSet extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get cidrBlock(): string;
}
/**
 * @stability stable
 */
export interface DataAwsVpcPeeringConnectionFilter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class DataAwsVpcPeeringConnection extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsVpcPeeringConnectionConfig);
    /**
     * @stability stable
     */
    accepter(key: string): boolean;
    private _cidrBlock?;
    /**
     * @stability stable
     */
    get cidrBlock(): string;
    /**
     * @stability stable
     */
    set cidrBlock(value: string);
    /**
     * @stability stable
     */
    resetCidrBlock(): void;
    /**
     * @stability stable
     */
    get cidrBlockInput(): string | undefined;
    /**
     * @stability stable
     */
    cidrBlockSet(index: string): DataAwsVpcPeeringConnectionCidrBlockSet;
    /**
     * @stability stable
     */
    get id(): string;
    private _ownerId?;
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    set ownerId(value: string);
    /**
     * @stability stable
     */
    resetOwnerId(): void;
    /**
     * @stability stable
     */
    get ownerIdInput(): string | undefined;
    private _peerCidrBlock?;
    /**
     * @stability stable
     */
    get peerCidrBlock(): string;
    /**
     * @stability stable
     */
    set peerCidrBlock(value: string);
    /**
     * @stability stable
     */
    resetPeerCidrBlock(): void;
    /**
     * @stability stable
     */
    get peerCidrBlockInput(): string | undefined;
    /**
     * @stability stable
     */
    peerCidrBlockSet(index: string): DataAwsVpcPeeringConnectionPeerCidrBlockSet;
    private _peerOwnerId?;
    /**
     * @stability stable
     */
    get peerOwnerId(): string;
    /**
     * @stability stable
     */
    set peerOwnerId(value: string);
    /**
     * @stability stable
     */
    resetPeerOwnerId(): void;
    /**
     * @stability stable
     */
    get peerOwnerIdInput(): string | undefined;
    private _peerRegion?;
    /**
     * @stability stable
     */
    get peerRegion(): string;
    /**
     * @stability stable
     */
    set peerRegion(value: string);
    /**
     * @stability stable
     */
    resetPeerRegion(): void;
    /**
     * @stability stable
     */
    get peerRegionInput(): string | undefined;
    private _peerVpcId?;
    /**
     * @stability stable
     */
    get peerVpcId(): string;
    /**
     * @stability stable
     */
    set peerVpcId(value: string);
    /**
     * @stability stable
     */
    resetPeerVpcId(): void;
    /**
     * @stability stable
     */
    get peerVpcIdInput(): string | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    /**
     * @stability stable
     */
    requester(key: string): boolean;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    set status(value: string);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    resetVpcId(): void;
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): DataAwsVpcPeeringConnectionFilter[];
    /**
     * @stability stable
     */
    set filter(value: DataAwsVpcPeeringConnectionFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): DataAwsVpcPeeringConnectionFilter[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
