import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsWorkspacesBundleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly bundleId?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly owner?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsWorkspacesBundleComputeType extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get name(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsWorkspacesBundleRootStorage extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get capacity(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsWorkspacesBundleUserStorage extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get capacity(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsWorkspacesBundle extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsWorkspacesBundleConfig);
    private _bundleId?;
    /**
     * @stability stable
     */
    get bundleId(): string;
    /**
     * @stability stable
     */
    set bundleId(value: string);
    /**
     * @stability stable
     */
    resetBundleId(): void;
    /**
     * @stability stable
     */
    get bundleIdInput(): string | undefined;
    /**
     * @stability stable
     */
    computeType(index: string): DataAwsWorkspacesBundleComputeType;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _owner?;
    /**
     * @stability stable
     */
    get owner(): string;
    /**
     * @stability stable
     */
    set owner(value: string);
    /**
     * @stability stable
     */
    resetOwner(): void;
    /**
     * @stability stable
     */
    get ownerInput(): string | undefined;
    /**
     * @stability stable
     */
    rootStorage(index: string): DataAwsWorkspacesBundleRootStorage;
    /**
     * @stability stable
     */
    userStorage(index: string): DataAwsWorkspacesBundleUserStorage;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
