import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsWorkspacesDirectoryConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly directoryId: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DataAwsWorkspacesDirectorySelfServicePermissions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get changeComputeType(): boolean;
    /**
     * @stability stable
     */
    get increaseVolumeSize(): boolean;
    /**
     * @stability stable
     */
    get rebuildWorkspace(): boolean;
    /**
     * @stability stable
     */
    get restartWorkspace(): boolean;
    /**
     * @stability stable
     */
    get switchRunningMode(): boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsWorkspacesDirectoryWorkspaceAccessProperties extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get deviceTypeAndroid(): string;
    /**
     * @stability stable
     */
    get deviceTypeChromeos(): string;
    /**
     * @stability stable
     */
    get deviceTypeIos(): string;
    /**
     * @stability stable
     */
    get deviceTypeOsx(): string;
    /**
     * @stability stable
     */
    get deviceTypeWeb(): string;
    /**
     * @stability stable
     */
    get deviceTypeWindows(): string;
    /**
     * @stability stable
     */
    get deviceTypeZeroclient(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsWorkspacesDirectoryWorkspaceCreationProperties extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get customSecurityGroupId(): string;
    /**
     * @stability stable
     */
    get defaultOu(): string;
    /**
     * @stability stable
     */
    get enableInternetAccess(): boolean;
    /**
     * @stability stable
     */
    get enableMaintenanceMode(): boolean;
    /**
     * @stability stable
     */
    get userEnabledAsLocalAdministrator(): boolean;
}
/**
 * @stability stable
 */
export declare class DataAwsWorkspacesDirectory extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsWorkspacesDirectoryConfig);
    /**
     * @stability stable
     */
    get alias(): string;
    /**
     * @stability stable
     */
    get customerUserName(): string;
    private _directoryId;
    /**
     * @stability stable
     */
    get directoryId(): string;
    /**
     * @stability stable
     */
    set directoryId(value: string);
    /**
     * @stability stable
     */
    get directoryIdInput(): string;
    /**
     * @stability stable
     */
    get directoryName(): string;
    /**
     * @stability stable
     */
    get directoryType(): string;
    /**
     * @stability stable
     */
    get dnsIpAddresses(): string[];
    /**
     * @stability stable
     */
    get iamRoleId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ipGroupIds(): string[];
    /**
     * @stability stable
     */
    get registrationCode(): string;
    /**
     * @stability stable
     */
    selfServicePermissions(index: string): DataAwsWorkspacesDirectorySelfServicePermissions;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    workspaceAccessProperties(index: string): DataAwsWorkspacesDirectoryWorkspaceAccessProperties;
    /**
     * @stability stable
     */
    workspaceCreationProperties(index: string): DataAwsWorkspacesDirectoryWorkspaceCreationProperties;
    /**
     * @stability stable
     */
    get workspaceSecurityGroupId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
