import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsWorkspacesWorkspaceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly directoryId?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly userName?: string;
    /**
     * @stability stable
     */
    readonly workspaceId?: string;
}
/**
 * @stability stable
 */
export declare class DataAwsWorkspacesWorkspaceWorkspaceProperties extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get computeTypeName(): string;
    /**
     * @stability stable
     */
    get rootVolumeSizeGib(): number;
    /**
     * @stability stable
     */
    get runningMode(): string;
    /**
     * @stability stable
     */
    get runningModeAutoStopTimeoutInMinutes(): number;
    /**
     * @stability stable
     */
    get userVolumeSizeGib(): number;
}
/**
 * @stability stable
 */
export declare class DataAwsWorkspacesWorkspace extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataAwsWorkspacesWorkspaceConfig);
    /**
     * @stability stable
     */
    get bundleId(): string;
    /**
     * @stability stable
     */
    get computerName(): string;
    private _directoryId?;
    /**
     * @stability stable
     */
    get directoryId(): string;
    /**
     * @stability stable
     */
    set directoryId(value: string);
    /**
     * @stability stable
     */
    resetDirectoryId(): void;
    /**
     * @stability stable
     */
    get directoryIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ipAddress(): string;
    /**
     * @stability stable
     */
    get rootVolumeEncryptionEnabled(): boolean;
    /**
     * @stability stable
     */
    get state(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _userName?;
    /**
     * @stability stable
     */
    get userName(): string;
    /**
     * @stability stable
     */
    set userName(value: string);
    /**
     * @stability stable
     */
    resetUserName(): void;
    /**
     * @stability stable
     */
    get userNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get userVolumeEncryptionEnabled(): boolean;
    /**
     * @stability stable
     */
    get volumeEncryptionKey(): string;
    private _workspaceId?;
    /**
     * @stability stable
     */
    get workspaceId(): string;
    /**
     * @stability stable
     */
    set workspaceId(value: string);
    /**
     * @stability stable
     */
    resetWorkspaceId(): void;
    /**
     * @stability stable
     */
    get workspaceIdInput(): string | undefined;
    /**
     * @stability stable
     */
    workspaceProperties(index: string): DataAwsWorkspacesWorkspaceWorkspaceProperties;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
