import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DatasyncLocationEfsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly efsFileSystemArn: string;
    /**
     * @stability stable
     */
    readonly subdirectory?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * ec2_config block.
     *
     * @stability stable
     */
    readonly ec2Config: DatasyncLocationEfsEc2Config[];
}
/**
 * @stability stable
 */
export interface DatasyncLocationEfsEc2Config {
    /**
     * @stability stable
     */
    readonly securityGroupArns: string[];
    /**
     * @stability stable
     */
    readonly subnetArn: string;
}
/**
 * @stability stable
 */
export declare class DatasyncLocationEfs extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DatasyncLocationEfsConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _efsFileSystemArn;
    /**
     * @stability stable
     */
    get efsFileSystemArn(): string;
    /**
     * @stability stable
     */
    set efsFileSystemArn(value: string);
    /**
     * @stability stable
     */
    get efsFileSystemArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _subdirectory?;
    /**
     * @stability stable
     */
    get subdirectory(): string;
    /**
     * @stability stable
     */
    set subdirectory(value: string);
    /**
     * @stability stable
     */
    resetSubdirectory(): void;
    /**
     * @stability stable
     */
    get subdirectoryInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get uri(): string;
    private _ec2Config;
    /**
     * @stability stable
     */
    get ec2Config(): DatasyncLocationEfsEc2Config[];
    /**
     * @stability stable
     */
    set ec2Config(value: DatasyncLocationEfsEc2Config[]);
    /**
     * @stability stable
     */
    get ec2ConfigInput(): DatasyncLocationEfsEc2Config[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
