import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DatasyncLocationNfsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly serverHostname: string;
    /**
     * @stability stable
     */
    readonly subdirectory: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * on_prem_config block.
     *
     * @stability stable
     */
    readonly onPremConfig: DatasyncLocationNfsOnPremConfig[];
}
/**
 * @stability stable
 */
export interface DatasyncLocationNfsOnPremConfig {
    /**
     * @stability stable
     */
    readonly agentArns: string[];
}
/**
 * @stability stable
 */
export declare class DatasyncLocationNfs extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DatasyncLocationNfsConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _serverHostname;
    /**
     * @stability stable
     */
    get serverHostname(): string;
    /**
     * @stability stable
     */
    set serverHostname(value: string);
    /**
     * @stability stable
     */
    get serverHostnameInput(): string;
    private _subdirectory;
    /**
     * @stability stable
     */
    get subdirectory(): string;
    /**
     * @stability stable
     */
    set subdirectory(value: string);
    /**
     * @stability stable
     */
    get subdirectoryInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get uri(): string;
    private _onPremConfig;
    /**
     * @stability stable
     */
    get onPremConfig(): DatasyncLocationNfsOnPremConfig[];
    /**
     * @stability stable
     */
    set onPremConfig(value: DatasyncLocationNfsOnPremConfig[]);
    /**
     * @stability stable
     */
    get onPremConfigInput(): DatasyncLocationNfsOnPremConfig[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
