import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DatasyncLocationS3Config extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly s3BucketArn: string;
    /**
     * @stability stable
     */
    readonly subdirectory: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * s3_config block.
     *
     * @stability stable
     */
    readonly s3Config: DatasyncLocationS3S3Config[];
}
/**
 * @stability stable
 */
export interface DatasyncLocationS3S3Config {
    /**
     * @stability stable
     */
    readonly bucketAccessRoleArn: string;
}
/**
 * @stability stable
 */
export declare class DatasyncLocationS3 extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DatasyncLocationS3Config);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _s3BucketArn;
    /**
     * @stability stable
     */
    get s3BucketArn(): string;
    /**
     * @stability stable
     */
    set s3BucketArn(value: string);
    /**
     * @stability stable
     */
    get s3BucketArnInput(): string;
    private _subdirectory;
    /**
     * @stability stable
     */
    get subdirectory(): string;
    /**
     * @stability stable
     */
    set subdirectory(value: string);
    /**
     * @stability stable
     */
    get subdirectoryInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get uri(): string;
    private _s3Config;
    /**
     * @stability stable
     */
    get s3Config(): DatasyncLocationS3S3Config[];
    /**
     * @stability stable
     */
    set s3Config(value: DatasyncLocationS3S3Config[]);
    /**
     * @stability stable
     */
    get s3ConfigInput(): DatasyncLocationS3S3Config[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
