import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DatasyncLocationSmbConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly agentArns: string[];
    /**
     * @stability stable
     */
    readonly domain?: string;
    /**
     * @stability stable
     */
    readonly password: string;
    /**
     * @stability stable
     */
    readonly serverHostname: string;
    /**
     * @stability stable
     */
    readonly subdirectory: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly user: string;
    /**
     * mount_options block.
     *
     * @stability stable
     */
    readonly mountOptions?: DatasyncLocationSmbMountOptions[];
}
/**
 * @stability stable
 */
export interface DatasyncLocationSmbMountOptions {
    /**
     * @stability stable
     */
    readonly version?: string;
}
/**
 * @stability stable
 */
export declare class DatasyncLocationSmb extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DatasyncLocationSmbConfig);
    private _agentArns;
    /**
     * @stability stable
     */
    get agentArns(): string[];
    /**
     * @stability stable
     */
    set agentArns(value: string[]);
    /**
     * @stability stable
     */
    get agentArnsInput(): string[];
    /**
     * @stability stable
     */
    get arn(): string;
    private _domain?;
    /**
     * @stability stable
     */
    get domain(): string;
    /**
     * @stability stable
     */
    set domain(value: string);
    /**
     * @stability stable
     */
    resetDomain(): void;
    /**
     * @stability stable
     */
    get domainInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _password;
    /**
     * @stability stable
     */
    get password(): string;
    /**
     * @stability stable
     */
    set password(value: string);
    /**
     * @stability stable
     */
    get passwordInput(): string;
    private _serverHostname;
    /**
     * @stability stable
     */
    get serverHostname(): string;
    /**
     * @stability stable
     */
    set serverHostname(value: string);
    /**
     * @stability stable
     */
    get serverHostnameInput(): string;
    private _subdirectory;
    /**
     * @stability stable
     */
    get subdirectory(): string;
    /**
     * @stability stable
     */
    set subdirectory(value: string);
    /**
     * @stability stable
     */
    get subdirectoryInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get uri(): string;
    private _user;
    /**
     * @stability stable
     */
    get user(): string;
    /**
     * @stability stable
     */
    set user(value: string);
    /**
     * @stability stable
     */
    get userInput(): string;
    private _mountOptions?;
    /**
     * @stability stable
     */
    get mountOptions(): DatasyncLocationSmbMountOptions[];
    /**
     * @stability stable
     */
    set mountOptions(value: DatasyncLocationSmbMountOptions[]);
    /**
     * @stability stable
     */
    resetMountOptions(): void;
    /**
     * @stability stable
     */
    get mountOptionsInput(): DatasyncLocationSmbMountOptions[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
