import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DbInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly allocatedStorage?: number;
    /**
     * @stability stable
     */
    readonly allowMajorVersionUpgrade?: boolean;
    /**
     * @stability stable
     */
    readonly applyImmediately?: boolean;
    /**
     * @stability stable
     */
    readonly autoMinorVersionUpgrade?: boolean;
    /**
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * @stability stable
     */
    readonly backupRetentionPeriod?: number;
    /**
     * @stability stable
     */
    readonly backupWindow?: string;
    /**
     * @stability stable
     */
    readonly caCertIdentifier?: string;
    /**
     * @stability stable
     */
    readonly characterSetName?: string;
    /**
     * @stability stable
     */
    readonly copyTagsToSnapshot?: boolean;
    /**
     * @stability stable
     */
    readonly dbSubnetGroupName?: string;
    /**
     * @stability stable
     */
    readonly deleteAutomatedBackups?: boolean;
    /**
     * @stability stable
     */
    readonly deletionProtection?: boolean;
    /**
     * @stability stable
     */
    readonly domain?: string;
    /**
     * @stability stable
     */
    readonly domainIamRoleName?: string;
    /**
     * @stability stable
     */
    readonly enabledCloudwatchLogsExports?: string[];
    /**
     * @stability stable
     */
    readonly engine?: string;
    /**
     * @stability stable
     */
    readonly engineVersion?: string;
    /**
     * @stability stable
     */
    readonly finalSnapshotIdentifier?: string;
    /**
     * @stability stable
     */
    readonly iamDatabaseAuthenticationEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly identifier?: string;
    /**
     * @stability stable
     */
    readonly identifierPrefix?: string;
    /**
     * @stability stable
     */
    readonly instanceClass: string;
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly licenseModel?: string;
    /**
     * @stability stable
     */
    readonly maintenanceWindow?: string;
    /**
     * @stability stable
     */
    readonly maxAllocatedStorage?: number;
    /**
     * @stability stable
     */
    readonly monitoringInterval?: number;
    /**
     * @stability stable
     */
    readonly monitoringRoleArn?: string;
    /**
     * @stability stable
     */
    readonly multiAz?: boolean;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly optionGroupName?: string;
    /**
     * @stability stable
     */
    readonly parameterGroupName?: string;
    /**
     * @stability stable
     */
    readonly password?: string;
    /**
     * @stability stable
     */
    readonly performanceInsightsEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly performanceInsightsKmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly performanceInsightsRetentionPeriod?: number;
    /**
     * @stability stable
     */
    readonly port?: number;
    /**
     * @stability stable
     */
    readonly publiclyAccessible?: boolean;
    /**
     * @stability stable
     */
    readonly replicateSourceDb?: string;
    /**
     * @stability stable
     */
    readonly securityGroupNames?: string[];
    /**
     * @stability stable
     */
    readonly skipFinalSnapshot?: boolean;
    /**
     * @stability stable
     */
    readonly snapshotIdentifier?: string;
    /**
     * @stability stable
     */
    readonly storageEncrypted?: boolean;
    /**
     * @stability stable
     */
    readonly storageType?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly timezone?: string;
    /**
     * @stability stable
     */
    readonly username?: string;
    /**
     * @stability stable
     */
    readonly vpcSecurityGroupIds?: string[];
    /**
     * restore_to_point_in_time block.
     *
     * @stability stable
     */
    readonly restoreToPointInTime?: DbInstanceRestoreToPointInTime[];
    /**
     * s3_import block.
     *
     * @stability stable
     */
    readonly s3Import?: DbInstanceS3Import[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: DbInstanceTimeouts;
}
/**
 * @stability stable
 */
export interface DbInstanceRestoreToPointInTime {
    /**
     * @stability stable
     */
    readonly restoreTime?: string;
    /**
     * @stability stable
     */
    readonly sourceDbInstanceIdentifier?: string;
    /**
     * @stability stable
     */
    readonly sourceDbiResourceId?: string;
    /**
     * @stability stable
     */
    readonly useLatestRestorableTime?: boolean;
}
/**
 * @stability stable
 */
export interface DbInstanceS3Import {
    /**
     * @stability stable
     */
    readonly bucketName: string;
    /**
     * @stability stable
     */
    readonly bucketPrefix?: string;
    /**
     * @stability stable
     */
    readonly ingestionRole: string;
    /**
     * @stability stable
     */
    readonly sourceEngine: string;
    /**
     * @stability stable
     */
    readonly sourceEngineVersion: string;
}
/**
 * @stability stable
 */
export interface DbInstanceTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class DbInstance extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DbInstanceConfig);
    /**
     * @stability stable
     */
    get address(): string;
    private _allocatedStorage?;
    /**
     * @stability stable
     */
    get allocatedStorage(): number;
    /**
     * @stability stable
     */
    set allocatedStorage(value: number);
    /**
     * @stability stable
     */
    resetAllocatedStorage(): void;
    /**
     * @stability stable
     */
    get allocatedStorageInput(): number | undefined;
    private _allowMajorVersionUpgrade?;
    /**
     * @stability stable
     */
    get allowMajorVersionUpgrade(): boolean;
    /**
     * @stability stable
     */
    set allowMajorVersionUpgrade(value: boolean);
    /**
     * @stability stable
     */
    resetAllowMajorVersionUpgrade(): void;
    /**
     * @stability stable
     */
    get allowMajorVersionUpgradeInput(): boolean | undefined;
    private _applyImmediately?;
    /**
     * @stability stable
     */
    get applyImmediately(): boolean;
    /**
     * @stability stable
     */
    set applyImmediately(value: boolean);
    /**
     * @stability stable
     */
    resetApplyImmediately(): void;
    /**
     * @stability stable
     */
    get applyImmediatelyInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoMinorVersionUpgrade?;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgrade(): boolean;
    /**
     * @stability stable
     */
    set autoMinorVersionUpgrade(value: boolean);
    /**
     * @stability stable
     */
    resetAutoMinorVersionUpgrade(): void;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgradeInput(): boolean | undefined;
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    private _backupRetentionPeriod?;
    /**
     * @stability stable
     */
    get backupRetentionPeriod(): number;
    /**
     * @stability stable
     */
    set backupRetentionPeriod(value: number);
    /**
     * @stability stable
     */
    resetBackupRetentionPeriod(): void;
    /**
     * @stability stable
     */
    get backupRetentionPeriodInput(): number | undefined;
    private _backupWindow?;
    /**
     * @stability stable
     */
    get backupWindow(): string;
    /**
     * @stability stable
     */
    set backupWindow(value: string);
    /**
     * @stability stable
     */
    resetBackupWindow(): void;
    /**
     * @stability stable
     */
    get backupWindowInput(): string | undefined;
    private _caCertIdentifier?;
    /**
     * @stability stable
     */
    get caCertIdentifier(): string;
    /**
     * @stability stable
     */
    set caCertIdentifier(value: string);
    /**
     * @stability stable
     */
    resetCaCertIdentifier(): void;
    /**
     * @stability stable
     */
    get caCertIdentifierInput(): string | undefined;
    private _characterSetName?;
    /**
     * @stability stable
     */
    get characterSetName(): string;
    /**
     * @stability stable
     */
    set characterSetName(value: string);
    /**
     * @stability stable
     */
    resetCharacterSetName(): void;
    /**
     * @stability stable
     */
    get characterSetNameInput(): string | undefined;
    private _copyTagsToSnapshot?;
    /**
     * @stability stable
     */
    get copyTagsToSnapshot(): boolean;
    /**
     * @stability stable
     */
    set copyTagsToSnapshot(value: boolean);
    /**
     * @stability stable
     */
    resetCopyTagsToSnapshot(): void;
    /**
     * @stability stable
     */
    get copyTagsToSnapshotInput(): boolean | undefined;
    private _dbSubnetGroupName?;
    /**
     * @stability stable
     */
    get dbSubnetGroupName(): string;
    /**
     * @stability stable
     */
    set dbSubnetGroupName(value: string);
    /**
     * @stability stable
     */
    resetDbSubnetGroupName(): void;
    /**
     * @stability stable
     */
    get dbSubnetGroupNameInput(): string | undefined;
    private _deleteAutomatedBackups?;
    /**
     * @stability stable
     */
    get deleteAutomatedBackups(): boolean;
    /**
     * @stability stable
     */
    set deleteAutomatedBackups(value: boolean);
    /**
     * @stability stable
     */
    resetDeleteAutomatedBackups(): void;
    /**
     * @stability stable
     */
    get deleteAutomatedBackupsInput(): boolean | undefined;
    private _deletionProtection?;
    /**
     * @stability stable
     */
    get deletionProtection(): boolean;
    /**
     * @stability stable
     */
    set deletionProtection(value: boolean);
    /**
     * @stability stable
     */
    resetDeletionProtection(): void;
    /**
     * @stability stable
     */
    get deletionProtectionInput(): boolean | undefined;
    private _domain?;
    /**
     * @stability stable
     */
    get domain(): string;
    /**
     * @stability stable
     */
    set domain(value: string);
    /**
     * @stability stable
     */
    resetDomain(): void;
    /**
     * @stability stable
     */
    get domainInput(): string | undefined;
    private _domainIamRoleName?;
    /**
     * @stability stable
     */
    get domainIamRoleName(): string;
    /**
     * @stability stable
     */
    set domainIamRoleName(value: string);
    /**
     * @stability stable
     */
    resetDomainIamRoleName(): void;
    /**
     * @stability stable
     */
    get domainIamRoleNameInput(): string | undefined;
    private _enabledCloudwatchLogsExports?;
    /**
     * @stability stable
     */
    get enabledCloudwatchLogsExports(): string[];
    /**
     * @stability stable
     */
    set enabledCloudwatchLogsExports(value: string[]);
    /**
     * @stability stable
     */
    resetEnabledCloudwatchLogsExports(): void;
    /**
     * @stability stable
     */
    get enabledCloudwatchLogsExportsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get endpoint(): string;
    private _engine?;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    resetEngine(): void;
    /**
     * @stability stable
     */
    get engineInput(): string | undefined;
    private _engineVersion?;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    set engineVersion(value: string);
    /**
     * @stability stable
     */
    resetEngineVersion(): void;
    /**
     * @stability stable
     */
    get engineVersionInput(): string | undefined;
    private _finalSnapshotIdentifier?;
    /**
     * @stability stable
     */
    get finalSnapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set finalSnapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    resetFinalSnapshotIdentifier(): void;
    /**
     * @stability stable
     */
    get finalSnapshotIdentifierInput(): string | undefined;
    /**
     * @stability stable
     */
    get hostedZoneId(): string;
    private _iamDatabaseAuthenticationEnabled?;
    /**
     * @stability stable
     */
    get iamDatabaseAuthenticationEnabled(): boolean;
    /**
     * @stability stable
     */
    set iamDatabaseAuthenticationEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetIamDatabaseAuthenticationEnabled(): void;
    /**
     * @stability stable
     */
    get iamDatabaseAuthenticationEnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _identifier?;
    /**
     * @stability stable
     */
    get identifier(): string;
    /**
     * @stability stable
     */
    set identifier(value: string);
    /**
     * @stability stable
     */
    resetIdentifier(): void;
    /**
     * @stability stable
     */
    get identifierInput(): string | undefined;
    private _identifierPrefix?;
    /**
     * @stability stable
     */
    get identifierPrefix(): string;
    /**
     * @stability stable
     */
    set identifierPrefix(value: string);
    /**
     * @stability stable
     */
    resetIdentifierPrefix(): void;
    /**
     * @stability stable
     */
    get identifierPrefixInput(): string | undefined;
    private _instanceClass;
    /**
     * @stability stable
     */
    get instanceClass(): string;
    /**
     * @stability stable
     */
    set instanceClass(value: string);
    /**
     * @stability stable
     */
    get instanceClassInput(): string;
    private _iops?;
    /**
     * @stability stable
     */
    get iops(): number;
    /**
     * @stability stable
     */
    set iops(value: number);
    /**
     * @stability stable
     */
    resetIops(): void;
    /**
     * @stability stable
     */
    get iopsInput(): number | undefined;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get latestRestorableTime(): string;
    private _licenseModel?;
    /**
     * @stability stable
     */
    get licenseModel(): string;
    /**
     * @stability stable
     */
    set licenseModel(value: string);
    /**
     * @stability stable
     */
    resetLicenseModel(): void;
    /**
     * @stability stable
     */
    get licenseModelInput(): string | undefined;
    private _maintenanceWindow?;
    /**
     * @stability stable
     */
    get maintenanceWindow(): string;
    /**
     * @stability stable
     */
    set maintenanceWindow(value: string);
    /**
     * @stability stable
     */
    resetMaintenanceWindow(): void;
    /**
     * @stability stable
     */
    get maintenanceWindowInput(): string | undefined;
    private _maxAllocatedStorage?;
    /**
     * @stability stable
     */
    get maxAllocatedStorage(): number;
    /**
     * @stability stable
     */
    set maxAllocatedStorage(value: number);
    /**
     * @stability stable
     */
    resetMaxAllocatedStorage(): void;
    /**
     * @stability stable
     */
    get maxAllocatedStorageInput(): number | undefined;
    private _monitoringInterval?;
    /**
     * @stability stable
     */
    get monitoringInterval(): number;
    /**
     * @stability stable
     */
    set monitoringInterval(value: number);
    /**
     * @stability stable
     */
    resetMonitoringInterval(): void;
    /**
     * @stability stable
     */
    get monitoringIntervalInput(): number | undefined;
    private _monitoringRoleArn?;
    /**
     * @stability stable
     */
    get monitoringRoleArn(): string;
    /**
     * @stability stable
     */
    set monitoringRoleArn(value: string);
    /**
     * @stability stable
     */
    resetMonitoringRoleArn(): void;
    /**
     * @stability stable
     */
    get monitoringRoleArnInput(): string | undefined;
    private _multiAz?;
    /**
     * @stability stable
     */
    get multiAz(): boolean;
    /**
     * @stability stable
     */
    set multiAz(value: boolean);
    /**
     * @stability stable
     */
    resetMultiAz(): void;
    /**
     * @stability stable
     */
    get multiAzInput(): boolean | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _optionGroupName?;
    /**
     * @stability stable
     */
    get optionGroupName(): string;
    /**
     * @stability stable
     */
    set optionGroupName(value: string);
    /**
     * @stability stable
     */
    resetOptionGroupName(): void;
    /**
     * @stability stable
     */
    get optionGroupNameInput(): string | undefined;
    private _parameterGroupName?;
    /**
     * @stability stable
     */
    get parameterGroupName(): string;
    /**
     * @stability stable
     */
    set parameterGroupName(value: string);
    /**
     * @stability stable
     */
    resetParameterGroupName(): void;
    /**
     * @stability stable
     */
    get parameterGroupNameInput(): string | undefined;
    private _password?;
    /**
     * @stability stable
     */
    get password(): string;
    /**
     * @stability stable
     */
    set password(value: string);
    /**
     * @stability stable
     */
    resetPassword(): void;
    /**
     * @stability stable
     */
    get passwordInput(): string | undefined;
    private _performanceInsightsEnabled?;
    /**
     * @stability stable
     */
    get performanceInsightsEnabled(): boolean;
    /**
     * @stability stable
     */
    set performanceInsightsEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetPerformanceInsightsEnabled(): void;
    /**
     * @stability stable
     */
    get performanceInsightsEnabledInput(): boolean | undefined;
    private _performanceInsightsKmsKeyId?;
    /**
     * @stability stable
     */
    get performanceInsightsKmsKeyId(): string;
    /**
     * @stability stable
     */
    set performanceInsightsKmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetPerformanceInsightsKmsKeyId(): void;
    /**
     * @stability stable
     */
    get performanceInsightsKmsKeyIdInput(): string | undefined;
    private _performanceInsightsRetentionPeriod?;
    /**
     * @stability stable
     */
    get performanceInsightsRetentionPeriod(): number;
    /**
     * @stability stable
     */
    set performanceInsightsRetentionPeriod(value: number);
    /**
     * @stability stable
     */
    resetPerformanceInsightsRetentionPeriod(): void;
    /**
     * @stability stable
     */
    get performanceInsightsRetentionPeriodInput(): number | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    private _publiclyAccessible?;
    /**
     * @stability stable
     */
    get publiclyAccessible(): boolean;
    /**
     * @stability stable
     */
    set publiclyAccessible(value: boolean);
    /**
     * @stability stable
     */
    resetPubliclyAccessible(): void;
    /**
     * @stability stable
     */
    get publiclyAccessibleInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get replicas(): string[];
    private _replicateSourceDb?;
    /**
     * @stability stable
     */
    get replicateSourceDb(): string;
    /**
     * @stability stable
     */
    set replicateSourceDb(value: string);
    /**
     * @stability stable
     */
    resetReplicateSourceDb(): void;
    /**
     * @stability stable
     */
    get replicateSourceDbInput(): string | undefined;
    /**
     * @stability stable
     */
    get resourceId(): string;
    private _securityGroupNames?;
    /**
     * @stability stable
     */
    get securityGroupNames(): string[];
    /**
     * @stability stable
     */
    set securityGroupNames(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupNames(): void;
    /**
     * @stability stable
     */
    get securityGroupNamesInput(): string[] | undefined;
    private _skipFinalSnapshot?;
    /**
     * @stability stable
     */
    get skipFinalSnapshot(): boolean;
    /**
     * @stability stable
     */
    set skipFinalSnapshot(value: boolean);
    /**
     * @stability stable
     */
    resetSkipFinalSnapshot(): void;
    /**
     * @stability stable
     */
    get skipFinalSnapshotInput(): boolean | undefined;
    private _snapshotIdentifier?;
    /**
     * @stability stable
     */
    get snapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set snapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    resetSnapshotIdentifier(): void;
    /**
     * @stability stable
     */
    get snapshotIdentifierInput(): string | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    private _storageEncrypted?;
    /**
     * @stability stable
     */
    get storageEncrypted(): boolean;
    /**
     * @stability stable
     */
    set storageEncrypted(value: boolean);
    /**
     * @stability stable
     */
    resetStorageEncrypted(): void;
    /**
     * @stability stable
     */
    get storageEncryptedInput(): boolean | undefined;
    private _storageType?;
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    set storageType(value: string);
    /**
     * @stability stable
     */
    resetStorageType(): void;
    /**
     * @stability stable
     */
    get storageTypeInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _timezone?;
    /**
     * @stability stable
     */
    get timezone(): string;
    /**
     * @stability stable
     */
    set timezone(value: string);
    /**
     * @stability stable
     */
    resetTimezone(): void;
    /**
     * @stability stable
     */
    get timezoneInput(): string | undefined;
    private _username?;
    /**
     * @stability stable
     */
    get username(): string;
    /**
     * @stability stable
     */
    set username(value: string);
    /**
     * @stability stable
     */
    resetUsername(): void;
    /**
     * @stability stable
     */
    get usernameInput(): string | undefined;
    private _vpcSecurityGroupIds?;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set vpcSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetVpcSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIdsInput(): string[] | undefined;
    private _restoreToPointInTime?;
    /**
     * @stability stable
     */
    get restoreToPointInTime(): DbInstanceRestoreToPointInTime[];
    /**
     * @stability stable
     */
    set restoreToPointInTime(value: DbInstanceRestoreToPointInTime[]);
    /**
     * @stability stable
     */
    resetRestoreToPointInTime(): void;
    /**
     * @stability stable
     */
    get restoreToPointInTimeInput(): DbInstanceRestoreToPointInTime[] | undefined;
    private _s3Import?;
    /**
     * @stability stable
     */
    get s3Import(): DbInstanceS3Import[];
    /**
     * @stability stable
     */
    set s3Import(value: DbInstanceS3Import[]);
    /**
     * @stability stable
     */
    resetS3Import(): void;
    /**
     * @stability stable
     */
    get s3ImportInput(): DbInstanceS3Import[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DbInstanceTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DbInstanceTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DbInstanceTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
