import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DbOptionGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly engineName: string;
    /**
     * @stability stable
     */
    readonly majorEngineVersion: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly optionGroupDescription?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * option block.
     *
     * @stability stable
     */
    readonly option?: DbOptionGroupOption[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: DbOptionGroupTimeouts;
}
/**
 * @stability stable
 */
export interface DbOptionGroupOptionOptionSettings {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface DbOptionGroupOption {
    /**
     * @stability stable
     */
    readonly dbSecurityGroupMemberships?: string[];
    /**
     * @stability stable
     */
    readonly optionName: string;
    /**
     * @stability stable
     */
    readonly port?: number;
    /**
     * @stability stable
     */
    readonly version?: string;
    /**
     * @stability stable
     */
    readonly vpcSecurityGroupMemberships?: string[];
    /**
     * option_settings block.
     *
     * @stability stable
     */
    readonly optionSettings?: DbOptionGroupOptionOptionSettings[];
}
/**
 * @stability stable
 */
export interface DbOptionGroupTimeouts {
    /**
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export declare class DbOptionGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DbOptionGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _engineName;
    /**
     * @stability stable
     */
    get engineName(): string;
    /**
     * @stability stable
     */
    set engineName(value: string);
    /**
     * @stability stable
     */
    get engineNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _majorEngineVersion;
    /**
     * @stability stable
     */
    get majorEngineVersion(): string;
    /**
     * @stability stable
     */
    set majorEngineVersion(value: string);
    /**
     * @stability stable
     */
    get majorEngineVersionInput(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _optionGroupDescription?;
    /**
     * @stability stable
     */
    get optionGroupDescription(): string;
    /**
     * @stability stable
     */
    set optionGroupDescription(value: string);
    /**
     * @stability stable
     */
    resetOptionGroupDescription(): void;
    /**
     * @stability stable
     */
    get optionGroupDescriptionInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _option?;
    /**
     * @stability stable
     */
    get option(): DbOptionGroupOption[];
    /**
     * @stability stable
     */
    set option(value: DbOptionGroupOption[]);
    /**
     * @stability stable
     */
    resetOption(): void;
    /**
     * @stability stable
     */
    get optionInput(): DbOptionGroupOption[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DbOptionGroupTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DbOptionGroupTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DbOptionGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
