import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DbProxyDefaultTargetGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly dbProxyName: string;
    /**
     * connection_pool_config block.
     *
     * @stability stable
     */
    readonly connectionPoolConfig?: DbProxyDefaultTargetGroupConnectionPoolConfig[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: DbProxyDefaultTargetGroupTimeouts;
}
/**
 * @stability stable
 */
export interface DbProxyDefaultTargetGroupConnectionPoolConfig {
    /**
     * @stability stable
     */
    readonly connectionBorrowTimeout?: number;
    /**
     * @stability stable
     */
    readonly initQuery?: string;
    /**
     * @stability stable
     */
    readonly maxConnectionsPercent?: number;
    /**
     * @stability stable
     */
    readonly maxIdleConnectionsPercent?: number;
    /**
     * @stability stable
     */
    readonly sessionPinningFilters?: string[];
}
/**
 * @stability stable
 */
export interface DbProxyDefaultTargetGroupTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class DbProxyDefaultTargetGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DbProxyDefaultTargetGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _dbProxyName;
    /**
     * @stability stable
     */
    get dbProxyName(): string;
    /**
     * @stability stable
     */
    set dbProxyName(value: string);
    /**
     * @stability stable
     */
    get dbProxyNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    private _connectionPoolConfig?;
    /**
     * @stability stable
     */
    get connectionPoolConfig(): DbProxyDefaultTargetGroupConnectionPoolConfig[];
    /**
     * @stability stable
     */
    set connectionPoolConfig(value: DbProxyDefaultTargetGroupConnectionPoolConfig[]);
    /**
     * @stability stable
     */
    resetConnectionPoolConfig(): void;
    /**
     * @stability stable
     */
    get connectionPoolConfigInput(): DbProxyDefaultTargetGroupConnectionPoolConfig[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DbProxyDefaultTargetGroupTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DbProxyDefaultTargetGroupTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DbProxyDefaultTargetGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
