import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DbProxyTargetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly dbClusterIdentifier?: string;
    /**
     * @stability stable
     */
    readonly dbInstanceIdentifier?: string;
    /**
     * @stability stable
     */
    readonly dbProxyName: string;
    /**
     * @stability stable
     */
    readonly targetGroupName: string;
}
/**
 * @stability stable
 */
export declare class DbProxyTarget extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DbProxyTargetConfig);
    private _dbClusterIdentifier?;
    /**
     * @stability stable
     */
    get dbClusterIdentifier(): string;
    /**
     * @stability stable
     */
    set dbClusterIdentifier(value: string);
    /**
     * @stability stable
     */
    resetDbClusterIdentifier(): void;
    /**
     * @stability stable
     */
    get dbClusterIdentifierInput(): string | undefined;
    private _dbInstanceIdentifier?;
    /**
     * @stability stable
     */
    get dbInstanceIdentifier(): string;
    /**
     * @stability stable
     */
    set dbInstanceIdentifier(value: string);
    /**
     * @stability stable
     */
    resetDbInstanceIdentifier(): void;
    /**
     * @stability stable
     */
    get dbInstanceIdentifierInput(): string | undefined;
    private _dbProxyName;
    /**
     * @stability stable
     */
    get dbProxyName(): string;
    /**
     * @stability stable
     */
    set dbProxyName(value: string);
    /**
     * @stability stable
     */
    get dbProxyNameInput(): string;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    get rdsResourceId(): string;
    /**
     * @stability stable
     */
    get targetArn(): string;
    private _targetGroupName;
    /**
     * @stability stable
     */
    get targetGroupName(): string;
    /**
     * @stability stable
     */
    set targetGroupName(value: string);
    /**
     * @stability stable
     */
    get targetGroupNameInput(): string;
    /**
     * @stability stable
     */
    get trackedClusterId(): string;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
