import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DbProxyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly debugLogging?: boolean;
    /**
     * @stability stable
     */
    readonly engineFamily: string;
    /**
     * @stability stable
     */
    readonly idleClientTimeout?: number;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly requireTls?: boolean;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcSecurityGroupIds?: string[];
    /**
     * @stability stable
     */
    readonly vpcSubnetIds: string[];
    /**
     * auth block.
     *
     * @stability stable
     */
    readonly auth: DbProxyAuth[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: DbProxyTimeouts;
}
/**
 * @stability stable
 */
export interface DbProxyAuth {
    /**
     * @stability stable
     */
    readonly authScheme?: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly iamAuth?: string;
    /**
     * @stability stable
     */
    readonly secretArn?: string;
}
/**
 * @stability stable
 */
export interface DbProxyTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class DbProxy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DbProxyConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _debugLogging?;
    /**
     * @stability stable
     */
    get debugLogging(): boolean;
    /**
     * @stability stable
     */
    set debugLogging(value: boolean);
    /**
     * @stability stable
     */
    resetDebugLogging(): void;
    /**
     * @stability stable
     */
    get debugLoggingInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get endpoint(): string;
    private _engineFamily;
    /**
     * @stability stable
     */
    get engineFamily(): string;
    /**
     * @stability stable
     */
    set engineFamily(value: string);
    /**
     * @stability stable
     */
    get engineFamilyInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _idleClientTimeout?;
    /**
     * @stability stable
     */
    get idleClientTimeout(): number;
    /**
     * @stability stable
     */
    set idleClientTimeout(value: number);
    /**
     * @stability stable
     */
    resetIdleClientTimeout(): void;
    /**
     * @stability stable
     */
    get idleClientTimeoutInput(): number | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _requireTls?;
    /**
     * @stability stable
     */
    get requireTls(): boolean;
    /**
     * @stability stable
     */
    set requireTls(value: boolean);
    /**
     * @stability stable
     */
    resetRequireTls(): void;
    /**
     * @stability stable
     */
    get requireTlsInput(): boolean | undefined;
    private _roleArn;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcSecurityGroupIds?;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set vpcSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetVpcSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIdsInput(): string[] | undefined;
    private _vpcSubnetIds;
    /**
     * @stability stable
     */
    get vpcSubnetIds(): string[];
    /**
     * @stability stable
     */
    set vpcSubnetIds(value: string[]);
    /**
     * @stability stable
     */
    get vpcSubnetIdsInput(): string[];
    private _auth;
    /**
     * @stability stable
     */
    get auth(): DbProxyAuth[];
    /**
     * @stability stable
     */
    set auth(value: DbProxyAuth[]);
    /**
     * @stability stable
     */
    get authInput(): DbProxyAuth[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DbProxyTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DbProxyTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DbProxyTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
