import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DbSecurityGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * ingress block.
     *
     * @stability stable
     */
    readonly ingress: DbSecurityGroupIngress[];
}
/**
 * @stability stable
 */
export interface DbSecurityGroupIngress {
    /**
     * @stability stable
     */
    readonly cidr?: string;
    /**
     * @stability stable
     */
    readonly securityGroupId?: string;
    /**
     * @stability stable
     */
    readonly securityGroupName?: string;
    /**
     * @stability stable
     */
    readonly securityGroupOwnerId?: string;
}
/**
 * @stability stable
 */
export declare class DbSecurityGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DbSecurityGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _ingress;
    /**
     * @stability stable
     */
    get ingress(): DbSecurityGroupIngress[];
    /**
     * @stability stable
     */
    set ingress(value: DbSecurityGroupIngress[]);
    /**
     * @stability stable
     */
    get ingressInput(): DbSecurityGroupIngress[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
