import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DbSnapshotConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly dbInstanceIdentifier: string;
    /**
     * @stability stable
     */
    readonly dbSnapshotIdentifier: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: DbSnapshotTimeouts;
}
/**
 * @stability stable
 */
export interface DbSnapshotTimeouts {
    /**
     * @stability stable
     */
    readonly read?: string;
}
/**
 * @stability stable
 */
export declare class DbSnapshot extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DbSnapshotConfig);
    /**
     * @stability stable
     */
    get allocatedStorage(): number;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    private _dbInstanceIdentifier;
    /**
     * @stability stable
     */
    get dbInstanceIdentifier(): string;
    /**
     * @stability stable
     */
    set dbInstanceIdentifier(value: string);
    /**
     * @stability stable
     */
    get dbInstanceIdentifierInput(): string;
    /**
     * @stability stable
     */
    get dbSnapshotArn(): string;
    private _dbSnapshotIdentifier;
    /**
     * @stability stable
     */
    get dbSnapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set dbSnapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    get dbSnapshotIdentifierInput(): string;
    /**
     * @stability stable
     */
    get encrypted(): boolean;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get iops(): number;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    get licenseModel(): string;
    /**
     * @stability stable
     */
    get optionGroupName(): string;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    get snapshotType(): string;
    /**
     * @stability stable
     */
    get sourceDbSnapshotIdentifier(): string;
    /**
     * @stability stable
     */
    get sourceRegion(): string;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get storageType(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get vpcId(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DbSnapshotTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DbSnapshotTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DbSnapshotTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
