import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DefaultNetworkAclConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly defaultNetworkAclId: string;
    /**
     * @stability stable
     */
    readonly subnetIds?: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * egress block.
     *
     * @stability stable
     */
    readonly egress?: DefaultNetworkAclEgress[];
    /**
     * ingress block.
     *
     * @stability stable
     */
    readonly ingress?: DefaultNetworkAclIngress[];
}
/**
 * @stability stable
 */
export interface DefaultNetworkAclEgress {
    /**
     * @stability stable
     */
    readonly action: string;
    /**
     * @stability stable
     */
    readonly cidrBlock?: string;
    /**
     * @stability stable
     */
    readonly fromPort: number;
    /**
     * @stability stable
     */
    readonly icmpCode?: number;
    /**
     * @stability stable
     */
    readonly icmpType?: number;
    /**
     * @stability stable
     */
    readonly ipv6CidrBlock?: string;
    /**
     * @stability stable
     */
    readonly protocol: string;
    /**
     * @stability stable
     */
    readonly ruleNo: number;
    /**
     * @stability stable
     */
    readonly toPort: number;
}
/**
 * @stability stable
 */
export interface DefaultNetworkAclIngress {
    /**
     * @stability stable
     */
    readonly action: string;
    /**
     * @stability stable
     */
    readonly cidrBlock?: string;
    /**
     * @stability stable
     */
    readonly fromPort: number;
    /**
     * @stability stable
     */
    readonly icmpCode?: number;
    /**
     * @stability stable
     */
    readonly icmpType?: number;
    /**
     * @stability stable
     */
    readonly ipv6CidrBlock?: string;
    /**
     * @stability stable
     */
    readonly protocol: string;
    /**
     * @stability stable
     */
    readonly ruleNo: number;
    /**
     * @stability stable
     */
    readonly toPort: number;
}
/**
 * @stability stable
 */
export declare class DefaultNetworkAcl extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DefaultNetworkAclConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _defaultNetworkAclId;
    /**
     * @stability stable
     */
    get defaultNetworkAclId(): string;
    /**
     * @stability stable
     */
    set defaultNetworkAclId(value: string);
    /**
     * @stability stable
     */
    get defaultNetworkAclIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _subnetIds?;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    resetSubnetIds(): void;
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get vpcId(): string;
    private _egress?;
    /**
     * @stability stable
     */
    get egress(): DefaultNetworkAclEgress[];
    /**
     * @stability stable
     */
    set egress(value: DefaultNetworkAclEgress[]);
    /**
     * @stability stable
     */
    resetEgress(): void;
    /**
     * @stability stable
     */
    get egressInput(): DefaultNetworkAclEgress[] | undefined;
    private _ingress?;
    /**
     * @stability stable
     */
    get ingress(): DefaultNetworkAclIngress[];
    /**
     * @stability stable
     */
    set ingress(value: DefaultNetworkAclIngress[]);
    /**
     * @stability stable
     */
    resetIngress(): void;
    /**
     * @stability stable
     */
    get ingressInput(): DefaultNetworkAclIngress[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
