import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DefaultRouteTableConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly defaultRouteTableId: string;
    /**
     * @stability stable
     */
    readonly propagatingVgws?: string[];
    /**
     * @stability stable
     */
    readonly route?: DefaultRouteTableRoute[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export interface DefaultRouteTableRoute {
    /**
     * @stability stable
     */
    readonly cidrBlock?: string;
    /**
     * @stability stable
     */
    readonly egressOnlyGatewayId?: string;
    /**
     * @stability stable
     */
    readonly gatewayId?: string;
    /**
     * @stability stable
     */
    readonly instanceId?: string;
    /**
     * @stability stable
     */
    readonly ipv6CidrBlock?: string;
    /**
     * @stability stable
     */
    readonly natGatewayId?: string;
    /**
     * @stability stable
     */
    readonly networkInterfaceId?: string;
    /**
     * @stability stable
     */
    readonly transitGatewayId?: string;
    /**
     * @stability stable
     */
    readonly vpcEndpointId?: string;
    /**
     * @stability stable
     */
    readonly vpcPeeringConnectionId?: string;
}
/**
 * @stability stable
 */
export declare class DefaultRouteTable extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DefaultRouteTableConfig);
    private _defaultRouteTableId;
    /**
     * @stability stable
     */
    get defaultRouteTableId(): string;
    /**
     * @stability stable
     */
    set defaultRouteTableId(value: string);
    /**
     * @stability stable
     */
    get defaultRouteTableIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _propagatingVgws?;
    /**
     * @stability stable
     */
    get propagatingVgws(): string[];
    /**
     * @stability stable
     */
    set propagatingVgws(value: string[]);
    /**
     * @stability stable
     */
    resetPropagatingVgws(): void;
    /**
     * @stability stable
     */
    get propagatingVgwsInput(): string[] | undefined;
    private _route?;
    /**
     * @stability stable
     */
    get route(): DefaultRouteTableRoute[];
    /**
     * @stability stable
     */
    set route(value: DefaultRouteTableRoute[]);
    /**
     * @stability stable
     */
    resetRoute(): void;
    /**
     * @stability stable
     */
    get routeInput(): DefaultRouteTableRoute[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
