import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DefaultSecurityGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly egress?: DefaultSecurityGroupEgress[];
    /**
     * @stability stable
     */
    readonly ingress?: DefaultSecurityGroupIngress[];
    /**
     * @stability stable
     */
    readonly revokeRulesOnDelete?: boolean;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcId?: string;
}
/**
 * @stability stable
 */
export interface DefaultSecurityGroupEgress {
    /**
     * @stability stable
     */
    readonly cidrBlocks?: string[];
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly fromPort?: number;
    /**
     * @stability stable
     */
    readonly ipv6CidrBlocks?: string[];
    /**
     * @stability stable
     */
    readonly prefixListIds?: string[];
    /**
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * @stability stable
     */
    readonly selfAttribute?: boolean;
    /**
     * @stability stable
     */
    readonly toPort?: number;
}
/**
 * @stability stable
 */
export interface DefaultSecurityGroupIngress {
    /**
     * @stability stable
     */
    readonly cidrBlocks?: string[];
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly fromPort?: number;
    /**
     * @stability stable
     */
    readonly ipv6CidrBlocks?: string[];
    /**
     * @stability stable
     */
    readonly prefixListIds?: string[];
    /**
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * @stability stable
     */
    readonly selfAttribute?: boolean;
    /**
     * @stability stable
     */
    readonly toPort?: number;
}
/**
 * @stability stable
 */
export declare class DefaultSecurityGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DefaultSecurityGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get description(): string;
    private _egress?;
    /**
     * @stability stable
     */
    get egress(): DefaultSecurityGroupEgress[];
    /**
     * @stability stable
     */
    set egress(value: DefaultSecurityGroupEgress[]);
    /**
     * @stability stable
     */
    resetEgress(): void;
    /**
     * @stability stable
     */
    get egressInput(): DefaultSecurityGroupEgress[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _ingress?;
    /**
     * @stability stable
     */
    get ingress(): DefaultSecurityGroupIngress[];
    /**
     * @stability stable
     */
    set ingress(value: DefaultSecurityGroupIngress[]);
    /**
     * @stability stable
     */
    resetIngress(): void;
    /**
     * @stability stable
     */
    get ingressInput(): DefaultSecurityGroupIngress[] | undefined;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _revokeRulesOnDelete?;
    /**
     * @stability stable
     */
    get revokeRulesOnDelete(): boolean;
    /**
     * @stability stable
     */
    set revokeRulesOnDelete(value: boolean);
    /**
     * @stability stable
     */
    resetRevokeRulesOnDelete(): void;
    /**
     * @stability stable
     */
    get revokeRulesOnDeleteInput(): boolean | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    resetVpcId(): void;
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
