import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DefaultVpcDhcpOptionsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly netbiosNameServers?: string[];
    /**
     * @stability stable
     */
    readonly netbiosNodeType?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DefaultVpcDhcpOptions extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DefaultVpcDhcpOptionsConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    get domainNameServers(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _netbiosNameServers?;
    /**
     * @stability stable
     */
    get netbiosNameServers(): string[];
    /**
     * @stability stable
     */
    set netbiosNameServers(value: string[]);
    /**
     * @stability stable
     */
    resetNetbiosNameServers(): void;
    /**
     * @stability stable
     */
    get netbiosNameServersInput(): string[] | undefined;
    private _netbiosNodeType?;
    /**
     * @stability stable
     */
    get netbiosNodeType(): string;
    /**
     * @stability stable
     */
    set netbiosNodeType(value: string);
    /**
     * @stability stable
     */
    resetNetbiosNodeType(): void;
    /**
     * @stability stable
     */
    get netbiosNodeTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get ntpServers(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
