import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DefaultVpcConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly enableClassiclink?: boolean;
    /**
     * @stability stable
     */
    readonly enableClassiclinkDnsSupport?: boolean;
    /**
     * @stability stable
     */
    readonly enableDnsHostnames?: boolean;
    /**
     * @stability stable
     */
    readonly enableDnsSupport?: boolean;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DefaultVpc extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DefaultVpcConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get assignGeneratedIpv6CidrBlock(): boolean;
    /**
     * @stability stable
     */
    get cidrBlock(): string;
    /**
     * @stability stable
     */
    get defaultNetworkAclId(): string;
    /**
     * @stability stable
     */
    get defaultRouteTableId(): string;
    /**
     * @stability stable
     */
    get defaultSecurityGroupId(): string;
    /**
     * @stability stable
     */
    get dhcpOptionsId(): string;
    private _enableClassiclink?;
    /**
     * @stability stable
     */
    get enableClassiclink(): boolean;
    /**
     * @stability stable
     */
    set enableClassiclink(value: boolean);
    /**
     * @stability stable
     */
    resetEnableClassiclink(): void;
    /**
     * @stability stable
     */
    get enableClassiclinkInput(): boolean | undefined;
    private _enableClassiclinkDnsSupport?;
    /**
     * @stability stable
     */
    get enableClassiclinkDnsSupport(): boolean;
    /**
     * @stability stable
     */
    set enableClassiclinkDnsSupport(value: boolean);
    /**
     * @stability stable
     */
    resetEnableClassiclinkDnsSupport(): void;
    /**
     * @stability stable
     */
    get enableClassiclinkDnsSupportInput(): boolean | undefined;
    private _enableDnsHostnames?;
    /**
     * @stability stable
     */
    get enableDnsHostnames(): boolean;
    /**
     * @stability stable
     */
    set enableDnsHostnames(value: boolean);
    /**
     * @stability stable
     */
    resetEnableDnsHostnames(): void;
    /**
     * @stability stable
     */
    get enableDnsHostnamesInput(): boolean | undefined;
    private _enableDnsSupport?;
    /**
     * @stability stable
     */
    get enableDnsSupport(): boolean;
    /**
     * @stability stable
     */
    set enableDnsSupport(value: boolean);
    /**
     * @stability stable
     */
    resetEnableDnsSupport(): void;
    /**
     * @stability stable
     */
    get enableDnsSupportInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get instanceTenancy(): string;
    /**
     * @stability stable
     */
    get ipv6AssociationId(): string;
    /**
     * @stability stable
     */
    get ipv6CidrBlock(): string;
    /**
     * @stability stable
     */
    get mainRouteTableId(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
