import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DirectoryServiceConditionalForwarderConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly directoryId: string;
    /**
     * @stability stable
     */
    readonly dnsIps: string[];
    /**
     * @stability stable
     */
    readonly remoteDomainName: string;
}
/**
 * @stability stable
 */
export declare class DirectoryServiceConditionalForwarder extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DirectoryServiceConditionalForwarderConfig);
    private _directoryId;
    /**
     * @stability stable
     */
    get directoryId(): string;
    /**
     * @stability stable
     */
    set directoryId(value: string);
    /**
     * @stability stable
     */
    get directoryIdInput(): string;
    private _dnsIps;
    /**
     * @stability stable
     */
    get dnsIps(): string[];
    /**
     * @stability stable
     */
    set dnsIps(value: string[]);
    /**
     * @stability stable
     */
    get dnsIpsInput(): string[];
    /**
     * @stability stable
     */
    get id(): string;
    private _remoteDomainName;
    /**
     * @stability stable
     */
    get remoteDomainName(): string;
    /**
     * @stability stable
     */
    set remoteDomainName(value: string);
    /**
     * @stability stable
     */
    get remoteDomainNameInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
