import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DirectoryServiceDirectoryConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly alias?: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly edition?: string;
    /**
     * @stability stable
     */
    readonly enableSso?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly password: string;
    /**
     * @stability stable
     */
    readonly shortName?: string;
    /**
     * @stability stable
     */
    readonly size?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly type?: string;
    /**
     * connect_settings block.
     *
     * @stability stable
     */
    readonly connectSettings?: DirectoryServiceDirectoryConnectSettings[];
    /**
     * vpc_settings block.
     *
     * @stability stable
     */
    readonly vpcSettings?: DirectoryServiceDirectoryVpcSettings[];
}
/**
 * @stability stable
 */
export interface DirectoryServiceDirectoryConnectSettings {
    /**
     * @stability stable
     */
    readonly customerDnsIps: string[];
    /**
     * @stability stable
     */
    readonly customerUsername: string;
    /**
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * @stability stable
     */
    readonly vpcId: string;
}
/**
 * @stability stable
 */
export interface DirectoryServiceDirectoryVpcSettings {
    /**
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * @stability stable
     */
    readonly vpcId: string;
}
/**
 * @stability stable
 */
export declare class DirectoryServiceDirectory extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DirectoryServiceDirectoryConfig);
    /**
     * @stability stable
     */
    get accessUrl(): string;
    private _alias?;
    /**
     * @stability stable
     */
    get alias(): string;
    /**
     * @stability stable
     */
    set alias(value: string);
    /**
     * @stability stable
     */
    resetAlias(): void;
    /**
     * @stability stable
     */
    get aliasInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get dnsIpAddresses(): string[];
    private _edition?;
    /**
     * @stability stable
     */
    get edition(): string;
    /**
     * @stability stable
     */
    set edition(value: string);
    /**
     * @stability stable
     */
    resetEdition(): void;
    /**
     * @stability stable
     */
    get editionInput(): string | undefined;
    private _enableSso?;
    /**
     * @stability stable
     */
    get enableSso(): boolean;
    /**
     * @stability stable
     */
    set enableSso(value: boolean);
    /**
     * @stability stable
     */
    resetEnableSso(): void;
    /**
     * @stability stable
     */
    get enableSsoInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _password;
    /**
     * @stability stable
     */
    get password(): string;
    /**
     * @stability stable
     */
    set password(value: string);
    /**
     * @stability stable
     */
    get passwordInput(): string;
    /**
     * @stability stable
     */
    get securityGroupId(): string;
    private _shortName?;
    /**
     * @stability stable
     */
    get shortName(): string;
    /**
     * @stability stable
     */
    set shortName(value: string);
    /**
     * @stability stable
     */
    resetShortName(): void;
    /**
     * @stability stable
     */
    get shortNameInput(): string | undefined;
    private _size?;
    /**
     * @stability stable
     */
    get size(): string;
    /**
     * @stability stable
     */
    set size(value: string);
    /**
     * @stability stable
     */
    resetSize(): void;
    /**
     * @stability stable
     */
    get sizeInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _connectSettings?;
    /**
     * @stability stable
     */
    get connectSettings(): DirectoryServiceDirectoryConnectSettings[];
    /**
     * @stability stable
     */
    set connectSettings(value: DirectoryServiceDirectoryConnectSettings[]);
    /**
     * @stability stable
     */
    resetConnectSettings(): void;
    /**
     * @stability stable
     */
    get connectSettingsInput(): DirectoryServiceDirectoryConnectSettings[] | undefined;
    private _vpcSettings?;
    /**
     * @stability stable
     */
    get vpcSettings(): DirectoryServiceDirectoryVpcSettings[];
    /**
     * @stability stable
     */
    set vpcSettings(value: DirectoryServiceDirectoryVpcSettings[]);
    /**
     * @stability stable
     */
    resetVpcSettings(): void;
    /**
     * @stability stable
     */
    get vpcSettingsInput(): DirectoryServiceDirectoryVpcSettings[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
