import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DlmLifecyclePolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description: string;
    /**
     * @stability stable
     */
    readonly executionRoleArn: string;
    /**
     * @stability stable
     */
    readonly state?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * policy_details block.
     *
     * @stability stable
     */
    readonly policyDetails: DlmLifecyclePolicyPolicyDetails[];
}
/**
 * @stability stable
 */
export interface DlmLifecyclePolicyPolicyDetailsScheduleCreateRule {
    /**
     * @stability stable
     */
    readonly interval: number;
    /**
     * @stability stable
     */
    readonly intervalUnit?: string;
    /**
     * @stability stable
     */
    readonly times?: string[];
}
/**
 * @stability stable
 */
export interface DlmLifecyclePolicyPolicyDetailsScheduleRetainRule {
    /**
     * @stability stable
     */
    readonly count: number;
}
/**
 * @stability stable
 */
export interface DlmLifecyclePolicyPolicyDetailsSchedule {
    /**
     * @stability stable
     */
    readonly copyTags?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tagsToAdd?: {
        [key: string]: string;
    };
    /**
     * create_rule block.
     *
     * @stability stable
     */
    readonly createRule: DlmLifecyclePolicyPolicyDetailsScheduleCreateRule[];
    /**
     * retain_rule block.
     *
     * @stability stable
     */
    readonly retainRule: DlmLifecyclePolicyPolicyDetailsScheduleRetainRule[];
}
/**
 * @stability stable
 */
export interface DlmLifecyclePolicyPolicyDetails {
    /**
     * @stability stable
     */
    readonly resourceTypes: string[];
    /**
     * @stability stable
     */
    readonly targetTags: {
        [key: string]: string;
    };
    /**
     * schedule block.
     *
     * @stability stable
     */
    readonly schedule: DlmLifecyclePolicyPolicyDetailsSchedule[];
}
/**
 * @stability stable
 */
export declare class DlmLifecyclePolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DlmLifecyclePolicyConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    get descriptionInput(): string;
    private _executionRoleArn;
    /**
     * @stability stable
     */
    get executionRoleArn(): string;
    /**
     * @stability stable
     */
    set executionRoleArn(value: string);
    /**
     * @stability stable
     */
    get executionRoleArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _state?;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    set state(value: string);
    /**
     * @stability stable
     */
    resetState(): void;
    /**
     * @stability stable
     */
    get stateInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _policyDetails;
    /**
     * @stability stable
     */
    get policyDetails(): DlmLifecyclePolicyPolicyDetails[];
    /**
     * @stability stable
     */
    set policyDetails(value: DlmLifecyclePolicyPolicyDetails[]);
    /**
     * @stability stable
     */
    get policyDetailsInput(): DlmLifecyclePolicyPolicyDetails[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
