import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DmsCertificateConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly certificateId: string;
    /**
     * @stability stable
     */
    readonly certificatePem?: string;
    /**
     * @stability stable
     */
    readonly certificateWallet?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DmsCertificate extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DmsCertificateConfig);
    /**
     * @stability stable
     */
    get certificateArn(): string;
    private _certificateId;
    /**
     * @stability stable
     */
    get certificateId(): string;
    /**
     * @stability stable
     */
    set certificateId(value: string);
    /**
     * @stability stable
     */
    get certificateIdInput(): string;
    private _certificatePem?;
    /**
     * @stability stable
     */
    get certificatePem(): string;
    /**
     * @stability stable
     */
    set certificatePem(value: string);
    /**
     * @stability stable
     */
    resetCertificatePem(): void;
    /**
     * @stability stable
     */
    get certificatePemInput(): string | undefined;
    private _certificateWallet?;
    /**
     * @stability stable
     */
    get certificateWallet(): string;
    /**
     * @stability stable
     */
    set certificateWallet(value: string);
    /**
     * @stability stable
     */
    resetCertificateWallet(): void;
    /**
     * @stability stable
     */
    get certificateWalletInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
