import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DmsReplicationInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly allocatedStorage?: number;
    /**
     * @stability stable
     */
    readonly allowMajorVersionUpgrade?: boolean;
    /**
     * @stability stable
     */
    readonly applyImmediately?: boolean;
    /**
     * @stability stable
     */
    readonly autoMinorVersionUpgrade?: boolean;
    /**
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * @stability stable
     */
    readonly engineVersion?: string;
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * @stability stable
     */
    readonly multiAz?: boolean;
    /**
     * @stability stable
     */
    readonly preferredMaintenanceWindow?: string;
    /**
     * @stability stable
     */
    readonly publiclyAccessible?: boolean;
    /**
     * @stability stable
     */
    readonly replicationInstanceClass: string;
    /**
     * @stability stable
     */
    readonly replicationInstanceId: string;
    /**
     * @stability stable
     */
    readonly replicationSubnetGroupId?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcSecurityGroupIds?: string[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: DmsReplicationInstanceTimeouts;
}
/**
 * @stability stable
 */
export interface DmsReplicationInstanceTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class DmsReplicationInstance extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DmsReplicationInstanceConfig);
    private _allocatedStorage?;
    /**
     * @stability stable
     */
    get allocatedStorage(): number;
    /**
     * @stability stable
     */
    set allocatedStorage(value: number);
    /**
     * @stability stable
     */
    resetAllocatedStorage(): void;
    /**
     * @stability stable
     */
    get allocatedStorageInput(): number | undefined;
    private _allowMajorVersionUpgrade?;
    /**
     * @stability stable
     */
    get allowMajorVersionUpgrade(): boolean;
    /**
     * @stability stable
     */
    set allowMajorVersionUpgrade(value: boolean);
    /**
     * @stability stable
     */
    resetAllowMajorVersionUpgrade(): void;
    /**
     * @stability stable
     */
    get allowMajorVersionUpgradeInput(): boolean | undefined;
    private _applyImmediately?;
    /**
     * @stability stable
     */
    get applyImmediately(): boolean;
    /**
     * @stability stable
     */
    set applyImmediately(value: boolean);
    /**
     * @stability stable
     */
    resetApplyImmediately(): void;
    /**
     * @stability stable
     */
    get applyImmediatelyInput(): boolean | undefined;
    private _autoMinorVersionUpgrade?;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgrade(): boolean;
    /**
     * @stability stable
     */
    set autoMinorVersionUpgrade(value: boolean);
    /**
     * @stability stable
     */
    resetAutoMinorVersionUpgrade(): void;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgradeInput(): boolean | undefined;
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    private _engineVersion?;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    set engineVersion(value: string);
    /**
     * @stability stable
     */
    resetEngineVersion(): void;
    /**
     * @stability stable
     */
    get engineVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyArn?;
    /**
     * @stability stable
     */
    get kmsKeyArn(): string;
    /**
     * @stability stable
     */
    set kmsKeyArn(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyArn(): void;
    /**
     * @stability stable
     */
    get kmsKeyArnInput(): string | undefined;
    private _multiAz?;
    /**
     * @stability stable
     */
    get multiAz(): boolean;
    /**
     * @stability stable
     */
    set multiAz(value: boolean);
    /**
     * @stability stable
     */
    resetMultiAz(): void;
    /**
     * @stability stable
     */
    get multiAzInput(): boolean | undefined;
    private _preferredMaintenanceWindow?;
    /**
     * @stability stable
     */
    get preferredMaintenanceWindow(): string;
    /**
     * @stability stable
     */
    set preferredMaintenanceWindow(value: string);
    /**
     * @stability stable
     */
    resetPreferredMaintenanceWindow(): void;
    /**
     * @stability stable
     */
    get preferredMaintenanceWindowInput(): string | undefined;
    private _publiclyAccessible?;
    /**
     * @stability stable
     */
    get publiclyAccessible(): boolean;
    /**
     * @stability stable
     */
    set publiclyAccessible(value: boolean);
    /**
     * @stability stable
     */
    resetPubliclyAccessible(): void;
    /**
     * @stability stable
     */
    get publiclyAccessibleInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get replicationInstanceArn(): string;
    private _replicationInstanceClass;
    /**
     * @stability stable
     */
    get replicationInstanceClass(): string;
    /**
     * @stability stable
     */
    set replicationInstanceClass(value: string);
    /**
     * @stability stable
     */
    get replicationInstanceClassInput(): string;
    private _replicationInstanceId;
    /**
     * @stability stable
     */
    get replicationInstanceId(): string;
    /**
     * @stability stable
     */
    set replicationInstanceId(value: string);
    /**
     * @stability stable
     */
    get replicationInstanceIdInput(): string;
    /**
     * @stability stable
     */
    get replicationInstancePrivateIps(): string[];
    /**
     * @stability stable
     */
    get replicationInstancePublicIps(): string[];
    private _replicationSubnetGroupId?;
    /**
     * @stability stable
     */
    get replicationSubnetGroupId(): string;
    /**
     * @stability stable
     */
    set replicationSubnetGroupId(value: string);
    /**
     * @stability stable
     */
    resetReplicationSubnetGroupId(): void;
    /**
     * @stability stable
     */
    get replicationSubnetGroupIdInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcSecurityGroupIds?;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set vpcSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetVpcSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIdsInput(): string[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DmsReplicationInstanceTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DmsReplicationInstanceTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DmsReplicationInstanceTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
