import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DmsReplicationSubnetGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly replicationSubnetGroupDescription: string;
    /**
     * @stability stable
     */
    readonly replicationSubnetGroupId: string;
    /**
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class DmsReplicationSubnetGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DmsReplicationSubnetGroupConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get replicationSubnetGroupArn(): string;
    private _replicationSubnetGroupDescription;
    /**
     * @stability stable
     */
    get replicationSubnetGroupDescription(): string;
    /**
     * @stability stable
     */
    set replicationSubnetGroupDescription(value: string);
    /**
     * @stability stable
     */
    get replicationSubnetGroupDescriptionInput(): string;
    private _replicationSubnetGroupId;
    /**
     * @stability stable
     */
    get replicationSubnetGroupId(): string;
    /**
     * @stability stable
     */
    set replicationSubnetGroupId(value: string);
    /**
     * @stability stable
     */
    get replicationSubnetGroupIdInput(): string;
    private _subnetIds;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
