import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DmsReplicationTaskConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly cdcStartTime?: string;
    /**
     * @stability stable
     */
    readonly migrationType: string;
    /**
     * @stability stable
     */
    readonly replicationInstanceArn: string;
    /**
     * @stability stable
     */
    readonly replicationTaskId: string;
    /**
     * @stability stable
     */
    readonly replicationTaskSettings?: string;
    /**
     * @stability stable
     */
    readonly sourceEndpointArn: string;
    /**
     * @stability stable
     */
    readonly tableMappings: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly targetEndpointArn: string;
}
/**
 * @stability stable
 */
export declare class DmsReplicationTask extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DmsReplicationTaskConfig);
    private _cdcStartTime?;
    /**
     * @stability stable
     */
    get cdcStartTime(): string;
    /**
     * @stability stable
     */
    set cdcStartTime(value: string);
    /**
     * @stability stable
     */
    resetCdcStartTime(): void;
    /**
     * @stability stable
     */
    get cdcStartTimeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _migrationType;
    /**
     * @stability stable
     */
    get migrationType(): string;
    /**
     * @stability stable
     */
    set migrationType(value: string);
    /**
     * @stability stable
     */
    get migrationTypeInput(): string;
    private _replicationInstanceArn;
    /**
     * @stability stable
     */
    get replicationInstanceArn(): string;
    /**
     * @stability stable
     */
    set replicationInstanceArn(value: string);
    /**
     * @stability stable
     */
    get replicationInstanceArnInput(): string;
    /**
     * @stability stable
     */
    get replicationTaskArn(): string;
    private _replicationTaskId;
    /**
     * @stability stable
     */
    get replicationTaskId(): string;
    /**
     * @stability stable
     */
    set replicationTaskId(value: string);
    /**
     * @stability stable
     */
    get replicationTaskIdInput(): string;
    private _replicationTaskSettings?;
    /**
     * @stability stable
     */
    get replicationTaskSettings(): string;
    /**
     * @stability stable
     */
    set replicationTaskSettings(value: string);
    /**
     * @stability stable
     */
    resetReplicationTaskSettings(): void;
    /**
     * @stability stable
     */
    get replicationTaskSettingsInput(): string | undefined;
    private _sourceEndpointArn;
    /**
     * @stability stable
     */
    get sourceEndpointArn(): string;
    /**
     * @stability stable
     */
    set sourceEndpointArn(value: string);
    /**
     * @stability stable
     */
    get sourceEndpointArnInput(): string;
    private _tableMappings;
    /**
     * @stability stable
     */
    get tableMappings(): string;
    /**
     * @stability stable
     */
    set tableMappings(value: string);
    /**
     * @stability stable
     */
    get tableMappingsInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _targetEndpointArn;
    /**
     * @stability stable
     */
    get targetEndpointArn(): string;
    /**
     * @stability stable
     */
    set targetEndpointArn(value: string);
    /**
     * @stability stable
     */
    get targetEndpointArnInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
