import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DocdbClusterInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly applyImmediately?: boolean;
    /**
     * @stability stable
     */
    readonly autoMinorVersionUpgrade?: boolean;
    /**
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * @stability stable
     */
    readonly caCertIdentifier?: string;
    /**
     * @stability stable
     */
    readonly clusterIdentifier: string;
    /**
     * @stability stable
     */
    readonly engine?: string;
    /**
     * @stability stable
     */
    readonly identifier?: string;
    /**
     * @stability stable
     */
    readonly identifierPrefix?: string;
    /**
     * @stability stable
     */
    readonly instanceClass: string;
    /**
     * @stability stable
     */
    readonly preferredMaintenanceWindow?: string;
    /**
     * @stability stable
     */
    readonly promotionTier?: number;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: DocdbClusterInstanceTimeouts;
}
/**
 * @stability stable
 */
export interface DocdbClusterInstanceTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class DocdbClusterInstance extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DocdbClusterInstanceConfig);
    private _applyImmediately?;
    /**
     * @stability stable
     */
    get applyImmediately(): boolean;
    /**
     * @stability stable
     */
    set applyImmediately(value: boolean);
    /**
     * @stability stable
     */
    resetApplyImmediately(): void;
    /**
     * @stability stable
     */
    get applyImmediatelyInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoMinorVersionUpgrade?;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgrade(): boolean;
    /**
     * @stability stable
     */
    set autoMinorVersionUpgrade(value: boolean);
    /**
     * @stability stable
     */
    resetAutoMinorVersionUpgrade(): void;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgradeInput(): boolean | undefined;
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    private _caCertIdentifier?;
    /**
     * @stability stable
     */
    get caCertIdentifier(): string;
    /**
     * @stability stable
     */
    set caCertIdentifier(value: string);
    /**
     * @stability stable
     */
    resetCaCertIdentifier(): void;
    /**
     * @stability stable
     */
    get caCertIdentifierInput(): string | undefined;
    private _clusterIdentifier;
    /**
     * @stability stable
     */
    get clusterIdentifier(): string;
    /**
     * @stability stable
     */
    set clusterIdentifier(value: string);
    /**
     * @stability stable
     */
    get clusterIdentifierInput(): string;
    /**
     * @stability stable
     */
    get dbSubnetGroupName(): string;
    /**
     * @stability stable
     */
    get dbiResourceId(): string;
    /**
     * @stability stable
     */
    get endpoint(): string;
    private _engine?;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    resetEngine(): void;
    /**
     * @stability stable
     */
    get engineInput(): string | undefined;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _identifier?;
    /**
     * @stability stable
     */
    get identifier(): string;
    /**
     * @stability stable
     */
    set identifier(value: string);
    /**
     * @stability stable
     */
    resetIdentifier(): void;
    /**
     * @stability stable
     */
    get identifierInput(): string | undefined;
    private _identifierPrefix?;
    /**
     * @stability stable
     */
    get identifierPrefix(): string;
    /**
     * @stability stable
     */
    set identifierPrefix(value: string);
    /**
     * @stability stable
     */
    resetIdentifierPrefix(): void;
    /**
     * @stability stable
     */
    get identifierPrefixInput(): string | undefined;
    private _instanceClass;
    /**
     * @stability stable
     */
    get instanceClass(): string;
    /**
     * @stability stable
     */
    set instanceClass(value: string);
    /**
     * @stability stable
     */
    get instanceClassInput(): string;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    get preferredBackupWindow(): string;
    private _preferredMaintenanceWindow?;
    /**
     * @stability stable
     */
    get preferredMaintenanceWindow(): string;
    /**
     * @stability stable
     */
    set preferredMaintenanceWindow(value: string);
    /**
     * @stability stable
     */
    resetPreferredMaintenanceWindow(): void;
    /**
     * @stability stable
     */
    get preferredMaintenanceWindowInput(): string | undefined;
    private _promotionTier?;
    /**
     * @stability stable
     */
    get promotionTier(): number;
    /**
     * @stability stable
     */
    set promotionTier(value: number);
    /**
     * @stability stable
     */
    resetPromotionTier(): void;
    /**
     * @stability stable
     */
    get promotionTierInput(): number | undefined;
    /**
     * @stability stable
     */
    get publiclyAccessible(): boolean;
    /**
     * @stability stable
     */
    get storageEncrypted(): boolean;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get writer(): boolean;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DocdbClusterInstanceTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DocdbClusterInstanceTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DocdbClusterInstanceTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
