import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DxGatewayAssociationProposalConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly allowedPrefixes?: string[];
    /**
     * @stability stable
     */
    readonly associatedGatewayId: string;
    /**
     * @stability stable
     */
    readonly dxGatewayId: string;
    /**
     * @stability stable
     */
    readonly dxGatewayOwnerAccountId: string;
}
/**
 * @stability stable
 */
export declare class DxGatewayAssociationProposal extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DxGatewayAssociationProposalConfig);
    private _allowedPrefixes?;
    /**
     * @stability stable
     */
    get allowedPrefixes(): string[];
    /**
     * @stability stable
     */
    set allowedPrefixes(value: string[]);
    /**
     * @stability stable
     */
    resetAllowedPrefixes(): void;
    /**
     * @stability stable
     */
    get allowedPrefixesInput(): string[] | undefined;
    private _associatedGatewayId;
    /**
     * @stability stable
     */
    get associatedGatewayId(): string;
    /**
     * @stability stable
     */
    set associatedGatewayId(value: string);
    /**
     * @stability stable
     */
    get associatedGatewayIdInput(): string;
    /**
     * @stability stable
     */
    get associatedGatewayOwnerAccountId(): string;
    /**
     * @stability stable
     */
    get associatedGatewayType(): string;
    private _dxGatewayId;
    /**
     * @stability stable
     */
    get dxGatewayId(): string;
    /**
     * @stability stable
     */
    set dxGatewayId(value: string);
    /**
     * @stability stable
     */
    get dxGatewayIdInput(): string;
    private _dxGatewayOwnerAccountId;
    /**
     * @stability stable
     */
    get dxGatewayOwnerAccountId(): string;
    /**
     * @stability stable
     */
    set dxGatewayOwnerAccountId(value: string);
    /**
     * @stability stable
     */
    get dxGatewayOwnerAccountIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
