import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DxGatewayAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly allowedPrefixes?: string[];
    /**
     * @stability stable
     */
    readonly associatedGatewayId?: string;
    /**
     * @stability stable
     */
    readonly associatedGatewayOwnerAccountId?: string;
    /**
     * @stability stable
     */
    readonly dxGatewayId: string;
    /**
     * @stability stable
     */
    readonly proposalId?: string;
    /**
     * @stability stable
     */
    readonly vpnGatewayId?: string;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: DxGatewayAssociationTimeouts;
}
/**
 * @stability stable
 */
export interface DxGatewayAssociationTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class DxGatewayAssociation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DxGatewayAssociationConfig);
    private _allowedPrefixes?;
    /**
     * @stability stable
     */
    get allowedPrefixes(): string[];
    /**
     * @stability stable
     */
    set allowedPrefixes(value: string[]);
    /**
     * @stability stable
     */
    resetAllowedPrefixes(): void;
    /**
     * @stability stable
     */
    get allowedPrefixesInput(): string[] | undefined;
    private _associatedGatewayId?;
    /**
     * @stability stable
     */
    get associatedGatewayId(): string;
    /**
     * @stability stable
     */
    set associatedGatewayId(value: string);
    /**
     * @stability stable
     */
    resetAssociatedGatewayId(): void;
    /**
     * @stability stable
     */
    get associatedGatewayIdInput(): string | undefined;
    private _associatedGatewayOwnerAccountId?;
    /**
     * @stability stable
     */
    get associatedGatewayOwnerAccountId(): string;
    /**
     * @stability stable
     */
    set associatedGatewayOwnerAccountId(value: string);
    /**
     * @stability stable
     */
    resetAssociatedGatewayOwnerAccountId(): void;
    /**
     * @stability stable
     */
    get associatedGatewayOwnerAccountIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get associatedGatewayType(): string;
    /**
     * @stability stable
     */
    get dxGatewayAssociationId(): string;
    private _dxGatewayId;
    /**
     * @stability stable
     */
    get dxGatewayId(): string;
    /**
     * @stability stable
     */
    set dxGatewayId(value: string);
    /**
     * @stability stable
     */
    get dxGatewayIdInput(): string;
    /**
     * @stability stable
     */
    get dxGatewayOwnerAccountId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _proposalId?;
    /**
     * @stability stable
     */
    get proposalId(): string;
    /**
     * @stability stable
     */
    set proposalId(value: string);
    /**
     * @stability stable
     */
    resetProposalId(): void;
    /**
     * @stability stable
     */
    get proposalIdInput(): string | undefined;
    private _vpnGatewayId?;
    /**
     * @stability stable
     */
    get vpnGatewayId(): string;
    /**
     * @stability stable
     */
    set vpnGatewayId(value: string);
    /**
     * @stability stable
     */
    resetVpnGatewayId(): void;
    /**
     * @stability stable
     */
    get vpnGatewayIdInput(): string | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DxGatewayAssociationTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DxGatewayAssociationTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DxGatewayAssociationTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
