import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DxGatewayConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly amazonSideAsn: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: DxGatewayTimeouts;
}
/**
 * @stability stable
 */
export interface DxGatewayTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export declare class DxGateway extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DxGatewayConfig);
    private _amazonSideAsn;
    /**
     * @stability stable
     */
    get amazonSideAsn(): string;
    /**
     * @stability stable
     */
    set amazonSideAsn(value: string);
    /**
     * @stability stable
     */
    get amazonSideAsnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get ownerAccountId(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DxGatewayTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DxGatewayTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DxGatewayTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
