import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DxHostedPublicVirtualInterfaceAccepterConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly virtualInterfaceId: string;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: DxHostedPublicVirtualInterfaceAccepterTimeouts;
}
/**
 * @stability stable
 */
export interface DxHostedPublicVirtualInterfaceAccepterTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export declare class DxHostedPublicVirtualInterfaceAccepter extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DxHostedPublicVirtualInterfaceAccepterConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _virtualInterfaceId;
    /**
     * @stability stable
     */
    get virtualInterfaceId(): string;
    /**
     * @stability stable
     */
    set virtualInterfaceId(value: string);
    /**
     * @stability stable
     */
    get virtualInterfaceIdInput(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DxHostedPublicVirtualInterfaceAccepterTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DxHostedPublicVirtualInterfaceAccepterTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DxHostedPublicVirtualInterfaceAccepterTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
