import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DxHostedTransitVirtualInterfaceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly addressFamily: string;
    /**
     * @stability stable
     */
    readonly amazonAddress?: string;
    /**
     * @stability stable
     */
    readonly bgpAsn: number;
    /**
     * @stability stable
     */
    readonly bgpAuthKey?: string;
    /**
     * @stability stable
     */
    readonly connectionId: string;
    /**
     * @stability stable
     */
    readonly customerAddress?: string;
    /**
     * @stability stable
     */
    readonly mtu?: number;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly ownerAccountId: string;
    /**
     * @stability stable
     */
    readonly vlan: number;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: DxHostedTransitVirtualInterfaceTimeouts;
}
/**
 * @stability stable
 */
export interface DxHostedTransitVirtualInterfaceTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export declare class DxHostedTransitVirtualInterface extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DxHostedTransitVirtualInterfaceConfig);
    private _addressFamily;
    /**
     * @stability stable
     */
    get addressFamily(): string;
    /**
     * @stability stable
     */
    set addressFamily(value: string);
    /**
     * @stability stable
     */
    get addressFamilyInput(): string;
    private _amazonAddress?;
    /**
     * @stability stable
     */
    get amazonAddress(): string;
    /**
     * @stability stable
     */
    set amazonAddress(value: string);
    /**
     * @stability stable
     */
    resetAmazonAddress(): void;
    /**
     * @stability stable
     */
    get amazonAddressInput(): string | undefined;
    /**
     * @stability stable
     */
    get amazonSideAsn(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get awsDevice(): string;
    private _bgpAsn;
    /**
     * @stability stable
     */
    get bgpAsn(): number;
    /**
     * @stability stable
     */
    set bgpAsn(value: number);
    /**
     * @stability stable
     */
    get bgpAsnInput(): number;
    private _bgpAuthKey?;
    /**
     * @stability stable
     */
    get bgpAuthKey(): string;
    /**
     * @stability stable
     */
    set bgpAuthKey(value: string);
    /**
     * @stability stable
     */
    resetBgpAuthKey(): void;
    /**
     * @stability stable
     */
    get bgpAuthKeyInput(): string | undefined;
    private _connectionId;
    /**
     * @stability stable
     */
    get connectionId(): string;
    /**
     * @stability stable
     */
    set connectionId(value: string);
    /**
     * @stability stable
     */
    get connectionIdInput(): string;
    private _customerAddress?;
    /**
     * @stability stable
     */
    get customerAddress(): string;
    /**
     * @stability stable
     */
    set customerAddress(value: string);
    /**
     * @stability stable
     */
    resetCustomerAddress(): void;
    /**
     * @stability stable
     */
    get customerAddressInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get jumboFrameCapable(): boolean;
    private _mtu?;
    /**
     * @stability stable
     */
    get mtu(): number;
    /**
     * @stability stable
     */
    set mtu(value: number);
    /**
     * @stability stable
     */
    resetMtu(): void;
    /**
     * @stability stable
     */
    get mtuInput(): number | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _ownerAccountId;
    /**
     * @stability stable
     */
    get ownerAccountId(): string;
    /**
     * @stability stable
     */
    set ownerAccountId(value: string);
    /**
     * @stability stable
     */
    get ownerAccountIdInput(): string;
    private _vlan;
    /**
     * @stability stable
     */
    get vlan(): number;
    /**
     * @stability stable
     */
    set vlan(value: number);
    /**
     * @stability stable
     */
    get vlanInput(): number;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DxHostedTransitVirtualInterfaceTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DxHostedTransitVirtualInterfaceTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DxHostedTransitVirtualInterfaceTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
