import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DynamodbGlobalTableConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * replica block.
     *
     * @stability stable
     */
    readonly replica: DynamodbGlobalTableReplica[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: DynamodbGlobalTableTimeouts;
}
/**
 * @stability stable
 */
export interface DynamodbGlobalTableReplica {
    /**
     * @stability stable
     */
    readonly regionName: string;
}
/**
 * @stability stable
 */
export interface DynamodbGlobalTableTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class DynamodbGlobalTable extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DynamodbGlobalTableConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _replica;
    /**
     * @stability stable
     */
    get replica(): DynamodbGlobalTableReplica[];
    /**
     * @stability stable
     */
    set replica(value: DynamodbGlobalTableReplica[]);
    /**
     * @stability stable
     */
    get replicaInput(): DynamodbGlobalTableReplica[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): DynamodbGlobalTableTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: DynamodbGlobalTableTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DynamodbGlobalTableTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
