import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DynamodbTableItemConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly hashKey: string;
    /**
     * @stability stable
     */
    readonly item: string;
    /**
     * @stability stable
     */
    readonly rangeKey?: string;
    /**
     * @stability stable
     */
    readonly tableName: string;
}
/**
 * @stability stable
 */
export declare class DynamodbTableItem extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DynamodbTableItemConfig);
    private _hashKey;
    /**
     * @stability stable
     */
    get hashKey(): string;
    /**
     * @stability stable
     */
    set hashKey(value: string);
    /**
     * @stability stable
     */
    get hashKeyInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _item;
    /**
     * @stability stable
     */
    get item(): string;
    /**
     * @stability stable
     */
    set item(value: string);
    /**
     * @stability stable
     */
    get itemInput(): string;
    private _rangeKey?;
    /**
     * @stability stable
     */
    get rangeKey(): string;
    /**
     * @stability stable
     */
    set rangeKey(value: string);
    /**
     * @stability stable
     */
    resetRangeKey(): void;
    /**
     * @stability stable
     */
    get rangeKeyInput(): string | undefined;
    private _tableName;
    /**
     * @stability stable
     */
    get tableName(): string;
    /**
     * @stability stable
     */
    set tableName(value: string);
    /**
     * @stability stable
     */
    get tableNameInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
