import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EbsSnapshotCopyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly sourceRegion: string;
    /**
     * @stability stable
     */
    readonly sourceSnapshotId: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class EbsSnapshotCopy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EbsSnapshotCopyConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get dataEncryptionKeyId(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _encrypted?;
    /**
     * @stability stable
     */
    get encrypted(): boolean;
    /**
     * @stability stable
     */
    set encrypted(value: boolean);
    /**
     * @stability stable
     */
    resetEncrypted(): void;
    /**
     * @stability stable
     */
    get encryptedInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get ownerAlias(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _sourceRegion;
    /**
     * @stability stable
     */
    get sourceRegion(): string;
    /**
     * @stability stable
     */
    set sourceRegion(value: string);
    /**
     * @stability stable
     */
    get sourceRegionInput(): string;
    private _sourceSnapshotId;
    /**
     * @stability stable
     */
    get sourceSnapshotId(): string;
    /**
     * @stability stable
     */
    set sourceSnapshotId(value: string);
    /**
     * @stability stable
     */
    get sourceSnapshotIdInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get volumeId(): string;
    /**
     * @stability stable
     */
    get volumeSize(): number;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
