import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2CapacityReservationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly availabilityZone: string;
    /**
     * @stability stable
     */
    readonly ebsOptimized?: boolean;
    /**
     * @stability stable
     */
    readonly endDate?: string;
    /**
     * @stability stable
     */
    readonly endDateType?: string;
    /**
     * @stability stable
     */
    readonly ephemeralStorage?: boolean;
    /**
     * @stability stable
     */
    readonly instanceCount: number;
    /**
     * @stability stable
     */
    readonly instanceMatchCriteria?: string;
    /**
     * @stability stable
     */
    readonly instancePlatform: string;
    /**
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly tenancy?: string;
}
/**
 * @stability stable
 */
export declare class Ec2CapacityReservation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2CapacityReservationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _availabilityZone;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string;
    private _ebsOptimized?;
    /**
     * @stability stable
     */
    get ebsOptimized(): boolean;
    /**
     * @stability stable
     */
    set ebsOptimized(value: boolean);
    /**
     * @stability stable
     */
    resetEbsOptimized(): void;
    /**
     * @stability stable
     */
    get ebsOptimizedInput(): boolean | undefined;
    private _endDate?;
    /**
     * @stability stable
     */
    get endDate(): string;
    /**
     * @stability stable
     */
    set endDate(value: string);
    /**
     * @stability stable
     */
    resetEndDate(): void;
    /**
     * @stability stable
     */
    get endDateInput(): string | undefined;
    private _endDateType?;
    /**
     * @stability stable
     */
    get endDateType(): string;
    /**
     * @stability stable
     */
    set endDateType(value: string);
    /**
     * @stability stable
     */
    resetEndDateType(): void;
    /**
     * @stability stable
     */
    get endDateTypeInput(): string | undefined;
    private _ephemeralStorage?;
    /**
     * @stability stable
     */
    get ephemeralStorage(): boolean;
    /**
     * @stability stable
     */
    set ephemeralStorage(value: boolean);
    /**
     * @stability stable
     */
    resetEphemeralStorage(): void;
    /**
     * @stability stable
     */
    get ephemeralStorageInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceCount;
    /**
     * @stability stable
     */
    get instanceCount(): number;
    /**
     * @stability stable
     */
    set instanceCount(value: number);
    /**
     * @stability stable
     */
    get instanceCountInput(): number;
    private _instanceMatchCriteria?;
    /**
     * @stability stable
     */
    get instanceMatchCriteria(): string;
    /**
     * @stability stable
     */
    set instanceMatchCriteria(value: string);
    /**
     * @stability stable
     */
    resetInstanceMatchCriteria(): void;
    /**
     * @stability stable
     */
    get instanceMatchCriteriaInput(): string | undefined;
    private _instancePlatform;
    /**
     * @stability stable
     */
    get instancePlatform(): string;
    /**
     * @stability stable
     */
    set instancePlatform(value: string);
    /**
     * @stability stable
     */
    get instancePlatformInput(): string;
    private _instanceType;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    get instanceTypeInput(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tenancy?;
    /**
     * @stability stable
     */
    get tenancy(): string;
    /**
     * @stability stable
     */
    set tenancy(value: string);
    /**
     * @stability stable
     */
    resetTenancy(): void;
    /**
     * @stability stable
     */
    get tenancyInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
