import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2ClientVpnAuthorizationRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly accessGroupId?: string;
    /**
     * @stability stable
     */
    readonly authorizeAllGroups?: boolean;
    /**
     * @stability stable
     */
    readonly clientVpnEndpointId: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly targetNetworkCidr: string;
}
/**
 * @stability stable
 */
export declare class Ec2ClientVpnAuthorizationRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2ClientVpnAuthorizationRuleConfig);
    private _accessGroupId?;
    /**
     * @stability stable
     */
    get accessGroupId(): string;
    /**
     * @stability stable
     */
    set accessGroupId(value: string);
    /**
     * @stability stable
     */
    resetAccessGroupId(): void;
    /**
     * @stability stable
     */
    get accessGroupIdInput(): string | undefined;
    private _authorizeAllGroups?;
    /**
     * @stability stable
     */
    get authorizeAllGroups(): boolean;
    /**
     * @stability stable
     */
    set authorizeAllGroups(value: boolean);
    /**
     * @stability stable
     */
    resetAuthorizeAllGroups(): void;
    /**
     * @stability stable
     */
    get authorizeAllGroupsInput(): boolean | undefined;
    private _clientVpnEndpointId;
    /**
     * @stability stable
     */
    get clientVpnEndpointId(): string;
    /**
     * @stability stable
     */
    set clientVpnEndpointId(value: string);
    /**
     * @stability stable
     */
    get clientVpnEndpointIdInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _targetNetworkCidr;
    /**
     * @stability stable
     */
    get targetNetworkCidr(): string;
    /**
     * @stability stable
     */
    set targetNetworkCidr(value: string);
    /**
     * @stability stable
     */
    get targetNetworkCidrInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
