import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2ClientVpnEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly clientCidrBlock: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly dnsServers?: string[];
    /**
     * @stability stable
     */
    readonly serverCertificateArn: string;
    /**
     * @stability stable
     */
    readonly splitTunnel?: boolean;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly transportProtocol?: string;
    /**
     * authentication_options block.
     *
     * @stability stable
     */
    readonly authenticationOptions: Ec2ClientVpnEndpointAuthenticationOptions[];
    /**
     * connection_log_options block.
     *
     * @stability stable
     */
    readonly connectionLogOptions: Ec2ClientVpnEndpointConnectionLogOptions[];
}
/**
 * @stability stable
 */
export interface Ec2ClientVpnEndpointAuthenticationOptions {
    /**
     * @stability stable
     */
    readonly activeDirectoryId?: string;
    /**
     * @stability stable
     */
    readonly rootCertificateChainArn?: string;
    /**
     * @stability stable
     */
    readonly samlProviderArn?: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface Ec2ClientVpnEndpointConnectionLogOptions {
    /**
     * @stability stable
     */
    readonly cloudwatchLogGroup?: string;
    /**
     * @stability stable
     */
    readonly cloudwatchLogStream?: string;
    /**
     * @stability stable
     */
    readonly enabled: boolean;
}
/**
 * @stability stable
 */
export declare class Ec2ClientVpnEndpoint extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2ClientVpnEndpointConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _clientCidrBlock;
    /**
     * @stability stable
     */
    get clientCidrBlock(): string;
    /**
     * @stability stable
     */
    set clientCidrBlock(value: string);
    /**
     * @stability stable
     */
    get clientCidrBlockInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get dnsName(): string;
    private _dnsServers?;
    /**
     * @stability stable
     */
    get dnsServers(): string[];
    /**
     * @stability stable
     */
    set dnsServers(value: string[]);
    /**
     * @stability stable
     */
    resetDnsServers(): void;
    /**
     * @stability stable
     */
    get dnsServersInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _serverCertificateArn;
    /**
     * @stability stable
     */
    get serverCertificateArn(): string;
    /**
     * @stability stable
     */
    set serverCertificateArn(value: string);
    /**
     * @stability stable
     */
    get serverCertificateArnInput(): string;
    private _splitTunnel?;
    /**
     * @stability stable
     */
    get splitTunnel(): boolean;
    /**
     * @stability stable
     */
    set splitTunnel(value: boolean);
    /**
     * @stability stable
     */
    resetSplitTunnel(): void;
    /**
     * @stability stable
     */
    get splitTunnelInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _transportProtocol?;
    /**
     * @stability stable
     */
    get transportProtocol(): string;
    /**
     * @stability stable
     */
    set transportProtocol(value: string);
    /**
     * @stability stable
     */
    resetTransportProtocol(): void;
    /**
     * @stability stable
     */
    get transportProtocolInput(): string | undefined;
    private _authenticationOptions;
    /**
     * @stability stable
     */
    get authenticationOptions(): Ec2ClientVpnEndpointAuthenticationOptions[];
    /**
     * @stability stable
     */
    set authenticationOptions(value: Ec2ClientVpnEndpointAuthenticationOptions[]);
    /**
     * @stability stable
     */
    get authenticationOptionsInput(): Ec2ClientVpnEndpointAuthenticationOptions[];
    private _connectionLogOptions;
    /**
     * @stability stable
     */
    get connectionLogOptions(): Ec2ClientVpnEndpointConnectionLogOptions[];
    /**
     * @stability stable
     */
    set connectionLogOptions(value: Ec2ClientVpnEndpointConnectionLogOptions[]);
    /**
     * @stability stable
     */
    get connectionLogOptionsInput(): Ec2ClientVpnEndpointConnectionLogOptions[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
