import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2FleetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly excessCapacityTerminationPolicy?: string;
    /**
     * @stability stable
     */
    readonly replaceUnhealthyInstances?: boolean;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly terminateInstances?: boolean;
    /**
     * @stability stable
     */
    readonly terminateInstancesWithExpiration?: boolean;
    /**
     * @stability stable
     */
    readonly type?: string;
    /**
     * launch_template_config block.
     *
     * @stability stable
     */
    readonly launchTemplateConfig: Ec2FleetLaunchTemplateConfig[];
    /**
     * on_demand_options block.
     *
     * @stability stable
     */
    readonly onDemandOptions?: Ec2FleetOnDemandOptions[];
    /**
     * spot_options block.
     *
     * @stability stable
     */
    readonly spotOptions?: Ec2FleetSpotOptions[];
    /**
     * target_capacity_specification block.
     *
     * @stability stable
     */
    readonly targetCapacitySpecification: Ec2FleetTargetCapacitySpecification[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: Ec2FleetTimeouts;
}
/**
 * @stability stable
 */
export interface Ec2FleetLaunchTemplateConfigLaunchTemplateSpecification {
    /**
     * @stability stable
     */
    readonly launchTemplateId?: string;
    /**
     * @stability stable
     */
    readonly launchTemplateName?: string;
    /**
     * @stability stable
     */
    readonly version: string;
}
/**
 * @stability stable
 */
export interface Ec2FleetLaunchTemplateConfigOverride {
    /**
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * @stability stable
     */
    readonly maxPrice?: string;
    /**
     * @stability stable
     */
    readonly priority?: number;
    /**
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * @stability stable
     */
    readonly weightedCapacity?: number;
}
/**
 * @stability stable
 */
export interface Ec2FleetLaunchTemplateConfig {
    /**
     * launch_template_specification block.
     *
     * @stability stable
     */
    readonly launchTemplateSpecification: Ec2FleetLaunchTemplateConfigLaunchTemplateSpecification[];
    /**
     * override block.
     *
     * @stability stable
     */
    readonly override?: Ec2FleetLaunchTemplateConfigOverride[];
}
/**
 * @stability stable
 */
export interface Ec2FleetOnDemandOptions {
    /**
     * @stability stable
     */
    readonly allocationStrategy?: string;
}
/**
 * @stability stable
 */
export interface Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalance {
    /**
     * @stability stable
     */
    readonly replacementStrategy?: string;
}
/**
 * @stability stable
 */
export interface Ec2FleetSpotOptionsMaintenanceStrategies {
    /**
     * capacity_rebalance block.
     *
     * @stability stable
     */
    readonly capacityRebalance?: Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalance[];
}
/**
 * @stability stable
 */
export interface Ec2FleetSpotOptions {
    /**
     * @stability stable
     */
    readonly allocationStrategy?: string;
    /**
     * @stability stable
     */
    readonly instanceInterruptionBehavior?: string;
    /**
     * @stability stable
     */
    readonly instancePoolsToUseCount?: number;
    /**
     * maintenance_strategies block.
     *
     * @stability stable
     */
    readonly maintenanceStrategies?: Ec2FleetSpotOptionsMaintenanceStrategies[];
}
/**
 * @stability stable
 */
export interface Ec2FleetTargetCapacitySpecification {
    /**
     * @stability stable
     */
    readonly defaultTargetCapacityType: string;
    /**
     * @stability stable
     */
    readonly onDemandTargetCapacity?: number;
    /**
     * @stability stable
     */
    readonly spotTargetCapacity?: number;
    /**
     * @stability stable
     */
    readonly totalTargetCapacity: number;
}
/**
 * @stability stable
 */
export interface Ec2FleetTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class Ec2Fleet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2FleetConfig);
    private _excessCapacityTerminationPolicy?;
    /**
     * @stability stable
     */
    get excessCapacityTerminationPolicy(): string;
    /**
     * @stability stable
     */
    set excessCapacityTerminationPolicy(value: string);
    /**
     * @stability stable
     */
    resetExcessCapacityTerminationPolicy(): void;
    /**
     * @stability stable
     */
    get excessCapacityTerminationPolicyInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _replaceUnhealthyInstances?;
    /**
     * @stability stable
     */
    get replaceUnhealthyInstances(): boolean;
    /**
     * @stability stable
     */
    set replaceUnhealthyInstances(value: boolean);
    /**
     * @stability stable
     */
    resetReplaceUnhealthyInstances(): void;
    /**
     * @stability stable
     */
    get replaceUnhealthyInstancesInput(): boolean | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _terminateInstances?;
    /**
     * @stability stable
     */
    get terminateInstances(): boolean;
    /**
     * @stability stable
     */
    set terminateInstances(value: boolean);
    /**
     * @stability stable
     */
    resetTerminateInstances(): void;
    /**
     * @stability stable
     */
    get terminateInstancesInput(): boolean | undefined;
    private _terminateInstancesWithExpiration?;
    /**
     * @stability stable
     */
    get terminateInstancesWithExpiration(): boolean;
    /**
     * @stability stable
     */
    set terminateInstancesWithExpiration(value: boolean);
    /**
     * @stability stable
     */
    resetTerminateInstancesWithExpiration(): void;
    /**
     * @stability stable
     */
    get terminateInstancesWithExpirationInput(): boolean | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _launchTemplateConfig;
    /**
     * @stability stable
     */
    get launchTemplateConfig(): Ec2FleetLaunchTemplateConfig[];
    /**
     * @stability stable
     */
    set launchTemplateConfig(value: Ec2FleetLaunchTemplateConfig[]);
    /**
     * @stability stable
     */
    get launchTemplateConfigInput(): Ec2FleetLaunchTemplateConfig[];
    private _onDemandOptions?;
    /**
     * @stability stable
     */
    get onDemandOptions(): Ec2FleetOnDemandOptions[];
    /**
     * @stability stable
     */
    set onDemandOptions(value: Ec2FleetOnDemandOptions[]);
    /**
     * @stability stable
     */
    resetOnDemandOptions(): void;
    /**
     * @stability stable
     */
    get onDemandOptionsInput(): Ec2FleetOnDemandOptions[] | undefined;
    private _spotOptions?;
    /**
     * @stability stable
     */
    get spotOptions(): Ec2FleetSpotOptions[];
    /**
     * @stability stable
     */
    set spotOptions(value: Ec2FleetSpotOptions[]);
    /**
     * @stability stable
     */
    resetSpotOptions(): void;
    /**
     * @stability stable
     */
    get spotOptionsInput(): Ec2FleetSpotOptions[] | undefined;
    private _targetCapacitySpecification;
    /**
     * @stability stable
     */
    get targetCapacitySpecification(): Ec2FleetTargetCapacitySpecification[];
    /**
     * @stability stable
     */
    set targetCapacitySpecification(value: Ec2FleetTargetCapacitySpecification[]);
    /**
     * @stability stable
     */
    get targetCapacitySpecificationInput(): Ec2FleetTargetCapacitySpecification[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): Ec2FleetTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: Ec2FleetTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): Ec2FleetTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
