import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2LocalGatewayRouteConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly destinationCidrBlock: string;
    /**
     * @stability stable
     */
    readonly localGatewayRouteTableId: string;
    /**
     * @stability stable
     */
    readonly localGatewayVirtualInterfaceGroupId: string;
}
/**
 * @stability stable
 */
export declare class Ec2LocalGatewayRoute extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2LocalGatewayRouteConfig);
    private _destinationCidrBlock;
    /**
     * @stability stable
     */
    get destinationCidrBlock(): string;
    /**
     * @stability stable
     */
    set destinationCidrBlock(value: string);
    /**
     * @stability stable
     */
    get destinationCidrBlockInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _localGatewayRouteTableId;
    /**
     * @stability stable
     */
    get localGatewayRouteTableId(): string;
    /**
     * @stability stable
     */
    set localGatewayRouteTableId(value: string);
    /**
     * @stability stable
     */
    get localGatewayRouteTableIdInput(): string;
    private _localGatewayVirtualInterfaceGroupId;
    /**
     * @stability stable
     */
    get localGatewayVirtualInterfaceGroupId(): string;
    /**
     * @stability stable
     */
    set localGatewayVirtualInterfaceGroupId(value: string);
    /**
     * @stability stable
     */
    get localGatewayVirtualInterfaceGroupIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
