import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2ManagedPrefixListConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly addressFamily: string;
    /**
     * @stability stable
     */
    readonly maxEntries: number;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * entry block.
     *
     * @stability stable
     */
    readonly entry?: Ec2ManagedPrefixListEntry[];
}
/**
 * @stability stable
 */
export interface Ec2ManagedPrefixListEntry {
    /**
     * @stability stable
     */
    readonly cidr: string;
    /**
     * @stability stable
     */
    readonly description?: string;
}
/**
 * @stability stable
 */
export declare class Ec2ManagedPrefixList extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2ManagedPrefixListConfig);
    private _addressFamily;
    /**
     * @stability stable
     */
    get addressFamily(): string;
    /**
     * @stability stable
     */
    set addressFamily(value: string);
    /**
     * @stability stable
     */
    get addressFamilyInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _maxEntries;
    /**
     * @stability stable
     */
    get maxEntries(): number;
    /**
     * @stability stable
     */
    set maxEntries(value: number);
    /**
     * @stability stable
     */
    get maxEntriesInput(): number;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get version(): number;
    private _entry?;
    /**
     * @stability stable
     */
    get entry(): Ec2ManagedPrefixListEntry[];
    /**
     * @stability stable
     */
    set entry(value: Ec2ManagedPrefixListEntry[]);
    /**
     * @stability stable
     */
    resetEntry(): void;
    /**
     * @stability stable
     */
    get entryInput(): Ec2ManagedPrefixListEntry[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
