import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2TrafficMirrorFilterRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly destinationCidrBlock: string;
    /**
     * @stability stable
     */
    readonly protocol?: number;
    /**
     * @stability stable
     */
    readonly ruleAction: string;
    /**
     * @stability stable
     */
    readonly ruleNumber: number;
    /**
     * @stability stable
     */
    readonly sourceCidrBlock: string;
    /**
     * @stability stable
     */
    readonly trafficDirection: string;
    /**
     * @stability stable
     */
    readonly trafficMirrorFilterId: string;
    /**
     * destination_port_range block.
     *
     * @stability stable
     */
    readonly destinationPortRange?: Ec2TrafficMirrorFilterRuleDestinationPortRange[];
    /**
     * source_port_range block.
     *
     * @stability stable
     */
    readonly sourcePortRange?: Ec2TrafficMirrorFilterRuleSourcePortRange[];
}
/**
 * @stability stable
 */
export interface Ec2TrafficMirrorFilterRuleDestinationPortRange {
    /**
     * @stability stable
     */
    readonly fromPort?: number;
    /**
     * @stability stable
     */
    readonly toPort?: number;
}
/**
 * @stability stable
 */
export interface Ec2TrafficMirrorFilterRuleSourcePortRange {
    /**
     * @stability stable
     */
    readonly fromPort?: number;
    /**
     * @stability stable
     */
    readonly toPort?: number;
}
/**
 * @stability stable
 */
export declare class Ec2TrafficMirrorFilterRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2TrafficMirrorFilterRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _destinationCidrBlock;
    /**
     * @stability stable
     */
    get destinationCidrBlock(): string;
    /**
     * @stability stable
     */
    set destinationCidrBlock(value: string);
    /**
     * @stability stable
     */
    get destinationCidrBlockInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _protocol?;
    /**
     * @stability stable
     */
    get protocol(): number;
    /**
     * @stability stable
     */
    set protocol(value: number);
    /**
     * @stability stable
     */
    resetProtocol(): void;
    /**
     * @stability stable
     */
    get protocolInput(): number | undefined;
    private _ruleAction;
    /**
     * @stability stable
     */
    get ruleAction(): string;
    /**
     * @stability stable
     */
    set ruleAction(value: string);
    /**
     * @stability stable
     */
    get ruleActionInput(): string;
    private _ruleNumber;
    /**
     * @stability stable
     */
    get ruleNumber(): number;
    /**
     * @stability stable
     */
    set ruleNumber(value: number);
    /**
     * @stability stable
     */
    get ruleNumberInput(): number;
    private _sourceCidrBlock;
    /**
     * @stability stable
     */
    get sourceCidrBlock(): string;
    /**
     * @stability stable
     */
    set sourceCidrBlock(value: string);
    /**
     * @stability stable
     */
    get sourceCidrBlockInput(): string;
    private _trafficDirection;
    /**
     * @stability stable
     */
    get trafficDirection(): string;
    /**
     * @stability stable
     */
    set trafficDirection(value: string);
    /**
     * @stability stable
     */
    get trafficDirectionInput(): string;
    private _trafficMirrorFilterId;
    /**
     * @stability stable
     */
    get trafficMirrorFilterId(): string;
    /**
     * @stability stable
     */
    set trafficMirrorFilterId(value: string);
    /**
     * @stability stable
     */
    get trafficMirrorFilterIdInput(): string;
    private _destinationPortRange?;
    /**
     * @stability stable
     */
    get destinationPortRange(): Ec2TrafficMirrorFilterRuleDestinationPortRange[];
    /**
     * @stability stable
     */
    set destinationPortRange(value: Ec2TrafficMirrorFilterRuleDestinationPortRange[]);
    /**
     * @stability stable
     */
    resetDestinationPortRange(): void;
    /**
     * @stability stable
     */
    get destinationPortRangeInput(): Ec2TrafficMirrorFilterRuleDestinationPortRange[] | undefined;
    private _sourcePortRange?;
    /**
     * @stability stable
     */
    get sourcePortRange(): Ec2TrafficMirrorFilterRuleSourcePortRange[];
    /**
     * @stability stable
     */
    set sourcePortRange(value: Ec2TrafficMirrorFilterRuleSourcePortRange[]);
    /**
     * @stability stable
     */
    resetSourcePortRange(): void;
    /**
     * @stability stable
     */
    get sourcePortRangeInput(): Ec2TrafficMirrorFilterRuleSourcePortRange[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
