import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2TrafficMirrorSessionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly networkInterfaceId: string;
    /**
     * @stability stable
     */
    readonly packetLength?: number;
    /**
     * @stability stable
     */
    readonly sessionNumber: number;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly trafficMirrorFilterId: string;
    /**
     * @stability stable
     */
    readonly trafficMirrorTargetId: string;
    /**
     * @stability stable
     */
    readonly virtualNetworkId?: number;
}
/**
 * @stability stable
 */
export declare class Ec2TrafficMirrorSession extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2TrafficMirrorSessionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _networkInterfaceId;
    /**
     * @stability stable
     */
    get networkInterfaceId(): string;
    /**
     * @stability stable
     */
    set networkInterfaceId(value: string);
    /**
     * @stability stable
     */
    get networkInterfaceIdInput(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _packetLength?;
    /**
     * @stability stable
     */
    get packetLength(): number;
    /**
     * @stability stable
     */
    set packetLength(value: number);
    /**
     * @stability stable
     */
    resetPacketLength(): void;
    /**
     * @stability stable
     */
    get packetLengthInput(): number | undefined;
    private _sessionNumber;
    /**
     * @stability stable
     */
    get sessionNumber(): number;
    /**
     * @stability stable
     */
    set sessionNumber(value: number);
    /**
     * @stability stable
     */
    get sessionNumberInput(): number;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _trafficMirrorFilterId;
    /**
     * @stability stable
     */
    get trafficMirrorFilterId(): string;
    /**
     * @stability stable
     */
    set trafficMirrorFilterId(value: string);
    /**
     * @stability stable
     */
    get trafficMirrorFilterIdInput(): string;
    private _trafficMirrorTargetId;
    /**
     * @stability stable
     */
    get trafficMirrorTargetId(): string;
    /**
     * @stability stable
     */
    set trafficMirrorTargetId(value: string);
    /**
     * @stability stable
     */
    get trafficMirrorTargetIdInput(): string;
    private _virtualNetworkId?;
    /**
     * @stability stable
     */
    get virtualNetworkId(): number;
    /**
     * @stability stable
     */
    set virtualNetworkId(value: number);
    /**
     * @stability stable
     */
    resetVirtualNetworkId(): void;
    /**
     * @stability stable
     */
    get virtualNetworkIdInput(): number | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
