import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2TransitGatewayPeeringAttachmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly peerAccountId?: string;
    /**
     * @stability stable
     */
    readonly peerRegion: string;
    /**
     * @stability stable
     */
    readonly peerTransitGatewayId: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly transitGatewayId: string;
}
/**
 * @stability stable
 */
export declare class Ec2TransitGatewayPeeringAttachment extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2TransitGatewayPeeringAttachmentConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _peerAccountId?;
    /**
     * @stability stable
     */
    get peerAccountId(): string;
    /**
     * @stability stable
     */
    set peerAccountId(value: string);
    /**
     * @stability stable
     */
    resetPeerAccountId(): void;
    /**
     * @stability stable
     */
    get peerAccountIdInput(): string | undefined;
    private _peerRegion;
    /**
     * @stability stable
     */
    get peerRegion(): string;
    /**
     * @stability stable
     */
    set peerRegion(value: string);
    /**
     * @stability stable
     */
    get peerRegionInput(): string;
    private _peerTransitGatewayId;
    /**
     * @stability stable
     */
    get peerTransitGatewayId(): string;
    /**
     * @stability stable
     */
    set peerTransitGatewayId(value: string);
    /**
     * @stability stable
     */
    get peerTransitGatewayIdInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _transitGatewayId;
    /**
     * @stability stable
     */
    get transitGatewayId(): string;
    /**
     * @stability stable
     */
    set transitGatewayId(value: string);
    /**
     * @stability stable
     */
    get transitGatewayIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
