import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2TransitGatewayPrefixListReferenceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly blackhole?: boolean;
    /**
     * @stability stable
     */
    readonly prefixListId: string;
    /**
     * @stability stable
     */
    readonly transitGatewayAttachmentId?: string;
    /**
     * @stability stable
     */
    readonly transitGatewayRouteTableId: string;
}
/**
 * @stability stable
 */
export declare class Ec2TransitGatewayPrefixListReference extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2TransitGatewayPrefixListReferenceConfig);
    private _blackhole?;
    /**
     * @stability stable
     */
    get blackhole(): boolean;
    /**
     * @stability stable
     */
    set blackhole(value: boolean);
    /**
     * @stability stable
     */
    resetBlackhole(): void;
    /**
     * @stability stable
     */
    get blackholeInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _prefixListId;
    /**
     * @stability stable
     */
    get prefixListId(): string;
    /**
     * @stability stable
     */
    set prefixListId(value: string);
    /**
     * @stability stable
     */
    get prefixListIdInput(): string;
    /**
     * @stability stable
     */
    get prefixListOwnerId(): string;
    private _transitGatewayAttachmentId?;
    /**
     * @stability stable
     */
    get transitGatewayAttachmentId(): string;
    /**
     * @stability stable
     */
    set transitGatewayAttachmentId(value: string);
    /**
     * @stability stable
     */
    resetTransitGatewayAttachmentId(): void;
    /**
     * @stability stable
     */
    get transitGatewayAttachmentIdInput(): string | undefined;
    private _transitGatewayRouteTableId;
    /**
     * @stability stable
     */
    get transitGatewayRouteTableId(): string;
    /**
     * @stability stable
     */
    set transitGatewayRouteTableId(value: string);
    /**
     * @stability stable
     */
    get transitGatewayRouteTableIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
