import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2TransitGatewayRouteConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly blackhole?: boolean;
    /**
     * @stability stable
     */
    readonly destinationCidrBlock: string;
    /**
     * @stability stable
     */
    readonly transitGatewayAttachmentId?: string;
    /**
     * @stability stable
     */
    readonly transitGatewayRouteTableId: string;
}
/**
 * @stability stable
 */
export declare class Ec2TransitGatewayRoute extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2TransitGatewayRouteConfig);
    private _blackhole?;
    /**
     * @stability stable
     */
    get blackhole(): boolean;
    /**
     * @stability stable
     */
    set blackhole(value: boolean);
    /**
     * @stability stable
     */
    resetBlackhole(): void;
    /**
     * @stability stable
     */
    get blackholeInput(): boolean | undefined;
    private _destinationCidrBlock;
    /**
     * @stability stable
     */
    get destinationCidrBlock(): string;
    /**
     * @stability stable
     */
    set destinationCidrBlock(value: string);
    /**
     * @stability stable
     */
    get destinationCidrBlockInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _transitGatewayAttachmentId?;
    /**
     * @stability stable
     */
    get transitGatewayAttachmentId(): string;
    /**
     * @stability stable
     */
    set transitGatewayAttachmentId(value: string);
    /**
     * @stability stable
     */
    resetTransitGatewayAttachmentId(): void;
    /**
     * @stability stable
     */
    get transitGatewayAttachmentIdInput(): string | undefined;
    private _transitGatewayRouteTableId;
    /**
     * @stability stable
     */
    get transitGatewayRouteTableId(): string;
    /**
     * @stability stable
     */
    set transitGatewayRouteTableId(value: string);
    /**
     * @stability stable
     */
    get transitGatewayRouteTableIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
