import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2TransitGatewayVpcAttachmentAccepterConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly transitGatewayAttachmentId: string;
    /**
     * @stability stable
     */
    readonly transitGatewayDefaultRouteTableAssociation?: boolean;
    /**
     * @stability stable
     */
    readonly transitGatewayDefaultRouteTablePropagation?: boolean;
}
/**
 * @stability stable
 */
export declare class Ec2TransitGatewayVpcAttachmentAccepter extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2TransitGatewayVpcAttachmentAccepterConfig);
    /**
     * @stability stable
     */
    get applianceModeSupport(): string;
    /**
     * @stability stable
     */
    get dnsSupport(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ipv6Support(): string;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _transitGatewayAttachmentId;
    /**
     * @stability stable
     */
    get transitGatewayAttachmentId(): string;
    /**
     * @stability stable
     */
    set transitGatewayAttachmentId(value: string);
    /**
     * @stability stable
     */
    get transitGatewayAttachmentIdInput(): string;
    private _transitGatewayDefaultRouteTableAssociation?;
    /**
     * @stability stable
     */
    get transitGatewayDefaultRouteTableAssociation(): boolean;
    /**
     * @stability stable
     */
    set transitGatewayDefaultRouteTableAssociation(value: boolean);
    /**
     * @stability stable
     */
    resetTransitGatewayDefaultRouteTableAssociation(): void;
    /**
     * @stability stable
     */
    get transitGatewayDefaultRouteTableAssociationInput(): boolean | undefined;
    private _transitGatewayDefaultRouteTablePropagation?;
    /**
     * @stability stable
     */
    get transitGatewayDefaultRouteTablePropagation(): boolean;
    /**
     * @stability stable
     */
    set transitGatewayDefaultRouteTablePropagation(value: boolean);
    /**
     * @stability stable
     */
    resetTransitGatewayDefaultRouteTablePropagation(): void;
    /**
     * @stability stable
     */
    get transitGatewayDefaultRouteTablePropagationInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get transitGatewayId(): string;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    get vpcOwnerId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
