import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2TransitGatewayVpcAttachmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly applianceModeSupport?: string;
    /**
     * @stability stable
     */
    readonly dnsSupport?: string;
    /**
     * @stability stable
     */
    readonly ipv6Support?: string;
    /**
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly transitGatewayDefaultRouteTableAssociation?: boolean;
    /**
     * @stability stable
     */
    readonly transitGatewayDefaultRouteTablePropagation?: boolean;
    /**
     * @stability stable
     */
    readonly transitGatewayId: string;
    /**
     * @stability stable
     */
    readonly vpcId: string;
}
/**
 * @stability stable
 */
export declare class Ec2TransitGatewayVpcAttachment extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2TransitGatewayVpcAttachmentConfig);
    private _applianceModeSupport?;
    /**
     * @stability stable
     */
    get applianceModeSupport(): string;
    /**
     * @stability stable
     */
    set applianceModeSupport(value: string);
    /**
     * @stability stable
     */
    resetApplianceModeSupport(): void;
    /**
     * @stability stable
     */
    get applianceModeSupportInput(): string | undefined;
    private _dnsSupport?;
    /**
     * @stability stable
     */
    get dnsSupport(): string;
    /**
     * @stability stable
     */
    set dnsSupport(value: string);
    /**
     * @stability stable
     */
    resetDnsSupport(): void;
    /**
     * @stability stable
     */
    get dnsSupportInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _ipv6Support?;
    /**
     * @stability stable
     */
    get ipv6Support(): string;
    /**
     * @stability stable
     */
    set ipv6Support(value: string);
    /**
     * @stability stable
     */
    resetIpv6Support(): void;
    /**
     * @stability stable
     */
    get ipv6SupportInput(): string | undefined;
    private _subnetIds;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _transitGatewayDefaultRouteTableAssociation?;
    /**
     * @stability stable
     */
    get transitGatewayDefaultRouteTableAssociation(): boolean;
    /**
     * @stability stable
     */
    set transitGatewayDefaultRouteTableAssociation(value: boolean);
    /**
     * @stability stable
     */
    resetTransitGatewayDefaultRouteTableAssociation(): void;
    /**
     * @stability stable
     */
    get transitGatewayDefaultRouteTableAssociationInput(): boolean | undefined;
    private _transitGatewayDefaultRouteTablePropagation?;
    /**
     * @stability stable
     */
    get transitGatewayDefaultRouteTablePropagation(): boolean;
    /**
     * @stability stable
     */
    set transitGatewayDefaultRouteTablePropagation(value: boolean);
    /**
     * @stability stable
     */
    resetTransitGatewayDefaultRouteTablePropagation(): void;
    /**
     * @stability stable
     */
    get transitGatewayDefaultRouteTablePropagationInput(): boolean | undefined;
    private _transitGatewayId;
    /**
     * @stability stable
     */
    get transitGatewayId(): string;
    /**
     * @stability stable
     */
    set transitGatewayId(value: string);
    /**
     * @stability stable
     */
    get transitGatewayIdInput(): string;
    private _vpcId;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string;
    /**
     * @stability stable
     */
    get vpcOwnerId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
