import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2TransitGatewayConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly amazonSideAsn?: number;
    /**
     * @stability stable
     */
    readonly autoAcceptSharedAttachments?: string;
    /**
     * @stability stable
     */
    readonly defaultRouteTableAssociation?: string;
    /**
     * @stability stable
     */
    readonly defaultRouteTablePropagation?: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly dnsSupport?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpnEcmpSupport?: string;
}
/**
 * @stability stable
 */
export declare class Ec2TransitGateway extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: Ec2TransitGatewayConfig);
    private _amazonSideAsn?;
    /**
     * @stability stable
     */
    get amazonSideAsn(): number;
    /**
     * @stability stable
     */
    set amazonSideAsn(value: number);
    /**
     * @stability stable
     */
    resetAmazonSideAsn(): void;
    /**
     * @stability stable
     */
    get amazonSideAsnInput(): number | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get associationDefaultRouteTableId(): string;
    private _autoAcceptSharedAttachments?;
    /**
     * @stability stable
     */
    get autoAcceptSharedAttachments(): string;
    /**
     * @stability stable
     */
    set autoAcceptSharedAttachments(value: string);
    /**
     * @stability stable
     */
    resetAutoAcceptSharedAttachments(): void;
    /**
     * @stability stable
     */
    get autoAcceptSharedAttachmentsInput(): string | undefined;
    private _defaultRouteTableAssociation?;
    /**
     * @stability stable
     */
    get defaultRouteTableAssociation(): string;
    /**
     * @stability stable
     */
    set defaultRouteTableAssociation(value: string);
    /**
     * @stability stable
     */
    resetDefaultRouteTableAssociation(): void;
    /**
     * @stability stable
     */
    get defaultRouteTableAssociationInput(): string | undefined;
    private _defaultRouteTablePropagation?;
    /**
     * @stability stable
     */
    get defaultRouteTablePropagation(): string;
    /**
     * @stability stable
     */
    set defaultRouteTablePropagation(value: string);
    /**
     * @stability stable
     */
    resetDefaultRouteTablePropagation(): void;
    /**
     * @stability stable
     */
    get defaultRouteTablePropagationInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _dnsSupport?;
    /**
     * @stability stable
     */
    get dnsSupport(): string;
    /**
     * @stability stable
     */
    set dnsSupport(value: string);
    /**
     * @stability stable
     */
    resetDnsSupport(): void;
    /**
     * @stability stable
     */
    get dnsSupportInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    get propagationDefaultRouteTableId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpnEcmpSupport?;
    /**
     * @stability stable
     */
    get vpnEcmpSupport(): string;
    /**
     * @stability stable
     */
    set vpnEcmpSupport(value: string);
    /**
     * @stability stable
     */
    resetVpnEcmpSupport(): void;
    /**
     * @stability stable
     */
    get vpnEcmpSupportInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
