import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EcrpublicRepositoryConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly forceDestroy?: boolean;
    /**
     * @stability stable
     */
    readonly repositoryName: string;
    /**
     * catalog_data block.
     *
     * @stability stable
     */
    readonly catalogData?: EcrpublicRepositoryCatalogData[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: EcrpublicRepositoryTimeouts;
}
/**
 * @stability stable
 */
export interface EcrpublicRepositoryCatalogData {
    /**
     * @stability stable
     */
    readonly aboutText?: string;
    /**
     * @stability stable
     */
    readonly architectures?: string[];
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly logoImageBlob?: string;
    /**
     * @stability stable
     */
    readonly operatingSystems?: string[];
    /**
     * @stability stable
     */
    readonly usageText?: string;
}
/**
 * @stability stable
 */
export interface EcrpublicRepositoryTimeouts {
    /**
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export declare class EcrpublicRepository extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EcrpublicRepositoryConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _forceDestroy?;
    /**
     * @stability stable
     */
    get forceDestroy(): boolean;
    /**
     * @stability stable
     */
    set forceDestroy(value: boolean);
    /**
     * @stability stable
     */
    resetForceDestroy(): void;
    /**
     * @stability stable
     */
    get forceDestroyInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get registryId(): string;
    private _repositoryName;
    /**
     * @stability stable
     */
    get repositoryName(): string;
    /**
     * @stability stable
     */
    set repositoryName(value: string);
    /**
     * @stability stable
     */
    get repositoryNameInput(): string;
    /**
     * @stability stable
     */
    get repositoryUri(): string;
    private _catalogData?;
    /**
     * @stability stable
     */
    get catalogData(): EcrpublicRepositoryCatalogData[];
    /**
     * @stability stable
     */
    set catalogData(value: EcrpublicRepositoryCatalogData[]);
    /**
     * @stability stable
     */
    resetCatalogData(): void;
    /**
     * @stability stable
     */
    get catalogDataInput(): EcrpublicRepositoryCatalogData[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): EcrpublicRepositoryTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: EcrpublicRepositoryTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): EcrpublicRepositoryTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
