import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EcsCapacityProviderConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * auto_scaling_group_provider block.
     *
     * @stability stable
     */
    readonly autoScalingGroupProvider: EcsCapacityProviderAutoScalingGroupProvider[];
}
/**
 * @stability stable
 */
export interface EcsCapacityProviderAutoScalingGroupProviderManagedScaling {
    /**
     * @stability stable
     */
    readonly instanceWarmupPeriod?: number;
    /**
     * @stability stable
     */
    readonly maximumScalingStepSize?: number;
    /**
     * @stability stable
     */
    readonly minimumScalingStepSize?: number;
    /**
     * @stability stable
     */
    readonly status?: string;
    /**
     * @stability stable
     */
    readonly targetCapacity?: number;
}
/**
 * @stability stable
 */
export interface EcsCapacityProviderAutoScalingGroupProvider {
    /**
     * @stability stable
     */
    readonly autoScalingGroupArn: string;
    /**
     * @stability stable
     */
    readonly managedTerminationProtection?: string;
    /**
     * managed_scaling block.
     *
     * @stability stable
     */
    readonly managedScaling?: EcsCapacityProviderAutoScalingGroupProviderManagedScaling[];
}
/**
 * @stability stable
 */
export declare class EcsCapacityProvider extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EcsCapacityProviderConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _autoScalingGroupProvider;
    /**
     * @stability stable
     */
    get autoScalingGroupProvider(): EcsCapacityProviderAutoScalingGroupProvider[];
    /**
     * @stability stable
     */
    set autoScalingGroupProvider(value: EcsCapacityProviderAutoScalingGroupProvider[]);
    /**
     * @stability stable
     */
    get autoScalingGroupProviderInput(): EcsCapacityProviderAutoScalingGroupProvider[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
