import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EfsAccessPointConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly fileSystemId: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * posix_user block.
     *
     * @stability stable
     */
    readonly posixUser?: EfsAccessPointPosixUser[];
    /**
     * root_directory block.
     *
     * @stability stable
     */
    readonly rootDirectory?: EfsAccessPointRootDirectory[];
}
/**
 * @stability stable
 */
export interface EfsAccessPointPosixUser {
    /**
     * @stability stable
     */
    readonly gid: number;
    /**
     * @stability stable
     */
    readonly secondaryGids?: number[];
    /**
     * @stability stable
     */
    readonly uid: number;
}
/**
 * @stability stable
 */
export interface EfsAccessPointRootDirectoryCreationInfo {
    /**
     * @stability stable
     */
    readonly ownerGid: number;
    /**
     * @stability stable
     */
    readonly ownerUid: number;
    /**
     * @stability stable
     */
    readonly permissions: string;
}
/**
 * @stability stable
 */
export interface EfsAccessPointRootDirectory {
    /**
     * @stability stable
     */
    readonly path?: string;
    /**
     * creation_info block.
     *
     * @stability stable
     */
    readonly creationInfo?: EfsAccessPointRootDirectoryCreationInfo[];
}
/**
 * @stability stable
 */
export declare class EfsAccessPoint extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EfsAccessPointConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get fileSystemArn(): string;
    private _fileSystemId;
    /**
     * @stability stable
     */
    get fileSystemId(): string;
    /**
     * @stability stable
     */
    set fileSystemId(value: string);
    /**
     * @stability stable
     */
    get fileSystemIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _posixUser?;
    /**
     * @stability stable
     */
    get posixUser(): EfsAccessPointPosixUser[];
    /**
     * @stability stable
     */
    set posixUser(value: EfsAccessPointPosixUser[]);
    /**
     * @stability stable
     */
    resetPosixUser(): void;
    /**
     * @stability stable
     */
    get posixUserInput(): EfsAccessPointPosixUser[] | undefined;
    private _rootDirectory?;
    /**
     * @stability stable
     */
    get rootDirectory(): EfsAccessPointRootDirectory[];
    /**
     * @stability stable
     */
    set rootDirectory(value: EfsAccessPointRootDirectory[]);
    /**
     * @stability stable
     */
    resetRootDirectory(): void;
    /**
     * @stability stable
     */
    get rootDirectoryInput(): EfsAccessPointRootDirectory[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
