import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EfsFileSystemConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly creationToken?: string;
    /**
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly performanceMode?: string;
    /**
     * @stability stable
     */
    readonly provisionedThroughputInMibps?: number;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly throughputMode?: string;
    /**
     * lifecycle_policy block.
     *
     * @stability stable
     */
    readonly lifecyclePolicy?: EfsFileSystemLifecyclePolicy[];
}
/**
 * @stability stable
 */
export interface EfsFileSystemLifecyclePolicy {
    /**
     * @stability stable
     */
    readonly transitionToIa: string;
}
/**
 * @stability stable
 */
export declare class EfsFileSystem extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: EfsFileSystemConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _creationToken?;
    /**
     * @stability stable
     */
    get creationToken(): string;
    /**
     * @stability stable
     */
    set creationToken(value: string);
    /**
     * @stability stable
     */
    resetCreationToken(): void;
    /**
     * @stability stable
     */
    get creationTokenInput(): string | undefined;
    /**
     * @stability stable
     */
    get dnsName(): string;
    private _encrypted?;
    /**
     * @stability stable
     */
    get encrypted(): boolean;
    /**
     * @stability stable
     */
    set encrypted(value: boolean);
    /**
     * @stability stable
     */
    resetEncrypted(): void;
    /**
     * @stability stable
     */
    get encryptedInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    private _performanceMode?;
    /**
     * @stability stable
     */
    get performanceMode(): string;
    /**
     * @stability stable
     */
    set performanceMode(value: string);
    /**
     * @stability stable
     */
    resetPerformanceMode(): void;
    /**
     * @stability stable
     */
    get performanceModeInput(): string | undefined;
    private _provisionedThroughputInMibps?;
    /**
     * @stability stable
     */
    get provisionedThroughputInMibps(): number;
    /**
     * @stability stable
     */
    set provisionedThroughputInMibps(value: number);
    /**
     * @stability stable
     */
    resetProvisionedThroughputInMibps(): void;
    /**
     * @stability stable
     */
    get provisionedThroughputInMibpsInput(): number | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _throughputMode?;
    /**
     * @stability stable
     */
    get throughputMode(): string;
    /**
     * @stability stable
     */
    set throughputMode(value: string);
    /**
     * @stability stable
     */
    resetThroughputMode(): void;
    /**
     * @stability stable
     */
    get throughputModeInput(): string | undefined;
    private _lifecyclePolicy?;
    /**
     * @stability stable
     */
    get lifecyclePolicy(): EfsFileSystemLifecyclePolicy[];
    /**
     * @stability stable
     */
    set lifecyclePolicy(value: EfsFileSystemLifecyclePolicy[]);
    /**
     * @stability stable
     */
    resetLifecyclePolicy(): void;
    /**
     * @stability stable
     */
    get lifecyclePolicyInput(): EfsFileSystemLifecyclePolicy[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
