import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EipAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly allocationId?: string;
    /**
     * @stability stable
     */
    readonly allowReassociation?: boolean;
    /**
     * @stability stable
     */
    readonly instanceId?: string;
    /**
     * @stability stable
     */
    readonly networkInterfaceId?: string;
    /**
     * @stability stable
     */
    readonly privateIpAddress?: string;
    /**
     * @stability stable
     */
    readonly publicIp?: string;
}
/**
 * @stability stable
 */
export declare class EipAssociation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: EipAssociationConfig);
    private _allocationId?;
    /**
     * @stability stable
     */
    get allocationId(): string;
    /**
     * @stability stable
     */
    set allocationId(value: string);
    /**
     * @stability stable
     */
    resetAllocationId(): void;
    /**
     * @stability stable
     */
    get allocationIdInput(): string | undefined;
    private _allowReassociation?;
    /**
     * @stability stable
     */
    get allowReassociation(): boolean;
    /**
     * @stability stable
     */
    set allowReassociation(value: boolean);
    /**
     * @stability stable
     */
    resetAllowReassociation(): void;
    /**
     * @stability stable
     */
    get allowReassociationInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceId?;
    /**
     * @stability stable
     */
    get instanceId(): string;
    /**
     * @stability stable
     */
    set instanceId(value: string);
    /**
     * @stability stable
     */
    resetInstanceId(): void;
    /**
     * @stability stable
     */
    get instanceIdInput(): string | undefined;
    private _networkInterfaceId?;
    /**
     * @stability stable
     */
    get networkInterfaceId(): string;
    /**
     * @stability stable
     */
    set networkInterfaceId(value: string);
    /**
     * @stability stable
     */
    resetNetworkInterfaceId(): void;
    /**
     * @stability stable
     */
    get networkInterfaceIdInput(): string | undefined;
    private _privateIpAddress?;
    /**
     * @stability stable
     */
    get privateIpAddress(): string;
    /**
     * @stability stable
     */
    set privateIpAddress(value: string);
    /**
     * @stability stable
     */
    resetPrivateIpAddress(): void;
    /**
     * @stability stable
     */
    get privateIpAddressInput(): string | undefined;
    private _publicIp?;
    /**
     * @stability stable
     */
    get publicIp(): string;
    /**
     * @stability stable
     */
    set publicIp(value: string);
    /**
     * @stability stable
     */
    resetPublicIp(): void;
    /**
     * @stability stable
     */
    get publicIpInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
