import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EipConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly associateWithPrivateIp?: string;
    /**
     * @stability stable
     */
    readonly customerOwnedIpv4Pool?: string;
    /**
     * @stability stable
     */
    readonly instance?: string;
    /**
     * @stability stable
     */
    readonly networkBorderGroup?: string;
    /**
     * @stability stable
     */
    readonly networkInterface?: string;
    /**
     * @stability stable
     */
    readonly publicIpv4Pool?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpc?: boolean;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: EipTimeouts;
}
/**
 * @stability stable
 */
export interface EipTimeouts {
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly read?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class Eip extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: EipConfig);
    /**
     * @stability stable
     */
    get allocationId(): string;
    private _associateWithPrivateIp?;
    /**
     * @stability stable
     */
    get associateWithPrivateIp(): string;
    /**
     * @stability stable
     */
    set associateWithPrivateIp(value: string);
    /**
     * @stability stable
     */
    resetAssociateWithPrivateIp(): void;
    /**
     * @stability stable
     */
    get associateWithPrivateIpInput(): string | undefined;
    /**
     * @stability stable
     */
    get associationId(): string;
    /**
     * @stability stable
     */
    get carrierIp(): string;
    /**
     * @stability stable
     */
    get customerOwnedIp(): string;
    private _customerOwnedIpv4Pool?;
    /**
     * @stability stable
     */
    get customerOwnedIpv4Pool(): string;
    /**
     * @stability stable
     */
    set customerOwnedIpv4Pool(value: string);
    /**
     * @stability stable
     */
    resetCustomerOwnedIpv4Pool(): void;
    /**
     * @stability stable
     */
    get customerOwnedIpv4PoolInput(): string | undefined;
    /**
     * @stability stable
     */
    get domain(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _instance?;
    /**
     * @stability stable
     */
    get instance(): string;
    /**
     * @stability stable
     */
    set instance(value: string);
    /**
     * @stability stable
     */
    resetInstance(): void;
    /**
     * @stability stable
     */
    get instanceInput(): string | undefined;
    private _networkBorderGroup?;
    /**
     * @stability stable
     */
    get networkBorderGroup(): string;
    /**
     * @stability stable
     */
    set networkBorderGroup(value: string);
    /**
     * @stability stable
     */
    resetNetworkBorderGroup(): void;
    /**
     * @stability stable
     */
    get networkBorderGroupInput(): string | undefined;
    private _networkInterface?;
    /**
     * @stability stable
     */
    get networkInterface(): string;
    /**
     * @stability stable
     */
    set networkInterface(value: string);
    /**
     * @stability stable
     */
    resetNetworkInterface(): void;
    /**
     * @stability stable
     */
    get networkInterfaceInput(): string | undefined;
    /**
     * @stability stable
     */
    get privateDns(): string;
    /**
     * @stability stable
     */
    get privateIp(): string;
    /**
     * @stability stable
     */
    get publicDns(): string;
    /**
     * @stability stable
     */
    get publicIp(): string;
    private _publicIpv4Pool?;
    /**
     * @stability stable
     */
    get publicIpv4Pool(): string;
    /**
     * @stability stable
     */
    set publicIpv4Pool(value: string);
    /**
     * @stability stable
     */
    resetPublicIpv4Pool(): void;
    /**
     * @stability stable
     */
    get publicIpv4PoolInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpc?;
    /**
     * @stability stable
     */
    get vpc(): boolean;
    /**
     * @stability stable
     */
    set vpc(value: boolean);
    /**
     * @stability stable
     */
    resetVpc(): void;
    /**
     * @stability stable
     */
    get vpcInput(): boolean | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): EipTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: EipTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): EipTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
