import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EksFargateProfileConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly clusterName: string;
    /**
     * @stability stable
     */
    readonly fargateProfileName: string;
    /**
     * @stability stable
     */
    readonly podExecutionRoleArn: string;
    /**
     * @stability stable
     */
    readonly subnetIds?: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * selector block.
     *
     * @stability stable
     */
    readonly selector: EksFargateProfileSelector[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: EksFargateProfileTimeouts;
}
/**
 * @stability stable
 */
export interface EksFargateProfileSelector {
    /**
     * @stability stable
     */
    readonly labels?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly namespace: string;
}
/**
 * @stability stable
 */
export interface EksFargateProfileTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export declare class EksFargateProfile extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EksFargateProfileConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _clusterName;
    /**
     * @stability stable
     */
    get clusterName(): string;
    /**
     * @stability stable
     */
    set clusterName(value: string);
    /**
     * @stability stable
     */
    get clusterNameInput(): string;
    private _fargateProfileName;
    /**
     * @stability stable
     */
    get fargateProfileName(): string;
    /**
     * @stability stable
     */
    set fargateProfileName(value: string);
    /**
     * @stability stable
     */
    get fargateProfileNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _podExecutionRoleArn;
    /**
     * @stability stable
     */
    get podExecutionRoleArn(): string;
    /**
     * @stability stable
     */
    set podExecutionRoleArn(value: string);
    /**
     * @stability stable
     */
    get podExecutionRoleArnInput(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _subnetIds?;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    resetSubnetIds(): void;
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _selector;
    /**
     * @stability stable
     */
    get selector(): EksFargateProfileSelector[];
    /**
     * @stability stable
     */
    set selector(value: EksFargateProfileSelector[]);
    /**
     * @stability stable
     */
    get selectorInput(): EksFargateProfileSelector[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): EksFargateProfileTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: EksFargateProfileTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): EksFargateProfileTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
