import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EksNodeGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly amiType?: string;
    /**
     * @stability stable
     */
    readonly capacityType?: string;
    /**
     * @stability stable
     */
    readonly clusterName: string;
    /**
     * @stability stable
     */
    readonly diskSize?: number;
    /**
     * @stability stable
     */
    readonly forceUpdateVersion?: boolean;
    /**
     * @stability stable
     */
    readonly instanceTypes?: string[];
    /**
     * @stability stable
     */
    readonly labels?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly nodeGroupName: string;
    /**
     * @stability stable
     */
    readonly nodeRoleArn: string;
    /**
     * @stability stable
     */
    readonly releaseVersion?: string;
    /**
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly version?: string;
    /**
     * launch_template block.
     *
     * @stability stable
     */
    readonly launchTemplate?: EksNodeGroupLaunchTemplate[];
    /**
     * remote_access block.
     *
     * @stability stable
     */
    readonly remoteAccess?: EksNodeGroupRemoteAccess[];
    /**
     * scaling_config block.
     *
     * @stability stable
     */
    readonly scalingConfig: EksNodeGroupScalingConfig[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: EksNodeGroupTimeouts;
}
/**
 * @stability stable
 */
export declare class EksNodeGroupResourcesAutoscalingGroups extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get name(): string;
}
/**
 * @stability stable
 */
export declare class EksNodeGroupResources extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get autoscalingGroups(): any;
    /**
     * @stability stable
     */
    get remoteAccessSecurityGroupId(): string;
}
/**
 * @stability stable
 */
export interface EksNodeGroupLaunchTemplate {
    /**
     * @stability stable
     */
    readonly id?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly version: string;
}
/**
 * @stability stable
 */
export interface EksNodeGroupRemoteAccess {
    /**
     * @stability stable
     */
    readonly ec2SshKey?: string;
    /**
     * @stability stable
     */
    readonly sourceSecurityGroupIds?: string[];
}
/**
 * @stability stable
 */
export interface EksNodeGroupScalingConfig {
    /**
     * @stability stable
     */
    readonly desiredSize: number;
    /**
     * @stability stable
     */
    readonly maxSize: number;
    /**
     * @stability stable
     */
    readonly minSize: number;
}
/**
 * @stability stable
 */
export interface EksNodeGroupTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class EksNodeGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EksNodeGroupConfig);
    private _amiType?;
    /**
     * @stability stable
     */
    get amiType(): string;
    /**
     * @stability stable
     */
    set amiType(value: string);
    /**
     * @stability stable
     */
    resetAmiType(): void;
    /**
     * @stability stable
     */
    get amiTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _capacityType?;
    /**
     * @stability stable
     */
    get capacityType(): string;
    /**
     * @stability stable
     */
    set capacityType(value: string);
    /**
     * @stability stable
     */
    resetCapacityType(): void;
    /**
     * @stability stable
     */
    get capacityTypeInput(): string | undefined;
    private _clusterName;
    /**
     * @stability stable
     */
    get clusterName(): string;
    /**
     * @stability stable
     */
    set clusterName(value: string);
    /**
     * @stability stable
     */
    get clusterNameInput(): string;
    private _diskSize?;
    /**
     * @stability stable
     */
    get diskSize(): number;
    /**
     * @stability stable
     */
    set diskSize(value: number);
    /**
     * @stability stable
     */
    resetDiskSize(): void;
    /**
     * @stability stable
     */
    get diskSizeInput(): number | undefined;
    private _forceUpdateVersion?;
    /**
     * @stability stable
     */
    get forceUpdateVersion(): boolean;
    /**
     * @stability stable
     */
    set forceUpdateVersion(value: boolean);
    /**
     * @stability stable
     */
    resetForceUpdateVersion(): void;
    /**
     * @stability stable
     */
    get forceUpdateVersionInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceTypes?;
    /**
     * @stability stable
     */
    get instanceTypes(): string[];
    /**
     * @stability stable
     */
    set instanceTypes(value: string[]);
    /**
     * @stability stable
     */
    resetInstanceTypes(): void;
    /**
     * @stability stable
     */
    get instanceTypesInput(): string[] | undefined;
    private _labels?;
    /**
     * @stability stable
     */
    get labels(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set labels(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetLabels(): void;
    /**
     * @stability stable
     */
    get labelsInput(): {
        [key: string]: string;
    } | undefined;
    private _nodeGroupName;
    /**
     * @stability stable
     */
    get nodeGroupName(): string;
    /**
     * @stability stable
     */
    set nodeGroupName(value: string);
    /**
     * @stability stable
     */
    get nodeGroupNameInput(): string;
    private _nodeRoleArn;
    /**
     * @stability stable
     */
    get nodeRoleArn(): string;
    /**
     * @stability stable
     */
    set nodeRoleArn(value: string);
    /**
     * @stability stable
     */
    get nodeRoleArnInput(): string;
    private _releaseVersion?;
    /**
     * @stability stable
     */
    get releaseVersion(): string;
    /**
     * @stability stable
     */
    set releaseVersion(value: string);
    /**
     * @stability stable
     */
    resetReleaseVersion(): void;
    /**
     * @stability stable
     */
    get releaseVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    resources(index: string): EksNodeGroupResources;
    /**
     * @stability stable
     */
    get status(): string;
    private _subnetIds;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _version?;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    resetVersion(): void;
    /**
     * @stability stable
     */
    get versionInput(): string | undefined;
    private _launchTemplate?;
    /**
     * @stability stable
     */
    get launchTemplate(): EksNodeGroupLaunchTemplate[];
    /**
     * @stability stable
     */
    set launchTemplate(value: EksNodeGroupLaunchTemplate[]);
    /**
     * @stability stable
     */
    resetLaunchTemplate(): void;
    /**
     * @stability stable
     */
    get launchTemplateInput(): EksNodeGroupLaunchTemplate[] | undefined;
    private _remoteAccess?;
    /**
     * @stability stable
     */
    get remoteAccess(): EksNodeGroupRemoteAccess[];
    /**
     * @stability stable
     */
    set remoteAccess(value: EksNodeGroupRemoteAccess[]);
    /**
     * @stability stable
     */
    resetRemoteAccess(): void;
    /**
     * @stability stable
     */
    get remoteAccessInput(): EksNodeGroupRemoteAccess[] | undefined;
    private _scalingConfig;
    /**
     * @stability stable
     */
    get scalingConfig(): EksNodeGroupScalingConfig[];
    /**
     * @stability stable
     */
    set scalingConfig(value: EksNodeGroupScalingConfig[]);
    /**
     * @stability stable
     */
    get scalingConfigInput(): EksNodeGroupScalingConfig[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): EksNodeGroupTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: EksNodeGroupTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): EksNodeGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
