import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ElasticBeanstalkApplicationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * appversion_lifecycle block.
     *
     * @stability stable
     */
    readonly appversionLifecycle?: ElasticBeanstalkApplicationAppversionLifecycle[];
}
/**
 * @stability stable
 */
export interface ElasticBeanstalkApplicationAppversionLifecycle {
    /**
     * @stability stable
     */
    readonly deleteSourceFromS3?: boolean;
    /**
     * @stability stable
     */
    readonly maxAgeInDays?: number;
    /**
     * @stability stable
     */
    readonly maxCount?: number;
    /**
     * @stability stable
     */
    readonly serviceRole: string;
}
/**
 * @stability stable
 */
export declare class ElasticBeanstalkApplication extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElasticBeanstalkApplicationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _appversionLifecycle?;
    /**
     * @stability stable
     */
    get appversionLifecycle(): ElasticBeanstalkApplicationAppversionLifecycle[];
    /**
     * @stability stable
     */
    set appversionLifecycle(value: ElasticBeanstalkApplicationAppversionLifecycle[]);
    /**
     * @stability stable
     */
    resetAppversionLifecycle(): void;
    /**
     * @stability stable
     */
    get appversionLifecycleInput(): ElasticBeanstalkApplicationAppversionLifecycle[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
