import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ElasticBeanstalkConfigurationTemplateConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly application: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly environmentId?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly solutionStackName?: string;
    /**
     * setting block.
     *
     * @stability stable
     */
    readonly setting?: ElasticBeanstalkConfigurationTemplateSetting[];
}
/**
 * @stability stable
 */
export interface ElasticBeanstalkConfigurationTemplateSetting {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly namespace: string;
    /**
     * @stability stable
     */
    readonly resource?: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export declare class ElasticBeanstalkConfigurationTemplate extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElasticBeanstalkConfigurationTemplateConfig);
    private _application;
    /**
     * @stability stable
     */
    get application(): string;
    /**
     * @stability stable
     */
    set application(value: string);
    /**
     * @stability stable
     */
    get applicationInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _environmentId?;
    /**
     * @stability stable
     */
    get environmentId(): string;
    /**
     * @stability stable
     */
    set environmentId(value: string);
    /**
     * @stability stable
     */
    resetEnvironmentId(): void;
    /**
     * @stability stable
     */
    get environmentIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _solutionStackName?;
    /**
     * @stability stable
     */
    get solutionStackName(): string;
    /**
     * @stability stable
     */
    set solutionStackName(value: string);
    /**
     * @stability stable
     */
    resetSolutionStackName(): void;
    /**
     * @stability stable
     */
    get solutionStackNameInput(): string | undefined;
    private _setting?;
    /**
     * @stability stable
     */
    get setting(): ElasticBeanstalkConfigurationTemplateSetting[];
    /**
     * @stability stable
     */
    set setting(value: ElasticBeanstalkConfigurationTemplateSetting[]);
    /**
     * @stability stable
     */
    resetSetting(): void;
    /**
     * @stability stable
     */
    get settingInput(): ElasticBeanstalkConfigurationTemplateSetting[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
