import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ElasticBeanstalkEnvironmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly application: string;
    /**
     * @stability stable
     */
    readonly cnamePrefix?: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly platformArn?: string;
    /**
     * @stability stable
     */
    readonly pollInterval?: string;
    /**
     * @stability stable
     */
    readonly solutionStackName?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly templateName?: string;
    /**
     * @stability stable
     */
    readonly tier?: string;
    /**
     * @stability stable
     */
    readonly versionLabel?: string;
    /**
     * @stability stable
     */
    readonly waitForReadyTimeout?: string;
    /**
     * setting block.
     *
     * @stability stable
     */
    readonly setting?: ElasticBeanstalkEnvironmentSetting[];
}
/**
 * @stability stable
 */
export declare class ElasticBeanstalkEnvironmentAllSettings extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get namespace(): string;
    /**
     * @stability stable
     */
    get resource(): string;
    /**
     * @stability stable
     */
    get value(): string;
}
/**
 * @stability stable
 */
export interface ElasticBeanstalkEnvironmentSetting {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly namespace: string;
    /**
     * @stability stable
     */
    readonly resource?: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export declare class ElasticBeanstalkEnvironment extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElasticBeanstalkEnvironmentConfig);
    /**
     * @stability stable
     */
    allSettings(index: string): ElasticBeanstalkEnvironmentAllSettings;
    private _application;
    /**
     * @stability stable
     */
    get application(): string;
    /**
     * @stability stable
     */
    set application(value: string);
    /**
     * @stability stable
     */
    get applicationInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get autoscalingGroups(): string[];
    /**
     * @stability stable
     */
    get cname(): string;
    private _cnamePrefix?;
    /**
     * @stability stable
     */
    get cnamePrefix(): string;
    /**
     * @stability stable
     */
    set cnamePrefix(value: string);
    /**
     * @stability stable
     */
    resetCnamePrefix(): void;
    /**
     * @stability stable
     */
    get cnamePrefixInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get endpointUrl(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get instances(): string[];
    /**
     * @stability stable
     */
    get launchConfigurations(): string[];
    /**
     * @stability stable
     */
    get loadBalancers(): string[];
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _platformArn?;
    /**
     * @stability stable
     */
    get platformArn(): string;
    /**
     * @stability stable
     */
    set platformArn(value: string);
    /**
     * @stability stable
     */
    resetPlatformArn(): void;
    /**
     * @stability stable
     */
    get platformArnInput(): string | undefined;
    private _pollInterval?;
    /**
     * @stability stable
     */
    get pollInterval(): string;
    /**
     * @stability stable
     */
    set pollInterval(value: string);
    /**
     * @stability stable
     */
    resetPollInterval(): void;
    /**
     * @stability stable
     */
    get pollIntervalInput(): string | undefined;
    /**
     * @stability stable
     */
    get queues(): string[];
    private _solutionStackName?;
    /**
     * @stability stable
     */
    get solutionStackName(): string;
    /**
     * @stability stable
     */
    set solutionStackName(value: string);
    /**
     * @stability stable
     */
    resetSolutionStackName(): void;
    /**
     * @stability stable
     */
    get solutionStackNameInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _templateName?;
    /**
     * @stability stable
     */
    get templateName(): string;
    /**
     * @stability stable
     */
    set templateName(value: string);
    /**
     * @stability stable
     */
    resetTemplateName(): void;
    /**
     * @stability stable
     */
    get templateNameInput(): string | undefined;
    private _tier?;
    /**
     * @stability stable
     */
    get tier(): string;
    /**
     * @stability stable
     */
    set tier(value: string);
    /**
     * @stability stable
     */
    resetTier(): void;
    /**
     * @stability stable
     */
    get tierInput(): string | undefined;
    /**
     * @stability stable
     */
    get triggers(): string[];
    private _versionLabel?;
    /**
     * @stability stable
     */
    get versionLabel(): string;
    /**
     * @stability stable
     */
    set versionLabel(value: string);
    /**
     * @stability stable
     */
    resetVersionLabel(): void;
    /**
     * @stability stable
     */
    get versionLabelInput(): string | undefined;
    private _waitForReadyTimeout?;
    /**
     * @stability stable
     */
    get waitForReadyTimeout(): string;
    /**
     * @stability stable
     */
    set waitForReadyTimeout(value: string);
    /**
     * @stability stable
     */
    resetWaitForReadyTimeout(): void;
    /**
     * @stability stable
     */
    get waitForReadyTimeoutInput(): string | undefined;
    private _setting?;
    /**
     * @stability stable
     */
    get setting(): ElasticBeanstalkEnvironmentSetting[];
    /**
     * @stability stable
     */
    set setting(value: ElasticBeanstalkEnvironmentSetting[]);
    /**
     * @stability stable
     */
    resetSetting(): void;
    /**
     * @stability stable
     */
    get settingInput(): ElasticBeanstalkEnvironmentSetting[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
