import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ElasticacheGlobalReplicationGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly globalReplicationGroupDescription?: string;
    /**
     * @stability stable
     */
    readonly globalReplicationGroupIdSuffix: string;
    /**
     * @stability stable
     */
    readonly primaryReplicationGroupId: string;
}
/**
 * @stability stable
 */
export declare class ElasticacheGlobalReplicationGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElasticacheGlobalReplicationGroupConfig);
    /**
     * @stability stable
     */
    get actualEngineVersion(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get atRestEncryptionEnabled(): boolean;
    /**
     * @stability stable
     */
    get authTokenEnabled(): boolean;
    /**
     * @stability stable
     */
    get cacheNodeType(): string;
    /**
     * @stability stable
     */
    get clusterEnabled(): boolean;
    /**
     * @stability stable
     */
    get engine(): string;
    private _globalReplicationGroupDescription?;
    /**
     * @stability stable
     */
    get globalReplicationGroupDescription(): string;
    /**
     * @stability stable
     */
    set globalReplicationGroupDescription(value: string);
    /**
     * @stability stable
     */
    resetGlobalReplicationGroupDescription(): void;
    /**
     * @stability stable
     */
    get globalReplicationGroupDescriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get globalReplicationGroupId(): string;
    private _globalReplicationGroupIdSuffix;
    /**
     * @stability stable
     */
    get globalReplicationGroupIdSuffix(): string;
    /**
     * @stability stable
     */
    set globalReplicationGroupIdSuffix(value: string);
    /**
     * @stability stable
     */
    get globalReplicationGroupIdSuffixInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _primaryReplicationGroupId;
    /**
     * @stability stable
     */
    get primaryReplicationGroupId(): string;
    /**
     * @stability stable
     */
    set primaryReplicationGroupId(value: string);
    /**
     * @stability stable
     */
    get primaryReplicationGroupIdInput(): string;
    /**
     * @stability stable
     */
    get transitEncryptionEnabled(): boolean;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
