import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ElasticacheReplicationGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly applyImmediately?: boolean;
    /**
     * @stability stable
     */
    readonly atRestEncryptionEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly authToken?: string;
    /**
     * @stability stable
     */
    readonly autoMinorVersionUpgrade?: boolean;
    /**
     * @stability stable
     */
    readonly automaticFailoverEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly availabilityZones?: string[];
    /**
     * @stability stable
     */
    readonly engine?: string;
    /**
     * @stability stable
     */
    readonly engineVersion?: string;
    /**
     * @stability stable
     */
    readonly finalSnapshotIdentifier?: string;
    /**
     * @stability stable
     */
    readonly globalReplicationGroupId?: string;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly maintenanceWindow?: string;
    /**
     * @stability stable
     */
    readonly multiAzEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly nodeType?: string;
    /**
     * @stability stable
     */
    readonly notificationTopicArn?: string;
    /**
     * @stability stable
     */
    readonly numberCacheClusters?: number;
    /**
     * @stability stable
     */
    readonly parameterGroupName?: string;
    /**
     * @stability stable
     */
    readonly port?: number;
    /**
     * @stability stable
     */
    readonly replicationGroupDescription: string;
    /**
     * @stability stable
     */
    readonly replicationGroupId: string;
    /**
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * @stability stable
     */
    readonly securityGroupNames?: string[];
    /**
     * @stability stable
     */
    readonly snapshotArns?: string[];
    /**
     * @stability stable
     */
    readonly snapshotName?: string;
    /**
     * @stability stable
     */
    readonly snapshotRetentionLimit?: number;
    /**
     * @stability stable
     */
    readonly snapshotWindow?: string;
    /**
     * @stability stable
     */
    readonly subnetGroupName?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly transitEncryptionEnabled?: boolean;
    /**
     * cluster_mode block.
     *
     * @stability stable
     */
    readonly clusterMode?: ElasticacheReplicationGroupClusterMode[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: ElasticacheReplicationGroupTimeouts;
}
/**
 * @stability stable
 */
export interface ElasticacheReplicationGroupClusterMode {
    /**
     * @stability stable
     */
    readonly numNodeGroups: number;
    /**
     * @stability stable
     */
    readonly replicasPerNodeGroup: number;
}
/**
 * @stability stable
 */
export interface ElasticacheReplicationGroupTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class ElasticacheReplicationGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElasticacheReplicationGroupConfig);
    private _applyImmediately?;
    /**
     * @stability stable
     */
    get applyImmediately(): boolean;
    /**
     * @stability stable
     */
    set applyImmediately(value: boolean);
    /**
     * @stability stable
     */
    resetApplyImmediately(): void;
    /**
     * @stability stable
     */
    get applyImmediatelyInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _atRestEncryptionEnabled?;
    /**
     * @stability stable
     */
    get atRestEncryptionEnabled(): boolean;
    /**
     * @stability stable
     */
    set atRestEncryptionEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetAtRestEncryptionEnabled(): void;
    /**
     * @stability stable
     */
    get atRestEncryptionEnabledInput(): boolean | undefined;
    private _authToken?;
    /**
     * @stability stable
     */
    get authToken(): string;
    /**
     * @stability stable
     */
    set authToken(value: string);
    /**
     * @stability stable
     */
    resetAuthToken(): void;
    /**
     * @stability stable
     */
    get authTokenInput(): string | undefined;
    private _autoMinorVersionUpgrade?;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgrade(): boolean;
    /**
     * @stability stable
     */
    set autoMinorVersionUpgrade(value: boolean);
    /**
     * @stability stable
     */
    resetAutoMinorVersionUpgrade(): void;
    /**
     * @stability stable
     */
    get autoMinorVersionUpgradeInput(): boolean | undefined;
    private _automaticFailoverEnabled?;
    /**
     * @stability stable
     */
    get automaticFailoverEnabled(): boolean;
    /**
     * @stability stable
     */
    set automaticFailoverEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetAutomaticFailoverEnabled(): void;
    /**
     * @stability stable
     */
    get automaticFailoverEnabledInput(): boolean | undefined;
    private _availabilityZones?;
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    /**
     * @stability stable
     */
    set availabilityZones(value: string[]);
    /**
     * @stability stable
     */
    resetAvailabilityZones(): void;
    /**
     * @stability stable
     */
    get availabilityZonesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get clusterEnabled(): boolean;
    /**
     * @stability stable
     */
    get configurationEndpointAddress(): string;
    private _engine?;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    resetEngine(): void;
    /**
     * @stability stable
     */
    get engineInput(): string | undefined;
    private _engineVersion?;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    set engineVersion(value: string);
    /**
     * @stability stable
     */
    resetEngineVersion(): void;
    /**
     * @stability stable
     */
    get engineVersionInput(): string | undefined;
    private _finalSnapshotIdentifier?;
    /**
     * @stability stable
     */
    get finalSnapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set finalSnapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    resetFinalSnapshotIdentifier(): void;
    /**
     * @stability stable
     */
    get finalSnapshotIdentifierInput(): string | undefined;
    private _globalReplicationGroupId?;
    /**
     * @stability stable
     */
    get globalReplicationGroupId(): string;
    /**
     * @stability stable
     */
    set globalReplicationGroupId(value: string);
    /**
     * @stability stable
     */
    resetGlobalReplicationGroupId(): void;
    /**
     * @stability stable
     */
    get globalReplicationGroupIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    private _maintenanceWindow?;
    /**
     * @stability stable
     */
    get maintenanceWindow(): string;
    /**
     * @stability stable
     */
    set maintenanceWindow(value: string);
    /**
     * @stability stable
     */
    resetMaintenanceWindow(): void;
    /**
     * @stability stable
     */
    get maintenanceWindowInput(): string | undefined;
    /**
     * @stability stable
     */
    get memberClusters(): string[];
    private _multiAzEnabled?;
    /**
     * @stability stable
     */
    get multiAzEnabled(): boolean;
    /**
     * @stability stable
     */
    set multiAzEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetMultiAzEnabled(): void;
    /**
     * @stability stable
     */
    get multiAzEnabledInput(): boolean | undefined;
    private _nodeType?;
    /**
     * @stability stable
     */
    get nodeType(): string;
    /**
     * @stability stable
     */
    set nodeType(value: string);
    /**
     * @stability stable
     */
    resetNodeType(): void;
    /**
     * @stability stable
     */
    get nodeTypeInput(): string | undefined;
    private _notificationTopicArn?;
    /**
     * @stability stable
     */
    get notificationTopicArn(): string;
    /**
     * @stability stable
     */
    set notificationTopicArn(value: string);
    /**
     * @stability stable
     */
    resetNotificationTopicArn(): void;
    /**
     * @stability stable
     */
    get notificationTopicArnInput(): string | undefined;
    private _numberCacheClusters?;
    /**
     * @stability stable
     */
    get numberCacheClusters(): number;
    /**
     * @stability stable
     */
    set numberCacheClusters(value: number);
    /**
     * @stability stable
     */
    resetNumberCacheClusters(): void;
    /**
     * @stability stable
     */
    get numberCacheClustersInput(): number | undefined;
    private _parameterGroupName?;
    /**
     * @stability stable
     */
    get parameterGroupName(): string;
    /**
     * @stability stable
     */
    set parameterGroupName(value: string);
    /**
     * @stability stable
     */
    resetParameterGroupName(): void;
    /**
     * @stability stable
     */
    get parameterGroupNameInput(): string | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    /**
     * @stability stable
     */
    get primaryEndpointAddress(): string;
    /**
     * @stability stable
     */
    get readerEndpointAddress(): string;
    private _replicationGroupDescription;
    /**
     * @stability stable
     */
    get replicationGroupDescription(): string;
    /**
     * @stability stable
     */
    set replicationGroupDescription(value: string);
    /**
     * @stability stable
     */
    get replicationGroupDescriptionInput(): string;
    private _replicationGroupId;
    /**
     * @stability stable
     */
    get replicationGroupId(): string;
    /**
     * @stability stable
     */
    set replicationGroupId(value: string);
    /**
     * @stability stable
     */
    get replicationGroupIdInput(): string;
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _securityGroupNames?;
    /**
     * @stability stable
     */
    get securityGroupNames(): string[];
    /**
     * @stability stable
     */
    set securityGroupNames(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupNames(): void;
    /**
     * @stability stable
     */
    get securityGroupNamesInput(): string[] | undefined;
    private _snapshotArns?;
    /**
     * @stability stable
     */
    get snapshotArns(): string[];
    /**
     * @stability stable
     */
    set snapshotArns(value: string[]);
    /**
     * @stability stable
     */
    resetSnapshotArns(): void;
    /**
     * @stability stable
     */
    get snapshotArnsInput(): string[] | undefined;
    private _snapshotName?;
    /**
     * @stability stable
     */
    get snapshotName(): string;
    /**
     * @stability stable
     */
    set snapshotName(value: string);
    /**
     * @stability stable
     */
    resetSnapshotName(): void;
    /**
     * @stability stable
     */
    get snapshotNameInput(): string | undefined;
    private _snapshotRetentionLimit?;
    /**
     * @stability stable
     */
    get snapshotRetentionLimit(): number;
    /**
     * @stability stable
     */
    set snapshotRetentionLimit(value: number);
    /**
     * @stability stable
     */
    resetSnapshotRetentionLimit(): void;
    /**
     * @stability stable
     */
    get snapshotRetentionLimitInput(): number | undefined;
    private _snapshotWindow?;
    /**
     * @stability stable
     */
    get snapshotWindow(): string;
    /**
     * @stability stable
     */
    set snapshotWindow(value: string);
    /**
     * @stability stable
     */
    resetSnapshotWindow(): void;
    /**
     * @stability stable
     */
    get snapshotWindowInput(): string | undefined;
    private _subnetGroupName?;
    /**
     * @stability stable
     */
    get subnetGroupName(): string;
    /**
     * @stability stable
     */
    set subnetGroupName(value: string);
    /**
     * @stability stable
     */
    resetSubnetGroupName(): void;
    /**
     * @stability stable
     */
    get subnetGroupNameInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _transitEncryptionEnabled?;
    /**
     * @stability stable
     */
    get transitEncryptionEnabled(): boolean;
    /**
     * @stability stable
     */
    set transitEncryptionEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetTransitEncryptionEnabled(): void;
    /**
     * @stability stable
     */
    get transitEncryptionEnabledInput(): boolean | undefined;
    private _clusterMode?;
    /**
     * @stability stable
     */
    get clusterMode(): ElasticacheReplicationGroupClusterMode[];
    /**
     * @stability stable
     */
    set clusterMode(value: ElasticacheReplicationGroupClusterMode[]);
    /**
     * @stability stable
     */
    resetClusterMode(): void;
    /**
     * @stability stable
     */
    get clusterModeInput(): ElasticacheReplicationGroupClusterMode[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): ElasticacheReplicationGroupTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: ElasticacheReplicationGroupTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ElasticacheReplicationGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
