import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ElastictranscoderPipelineConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly awsKmsKeyArn?: string;
    /**
     * @stability stable
     */
    readonly inputBucket: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly outputBucket?: string;
    /**
     * @stability stable
     */
    readonly role: string;
    /**
     * content_config block.
     *
     * @stability stable
     */
    readonly contentConfig?: ElastictranscoderPipelineContentConfig[];
    /**
     * content_config_permissions block.
     *
     * @stability stable
     */
    readonly contentConfigPermissions?: ElastictranscoderPipelineContentConfigPermissions[];
    /**
     * notifications block.
     *
     * @stability stable
     */
    readonly notifications?: ElastictranscoderPipelineNotifications[];
    /**
     * thumbnail_config block.
     *
     * @stability stable
     */
    readonly thumbnailConfig?: ElastictranscoderPipelineThumbnailConfig[];
    /**
     * thumbnail_config_permissions block.
     *
     * @stability stable
     */
    readonly thumbnailConfigPermissions?: ElastictranscoderPipelineThumbnailConfigPermissions[];
}
/**
 * @stability stable
 */
export interface ElastictranscoderPipelineContentConfig {
    /**
     * @stability stable
     */
    readonly bucket?: string;
    /**
     * @stability stable
     */
    readonly storageClass?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPipelineContentConfigPermissions {
    /**
     * @stability stable
     */
    readonly access?: string[];
    /**
     * @stability stable
     */
    readonly grantee?: string;
    /**
     * @stability stable
     */
    readonly granteeType?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPipelineNotifications {
    /**
     * @stability stable
     */
    readonly completed?: string;
    /**
     * @stability stable
     */
    readonly error?: string;
    /**
     * @stability stable
     */
    readonly progressing?: string;
    /**
     * @stability stable
     */
    readonly warning?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPipelineThumbnailConfig {
    /**
     * @stability stable
     */
    readonly bucket?: string;
    /**
     * @stability stable
     */
    readonly storageClass?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPipelineThumbnailConfigPermissions {
    /**
     * @stability stable
     */
    readonly access?: string[];
    /**
     * @stability stable
     */
    readonly grantee?: string;
    /**
     * @stability stable
     */
    readonly granteeType?: string;
}
/**
 * @stability stable
 */
export declare class ElastictranscoderPipeline extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElastictranscoderPipelineConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _awsKmsKeyArn?;
    /**
     * @stability stable
     */
    get awsKmsKeyArn(): string;
    /**
     * @stability stable
     */
    set awsKmsKeyArn(value: string);
    /**
     * @stability stable
     */
    resetAwsKmsKeyArn(): void;
    /**
     * @stability stable
     */
    get awsKmsKeyArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _inputBucket;
    /**
     * @stability stable
     */
    get inputBucket(): string;
    /**
     * @stability stable
     */
    set inputBucket(value: string);
    /**
     * @stability stable
     */
    get inputBucketInput(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _outputBucket?;
    /**
     * @stability stable
     */
    get outputBucket(): string;
    /**
     * @stability stable
     */
    set outputBucket(value: string);
    /**
     * @stability stable
     */
    resetOutputBucket(): void;
    /**
     * @stability stable
     */
    get outputBucketInput(): string | undefined;
    private _role;
    /**
     * @stability stable
     */
    get role(): string;
    /**
     * @stability stable
     */
    set role(value: string);
    /**
     * @stability stable
     */
    get roleInput(): string;
    private _contentConfig?;
    /**
     * @stability stable
     */
    get contentConfig(): ElastictranscoderPipelineContentConfig[];
    /**
     * @stability stable
     */
    set contentConfig(value: ElastictranscoderPipelineContentConfig[]);
    /**
     * @stability stable
     */
    resetContentConfig(): void;
    /**
     * @stability stable
     */
    get contentConfigInput(): ElastictranscoderPipelineContentConfig[] | undefined;
    private _contentConfigPermissions?;
    /**
     * @stability stable
     */
    get contentConfigPermissions(): ElastictranscoderPipelineContentConfigPermissions[];
    /**
     * @stability stable
     */
    set contentConfigPermissions(value: ElastictranscoderPipelineContentConfigPermissions[]);
    /**
     * @stability stable
     */
    resetContentConfigPermissions(): void;
    /**
     * @stability stable
     */
    get contentConfigPermissionsInput(): ElastictranscoderPipelineContentConfigPermissions[] | undefined;
    private _notifications?;
    /**
     * @stability stable
     */
    get notifications(): ElastictranscoderPipelineNotifications[];
    /**
     * @stability stable
     */
    set notifications(value: ElastictranscoderPipelineNotifications[]);
    /**
     * @stability stable
     */
    resetNotifications(): void;
    /**
     * @stability stable
     */
    get notificationsInput(): ElastictranscoderPipelineNotifications[] | undefined;
    private _thumbnailConfig?;
    /**
     * @stability stable
     */
    get thumbnailConfig(): ElastictranscoderPipelineThumbnailConfig[];
    /**
     * @stability stable
     */
    set thumbnailConfig(value: ElastictranscoderPipelineThumbnailConfig[]);
    /**
     * @stability stable
     */
    resetThumbnailConfig(): void;
    /**
     * @stability stable
     */
    get thumbnailConfigInput(): ElastictranscoderPipelineThumbnailConfig[] | undefined;
    private _thumbnailConfigPermissions?;
    /**
     * @stability stable
     */
    get thumbnailConfigPermissions(): ElastictranscoderPipelineThumbnailConfigPermissions[];
    /**
     * @stability stable
     */
    set thumbnailConfigPermissions(value: ElastictranscoderPipelineThumbnailConfigPermissions[]);
    /**
     * @stability stable
     */
    resetThumbnailConfigPermissions(): void;
    /**
     * @stability stable
     */
    get thumbnailConfigPermissionsInput(): ElastictranscoderPipelineThumbnailConfigPermissions[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
