import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ElastictranscoderPresetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly container: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly type?: string;
    /**
     * @stability stable
     */
    readonly videoCodecOptions?: {
        [key: string]: string;
    };
    /**
     * audio block.
     *
     * @stability stable
     */
    readonly audio?: ElastictranscoderPresetAudio[];
    /**
     * audio_codec_options block.
     *
     * @stability stable
     */
    readonly audioCodecOptions?: ElastictranscoderPresetAudioCodecOptions[];
    /**
     * thumbnails block.
     *
     * @stability stable
     */
    readonly thumbnails?: ElastictranscoderPresetThumbnails[];
    /**
     * video block.
     *
     * @stability stable
     */
    readonly video?: ElastictranscoderPresetVideo[];
    /**
     * video_watermarks block.
     *
     * @stability stable
     */
    readonly videoWatermarks?: ElastictranscoderPresetVideoWatermarks[];
}
/**
 * @stability stable
 */
export interface ElastictranscoderPresetAudio {
    /**
     * @stability stable
     */
    readonly audioPackingMode?: string;
    /**
     * @stability stable
     */
    readonly bitRate?: string;
    /**
     * @stability stable
     */
    readonly channels?: string;
    /**
     * @stability stable
     */
    readonly codec?: string;
    /**
     * @stability stable
     */
    readonly sampleRate?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPresetAudioCodecOptions {
    /**
     * @stability stable
     */
    readonly bitDepth?: string;
    /**
     * @stability stable
     */
    readonly bitOrder?: string;
    /**
     * @stability stable
     */
    readonly profile?: string;
    /**
     * @stability stable
     */
    readonly signed?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPresetThumbnails {
    /**
     * @stability stable
     */
    readonly aspectRatio?: string;
    /**
     * @stability stable
     */
    readonly format?: string;
    /**
     * @stability stable
     */
    readonly interval?: string;
    /**
     * @stability stable
     */
    readonly maxHeight?: string;
    /**
     * @stability stable
     */
    readonly maxWidth?: string;
    /**
     * @stability stable
     */
    readonly paddingPolicy?: string;
    /**
     * @stability stable
     */
    readonly resolution?: string;
    /**
     * @stability stable
     */
    readonly sizingPolicy?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPresetVideo {
    /**
     * @stability stable
     */
    readonly aspectRatio?: string;
    /**
     * @stability stable
     */
    readonly bitRate?: string;
    /**
     * @stability stable
     */
    readonly codec?: string;
    /**
     * @stability stable
     */
    readonly displayAspectRatio?: string;
    /**
     * @stability stable
     */
    readonly fixedGop?: string;
    /**
     * @stability stable
     */
    readonly frameRate?: string;
    /**
     * @stability stable
     */
    readonly keyframesMaxDist?: string;
    /**
     * @stability stable
     */
    readonly maxFrameRate?: string;
    /**
     * @stability stable
     */
    readonly maxHeight?: string;
    /**
     * @stability stable
     */
    readonly maxWidth?: string;
    /**
     * @stability stable
     */
    readonly paddingPolicy?: string;
    /**
     * @stability stable
     */
    readonly resolution?: string;
    /**
     * @stability stable
     */
    readonly sizingPolicy?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPresetVideoWatermarks {
    /**
     * @stability stable
     */
    readonly horizontalAlign?: string;
    /**
     * @stability stable
     */
    readonly horizontalOffset?: string;
    /**
     * @stability stable
     */
    readonly id?: string;
    /**
     * @stability stable
     */
    readonly maxHeight?: string;
    /**
     * @stability stable
     */
    readonly maxWidth?: string;
    /**
     * @stability stable
     */
    readonly opacity?: string;
    /**
     * @stability stable
     */
    readonly sizingPolicy?: string;
    /**
     * @stability stable
     */
    readonly target?: string;
    /**
     * @stability stable
     */
    readonly verticalAlign?: string;
    /**
     * @stability stable
     */
    readonly verticalOffset?: string;
}
/**
 * @stability stable
 */
export declare class ElastictranscoderPreset extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElastictranscoderPresetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _container;
    /**
     * @stability stable
     */
    get container(): string;
    /**
     * @stability stable
     */
    set container(value: string);
    /**
     * @stability stable
     */
    get containerInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _videoCodecOptions?;
    /**
     * @stability stable
     */
    get videoCodecOptions(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set videoCodecOptions(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetVideoCodecOptions(): void;
    /**
     * @stability stable
     */
    get videoCodecOptionsInput(): {
        [key: string]: string;
    } | undefined;
    private _audio?;
    /**
     * @stability stable
     */
    get audio(): ElastictranscoderPresetAudio[];
    /**
     * @stability stable
     */
    set audio(value: ElastictranscoderPresetAudio[]);
    /**
     * @stability stable
     */
    resetAudio(): void;
    /**
     * @stability stable
     */
    get audioInput(): ElastictranscoderPresetAudio[] | undefined;
    private _audioCodecOptions?;
    /**
     * @stability stable
     */
    get audioCodecOptions(): ElastictranscoderPresetAudioCodecOptions[];
    /**
     * @stability stable
     */
    set audioCodecOptions(value: ElastictranscoderPresetAudioCodecOptions[]);
    /**
     * @stability stable
     */
    resetAudioCodecOptions(): void;
    /**
     * @stability stable
     */
    get audioCodecOptionsInput(): ElastictranscoderPresetAudioCodecOptions[] | undefined;
    private _thumbnails?;
    /**
     * @stability stable
     */
    get thumbnails(): ElastictranscoderPresetThumbnails[];
    /**
     * @stability stable
     */
    set thumbnails(value: ElastictranscoderPresetThumbnails[]);
    /**
     * @stability stable
     */
    resetThumbnails(): void;
    /**
     * @stability stable
     */
    get thumbnailsInput(): ElastictranscoderPresetThumbnails[] | undefined;
    private _video?;
    /**
     * @stability stable
     */
    get video(): ElastictranscoderPresetVideo[];
    /**
     * @stability stable
     */
    set video(value: ElastictranscoderPresetVideo[]);
    /**
     * @stability stable
     */
    resetVideo(): void;
    /**
     * @stability stable
     */
    get videoInput(): ElastictranscoderPresetVideo[] | undefined;
    private _videoWatermarks?;
    /**
     * @stability stable
     */
    get videoWatermarks(): ElastictranscoderPresetVideoWatermarks[];
    /**
     * @stability stable
     */
    set videoWatermarks(value: ElastictranscoderPresetVideoWatermarks[]);
    /**
     * @stability stable
     */
    resetVideoWatermarks(): void;
    /**
     * @stability stable
     */
    get videoWatermarksInput(): ElastictranscoderPresetVideoWatermarks[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
