import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ElbConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly availabilityZones?: string[];
    /**
     * @stability stable
     */
    readonly connectionDraining?: boolean;
    /**
     * @stability stable
     */
    readonly connectionDrainingTimeout?: number;
    /**
     * @stability stable
     */
    readonly crossZoneLoadBalancing?: boolean;
    /**
     * @stability stable
     */
    readonly idleTimeout?: number;
    /**
     * @stability stable
     */
    readonly instances?: string[];
    /**
     * @stability stable
     */
    readonly internal?: boolean;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * @stability stable
     */
    readonly sourceSecurityGroup?: string;
    /**
     * @stability stable
     */
    readonly subnets?: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * access_logs block.
     *
     * @stability stable
     */
    readonly accessLogs?: ElbAccessLogs[];
    /**
     * health_check block.
     *
     * @stability stable
     */
    readonly healthCheck?: ElbHealthCheck[];
    /**
     * listener block.
     *
     * @stability stable
     */
    readonly listener: ElbListener[];
}
/**
 * @stability stable
 */
export interface ElbAccessLogs {
    /**
     * @stability stable
     */
    readonly bucket: string;
    /**
     * @stability stable
     */
    readonly bucketPrefix?: string;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly interval?: number;
}
/**
 * @stability stable
 */
export interface ElbHealthCheck {
    /**
     * @stability stable
     */
    readonly healthyThreshold: number;
    /**
     * @stability stable
     */
    readonly interval: number;
    /**
     * @stability stable
     */
    readonly target: string;
    /**
     * @stability stable
     */
    readonly timeout: number;
    /**
     * @stability stable
     */
    readonly unhealthyThreshold: number;
}
/**
 * @stability stable
 */
export interface ElbListener {
    /**
     * @stability stable
     */
    readonly instancePort: number;
    /**
     * @stability stable
     */
    readonly instanceProtocol: string;
    /**
     * @stability stable
     */
    readonly lbPort: number;
    /**
     * @stability stable
     */
    readonly lbProtocol: string;
    /**
     * @stability stable
     */
    readonly sslCertificateId?: string;
}
/**
 * @stability stable
 */
export declare class Elb extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElbConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _availabilityZones?;
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    /**
     * @stability stable
     */
    set availabilityZones(value: string[]);
    /**
     * @stability stable
     */
    resetAvailabilityZones(): void;
    /**
     * @stability stable
     */
    get availabilityZonesInput(): string[] | undefined;
    private _connectionDraining?;
    /**
     * @stability stable
     */
    get connectionDraining(): boolean;
    /**
     * @stability stable
     */
    set connectionDraining(value: boolean);
    /**
     * @stability stable
     */
    resetConnectionDraining(): void;
    /**
     * @stability stable
     */
    get connectionDrainingInput(): boolean | undefined;
    private _connectionDrainingTimeout?;
    /**
     * @stability stable
     */
    get connectionDrainingTimeout(): number;
    /**
     * @stability stable
     */
    set connectionDrainingTimeout(value: number);
    /**
     * @stability stable
     */
    resetConnectionDrainingTimeout(): void;
    /**
     * @stability stable
     */
    get connectionDrainingTimeoutInput(): number | undefined;
    private _crossZoneLoadBalancing?;
    /**
     * @stability stable
     */
    get crossZoneLoadBalancing(): boolean;
    /**
     * @stability stable
     */
    set crossZoneLoadBalancing(value: boolean);
    /**
     * @stability stable
     */
    resetCrossZoneLoadBalancing(): void;
    /**
     * @stability stable
     */
    get crossZoneLoadBalancingInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get dnsName(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _idleTimeout?;
    /**
     * @stability stable
     */
    get idleTimeout(): number;
    /**
     * @stability stable
     */
    set idleTimeout(value: number);
    /**
     * @stability stable
     */
    resetIdleTimeout(): void;
    /**
     * @stability stable
     */
    get idleTimeoutInput(): number | undefined;
    private _instances?;
    /**
     * @stability stable
     */
    get instances(): string[];
    /**
     * @stability stable
     */
    set instances(value: string[]);
    /**
     * @stability stable
     */
    resetInstances(): void;
    /**
     * @stability stable
     */
    get instancesInput(): string[] | undefined;
    private _internal?;
    /**
     * @stability stable
     */
    get internal(): boolean;
    /**
     * @stability stable
     */
    set internal(value: boolean);
    /**
     * @stability stable
     */
    resetInternal(): void;
    /**
     * @stability stable
     */
    get internalInput(): boolean | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _securityGroups?;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    set securityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroups(): void;
    /**
     * @stability stable
     */
    get securityGroupsInput(): string[] | undefined;
    private _sourceSecurityGroup?;
    /**
     * @stability stable
     */
    get sourceSecurityGroup(): string;
    /**
     * @stability stable
     */
    set sourceSecurityGroup(value: string);
    /**
     * @stability stable
     */
    resetSourceSecurityGroup(): void;
    /**
     * @stability stable
     */
    get sourceSecurityGroupInput(): string | undefined;
    /**
     * @stability stable
     */
    get sourceSecurityGroupId(): string;
    private _subnets?;
    /**
     * @stability stable
     */
    get subnets(): string[];
    /**
     * @stability stable
     */
    set subnets(value: string[]);
    /**
     * @stability stable
     */
    resetSubnets(): void;
    /**
     * @stability stable
     */
    get subnetsInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get zoneId(): string;
    private _accessLogs?;
    /**
     * @stability stable
     */
    get accessLogs(): ElbAccessLogs[];
    /**
     * @stability stable
     */
    set accessLogs(value: ElbAccessLogs[]);
    /**
     * @stability stable
     */
    resetAccessLogs(): void;
    /**
     * @stability stable
     */
    get accessLogsInput(): ElbAccessLogs[] | undefined;
    private _healthCheck?;
    /**
     * @stability stable
     */
    get healthCheck(): ElbHealthCheck[];
    /**
     * @stability stable
     */
    set healthCheck(value: ElbHealthCheck[]);
    /**
     * @stability stable
     */
    resetHealthCheck(): void;
    /**
     * @stability stable
     */
    get healthCheckInput(): ElbHealthCheck[] | undefined;
    private _listener;
    /**
     * @stability stable
     */
    get listener(): ElbListener[];
    /**
     * @stability stable
     */
    set listener(value: ElbListener[]);
    /**
     * @stability stable
     */
    get listenerInput(): ElbListener[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
