import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EmrClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly additionalInfo?: string;
    /**
     * @stability stable
     */
    readonly applications?: string[];
    /**
     * @stability stable
     */
    readonly autoscalingRole?: string;
    /**
     * @stability stable
     */
    readonly configurations?: string;
    /**
     * @stability stable
     */
    readonly configurationsJson?: string;
    /**
     * @stability stable
     */
    readonly customAmiId?: string;
    /**
     * @stability stable
     */
    readonly ebsRootVolumeSize?: number;
    /**
     * @stability stable
     */
    readonly keepJobFlowAliveWhenNoSteps?: boolean;
    /**
     * @stability stable
     */
    readonly logUri?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly releaseLabel: string;
    /**
     * @stability stable
     */
    readonly scaleDownBehavior?: string;
    /**
     * @stability stable
     */
    readonly securityConfiguration?: string;
    /**
     * @stability stable
     */
    readonly serviceRole: string;
    /**
     * @stability stable
     */
    readonly step?: EmrClusterStep[];
    /**
     * @stability stable
     */
    readonly stepConcurrencyLevel?: number;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly terminationProtection?: boolean;
    /**
     * @stability stable
     */
    readonly visibleToAllUsers?: boolean;
    /**
     * bootstrap_action block.
     *
     * @stability stable
     */
    readonly bootstrapAction?: EmrClusterBootstrapAction[];
    /**
     * core_instance_fleet block.
     *
     * @stability stable
     */
    readonly coreInstanceFleet?: EmrClusterCoreInstanceFleet[];
    /**
     * core_instance_group block.
     *
     * @stability stable
     */
    readonly coreInstanceGroup?: EmrClusterCoreInstanceGroup[];
    /**
     * ec2_attributes block.
     *
     * @stability stable
     */
    readonly ec2Attributes?: EmrClusterEc2Attributes[];
    /**
     * kerberos_attributes block.
     *
     * @stability stable
     */
    readonly kerberosAttributes?: EmrClusterKerberosAttributes[];
    /**
     * master_instance_fleet block.
     *
     * @stability stable
     */
    readonly masterInstanceFleet?: EmrClusterMasterInstanceFleet[];
    /**
     * master_instance_group block.
     *
     * @stability stable
     */
    readonly masterInstanceGroup?: EmrClusterMasterInstanceGroup[];
}
/**
 * @stability stable
 */
export interface EmrClusterStepHadoopJarStep {
    /**
     * @stability stable
     */
    readonly args?: string[];
    /**
     * @stability stable
     */
    readonly jar?: string;
    /**
     * @stability stable
     */
    readonly mainClass?: string;
    /**
     * @stability stable
     */
    readonly properties?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export interface EmrClusterStep {
    /**
     * @stability stable
     */
    readonly actionOnFailure?: string;
    /**
     * @stability stable
     */
    readonly hadoopJarStep?: EmrClusterStepHadoopJarStep[];
    /**
     * @stability stable
     */
    readonly name?: string;
}
/**
 * @stability stable
 */
export interface EmrClusterBootstrapAction {
    /**
     * @stability stable
     */
    readonly args?: string[];
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly path: string;
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetInstanceTypeConfigsConfigurations {
    /**
     * @stability stable
     */
    readonly classification?: string;
    /**
     * @stability stable
     */
    readonly properties?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetInstanceTypeConfigsEbsConfig {
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly size: number;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly volumesPerInstance?: number;
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetInstanceTypeConfigs {
    /**
     * @stability stable
     */
    readonly bidPrice?: string;
    /**
     * @stability stable
     */
    readonly bidPriceAsPercentageOfOnDemandPrice?: number;
    /**
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * @stability stable
     */
    readonly weightedCapacity?: number;
    /**
     * configurations block.
     *
     * @stability stable
     */
    readonly configurations?: EmrClusterCoreInstanceFleetInstanceTypeConfigsConfigurations[];
    /**
     * ebs_config block.
     *
     * @stability stable
     */
    readonly ebsConfig?: EmrClusterCoreInstanceFleetInstanceTypeConfigsEbsConfig[];
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecification {
    /**
     * @stability stable
     */
    readonly allocationStrategy: string;
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecification {
    /**
     * @stability stable
     */
    readonly allocationStrategy: string;
    /**
     * @stability stable
     */
    readonly blockDurationMinutes?: number;
    /**
     * @stability stable
     */
    readonly timeoutAction: string;
    /**
     * @stability stable
     */
    readonly timeoutDurationMinutes: number;
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleetLaunchSpecifications {
    /**
     * on_demand_specification block.
     *
     * @stability stable
     */
    readonly onDemandSpecification?: EmrClusterCoreInstanceFleetLaunchSpecificationsOnDemandSpecification[];
    /**
     * spot_specification block.
     *
     * @stability stable
     */
    readonly spotSpecification?: EmrClusterCoreInstanceFleetLaunchSpecificationsSpotSpecification[];
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceFleet {
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly targetOnDemandCapacity?: number;
    /**
     * @stability stable
     */
    readonly targetSpotCapacity?: number;
    /**
     * instance_type_configs block.
     *
     * @stability stable
     */
    readonly instanceTypeConfigs?: EmrClusterCoreInstanceFleetInstanceTypeConfigs[];
    /**
     * launch_specifications block.
     *
     * @stability stable
     */
    readonly launchSpecifications?: EmrClusterCoreInstanceFleetLaunchSpecifications[];
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceGroupEbsConfig {
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly size: number;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly volumesPerInstance?: number;
}
/**
 * @stability stable
 */
export interface EmrClusterCoreInstanceGroup {
    /**
     * @stability stable
     */
    readonly autoscalingPolicy?: string;
    /**
     * @stability stable
     */
    readonly bidPrice?: string;
    /**
     * @stability stable
     */
    readonly instanceCount?: number;
    /**
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * ebs_config block.
     *
     * @stability stable
     */
    readonly ebsConfig?: EmrClusterCoreInstanceGroupEbsConfig[];
}
/**
 * @stability stable
 */
export interface EmrClusterEc2Attributes {
    /**
     * @stability stable
     */
    readonly additionalMasterSecurityGroups?: string;
    /**
     * @stability stable
     */
    readonly additionalSlaveSecurityGroups?: string;
    /**
     * @stability stable
     */
    readonly emrManagedMasterSecurityGroup?: string;
    /**
     * @stability stable
     */
    readonly emrManagedSlaveSecurityGroup?: string;
    /**
     * @stability stable
     */
    readonly instanceProfile: string;
    /**
     * @stability stable
     */
    readonly keyName?: string;
    /**
     * @stability stable
     */
    readonly serviceAccessSecurityGroup?: string;
    /**
     * @stability stable
     */
    readonly subnetId?: string;
}
/**
 * @stability stable
 */
export interface EmrClusterKerberosAttributes {
    /**
     * @stability stable
     */
    readonly adDomainJoinPassword?: string;
    /**
     * @stability stable
     */
    readonly adDomainJoinUser?: string;
    /**
     * @stability stable
     */
    readonly crossRealmTrustPrincipalPassword?: string;
    /**
     * @stability stable
     */
    readonly kdcAdminPassword: string;
    /**
     * @stability stable
     */
    readonly realm: string;
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetInstanceTypeConfigsConfigurations {
    /**
     * @stability stable
     */
    readonly classification?: string;
    /**
     * @stability stable
     */
    readonly properties?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetInstanceTypeConfigsEbsConfig {
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly size: number;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly volumesPerInstance?: number;
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetInstanceTypeConfigs {
    /**
     * @stability stable
     */
    readonly bidPrice?: string;
    /**
     * @stability stable
     */
    readonly bidPriceAsPercentageOfOnDemandPrice?: number;
    /**
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * @stability stable
     */
    readonly weightedCapacity?: number;
    /**
     * configurations block.
     *
     * @stability stable
     */
    readonly configurations?: EmrClusterMasterInstanceFleetInstanceTypeConfigsConfigurations[];
    /**
     * ebs_config block.
     *
     * @stability stable
     */
    readonly ebsConfig?: EmrClusterMasterInstanceFleetInstanceTypeConfigsEbsConfig[];
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecification {
    /**
     * @stability stable
     */
    readonly allocationStrategy: string;
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecification {
    /**
     * @stability stable
     */
    readonly allocationStrategy: string;
    /**
     * @stability stable
     */
    readonly blockDurationMinutes?: number;
    /**
     * @stability stable
     */
    readonly timeoutAction: string;
    /**
     * @stability stable
     */
    readonly timeoutDurationMinutes: number;
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleetLaunchSpecifications {
    /**
     * on_demand_specification block.
     *
     * @stability stable
     */
    readonly onDemandSpecification?: EmrClusterMasterInstanceFleetLaunchSpecificationsOnDemandSpecification[];
    /**
     * spot_specification block.
     *
     * @stability stable
     */
    readonly spotSpecification?: EmrClusterMasterInstanceFleetLaunchSpecificationsSpotSpecification[];
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceFleet {
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly targetOnDemandCapacity?: number;
    /**
     * @stability stable
     */
    readonly targetSpotCapacity?: number;
    /**
     * instance_type_configs block.
     *
     * @stability stable
     */
    readonly instanceTypeConfigs?: EmrClusterMasterInstanceFleetInstanceTypeConfigs[];
    /**
     * launch_specifications block.
     *
     * @stability stable
     */
    readonly launchSpecifications?: EmrClusterMasterInstanceFleetLaunchSpecifications[];
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceGroupEbsConfig {
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly size: number;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly volumesPerInstance?: number;
}
/**
 * @stability stable
 */
export interface EmrClusterMasterInstanceGroup {
    /**
     * @stability stable
     */
    readonly bidPrice?: string;
    /**
     * @stability stable
     */
    readonly instanceCount?: number;
    /**
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * ebs_config block.
     *
     * @stability stable
     */
    readonly ebsConfig?: EmrClusterMasterInstanceGroupEbsConfig[];
}
/**
 * @stability stable
 */
export declare class EmrCluster extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EmrClusterConfig);
    private _additionalInfo?;
    /**
     * @stability stable
     */
    get additionalInfo(): string;
    /**
     * @stability stable
     */
    set additionalInfo(value: string);
    /**
     * @stability stable
     */
    resetAdditionalInfo(): void;
    /**
     * @stability stable
     */
    get additionalInfoInput(): string | undefined;
    private _applications?;
    /**
     * @stability stable
     */
    get applications(): string[];
    /**
     * @stability stable
     */
    set applications(value: string[]);
    /**
     * @stability stable
     */
    resetApplications(): void;
    /**
     * @stability stable
     */
    get applicationsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoscalingRole?;
    /**
     * @stability stable
     */
    get autoscalingRole(): string;
    /**
     * @stability stable
     */
    set autoscalingRole(value: string);
    /**
     * @stability stable
     */
    resetAutoscalingRole(): void;
    /**
     * @stability stable
     */
    get autoscalingRoleInput(): string | undefined;
    /**
     * @stability stable
     */
    get clusterState(): string;
    private _configurations?;
    /**
     * @stability stable
     */
    get configurations(): string;
    /**
     * @stability stable
     */
    set configurations(value: string);
    /**
     * @stability stable
     */
    resetConfigurations(): void;
    /**
     * @stability stable
     */
    get configurationsInput(): string | undefined;
    private _configurationsJson?;
    /**
     * @stability stable
     */
    get configurationsJson(): string;
    /**
     * @stability stable
     */
    set configurationsJson(value: string);
    /**
     * @stability stable
     */
    resetConfigurationsJson(): void;
    /**
     * @stability stable
     */
    get configurationsJsonInput(): string | undefined;
    private _customAmiId?;
    /**
     * @stability stable
     */
    get customAmiId(): string;
    /**
     * @stability stable
     */
    set customAmiId(value: string);
    /**
     * @stability stable
     */
    resetCustomAmiId(): void;
    /**
     * @stability stable
     */
    get customAmiIdInput(): string | undefined;
    private _ebsRootVolumeSize?;
    /**
     * @stability stable
     */
    get ebsRootVolumeSize(): number;
    /**
     * @stability stable
     */
    set ebsRootVolumeSize(value: number);
    /**
     * @stability stable
     */
    resetEbsRootVolumeSize(): void;
    /**
     * @stability stable
     */
    get ebsRootVolumeSizeInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _keepJobFlowAliveWhenNoSteps?;
    /**
     * @stability stable
     */
    get keepJobFlowAliveWhenNoSteps(): boolean;
    /**
     * @stability stable
     */
    set keepJobFlowAliveWhenNoSteps(value: boolean);
    /**
     * @stability stable
     */
    resetKeepJobFlowAliveWhenNoSteps(): void;
    /**
     * @stability stable
     */
    get keepJobFlowAliveWhenNoStepsInput(): boolean | undefined;
    private _logUri?;
    /**
     * @stability stable
     */
    get logUri(): string;
    /**
     * @stability stable
     */
    set logUri(value: string);
    /**
     * @stability stable
     */
    resetLogUri(): void;
    /**
     * @stability stable
     */
    get logUriInput(): string | undefined;
    /**
     * @stability stable
     */
    get masterPublicDns(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _releaseLabel;
    /**
     * @stability stable
     */
    get releaseLabel(): string;
    /**
     * @stability stable
     */
    set releaseLabel(value: string);
    /**
     * @stability stable
     */
    get releaseLabelInput(): string;
    private _scaleDownBehavior?;
    /**
     * @stability stable
     */
    get scaleDownBehavior(): string;
    /**
     * @stability stable
     */
    set scaleDownBehavior(value: string);
    /**
     * @stability stable
     */
    resetScaleDownBehavior(): void;
    /**
     * @stability stable
     */
    get scaleDownBehaviorInput(): string | undefined;
    private _securityConfiguration?;
    /**
     * @stability stable
     */
    get securityConfiguration(): string;
    /**
     * @stability stable
     */
    set securityConfiguration(value: string);
    /**
     * @stability stable
     */
    resetSecurityConfiguration(): void;
    /**
     * @stability stable
     */
    get securityConfigurationInput(): string | undefined;
    private _serviceRole;
    /**
     * @stability stable
     */
    get serviceRole(): string;
    /**
     * @stability stable
     */
    set serviceRole(value: string);
    /**
     * @stability stable
     */
    get serviceRoleInput(): string;
    private _step?;
    /**
     * @stability stable
     */
    get step(): EmrClusterStep[];
    /**
     * @stability stable
     */
    set step(value: EmrClusterStep[]);
    /**
     * @stability stable
     */
    resetStep(): void;
    /**
     * @stability stable
     */
    get stepInput(): EmrClusterStep[] | undefined;
    private _stepConcurrencyLevel?;
    /**
     * @stability stable
     */
    get stepConcurrencyLevel(): number;
    /**
     * @stability stable
     */
    set stepConcurrencyLevel(value: number);
    /**
     * @stability stable
     */
    resetStepConcurrencyLevel(): void;
    /**
     * @stability stable
     */
    get stepConcurrencyLevelInput(): number | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _terminationProtection?;
    /**
     * @stability stable
     */
    get terminationProtection(): boolean;
    /**
     * @stability stable
     */
    set terminationProtection(value: boolean);
    /**
     * @stability stable
     */
    resetTerminationProtection(): void;
    /**
     * @stability stable
     */
    get terminationProtectionInput(): boolean | undefined;
    private _visibleToAllUsers?;
    /**
     * @stability stable
     */
    get visibleToAllUsers(): boolean;
    /**
     * @stability stable
     */
    set visibleToAllUsers(value: boolean);
    /**
     * @stability stable
     */
    resetVisibleToAllUsers(): void;
    /**
     * @stability stable
     */
    get visibleToAllUsersInput(): boolean | undefined;
    private _bootstrapAction?;
    /**
     * @stability stable
     */
    get bootstrapAction(): EmrClusterBootstrapAction[];
    /**
     * @stability stable
     */
    set bootstrapAction(value: EmrClusterBootstrapAction[]);
    /**
     * @stability stable
     */
    resetBootstrapAction(): void;
    /**
     * @stability stable
     */
    get bootstrapActionInput(): EmrClusterBootstrapAction[] | undefined;
    private _coreInstanceFleet?;
    /**
     * @stability stable
     */
    get coreInstanceFleet(): EmrClusterCoreInstanceFleet[];
    /**
     * @stability stable
     */
    set coreInstanceFleet(value: EmrClusterCoreInstanceFleet[]);
    /**
     * @stability stable
     */
    resetCoreInstanceFleet(): void;
    /**
     * @stability stable
     */
    get coreInstanceFleetInput(): EmrClusterCoreInstanceFleet[] | undefined;
    private _coreInstanceGroup?;
    /**
     * @stability stable
     */
    get coreInstanceGroup(): EmrClusterCoreInstanceGroup[];
    /**
     * @stability stable
     */
    set coreInstanceGroup(value: EmrClusterCoreInstanceGroup[]);
    /**
     * @stability stable
     */
    resetCoreInstanceGroup(): void;
    /**
     * @stability stable
     */
    get coreInstanceGroupInput(): EmrClusterCoreInstanceGroup[] | undefined;
    private _ec2Attributes?;
    /**
     * @stability stable
     */
    get ec2Attributes(): EmrClusterEc2Attributes[];
    /**
     * @stability stable
     */
    set ec2Attributes(value: EmrClusterEc2Attributes[]);
    /**
     * @stability stable
     */
    resetEc2Attributes(): void;
    /**
     * @stability stable
     */
    get ec2AttributesInput(): EmrClusterEc2Attributes[] | undefined;
    private _kerberosAttributes?;
    /**
     * @stability stable
     */
    get kerberosAttributes(): EmrClusterKerberosAttributes[];
    /**
     * @stability stable
     */
    set kerberosAttributes(value: EmrClusterKerberosAttributes[]);
    /**
     * @stability stable
     */
    resetKerberosAttributes(): void;
    /**
     * @stability stable
     */
    get kerberosAttributesInput(): EmrClusterKerberosAttributes[] | undefined;
    private _masterInstanceFleet?;
    /**
     * @stability stable
     */
    get masterInstanceFleet(): EmrClusterMasterInstanceFleet[];
    /**
     * @stability stable
     */
    set masterInstanceFleet(value: EmrClusterMasterInstanceFleet[]);
    /**
     * @stability stable
     */
    resetMasterInstanceFleet(): void;
    /**
     * @stability stable
     */
    get masterInstanceFleetInput(): EmrClusterMasterInstanceFleet[] | undefined;
    private _masterInstanceGroup?;
    /**
     * @stability stable
     */
    get masterInstanceGroup(): EmrClusterMasterInstanceGroup[];
    /**
     * @stability stable
     */
    set masterInstanceGroup(value: EmrClusterMasterInstanceGroup[]);
    /**
     * @stability stable
     */
    resetMasterInstanceGroup(): void;
    /**
     * @stability stable
     */
    get masterInstanceGroupInput(): EmrClusterMasterInstanceGroup[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
