import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EmrInstanceFleetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly clusterId: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly targetOnDemandCapacity?: number;
    /**
     * @stability stable
     */
    readonly targetSpotCapacity?: number;
    /**
     * instance_type_configs block.
     *
     * @stability stable
     */
    readonly instanceTypeConfigs?: EmrInstanceFleetInstanceTypeConfigs[];
    /**
     * launch_specifications block.
     *
     * @stability stable
     */
    readonly launchSpecifications?: EmrInstanceFleetLaunchSpecifications[];
}
/**
 * @stability stable
 */
export interface EmrInstanceFleetInstanceTypeConfigsConfigurations {
    /**
     * @stability stable
     */
    readonly classification?: string;
    /**
     * @stability stable
     */
    readonly properties?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export interface EmrInstanceFleetInstanceTypeConfigsEbsConfig {
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly size: number;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly volumesPerInstance?: number;
}
/**
 * @stability stable
 */
export interface EmrInstanceFleetInstanceTypeConfigs {
    /**
     * @stability stable
     */
    readonly bidPrice?: string;
    /**
     * @stability stable
     */
    readonly bidPriceAsPercentageOfOnDemandPrice?: number;
    /**
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * @stability stable
     */
    readonly weightedCapacity?: number;
    /**
     * configurations block.
     *
     * @stability stable
     */
    readonly configurations?: EmrInstanceFleetInstanceTypeConfigsConfigurations[];
    /**
     * ebs_config block.
     *
     * @stability stable
     */
    readonly ebsConfig?: EmrInstanceFleetInstanceTypeConfigsEbsConfig[];
}
/**
 * @stability stable
 */
export interface EmrInstanceFleetLaunchSpecificationsOnDemandSpecification {
    /**
     * @stability stable
     */
    readonly allocationStrategy: string;
}
/**
 * @stability stable
 */
export interface EmrInstanceFleetLaunchSpecificationsSpotSpecification {
    /**
     * @stability stable
     */
    readonly allocationStrategy: string;
    /**
     * @stability stable
     */
    readonly blockDurationMinutes?: number;
    /**
     * @stability stable
     */
    readonly timeoutAction: string;
    /**
     * @stability stable
     */
    readonly timeoutDurationMinutes: number;
}
/**
 * @stability stable
 */
export interface EmrInstanceFleetLaunchSpecifications {
    /**
     * on_demand_specification block.
     *
     * @stability stable
     */
    readonly onDemandSpecification?: EmrInstanceFleetLaunchSpecificationsOnDemandSpecification[];
    /**
     * spot_specification block.
     *
     * @stability stable
     */
    readonly spotSpecification?: EmrInstanceFleetLaunchSpecificationsSpotSpecification[];
}
/**
 * @stability stable
 */
export declare class EmrInstanceFleet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EmrInstanceFleetConfig);
    private _clusterId;
    /**
     * @stability stable
     */
    get clusterId(): string;
    /**
     * @stability stable
     */
    set clusterId(value: string);
    /**
     * @stability stable
     */
    get clusterIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get provisionedOnDemandCapacity(): number;
    /**
     * @stability stable
     */
    get provisionedSpotCapacity(): number;
    private _targetOnDemandCapacity?;
    /**
     * @stability stable
     */
    get targetOnDemandCapacity(): number;
    /**
     * @stability stable
     */
    set targetOnDemandCapacity(value: number);
    /**
     * @stability stable
     */
    resetTargetOnDemandCapacity(): void;
    /**
     * @stability stable
     */
    get targetOnDemandCapacityInput(): number | undefined;
    private _targetSpotCapacity?;
    /**
     * @stability stable
     */
    get targetSpotCapacity(): number;
    /**
     * @stability stable
     */
    set targetSpotCapacity(value: number);
    /**
     * @stability stable
     */
    resetTargetSpotCapacity(): void;
    /**
     * @stability stable
     */
    get targetSpotCapacityInput(): number | undefined;
    private _instanceTypeConfigs?;
    /**
     * @stability stable
     */
    get instanceTypeConfigs(): EmrInstanceFleetInstanceTypeConfigs[];
    /**
     * @stability stable
     */
    set instanceTypeConfigs(value: EmrInstanceFleetInstanceTypeConfigs[]);
    /**
     * @stability stable
     */
    resetInstanceTypeConfigs(): void;
    /**
     * @stability stable
     */
    get instanceTypeConfigsInput(): EmrInstanceFleetInstanceTypeConfigs[] | undefined;
    private _launchSpecifications?;
    /**
     * @stability stable
     */
    get launchSpecifications(): EmrInstanceFleetLaunchSpecifications[];
    /**
     * @stability stable
     */
    set launchSpecifications(value: EmrInstanceFleetLaunchSpecifications[]);
    /**
     * @stability stable
     */
    resetLaunchSpecifications(): void;
    /**
     * @stability stable
     */
    get launchSpecificationsInput(): EmrInstanceFleetLaunchSpecifications[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
