import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EmrInstanceGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly autoscalingPolicy?: string;
    /**
     * @stability stable
     */
    readonly bidPrice?: string;
    /**
     * @stability stable
     */
    readonly clusterId: string;
    /**
     * @stability stable
     */
    readonly configurationsJson?: string;
    /**
     * @stability stable
     */
    readonly ebsOptimized?: boolean;
    /**
     * @stability stable
     */
    readonly instanceCount?: number;
    /**
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * ebs_config block.
     *
     * @stability stable
     */
    readonly ebsConfig?: EmrInstanceGroupEbsConfig[];
}
/**
 * @stability stable
 */
export interface EmrInstanceGroupEbsConfig {
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly size: number;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly volumesPerInstance?: number;
}
/**
 * @stability stable
 */
export declare class EmrInstanceGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EmrInstanceGroupConfig);
    private _autoscalingPolicy?;
    /**
     * @stability stable
     */
    get autoscalingPolicy(): string;
    /**
     * @stability stable
     */
    set autoscalingPolicy(value: string);
    /**
     * @stability stable
     */
    resetAutoscalingPolicy(): void;
    /**
     * @stability stable
     */
    get autoscalingPolicyInput(): string | undefined;
    private _bidPrice?;
    /**
     * @stability stable
     */
    get bidPrice(): string;
    /**
     * @stability stable
     */
    set bidPrice(value: string);
    /**
     * @stability stable
     */
    resetBidPrice(): void;
    /**
     * @stability stable
     */
    get bidPriceInput(): string | undefined;
    private _clusterId;
    /**
     * @stability stable
     */
    get clusterId(): string;
    /**
     * @stability stable
     */
    set clusterId(value: string);
    /**
     * @stability stable
     */
    get clusterIdInput(): string;
    private _configurationsJson?;
    /**
     * @stability stable
     */
    get configurationsJson(): string;
    /**
     * @stability stable
     */
    set configurationsJson(value: string);
    /**
     * @stability stable
     */
    resetConfigurationsJson(): void;
    /**
     * @stability stable
     */
    get configurationsJsonInput(): string | undefined;
    private _ebsOptimized?;
    /**
     * @stability stable
     */
    get ebsOptimized(): boolean;
    /**
     * @stability stable
     */
    set ebsOptimized(value: boolean);
    /**
     * @stability stable
     */
    resetEbsOptimized(): void;
    /**
     * @stability stable
     */
    get ebsOptimizedInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceCount?;
    /**
     * @stability stable
     */
    get instanceCount(): number;
    /**
     * @stability stable
     */
    set instanceCount(value: number);
    /**
     * @stability stable
     */
    resetInstanceCount(): void;
    /**
     * @stability stable
     */
    get instanceCountInput(): number | undefined;
    private _instanceType;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    get instanceTypeInput(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get runningInstanceCount(): number;
    /**
     * @stability stable
     */
    get status(): string;
    private _ebsConfig?;
    /**
     * @stability stable
     */
    get ebsConfig(): EmrInstanceGroupEbsConfig[];
    /**
     * @stability stable
     */
    set ebsConfig(value: EmrInstanceGroupEbsConfig[]);
    /**
     * @stability stable
     */
    resetEbsConfig(): void;
    /**
     * @stability stable
     */
    get ebsConfigInput(): EmrInstanceGroupEbsConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
