import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface EmrManagedScalingPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly clusterId: string;
    /**
     * compute_limits block.
     *
     * @stability stable
     */
    readonly computeLimits: EmrManagedScalingPolicyComputeLimits[];
}
/**
 * @stability stable
 */
export interface EmrManagedScalingPolicyComputeLimits {
    /**
     * @stability stable
     */
    readonly maximumCapacityUnits: number;
    /**
     * @stability stable
     */
    readonly maximumCoreCapacityUnits?: number;
    /**
     * @stability stable
     */
    readonly maximumOndemandCapacityUnits?: number;
    /**
     * @stability stable
     */
    readonly minimumCapacityUnits: number;
    /**
     * @stability stable
     */
    readonly unitType: string;
}
/**
 * @stability stable
 */
export declare class EmrManagedScalingPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: EmrManagedScalingPolicyConfig);
    private _clusterId;
    /**
     * @stability stable
     */
    get clusterId(): string;
    /**
     * @stability stable
     */
    set clusterId(value: string);
    /**
     * @stability stable
     */
    get clusterIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _computeLimits;
    /**
     * @stability stable
     */
    get computeLimits(): EmrManagedScalingPolicyComputeLimits[];
    /**
     * @stability stable
     */
    set computeLimits(value: EmrManagedScalingPolicyComputeLimits[]);
    /**
     * @stability stable
     */
    get computeLimitsInput(): EmrManagedScalingPolicyComputeLimits[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
