import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface FlowLogConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly eniId?: string;
    /**
     * @stability stable
     */
    readonly iamRoleArn?: string;
    /**
     * @stability stable
     */
    readonly logDestination?: string;
    /**
     * @stability stable
     */
    readonly logDestinationType?: string;
    /**
     * @stability stable
     */
    readonly logFormat?: string;
    /**
     * @stability stable
     */
    readonly logGroupName?: string;
    /**
     * @stability stable
     */
    readonly maxAggregationInterval?: number;
    /**
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly trafficType: string;
    /**
     * @stability stable
     */
    readonly vpcId?: string;
}
/**
 * @stability stable
 */
export declare class FlowLog extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: FlowLogConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _eniId?;
    /**
     * @stability stable
     */
    get eniId(): string;
    /**
     * @stability stable
     */
    set eniId(value: string);
    /**
     * @stability stable
     */
    resetEniId(): void;
    /**
     * @stability stable
     */
    get eniIdInput(): string | undefined;
    private _iamRoleArn?;
    /**
     * @stability stable
     */
    get iamRoleArn(): string;
    /**
     * @stability stable
     */
    set iamRoleArn(value: string);
    /**
     * @stability stable
     */
    resetIamRoleArn(): void;
    /**
     * @stability stable
     */
    get iamRoleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _logDestination?;
    /**
     * @stability stable
     */
    get logDestination(): string;
    /**
     * @stability stable
     */
    set logDestination(value: string);
    /**
     * @stability stable
     */
    resetLogDestination(): void;
    /**
     * @stability stable
     */
    get logDestinationInput(): string | undefined;
    private _logDestinationType?;
    /**
     * @stability stable
     */
    get logDestinationType(): string;
    /**
     * @stability stable
     */
    set logDestinationType(value: string);
    /**
     * @stability stable
     */
    resetLogDestinationType(): void;
    /**
     * @stability stable
     */
    get logDestinationTypeInput(): string | undefined;
    private _logFormat?;
    /**
     * @stability stable
     */
    get logFormat(): string;
    /**
     * @stability stable
     */
    set logFormat(value: string);
    /**
     * @stability stable
     */
    resetLogFormat(): void;
    /**
     * @stability stable
     */
    get logFormatInput(): string | undefined;
    private _logGroupName?;
    /**
     * @stability stable
     */
    get logGroupName(): string;
    /**
     * @stability stable
     */
    set logGroupName(value: string);
    /**
     * @stability stable
     */
    resetLogGroupName(): void;
    /**
     * @stability stable
     */
    get logGroupNameInput(): string | undefined;
    private _maxAggregationInterval?;
    /**
     * @stability stable
     */
    get maxAggregationInterval(): number;
    /**
     * @stability stable
     */
    set maxAggregationInterval(value: number);
    /**
     * @stability stable
     */
    resetMaxAggregationInterval(): void;
    /**
     * @stability stable
     */
    get maxAggregationIntervalInput(): number | undefined;
    private _subnetId?;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    resetSubnetId(): void;
    /**
     * @stability stable
     */
    get subnetIdInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _trafficType;
    /**
     * @stability stable
     */
    get trafficType(): string;
    /**
     * @stability stable
     */
    set trafficType(value: string);
    /**
     * @stability stable
     */
    get trafficTypeInput(): string;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    resetVpcId(): void;
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
