import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface FmsPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly deleteAllPolicyResources?: boolean;
    /**
     * @stability stable
     */
    readonly excludeResourceTags: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly remediationEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly resourceTags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly resourceType?: string;
    /**
     * @stability stable
     */
    readonly resourceTypeList?: string[];
    /**
     * exclude_map block.
     *
     * @stability stable
     */
    readonly excludeMap?: FmsPolicyExcludeMap[];
    /**
     * include_map block.
     *
     * @stability stable
     */
    readonly includeMap?: FmsPolicyIncludeMap[];
    /**
     * security_service_policy_data block.
     *
     * @stability stable
     */
    readonly securityServicePolicyData: FmsPolicySecurityServicePolicyData[];
}
/**
 * @stability stable
 */
export interface FmsPolicyExcludeMap {
    /**
     * @stability stable
     */
    readonly account?: string[];
    /**
     * @stability stable
     */
    readonly orgunit?: string[];
}
/**
 * @stability stable
 */
export interface FmsPolicyIncludeMap {
    /**
     * @stability stable
     */
    readonly account?: string[];
    /**
     * @stability stable
     */
    readonly orgunit?: string[];
}
/**
 * @stability stable
 */
export interface FmsPolicySecurityServicePolicyData {
    /**
     * @stability stable
     */
    readonly managedServiceData?: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export declare class FmsPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: FmsPolicyConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _deleteAllPolicyResources?;
    /**
     * @stability stable
     */
    get deleteAllPolicyResources(): boolean;
    /**
     * @stability stable
     */
    set deleteAllPolicyResources(value: boolean);
    /**
     * @stability stable
     */
    resetDeleteAllPolicyResources(): void;
    /**
     * @stability stable
     */
    get deleteAllPolicyResourcesInput(): boolean | undefined;
    private _excludeResourceTags;
    /**
     * @stability stable
     */
    get excludeResourceTags(): boolean;
    /**
     * @stability stable
     */
    set excludeResourceTags(value: boolean);
    /**
     * @stability stable
     */
    get excludeResourceTagsInput(): boolean;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get policyUpdateToken(): string;
    private _remediationEnabled?;
    /**
     * @stability stable
     */
    get remediationEnabled(): boolean;
    /**
     * @stability stable
     */
    set remediationEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetRemediationEnabled(): void;
    /**
     * @stability stable
     */
    get remediationEnabledInput(): boolean | undefined;
    private _resourceTags?;
    /**
     * @stability stable
     */
    get resourceTags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set resourceTags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetResourceTags(): void;
    /**
     * @stability stable
     */
    get resourceTagsInput(): {
        [key: string]: string;
    } | undefined;
    private _resourceType?;
    /**
     * @stability stable
     */
    get resourceType(): string;
    /**
     * @stability stable
     */
    set resourceType(value: string);
    /**
     * @stability stable
     */
    resetResourceType(): void;
    /**
     * @stability stable
     */
    get resourceTypeInput(): string | undefined;
    private _resourceTypeList?;
    /**
     * @stability stable
     */
    get resourceTypeList(): string[];
    /**
     * @stability stable
     */
    set resourceTypeList(value: string[]);
    /**
     * @stability stable
     */
    resetResourceTypeList(): void;
    /**
     * @stability stable
     */
    get resourceTypeListInput(): string[] | undefined;
    private _excludeMap?;
    /**
     * @stability stable
     */
    get excludeMap(): FmsPolicyExcludeMap[];
    /**
     * @stability stable
     */
    set excludeMap(value: FmsPolicyExcludeMap[]);
    /**
     * @stability stable
     */
    resetExcludeMap(): void;
    /**
     * @stability stable
     */
    get excludeMapInput(): FmsPolicyExcludeMap[] | undefined;
    private _includeMap?;
    /**
     * @stability stable
     */
    get includeMap(): FmsPolicyIncludeMap[];
    /**
     * @stability stable
     */
    set includeMap(value: FmsPolicyIncludeMap[]);
    /**
     * @stability stable
     */
    resetIncludeMap(): void;
    /**
     * @stability stable
     */
    get includeMapInput(): FmsPolicyIncludeMap[] | undefined;
    private _securityServicePolicyData;
    /**
     * @stability stable
     */
    get securityServicePolicyData(): FmsPolicySecurityServicePolicyData[];
    /**
     * @stability stable
     */
    set securityServicePolicyData(value: FmsPolicySecurityServicePolicyData[]);
    /**
     * @stability stable
     */
    get securityServicePolicyDataInput(): FmsPolicySecurityServicePolicyData[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
