import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface FsxLustreFileSystemConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly autoImportPolicy?: string;
    /**
     * @stability stable
     */
    readonly automaticBackupRetentionDays?: number;
    /**
     * @stability stable
     */
    readonly copyTagsToBackups?: boolean;
    /**
     * @stability stable
     */
    readonly dailyAutomaticBackupStartTime?: string;
    /**
     * @stability stable
     */
    readonly deploymentType?: string;
    /**
     * @stability stable
     */
    readonly driveCacheType?: string;
    /**
     * @stability stable
     */
    readonly exportPath?: string;
    /**
     * @stability stable
     */
    readonly importPath?: string;
    /**
     * @stability stable
     */
    readonly importedFileChunkSize?: number;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly perUnitStorageThroughput?: number;
    /**
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * @stability stable
     */
    readonly storageCapacity: number;
    /**
     * @stability stable
     */
    readonly storageType?: string;
    /**
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly weeklyMaintenanceStartTime?: string;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: FsxLustreFileSystemTimeouts;
}
/**
 * @stability stable
 */
export interface FsxLustreFileSystemTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export declare class FsxLustreFileSystem extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: FsxLustreFileSystemConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoImportPolicy?;
    /**
     * @stability stable
     */
    get autoImportPolicy(): string;
    /**
     * @stability stable
     */
    set autoImportPolicy(value: string);
    /**
     * @stability stable
     */
    resetAutoImportPolicy(): void;
    /**
     * @stability stable
     */
    get autoImportPolicyInput(): string | undefined;
    private _automaticBackupRetentionDays?;
    /**
     * @stability stable
     */
    get automaticBackupRetentionDays(): number;
    /**
     * @stability stable
     */
    set automaticBackupRetentionDays(value: number);
    /**
     * @stability stable
     */
    resetAutomaticBackupRetentionDays(): void;
    /**
     * @stability stable
     */
    get automaticBackupRetentionDaysInput(): number | undefined;
    private _copyTagsToBackups?;
    /**
     * @stability stable
     */
    get copyTagsToBackups(): boolean;
    /**
     * @stability stable
     */
    set copyTagsToBackups(value: boolean);
    /**
     * @stability stable
     */
    resetCopyTagsToBackups(): void;
    /**
     * @stability stable
     */
    get copyTagsToBackupsInput(): boolean | undefined;
    private _dailyAutomaticBackupStartTime?;
    /**
     * @stability stable
     */
    get dailyAutomaticBackupStartTime(): string;
    /**
     * @stability stable
     */
    set dailyAutomaticBackupStartTime(value: string);
    /**
     * @stability stable
     */
    resetDailyAutomaticBackupStartTime(): void;
    /**
     * @stability stable
     */
    get dailyAutomaticBackupStartTimeInput(): string | undefined;
    private _deploymentType?;
    /**
     * @stability stable
     */
    get deploymentType(): string;
    /**
     * @stability stable
     */
    set deploymentType(value: string);
    /**
     * @stability stable
     */
    resetDeploymentType(): void;
    /**
     * @stability stable
     */
    get deploymentTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get dnsName(): string;
    private _driveCacheType?;
    /**
     * @stability stable
     */
    get driveCacheType(): string;
    /**
     * @stability stable
     */
    set driveCacheType(value: string);
    /**
     * @stability stable
     */
    resetDriveCacheType(): void;
    /**
     * @stability stable
     */
    get driveCacheTypeInput(): string | undefined;
    private _exportPath?;
    /**
     * @stability stable
     */
    get exportPath(): string;
    /**
     * @stability stable
     */
    set exportPath(value: string);
    /**
     * @stability stable
     */
    resetExportPath(): void;
    /**
     * @stability stable
     */
    get exportPathInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _importPath?;
    /**
     * @stability stable
     */
    get importPath(): string;
    /**
     * @stability stable
     */
    set importPath(value: string);
    /**
     * @stability stable
     */
    resetImportPath(): void;
    /**
     * @stability stable
     */
    get importPathInput(): string | undefined;
    private _importedFileChunkSize?;
    /**
     * @stability stable
     */
    get importedFileChunkSize(): number;
    /**
     * @stability stable
     */
    set importedFileChunkSize(value: number);
    /**
     * @stability stable
     */
    resetImportedFileChunkSize(): void;
    /**
     * @stability stable
     */
    get importedFileChunkSizeInput(): number | undefined;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get mountName(): string;
    /**
     * @stability stable
     */
    get networkInterfaceIds(): string[];
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _perUnitStorageThroughput?;
    /**
     * @stability stable
     */
    get perUnitStorageThroughput(): number;
    /**
     * @stability stable
     */
    set perUnitStorageThroughput(value: number);
    /**
     * @stability stable
     */
    resetPerUnitStorageThroughput(): void;
    /**
     * @stability stable
     */
    get perUnitStorageThroughputInput(): number | undefined;
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _storageCapacity;
    /**
     * @stability stable
     */
    get storageCapacity(): number;
    /**
     * @stability stable
     */
    set storageCapacity(value: number);
    /**
     * @stability stable
     */
    get storageCapacityInput(): number;
    private _storageType?;
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    set storageType(value: string);
    /**
     * @stability stable
     */
    resetStorageType(): void;
    /**
     * @stability stable
     */
    get storageTypeInput(): string | undefined;
    private _subnetIds;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get vpcId(): string;
    private _weeklyMaintenanceStartTime?;
    /**
     * @stability stable
     */
    get weeklyMaintenanceStartTime(): string;
    /**
     * @stability stable
     */
    set weeklyMaintenanceStartTime(value: string);
    /**
     * @stability stable
     */
    resetWeeklyMaintenanceStartTime(): void;
    /**
     * @stability stable
     */
    get weeklyMaintenanceStartTimeInput(): string | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): FsxLustreFileSystemTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: FsxLustreFileSystemTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): FsxLustreFileSystemTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
