import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface FsxWindowsFileSystemConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly activeDirectoryId?: string;
    /**
     * @stability stable
     */
    readonly automaticBackupRetentionDays?: number;
    /**
     * @stability stable
     */
    readonly copyTagsToBackups?: boolean;
    /**
     * @stability stable
     */
    readonly dailyAutomaticBackupStartTime?: string;
    /**
     * @stability stable
     */
    readonly deploymentType?: string;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly preferredSubnetId?: string;
    /**
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * @stability stable
     */
    readonly skipFinalBackup?: boolean;
    /**
     * @stability stable
     */
    readonly storageCapacity: number;
    /**
     * @stability stable
     */
    readonly storageType?: string;
    /**
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly throughputCapacity: number;
    /**
     * @stability stable
     */
    readonly weeklyMaintenanceStartTime?: string;
    /**
     * self_managed_active_directory block.
     *
     * @stability stable
     */
    readonly selfManagedActiveDirectory?: FsxWindowsFileSystemSelfManagedActiveDirectory[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: FsxWindowsFileSystemTimeouts;
}
/**
 * @stability stable
 */
export interface FsxWindowsFileSystemSelfManagedActiveDirectory {
    /**
     * @stability stable
     */
    readonly dnsIps: string[];
    /**
     * @stability stable
     */
    readonly domainName: string;
    /**
     * @stability stable
     */
    readonly fileSystemAdministratorsGroup?: string;
    /**
     * @stability stable
     */
    readonly organizationalUnitDistinguishedName?: string;
    /**
     * @stability stable
     */
    readonly password: string;
    /**
     * @stability stable
     */
    readonly username: string;
}
/**
 * @stability stable
 */
export interface FsxWindowsFileSystemTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class FsxWindowsFileSystem extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: FsxWindowsFileSystemConfig);
    private _activeDirectoryId?;
    /**
     * @stability stable
     */
    get activeDirectoryId(): string;
    /**
     * @stability stable
     */
    set activeDirectoryId(value: string);
    /**
     * @stability stable
     */
    resetActiveDirectoryId(): void;
    /**
     * @stability stable
     */
    get activeDirectoryIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _automaticBackupRetentionDays?;
    /**
     * @stability stable
     */
    get automaticBackupRetentionDays(): number;
    /**
     * @stability stable
     */
    set automaticBackupRetentionDays(value: number);
    /**
     * @stability stable
     */
    resetAutomaticBackupRetentionDays(): void;
    /**
     * @stability stable
     */
    get automaticBackupRetentionDaysInput(): number | undefined;
    private _copyTagsToBackups?;
    /**
     * @stability stable
     */
    get copyTagsToBackups(): boolean;
    /**
     * @stability stable
     */
    set copyTagsToBackups(value: boolean);
    /**
     * @stability stable
     */
    resetCopyTagsToBackups(): void;
    /**
     * @stability stable
     */
    get copyTagsToBackupsInput(): boolean | undefined;
    private _dailyAutomaticBackupStartTime?;
    /**
     * @stability stable
     */
    get dailyAutomaticBackupStartTime(): string;
    /**
     * @stability stable
     */
    set dailyAutomaticBackupStartTime(value: string);
    /**
     * @stability stable
     */
    resetDailyAutomaticBackupStartTime(): void;
    /**
     * @stability stable
     */
    get dailyAutomaticBackupStartTimeInput(): string | undefined;
    private _deploymentType?;
    /**
     * @stability stable
     */
    get deploymentType(): string;
    /**
     * @stability stable
     */
    set deploymentType(value: string);
    /**
     * @stability stable
     */
    resetDeploymentType(): void;
    /**
     * @stability stable
     */
    get deploymentTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get dnsName(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get networkInterfaceIds(): string[];
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    get preferredFileServerIp(): string;
    private _preferredSubnetId?;
    /**
     * @stability stable
     */
    get preferredSubnetId(): string;
    /**
     * @stability stable
     */
    set preferredSubnetId(value: string);
    /**
     * @stability stable
     */
    resetPreferredSubnetId(): void;
    /**
     * @stability stable
     */
    get preferredSubnetIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get remoteAdministrationEndpoint(): string;
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _skipFinalBackup?;
    /**
     * @stability stable
     */
    get skipFinalBackup(): boolean;
    /**
     * @stability stable
     */
    set skipFinalBackup(value: boolean);
    /**
     * @stability stable
     */
    resetSkipFinalBackup(): void;
    /**
     * @stability stable
     */
    get skipFinalBackupInput(): boolean | undefined;
    private _storageCapacity;
    /**
     * @stability stable
     */
    get storageCapacity(): number;
    /**
     * @stability stable
     */
    set storageCapacity(value: number);
    /**
     * @stability stable
     */
    get storageCapacityInput(): number;
    private _storageType?;
    /**
     * @stability stable
     */
    get storageType(): string;
    /**
     * @stability stable
     */
    set storageType(value: string);
    /**
     * @stability stable
     */
    resetStorageType(): void;
    /**
     * @stability stable
     */
    get storageTypeInput(): string | undefined;
    private _subnetIds;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _throughputCapacity;
    /**
     * @stability stable
     */
    get throughputCapacity(): number;
    /**
     * @stability stable
     */
    set throughputCapacity(value: number);
    /**
     * @stability stable
     */
    get throughputCapacityInput(): number;
    /**
     * @stability stable
     */
    get vpcId(): string;
    private _weeklyMaintenanceStartTime?;
    /**
     * @stability stable
     */
    get weeklyMaintenanceStartTime(): string;
    /**
     * @stability stable
     */
    set weeklyMaintenanceStartTime(value: string);
    /**
     * @stability stable
     */
    resetWeeklyMaintenanceStartTime(): void;
    /**
     * @stability stable
     */
    get weeklyMaintenanceStartTimeInput(): string | undefined;
    private _selfManagedActiveDirectory?;
    /**
     * @stability stable
     */
    get selfManagedActiveDirectory(): FsxWindowsFileSystemSelfManagedActiveDirectory[];
    /**
     * @stability stable
     */
    set selfManagedActiveDirectory(value: FsxWindowsFileSystemSelfManagedActiveDirectory[]);
    /**
     * @stability stable
     */
    resetSelfManagedActiveDirectory(): void;
    /**
     * @stability stable
     */
    get selfManagedActiveDirectoryInput(): FsxWindowsFileSystemSelfManagedActiveDirectory[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): FsxWindowsFileSystemTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: FsxWindowsFileSystemTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): FsxWindowsFileSystemTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
