import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GameliftGameSessionQueueConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly destinations?: string[];
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly timeoutInSeconds?: number;
    /**
     * player_latency_policy block.
     *
     * @stability stable
     */
    readonly playerLatencyPolicy?: GameliftGameSessionQueuePlayerLatencyPolicy[];
}
/**
 * @stability stable
 */
export interface GameliftGameSessionQueuePlayerLatencyPolicy {
    /**
     * @stability stable
     */
    readonly maximumIndividualPlayerLatencyMilliseconds: number;
    /**
     * @stability stable
     */
    readonly policyDurationSeconds?: number;
}
/**
 * @stability stable
 */
export declare class GameliftGameSessionQueue extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GameliftGameSessionQueueConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _destinations?;
    /**
     * @stability stable
     */
    get destinations(): string[];
    /**
     * @stability stable
     */
    set destinations(value: string[]);
    /**
     * @stability stable
     */
    resetDestinations(): void;
    /**
     * @stability stable
     */
    get destinationsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _timeoutInSeconds?;
    /**
     * @stability stable
     */
    get timeoutInSeconds(): number;
    /**
     * @stability stable
     */
    set timeoutInSeconds(value: number);
    /**
     * @stability stable
     */
    resetTimeoutInSeconds(): void;
    /**
     * @stability stable
     */
    get timeoutInSecondsInput(): number | undefined;
    private _playerLatencyPolicy?;
    /**
     * @stability stable
     */
    get playerLatencyPolicy(): GameliftGameSessionQueuePlayerLatencyPolicy[];
    /**
     * @stability stable
     */
    set playerLatencyPolicy(value: GameliftGameSessionQueuePlayerLatencyPolicy[]);
    /**
     * @stability stable
     */
    resetPlayerLatencyPolicy(): void;
    /**
     * @stability stable
     */
    get playerLatencyPolicyInput(): GameliftGameSessionQueuePlayerLatencyPolicy[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
