import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlacierVaultLockConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly completeLock: boolean;
    /**
     * @stability stable
     */
    readonly ignoreDeletionError?: boolean;
    /**
     * @stability stable
     */
    readonly policy: string;
    /**
     * @stability stable
     */
    readonly vaultName: string;
}
/**
 * @stability stable
 */
export declare class GlacierVaultLock extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlacierVaultLockConfig);
    private _completeLock;
    /**
     * @stability stable
     */
    get completeLock(): boolean;
    /**
     * @stability stable
     */
    set completeLock(value: boolean);
    /**
     * @stability stable
     */
    get completeLockInput(): boolean;
    /**
     * @stability stable
     */
    get id(): string;
    private _ignoreDeletionError?;
    /**
     * @stability stable
     */
    get ignoreDeletionError(): boolean;
    /**
     * @stability stable
     */
    set ignoreDeletionError(value: boolean);
    /**
     * @stability stable
     */
    resetIgnoreDeletionError(): void;
    /**
     * @stability stable
     */
    get ignoreDeletionErrorInput(): boolean | undefined;
    private _policy;
    /**
     * @stability stable
     */
    get policy(): string;
    /**
     * @stability stable
     */
    set policy(value: string);
    /**
     * @stability stable
     */
    get policyInput(): string;
    private _vaultName;
    /**
     * @stability stable
     */
    get vaultName(): string;
    /**
     * @stability stable
     */
    set vaultName(value: string);
    /**
     * @stability stable
     */
    get vaultNameInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
