import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlacierVaultConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly accessPolicy?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * notification block.
     *
     * @stability stable
     */
    readonly notification?: GlacierVaultNotification[];
}
/**
 * @stability stable
 */
export interface GlacierVaultNotification {
    /**
     * @stability stable
     */
    readonly events: string[];
    /**
     * @stability stable
     */
    readonly snsTopic: string;
}
/**
 * @stability stable
 */
export declare class GlacierVault extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlacierVaultConfig);
    private _accessPolicy?;
    /**
     * @stability stable
     */
    get accessPolicy(): string;
    /**
     * @stability stable
     */
    set accessPolicy(value: string);
    /**
     * @stability stable
     */
    resetAccessPolicy(): void;
    /**
     * @stability stable
     */
    get accessPolicyInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get location(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _notification?;
    /**
     * @stability stable
     */
    get notification(): GlacierVaultNotification[];
    /**
     * @stability stable
     */
    set notification(value: GlacierVaultNotification[]);
    /**
     * @stability stable
     */
    resetNotification(): void;
    /**
     * @stability stable
     */
    get notificationInput(): GlacierVaultNotification[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
