import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlobalacceleratorAcceleratorConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly ipAddressType?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * attributes block.
     *
     * @stability stable
     */
    readonly attributes?: GlobalacceleratorAcceleratorAttributes[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: GlobalacceleratorAcceleratorTimeouts;
}
/**
 * @stability stable
 */
export declare class GlobalacceleratorAcceleratorIpSets extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get ipAddresses(): string[];
    /**
     * @stability stable
     */
    get ipFamily(): string;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorAcceleratorAttributes {
    /**
     * @stability stable
     */
    readonly flowLogsEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly flowLogsS3Bucket?: string;
    /**
     * @stability stable
     */
    readonly flowLogsS3Prefix?: string;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorAcceleratorTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class GlobalacceleratorAccelerator extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlobalacceleratorAcceleratorConfig);
    /**
     * @stability stable
     */
    get dnsName(): string;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get hostedZoneId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _ipAddressType?;
    /**
     * @stability stable
     */
    get ipAddressType(): string;
    /**
     * @stability stable
     */
    set ipAddressType(value: string);
    /**
     * @stability stable
     */
    resetIpAddressType(): void;
    /**
     * @stability stable
     */
    get ipAddressTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    ipSets(index: string): GlobalacceleratorAcceleratorIpSets;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _attributes?;
    /**
     * @stability stable
     */
    get attributes(): GlobalacceleratorAcceleratorAttributes[];
    /**
     * @stability stable
     */
    set attributes(value: GlobalacceleratorAcceleratorAttributes[]);
    /**
     * @stability stable
     */
    resetAttributes(): void;
    /**
     * @stability stable
     */
    get attributesInput(): GlobalacceleratorAcceleratorAttributes[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): GlobalacceleratorAcceleratorTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: GlobalacceleratorAcceleratorTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): GlobalacceleratorAcceleratorTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
