import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlobalacceleratorEndpointGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly endpointGroupRegion?: string;
    /**
     * @stability stable
     */
    readonly healthCheckIntervalSeconds?: number;
    /**
     * @stability stable
     */
    readonly healthCheckPath?: string;
    /**
     * @stability stable
     */
    readonly healthCheckPort?: number;
    /**
     * @stability stable
     */
    readonly healthCheckProtocol?: string;
    /**
     * @stability stable
     */
    readonly listenerArn: string;
    /**
     * @stability stable
     */
    readonly thresholdCount?: number;
    /**
     * @stability stable
     */
    readonly trafficDialPercentage?: number;
    /**
     * endpoint_configuration block.
     *
     * @stability stable
     */
    readonly endpointConfiguration?: GlobalacceleratorEndpointGroupEndpointConfiguration[];
    /**
     * port_override block.
     *
     * @stability stable
     */
    readonly portOverride?: GlobalacceleratorEndpointGroupPortOverride[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: GlobalacceleratorEndpointGroupTimeouts;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorEndpointGroupEndpointConfiguration {
    /**
     * @stability stable
     */
    readonly clientIpPreservationEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly endpointId?: string;
    /**
     * @stability stable
     */
    readonly weight?: number;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorEndpointGroupPortOverride {
    /**
     * @stability stable
     */
    readonly endpointPort: number;
    /**
     * @stability stable
     */
    readonly listenerPort: number;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorEndpointGroupTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class GlobalacceleratorEndpointGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlobalacceleratorEndpointGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _endpointGroupRegion?;
    /**
     * @stability stable
     */
    get endpointGroupRegion(): string;
    /**
     * @stability stable
     */
    set endpointGroupRegion(value: string);
    /**
     * @stability stable
     */
    resetEndpointGroupRegion(): void;
    /**
     * @stability stable
     */
    get endpointGroupRegionInput(): string | undefined;
    private _healthCheckIntervalSeconds?;
    /**
     * @stability stable
     */
    get healthCheckIntervalSeconds(): number;
    /**
     * @stability stable
     */
    set healthCheckIntervalSeconds(value: number);
    /**
     * @stability stable
     */
    resetHealthCheckIntervalSeconds(): void;
    /**
     * @stability stable
     */
    get healthCheckIntervalSecondsInput(): number | undefined;
    private _healthCheckPath?;
    /**
     * @stability stable
     */
    get healthCheckPath(): string;
    /**
     * @stability stable
     */
    set healthCheckPath(value: string);
    /**
     * @stability stable
     */
    resetHealthCheckPath(): void;
    /**
     * @stability stable
     */
    get healthCheckPathInput(): string | undefined;
    private _healthCheckPort?;
    /**
     * @stability stable
     */
    get healthCheckPort(): number;
    /**
     * @stability stable
     */
    set healthCheckPort(value: number);
    /**
     * @stability stable
     */
    resetHealthCheckPort(): void;
    /**
     * @stability stable
     */
    get healthCheckPortInput(): number | undefined;
    private _healthCheckProtocol?;
    /**
     * @stability stable
     */
    get healthCheckProtocol(): string;
    /**
     * @stability stable
     */
    set healthCheckProtocol(value: string);
    /**
     * @stability stable
     */
    resetHealthCheckProtocol(): void;
    /**
     * @stability stable
     */
    get healthCheckProtocolInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _listenerArn;
    /**
     * @stability stable
     */
    get listenerArn(): string;
    /**
     * @stability stable
     */
    set listenerArn(value: string);
    /**
     * @stability stable
     */
    get listenerArnInput(): string;
    private _thresholdCount?;
    /**
     * @stability stable
     */
    get thresholdCount(): number;
    /**
     * @stability stable
     */
    set thresholdCount(value: number);
    /**
     * @stability stable
     */
    resetThresholdCount(): void;
    /**
     * @stability stable
     */
    get thresholdCountInput(): number | undefined;
    private _trafficDialPercentage?;
    /**
     * @stability stable
     */
    get trafficDialPercentage(): number;
    /**
     * @stability stable
     */
    set trafficDialPercentage(value: number);
    /**
     * @stability stable
     */
    resetTrafficDialPercentage(): void;
    /**
     * @stability stable
     */
    get trafficDialPercentageInput(): number | undefined;
    private _endpointConfiguration?;
    /**
     * @stability stable
     */
    get endpointConfiguration(): GlobalacceleratorEndpointGroupEndpointConfiguration[];
    /**
     * @stability stable
     */
    set endpointConfiguration(value: GlobalacceleratorEndpointGroupEndpointConfiguration[]);
    /**
     * @stability stable
     */
    resetEndpointConfiguration(): void;
    /**
     * @stability stable
     */
    get endpointConfigurationInput(): GlobalacceleratorEndpointGroupEndpointConfiguration[] | undefined;
    private _portOverride?;
    /**
     * @stability stable
     */
    get portOverride(): GlobalacceleratorEndpointGroupPortOverride[];
    /**
     * @stability stable
     */
    set portOverride(value: GlobalacceleratorEndpointGroupPortOverride[]);
    /**
     * @stability stable
     */
    resetPortOverride(): void;
    /**
     * @stability stable
     */
    get portOverrideInput(): GlobalacceleratorEndpointGroupPortOverride[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): GlobalacceleratorEndpointGroupTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: GlobalacceleratorEndpointGroupTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): GlobalacceleratorEndpointGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
