import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlobalacceleratorListenerConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly acceleratorArn: string;
    /**
     * @stability stable
     */
    readonly clientAffinity?: string;
    /**
     * @stability stable
     */
    readonly protocol: string;
    /**
     * port_range block.
     *
     * @stability stable
     */
    readonly portRange: GlobalacceleratorListenerPortRange[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: GlobalacceleratorListenerTimeouts;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorListenerPortRange {
    /**
     * @stability stable
     */
    readonly fromPort?: number;
    /**
     * @stability stable
     */
    readonly toPort?: number;
}
/**
 * @stability stable
 */
export interface GlobalacceleratorListenerTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class GlobalacceleratorListener extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlobalacceleratorListenerConfig);
    private _acceleratorArn;
    /**
     * @stability stable
     */
    get acceleratorArn(): string;
    /**
     * @stability stable
     */
    set acceleratorArn(value: string);
    /**
     * @stability stable
     */
    get acceleratorArnInput(): string;
    private _clientAffinity?;
    /**
     * @stability stable
     */
    get clientAffinity(): string;
    /**
     * @stability stable
     */
    set clientAffinity(value: string);
    /**
     * @stability stable
     */
    resetClientAffinity(): void;
    /**
     * @stability stable
     */
    get clientAffinityInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _protocol;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    set protocol(value: string);
    /**
     * @stability stable
     */
    get protocolInput(): string;
    private _portRange;
    /**
     * @stability stable
     */
    get portRange(): GlobalacceleratorListenerPortRange[];
    /**
     * @stability stable
     */
    set portRange(value: GlobalacceleratorListenerPortRange[]);
    /**
     * @stability stable
     */
    get portRangeInput(): GlobalacceleratorListenerPortRange[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): GlobalacceleratorListenerTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: GlobalacceleratorListenerTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): GlobalacceleratorListenerTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
