import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlueClassifierConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * csv_classifier block.
     *
     * @stability stable
     */
    readonly csvClassifier?: GlueClassifierCsvClassifier[];
    /**
     * grok_classifier block.
     *
     * @stability stable
     */
    readonly grokClassifier?: GlueClassifierGrokClassifier[];
    /**
     * json_classifier block.
     *
     * @stability stable
     */
    readonly jsonClassifier?: GlueClassifierJsonClassifier[];
    /**
     * xml_classifier block.
     *
     * @stability stable
     */
    readonly xmlClassifier?: GlueClassifierXmlClassifier[];
}
/**
 * @stability stable
 */
export interface GlueClassifierCsvClassifier {
    /**
     * @stability stable
     */
    readonly allowSingleColumn?: boolean;
    /**
     * @stability stable
     */
    readonly containsHeader?: string;
    /**
     * @stability stable
     */
    readonly delimiter?: string;
    /**
     * @stability stable
     */
    readonly disableValueTrimming?: boolean;
    /**
     * @stability stable
     */
    readonly header?: string[];
    /**
     * @stability stable
     */
    readonly quoteSymbol?: string;
}
/**
 * @stability stable
 */
export interface GlueClassifierGrokClassifier {
    /**
     * @stability stable
     */
    readonly classification: string;
    /**
     * @stability stable
     */
    readonly customPatterns?: string;
    /**
     * @stability stable
     */
    readonly grokPattern: string;
}
/**
 * @stability stable
 */
export interface GlueClassifierJsonClassifier {
    /**
     * @stability stable
     */
    readonly jsonPath: string;
}
/**
 * @stability stable
 */
export interface GlueClassifierXmlClassifier {
    /**
     * @stability stable
     */
    readonly classification: string;
    /**
     * @stability stable
     */
    readonly rowTag: string;
}
/**
 * @stability stable
 */
export declare class GlueClassifier extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueClassifierConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _csvClassifier?;
    /**
     * @stability stable
     */
    get csvClassifier(): GlueClassifierCsvClassifier[];
    /**
     * @stability stable
     */
    set csvClassifier(value: GlueClassifierCsvClassifier[]);
    /**
     * @stability stable
     */
    resetCsvClassifier(): void;
    /**
     * @stability stable
     */
    get csvClassifierInput(): GlueClassifierCsvClassifier[] | undefined;
    private _grokClassifier?;
    /**
     * @stability stable
     */
    get grokClassifier(): GlueClassifierGrokClassifier[];
    /**
     * @stability stable
     */
    set grokClassifier(value: GlueClassifierGrokClassifier[]);
    /**
     * @stability stable
     */
    resetGrokClassifier(): void;
    /**
     * @stability stable
     */
    get grokClassifierInput(): GlueClassifierGrokClassifier[] | undefined;
    private _jsonClassifier?;
    /**
     * @stability stable
     */
    get jsonClassifier(): GlueClassifierJsonClassifier[];
    /**
     * @stability stable
     */
    set jsonClassifier(value: GlueClassifierJsonClassifier[]);
    /**
     * @stability stable
     */
    resetJsonClassifier(): void;
    /**
     * @stability stable
     */
    get jsonClassifierInput(): GlueClassifierJsonClassifier[] | undefined;
    private _xmlClassifier?;
    /**
     * @stability stable
     */
    get xmlClassifier(): GlueClassifierXmlClassifier[];
    /**
     * @stability stable
     */
    set xmlClassifier(value: GlueClassifierXmlClassifier[]);
    /**
     * @stability stable
     */
    resetXmlClassifier(): void;
    /**
     * @stability stable
     */
    get xmlClassifierInput(): GlueClassifierXmlClassifier[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
