import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlueConnectionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * @stability stable
     */
    readonly connectionProperties: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly connectionType?: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly matchCriteria?: string[];
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * physical_connection_requirements block.
     *
     * @stability stable
     */
    readonly physicalConnectionRequirements?: GlueConnectionPhysicalConnectionRequirements[];
}
/**
 * @stability stable
 */
export interface GlueConnectionPhysicalConnectionRequirements {
    /**
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * @stability stable
     */
    readonly securityGroupIdList?: string[];
    /**
     * @stability stable
     */
    readonly subnetId?: string;
}
/**
 * @stability stable
 */
export declare class GlueConnection extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueConnectionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _catalogId?;
    /**
     * @stability stable
     */
    get catalogId(): string;
    /**
     * @stability stable
     */
    set catalogId(value: string);
    /**
     * @stability stable
     */
    resetCatalogId(): void;
    /**
     * @stability stable
     */
    get catalogIdInput(): string | undefined;
    private _connectionProperties;
    /**
     * @stability stable
     */
    get connectionProperties(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set connectionProperties(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    get connectionPropertiesInput(): {
        [key: string]: string;
    };
    private _connectionType?;
    /**
     * @stability stable
     */
    get connectionType(): string;
    /**
     * @stability stable
     */
    set connectionType(value: string);
    /**
     * @stability stable
     */
    resetConnectionType(): void;
    /**
     * @stability stable
     */
    get connectionTypeInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _matchCriteria?;
    /**
     * @stability stable
     */
    get matchCriteria(): string[];
    /**
     * @stability stable
     */
    set matchCriteria(value: string[]);
    /**
     * @stability stable
     */
    resetMatchCriteria(): void;
    /**
     * @stability stable
     */
    get matchCriteriaInput(): string[] | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _physicalConnectionRequirements?;
    /**
     * @stability stable
     */
    get physicalConnectionRequirements(): GlueConnectionPhysicalConnectionRequirements[];
    /**
     * @stability stable
     */
    set physicalConnectionRequirements(value: GlueConnectionPhysicalConnectionRequirements[]);
    /**
     * @stability stable
     */
    resetPhysicalConnectionRequirements(): void;
    /**
     * @stability stable
     */
    get physicalConnectionRequirementsInput(): GlueConnectionPhysicalConnectionRequirements[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
