import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlueDataCatalogEncryptionSettingsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * data_catalog_encryption_settings block.
     *
     * @stability stable
     */
    readonly dataCatalogEncryptionSettings: GlueDataCatalogEncryptionSettingsDataCatalogEncryptionSettings[];
}
/**
 * @stability stable
 */
export interface GlueDataCatalogEncryptionSettingsDataCatalogEncryptionSettingsConnectionPasswordEncryption {
    /**
     * @stability stable
     */
    readonly awsKmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly returnConnectionPasswordEncrypted: boolean;
}
/**
 * @stability stable
 */
export interface GlueDataCatalogEncryptionSettingsDataCatalogEncryptionSettingsEncryptionAtRest {
    /**
     * @stability stable
     */
    readonly catalogEncryptionMode: string;
    /**
     * @stability stable
     */
    readonly sseAwsKmsKeyId?: string;
}
/**
 * @stability stable
 */
export interface GlueDataCatalogEncryptionSettingsDataCatalogEncryptionSettings {
    /**
     * connection_password_encryption block.
     *
     * @stability stable
     */
    readonly connectionPasswordEncryption: GlueDataCatalogEncryptionSettingsDataCatalogEncryptionSettingsConnectionPasswordEncryption[];
    /**
     * encryption_at_rest block.
     *
     * @stability stable
     */
    readonly encryptionAtRest: GlueDataCatalogEncryptionSettingsDataCatalogEncryptionSettingsEncryptionAtRest[];
}
/**
 * @stability stable
 */
export declare class GlueDataCatalogEncryptionSettings extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueDataCatalogEncryptionSettingsConfig);
    private _catalogId?;
    /**
     * @stability stable
     */
    get catalogId(): string;
    /**
     * @stability stable
     */
    set catalogId(value: string);
    /**
     * @stability stable
     */
    resetCatalogId(): void;
    /**
     * @stability stable
     */
    get catalogIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _dataCatalogEncryptionSettings;
    /**
     * @stability stable
     */
    get dataCatalogEncryptionSettings(): GlueDataCatalogEncryptionSettingsDataCatalogEncryptionSettings[];
    /**
     * @stability stable
     */
    set dataCatalogEncryptionSettings(value: GlueDataCatalogEncryptionSettingsDataCatalogEncryptionSettings[]);
    /**
     * @stability stable
     */
    get dataCatalogEncryptionSettingsInput(): GlueDataCatalogEncryptionSettingsDataCatalogEncryptionSettings[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
