import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlueDevEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly arguments?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly extraJarsS3Path?: string;
    /**
     * @stability stable
     */
    readonly extraPythonLibsS3Path?: string;
    /**
     * @stability stable
     */
    readonly glueVersion?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly numberOfNodes?: number;
    /**
     * @stability stable
     */
    readonly numberOfWorkers?: number;
    /**
     * @stability stable
     */
    readonly publicKey?: string;
    /**
     * @stability stable
     */
    readonly publicKeys?: string[];
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly securityConfiguration?: string;
    /**
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly workerType?: string;
}
/**
 * @stability stable
 */
export declare class GlueDevEndpoint extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueDevEndpointConfig);
    private _arguments?;
    /**
     * @stability stable
     */
    get arguments(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set arguments(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetArguments(): void;
    /**
     * @stability stable
     */
    get argumentsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    private _extraJarsS3Path?;
    /**
     * @stability stable
     */
    get extraJarsS3Path(): string;
    /**
     * @stability stable
     */
    set extraJarsS3Path(value: string);
    /**
     * @stability stable
     */
    resetExtraJarsS3Path(): void;
    /**
     * @stability stable
     */
    get extraJarsS3PathInput(): string | undefined;
    private _extraPythonLibsS3Path?;
    /**
     * @stability stable
     */
    get extraPythonLibsS3Path(): string;
    /**
     * @stability stable
     */
    set extraPythonLibsS3Path(value: string);
    /**
     * @stability stable
     */
    resetExtraPythonLibsS3Path(): void;
    /**
     * @stability stable
     */
    get extraPythonLibsS3PathInput(): string | undefined;
    /**
     * @stability stable
     */
    get failureReason(): string;
    private _glueVersion?;
    /**
     * @stability stable
     */
    get glueVersion(): string;
    /**
     * @stability stable
     */
    set glueVersion(value: string);
    /**
     * @stability stable
     */
    resetGlueVersion(): void;
    /**
     * @stability stable
     */
    get glueVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _numberOfNodes?;
    /**
     * @stability stable
     */
    get numberOfNodes(): number;
    /**
     * @stability stable
     */
    set numberOfNodes(value: number);
    /**
     * @stability stable
     */
    resetNumberOfNodes(): void;
    /**
     * @stability stable
     */
    get numberOfNodesInput(): number | undefined;
    private _numberOfWorkers?;
    /**
     * @stability stable
     */
    get numberOfWorkers(): number;
    /**
     * @stability stable
     */
    set numberOfWorkers(value: number);
    /**
     * @stability stable
     */
    resetNumberOfWorkers(): void;
    /**
     * @stability stable
     */
    get numberOfWorkersInput(): number | undefined;
    /**
     * @stability stable
     */
    get privateAddress(): string;
    /**
     * @stability stable
     */
    get publicAddress(): string;
    private _publicKey?;
    /**
     * @stability stable
     */
    get publicKey(): string;
    /**
     * @stability stable
     */
    set publicKey(value: string);
    /**
     * @stability stable
     */
    resetPublicKey(): void;
    /**
     * @stability stable
     */
    get publicKeyInput(): string | undefined;
    private _publicKeys?;
    /**
     * @stability stable
     */
    get publicKeys(): string[];
    /**
     * @stability stable
     */
    set publicKeys(value: string[]);
    /**
     * @stability stable
     */
    resetPublicKeys(): void;
    /**
     * @stability stable
     */
    get publicKeysInput(): string[] | undefined;
    private _roleArn;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string;
    private _securityConfiguration?;
    /**
     * @stability stable
     */
    get securityConfiguration(): string;
    /**
     * @stability stable
     */
    set securityConfiguration(value: string);
    /**
     * @stability stable
     */
    resetSecurityConfiguration(): void;
    /**
     * @stability stable
     */
    get securityConfigurationInput(): string | undefined;
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    private _subnetId?;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    resetSubnetId(): void;
    /**
     * @stability stable
     */
    get subnetIdInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get vpcId(): string;
    private _workerType?;
    /**
     * @stability stable
     */
    get workerType(): string;
    /**
     * @stability stable
     */
    set workerType(value: string);
    /**
     * @stability stable
     */
    resetWorkerType(): void;
    /**
     * @stability stable
     */
    get workerTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get yarnEndpointAddress(): string;
    /**
     * @stability stable
     */
    get zeppelinRemoteSparkInterpreterPort(): number;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
