import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlueMlTransformConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly glueVersion?: string;
    /**
     * @stability stable
     */
    readonly maxCapacity?: number;
    /**
     * @stability stable
     */
    readonly maxRetries?: number;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly numberOfWorkers?: number;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly timeout?: number;
    /**
     * @stability stable
     */
    readonly workerType?: string;
    /**
     * input_record_tables block.
     *
     * @stability stable
     */
    readonly inputRecordTables: GlueMlTransformInputRecordTables[];
    /**
     * parameters block.
     *
     * @stability stable
     */
    readonly parameters: GlueMlTransformParameters[];
}
/**
 * @stability stable
 */
export declare class GlueMlTransformSchema extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get dataType(): string;
    /**
     * @stability stable
     */
    get name(): string;
}
/**
 * @stability stable
 */
export interface GlueMlTransformInputRecordTables {
    /**
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * @stability stable
     */
    readonly connectionName?: string;
    /**
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * @stability stable
     */
    readonly tableName: string;
}
/**
 * @stability stable
 */
export interface GlueMlTransformParametersFindMatchesParameters {
    /**
     * @stability stable
     */
    readonly accuracyCostTradeOff?: number;
    /**
     * @stability stable
     */
    readonly enforceProvidedLabels?: boolean;
    /**
     * @stability stable
     */
    readonly precisionRecallTradeOff?: number;
    /**
     * @stability stable
     */
    readonly primaryKeyColumnName?: string;
}
/**
 * @stability stable
 */
export interface GlueMlTransformParameters {
    /**
     * @stability stable
     */
    readonly transformType: string;
    /**
     * find_matches_parameters block.
     *
     * @stability stable
     */
    readonly findMatchesParameters: GlueMlTransformParametersFindMatchesParameters[];
}
/**
 * @stability stable
 */
export declare class GlueMlTransform extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueMlTransformConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _glueVersion?;
    /**
     * @stability stable
     */
    get glueVersion(): string;
    /**
     * @stability stable
     */
    set glueVersion(value: string);
    /**
     * @stability stable
     */
    resetGlueVersion(): void;
    /**
     * @stability stable
     */
    get glueVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get labelCount(): number;
    private _maxCapacity?;
    /**
     * @stability stable
     */
    get maxCapacity(): number;
    /**
     * @stability stable
     */
    set maxCapacity(value: number);
    /**
     * @stability stable
     */
    resetMaxCapacity(): void;
    /**
     * @stability stable
     */
    get maxCapacityInput(): number | undefined;
    private _maxRetries?;
    /**
     * @stability stable
     */
    get maxRetries(): number;
    /**
     * @stability stable
     */
    set maxRetries(value: number);
    /**
     * @stability stable
     */
    resetMaxRetries(): void;
    /**
     * @stability stable
     */
    get maxRetriesInput(): number | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _numberOfWorkers?;
    /**
     * @stability stable
     */
    get numberOfWorkers(): number;
    /**
     * @stability stable
     */
    set numberOfWorkers(value: number);
    /**
     * @stability stable
     */
    resetNumberOfWorkers(): void;
    /**
     * @stability stable
     */
    get numberOfWorkersInput(): number | undefined;
    private _roleArn;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string;
    /**
     * @stability stable
     */
    schema(index: string): GlueMlTransformSchema;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _timeout?;
    /**
     * @stability stable
     */
    get timeout(): number;
    /**
     * @stability stable
     */
    set timeout(value: number);
    /**
     * @stability stable
     */
    resetTimeout(): void;
    /**
     * @stability stable
     */
    get timeoutInput(): number | undefined;
    private _workerType?;
    /**
     * @stability stable
     */
    get workerType(): string;
    /**
     * @stability stable
     */
    set workerType(value: string);
    /**
     * @stability stable
     */
    resetWorkerType(): void;
    /**
     * @stability stable
     */
    get workerTypeInput(): string | undefined;
    private _inputRecordTables;
    /**
     * @stability stable
     */
    get inputRecordTables(): GlueMlTransformInputRecordTables[];
    /**
     * @stability stable
     */
    set inputRecordTables(value: GlueMlTransformInputRecordTables[]);
    /**
     * @stability stable
     */
    get inputRecordTablesInput(): GlueMlTransformInputRecordTables[];
    private _parameters;
    /**
     * @stability stable
     */
    get parameters(): GlueMlTransformParameters[];
    /**
     * @stability stable
     */
    set parameters(value: GlueMlTransformParameters[]);
    /**
     * @stability stable
     */
    get parametersInput(): GlueMlTransformParameters[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
