import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GluePartitionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * @stability stable
     */
    readonly parameters?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly partitionValues: string[];
    /**
     * @stability stable
     */
    readonly tableName: string;
    /**
     * storage_descriptor block.
     *
     * @stability stable
     */
    readonly storageDescriptor?: GluePartitionStorageDescriptor[];
}
/**
 * @stability stable
 */
export interface GluePartitionStorageDescriptorColumns {
    /**
     * @stability stable
     */
    readonly comment?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export interface GluePartitionStorageDescriptorSerDeInfo {
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly parameters?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly serializationLibrary?: string;
}
/**
 * @stability stable
 */
export interface GluePartitionStorageDescriptorSkewedInfo {
    /**
     * @stability stable
     */
    readonly skewedColumnNames?: string[];
    /**
     * @stability stable
     */
    readonly skewedColumnValueLocationMaps?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly skewedColumnValues?: string[];
}
/**
 * @stability stable
 */
export interface GluePartitionStorageDescriptorSortColumns {
    /**
     * @stability stable
     */
    readonly column: string;
    /**
     * @stability stable
     */
    readonly sortOrder: number;
}
/**
 * @stability stable
 */
export interface GluePartitionStorageDescriptor {
    /**
     * @stability stable
     */
    readonly bucketColumns?: string[];
    /**
     * @stability stable
     */
    readonly compressed?: boolean;
    /**
     * @stability stable
     */
    readonly inputFormat?: string;
    /**
     * @stability stable
     */
    readonly location?: string;
    /**
     * @stability stable
     */
    readonly numberOfBuckets?: number;
    /**
     * @stability stable
     */
    readonly outputFormat?: string;
    /**
     * @stability stable
     */
    readonly parameters?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly storedAsSubDirectories?: boolean;
    /**
     * columns block.
     *
     * @stability stable
     */
    readonly columns?: GluePartitionStorageDescriptorColumns[];
    /**
     * ser_de_info block.
     *
     * @stability stable
     */
    readonly serDeInfo?: GluePartitionStorageDescriptorSerDeInfo[];
    /**
     * skewed_info block.
     *
     * @stability stable
     */
    readonly skewedInfo?: GluePartitionStorageDescriptorSkewedInfo[];
    /**
     * sort_columns block.
     *
     * @stability stable
     */
    readonly sortColumns?: GluePartitionStorageDescriptorSortColumns[];
}
/**
 * @stability stable
 */
export declare class GluePartition extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GluePartitionConfig);
    private _catalogId?;
    /**
     * @stability stable
     */
    get catalogId(): string;
    /**
     * @stability stable
     */
    set catalogId(value: string);
    /**
     * @stability stable
     */
    resetCatalogId(): void;
    /**
     * @stability stable
     */
    get catalogIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get creationTime(): string;
    private _databaseName;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    get databaseNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastAccessedTime(): string;
    /**
     * @stability stable
     */
    get lastAnalyzedTime(): string;
    private _parameters?;
    /**
     * @stability stable
     */
    get parameters(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set parameters(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetParameters(): void;
    /**
     * @stability stable
     */
    get parametersInput(): {
        [key: string]: string;
    } | undefined;
    private _partitionValues;
    /**
     * @stability stable
     */
    get partitionValues(): string[];
    /**
     * @stability stable
     */
    set partitionValues(value: string[]);
    /**
     * @stability stable
     */
    get partitionValuesInput(): string[];
    private _tableName;
    /**
     * @stability stable
     */
    get tableName(): string;
    /**
     * @stability stable
     */
    set tableName(value: string);
    /**
     * @stability stable
     */
    get tableNameInput(): string;
    private _storageDescriptor?;
    /**
     * @stability stable
     */
    get storageDescriptor(): GluePartitionStorageDescriptor[];
    /**
     * @stability stable
     */
    set storageDescriptor(value: GluePartitionStorageDescriptor[]);
    /**
     * @stability stable
     */
    resetStorageDescriptor(): void;
    /**
     * @stability stable
     */
    get storageDescriptorInput(): GluePartitionStorageDescriptor[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
