import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlueSchemaConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly compatibility: string;
    /**
     * @stability stable
     */
    readonly dataFormat: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly registryArn?: string;
    /**
     * @stability stable
     */
    readonly schemaDefinition: string;
    /**
     * @stability stable
     */
    readonly schemaName: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class GlueSchema extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueSchemaConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _compatibility;
    /**
     * @stability stable
     */
    get compatibility(): string;
    /**
     * @stability stable
     */
    set compatibility(value: string);
    /**
     * @stability stable
     */
    get compatibilityInput(): string;
    private _dataFormat;
    /**
     * @stability stable
     */
    get dataFormat(): string;
    /**
     * @stability stable
     */
    set dataFormat(value: string);
    /**
     * @stability stable
     */
    get dataFormatInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get latestSchemaVersion(): number;
    /**
     * @stability stable
     */
    get nextSchemaVersion(): number;
    private _registryArn?;
    /**
     * @stability stable
     */
    get registryArn(): string;
    /**
     * @stability stable
     */
    set registryArn(value: string);
    /**
     * @stability stable
     */
    resetRegistryArn(): void;
    /**
     * @stability stable
     */
    get registryArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get registryName(): string;
    /**
     * @stability stable
     */
    get schemaCheckpoint(): number;
    private _schemaDefinition;
    /**
     * @stability stable
     */
    get schemaDefinition(): string;
    /**
     * @stability stable
     */
    set schemaDefinition(value: string);
    /**
     * @stability stable
     */
    get schemaDefinitionInput(): string;
    private _schemaName;
    /**
     * @stability stable
     */
    get schemaName(): string;
    /**
     * @stability stable
     */
    set schemaName(value: string);
    /**
     * @stability stable
     */
    get schemaNameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
