import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlueSecurityConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * encryption_configuration block.
     *
     * @stability stable
     */
    readonly encryptionConfiguration: GlueSecurityConfigurationEncryptionConfiguration[];
}
/**
 * @stability stable
 */
export interface GlueSecurityConfigurationEncryptionConfigurationCloudwatchEncryption {
    /**
     * @stability stable
     */
    readonly cloudwatchEncryptionMode?: string;
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
}
/**
 * @stability stable
 */
export interface GlueSecurityConfigurationEncryptionConfigurationJobBookmarksEncryption {
    /**
     * @stability stable
     */
    readonly jobBookmarksEncryptionMode?: string;
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
}
/**
 * @stability stable
 */
export interface GlueSecurityConfigurationEncryptionConfigurationS3Encryption {
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * @stability stable
     */
    readonly s3EncryptionMode?: string;
}
/**
 * @stability stable
 */
export interface GlueSecurityConfigurationEncryptionConfiguration {
    /**
     * cloudwatch_encryption block.
     *
     * @stability stable
     */
    readonly cloudwatchEncryption: GlueSecurityConfigurationEncryptionConfigurationCloudwatchEncryption[];
    /**
     * job_bookmarks_encryption block.
     *
     * @stability stable
     */
    readonly jobBookmarksEncryption: GlueSecurityConfigurationEncryptionConfigurationJobBookmarksEncryption[];
    /**
     * s3_encryption block.
     *
     * @stability stable
     */
    readonly s3Encryption: GlueSecurityConfigurationEncryptionConfigurationS3Encryption[];
}
/**
 * @stability stable
 */
export declare class GlueSecurityConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueSecurityConfigurationConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _encryptionConfiguration;
    /**
     * @stability stable
     */
    get encryptionConfiguration(): GlueSecurityConfigurationEncryptionConfiguration[];
    /**
     * @stability stable
     */
    set encryptionConfiguration(value: GlueSecurityConfigurationEncryptionConfiguration[]);
    /**
     * @stability stable
     */
    get encryptionConfigurationInput(): GlueSecurityConfigurationEncryptionConfiguration[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
