import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlueTriggerConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly schedule?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly workflowName?: string;
    /**
     * actions block.
     *
     * @stability stable
     */
    readonly actions: GlueTriggerActions[];
    /**
     * predicate block.
     *
     * @stability stable
     */
    readonly predicate?: GlueTriggerPredicate[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: GlueTriggerTimeouts;
}
/**
 * @stability stable
 */
export interface GlueTriggerActionsNotificationProperty {
    /**
     * @stability stable
     */
    readonly notifyDelayAfter?: number;
}
/**
 * @stability stable
 */
export interface GlueTriggerActions {
    /**
     * @stability stable
     */
    readonly arguments?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly crawlerName?: string;
    /**
     * @stability stable
     */
    readonly jobName?: string;
    /**
     * @stability stable
     */
    readonly securityConfiguration?: string;
    /**
     * @stability stable
     */
    readonly timeout?: number;
    /**
     * notification_property block.
     *
     * @stability stable
     */
    readonly notificationProperty?: GlueTriggerActionsNotificationProperty[];
}
/**
 * @stability stable
 */
export interface GlueTriggerPredicateConditions {
    /**
     * @stability stable
     */
    readonly crawlState?: string;
    /**
     * @stability stable
     */
    readonly crawlerName?: string;
    /**
     * @stability stable
     */
    readonly jobName?: string;
    /**
     * @stability stable
     */
    readonly logicalOperator?: string;
    /**
     * @stability stable
     */
    readonly state?: string;
}
/**
 * @stability stable
 */
export interface GlueTriggerPredicate {
    /**
     * @stability stable
     */
    readonly logical?: string;
    /**
     * conditions block.
     *
     * @stability stable
     */
    readonly conditions: GlueTriggerPredicateConditions[];
}
/**
 * @stability stable
 */
export interface GlueTriggerTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export declare class GlueTrigger extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueTriggerConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _schedule?;
    /**
     * @stability stable
     */
    get schedule(): string;
    /**
     * @stability stable
     */
    set schedule(value: string);
    /**
     * @stability stable
     */
    resetSchedule(): void;
    /**
     * @stability stable
     */
    get scheduleInput(): string | undefined;
    /**
     * @stability stable
     */
    get state(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    private _workflowName?;
    /**
     * @stability stable
     */
    get workflowName(): string;
    /**
     * @stability stable
     */
    set workflowName(value: string);
    /**
     * @stability stable
     */
    resetWorkflowName(): void;
    /**
     * @stability stable
     */
    get workflowNameInput(): string | undefined;
    private _actions;
    /**
     * @stability stable
     */
    get actions(): GlueTriggerActions[];
    /**
     * @stability stable
     */
    set actions(value: GlueTriggerActions[]);
    /**
     * @stability stable
     */
    get actionsInput(): GlueTriggerActions[];
    private _predicate?;
    /**
     * @stability stable
     */
    get predicate(): GlueTriggerPredicate[];
    /**
     * @stability stable
     */
    set predicate(value: GlueTriggerPredicate[]);
    /**
     * @stability stable
     */
    resetPredicate(): void;
    /**
     * @stability stable
     */
    get predicateInput(): GlueTriggerPredicate[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): GlueTriggerTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: GlueTriggerTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): GlueTriggerTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
