import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlueUserDefinedFunctionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * @stability stable
     */
    readonly className: string;
    /**
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly ownerName: string;
    /**
     * @stability stable
     */
    readonly ownerType: string;
    /**
     * resource_uris block.
     *
     * @stability stable
     */
    readonly resourceUris?: GlueUserDefinedFunctionResourceUris[];
}
/**
 * @stability stable
 */
export interface GlueUserDefinedFunctionResourceUris {
    /**
     * @stability stable
     */
    readonly resourceType: string;
    /**
     * @stability stable
     */
    readonly uri: string;
}
/**
 * @stability stable
 */
export declare class GlueUserDefinedFunction extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GlueUserDefinedFunctionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _catalogId?;
    /**
     * @stability stable
     */
    get catalogId(): string;
    /**
     * @stability stable
     */
    set catalogId(value: string);
    /**
     * @stability stable
     */
    resetCatalogId(): void;
    /**
     * @stability stable
     */
    get catalogIdInput(): string | undefined;
    private _className;
    /**
     * @stability stable
     */
    get className(): string;
    /**
     * @stability stable
     */
    set className(value: string);
    /**
     * @stability stable
     */
    get classNameInput(): string;
    /**
     * @stability stable
     */
    get createTime(): string;
    private _databaseName;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    get databaseNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _ownerName;
    /**
     * @stability stable
     */
    get ownerName(): string;
    /**
     * @stability stable
     */
    set ownerName(value: string);
    /**
     * @stability stable
     */
    get ownerNameInput(): string;
    private _ownerType;
    /**
     * @stability stable
     */
    get ownerType(): string;
    /**
     * @stability stable
     */
    set ownerType(value: string);
    /**
     * @stability stable
     */
    get ownerTypeInput(): string;
    private _resourceUris?;
    /**
     * @stability stable
     */
    get resourceUris(): GlueUserDefinedFunctionResourceUris[];
    /**
     * @stability stable
     */
    set resourceUris(value: GlueUserDefinedFunctionResourceUris[]);
    /**
     * @stability stable
     */
    resetResourceUris(): void;
    /**
     * @stability stable
     */
    get resourceUrisInput(): GlueUserDefinedFunctionResourceUris[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
