import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GlueWorkflowConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly defaultRunProperties?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly maxConcurrentRuns?: number;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class GlueWorkflow extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: GlueWorkflowConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _defaultRunProperties?;
    /**
     * @stability stable
     */
    get defaultRunProperties(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set defaultRunProperties(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetDefaultRunProperties(): void;
    /**
     * @stability stable
     */
    get defaultRunPropertiesInput(): {
        [key: string]: string;
    } | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _maxConcurrentRuns?;
    /**
     * @stability stable
     */
    get maxConcurrentRuns(): number;
    /**
     * @stability stable
     */
    set maxConcurrentRuns(value: number);
    /**
     * @stability stable
     */
    resetMaxConcurrentRuns(): void;
    /**
     * @stability stable
     */
    get maxConcurrentRunsInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
