import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GuarddutyDetectorConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly enable?: boolean;
    /**
     * @stability stable
     */
    readonly findingPublishingFrequency?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class GuarddutyDetector extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: GuarddutyDetectorConfig);
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _enable?;
    /**
     * @stability stable
     */
    get enable(): boolean;
    /**
     * @stability stable
     */
    set enable(value: boolean);
    /**
     * @stability stable
     */
    resetEnable(): void;
    /**
     * @stability stable
     */
    get enableInput(): boolean | undefined;
    private _findingPublishingFrequency?;
    /**
     * @stability stable
     */
    get findingPublishingFrequency(): string;
    /**
     * @stability stable
     */
    set findingPublishingFrequency(value: string);
    /**
     * @stability stable
     */
    resetFindingPublishingFrequency(): void;
    /**
     * @stability stable
     */
    get findingPublishingFrequencyInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
