import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GuarddutyFilterConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly action: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly detectorId: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly rank: number;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * finding_criteria block.
     *
     * @stability stable
     */
    readonly findingCriteria: GuarddutyFilterFindingCriteria[];
}
/**
 * @stability stable
 */
export interface GuarddutyFilterFindingCriteriaCriterion {
    /**
     * @stability stable
     */
    readonly equalTo?: string[];
    /**
     * @stability stable
     */
    readonly field: string;
    /**
     * @stability stable
     */
    readonly greaterThan?: string;
    /**
     * @stability stable
     */
    readonly greaterThanOrEqual?: string;
    /**
     * @stability stable
     */
    readonly lessThan?: string;
    /**
     * @stability stable
     */
    readonly lessThanOrEqual?: string;
    /**
     * @stability stable
     */
    readonly notEquals?: string[];
}
/**
 * @stability stable
 */
export interface GuarddutyFilterFindingCriteria {
    /**
     * criterion block.
     *
     * @stability stable
     */
    readonly criterion: GuarddutyFilterFindingCriteriaCriterion[];
}
/**
 * @stability stable
 */
export declare class GuarddutyFilter extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GuarddutyFilterConfig);
    private _action;
    /**
     * @stability stable
     */
    get action(): string;
    /**
     * @stability stable
     */
    set action(value: string);
    /**
     * @stability stable
     */
    get actionInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _detectorId;
    /**
     * @stability stable
     */
    get detectorId(): string;
    /**
     * @stability stable
     */
    set detectorId(value: string);
    /**
     * @stability stable
     */
    get detectorIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _rank;
    /**
     * @stability stable
     */
    get rank(): number;
    /**
     * @stability stable
     */
    set rank(value: number);
    /**
     * @stability stable
     */
    get rankInput(): number;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _findingCriteria;
    /**
     * @stability stable
     */
    get findingCriteria(): GuarddutyFilterFindingCriteria[];
    /**
     * @stability stable
     */
    set findingCriteria(value: GuarddutyFilterFindingCriteria[]);
    /**
     * @stability stable
     */
    get findingCriteriaInput(): GuarddutyFilterFindingCriteria[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
