import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GuarddutyIpsetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly activate: boolean;
    /**
     * @stability stable
     */
    readonly detectorId: string;
    /**
     * @stability stable
     */
    readonly format: string;
    /**
     * @stability stable
     */
    readonly location: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class GuarddutyIpset extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GuarddutyIpsetConfig);
    private _activate;
    /**
     * @stability stable
     */
    get activate(): boolean;
    /**
     * @stability stable
     */
    set activate(value: boolean);
    /**
     * @stability stable
     */
    get activateInput(): boolean;
    /**
     * @stability stable
     */
    get arn(): string;
    private _detectorId;
    /**
     * @stability stable
     */
    get detectorId(): string;
    /**
     * @stability stable
     */
    set detectorId(value: string);
    /**
     * @stability stable
     */
    get detectorIdInput(): string;
    private _format;
    /**
     * @stability stable
     */
    get format(): string;
    /**
     * @stability stable
     */
    set format(value: string);
    /**
     * @stability stable
     */
    get formatInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _location;
    /**
     * @stability stable
     */
    get location(): string;
    /**
     * @stability stable
     */
    set location(value: string);
    /**
     * @stability stable
     */
    get locationInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
