import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GuarddutyMemberConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly accountId: string;
    /**
     * @stability stable
     */
    readonly detectorId: string;
    /**
     * @stability stable
     */
    readonly disableEmailNotification?: boolean;
    /**
     * @stability stable
     */
    readonly email: string;
    /**
     * @stability stable
     */
    readonly invitationMessage?: string;
    /**
     * @stability stable
     */
    readonly invite?: boolean;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: GuarddutyMemberTimeouts;
}
/**
 * @stability stable
 */
export interface GuarddutyMemberTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class GuarddutyMember extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GuarddutyMemberConfig);
    private _accountId;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    get accountIdInput(): string;
    private _detectorId;
    /**
     * @stability stable
     */
    get detectorId(): string;
    /**
     * @stability stable
     */
    set detectorId(value: string);
    /**
     * @stability stable
     */
    get detectorIdInput(): string;
    private _disableEmailNotification?;
    /**
     * @stability stable
     */
    get disableEmailNotification(): boolean;
    /**
     * @stability stable
     */
    set disableEmailNotification(value: boolean);
    /**
     * @stability stable
     */
    resetDisableEmailNotification(): void;
    /**
     * @stability stable
     */
    get disableEmailNotificationInput(): boolean | undefined;
    private _email;
    /**
     * @stability stable
     */
    get email(): string;
    /**
     * @stability stable
     */
    set email(value: string);
    /**
     * @stability stable
     */
    get emailInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _invitationMessage?;
    /**
     * @stability stable
     */
    get invitationMessage(): string;
    /**
     * @stability stable
     */
    set invitationMessage(value: string);
    /**
     * @stability stable
     */
    resetInvitationMessage(): void;
    /**
     * @stability stable
     */
    get invitationMessageInput(): string | undefined;
    private _invite?;
    /**
     * @stability stable
     */
    get invite(): boolean;
    /**
     * @stability stable
     */
    set invite(value: boolean);
    /**
     * @stability stable
     */
    resetInvite(): void;
    /**
     * @stability stable
     */
    get inviteInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get relationshipStatus(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): GuarddutyMemberTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: GuarddutyMemberTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): GuarddutyMemberTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
