import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface GuarddutyPublishingDestinationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly destinationArn: string;
    /**
     * @stability stable
     */
    readonly destinationType?: string;
    /**
     * @stability stable
     */
    readonly detectorId: string;
    /**
     * @stability stable
     */
    readonly kmsKeyArn: string;
}
/**
 * @stability stable
 */
export declare class GuarddutyPublishingDestination extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: GuarddutyPublishingDestinationConfig);
    private _destinationArn;
    /**
     * @stability stable
     */
    get destinationArn(): string;
    /**
     * @stability stable
     */
    set destinationArn(value: string);
    /**
     * @stability stable
     */
    get destinationArnInput(): string;
    private _destinationType?;
    /**
     * @stability stable
     */
    get destinationType(): string;
    /**
     * @stability stable
     */
    set destinationType(value: string);
    /**
     * @stability stable
     */
    resetDestinationType(): void;
    /**
     * @stability stable
     */
    get destinationTypeInput(): string | undefined;
    private _detectorId;
    /**
     * @stability stable
     */
    get detectorId(): string;
    /**
     * @stability stable
     */
    set detectorId(value: string);
    /**
     * @stability stable
     */
    get detectorIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyArn;
    /**
     * @stability stable
     */
    get kmsKeyArn(): string;
    /**
     * @stability stable
     */
    set kmsKeyArn(value: string);
    /**
     * @stability stable
     */
    get kmsKeyArnInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
