import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IamAccessKeyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly pgpKey?: string;
    /**
     * @stability stable
     */
    readonly status?: string;
    /**
     * @stability stable
     */
    readonly user: string;
}
/**
 * @stability stable
 */
export declare class IamAccessKey extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IamAccessKeyConfig);
    /**
     * @stability stable
     */
    get createDate(): string;
    /**
     * @stability stable
     */
    get encryptedSecret(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get keyFingerprint(): string;
    private _pgpKey?;
    /**
     * @stability stable
     */
    get pgpKey(): string;
    /**
     * @stability stable
     */
    set pgpKey(value: string);
    /**
     * @stability stable
     */
    resetPgpKey(): void;
    /**
     * @stability stable
     */
    get pgpKeyInput(): string | undefined;
    /**
     * @stability stable
     */
    get secret(): string;
    /**
     * @stability stable
     */
    get sesSmtpPasswordV4(): string;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    set status(value: string);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    private _user;
    /**
     * @stability stable
     */
    get user(): string;
    /**
     * @stability stable
     */
    set user(value: string);
    /**
     * @stability stable
     */
    get userInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
