import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IamAccountPasswordPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly allowUsersToChangePassword?: boolean;
    /**
     * @stability stable
     */
    readonly hardExpiry?: boolean;
    /**
     * @stability stable
     */
    readonly maxPasswordAge?: number;
    /**
     * @stability stable
     */
    readonly minimumPasswordLength?: number;
    /**
     * @stability stable
     */
    readonly passwordReusePrevention?: number;
    /**
     * @stability stable
     */
    readonly requireLowercaseCharacters?: boolean;
    /**
     * @stability stable
     */
    readonly requireNumbers?: boolean;
    /**
     * @stability stable
     */
    readonly requireSymbols?: boolean;
    /**
     * @stability stable
     */
    readonly requireUppercaseCharacters?: boolean;
}
/**
 * @stability stable
 */
export declare class IamAccountPasswordPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: IamAccountPasswordPolicyConfig);
    private _allowUsersToChangePassword?;
    /**
     * @stability stable
     */
    get allowUsersToChangePassword(): boolean;
    /**
     * @stability stable
     */
    set allowUsersToChangePassword(value: boolean);
    /**
     * @stability stable
     */
    resetAllowUsersToChangePassword(): void;
    /**
     * @stability stable
     */
    get allowUsersToChangePasswordInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get expirePasswords(): boolean;
    private _hardExpiry?;
    /**
     * @stability stable
     */
    get hardExpiry(): boolean;
    /**
     * @stability stable
     */
    set hardExpiry(value: boolean);
    /**
     * @stability stable
     */
    resetHardExpiry(): void;
    /**
     * @stability stable
     */
    get hardExpiryInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _maxPasswordAge?;
    /**
     * @stability stable
     */
    get maxPasswordAge(): number;
    /**
     * @stability stable
     */
    set maxPasswordAge(value: number);
    /**
     * @stability stable
     */
    resetMaxPasswordAge(): void;
    /**
     * @stability stable
     */
    get maxPasswordAgeInput(): number | undefined;
    private _minimumPasswordLength?;
    /**
     * @stability stable
     */
    get minimumPasswordLength(): number;
    /**
     * @stability stable
     */
    set minimumPasswordLength(value: number);
    /**
     * @stability stable
     */
    resetMinimumPasswordLength(): void;
    /**
     * @stability stable
     */
    get minimumPasswordLengthInput(): number | undefined;
    private _passwordReusePrevention?;
    /**
     * @stability stable
     */
    get passwordReusePrevention(): number;
    /**
     * @stability stable
     */
    set passwordReusePrevention(value: number);
    /**
     * @stability stable
     */
    resetPasswordReusePrevention(): void;
    /**
     * @stability stable
     */
    get passwordReusePreventionInput(): number | undefined;
    private _requireLowercaseCharacters?;
    /**
     * @stability stable
     */
    get requireLowercaseCharacters(): boolean;
    /**
     * @stability stable
     */
    set requireLowercaseCharacters(value: boolean);
    /**
     * @stability stable
     */
    resetRequireLowercaseCharacters(): void;
    /**
     * @stability stable
     */
    get requireLowercaseCharactersInput(): boolean | undefined;
    private _requireNumbers?;
    /**
     * @stability stable
     */
    get requireNumbers(): boolean;
    /**
     * @stability stable
     */
    set requireNumbers(value: boolean);
    /**
     * @stability stable
     */
    resetRequireNumbers(): void;
    /**
     * @stability stable
     */
    get requireNumbersInput(): boolean | undefined;
    private _requireSymbols?;
    /**
     * @stability stable
     */
    get requireSymbols(): boolean;
    /**
     * @stability stable
     */
    set requireSymbols(value: boolean);
    /**
     * @stability stable
     */
    resetRequireSymbols(): void;
    /**
     * @stability stable
     */
    get requireSymbolsInput(): boolean | undefined;
    private _requireUppercaseCharacters?;
    /**
     * @stability stable
     */
    get requireUppercaseCharacters(): boolean;
    /**
     * @stability stable
     */
    set requireUppercaseCharacters(value: boolean);
    /**
     * @stability stable
     */
    resetRequireUppercaseCharacters(): void;
    /**
     * @stability stable
     */
    get requireUppercaseCharactersInput(): boolean | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
