import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IamOpenidConnectProviderConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly clientIdList: string[];
    /**
     * @stability stable
     */
    readonly thumbprintList: string[];
    /**
     * @stability stable
     */
    readonly url: string;
}
/**
 * @stability stable
 */
export declare class IamOpenidConnectProvider extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IamOpenidConnectProviderConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _clientIdList;
    /**
     * @stability stable
     */
    get clientIdList(): string[];
    /**
     * @stability stable
     */
    set clientIdList(value: string[]);
    /**
     * @stability stable
     */
    get clientIdListInput(): string[];
    /**
     * @stability stable
     */
    get id(): string;
    private _thumbprintList;
    /**
     * @stability stable
     */
    get thumbprintList(): string[];
    /**
     * @stability stable
     */
    set thumbprintList(value: string[]);
    /**
     * @stability stable
     */
    get thumbprintListInput(): string[];
    private _url;
    /**
     * @stability stable
     */
    get url(): string;
    /**
     * @stability stable
     */
    set url(value: string);
    /**
     * @stability stable
     */
    get urlInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
