import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IamRoleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly assumeRolePolicy: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly forceDetachPolicies?: boolean;
    /**
     * @stability stable
     */
    readonly managedPolicyArns?: string[];
    /**
     * @stability stable
     */
    readonly maxSessionDuration?: number;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly path?: string;
    /**
     * @stability stable
     */
    readonly permissionsBoundary?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * inline_policy block.
     *
     * @stability stable
     */
    readonly inlinePolicy?: IamRoleInlinePolicy[];
}
/**
 * @stability stable
 */
export interface IamRoleInlinePolicy {
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly policy?: string;
}
/**
 * @stability stable
 */
export declare class IamRole extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IamRoleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _assumeRolePolicy;
    /**
     * @stability stable
     */
    get assumeRolePolicy(): string;
    /**
     * @stability stable
     */
    set assumeRolePolicy(value: string);
    /**
     * @stability stable
     */
    get assumeRolePolicyInput(): string;
    /**
     * @stability stable
     */
    get createDate(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _forceDetachPolicies?;
    /**
     * @stability stable
     */
    get forceDetachPolicies(): boolean;
    /**
     * @stability stable
     */
    set forceDetachPolicies(value: boolean);
    /**
     * @stability stable
     */
    resetForceDetachPolicies(): void;
    /**
     * @stability stable
     */
    get forceDetachPoliciesInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _managedPolicyArns?;
    /**
     * @stability stable
     */
    get managedPolicyArns(): string[];
    /**
     * @stability stable
     */
    set managedPolicyArns(value: string[]);
    /**
     * @stability stable
     */
    resetManagedPolicyArns(): void;
    /**
     * @stability stable
     */
    get managedPolicyArnsInput(): string[] | undefined;
    private _maxSessionDuration?;
    /**
     * @stability stable
     */
    get maxSessionDuration(): number;
    /**
     * @stability stable
     */
    set maxSessionDuration(value: number);
    /**
     * @stability stable
     */
    resetMaxSessionDuration(): void;
    /**
     * @stability stable
     */
    get maxSessionDurationInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _path?;
    /**
     * @stability stable
     */
    get path(): string;
    /**
     * @stability stable
     */
    set path(value: string);
    /**
     * @stability stable
     */
    resetPath(): void;
    /**
     * @stability stable
     */
    get pathInput(): string | undefined;
    private _permissionsBoundary?;
    /**
     * @stability stable
     */
    get permissionsBoundary(): string;
    /**
     * @stability stable
     */
    set permissionsBoundary(value: string);
    /**
     * @stability stable
     */
    resetPermissionsBoundary(): void;
    /**
     * @stability stable
     */
    get permissionsBoundaryInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get uniqueId(): string;
    private _inlinePolicy?;
    /**
     * @stability stable
     */
    get inlinePolicy(): IamRoleInlinePolicy[];
    /**
     * @stability stable
     */
    set inlinePolicy(value: IamRoleInlinePolicy[]);
    /**
     * @stability stable
     */
    resetInlinePolicy(): void;
    /**
     * @stability stable
     */
    get inlinePolicyInput(): IamRoleInlinePolicy[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
