import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IamSamlProviderConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly samlMetadataDocument: string;
}
/**
 * @stability stable
 */
export declare class IamSamlProvider extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IamSamlProviderConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _samlMetadataDocument;
    /**
     * @stability stable
     */
    get samlMetadataDocument(): string;
    /**
     * @stability stable
     */
    set samlMetadataDocument(value: string);
    /**
     * @stability stable
     */
    get samlMetadataDocumentInput(): string;
    /**
     * @stability stable
     */
    get validUntil(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
