import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IamServiceLinkedRoleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly awsServiceName: string;
    /**
     * @stability stable
     */
    readonly customSuffix?: string;
    /**
     * @stability stable
     */
    readonly description?: string;
}
/**
 * @stability stable
 */
export declare class IamServiceLinkedRole extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IamServiceLinkedRoleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _awsServiceName;
    /**
     * @stability stable
     */
    get awsServiceName(): string;
    /**
     * @stability stable
     */
    set awsServiceName(value: string);
    /**
     * @stability stable
     */
    get awsServiceNameInput(): string;
    /**
     * @stability stable
     */
    get createDate(): string;
    private _customSuffix?;
    /**
     * @stability stable
     */
    get customSuffix(): string;
    /**
     * @stability stable
     */
    set customSuffix(value: string);
    /**
     * @stability stable
     */
    resetCustomSuffix(): void;
    /**
     * @stability stable
     */
    get customSuffixInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get path(): string;
    /**
     * @stability stable
     */
    get uniqueId(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
