import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IamUserLoginProfileConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly passwordLength?: number;
    /**
     * @stability stable
     */
    readonly passwordResetRequired?: boolean;
    /**
     * @stability stable
     */
    readonly pgpKey: string;
    /**
     * @stability stable
     */
    readonly user: string;
}
/**
 * @stability stable
 */
export declare class IamUserLoginProfile extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IamUserLoginProfileConfig);
    /**
     * @stability stable
     */
    get encryptedPassword(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get keyFingerprint(): string;
    private _passwordLength?;
    /**
     * @stability stable
     */
    get passwordLength(): number;
    /**
     * @stability stable
     */
    set passwordLength(value: number);
    /**
     * @stability stable
     */
    resetPasswordLength(): void;
    /**
     * @stability stable
     */
    get passwordLengthInput(): number | undefined;
    private _passwordResetRequired?;
    /**
     * @stability stable
     */
    get passwordResetRequired(): boolean;
    /**
     * @stability stable
     */
    set passwordResetRequired(value: boolean);
    /**
     * @stability stable
     */
    resetPasswordResetRequired(): void;
    /**
     * @stability stable
     */
    get passwordResetRequiredInput(): boolean | undefined;
    private _pgpKey;
    /**
     * @stability stable
     */
    get pgpKey(): string;
    /**
     * @stability stable
     */
    set pgpKey(value: string);
    /**
     * @stability stable
     */
    get pgpKeyInput(): string;
    private _user;
    /**
     * @stability stable
     */
    get user(): string;
    /**
     * @stability stable
     */
    set user(value: string);
    /**
     * @stability stable
     */
    get userInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
