import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ImagebuilderDistributionConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * distribution block.
     *
     * @stability stable
     */
    readonly distribution: ImagebuilderDistributionConfigurationDistribution[];
}
/**
 * @stability stable
 */
export interface ImagebuilderDistributionConfigurationDistributionAmiDistributionConfigurationLaunchPermission {
    /**
     * @stability stable
     */
    readonly userGroups?: string[];
    /**
     * @stability stable
     */
    readonly userIds?: string[];
}
/**
 * @stability stable
 */
export interface ImagebuilderDistributionConfigurationDistributionAmiDistributionConfiguration {
    /**
     * @stability stable
     */
    readonly amiTags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly targetAccountIds?: string[];
    /**
     * launch_permission block.
     *
     * @stability stable
     */
    readonly launchPermission?: ImagebuilderDistributionConfigurationDistributionAmiDistributionConfigurationLaunchPermission[];
}
/**
 * @stability stable
 */
export interface ImagebuilderDistributionConfigurationDistribution {
    /**
     * @stability stable
     */
    readonly licenseConfigurationArns?: string[];
    /**
     * @stability stable
     */
    readonly region: string;
    /**
     * ami_distribution_configuration block.
     *
     * @stability stable
     */
    readonly amiDistributionConfiguration?: ImagebuilderDistributionConfigurationDistributionAmiDistributionConfiguration[];
}
/**
 * @stability stable
 */
export declare class ImagebuilderDistributionConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ImagebuilderDistributionConfigurationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get dateCreated(): string;
    /**
     * @stability stable
     */
    get dateUpdated(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _distribution;
    /**
     * @stability stable
     */
    get distribution(): ImagebuilderDistributionConfigurationDistribution[];
    /**
     * @stability stable
     */
    set distribution(value: ImagebuilderDistributionConfigurationDistribution[]);
    /**
     * @stability stable
     */
    get distributionInput(): ImagebuilderDistributionConfigurationDistribution[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
