import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ImagebuilderImagePipelineConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly distributionConfigurationArn?: string;
    /**
     * @stability stable
     */
    readonly enhancedImageMetadataEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly imageRecipeArn: string;
    /**
     * @stability stable
     */
    readonly infrastructureConfigurationArn: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly status?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * image_tests_configuration block.
     *
     * @stability stable
     */
    readonly imageTestsConfiguration?: ImagebuilderImagePipelineImageTestsConfiguration[];
    /**
     * schedule block.
     *
     * @stability stable
     */
    readonly schedule?: ImagebuilderImagePipelineSchedule[];
}
/**
 * @stability stable
 */
export interface ImagebuilderImagePipelineImageTestsConfiguration {
    /**
     * @stability stable
     */
    readonly imageTestsEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly timeoutMinutes?: number;
}
/**
 * @stability stable
 */
export interface ImagebuilderImagePipelineSchedule {
    /**
     * @stability stable
     */
    readonly pipelineExecutionStartCondition?: string;
    /**
     * @stability stable
     */
    readonly scheduleExpression: string;
}
/**
 * @stability stable
 */
export declare class ImagebuilderImagePipeline extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ImagebuilderImagePipelineConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get dateCreated(): string;
    /**
     * @stability stable
     */
    get dateLastRun(): string;
    /**
     * @stability stable
     */
    get dateNextRun(): string;
    /**
     * @stability stable
     */
    get dateUpdated(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _distributionConfigurationArn?;
    /**
     * @stability stable
     */
    get distributionConfigurationArn(): string;
    /**
     * @stability stable
     */
    set distributionConfigurationArn(value: string);
    /**
     * @stability stable
     */
    resetDistributionConfigurationArn(): void;
    /**
     * @stability stable
     */
    get distributionConfigurationArnInput(): string | undefined;
    private _enhancedImageMetadataEnabled?;
    /**
     * @stability stable
     */
    get enhancedImageMetadataEnabled(): boolean;
    /**
     * @stability stable
     */
    set enhancedImageMetadataEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnhancedImageMetadataEnabled(): void;
    /**
     * @stability stable
     */
    get enhancedImageMetadataEnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _imageRecipeArn;
    /**
     * @stability stable
     */
    get imageRecipeArn(): string;
    /**
     * @stability stable
     */
    set imageRecipeArn(value: string);
    /**
     * @stability stable
     */
    get imageRecipeArnInput(): string;
    private _infrastructureConfigurationArn;
    /**
     * @stability stable
     */
    get infrastructureConfigurationArn(): string;
    /**
     * @stability stable
     */
    set infrastructureConfigurationArn(value: string);
    /**
     * @stability stable
     */
    get infrastructureConfigurationArnInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get platform(): string;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    set status(value: string);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _imageTestsConfiguration?;
    /**
     * @stability stable
     */
    get imageTestsConfiguration(): ImagebuilderImagePipelineImageTestsConfiguration[];
    /**
     * @stability stable
     */
    set imageTestsConfiguration(value: ImagebuilderImagePipelineImageTestsConfiguration[]);
    /**
     * @stability stable
     */
    resetImageTestsConfiguration(): void;
    /**
     * @stability stable
     */
    get imageTestsConfigurationInput(): ImagebuilderImagePipelineImageTestsConfiguration[] | undefined;
    private _schedule?;
    /**
     * @stability stable
     */
    get schedule(): ImagebuilderImagePipelineSchedule[];
    /**
     * @stability stable
     */
    set schedule(value: ImagebuilderImagePipelineSchedule[]);
    /**
     * @stability stable
     */
    resetSchedule(): void;
    /**
     * @stability stable
     */
    get scheduleInput(): ImagebuilderImagePipelineSchedule[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
