import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ImagebuilderImageRecipeConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly parentImage: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly version: string;
    /**
     * @stability stable
     */
    readonly workingDirectory?: string;
    /**
     * block_device_mapping block.
     *
     * @stability stable
     */
    readonly blockDeviceMapping?: ImagebuilderImageRecipeBlockDeviceMapping[];
    /**
     * component block.
     *
     * @stability stable
     */
    readonly component: ImagebuilderImageRecipeComponent[];
}
/**
 * @stability stable
 */
export interface ImagebuilderImageRecipeBlockDeviceMappingEbs {
    /**
     * @stability stable
     */
    readonly deleteOnTermination?: string;
    /**
     * @stability stable
     */
    readonly encrypted?: string;
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly snapshotId?: string;
    /**
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface ImagebuilderImageRecipeBlockDeviceMapping {
    /**
     * @stability stable
     */
    readonly deviceName?: string;
    /**
     * @stability stable
     */
    readonly noDevice?: boolean;
    /**
     * @stability stable
     */
    readonly virtualName?: string;
    /**
     * ebs block.
     *
     * @stability stable
     */
    readonly ebs?: ImagebuilderImageRecipeBlockDeviceMappingEbs[];
}
/**
 * @stability stable
 */
export interface ImagebuilderImageRecipeComponent {
    /**
     * @stability stable
     */
    readonly componentArn: string;
}
/**
 * @stability stable
 */
export declare class ImagebuilderImageRecipe extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ImagebuilderImageRecipeConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get dateCreated(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get owner(): string;
    private _parentImage;
    /**
     * @stability stable
     */
    get parentImage(): string;
    /**
     * @stability stable
     */
    set parentImage(value: string);
    /**
     * @stability stable
     */
    get parentImageInput(): string;
    /**
     * @stability stable
     */
    get platform(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _version;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    set version(value: string);
    /**
     * @stability stable
     */
    get versionInput(): string;
    private _workingDirectory?;
    /**
     * @stability stable
     */
    get workingDirectory(): string;
    /**
     * @stability stable
     */
    set workingDirectory(value: string);
    /**
     * @stability stable
     */
    resetWorkingDirectory(): void;
    /**
     * @stability stable
     */
    get workingDirectoryInput(): string | undefined;
    private _blockDeviceMapping?;
    /**
     * @stability stable
     */
    get blockDeviceMapping(): ImagebuilderImageRecipeBlockDeviceMapping[];
    /**
     * @stability stable
     */
    set blockDeviceMapping(value: ImagebuilderImageRecipeBlockDeviceMapping[]);
    /**
     * @stability stable
     */
    resetBlockDeviceMapping(): void;
    /**
     * @stability stable
     */
    get blockDeviceMappingInput(): ImagebuilderImageRecipeBlockDeviceMapping[] | undefined;
    private _component;
    /**
     * @stability stable
     */
    get component(): ImagebuilderImageRecipeComponent[];
    /**
     * @stability stable
     */
    set component(value: ImagebuilderImageRecipeComponent[]);
    /**
     * @stability stable
     */
    get componentInput(): ImagebuilderImageRecipeComponent[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
