import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ImagebuilderImageConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly distributionConfigurationArn?: string;
    /**
     * @stability stable
     */
    readonly enhancedImageMetadataEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly imageRecipeArn: string;
    /**
     * @stability stable
     */
    readonly infrastructureConfigurationArn: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * image_tests_configuration block.
     *
     * @stability stable
     */
    readonly imageTestsConfiguration?: ImagebuilderImageImageTestsConfiguration[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: ImagebuilderImageTimeouts;
}
/**
 * @stability stable
 */
export declare class ImagebuilderImageOutputResourcesAmis extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get image(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get region(): string;
}
/**
 * @stability stable
 */
export declare class ImagebuilderImageOutputResources extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get amis(): any;
}
/**
 * @stability stable
 */
export interface ImagebuilderImageImageTestsConfiguration {
    /**
     * @stability stable
     */
    readonly imageTestsEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly timeoutMinutes?: number;
}
/**
 * @stability stable
 */
export interface ImagebuilderImageTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
}
/**
 * @stability stable
 */
export declare class ImagebuilderImage extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ImagebuilderImageConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get dateCreated(): string;
    private _distributionConfigurationArn?;
    /**
     * @stability stable
     */
    get distributionConfigurationArn(): string;
    /**
     * @stability stable
     */
    set distributionConfigurationArn(value: string);
    /**
     * @stability stable
     */
    resetDistributionConfigurationArn(): void;
    /**
     * @stability stable
     */
    get distributionConfigurationArnInput(): string | undefined;
    private _enhancedImageMetadataEnabled?;
    /**
     * @stability stable
     */
    get enhancedImageMetadataEnabled(): boolean;
    /**
     * @stability stable
     */
    set enhancedImageMetadataEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnhancedImageMetadataEnabled(): void;
    /**
     * @stability stable
     */
    get enhancedImageMetadataEnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _imageRecipeArn;
    /**
     * @stability stable
     */
    get imageRecipeArn(): string;
    /**
     * @stability stable
     */
    set imageRecipeArn(value: string);
    /**
     * @stability stable
     */
    get imageRecipeArnInput(): string;
    private _infrastructureConfigurationArn;
    /**
     * @stability stable
     */
    get infrastructureConfigurationArn(): string;
    /**
     * @stability stable
     */
    set infrastructureConfigurationArn(value: string);
    /**
     * @stability stable
     */
    get infrastructureConfigurationArnInput(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get osVersion(): string;
    /**
     * @stability stable
     */
    outputResources(index: string): ImagebuilderImageOutputResources;
    /**
     * @stability stable
     */
    get platform(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get version(): string;
    private _imageTestsConfiguration?;
    /**
     * @stability stable
     */
    get imageTestsConfiguration(): ImagebuilderImageImageTestsConfiguration[];
    /**
     * @stability stable
     */
    set imageTestsConfiguration(value: ImagebuilderImageImageTestsConfiguration[]);
    /**
     * @stability stable
     */
    resetImageTestsConfiguration(): void;
    /**
     * @stability stable
     */
    get imageTestsConfigurationInput(): ImagebuilderImageImageTestsConfiguration[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): ImagebuilderImageTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: ImagebuilderImageTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ImagebuilderImageTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
