import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface InstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly ami: string;
    /**
     * @stability stable
     */
    readonly associatePublicIpAddress?: boolean;
    /**
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * @stability stable
     */
    readonly cpuCoreCount?: number;
    /**
     * @stability stable
     */
    readonly cpuThreadsPerCore?: number;
    /**
     * @stability stable
     */
    readonly disableApiTermination?: boolean;
    /**
     * @stability stable
     */
    readonly ebsOptimized?: boolean;
    /**
     * @stability stable
     */
    readonly fetchPasswordData?: boolean;
    /**
     * @stability stable
     */
    readonly hibernation?: boolean;
    /**
     * @stability stable
     */
    readonly hostId?: string;
    /**
     * @stability stable
     */
    readonly iamInstanceProfile?: string;
    /**
     * @stability stable
     */
    readonly instanceInitiatedShutdownBehavior?: string;
    /**
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * @stability stable
     */
    readonly ipv6AddressCount?: number;
    /**
     * @stability stable
     */
    readonly ipv6Addresses?: string[];
    /**
     * @stability stable
     */
    readonly keyName?: string;
    /**
     * @stability stable
     */
    readonly monitoring?: boolean;
    /**
     * @stability stable
     */
    readonly placementGroup?: string;
    /**
     * @stability stable
     */
    readonly privateIp?: string;
    /**
     * @stability stable
     */
    readonly secondaryPrivateIps?: string[];
    /**
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * @stability stable
     */
    readonly sourceDestCheck?: boolean;
    /**
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly tenancy?: string;
    /**
     * @stability stable
     */
    readonly userData?: string;
    /**
     * @stability stable
     */
    readonly userDataBase64?: string;
    /**
     * @stability stable
     */
    readonly volumeTags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcSecurityGroupIds?: string[];
    /**
     * credit_specification block.
     *
     * @stability stable
     */
    readonly creditSpecification?: InstanceCreditSpecification[];
    /**
     * ebs_block_device block.
     *
     * @stability stable
     */
    readonly ebsBlockDevice?: InstanceEbsBlockDevice[];
    /**
     * enclave_options block.
     *
     * @stability stable
     */
    readonly enclaveOptions?: InstanceEnclaveOptions[];
    /**
     * ephemeral_block_device block.
     *
     * @stability stable
     */
    readonly ephemeralBlockDevice?: InstanceEphemeralBlockDevice[];
    /**
     * metadata_options block.
     *
     * @stability stable
     */
    readonly metadataOptions?: InstanceMetadataOptions[];
    /**
     * network_interface block.
     *
     * @stability stable
     */
    readonly networkInterface?: InstanceNetworkInterface[];
    /**
     * root_block_device block.
     *
     * @stability stable
     */
    readonly rootBlockDevice?: InstanceRootBlockDevice[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: InstanceTimeouts;
}
/**
 * @stability stable
 */
export interface InstanceCreditSpecification {
    /**
     * @stability stable
     */
    readonly cpuCredits?: string;
}
/**
 * @stability stable
 */
export interface InstanceEbsBlockDevice {
    /**
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly snapshotId?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface InstanceEnclaveOptions {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
}
/**
 * @stability stable
 */
export interface InstanceEphemeralBlockDevice {
    /**
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * @stability stable
     */
    readonly noDevice?: boolean;
    /**
     * @stability stable
     */
    readonly virtualName?: string;
}
/**
 * @stability stable
 */
export interface InstanceMetadataOptions {
    /**
     * @stability stable
     */
    readonly httpEndpoint?: string;
    /**
     * @stability stable
     */
    readonly httpPutResponseHopLimit?: number;
    /**
     * @stability stable
     */
    readonly httpTokens?: string;
}
/**
 * @stability stable
 */
export interface InstanceNetworkInterface {
    /**
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * @stability stable
     */
    readonly deviceIndex: number;
    /**
     * @stability stable
     */
    readonly networkInterfaceId: string;
}
/**
 * @stability stable
 */
export interface InstanceRootBlockDevice {
    /**
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface InstanceTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class Instance extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: InstanceConfig);
    private _ami;
    /**
     * @stability stable
     */
    get ami(): string;
    /**
     * @stability stable
     */
    set ami(value: string);
    /**
     * @stability stable
     */
    get amiInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _associatePublicIpAddress?;
    /**
     * @stability stable
     */
    get associatePublicIpAddress(): boolean;
    /**
     * @stability stable
     */
    set associatePublicIpAddress(value: boolean);
    /**
     * @stability stable
     */
    resetAssociatePublicIpAddress(): void;
    /**
     * @stability stable
     */
    get associatePublicIpAddressInput(): boolean | undefined;
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    private _cpuCoreCount?;
    /**
     * @stability stable
     */
    get cpuCoreCount(): number;
    /**
     * @stability stable
     */
    set cpuCoreCount(value: number);
    /**
     * @stability stable
     */
    resetCpuCoreCount(): void;
    /**
     * @stability stable
     */
    get cpuCoreCountInput(): number | undefined;
    private _cpuThreadsPerCore?;
    /**
     * @stability stable
     */
    get cpuThreadsPerCore(): number;
    /**
     * @stability stable
     */
    set cpuThreadsPerCore(value: number);
    /**
     * @stability stable
     */
    resetCpuThreadsPerCore(): void;
    /**
     * @stability stable
     */
    get cpuThreadsPerCoreInput(): number | undefined;
    private _disableApiTermination?;
    /**
     * @stability stable
     */
    get disableApiTermination(): boolean;
    /**
     * @stability stable
     */
    set disableApiTermination(value: boolean);
    /**
     * @stability stable
     */
    resetDisableApiTermination(): void;
    /**
     * @stability stable
     */
    get disableApiTerminationInput(): boolean | undefined;
    private _ebsOptimized?;
    /**
     * @stability stable
     */
    get ebsOptimized(): boolean;
    /**
     * @stability stable
     */
    set ebsOptimized(value: boolean);
    /**
     * @stability stable
     */
    resetEbsOptimized(): void;
    /**
     * @stability stable
     */
    get ebsOptimizedInput(): boolean | undefined;
    private _getPasswordData?;
    /**
     * @stability stable
     */
    get fetchPasswordData(): boolean;
    /**
     * @stability stable
     */
    set fetchPasswordData(value: boolean);
    /**
     * @stability stable
     */
    resetFetchPasswordData(): void;
    /**
     * @stability stable
     */
    get fetchPasswordDataInput(): boolean | undefined;
    private _hibernation?;
    /**
     * @stability stable
     */
    get hibernation(): boolean;
    /**
     * @stability stable
     */
    set hibernation(value: boolean);
    /**
     * @stability stable
     */
    resetHibernation(): void;
    /**
     * @stability stable
     */
    get hibernationInput(): boolean | undefined;
    private _hostId?;
    /**
     * @stability stable
     */
    get hostId(): string;
    /**
     * @stability stable
     */
    set hostId(value: string);
    /**
     * @stability stable
     */
    resetHostId(): void;
    /**
     * @stability stable
     */
    get hostIdInput(): string | undefined;
    private _iamInstanceProfile?;
    /**
     * @stability stable
     */
    get iamInstanceProfile(): string;
    /**
     * @stability stable
     */
    set iamInstanceProfile(value: string);
    /**
     * @stability stable
     */
    resetIamInstanceProfile(): void;
    /**
     * @stability stable
     */
    get iamInstanceProfileInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceInitiatedShutdownBehavior?;
    /**
     * @stability stable
     */
    get instanceInitiatedShutdownBehavior(): string;
    /**
     * @stability stable
     */
    set instanceInitiatedShutdownBehavior(value: string);
    /**
     * @stability stable
     */
    resetInstanceInitiatedShutdownBehavior(): void;
    /**
     * @stability stable
     */
    get instanceInitiatedShutdownBehaviorInput(): string | undefined;
    /**
     * @stability stable
     */
    get instanceState(): string;
    private _instanceType;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    get instanceTypeInput(): string;
    private _ipv6AddressCount?;
    /**
     * @stability stable
     */
    get ipv6AddressCount(): number;
    /**
     * @stability stable
     */
    set ipv6AddressCount(value: number);
    /**
     * @stability stable
     */
    resetIpv6AddressCount(): void;
    /**
     * @stability stable
     */
    get ipv6AddressCountInput(): number | undefined;
    private _ipv6Addresses?;
    /**
     * @stability stable
     */
    get ipv6Addresses(): string[];
    /**
     * @stability stable
     */
    set ipv6Addresses(value: string[]);
    /**
     * @stability stable
     */
    resetIpv6Addresses(): void;
    /**
     * @stability stable
     */
    get ipv6AddressesInput(): string[] | undefined;
    private _keyName?;
    /**
     * @stability stable
     */
    get keyName(): string;
    /**
     * @stability stable
     */
    set keyName(value: string);
    /**
     * @stability stable
     */
    resetKeyName(): void;
    /**
     * @stability stable
     */
    get keyNameInput(): string | undefined;
    private _monitoring?;
    /**
     * @stability stable
     */
    get monitoring(): boolean;
    /**
     * @stability stable
     */
    set monitoring(value: boolean);
    /**
     * @stability stable
     */
    resetMonitoring(): void;
    /**
     * @stability stable
     */
    get monitoringInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get outpostArn(): string;
    /**
     * @stability stable
     */
    get passwordData(): string;
    private _placementGroup?;
    /**
     * @stability stable
     */
    get placementGroup(): string;
    /**
     * @stability stable
     */
    set placementGroup(value: string);
    /**
     * @stability stable
     */
    resetPlacementGroup(): void;
    /**
     * @stability stable
     */
    get placementGroupInput(): string | undefined;
    /**
     * @stability stable
     */
    get primaryNetworkInterfaceId(): string;
    /**
     * @stability stable
     */
    get privateDns(): string;
    private _privateIp?;
    /**
     * @stability stable
     */
    get privateIp(): string;
    /**
     * @stability stable
     */
    set privateIp(value: string);
    /**
     * @stability stable
     */
    resetPrivateIp(): void;
    /**
     * @stability stable
     */
    get privateIpInput(): string | undefined;
    /**
     * @stability stable
     */
    get publicDns(): string;
    /**
     * @stability stable
     */
    get publicIp(): string;
    private _secondaryPrivateIps?;
    /**
     * @stability stable
     */
    get secondaryPrivateIps(): string[];
    /**
     * @stability stable
     */
    set secondaryPrivateIps(value: string[]);
    /**
     * @stability stable
     */
    resetSecondaryPrivateIps(): void;
    /**
     * @stability stable
     */
    get secondaryPrivateIpsInput(): string[] | undefined;
    private _securityGroups?;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    set securityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroups(): void;
    /**
     * @stability stable
     */
    get securityGroupsInput(): string[] | undefined;
    private _sourceDestCheck?;
    /**
     * @stability stable
     */
    get sourceDestCheck(): boolean;
    /**
     * @stability stable
     */
    set sourceDestCheck(value: boolean);
    /**
     * @stability stable
     */
    resetSourceDestCheck(): void;
    /**
     * @stability stable
     */
    get sourceDestCheckInput(): boolean | undefined;
    private _subnetId?;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    resetSubnetId(): void;
    /**
     * @stability stable
     */
    get subnetIdInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tenancy?;
    /**
     * @stability stable
     */
    get tenancy(): string;
    /**
     * @stability stable
     */
    set tenancy(value: string);
    /**
     * @stability stable
     */
    resetTenancy(): void;
    /**
     * @stability stable
     */
    get tenancyInput(): string | undefined;
    private _userData?;
    /**
     * @stability stable
     */
    get userData(): string;
    /**
     * @stability stable
     */
    set userData(value: string);
    /**
     * @stability stable
     */
    resetUserData(): void;
    /**
     * @stability stable
     */
    get userDataInput(): string | undefined;
    private _userDataBase64?;
    /**
     * @stability stable
     */
    get userDataBase64(): string;
    /**
     * @stability stable
     */
    set userDataBase64(value: string);
    /**
     * @stability stable
     */
    resetUserDataBase64(): void;
    /**
     * @stability stable
     */
    get userDataBase64Input(): string | undefined;
    private _volumeTags?;
    /**
     * @stability stable
     */
    get volumeTags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set volumeTags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetVolumeTags(): void;
    /**
     * @stability stable
     */
    get volumeTagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcSecurityGroupIds?;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set vpcSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetVpcSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIdsInput(): string[] | undefined;
    private _creditSpecification?;
    /**
     * @stability stable
     */
    get creditSpecification(): InstanceCreditSpecification[];
    /**
     * @stability stable
     */
    set creditSpecification(value: InstanceCreditSpecification[]);
    /**
     * @stability stable
     */
    resetCreditSpecification(): void;
    /**
     * @stability stable
     */
    get creditSpecificationInput(): InstanceCreditSpecification[] | undefined;
    private _ebsBlockDevice?;
    /**
     * @stability stable
     */
    get ebsBlockDevice(): InstanceEbsBlockDevice[];
    /**
     * @stability stable
     */
    set ebsBlockDevice(value: InstanceEbsBlockDevice[]);
    /**
     * @stability stable
     */
    resetEbsBlockDevice(): void;
    /**
     * @stability stable
     */
    get ebsBlockDeviceInput(): InstanceEbsBlockDevice[] | undefined;
    private _enclaveOptions?;
    /**
     * @stability stable
     */
    get enclaveOptions(): InstanceEnclaveOptions[];
    /**
     * @stability stable
     */
    set enclaveOptions(value: InstanceEnclaveOptions[]);
    /**
     * @stability stable
     */
    resetEnclaveOptions(): void;
    /**
     * @stability stable
     */
    get enclaveOptionsInput(): InstanceEnclaveOptions[] | undefined;
    private _ephemeralBlockDevice?;
    /**
     * @stability stable
     */
    get ephemeralBlockDevice(): InstanceEphemeralBlockDevice[];
    /**
     * @stability stable
     */
    set ephemeralBlockDevice(value: InstanceEphemeralBlockDevice[]);
    /**
     * @stability stable
     */
    resetEphemeralBlockDevice(): void;
    /**
     * @stability stable
     */
    get ephemeralBlockDeviceInput(): InstanceEphemeralBlockDevice[] | undefined;
    private _metadataOptions?;
    /**
     * @stability stable
     */
    get metadataOptions(): InstanceMetadataOptions[];
    /**
     * @stability stable
     */
    set metadataOptions(value: InstanceMetadataOptions[]);
    /**
     * @stability stable
     */
    resetMetadataOptions(): void;
    /**
     * @stability stable
     */
    get metadataOptionsInput(): InstanceMetadataOptions[] | undefined;
    private _networkInterface?;
    /**
     * @stability stable
     */
    get networkInterface(): InstanceNetworkInterface[];
    /**
     * @stability stable
     */
    set networkInterface(value: InstanceNetworkInterface[]);
    /**
     * @stability stable
     */
    resetNetworkInterface(): void;
    /**
     * @stability stable
     */
    get networkInterfaceInput(): InstanceNetworkInterface[] | undefined;
    private _rootBlockDevice?;
    /**
     * @stability stable
     */
    get rootBlockDevice(): InstanceRootBlockDevice[];
    /**
     * @stability stable
     */
    set rootBlockDevice(value: InstanceRootBlockDevice[]);
    /**
     * @stability stable
     */
    resetRootBlockDevice(): void;
    /**
     * @stability stable
     */
    get rootBlockDeviceInput(): InstanceRootBlockDevice[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): InstanceTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: InstanceTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): InstanceTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
