import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IotCertificateConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly active: boolean;
    /**
     * @stability stable
     */
    readonly csr?: string;
}
/**
 * @stability stable
 */
export declare class IotCertificate extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IotCertificateConfig);
    private _active;
    /**
     * @stability stable
     */
    get active(): boolean;
    /**
     * @stability stable
     */
    set active(value: boolean);
    /**
     * @stability stable
     */
    get activeInput(): boolean;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get certificatePem(): string;
    private _csr?;
    /**
     * @stability stable
     */
    get csr(): string;
    /**
     * @stability stable
     */
    set csr(value: string);
    /**
     * @stability stable
     */
    resetCsr(): void;
    /**
     * @stability stable
     */
    get csrInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get privateKey(): string;
    /**
     * @stability stable
     */
    get publicKey(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
