import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IotRoleAliasConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly alias: string;
    /**
     * @stability stable
     */
    readonly credentialDuration?: number;
    /**
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export declare class IotRoleAlias extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IotRoleAliasConfig);
    private _alias;
    /**
     * @stability stable
     */
    get alias(): string;
    /**
     * @stability stable
     */
    set alias(value: string);
    /**
     * @stability stable
     */
    get aliasInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _credentialDuration?;
    /**
     * @stability stable
     */
    get credentialDuration(): number;
    /**
     * @stability stable
     */
    set credentialDuration(value: number);
    /**
     * @stability stable
     */
    resetCredentialDuration(): void;
    /**
     * @stability stable
     */
    get credentialDurationInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _roleArn;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
