import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IotThingTypeConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly deprecated?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * properties block.
     *
     * @stability stable
     */
    readonly properties?: IotThingTypeProperties[];
}
/**
 * @stability stable
 */
export interface IotThingTypeProperties {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly searchableAttributes?: string[];
}
/**
 * @stability stable
 */
export declare class IotThingType extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IotThingTypeConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _deprecated?;
    /**
     * @stability stable
     */
    get deprecated(): boolean;
    /**
     * @stability stable
     */
    set deprecated(value: boolean);
    /**
     * @stability stable
     */
    resetDeprecated(): void;
    /**
     * @stability stable
     */
    get deprecatedInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _properties?;
    /**
     * @stability stable
     */
    get properties(): IotThingTypeProperties[];
    /**
     * @stability stable
     */
    set properties(value: IotThingTypeProperties[]);
    /**
     * @stability stable
     */
    resetProperties(): void;
    /**
     * @stability stable
     */
    get propertiesInput(): IotThingTypeProperties[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
