import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IotThingConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly attributes?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly thingTypeName?: string;
}
/**
 * @stability stable
 */
export declare class IotThing extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IotThingConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _attributes?;
    /**
     * @stability stable
     */
    get attributes(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set attributes(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetAttributes(): void;
    /**
     * @stability stable
     */
    get attributesInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get defaultClientId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _thingTypeName?;
    /**
     * @stability stable
     */
    get thingTypeName(): string;
    /**
     * @stability stable
     */
    set thingTypeName(value: string);
    /**
     * @stability stable
     */
    resetThingTypeName(): void;
    /**
     * @stability stable
     */
    get thingTypeNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get version(): number;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
