import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IotTopicRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly enabled: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly sql: string;
    /**
     * @stability stable
     */
    readonly sqlVersion: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * cloudwatch_alarm block.
     *
     * @stability stable
     */
    readonly cloudwatchAlarm?: IotTopicRuleCloudwatchAlarm[];
    /**
     * cloudwatch_metric block.
     *
     * @stability stable
     */
    readonly cloudwatchMetric?: IotTopicRuleCloudwatchMetric[];
    /**
     * dynamodb block.
     *
     * @stability stable
     */
    readonly dynamodb?: IotTopicRuleDynamodb[];
    /**
     * dynamodbv2 block.
     *
     * @stability stable
     */
    readonly dynamodbv2?: IotTopicRuleDynamodbv2[];
    /**
     * elasticsearch block.
     *
     * @stability stable
     */
    readonly elasticsearch?: IotTopicRuleElasticsearch[];
    /**
     * error_action block.
     *
     * @stability stable
     */
    readonly errorAction?: IotTopicRuleErrorAction[];
    /**
     * firehose block.
     *
     * @stability stable
     */
    readonly firehose?: IotTopicRuleFirehose[];
    /**
     * iot_analytics block.
     *
     * @stability stable
     */
    readonly iotAnalytics?: IotTopicRuleIotAnalytics[];
    /**
     * iot_events block.
     *
     * @stability stable
     */
    readonly iotEvents?: IotTopicRuleIotEvents[];
    /**
     * kinesis block.
     *
     * @stability stable
     */
    readonly kinesis?: IotTopicRuleKinesis[];
    /**
     * lambda block.
     *
     * @stability stable
     */
    readonly lambda?: IotTopicRuleLambda[];
    /**
     * republish block.
     *
     * @stability stable
     */
    readonly republish?: IotTopicRuleRepublish[];
    /**
     * s3 block.
     *
     * @stability stable
     */
    readonly s3?: IotTopicRuleS3[];
    /**
     * sns block.
     *
     * @stability stable
     */
    readonly sns?: IotTopicRuleSns[];
    /**
     * sqs block.
     *
     * @stability stable
     */
    readonly sqs?: IotTopicRuleSqs[];
    /**
     * step_functions block.
     *
     * @stability stable
     */
    readonly stepFunctions?: IotTopicRuleStepFunctions[];
}
/**
 * @stability stable
 */
export interface IotTopicRuleCloudwatchAlarm {
    /**
     * @stability stable
     */
    readonly alarmName: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly stateReason: string;
    /**
     * @stability stable
     */
    readonly stateValue: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleCloudwatchMetric {
    /**
     * @stability stable
     */
    readonly metricName: string;
    /**
     * @stability stable
     */
    readonly metricNamespace: string;
    /**
     * @stability stable
     */
    readonly metricTimestamp?: string;
    /**
     * @stability stable
     */
    readonly metricUnit: string;
    /**
     * @stability stable
     */
    readonly metricValue: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleDynamodb {
    /**
     * @stability stable
     */
    readonly hashKeyField: string;
    /**
     * @stability stable
     */
    readonly hashKeyType?: string;
    /**
     * @stability stable
     */
    readonly hashKeyValue: string;
    /**
     * @stability stable
     */
    readonly operation?: string;
    /**
     * @stability stable
     */
    readonly payloadField?: string;
    /**
     * @stability stable
     */
    readonly rangeKeyField?: string;
    /**
     * @stability stable
     */
    readonly rangeKeyType?: string;
    /**
     * @stability stable
     */
    readonly rangeKeyValue?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly tableName: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleDynamodbv2PutItem {
    /**
     * @stability stable
     */
    readonly tableName: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleDynamodbv2 {
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * put_item block.
     *
     * @stability stable
     */
    readonly putItem?: IotTopicRuleDynamodbv2PutItem[];
}
/**
 * @stability stable
 */
export interface IotTopicRuleElasticsearch {
    /**
     * @stability stable
     */
    readonly endpoint: string;
    /**
     * @stability stable
     */
    readonly id: string;
    /**
     * @stability stable
     */
    readonly index: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionCloudwatchAlarm {
    /**
     * @stability stable
     */
    readonly alarmName: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly stateReason: string;
    /**
     * @stability stable
     */
    readonly stateValue: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionCloudwatchMetric {
    /**
     * @stability stable
     */
    readonly metricName: string;
    /**
     * @stability stable
     */
    readonly metricNamespace: string;
    /**
     * @stability stable
     */
    readonly metricTimestamp?: string;
    /**
     * @stability stable
     */
    readonly metricUnit: string;
    /**
     * @stability stable
     */
    readonly metricValue: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionDynamodb {
    /**
     * @stability stable
     */
    readonly hashKeyField: string;
    /**
     * @stability stable
     */
    readonly hashKeyType?: string;
    /**
     * @stability stable
     */
    readonly hashKeyValue: string;
    /**
     * @stability stable
     */
    readonly operation?: string;
    /**
     * @stability stable
     */
    readonly payloadField?: string;
    /**
     * @stability stable
     */
    readonly rangeKeyField?: string;
    /**
     * @stability stable
     */
    readonly rangeKeyType?: string;
    /**
     * @stability stable
     */
    readonly rangeKeyValue?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly tableName: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionDynamodbv2PutItem {
    /**
     * @stability stable
     */
    readonly tableName: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionDynamodbv2 {
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * put_item block.
     *
     * @stability stable
     */
    readonly putItem?: IotTopicRuleErrorActionDynamodbv2PutItem[];
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionElasticsearch {
    /**
     * @stability stable
     */
    readonly endpoint: string;
    /**
     * @stability stable
     */
    readonly id: string;
    /**
     * @stability stable
     */
    readonly index: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionFirehose {
    /**
     * @stability stable
     */
    readonly deliveryStreamName: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly separator?: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionIotAnalytics {
    /**
     * @stability stable
     */
    readonly channelName: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionIotEvents {
    /**
     * @stability stable
     */
    readonly inputName: string;
    /**
     * @stability stable
     */
    readonly messageId?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionKinesis {
    /**
     * @stability stable
     */
    readonly partitionKey?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly streamName: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionLambda {
    /**
     * @stability stable
     */
    readonly functionArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionRepublish {
    /**
     * @stability stable
     */
    readonly qos?: number;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly topic: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionS3 {
    /**
     * @stability stable
     */
    readonly bucketName: string;
    /**
     * @stability stable
     */
    readonly key: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionSns {
    /**
     * @stability stable
     */
    readonly messageFormat?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly targetArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionSqs {
    /**
     * @stability stable
     */
    readonly queueUrl: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly useBase64: boolean;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorActionStepFunctions {
    /**
     * @stability stable
     */
    readonly executionNamePrefix?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly stateMachineName: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleErrorAction {
    /**
     * cloudwatch_alarm block.
     *
     * @stability stable
     */
    readonly cloudwatchAlarm?: IotTopicRuleErrorActionCloudwatchAlarm[];
    /**
     * cloudwatch_metric block.
     *
     * @stability stable
     */
    readonly cloudwatchMetric?: IotTopicRuleErrorActionCloudwatchMetric[];
    /**
     * dynamodb block.
     *
     * @stability stable
     */
    readonly dynamodb?: IotTopicRuleErrorActionDynamodb[];
    /**
     * dynamodbv2 block.
     *
     * @stability stable
     */
    readonly dynamodbv2?: IotTopicRuleErrorActionDynamodbv2[];
    /**
     * elasticsearch block.
     *
     * @stability stable
     */
    readonly elasticsearch?: IotTopicRuleErrorActionElasticsearch[];
    /**
     * firehose block.
     *
     * @stability stable
     */
    readonly firehose?: IotTopicRuleErrorActionFirehose[];
    /**
     * iot_analytics block.
     *
     * @stability stable
     */
    readonly iotAnalytics?: IotTopicRuleErrorActionIotAnalytics[];
    /**
     * iot_events block.
     *
     * @stability stable
     */
    readonly iotEvents?: IotTopicRuleErrorActionIotEvents[];
    /**
     * kinesis block.
     *
     * @stability stable
     */
    readonly kinesis?: IotTopicRuleErrorActionKinesis[];
    /**
     * lambda block.
     *
     * @stability stable
     */
    readonly lambda?: IotTopicRuleErrorActionLambda[];
    /**
     * republish block.
     *
     * @stability stable
     */
    readonly republish?: IotTopicRuleErrorActionRepublish[];
    /**
     * s3 block.
     *
     * @stability stable
     */
    readonly s3?: IotTopicRuleErrorActionS3[];
    /**
     * sns block.
     *
     * @stability stable
     */
    readonly sns?: IotTopicRuleErrorActionSns[];
    /**
     * sqs block.
     *
     * @stability stable
     */
    readonly sqs?: IotTopicRuleErrorActionSqs[];
    /**
     * step_functions block.
     *
     * @stability stable
     */
    readonly stepFunctions?: IotTopicRuleErrorActionStepFunctions[];
}
/**
 * @stability stable
 */
export interface IotTopicRuleFirehose {
    /**
     * @stability stable
     */
    readonly deliveryStreamName: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly separator?: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleIotAnalytics {
    /**
     * @stability stable
     */
    readonly channelName: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleIotEvents {
    /**
     * @stability stable
     */
    readonly inputName: string;
    /**
     * @stability stable
     */
    readonly messageId?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleKinesis {
    /**
     * @stability stable
     */
    readonly partitionKey?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly streamName: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleLambda {
    /**
     * @stability stable
     */
    readonly functionArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleRepublish {
    /**
     * @stability stable
     */
    readonly qos?: number;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly topic: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleS3 {
    /**
     * @stability stable
     */
    readonly bucketName: string;
    /**
     * @stability stable
     */
    readonly key: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleSns {
    /**
     * @stability stable
     */
    readonly messageFormat?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly targetArn: string;
}
/**
 * @stability stable
 */
export interface IotTopicRuleSqs {
    /**
     * @stability stable
     */
    readonly queueUrl: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly useBase64: boolean;
}
/**
 * @stability stable
 */
export interface IotTopicRuleStepFunctions {
    /**
     * @stability stable
     */
    readonly executionNamePrefix?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly stateMachineName: string;
}
/**
 * @stability stable
 */
export declare class IotTopicRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IotTopicRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _enabled;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    get enabledInput(): boolean;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _sql;
    /**
     * @stability stable
     */
    get sql(): string;
    /**
     * @stability stable
     */
    set sql(value: string);
    /**
     * @stability stable
     */
    get sqlInput(): string;
    private _sqlVersion;
    /**
     * @stability stable
     */
    get sqlVersion(): string;
    /**
     * @stability stable
     */
    set sqlVersion(value: string);
    /**
     * @stability stable
     */
    get sqlVersionInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _cloudwatchAlarm?;
    /**
     * @stability stable
     */
    get cloudwatchAlarm(): IotTopicRuleCloudwatchAlarm[];
    /**
     * @stability stable
     */
    set cloudwatchAlarm(value: IotTopicRuleCloudwatchAlarm[]);
    /**
     * @stability stable
     */
    resetCloudwatchAlarm(): void;
    /**
     * @stability stable
     */
    get cloudwatchAlarmInput(): IotTopicRuleCloudwatchAlarm[] | undefined;
    private _cloudwatchMetric?;
    /**
     * @stability stable
     */
    get cloudwatchMetric(): IotTopicRuleCloudwatchMetric[];
    /**
     * @stability stable
     */
    set cloudwatchMetric(value: IotTopicRuleCloudwatchMetric[]);
    /**
     * @stability stable
     */
    resetCloudwatchMetric(): void;
    /**
     * @stability stable
     */
    get cloudwatchMetricInput(): IotTopicRuleCloudwatchMetric[] | undefined;
    private _dynamodb?;
    /**
     * @stability stable
     */
    get dynamodb(): IotTopicRuleDynamodb[];
    /**
     * @stability stable
     */
    set dynamodb(value: IotTopicRuleDynamodb[]);
    /**
     * @stability stable
     */
    resetDynamodb(): void;
    /**
     * @stability stable
     */
    get dynamodbInput(): IotTopicRuleDynamodb[] | undefined;
    private _dynamodbv2?;
    /**
     * @stability stable
     */
    get dynamodbv2(): IotTopicRuleDynamodbv2[];
    /**
     * @stability stable
     */
    set dynamodbv2(value: IotTopicRuleDynamodbv2[]);
    /**
     * @stability stable
     */
    resetDynamodbv2(): void;
    /**
     * @stability stable
     */
    get dynamodbv2Input(): IotTopicRuleDynamodbv2[] | undefined;
    private _elasticsearch?;
    /**
     * @stability stable
     */
    get elasticsearch(): IotTopicRuleElasticsearch[];
    /**
     * @stability stable
     */
    set elasticsearch(value: IotTopicRuleElasticsearch[]);
    /**
     * @stability stable
     */
    resetElasticsearch(): void;
    /**
     * @stability stable
     */
    get elasticsearchInput(): IotTopicRuleElasticsearch[] | undefined;
    private _errorAction?;
    /**
     * @stability stable
     */
    get errorAction(): IotTopicRuleErrorAction[];
    /**
     * @stability stable
     */
    set errorAction(value: IotTopicRuleErrorAction[]);
    /**
     * @stability stable
     */
    resetErrorAction(): void;
    /**
     * @stability stable
     */
    get errorActionInput(): IotTopicRuleErrorAction[] | undefined;
    private _firehose?;
    /**
     * @stability stable
     */
    get firehose(): IotTopicRuleFirehose[];
    /**
     * @stability stable
     */
    set firehose(value: IotTopicRuleFirehose[]);
    /**
     * @stability stable
     */
    resetFirehose(): void;
    /**
     * @stability stable
     */
    get firehoseInput(): IotTopicRuleFirehose[] | undefined;
    private _iotAnalytics?;
    /**
     * @stability stable
     */
    get iotAnalytics(): IotTopicRuleIotAnalytics[];
    /**
     * @stability stable
     */
    set iotAnalytics(value: IotTopicRuleIotAnalytics[]);
    /**
     * @stability stable
     */
    resetIotAnalytics(): void;
    /**
     * @stability stable
     */
    get iotAnalyticsInput(): IotTopicRuleIotAnalytics[] | undefined;
    private _iotEvents?;
    /**
     * @stability stable
     */
    get iotEvents(): IotTopicRuleIotEvents[];
    /**
     * @stability stable
     */
    set iotEvents(value: IotTopicRuleIotEvents[]);
    /**
     * @stability stable
     */
    resetIotEvents(): void;
    /**
     * @stability stable
     */
    get iotEventsInput(): IotTopicRuleIotEvents[] | undefined;
    private _kinesis?;
    /**
     * @stability stable
     */
    get kinesis(): IotTopicRuleKinesis[];
    /**
     * @stability stable
     */
    set kinesis(value: IotTopicRuleKinesis[]);
    /**
     * @stability stable
     */
    resetKinesis(): void;
    /**
     * @stability stable
     */
    get kinesisInput(): IotTopicRuleKinesis[] | undefined;
    private _lambda?;
    /**
     * @stability stable
     */
    get lambda(): IotTopicRuleLambda[];
    /**
     * @stability stable
     */
    set lambda(value: IotTopicRuleLambda[]);
    /**
     * @stability stable
     */
    resetLambda(): void;
    /**
     * @stability stable
     */
    get lambdaInput(): IotTopicRuleLambda[] | undefined;
    private _republish?;
    /**
     * @stability stable
     */
    get republish(): IotTopicRuleRepublish[];
    /**
     * @stability stable
     */
    set republish(value: IotTopicRuleRepublish[]);
    /**
     * @stability stable
     */
    resetRepublish(): void;
    /**
     * @stability stable
     */
    get republishInput(): IotTopicRuleRepublish[] | undefined;
    private _s3?;
    /**
     * @stability stable
     */
    get s3(): IotTopicRuleS3[];
    /**
     * @stability stable
     */
    set s3(value: IotTopicRuleS3[]);
    /**
     * @stability stable
     */
    resetS3(): void;
    /**
     * @stability stable
     */
    get s3Input(): IotTopicRuleS3[] | undefined;
    private _sns?;
    /**
     * @stability stable
     */
    get sns(): IotTopicRuleSns[];
    /**
     * @stability stable
     */
    set sns(value: IotTopicRuleSns[]);
    /**
     * @stability stable
     */
    resetSns(): void;
    /**
     * @stability stable
     */
    get snsInput(): IotTopicRuleSns[] | undefined;
    private _sqs?;
    /**
     * @stability stable
     */
    get sqs(): IotTopicRuleSqs[];
    /**
     * @stability stable
     */
    set sqs(value: IotTopicRuleSqs[]);
    /**
     * @stability stable
     */
    resetSqs(): void;
    /**
     * @stability stable
     */
    get sqsInput(): IotTopicRuleSqs[] | undefined;
    private _stepFunctions?;
    /**
     * @stability stable
     */
    get stepFunctions(): IotTopicRuleStepFunctions[];
    /**
     * @stability stable
     */
    set stepFunctions(value: IotTopicRuleStepFunctions[]);
    /**
     * @stability stable
     */
    resetStepFunctions(): void;
    /**
     * @stability stable
     */
    get stepFunctionsInput(): IotTopicRuleStepFunctions[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
