import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly destination: string;
    /**
     * @stability stable
     */
    readonly destinationId?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly versionId?: string;
    /**
     * elasticsearch_configuration block.
     *
     * @stability stable
     */
    readonly elasticsearchConfiguration?: KinesisFirehoseDeliveryStreamElasticsearchConfiguration[];
    /**
     * extended_s3_configuration block.
     *
     * @stability stable
     */
    readonly extendedS3Configuration?: KinesisFirehoseDeliveryStreamExtendedS3Configuration[];
    /**
     * http_endpoint_configuration block.
     *
     * @stability stable
     */
    readonly httpEndpointConfiguration?: KinesisFirehoseDeliveryStreamHttpEndpointConfiguration[];
    /**
     * kinesis_source_configuration block.
     *
     * @stability stable
     */
    readonly kinesisSourceConfiguration?: KinesisFirehoseDeliveryStreamKinesisSourceConfiguration[];
    /**
     * redshift_configuration block.
     *
     * @stability stable
     */
    readonly redshiftConfiguration?: KinesisFirehoseDeliveryStreamRedshiftConfiguration[];
    /**
     * s3_configuration block.
     *
     * @stability stable
     */
    readonly s3Configuration?: KinesisFirehoseDeliveryStreamS3Configuration[];
    /**
     * server_side_encryption block.
     *
     * @stability stable
     */
    readonly serverSideEncryption?: KinesisFirehoseDeliveryStreamServerSideEncryption[];
    /**
     * splunk_configuration block.
     *
     * @stability stable
     */
    readonly splunkConfiguration?: KinesisFirehoseDeliveryStreamSplunkConfiguration[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamElasticsearchConfigurationCloudwatchLoggingOptions {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly logGroupName?: string;
    /**
     * @stability stable
     */
    readonly logStreamName?: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfigurationProcessorsParameters {
    /**
     * @stability stable
     */
    readonly parameterName: string;
    /**
     * @stability stable
     */
    readonly parameterValue: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfigurationProcessors {
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * parameters block.
     *
     * @stability stable
     */
    readonly parameters?: KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfigurationProcessorsParameters[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfiguration {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * processors block.
     *
     * @stability stable
     */
    readonly processors?: KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfigurationProcessors[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamElasticsearchConfigurationVpcConfig {
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly securityGroupIds: string[];
    /**
     * @stability stable
     */
    readonly subnetIds: string[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamElasticsearchConfiguration {
    /**
     * @stability stable
     */
    readonly bufferingInterval?: number;
    /**
     * @stability stable
     */
    readonly bufferingSize?: number;
    /**
     * @stability stable
     */
    readonly clusterEndpoint?: string;
    /**
     * @stability stable
     */
    readonly domainArn?: string;
    /**
     * @stability stable
     */
    readonly indexName: string;
    /**
     * @stability stable
     */
    readonly indexRotationPeriod?: string;
    /**
     * @stability stable
     */
    readonly retryDuration?: number;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly s3BackupMode?: string;
    /**
     * @stability stable
     */
    readonly typeName?: string;
    /**
     * cloudwatch_logging_options block.
     *
     * @stability stable
     */
    readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamElasticsearchConfigurationCloudwatchLoggingOptions[];
    /**
     * processing_configuration block.
     *
     * @stability stable
     */
    readonly processingConfiguration?: KinesisFirehoseDeliveryStreamElasticsearchConfigurationProcessingConfiguration[];
    /**
     * vpc_config block.
     *
     * @stability stable
     */
    readonly vpcConfig?: KinesisFirehoseDeliveryStreamElasticsearchConfigurationVpcConfig[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationCloudwatchLoggingOptions {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly logGroupName?: string;
    /**
     * @stability stable
     */
    readonly logStreamName?: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerHiveJsonSerDe {
    /**
     * @stability stable
     */
    readonly timestampFormats?: string[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerOpenXJsonSerDe {
    /**
     * @stability stable
     */
    readonly caseInsensitive?: boolean;
    /**
     * @stability stable
     */
    readonly columnToJsonKeyMappings?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly convertDotsInJsonKeysToUnderscores?: boolean;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializer {
    /**
     * hive_json_ser_de block.
     *
     * @stability stable
     */
    readonly hiveJsonSerDe?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerHiveJsonSerDe[];
    /**
     * open_x_json_ser_de block.
     *
     * @stability stable
     */
    readonly openXJsonSerDe?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializerOpenXJsonSerDe[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfiguration {
    /**
     * deserializer block.
     *
     * @stability stable
     */
    readonly deserializer: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfigurationDeserializer[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerOrcSerDe {
    /**
     * @stability stable
     */
    readonly blockSizeBytes?: number;
    /**
     * @stability stable
     */
    readonly bloomFilterColumns?: string[];
    /**
     * @stability stable
     */
    readonly bloomFilterFalsePositiveProbability?: number;
    /**
     * @stability stable
     */
    readonly compression?: string;
    /**
     * @stability stable
     */
    readonly dictionaryKeyThreshold?: number;
    /**
     * @stability stable
     */
    readonly enablePadding?: boolean;
    /**
     * @stability stable
     */
    readonly formatVersion?: string;
    /**
     * @stability stable
     */
    readonly paddingTolerance?: number;
    /**
     * @stability stable
     */
    readonly rowIndexStride?: number;
    /**
     * @stability stable
     */
    readonly stripeSizeBytes?: number;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerParquetSerDe {
    /**
     * @stability stable
     */
    readonly blockSizeBytes?: number;
    /**
     * @stability stable
     */
    readonly compression?: string;
    /**
     * @stability stable
     */
    readonly enableDictionaryCompression?: boolean;
    /**
     * @stability stable
     */
    readonly maxPaddingBytes?: number;
    /**
     * @stability stable
     */
    readonly pageSizeBytes?: number;
    /**
     * @stability stable
     */
    readonly writerVersion?: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializer {
    /**
     * orc_ser_de block.
     *
     * @stability stable
     */
    readonly orcSerDe?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerOrcSerDe[];
    /**
     * parquet_ser_de block.
     *
     * @stability stable
     */
    readonly parquetSerDe?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializerParquetSerDe[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfiguration {
    /**
     * serializer block.
     *
     * @stability stable
     */
    readonly serializer: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfigurationSerializer[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationSchemaConfiguration {
    /**
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * @stability stable
     */
    readonly region?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly tableName: string;
    /**
     * @stability stable
     */
    readonly versionId?: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfiguration {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * input_format_configuration block.
     *
     * @stability stable
     */
    readonly inputFormatConfiguration: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationInputFormatConfiguration[];
    /**
     * output_format_configuration block.
     *
     * @stability stable
     */
    readonly outputFormatConfiguration: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationOutputFormatConfiguration[];
    /**
     * schema_configuration block.
     *
     * @stability stable
     */
    readonly schemaConfiguration: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfigurationSchemaConfiguration[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfigurationProcessorsParameters {
    /**
     * @stability stable
     */
    readonly parameterName: string;
    /**
     * @stability stable
     */
    readonly parameterValue: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfigurationProcessors {
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * parameters block.
     *
     * @stability stable
     */
    readonly parameters?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfigurationProcessorsParameters[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfiguration {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * processors block.
     *
     * @stability stable
     */
    readonly processors?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfigurationProcessors[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfigurationCloudwatchLoggingOptions {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly logGroupName?: string;
    /**
     * @stability stable
     */
    readonly logStreamName?: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfiguration {
    /**
     * @stability stable
     */
    readonly bucketArn: string;
    /**
     * @stability stable
     */
    readonly bufferInterval?: number;
    /**
     * @stability stable
     */
    readonly bufferSize?: number;
    /**
     * @stability stable
     */
    readonly compressionFormat?: string;
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * cloudwatch_logging_options block.
     *
     * @stability stable
     */
    readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfigurationCloudwatchLoggingOptions[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamExtendedS3Configuration {
    /**
     * @stability stable
     */
    readonly bucketArn: string;
    /**
     * @stability stable
     */
    readonly bufferInterval?: number;
    /**
     * @stability stable
     */
    readonly bufferSize?: number;
    /**
     * @stability stable
     */
    readonly compressionFormat?: string;
    /**
     * @stability stable
     */
    readonly errorOutputPrefix?: string;
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly s3BackupMode?: string;
    /**
     * cloudwatch_logging_options block.
     *
     * @stability stable
     */
    readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationCloudwatchLoggingOptions[];
    /**
     * data_format_conversion_configuration block.
     *
     * @stability stable
     */
    readonly dataFormatConversionConfiguration?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationDataFormatConversionConfiguration[];
    /**
     * processing_configuration block.
     *
     * @stability stable
     */
    readonly processingConfiguration?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationProcessingConfiguration[];
    /**
     * s3_backup_configuration block.
     *
     * @stability stable
     */
    readonly s3BackupConfiguration?: KinesisFirehoseDeliveryStreamExtendedS3ConfigurationS3BackupConfiguration[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamHttpEndpointConfigurationCloudwatchLoggingOptions {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly logGroupName?: string;
    /**
     * @stability stable
     */
    readonly logStreamName?: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfigurationProcessorsParameters {
    /**
     * @stability stable
     */
    readonly parameterName: string;
    /**
     * @stability stable
     */
    readonly parameterValue: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfigurationProcessors {
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * parameters block.
     *
     * @stability stable
     */
    readonly parameters?: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfigurationProcessorsParameters[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfiguration {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * processors block.
     *
     * @stability stable
     */
    readonly processors?: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfigurationProcessors[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamHttpEndpointConfigurationRequestConfigurationCommonAttributes {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamHttpEndpointConfigurationRequestConfiguration {
    /**
     * @stability stable
     */
    readonly contentEncoding?: string;
    /**
     * common_attributes block.
     *
     * @stability stable
     */
    readonly commonAttributes?: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationRequestConfigurationCommonAttributes[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamHttpEndpointConfiguration {
    /**
     * @stability stable
     */
    readonly accessKey?: string;
    /**
     * @stability stable
     */
    readonly bufferingInterval?: number;
    /**
     * @stability stable
     */
    readonly bufferingSize?: number;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly retryDuration?: number;
    /**
     * @stability stable
     */
    readonly roleArn?: string;
    /**
     * @stability stable
     */
    readonly s3BackupMode?: string;
    /**
     * @stability stable
     */
    readonly url: string;
    /**
     * cloudwatch_logging_options block.
     *
     * @stability stable
     */
    readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationCloudwatchLoggingOptions[];
    /**
     * processing_configuration block.
     *
     * @stability stable
     */
    readonly processingConfiguration?: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationProcessingConfiguration[];
    /**
     * request_configuration block.
     *
     * @stability stable
     */
    readonly requestConfiguration?: KinesisFirehoseDeliveryStreamHttpEndpointConfigurationRequestConfiguration[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamKinesisSourceConfiguration {
    /**
     * @stability stable
     */
    readonly kinesisStreamArn: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamRedshiftConfigurationCloudwatchLoggingOptions {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly logGroupName?: string;
    /**
     * @stability stable
     */
    readonly logStreamName?: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfigurationProcessorsParameters {
    /**
     * @stability stable
     */
    readonly parameterName: string;
    /**
     * @stability stable
     */
    readonly parameterValue: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfigurationProcessors {
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * parameters block.
     *
     * @stability stable
     */
    readonly parameters?: KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfigurationProcessorsParameters[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfiguration {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * processors block.
     *
     * @stability stable
     */
    readonly processors?: KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfigurationProcessors[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfigurationCloudwatchLoggingOptions {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly logGroupName?: string;
    /**
     * @stability stable
     */
    readonly logStreamName?: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfiguration {
    /**
     * @stability stable
     */
    readonly bucketArn: string;
    /**
     * @stability stable
     */
    readonly bufferInterval?: number;
    /**
     * @stability stable
     */
    readonly bufferSize?: number;
    /**
     * @stability stable
     */
    readonly compressionFormat?: string;
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * cloudwatch_logging_options block.
     *
     * @stability stable
     */
    readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfigurationCloudwatchLoggingOptions[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamRedshiftConfiguration {
    /**
     * @stability stable
     */
    readonly clusterJdbcurl: string;
    /**
     * @stability stable
     */
    readonly copyOptions?: string;
    /**
     * @stability stable
     */
    readonly dataTableColumns?: string;
    /**
     * @stability stable
     */
    readonly dataTableName: string;
    /**
     * @stability stable
     */
    readonly password: string;
    /**
     * @stability stable
     */
    readonly retryDuration?: number;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly s3BackupMode?: string;
    /**
     * @stability stable
     */
    readonly username: string;
    /**
     * cloudwatch_logging_options block.
     *
     * @stability stable
     */
    readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamRedshiftConfigurationCloudwatchLoggingOptions[];
    /**
     * processing_configuration block.
     *
     * @stability stable
     */
    readonly processingConfiguration?: KinesisFirehoseDeliveryStreamRedshiftConfigurationProcessingConfiguration[];
    /**
     * s3_backup_configuration block.
     *
     * @stability stable
     */
    readonly s3BackupConfiguration?: KinesisFirehoseDeliveryStreamRedshiftConfigurationS3BackupConfiguration[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamS3ConfigurationCloudwatchLoggingOptions {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly logGroupName?: string;
    /**
     * @stability stable
     */
    readonly logStreamName?: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamS3Configuration {
    /**
     * @stability stable
     */
    readonly bucketArn: string;
    /**
     * @stability stable
     */
    readonly bufferInterval?: number;
    /**
     * @stability stable
     */
    readonly bufferSize?: number;
    /**
     * @stability stable
     */
    readonly compressionFormat?: string;
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * cloudwatch_logging_options block.
     *
     * @stability stable
     */
    readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamS3ConfigurationCloudwatchLoggingOptions[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamServerSideEncryption {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly keyArn?: string;
    /**
     * @stability stable
     */
    readonly keyType?: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamSplunkConfigurationCloudwatchLoggingOptions {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly logGroupName?: string;
    /**
     * @stability stable
     */
    readonly logStreamName?: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfigurationProcessorsParameters {
    /**
     * @stability stable
     */
    readonly parameterName: string;
    /**
     * @stability stable
     */
    readonly parameterValue: string;
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfigurationProcessors {
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * parameters block.
     *
     * @stability stable
     */
    readonly parameters?: KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfigurationProcessorsParameters[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfiguration {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * processors block.
     *
     * @stability stable
     */
    readonly processors?: KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfigurationProcessors[];
}
/**
 * @stability stable
 */
export interface KinesisFirehoseDeliveryStreamSplunkConfiguration {
    /**
     * @stability stable
     */
    readonly hecAcknowledgmentTimeout?: number;
    /**
     * @stability stable
     */
    readonly hecEndpoint: string;
    /**
     * @stability stable
     */
    readonly hecEndpointType?: string;
    /**
     * @stability stable
     */
    readonly hecToken: string;
    /**
     * @stability stable
     */
    readonly retryDuration?: number;
    /**
     * @stability stable
     */
    readonly s3BackupMode?: string;
    /**
     * cloudwatch_logging_options block.
     *
     * @stability stable
     */
    readonly cloudwatchLoggingOptions?: KinesisFirehoseDeliveryStreamSplunkConfigurationCloudwatchLoggingOptions[];
    /**
     * processing_configuration block.
     *
     * @stability stable
     */
    readonly processingConfiguration?: KinesisFirehoseDeliveryStreamSplunkConfigurationProcessingConfiguration[];
}
/**
 * @stability stable
 */
export declare class KinesisFirehoseDeliveryStream extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: KinesisFirehoseDeliveryStreamConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _destination;
    /**
     * @stability stable
     */
    get destination(): string;
    /**
     * @stability stable
     */
    set destination(value: string);
    /**
     * @stability stable
     */
    get destinationInput(): string;
    private _destinationId?;
    /**
     * @stability stable
     */
    get destinationId(): string;
    /**
     * @stability stable
     */
    set destinationId(value: string);
    /**
     * @stability stable
     */
    resetDestinationId(): void;
    /**
     * @stability stable
     */
    get destinationIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _versionId?;
    /**
     * @stability stable
     */
    get versionId(): string;
    /**
     * @stability stable
     */
    set versionId(value: string);
    /**
     * @stability stable
     */
    resetVersionId(): void;
    /**
     * @stability stable
     */
    get versionIdInput(): string | undefined;
    private _elasticsearchConfiguration?;
    /**
     * @stability stable
     */
    get elasticsearchConfiguration(): KinesisFirehoseDeliveryStreamElasticsearchConfiguration[];
    /**
     * @stability stable
     */
    set elasticsearchConfiguration(value: KinesisFirehoseDeliveryStreamElasticsearchConfiguration[]);
    /**
     * @stability stable
     */
    resetElasticsearchConfiguration(): void;
    /**
     * @stability stable
     */
    get elasticsearchConfigurationInput(): KinesisFirehoseDeliveryStreamElasticsearchConfiguration[] | undefined;
    private _extendedS3Configuration?;
    /**
     * @stability stable
     */
    get extendedS3Configuration(): KinesisFirehoseDeliveryStreamExtendedS3Configuration[];
    /**
     * @stability stable
     */
    set extendedS3Configuration(value: KinesisFirehoseDeliveryStreamExtendedS3Configuration[]);
    /**
     * @stability stable
     */
    resetExtendedS3Configuration(): void;
    /**
     * @stability stable
     */
    get extendedS3ConfigurationInput(): KinesisFirehoseDeliveryStreamExtendedS3Configuration[] | undefined;
    private _httpEndpointConfiguration?;
    /**
     * @stability stable
     */
    get httpEndpointConfiguration(): KinesisFirehoseDeliveryStreamHttpEndpointConfiguration[];
    /**
     * @stability stable
     */
    set httpEndpointConfiguration(value: KinesisFirehoseDeliveryStreamHttpEndpointConfiguration[]);
    /**
     * @stability stable
     */
    resetHttpEndpointConfiguration(): void;
    /**
     * @stability stable
     */
    get httpEndpointConfigurationInput(): KinesisFirehoseDeliveryStreamHttpEndpointConfiguration[] | undefined;
    private _kinesisSourceConfiguration?;
    /**
     * @stability stable
     */
    get kinesisSourceConfiguration(): KinesisFirehoseDeliveryStreamKinesisSourceConfiguration[];
    /**
     * @stability stable
     */
    set kinesisSourceConfiguration(value: KinesisFirehoseDeliveryStreamKinesisSourceConfiguration[]);
    /**
     * @stability stable
     */
    resetKinesisSourceConfiguration(): void;
    /**
     * @stability stable
     */
    get kinesisSourceConfigurationInput(): KinesisFirehoseDeliveryStreamKinesisSourceConfiguration[] | undefined;
    private _redshiftConfiguration?;
    /**
     * @stability stable
     */
    get redshiftConfiguration(): KinesisFirehoseDeliveryStreamRedshiftConfiguration[];
    /**
     * @stability stable
     */
    set redshiftConfiguration(value: KinesisFirehoseDeliveryStreamRedshiftConfiguration[]);
    /**
     * @stability stable
     */
    resetRedshiftConfiguration(): void;
    /**
     * @stability stable
     */
    get redshiftConfigurationInput(): KinesisFirehoseDeliveryStreamRedshiftConfiguration[] | undefined;
    private _s3Configuration?;
    /**
     * @stability stable
     */
    get s3Configuration(): KinesisFirehoseDeliveryStreamS3Configuration[];
    /**
     * @stability stable
     */
    set s3Configuration(value: KinesisFirehoseDeliveryStreamS3Configuration[]);
    /**
     * @stability stable
     */
    resetS3Configuration(): void;
    /**
     * @stability stable
     */
    get s3ConfigurationInput(): KinesisFirehoseDeliveryStreamS3Configuration[] | undefined;
    private _serverSideEncryption?;
    /**
     * @stability stable
     */
    get serverSideEncryption(): KinesisFirehoseDeliveryStreamServerSideEncryption[];
    /**
     * @stability stable
     */
    set serverSideEncryption(value: KinesisFirehoseDeliveryStreamServerSideEncryption[]);
    /**
     * @stability stable
     */
    resetServerSideEncryption(): void;
    /**
     * @stability stable
     */
    get serverSideEncryptionInput(): KinesisFirehoseDeliveryStreamServerSideEncryption[] | undefined;
    private _splunkConfiguration?;
    /**
     * @stability stable
     */
    get splunkConfiguration(): KinesisFirehoseDeliveryStreamSplunkConfiguration[];
    /**
     * @stability stable
     */
    set splunkConfiguration(value: KinesisFirehoseDeliveryStreamSplunkConfiguration[]);
    /**
     * @stability stable
     */
    resetSplunkConfiguration(): void;
    /**
     * @stability stable
     */
    get splunkConfigurationInput(): KinesisFirehoseDeliveryStreamSplunkConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
