import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface KinesisStreamConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly encryptionType?: string;
    /**
     * @stability stable
     */
    readonly enforceConsumerDeletion?: boolean;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly retentionPeriod?: number;
    /**
     * @stability stable
     */
    readonly shardCount: number;
    /**
     * @stability stable
     */
    readonly shardLevelMetrics?: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: KinesisStreamTimeouts;
}
/**
 * @stability stable
 */
export interface KinesisStreamTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class KinesisStream extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: KinesisStreamConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _encryptionType?;
    /**
     * @stability stable
     */
    get encryptionType(): string;
    /**
     * @stability stable
     */
    set encryptionType(value: string);
    /**
     * @stability stable
     */
    resetEncryptionType(): void;
    /**
     * @stability stable
     */
    get encryptionTypeInput(): string | undefined;
    private _enforceConsumerDeletion?;
    /**
     * @stability stable
     */
    get enforceConsumerDeletion(): boolean;
    /**
     * @stability stable
     */
    set enforceConsumerDeletion(value: boolean);
    /**
     * @stability stable
     */
    resetEnforceConsumerDeletion(): void;
    /**
     * @stability stable
     */
    get enforceConsumerDeletionInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _retentionPeriod?;
    /**
     * @stability stable
     */
    get retentionPeriod(): number;
    /**
     * @stability stable
     */
    set retentionPeriod(value: number);
    /**
     * @stability stable
     */
    resetRetentionPeriod(): void;
    /**
     * @stability stable
     */
    get retentionPeriodInput(): number | undefined;
    private _shardCount;
    /**
     * @stability stable
     */
    get shardCount(): number;
    /**
     * @stability stable
     */
    set shardCount(value: number);
    /**
     * @stability stable
     */
    get shardCountInput(): number;
    private _shardLevelMetrics?;
    /**
     * @stability stable
     */
    get shardLevelMetrics(): string[];
    /**
     * @stability stable
     */
    set shardLevelMetrics(value: string[]);
    /**
     * @stability stable
     */
    resetShardLevelMetrics(): void;
    /**
     * @stability stable
     */
    get shardLevelMetricsInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): KinesisStreamTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: KinesisStreamTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): KinesisStreamTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
