import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly runtimeEnvironment: string;
    /**
     * @stability stable
     */
    readonly serviceExecutionRole: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * application_configuration block.
     *
     * @stability stable
     */
    readonly applicationConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfiguration[];
    /**
     * cloudwatch_logging_options block.
     *
     * @stability stable
     */
    readonly cloudwatchLoggingOptions?: Kinesisanalyticsv2ApplicationCloudwatchLoggingOptions[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContentS3ContentLocation {
    /**
     * @stability stable
     */
    readonly bucketArn: string;
    /**
     * @stability stable
     */
    readonly fileKey: string;
    /**
     * @stability stable
     */
    readonly objectVersion?: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContent {
    /**
     * @stability stable
     */
    readonly textContent?: string;
    /**
     * s3_content_location block.
     *
     * @stability stable
     */
    readonly s3ContentLocation?: Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContentS3ContentLocation[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfiguration {
    /**
     * @stability stable
     */
    readonly codeContentType: string;
    /**
     * code_content block.
     *
     * @stability stable
     */
    readonly codeContent?: Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfigurationCodeContent[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationSnapshotConfiguration {
    /**
     * @stability stable
     */
    readonly snapshotsEnabled: boolean;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationEnvironmentPropertiesPropertyGroup {
    /**
     * @stability stable
     */
    readonly propertyGroupId: string;
    /**
     * @stability stable
     */
    readonly propertyMap: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationEnvironmentProperties {
    /**
     * property_group block.
     *
     * @stability stable
     */
    readonly propertyGroup: Kinesisanalyticsv2ApplicationApplicationConfigurationEnvironmentPropertiesPropertyGroup[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationCheckpointConfiguration {
    /**
     * @stability stable
     */
    readonly checkpointInterval?: number;
    /**
     * @stability stable
     */
    readonly checkpointingEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly configurationType: string;
    /**
     * @stability stable
     */
    readonly minPauseBetweenCheckpoints?: number;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationMonitoringConfiguration {
    /**
     * @stability stable
     */
    readonly configurationType: string;
    /**
     * @stability stable
     */
    readonly logLevel?: string;
    /**
     * @stability stable
     */
    readonly metricsLevel?: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationParallelismConfiguration {
    /**
     * @stability stable
     */
    readonly autoScalingEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly configurationType: string;
    /**
     * @stability stable
     */
    readonly parallelism?: number;
    /**
     * @stability stable
     */
    readonly parallelismPerKpu?: number;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfiguration {
    /**
     * checkpoint_configuration block.
     *
     * @stability stable
     */
    readonly checkpointConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationCheckpointConfiguration[];
    /**
     * monitoring_configuration block.
     *
     * @stability stable
     */
    readonly monitoringConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationMonitoringConfiguration[];
    /**
     * parallelism_configuration block.
     *
     * @stability stable
     */
    readonly parallelismConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfigurationParallelismConfiguration[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputParallelism {
    /**
     * @stability stable
     */
    readonly count?: number;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfigurationInputLambdaProcessor {
    /**
     * @stability stable
     */
    readonly resourceArn: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfiguration {
    /**
     * input_lambda_processor block.
     *
     * @stability stable
     */
    readonly inputLambdaProcessor: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfigurationInputLambdaProcessor[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordColumn {
    /**
     * @stability stable
     */
    readonly mapping?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly sqlType: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersCsvMappingParameters {
    /**
     * @stability stable
     */
    readonly recordColumnDelimiter: string;
    /**
     * @stability stable
     */
    readonly recordRowDelimiter: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersJsonMappingParameters {
    /**
     * @stability stable
     */
    readonly recordRowPath: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParameters {
    /**
     * csv_mapping_parameters block.
     *
     * @stability stable
     */
    readonly csvMappingParameters?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersCsvMappingParameters[];
    /**
     * json_mapping_parameters block.
     *
     * @stability stable
     */
    readonly jsonMappingParameters?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParametersJsonMappingParameters[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormat {
    /**
     * @stability stable
     */
    readonly recordFormatType: string;
    /**
     * mapping_parameters block.
     *
     * @stability stable
     */
    readonly mappingParameters: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormatMappingParameters[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchema {
    /**
     * @stability stable
     */
    readonly recordEncoding?: string;
    /**
     * record_column block.
     *
     * @stability stable
     */
    readonly recordColumn: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordColumn[];
    /**
     * record_format block.
     *
     * @stability stable
     */
    readonly recordFormat: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchemaRecordFormat[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisFirehoseInput {
    /**
     * @stability stable
     */
    readonly resourceArn: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisStreamsInput {
    /**
     * @stability stable
     */
    readonly resourceArn: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInput {
    /**
     * @stability stable
     */
    readonly namePrefix: string;
    /**
     * input_parallelism block.
     *
     * @stability stable
     */
    readonly inputParallelism?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputParallelism[];
    /**
     * input_processing_configuration block.
     *
     * @stability stable
     */
    readonly inputProcessingConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputProcessingConfiguration[];
    /**
     * input_schema block.
     *
     * @stability stable
     */
    readonly inputSchema: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputInputSchema[];
    /**
     * kinesis_firehose_input block.
     *
     * @stability stable
     */
    readonly kinesisFirehoseInput?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisFirehoseInput[];
    /**
     * kinesis_streams_input block.
     *
     * @stability stable
     */
    readonly kinesisStreamsInput?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInputKinesisStreamsInput[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputDestinationSchema {
    /**
     * @stability stable
     */
    readonly recordFormatType: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputKinesisFirehoseOutput {
    /**
     * @stability stable
     */
    readonly resourceArn: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputKinesisStreamsOutput {
    /**
     * @stability stable
     */
    readonly resourceArn: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputLambdaOutput {
    /**
     * @stability stable
     */
    readonly resourceArn: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutput {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * destination_schema block.
     *
     * @stability stable
     */
    readonly destinationSchema: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputDestinationSchema[];
    /**
     * kinesis_firehose_output block.
     *
     * @stability stable
     */
    readonly kinesisFirehoseOutput?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputKinesisFirehoseOutput[];
    /**
     * kinesis_streams_output block.
     *
     * @stability stable
     */
    readonly kinesisStreamsOutput?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputKinesisStreamsOutput[];
    /**
     * lambda_output block.
     *
     * @stability stable
     */
    readonly lambdaOutput?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutputLambdaOutput[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordColumn {
    /**
     * @stability stable
     */
    readonly mapping?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly sqlType: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersCsvMappingParameters {
    /**
     * @stability stable
     */
    readonly recordColumnDelimiter: string;
    /**
     * @stability stable
     */
    readonly recordRowDelimiter: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersJsonMappingParameters {
    /**
     * @stability stable
     */
    readonly recordRowPath: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParameters {
    /**
     * csv_mapping_parameters block.
     *
     * @stability stable
     */
    readonly csvMappingParameters?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersCsvMappingParameters[];
    /**
     * json_mapping_parameters block.
     *
     * @stability stable
     */
    readonly jsonMappingParameters?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParametersJsonMappingParameters[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormat {
    /**
     * @stability stable
     */
    readonly recordFormatType: string;
    /**
     * mapping_parameters block.
     *
     * @stability stable
     */
    readonly mappingParameters: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormatMappingParameters[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchema {
    /**
     * @stability stable
     */
    readonly recordEncoding?: string;
    /**
     * record_column block.
     *
     * @stability stable
     */
    readonly recordColumn: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordColumn[];
    /**
     * record_format block.
     *
     * @stability stable
     */
    readonly recordFormat: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchemaRecordFormat[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceS3ReferenceDataSource {
    /**
     * @stability stable
     */
    readonly bucketArn: string;
    /**
     * @stability stable
     */
    readonly fileKey: string;
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSource {
    /**
     * @stability stable
     */
    readonly tableName: string;
    /**
     * reference_schema block.
     *
     * @stability stable
     */
    readonly referenceSchema: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceReferenceSchema[];
    /**
     * s3_reference_data_source block.
     *
     * @stability stable
     */
    readonly s3ReferenceDataSource: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSourceS3ReferenceDataSource[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfiguration {
    /**
     * input block.
     *
     * @stability stable
     */
    readonly input?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationInput[];
    /**
     * output block.
     *
     * @stability stable
     */
    readonly output?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationOutput[];
    /**
     * reference_data_source block.
     *
     * @stability stable
     */
    readonly referenceDataSource?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfigurationReferenceDataSource[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfigurationVpcConfiguration {
    /**
     * @stability stable
     */
    readonly securityGroupIds: string[];
    /**
     * @stability stable
     */
    readonly subnetIds: string[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationApplicationConfiguration {
    /**
     * application_code_configuration block.
     *
     * @stability stable
     */
    readonly applicationCodeConfiguration: Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationCodeConfiguration[];
    /**
     * application_snapshot_configuration block.
     *
     * @stability stable
     */
    readonly applicationSnapshotConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationApplicationSnapshotConfiguration[];
    /**
     * environment_properties block.
     *
     * @stability stable
     */
    readonly environmentProperties?: Kinesisanalyticsv2ApplicationApplicationConfigurationEnvironmentProperties[];
    /**
     * flink_application_configuration block.
     *
     * @stability stable
     */
    readonly flinkApplicationConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationFlinkApplicationConfiguration[];
    /**
     * sql_application_configuration block.
     *
     * @stability stable
     */
    readonly sqlApplicationConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationSqlApplicationConfiguration[];
    /**
     * vpc_configuration block.
     *
     * @stability stable
     */
    readonly vpcConfiguration?: Kinesisanalyticsv2ApplicationApplicationConfigurationVpcConfiguration[];
}
/**
 * @stability stable
 */
export interface Kinesisanalyticsv2ApplicationCloudwatchLoggingOptions {
    /**
     * @stability stable
     */
    readonly logStreamArn: string;
}
/**
 * @stability stable
 */
export declare class Kinesisanalyticsv2Application extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Kinesisanalyticsv2ApplicationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get createTimestamp(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdateTimestamp(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _runtimeEnvironment;
    /**
     * @stability stable
     */
    get runtimeEnvironment(): string;
    /**
     * @stability stable
     */
    set runtimeEnvironment(value: string);
    /**
     * @stability stable
     */
    get runtimeEnvironmentInput(): string;
    private _serviceExecutionRole;
    /**
     * @stability stable
     */
    get serviceExecutionRole(): string;
    /**
     * @stability stable
     */
    set serviceExecutionRole(value: string);
    /**
     * @stability stable
     */
    get serviceExecutionRoleInput(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get versionId(): number;
    private _applicationConfiguration?;
    /**
     * @stability stable
     */
    get applicationConfiguration(): Kinesisanalyticsv2ApplicationApplicationConfiguration[];
    /**
     * @stability stable
     */
    set applicationConfiguration(value: Kinesisanalyticsv2ApplicationApplicationConfiguration[]);
    /**
     * @stability stable
     */
    resetApplicationConfiguration(): void;
    /**
     * @stability stable
     */
    get applicationConfigurationInput(): Kinesisanalyticsv2ApplicationApplicationConfiguration[] | undefined;
    private _cloudwatchLoggingOptions?;
    /**
     * @stability stable
     */
    get cloudwatchLoggingOptions(): Kinesisanalyticsv2ApplicationCloudwatchLoggingOptions[];
    /**
     * @stability stable
     */
    set cloudwatchLoggingOptions(value: Kinesisanalyticsv2ApplicationCloudwatchLoggingOptions[]);
    /**
     * @stability stable
     */
    resetCloudwatchLoggingOptions(): void;
    /**
     * @stability stable
     */
    get cloudwatchLoggingOptionsInput(): Kinesisanalyticsv2ApplicationCloudwatchLoggingOptions[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
