import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface KmsCiphertextConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly context?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly keyId: string;
    /**
     * @stability stable
     */
    readonly plaintext: string;
}
/**
 * @stability stable
 */
export declare class KmsCiphertext extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: KmsCiphertextConfig);
    /**
     * @stability stable
     */
    get ciphertextBlob(): string;
    private _context?;
    /**
     * @stability stable
     */
    get context(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set context(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetContext(): void;
    /**
     * @stability stable
     */
    get contextInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _keyId;
    /**
     * @stability stable
     */
    get keyId(): string;
    /**
     * @stability stable
     */
    set keyId(value: string);
    /**
     * @stability stable
     */
    get keyIdInput(): string;
    private _plaintext;
    /**
     * @stability stable
     */
    get plaintext(): string;
    /**
     * @stability stable
     */
    set plaintext(value: string);
    /**
     * @stability stable
     */
    get plaintextInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
