import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface KmsExternalKeyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly deletionWindowInDays?: number;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly keyMaterialBase64?: string;
    /**
     * @stability stable
     */
    readonly policy?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly validTo?: string;
}
/**
 * @stability stable
 */
export declare class KmsExternalKey extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: KmsExternalKeyConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _deletionWindowInDays?;
    /**
     * @stability stable
     */
    get deletionWindowInDays(): number;
    /**
     * @stability stable
     */
    set deletionWindowInDays(value: number);
    /**
     * @stability stable
     */
    resetDeletionWindowInDays(): void;
    /**
     * @stability stable
     */
    get deletionWindowInDaysInput(): number | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get expirationModel(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _keyMaterialBase64?;
    /**
     * @stability stable
     */
    get keyMaterialBase64(): string;
    /**
     * @stability stable
     */
    set keyMaterialBase64(value: string);
    /**
     * @stability stable
     */
    resetKeyMaterialBase64(): void;
    /**
     * @stability stable
     */
    get keyMaterialBase64Input(): string | undefined;
    /**
     * @stability stable
     */
    get keyState(): string;
    /**
     * @stability stable
     */
    get keyUsage(): string;
    private _policy?;
    /**
     * @stability stable
     */
    get policy(): string;
    /**
     * @stability stable
     */
    set policy(value: string);
    /**
     * @stability stable
     */
    resetPolicy(): void;
    /**
     * @stability stable
     */
    get policyInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _validTo?;
    /**
     * @stability stable
     */
    get validTo(): string;
    /**
     * @stability stable
     */
    set validTo(value: string);
    /**
     * @stability stable
     */
    resetValidTo(): void;
    /**
     * @stability stable
     */
    get validToInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
