import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface KmsGrantConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly grantCreationTokens?: string[];
    /**
     * @stability stable
     */
    readonly granteePrincipal: string;
    /**
     * @stability stable
     */
    readonly keyId: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly operations: string[];
    /**
     * @stability stable
     */
    readonly retireOnDelete?: boolean;
    /**
     * @stability stable
     */
    readonly retiringPrincipal?: string;
    /**
     * constraints block.
     *
     * @stability stable
     */
    readonly constraints?: KmsGrantConstraints[];
}
/**
 * @stability stable
 */
export interface KmsGrantConstraints {
    /**
     * @stability stable
     */
    readonly encryptionContextEquals?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly encryptionContextSubset?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class KmsGrant extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: KmsGrantConfig);
    private _grantCreationTokens?;
    /**
     * @stability stable
     */
    get grantCreationTokens(): string[];
    /**
     * @stability stable
     */
    set grantCreationTokens(value: string[]);
    /**
     * @stability stable
     */
    resetGrantCreationTokens(): void;
    /**
     * @stability stable
     */
    get grantCreationTokensInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get grantId(): string;
    /**
     * @stability stable
     */
    get grantToken(): string;
    private _granteePrincipal;
    /**
     * @stability stable
     */
    get granteePrincipal(): string;
    /**
     * @stability stable
     */
    set granteePrincipal(value: string);
    /**
     * @stability stable
     */
    get granteePrincipalInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _keyId;
    /**
     * @stability stable
     */
    get keyId(): string;
    /**
     * @stability stable
     */
    set keyId(value: string);
    /**
     * @stability stable
     */
    get keyIdInput(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _operations;
    /**
     * @stability stable
     */
    get operations(): string[];
    /**
     * @stability stable
     */
    set operations(value: string[]);
    /**
     * @stability stable
     */
    get operationsInput(): string[];
    private _retireOnDelete?;
    /**
     * @stability stable
     */
    get retireOnDelete(): boolean;
    /**
     * @stability stable
     */
    set retireOnDelete(value: boolean);
    /**
     * @stability stable
     */
    resetRetireOnDelete(): void;
    /**
     * @stability stable
     */
    get retireOnDeleteInput(): boolean | undefined;
    private _retiringPrincipal?;
    /**
     * @stability stable
     */
    get retiringPrincipal(): string;
    /**
     * @stability stable
     */
    set retiringPrincipal(value: string);
    /**
     * @stability stable
     */
    resetRetiringPrincipal(): void;
    /**
     * @stability stable
     */
    get retiringPrincipalInput(): string | undefined;
    private _constraints?;
    /**
     * @stability stable
     */
    get constraints(): KmsGrantConstraints[];
    /**
     * @stability stable
     */
    set constraints(value: KmsGrantConstraints[]);
    /**
     * @stability stable
     */
    resetConstraints(): void;
    /**
     * @stability stable
     */
    get constraintsInput(): KmsGrantConstraints[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
