import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface KmsKeyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly customerMasterKeySpec?: string;
    /**
     * @stability stable
     */
    readonly deletionWindowInDays?: number;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly enableKeyRotation?: boolean;
    /**
     * @stability stable
     */
    readonly isEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly keyUsage?: string;
    /**
     * @stability stable
     */
    readonly policy?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class KmsKey extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: KmsKeyConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _customerMasterKeySpec?;
    /**
     * @stability stable
     */
    get customerMasterKeySpec(): string;
    /**
     * @stability stable
     */
    set customerMasterKeySpec(value: string);
    /**
     * @stability stable
     */
    resetCustomerMasterKeySpec(): void;
    /**
     * @stability stable
     */
    get customerMasterKeySpecInput(): string | undefined;
    private _deletionWindowInDays?;
    /**
     * @stability stable
     */
    get deletionWindowInDays(): number;
    /**
     * @stability stable
     */
    set deletionWindowInDays(value: number);
    /**
     * @stability stable
     */
    resetDeletionWindowInDays(): void;
    /**
     * @stability stable
     */
    get deletionWindowInDaysInput(): number | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _enableKeyRotation?;
    /**
     * @stability stable
     */
    get enableKeyRotation(): boolean;
    /**
     * @stability stable
     */
    set enableKeyRotation(value: boolean);
    /**
     * @stability stable
     */
    resetEnableKeyRotation(): void;
    /**
     * @stability stable
     */
    get enableKeyRotationInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _isEnabled?;
    /**
     * @stability stable
     */
    get isEnabled(): boolean;
    /**
     * @stability stable
     */
    set isEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetIsEnabled(): void;
    /**
     * @stability stable
     */
    get isEnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get keyId(): string;
    private _keyUsage?;
    /**
     * @stability stable
     */
    get keyUsage(): string;
    /**
     * @stability stable
     */
    set keyUsage(value: string);
    /**
     * @stability stable
     */
    resetKeyUsage(): void;
    /**
     * @stability stable
     */
    get keyUsageInput(): string | undefined;
    private _policy?;
    /**
     * @stability stable
     */
    get policy(): string;
    /**
     * @stability stable
     */
    set policy(value: string);
    /**
     * @stability stable
     */
    resetPolicy(): void;
    /**
     * @stability stable
     */
    get policyInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
