import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LakeformationDataLakeSettingsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly admins?: string[];
    /**
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * @stability stable
     */
    readonly trustedResourceOwners?: string[];
    /**
     * create_database_default_permissions block.
     *
     * @stability stable
     */
    readonly createDatabaseDefaultPermissions?: LakeformationDataLakeSettingsCreateDatabaseDefaultPermissions[];
    /**
     * create_table_default_permissions block.
     *
     * @stability stable
     */
    readonly createTableDefaultPermissions?: LakeformationDataLakeSettingsCreateTableDefaultPermissions[];
}
/**
 * @stability stable
 */
export interface LakeformationDataLakeSettingsCreateDatabaseDefaultPermissions {
    /**
     * @stability stable
     */
    readonly permissions?: string[];
    /**
     * @stability stable
     */
    readonly principal?: string;
}
/**
 * @stability stable
 */
export interface LakeformationDataLakeSettingsCreateTableDefaultPermissions {
    /**
     * @stability stable
     */
    readonly permissions?: string[];
    /**
     * @stability stable
     */
    readonly principal?: string;
}
/**
 * @stability stable
 */
export declare class LakeformationDataLakeSettings extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: LakeformationDataLakeSettingsConfig);
    private _admins?;
    /**
     * @stability stable
     */
    get admins(): string[];
    /**
     * @stability stable
     */
    set admins(value: string[]);
    /**
     * @stability stable
     */
    resetAdmins(): void;
    /**
     * @stability stable
     */
    get adminsInput(): string[] | undefined;
    private _catalogId?;
    /**
     * @stability stable
     */
    get catalogId(): string;
    /**
     * @stability stable
     */
    set catalogId(value: string);
    /**
     * @stability stable
     */
    resetCatalogId(): void;
    /**
     * @stability stable
     */
    get catalogIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _trustedResourceOwners?;
    /**
     * @stability stable
     */
    get trustedResourceOwners(): string[];
    /**
     * @stability stable
     */
    set trustedResourceOwners(value: string[]);
    /**
     * @stability stable
     */
    resetTrustedResourceOwners(): void;
    /**
     * @stability stable
     */
    get trustedResourceOwnersInput(): string[] | undefined;
    private _createDatabaseDefaultPermissions?;
    /**
     * @stability stable
     */
    get createDatabaseDefaultPermissions(): LakeformationDataLakeSettingsCreateDatabaseDefaultPermissions[];
    /**
     * @stability stable
     */
    set createDatabaseDefaultPermissions(value: LakeformationDataLakeSettingsCreateDatabaseDefaultPermissions[]);
    /**
     * @stability stable
     */
    resetCreateDatabaseDefaultPermissions(): void;
    /**
     * @stability stable
     */
    get createDatabaseDefaultPermissionsInput(): LakeformationDataLakeSettingsCreateDatabaseDefaultPermissions[] | undefined;
    private _createTableDefaultPermissions?;
    /**
     * @stability stable
     */
    get createTableDefaultPermissions(): LakeformationDataLakeSettingsCreateTableDefaultPermissions[];
    /**
     * @stability stable
     */
    set createTableDefaultPermissions(value: LakeformationDataLakeSettingsCreateTableDefaultPermissions[]);
    /**
     * @stability stable
     */
    resetCreateTableDefaultPermissions(): void;
    /**
     * @stability stable
     */
    get createTableDefaultPermissionsInput(): LakeformationDataLakeSettingsCreateTableDefaultPermissions[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
