import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LakeformationPermissionsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * @stability stable
     */
    readonly catalogResource?: boolean;
    /**
     * @stability stable
     */
    readonly permissions: string[];
    /**
     * @stability stable
     */
    readonly permissionsWithGrantOption?: string[];
    /**
     * @stability stable
     */
    readonly principal: string;
    /**
     * data_location block.
     *
     * @stability stable
     */
    readonly dataLocation?: LakeformationPermissionsDataLocation[];
    /**
     * database block.
     *
     * @stability stable
     */
    readonly database?: LakeformationPermissionsDatabase[];
    /**
     * table block.
     *
     * @stability stable
     */
    readonly table?: LakeformationPermissionsTable[];
    /**
     * table_with_columns block.
     *
     * @stability stable
     */
    readonly tableWithColumns?: LakeformationPermissionsTableWithColumns[];
}
/**
 * @stability stable
 */
export interface LakeformationPermissionsDataLocation {
    /**
     * @stability stable
     */
    readonly arn: string;
    /**
     * @stability stable
     */
    readonly catalogId?: string;
}
/**
 * @stability stable
 */
export interface LakeformationPermissionsDatabase {
    /**
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface LakeformationPermissionsTable {
    /**
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly wildcard?: boolean;
}
/**
 * @stability stable
 */
export interface LakeformationPermissionsTableWithColumns {
    /**
     * @stability stable
     */
    readonly catalogId?: string;
    /**
     * @stability stable
     */
    readonly columnNames?: string[];
    /**
     * @stability stable
     */
    readonly databaseName: string;
    /**
     * @stability stable
     */
    readonly excludedColumnNames?: string[];
    /**
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export declare class LakeformationPermissions extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LakeformationPermissionsConfig);
    private _catalogId?;
    /**
     * @stability stable
     */
    get catalogId(): string;
    /**
     * @stability stable
     */
    set catalogId(value: string);
    /**
     * @stability stable
     */
    resetCatalogId(): void;
    /**
     * @stability stable
     */
    get catalogIdInput(): string | undefined;
    private _catalogResource?;
    /**
     * @stability stable
     */
    get catalogResource(): boolean;
    /**
     * @stability stable
     */
    set catalogResource(value: boolean);
    /**
     * @stability stable
     */
    resetCatalogResource(): void;
    /**
     * @stability stable
     */
    get catalogResourceInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _permissions;
    /**
     * @stability stable
     */
    get permissions(): string[];
    /**
     * @stability stable
     */
    set permissions(value: string[]);
    /**
     * @stability stable
     */
    get permissionsInput(): string[];
    private _permissionsWithGrantOption?;
    /**
     * @stability stable
     */
    get permissionsWithGrantOption(): string[];
    /**
     * @stability stable
     */
    set permissionsWithGrantOption(value: string[]);
    /**
     * @stability stable
     */
    resetPermissionsWithGrantOption(): void;
    /**
     * @stability stable
     */
    get permissionsWithGrantOptionInput(): string[] | undefined;
    private _principal;
    /**
     * @stability stable
     */
    get principal(): string;
    /**
     * @stability stable
     */
    set principal(value: string);
    /**
     * @stability stable
     */
    get principalInput(): string;
    private _dataLocation?;
    /**
     * @stability stable
     */
    get dataLocation(): LakeformationPermissionsDataLocation[];
    /**
     * @stability stable
     */
    set dataLocation(value: LakeformationPermissionsDataLocation[]);
    /**
     * @stability stable
     */
    resetDataLocation(): void;
    /**
     * @stability stable
     */
    get dataLocationInput(): LakeformationPermissionsDataLocation[] | undefined;
    private _database?;
    /**
     * @stability stable
     */
    get database(): LakeformationPermissionsDatabase[];
    /**
     * @stability stable
     */
    set database(value: LakeformationPermissionsDatabase[]);
    /**
     * @stability stable
     */
    resetDatabase(): void;
    /**
     * @stability stable
     */
    get databaseInput(): LakeformationPermissionsDatabase[] | undefined;
    private _table?;
    /**
     * @stability stable
     */
    get table(): LakeformationPermissionsTable[];
    /**
     * @stability stable
     */
    set table(value: LakeformationPermissionsTable[]);
    /**
     * @stability stable
     */
    resetTable(): void;
    /**
     * @stability stable
     */
    get tableInput(): LakeformationPermissionsTable[] | undefined;
    private _tableWithColumns?;
    /**
     * @stability stable
     */
    get tableWithColumns(): LakeformationPermissionsTableWithColumns[];
    /**
     * @stability stable
     */
    set tableWithColumns(value: LakeformationPermissionsTableWithColumns[]);
    /**
     * @stability stable
     */
    resetTableWithColumns(): void;
    /**
     * @stability stable
     */
    get tableWithColumnsInput(): LakeformationPermissionsTableWithColumns[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
