import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LambdaAliasConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly functionName: string;
    /**
     * @stability stable
     */
    readonly functionVersion: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * routing_config block.
     *
     * @stability stable
     */
    readonly routingConfig?: LambdaAliasRoutingConfig[];
}
/**
 * @stability stable
 */
export interface LambdaAliasRoutingConfig {
    /**
     * @stability stable
     */
    readonly additionalVersionWeights?: {
        [key: string]: number;
    };
}
/**
 * @stability stable
 */
export declare class LambdaAlias extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LambdaAliasConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _functionName;
    /**
     * @stability stable
     */
    get functionName(): string;
    /**
     * @stability stable
     */
    set functionName(value: string);
    /**
     * @stability stable
     */
    get functionNameInput(): string;
    private _functionVersion;
    /**
     * @stability stable
     */
    get functionVersion(): string;
    /**
     * @stability stable
     */
    set functionVersion(value: string);
    /**
     * @stability stable
     */
    get functionVersionInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get invokeArn(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _routingConfig?;
    /**
     * @stability stable
     */
    get routingConfig(): LambdaAliasRoutingConfig[];
    /**
     * @stability stable
     */
    set routingConfig(value: LambdaAliasRoutingConfig[]);
    /**
     * @stability stable
     */
    resetRoutingConfig(): void;
    /**
     * @stability stable
     */
    get routingConfigInput(): LambdaAliasRoutingConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
