import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LambdaCodeSigningConfigConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * allowed_publishers block.
     *
     * @stability stable
     */
    readonly allowedPublishers: LambdaCodeSigningConfigAllowedPublishers[];
    /**
     * policies block.
     *
     * @stability stable
     */
    readonly policies?: LambdaCodeSigningConfigPolicies[];
}
/**
 * @stability stable
 */
export interface LambdaCodeSigningConfigAllowedPublishers {
    /**
     * @stability stable
     */
    readonly signingProfileVersionArns: string[];
}
/**
 * @stability stable
 */
export interface LambdaCodeSigningConfigPolicies {
    /**
     * @stability stable
     */
    readonly untrustedArtifactOnDeployment: string;
}
/**
 * @stability stable
 */
export declare class LambdaCodeSigningConfig extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LambdaCodeSigningConfigConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get configId(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastModified(): string;
    private _allowedPublishers;
    /**
     * @stability stable
     */
    get allowedPublishers(): LambdaCodeSigningConfigAllowedPublishers[];
    /**
     * @stability stable
     */
    set allowedPublishers(value: LambdaCodeSigningConfigAllowedPublishers[]);
    /**
     * @stability stable
     */
    get allowedPublishersInput(): LambdaCodeSigningConfigAllowedPublishers[];
    private _policies?;
    /**
     * @stability stable
     */
    get policies(): LambdaCodeSigningConfigPolicies[];
    /**
     * @stability stable
     */
    set policies(value: LambdaCodeSigningConfigPolicies[]);
    /**
     * @stability stable
     */
    resetPolicies(): void;
    /**
     * @stability stable
     */
    get policiesInput(): LambdaCodeSigningConfigPolicies[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
