import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LambdaEventSourceMappingConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly batchSize?: number;
    /**
     * @stability stable
     */
    readonly bisectBatchOnFunctionError?: boolean;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly eventSourceArn: string;
    /**
     * @stability stable
     */
    readonly functionName: string;
    /**
     * @stability stable
     */
    readonly maximumBatchingWindowInSeconds?: number;
    /**
     * @stability stable
     */
    readonly maximumRecordAgeInSeconds?: number;
    /**
     * @stability stable
     */
    readonly maximumRetryAttempts?: number;
    /**
     * @stability stable
     */
    readonly parallelizationFactor?: number;
    /**
     * @stability stable
     */
    readonly startingPosition?: string;
    /**
     * @stability stable
     */
    readonly startingPositionTimestamp?: string;
    /**
     * @stability stable
     */
    readonly topics?: string[];
    /**
     * destination_config block.
     *
     * @stability stable
     */
    readonly destinationConfig?: LambdaEventSourceMappingDestinationConfig[];
}
/**
 * @stability stable
 */
export interface LambdaEventSourceMappingDestinationConfigOnFailure {
    /**
     * @stability stable
     */
    readonly destinationArn: string;
}
/**
 * @stability stable
 */
export interface LambdaEventSourceMappingDestinationConfig {
    /**
     * on_failure block.
     *
     * @stability stable
     */
    readonly onFailure?: LambdaEventSourceMappingDestinationConfigOnFailure[];
}
/**
 * @stability stable
 */
export declare class LambdaEventSourceMapping extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LambdaEventSourceMappingConfig);
    private _batchSize?;
    /**
     * @stability stable
     */
    get batchSize(): number;
    /**
     * @stability stable
     */
    set batchSize(value: number);
    /**
     * @stability stable
     */
    resetBatchSize(): void;
    /**
     * @stability stable
     */
    get batchSizeInput(): number | undefined;
    private _bisectBatchOnFunctionError?;
    /**
     * @stability stable
     */
    get bisectBatchOnFunctionError(): boolean;
    /**
     * @stability stable
     */
    set bisectBatchOnFunctionError(value: boolean);
    /**
     * @stability stable
     */
    resetBisectBatchOnFunctionError(): void;
    /**
     * @stability stable
     */
    get bisectBatchOnFunctionErrorInput(): boolean | undefined;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    private _eventSourceArn;
    /**
     * @stability stable
     */
    get eventSourceArn(): string;
    /**
     * @stability stable
     */
    set eventSourceArn(value: string);
    /**
     * @stability stable
     */
    get eventSourceArnInput(): string;
    /**
     * @stability stable
     */
    get functionArn(): string;
    private _functionName;
    /**
     * @stability stable
     */
    get functionName(): string;
    /**
     * @stability stable
     */
    set functionName(value: string);
    /**
     * @stability stable
     */
    get functionNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastModified(): string;
    /**
     * @stability stable
     */
    get lastProcessingResult(): string;
    private _maximumBatchingWindowInSeconds?;
    /**
     * @stability stable
     */
    get maximumBatchingWindowInSeconds(): number;
    /**
     * @stability stable
     */
    set maximumBatchingWindowInSeconds(value: number);
    /**
     * @stability stable
     */
    resetMaximumBatchingWindowInSeconds(): void;
    /**
     * @stability stable
     */
    get maximumBatchingWindowInSecondsInput(): number | undefined;
    private _maximumRecordAgeInSeconds?;
    /**
     * @stability stable
     */
    get maximumRecordAgeInSeconds(): number;
    /**
     * @stability stable
     */
    set maximumRecordAgeInSeconds(value: number);
    /**
     * @stability stable
     */
    resetMaximumRecordAgeInSeconds(): void;
    /**
     * @stability stable
     */
    get maximumRecordAgeInSecondsInput(): number | undefined;
    private _maximumRetryAttempts?;
    /**
     * @stability stable
     */
    get maximumRetryAttempts(): number;
    /**
     * @stability stable
     */
    set maximumRetryAttempts(value: number);
    /**
     * @stability stable
     */
    resetMaximumRetryAttempts(): void;
    /**
     * @stability stable
     */
    get maximumRetryAttemptsInput(): number | undefined;
    private _parallelizationFactor?;
    /**
     * @stability stable
     */
    get parallelizationFactor(): number;
    /**
     * @stability stable
     */
    set parallelizationFactor(value: number);
    /**
     * @stability stable
     */
    resetParallelizationFactor(): void;
    /**
     * @stability stable
     */
    get parallelizationFactorInput(): number | undefined;
    private _startingPosition?;
    /**
     * @stability stable
     */
    get startingPosition(): string;
    /**
     * @stability stable
     */
    set startingPosition(value: string);
    /**
     * @stability stable
     */
    resetStartingPosition(): void;
    /**
     * @stability stable
     */
    get startingPositionInput(): string | undefined;
    private _startingPositionTimestamp?;
    /**
     * @stability stable
     */
    get startingPositionTimestamp(): string;
    /**
     * @stability stable
     */
    set startingPositionTimestamp(value: string);
    /**
     * @stability stable
     */
    resetStartingPositionTimestamp(): void;
    /**
     * @stability stable
     */
    get startingPositionTimestampInput(): string | undefined;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    get stateTransitionReason(): string;
    private _topics?;
    /**
     * @stability stable
     */
    get topics(): string[];
    /**
     * @stability stable
     */
    set topics(value: string[]);
    /**
     * @stability stable
     */
    resetTopics(): void;
    /**
     * @stability stable
     */
    get topicsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get uuid(): string;
    private _destinationConfig?;
    /**
     * @stability stable
     */
    get destinationConfig(): LambdaEventSourceMappingDestinationConfig[];
    /**
     * @stability stable
     */
    set destinationConfig(value: LambdaEventSourceMappingDestinationConfig[]);
    /**
     * @stability stable
     */
    resetDestinationConfig(): void;
    /**
     * @stability stable
     */
    get destinationConfigInput(): LambdaEventSourceMappingDestinationConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
