import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LambdaFunctionEventInvokeConfigConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly functionName: string;
    /**
     * @stability stable
     */
    readonly maximumEventAgeInSeconds?: number;
    /**
     * @stability stable
     */
    readonly maximumRetryAttempts?: number;
    /**
     * @stability stable
     */
    readonly qualifier?: string;
    /**
     * destination_config block.
     *
     * @stability stable
     */
    readonly destinationConfig?: LambdaFunctionEventInvokeConfigDestinationConfig[];
}
/**
 * @stability stable
 */
export interface LambdaFunctionEventInvokeConfigDestinationConfigOnFailure {
    /**
     * @stability stable
     */
    readonly destination: string;
}
/**
 * @stability stable
 */
export interface LambdaFunctionEventInvokeConfigDestinationConfigOnSuccess {
    /**
     * @stability stable
     */
    readonly destination: string;
}
/**
 * @stability stable
 */
export interface LambdaFunctionEventInvokeConfigDestinationConfig {
    /**
     * on_failure block.
     *
     * @stability stable
     */
    readonly onFailure?: LambdaFunctionEventInvokeConfigDestinationConfigOnFailure[];
    /**
     * on_success block.
     *
     * @stability stable
     */
    readonly onSuccess?: LambdaFunctionEventInvokeConfigDestinationConfigOnSuccess[];
}
/**
 * @stability stable
 */
export declare class LambdaFunctionEventInvokeConfig extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LambdaFunctionEventInvokeConfigConfig);
    private _functionName;
    /**
     * @stability stable
     */
    get functionName(): string;
    /**
     * @stability stable
     */
    set functionName(value: string);
    /**
     * @stability stable
     */
    get functionNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _maximumEventAgeInSeconds?;
    /**
     * @stability stable
     */
    get maximumEventAgeInSeconds(): number;
    /**
     * @stability stable
     */
    set maximumEventAgeInSeconds(value: number);
    /**
     * @stability stable
     */
    resetMaximumEventAgeInSeconds(): void;
    /**
     * @stability stable
     */
    get maximumEventAgeInSecondsInput(): number | undefined;
    private _maximumRetryAttempts?;
    /**
     * @stability stable
     */
    get maximumRetryAttempts(): number;
    /**
     * @stability stable
     */
    set maximumRetryAttempts(value: number);
    /**
     * @stability stable
     */
    resetMaximumRetryAttempts(): void;
    /**
     * @stability stable
     */
    get maximumRetryAttemptsInput(): number | undefined;
    private _qualifier?;
    /**
     * @stability stable
     */
    get qualifier(): string;
    /**
     * @stability stable
     */
    set qualifier(value: string);
    /**
     * @stability stable
     */
    resetQualifier(): void;
    /**
     * @stability stable
     */
    get qualifierInput(): string | undefined;
    private _destinationConfig?;
    /**
     * @stability stable
     */
    get destinationConfig(): LambdaFunctionEventInvokeConfigDestinationConfig[];
    /**
     * @stability stable
     */
    set destinationConfig(value: LambdaFunctionEventInvokeConfigDestinationConfig[]);
    /**
     * @stability stable
     */
    resetDestinationConfig(): void;
    /**
     * @stability stable
     */
    get destinationConfigInput(): LambdaFunctionEventInvokeConfigDestinationConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
