import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LambdaLayerVersionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly compatibleRuntimes?: string[];
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly filename?: string;
    /**
     * @stability stable
     */
    readonly layerName: string;
    /**
     * @stability stable
     */
    readonly licenseInfo?: string;
    /**
     * @stability stable
     */
    readonly s3Bucket?: string;
    /**
     * @stability stable
     */
    readonly s3Key?: string;
    /**
     * @stability stable
     */
    readonly s3ObjectVersion?: string;
    /**
     * @stability stable
     */
    readonly sourceCodeHash?: string;
}
/**
 * @stability stable
 */
export declare class LambdaLayerVersion extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LambdaLayerVersionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _compatibleRuntimes?;
    /**
     * @stability stable
     */
    get compatibleRuntimes(): string[];
    /**
     * @stability stable
     */
    set compatibleRuntimes(value: string[]);
    /**
     * @stability stable
     */
    resetCompatibleRuntimes(): void;
    /**
     * @stability stable
     */
    get compatibleRuntimesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get createdDate(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _filename?;
    /**
     * @stability stable
     */
    get filename(): string;
    /**
     * @stability stable
     */
    set filename(value: string);
    /**
     * @stability stable
     */
    resetFilename(): void;
    /**
     * @stability stable
     */
    get filenameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get layerArn(): string;
    private _layerName;
    /**
     * @stability stable
     */
    get layerName(): string;
    /**
     * @stability stable
     */
    set layerName(value: string);
    /**
     * @stability stable
     */
    get layerNameInput(): string;
    private _licenseInfo?;
    /**
     * @stability stable
     */
    get licenseInfo(): string;
    /**
     * @stability stable
     */
    set licenseInfo(value: string);
    /**
     * @stability stable
     */
    resetLicenseInfo(): void;
    /**
     * @stability stable
     */
    get licenseInfoInput(): string | undefined;
    private _s3Bucket?;
    /**
     * @stability stable
     */
    get s3Bucket(): string;
    /**
     * @stability stable
     */
    set s3Bucket(value: string);
    /**
     * @stability stable
     */
    resetS3Bucket(): void;
    /**
     * @stability stable
     */
    get s3BucketInput(): string | undefined;
    private _s3Key?;
    /**
     * @stability stable
     */
    get s3Key(): string;
    /**
     * @stability stable
     */
    set s3Key(value: string);
    /**
     * @stability stable
     */
    resetS3Key(): void;
    /**
     * @stability stable
     */
    get s3KeyInput(): string | undefined;
    private _s3ObjectVersion?;
    /**
     * @stability stable
     */
    get s3ObjectVersion(): string;
    /**
     * @stability stable
     */
    set s3ObjectVersion(value: string);
    /**
     * @stability stable
     */
    resetS3ObjectVersion(): void;
    /**
     * @stability stable
     */
    get s3ObjectVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get signingJobArn(): string;
    /**
     * @stability stable
     */
    get signingProfileVersionArn(): string;
    private _sourceCodeHash?;
    /**
     * @stability stable
     */
    get sourceCodeHash(): string;
    /**
     * @stability stable
     */
    set sourceCodeHash(value: string);
    /**
     * @stability stable
     */
    resetSourceCodeHash(): void;
    /**
     * @stability stable
     */
    get sourceCodeHashInput(): string | undefined;
    /**
     * @stability stable
     */
    get sourceCodeSize(): number;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
