import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LambdaPermissionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly action: string;
    /**
     * @stability stable
     */
    readonly eventSourceToken?: string;
    /**
     * @stability stable
     */
    readonly functionName: string;
    /**
     * @stability stable
     */
    readonly principal: string;
    /**
     * @stability stable
     */
    readonly qualifier?: string;
    /**
     * @stability stable
     */
    readonly sourceAccount?: string;
    /**
     * @stability stable
     */
    readonly sourceArn?: string;
    /**
     * @stability stable
     */
    readonly statementId?: string;
    /**
     * @stability stable
     */
    readonly statementIdPrefix?: string;
}
/**
 * @stability stable
 */
export declare class LambdaPermission extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LambdaPermissionConfig);
    private _action;
    /**
     * @stability stable
     */
    get action(): string;
    /**
     * @stability stable
     */
    set action(value: string);
    /**
     * @stability stable
     */
    get actionInput(): string;
    private _eventSourceToken?;
    /**
     * @stability stable
     */
    get eventSourceToken(): string;
    /**
     * @stability stable
     */
    set eventSourceToken(value: string);
    /**
     * @stability stable
     */
    resetEventSourceToken(): void;
    /**
     * @stability stable
     */
    get eventSourceTokenInput(): string | undefined;
    private _functionName;
    /**
     * @stability stable
     */
    get functionName(): string;
    /**
     * @stability stable
     */
    set functionName(value: string);
    /**
     * @stability stable
     */
    get functionNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _principal;
    /**
     * @stability stable
     */
    get principal(): string;
    /**
     * @stability stable
     */
    set principal(value: string);
    /**
     * @stability stable
     */
    get principalInput(): string;
    private _qualifier?;
    /**
     * @stability stable
     */
    get qualifier(): string;
    /**
     * @stability stable
     */
    set qualifier(value: string);
    /**
     * @stability stable
     */
    resetQualifier(): void;
    /**
     * @stability stable
     */
    get qualifierInput(): string | undefined;
    private _sourceAccount?;
    /**
     * @stability stable
     */
    get sourceAccount(): string;
    /**
     * @stability stable
     */
    set sourceAccount(value: string);
    /**
     * @stability stable
     */
    resetSourceAccount(): void;
    /**
     * @stability stable
     */
    get sourceAccountInput(): string | undefined;
    private _sourceArn?;
    /**
     * @stability stable
     */
    get sourceArn(): string;
    /**
     * @stability stable
     */
    set sourceArn(value: string);
    /**
     * @stability stable
     */
    resetSourceArn(): void;
    /**
     * @stability stable
     */
    get sourceArnInput(): string | undefined;
    private _statementId?;
    /**
     * @stability stable
     */
    get statementId(): string;
    /**
     * @stability stable
     */
    set statementId(value: string);
    /**
     * @stability stable
     */
    resetStatementId(): void;
    /**
     * @stability stable
     */
    get statementIdInput(): string | undefined;
    private _statementIdPrefix?;
    /**
     * @stability stable
     */
    get statementIdPrefix(): string;
    /**
     * @stability stable
     */
    set statementIdPrefix(value: string);
    /**
     * @stability stable
     */
    resetStatementIdPrefix(): void;
    /**
     * @stability stable
     */
    get statementIdPrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
