import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LambdaProvisionedConcurrencyConfigConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly functionName: string;
    /**
     * @stability stable
     */
    readonly provisionedConcurrentExecutions: number;
    /**
     * @stability stable
     */
    readonly qualifier: string;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: LambdaProvisionedConcurrencyConfigTimeouts;
}
/**
 * @stability stable
 */
export interface LambdaProvisionedConcurrencyConfigTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class LambdaProvisionedConcurrencyConfig extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LambdaProvisionedConcurrencyConfigConfig);
    private _functionName;
    /**
     * @stability stable
     */
    get functionName(): string;
    /**
     * @stability stable
     */
    set functionName(value: string);
    /**
     * @stability stable
     */
    get functionNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _provisionedConcurrentExecutions;
    /**
     * @stability stable
     */
    get provisionedConcurrentExecutions(): number;
    /**
     * @stability stable
     */
    set provisionedConcurrentExecutions(value: number);
    /**
     * @stability stable
     */
    get provisionedConcurrentExecutionsInput(): number;
    private _qualifier;
    /**
     * @stability stable
     */
    get qualifier(): string;
    /**
     * @stability stable
     */
    set qualifier(value: string);
    /**
     * @stability stable
     */
    get qualifierInput(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): LambdaProvisionedConcurrencyConfigTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: LambdaProvisionedConcurrencyConfigTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): LambdaProvisionedConcurrencyConfigTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
