import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LaunchConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly associatePublicIpAddress?: boolean;
    /**
     * @stability stable
     */
    readonly ebsOptimized?: boolean;
    /**
     * @stability stable
     */
    readonly enableMonitoring?: boolean;
    /**
     * @stability stable
     */
    readonly iamInstanceProfile?: string;
    /**
     * @stability stable
     */
    readonly imageId: string;
    /**
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * @stability stable
     */
    readonly keyName?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly placementTenancy?: string;
    /**
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * @stability stable
     */
    readonly spotPrice?: string;
    /**
     * @stability stable
     */
    readonly userData?: string;
    /**
     * @stability stable
     */
    readonly userDataBase64?: string;
    /**
     * @stability stable
     */
    readonly vpcClassicLinkId?: string;
    /**
     * @stability stable
     */
    readonly vpcClassicLinkSecurityGroups?: string[];
    /**
     * ebs_block_device block.
     *
     * @stability stable
     */
    readonly ebsBlockDevice?: LaunchConfigurationEbsBlockDevice[];
    /**
     * ephemeral_block_device block.
     *
     * @stability stable
     */
    readonly ephemeralBlockDevice?: LaunchConfigurationEphemeralBlockDevice[];
    /**
     * metadata_options block.
     *
     * @stability stable
     */
    readonly metadataOptions?: LaunchConfigurationMetadataOptions[];
    /**
     * root_block_device block.
     *
     * @stability stable
     */
    readonly rootBlockDevice?: LaunchConfigurationRootBlockDevice[];
}
/**
 * @stability stable
 */
export interface LaunchConfigurationEbsBlockDevice {
    /**
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly noDevice?: boolean;
    /**
     * @stability stable
     */
    readonly snapshotId?: string;
    /**
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface LaunchConfigurationEphemeralBlockDevice {
    /**
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * @stability stable
     */
    readonly virtualName: string;
}
/**
 * @stability stable
 */
export interface LaunchConfigurationMetadataOptions {
    /**
     * @stability stable
     */
    readonly httpEndpoint?: string;
    /**
     * @stability stable
     */
    readonly httpPutResponseHopLimit?: number;
    /**
     * @stability stable
     */
    readonly httpTokens?: string;
}
/**
 * @stability stable
 */
export interface LaunchConfigurationRootBlockDevice {
    /**
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export declare class LaunchConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LaunchConfigurationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _associatePublicIpAddress?;
    /**
     * @stability stable
     */
    get associatePublicIpAddress(): boolean;
    /**
     * @stability stable
     */
    set associatePublicIpAddress(value: boolean);
    /**
     * @stability stable
     */
    resetAssociatePublicIpAddress(): void;
    /**
     * @stability stable
     */
    get associatePublicIpAddressInput(): boolean | undefined;
    private _ebsOptimized?;
    /**
     * @stability stable
     */
    get ebsOptimized(): boolean;
    /**
     * @stability stable
     */
    set ebsOptimized(value: boolean);
    /**
     * @stability stable
     */
    resetEbsOptimized(): void;
    /**
     * @stability stable
     */
    get ebsOptimizedInput(): boolean | undefined;
    private _enableMonitoring?;
    /**
     * @stability stable
     */
    get enableMonitoring(): boolean;
    /**
     * @stability stable
     */
    set enableMonitoring(value: boolean);
    /**
     * @stability stable
     */
    resetEnableMonitoring(): void;
    /**
     * @stability stable
     */
    get enableMonitoringInput(): boolean | undefined;
    private _iamInstanceProfile?;
    /**
     * @stability stable
     */
    get iamInstanceProfile(): string;
    /**
     * @stability stable
     */
    set iamInstanceProfile(value: string);
    /**
     * @stability stable
     */
    resetIamInstanceProfile(): void;
    /**
     * @stability stable
     */
    get iamInstanceProfileInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _imageId;
    /**
     * @stability stable
     */
    get imageId(): string;
    /**
     * @stability stable
     */
    set imageId(value: string);
    /**
     * @stability stable
     */
    get imageIdInput(): string;
    private _instanceType;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    get instanceTypeInput(): string;
    private _keyName?;
    /**
     * @stability stable
     */
    get keyName(): string;
    /**
     * @stability stable
     */
    set keyName(value: string);
    /**
     * @stability stable
     */
    resetKeyName(): void;
    /**
     * @stability stable
     */
    get keyNameInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _placementTenancy?;
    /**
     * @stability stable
     */
    get placementTenancy(): string;
    /**
     * @stability stable
     */
    set placementTenancy(value: string);
    /**
     * @stability stable
     */
    resetPlacementTenancy(): void;
    /**
     * @stability stable
     */
    get placementTenancyInput(): string | undefined;
    private _securityGroups?;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    set securityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroups(): void;
    /**
     * @stability stable
     */
    get securityGroupsInput(): string[] | undefined;
    private _spotPrice?;
    /**
     * @stability stable
     */
    get spotPrice(): string;
    /**
     * @stability stable
     */
    set spotPrice(value: string);
    /**
     * @stability stable
     */
    resetSpotPrice(): void;
    /**
     * @stability stable
     */
    get spotPriceInput(): string | undefined;
    private _userData?;
    /**
     * @stability stable
     */
    get userData(): string;
    /**
     * @stability stable
     */
    set userData(value: string);
    /**
     * @stability stable
     */
    resetUserData(): void;
    /**
     * @stability stable
     */
    get userDataInput(): string | undefined;
    private _userDataBase64?;
    /**
     * @stability stable
     */
    get userDataBase64(): string;
    /**
     * @stability stable
     */
    set userDataBase64(value: string);
    /**
     * @stability stable
     */
    resetUserDataBase64(): void;
    /**
     * @stability stable
     */
    get userDataBase64Input(): string | undefined;
    private _vpcClassicLinkId?;
    /**
     * @stability stable
     */
    get vpcClassicLinkId(): string;
    /**
     * @stability stable
     */
    set vpcClassicLinkId(value: string);
    /**
     * @stability stable
     */
    resetVpcClassicLinkId(): void;
    /**
     * @stability stable
     */
    get vpcClassicLinkIdInput(): string | undefined;
    private _vpcClassicLinkSecurityGroups?;
    /**
     * @stability stable
     */
    get vpcClassicLinkSecurityGroups(): string[];
    /**
     * @stability stable
     */
    set vpcClassicLinkSecurityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetVpcClassicLinkSecurityGroups(): void;
    /**
     * @stability stable
     */
    get vpcClassicLinkSecurityGroupsInput(): string[] | undefined;
    private _ebsBlockDevice?;
    /**
     * @stability stable
     */
    get ebsBlockDevice(): LaunchConfigurationEbsBlockDevice[];
    /**
     * @stability stable
     */
    set ebsBlockDevice(value: LaunchConfigurationEbsBlockDevice[]);
    /**
     * @stability stable
     */
    resetEbsBlockDevice(): void;
    /**
     * @stability stable
     */
    get ebsBlockDeviceInput(): LaunchConfigurationEbsBlockDevice[] | undefined;
    private _ephemeralBlockDevice?;
    /**
     * @stability stable
     */
    get ephemeralBlockDevice(): LaunchConfigurationEphemeralBlockDevice[];
    /**
     * @stability stable
     */
    set ephemeralBlockDevice(value: LaunchConfigurationEphemeralBlockDevice[]);
    /**
     * @stability stable
     */
    resetEphemeralBlockDevice(): void;
    /**
     * @stability stable
     */
    get ephemeralBlockDeviceInput(): LaunchConfigurationEphemeralBlockDevice[] | undefined;
    private _metadataOptions?;
    /**
     * @stability stable
     */
    get metadataOptions(): LaunchConfigurationMetadataOptions[];
    /**
     * @stability stable
     */
    set metadataOptions(value: LaunchConfigurationMetadataOptions[]);
    /**
     * @stability stable
     */
    resetMetadataOptions(): void;
    /**
     * @stability stable
     */
    get metadataOptionsInput(): LaunchConfigurationMetadataOptions[] | undefined;
    private _rootBlockDevice?;
    /**
     * @stability stable
     */
    get rootBlockDevice(): LaunchConfigurationRootBlockDevice[];
    /**
     * @stability stable
     */
    set rootBlockDevice(value: LaunchConfigurationRootBlockDevice[]);
    /**
     * @stability stable
     */
    resetRootBlockDevice(): void;
    /**
     * @stability stable
     */
    get rootBlockDeviceInput(): LaunchConfigurationRootBlockDevice[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
