import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LaunchTemplateConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly defaultVersion?: number;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly disableApiTermination?: boolean;
    /**
     * @stability stable
     */
    readonly ebsOptimized?: string;
    /**
     * @stability stable
     */
    readonly imageId?: string;
    /**
     * @stability stable
     */
    readonly instanceInitiatedShutdownBehavior?: string;
    /**
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * @stability stable
     */
    readonly kernelId?: string;
    /**
     * @stability stable
     */
    readonly keyName?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly ramDiskId?: string;
    /**
     * @stability stable
     */
    readonly securityGroupNames?: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly updateDefaultVersion?: boolean;
    /**
     * @stability stable
     */
    readonly userData?: string;
    /**
     * @stability stable
     */
    readonly vpcSecurityGroupIds?: string[];
    /**
     * block_device_mappings block.
     *
     * @stability stable
     */
    readonly blockDeviceMappings?: LaunchTemplateBlockDeviceMappings[];
    /**
     * capacity_reservation_specification block.
     *
     * @stability stable
     */
    readonly capacityReservationSpecification?: LaunchTemplateCapacityReservationSpecification[];
    /**
     * cpu_options block.
     *
     * @stability stable
     */
    readonly cpuOptions?: LaunchTemplateCpuOptions[];
    /**
     * credit_specification block.
     *
     * @stability stable
     */
    readonly creditSpecification?: LaunchTemplateCreditSpecification[];
    /**
     * elastic_gpu_specifications block.
     *
     * @stability stable
     */
    readonly elasticGpuSpecifications?: LaunchTemplateElasticGpuSpecifications[];
    /**
     * elastic_inference_accelerator block.
     *
     * @stability stable
     */
    readonly elasticInferenceAccelerator?: LaunchTemplateElasticInferenceAccelerator[];
    /**
     * enclave_options block.
     *
     * @stability stable
     */
    readonly enclaveOptions?: LaunchTemplateEnclaveOptions[];
    /**
     * hibernation_options block.
     *
     * @stability stable
     */
    readonly hibernationOptions?: LaunchTemplateHibernationOptions[];
    /**
     * iam_instance_profile block.
     *
     * @stability stable
     */
    readonly iamInstanceProfile?: LaunchTemplateIamInstanceProfile[];
    /**
     * instance_market_options block.
     *
     * @stability stable
     */
    readonly instanceMarketOptions?: LaunchTemplateInstanceMarketOptions[];
    /**
     * license_specification block.
     *
     * @stability stable
     */
    readonly licenseSpecification?: LaunchTemplateLicenseSpecification[];
    /**
     * metadata_options block.
     *
     * @stability stable
     */
    readonly metadataOptions?: LaunchTemplateMetadataOptions[];
    /**
     * monitoring block.
     *
     * @stability stable
     */
    readonly monitoring?: LaunchTemplateMonitoring[];
    /**
     * network_interfaces block.
     *
     * @stability stable
     */
    readonly networkInterfaces?: LaunchTemplateNetworkInterfaces[];
    /**
     * placement block.
     *
     * @stability stable
     */
    readonly placement?: LaunchTemplatePlacement[];
    /**
     * tag_specifications block.
     *
     * @stability stable
     */
    readonly tagSpecifications?: LaunchTemplateTagSpecifications[];
}
/**
 * @stability stable
 */
export interface LaunchTemplateBlockDeviceMappingsEbs {
    /**
     * @stability stable
     */
    readonly deleteOnTermination?: string;
    /**
     * @stability stable
     */
    readonly encrypted?: string;
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly snapshotId?: string;
    /**
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateBlockDeviceMappings {
    /**
     * @stability stable
     */
    readonly deviceName?: string;
    /**
     * @stability stable
     */
    readonly noDevice?: string;
    /**
     * @stability stable
     */
    readonly virtualName?: string;
    /**
     * ebs block.
     *
     * @stability stable
     */
    readonly ebs?: LaunchTemplateBlockDeviceMappingsEbs[];
}
/**
 * @stability stable
 */
export interface LaunchTemplateCapacityReservationSpecificationCapacityReservationTarget {
    /**
     * @stability stable
     */
    readonly capacityReservationId?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateCapacityReservationSpecification {
    /**
     * @stability stable
     */
    readonly capacityReservationPreference?: string;
    /**
     * capacity_reservation_target block.
     *
     * @stability stable
     */
    readonly capacityReservationTarget?: LaunchTemplateCapacityReservationSpecificationCapacityReservationTarget[];
}
/**
 * @stability stable
 */
export interface LaunchTemplateCpuOptions {
    /**
     * @stability stable
     */
    readonly coreCount?: number;
    /**
     * @stability stable
     */
    readonly threadsPerCore?: number;
}
/**
 * @stability stable
 */
export interface LaunchTemplateCreditSpecification {
    /**
     * @stability stable
     */
    readonly cpuCredits?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateElasticGpuSpecifications {
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateElasticInferenceAccelerator {
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateEnclaveOptions {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
}
/**
 * @stability stable
 */
export interface LaunchTemplateHibernationOptions {
    /**
     * @stability stable
     */
    readonly configured: boolean;
}
/**
 * @stability stable
 */
export interface LaunchTemplateIamInstanceProfile {
    /**
     * @stability stable
     */
    readonly arn?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateInstanceMarketOptionsSpotOptions {
    /**
     * @stability stable
     */
    readonly blockDurationMinutes?: number;
    /**
     * @stability stable
     */
    readonly instanceInterruptionBehavior?: string;
    /**
     * @stability stable
     */
    readonly maxPrice?: string;
    /**
     * @stability stable
     */
    readonly spotInstanceType?: string;
    /**
     * @stability stable
     */
    readonly validUntil?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateInstanceMarketOptions {
    /**
     * @stability stable
     */
    readonly marketType?: string;
    /**
     * spot_options block.
     *
     * @stability stable
     */
    readonly spotOptions?: LaunchTemplateInstanceMarketOptionsSpotOptions[];
}
/**
 * @stability stable
 */
export interface LaunchTemplateLicenseSpecification {
    /**
     * @stability stable
     */
    readonly licenseConfigurationArn: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateMetadataOptions {
    /**
     * @stability stable
     */
    readonly httpEndpoint?: string;
    /**
     * @stability stable
     */
    readonly httpPutResponseHopLimit?: number;
    /**
     * @stability stable
     */
    readonly httpTokens?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateMonitoring {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
}
/**
 * @stability stable
 */
export interface LaunchTemplateNetworkInterfaces {
    /**
     * @stability stable
     */
    readonly associateCarrierIpAddress?: string;
    /**
     * @stability stable
     */
    readonly associatePublicIpAddress?: string;
    /**
     * @stability stable
     */
    readonly deleteOnTermination?: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly deviceIndex?: number;
    /**
     * @stability stable
     */
    readonly ipv4AddressCount?: number;
    /**
     * @stability stable
     */
    readonly ipv4Addresses?: string[];
    /**
     * @stability stable
     */
    readonly ipv6AddressCount?: number;
    /**
     * @stability stable
     */
    readonly ipv6Addresses?: string[];
    /**
     * @stability stable
     */
    readonly networkInterfaceId?: string;
    /**
     * @stability stable
     */
    readonly privateIpAddress?: string;
    /**
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * @stability stable
     */
    readonly subnetId?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplatePlacement {
    /**
     * @stability stable
     */
    readonly affinity?: string;
    /**
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * @stability stable
     */
    readonly groupName?: string;
    /**
     * @stability stable
     */
    readonly hostId?: string;
    /**
     * @stability stable
     */
    readonly partitionNumber?: number;
    /**
     * @stability stable
     */
    readonly spreadDomain?: string;
    /**
     * @stability stable
     */
    readonly tenancy?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateTagSpecifications {
    /**
     * @stability stable
     */
    readonly resourceType?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class LaunchTemplate extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: LaunchTemplateConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _defaultVersion?;
    /**
     * @stability stable
     */
    get defaultVersion(): number;
    /**
     * @stability stable
     */
    set defaultVersion(value: number);
    /**
     * @stability stable
     */
    resetDefaultVersion(): void;
    /**
     * @stability stable
     */
    get defaultVersionInput(): number | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _disableApiTermination?;
    /**
     * @stability stable
     */
    get disableApiTermination(): boolean;
    /**
     * @stability stable
     */
    set disableApiTermination(value: boolean);
    /**
     * @stability stable
     */
    resetDisableApiTermination(): void;
    /**
     * @stability stable
     */
    get disableApiTerminationInput(): boolean | undefined;
    private _ebsOptimized?;
    /**
     * @stability stable
     */
    get ebsOptimized(): string;
    /**
     * @stability stable
     */
    set ebsOptimized(value: string);
    /**
     * @stability stable
     */
    resetEbsOptimized(): void;
    /**
     * @stability stable
     */
    get ebsOptimizedInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _imageId?;
    /**
     * @stability stable
     */
    get imageId(): string;
    /**
     * @stability stable
     */
    set imageId(value: string);
    /**
     * @stability stable
     */
    resetImageId(): void;
    /**
     * @stability stable
     */
    get imageIdInput(): string | undefined;
    private _instanceInitiatedShutdownBehavior?;
    /**
     * @stability stable
     */
    get instanceInitiatedShutdownBehavior(): string;
    /**
     * @stability stable
     */
    set instanceInitiatedShutdownBehavior(value: string);
    /**
     * @stability stable
     */
    resetInstanceInitiatedShutdownBehavior(): void;
    /**
     * @stability stable
     */
    get instanceInitiatedShutdownBehaviorInput(): string | undefined;
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    resetInstanceType(): void;
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    private _kernelId?;
    /**
     * @stability stable
     */
    get kernelId(): string;
    /**
     * @stability stable
     */
    set kernelId(value: string);
    /**
     * @stability stable
     */
    resetKernelId(): void;
    /**
     * @stability stable
     */
    get kernelIdInput(): string | undefined;
    private _keyName?;
    /**
     * @stability stable
     */
    get keyName(): string;
    /**
     * @stability stable
     */
    set keyName(value: string);
    /**
     * @stability stable
     */
    resetKeyName(): void;
    /**
     * @stability stable
     */
    get keyNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get latestVersion(): number;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _ramDiskId?;
    /**
     * @stability stable
     */
    get ramDiskId(): string;
    /**
     * @stability stable
     */
    set ramDiskId(value: string);
    /**
     * @stability stable
     */
    resetRamDiskId(): void;
    /**
     * @stability stable
     */
    get ramDiskIdInput(): string | undefined;
    private _securityGroupNames?;
    /**
     * @stability stable
     */
    get securityGroupNames(): string[];
    /**
     * @stability stable
     */
    set securityGroupNames(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupNames(): void;
    /**
     * @stability stable
     */
    get securityGroupNamesInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _updateDefaultVersion?;
    /**
     * @stability stable
     */
    get updateDefaultVersion(): boolean;
    /**
     * @stability stable
     */
    set updateDefaultVersion(value: boolean);
    /**
     * @stability stable
     */
    resetUpdateDefaultVersion(): void;
    /**
     * @stability stable
     */
    get updateDefaultVersionInput(): boolean | undefined;
    private _userData?;
    /**
     * @stability stable
     */
    get userData(): string;
    /**
     * @stability stable
     */
    set userData(value: string);
    /**
     * @stability stable
     */
    resetUserData(): void;
    /**
     * @stability stable
     */
    get userDataInput(): string | undefined;
    private _vpcSecurityGroupIds?;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set vpcSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetVpcSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIdsInput(): string[] | undefined;
    private _blockDeviceMappings?;
    /**
     * @stability stable
     */
    get blockDeviceMappings(): LaunchTemplateBlockDeviceMappings[];
    /**
     * @stability stable
     */
    set blockDeviceMappings(value: LaunchTemplateBlockDeviceMappings[]);
    /**
     * @stability stable
     */
    resetBlockDeviceMappings(): void;
    /**
     * @stability stable
     */
    get blockDeviceMappingsInput(): LaunchTemplateBlockDeviceMappings[] | undefined;
    private _capacityReservationSpecification?;
    /**
     * @stability stable
     */
    get capacityReservationSpecification(): LaunchTemplateCapacityReservationSpecification[];
    /**
     * @stability stable
     */
    set capacityReservationSpecification(value: LaunchTemplateCapacityReservationSpecification[]);
    /**
     * @stability stable
     */
    resetCapacityReservationSpecification(): void;
    /**
     * @stability stable
     */
    get capacityReservationSpecificationInput(): LaunchTemplateCapacityReservationSpecification[] | undefined;
    private _cpuOptions?;
    /**
     * @stability stable
     */
    get cpuOptions(): LaunchTemplateCpuOptions[];
    /**
     * @stability stable
     */
    set cpuOptions(value: LaunchTemplateCpuOptions[]);
    /**
     * @stability stable
     */
    resetCpuOptions(): void;
    /**
     * @stability stable
     */
    get cpuOptionsInput(): LaunchTemplateCpuOptions[] | undefined;
    private _creditSpecification?;
    /**
     * @stability stable
     */
    get creditSpecification(): LaunchTemplateCreditSpecification[];
    /**
     * @stability stable
     */
    set creditSpecification(value: LaunchTemplateCreditSpecification[]);
    /**
     * @stability stable
     */
    resetCreditSpecification(): void;
    /**
     * @stability stable
     */
    get creditSpecificationInput(): LaunchTemplateCreditSpecification[] | undefined;
    private _elasticGpuSpecifications?;
    /**
     * @stability stable
     */
    get elasticGpuSpecifications(): LaunchTemplateElasticGpuSpecifications[];
    /**
     * @stability stable
     */
    set elasticGpuSpecifications(value: LaunchTemplateElasticGpuSpecifications[]);
    /**
     * @stability stable
     */
    resetElasticGpuSpecifications(): void;
    /**
     * @stability stable
     */
    get elasticGpuSpecificationsInput(): LaunchTemplateElasticGpuSpecifications[] | undefined;
    private _elasticInferenceAccelerator?;
    /**
     * @stability stable
     */
    get elasticInferenceAccelerator(): LaunchTemplateElasticInferenceAccelerator[];
    /**
     * @stability stable
     */
    set elasticInferenceAccelerator(value: LaunchTemplateElasticInferenceAccelerator[]);
    /**
     * @stability stable
     */
    resetElasticInferenceAccelerator(): void;
    /**
     * @stability stable
     */
    get elasticInferenceAcceleratorInput(): LaunchTemplateElasticInferenceAccelerator[] | undefined;
    private _enclaveOptions?;
    /**
     * @stability stable
     */
    get enclaveOptions(): LaunchTemplateEnclaveOptions[];
    /**
     * @stability stable
     */
    set enclaveOptions(value: LaunchTemplateEnclaveOptions[]);
    /**
     * @stability stable
     */
    resetEnclaveOptions(): void;
    /**
     * @stability stable
     */
    get enclaveOptionsInput(): LaunchTemplateEnclaveOptions[] | undefined;
    private _hibernationOptions?;
    /**
     * @stability stable
     */
    get hibernationOptions(): LaunchTemplateHibernationOptions[];
    /**
     * @stability stable
     */
    set hibernationOptions(value: LaunchTemplateHibernationOptions[]);
    /**
     * @stability stable
     */
    resetHibernationOptions(): void;
    /**
     * @stability stable
     */
    get hibernationOptionsInput(): LaunchTemplateHibernationOptions[] | undefined;
    private _iamInstanceProfile?;
    /**
     * @stability stable
     */
    get iamInstanceProfile(): LaunchTemplateIamInstanceProfile[];
    /**
     * @stability stable
     */
    set iamInstanceProfile(value: LaunchTemplateIamInstanceProfile[]);
    /**
     * @stability stable
     */
    resetIamInstanceProfile(): void;
    /**
     * @stability stable
     */
    get iamInstanceProfileInput(): LaunchTemplateIamInstanceProfile[] | undefined;
    private _instanceMarketOptions?;
    /**
     * @stability stable
     */
    get instanceMarketOptions(): LaunchTemplateInstanceMarketOptions[];
    /**
     * @stability stable
     */
    set instanceMarketOptions(value: LaunchTemplateInstanceMarketOptions[]);
    /**
     * @stability stable
     */
    resetInstanceMarketOptions(): void;
    /**
     * @stability stable
     */
    get instanceMarketOptionsInput(): LaunchTemplateInstanceMarketOptions[] | undefined;
    private _licenseSpecification?;
    /**
     * @stability stable
     */
    get licenseSpecification(): LaunchTemplateLicenseSpecification[];
    /**
     * @stability stable
     */
    set licenseSpecification(value: LaunchTemplateLicenseSpecification[]);
    /**
     * @stability stable
     */
    resetLicenseSpecification(): void;
    /**
     * @stability stable
     */
    get licenseSpecificationInput(): LaunchTemplateLicenseSpecification[] | undefined;
    private _metadataOptions?;
    /**
     * @stability stable
     */
    get metadataOptions(): LaunchTemplateMetadataOptions[];
    /**
     * @stability stable
     */
    set metadataOptions(value: LaunchTemplateMetadataOptions[]);
    /**
     * @stability stable
     */
    resetMetadataOptions(): void;
    /**
     * @stability stable
     */
    get metadataOptionsInput(): LaunchTemplateMetadataOptions[] | undefined;
    private _monitoring?;
    /**
     * @stability stable
     */
    get monitoring(): LaunchTemplateMonitoring[];
    /**
     * @stability stable
     */
    set monitoring(value: LaunchTemplateMonitoring[]);
    /**
     * @stability stable
     */
    resetMonitoring(): void;
    /**
     * @stability stable
     */
    get monitoringInput(): LaunchTemplateMonitoring[] | undefined;
    private _networkInterfaces?;
    /**
     * @stability stable
     */
    get networkInterfaces(): LaunchTemplateNetworkInterfaces[];
    /**
     * @stability stable
     */
    set networkInterfaces(value: LaunchTemplateNetworkInterfaces[]);
    /**
     * @stability stable
     */
    resetNetworkInterfaces(): void;
    /**
     * @stability stable
     */
    get networkInterfacesInput(): LaunchTemplateNetworkInterfaces[] | undefined;
    private _placement?;
    /**
     * @stability stable
     */
    get placement(): LaunchTemplatePlacement[];
    /**
     * @stability stable
     */
    set placement(value: LaunchTemplatePlacement[]);
    /**
     * @stability stable
     */
    resetPlacement(): void;
    /**
     * @stability stable
     */
    get placementInput(): LaunchTemplatePlacement[] | undefined;
    private _tagSpecifications?;
    /**
     * @stability stable
     */
    get tagSpecifications(): LaunchTemplateTagSpecifications[];
    /**
     * @stability stable
     */
    set tagSpecifications(value: LaunchTemplateTagSpecifications[]);
    /**
     * @stability stable
     */
    resetTagSpecifications(): void;
    /**
     * @stability stable
     */
    get tagSpecificationsInput(): LaunchTemplateTagSpecifications[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
