import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LbListenerRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly listenerArn: string;
    /**
     * @stability stable
     */
    readonly priority?: number;
    /**
     * action block.
     *
     * @stability stable
     */
    readonly action: LbListenerRuleAction[];
    /**
     * condition block.
     *
     * @stability stable
     */
    readonly condition: LbListenerRuleCondition[];
}
/**
 * @stability stable
 */
export interface LbListenerRuleActionAuthenticateCognito {
    /**
     * @stability stable
     */
    readonly authenticationRequestExtraParams?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly onUnauthenticatedRequest?: string;
    /**
     * @stability stable
     */
    readonly scope?: string;
    /**
     * @stability stable
     */
    readonly sessionCookieName?: string;
    /**
     * @stability stable
     */
    readonly sessionTimeout?: number;
    /**
     * @stability stable
     */
    readonly userPoolArn: string;
    /**
     * @stability stable
     */
    readonly userPoolClientId: string;
    /**
     * @stability stable
     */
    readonly userPoolDomain: string;
}
/**
 * @stability stable
 */
export interface LbListenerRuleActionAuthenticateOidc {
    /**
     * @stability stable
     */
    readonly authenticationRequestExtraParams?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly authorizationEndpoint: string;
    /**
     * @stability stable
     */
    readonly clientId: string;
    /**
     * @stability stable
     */
    readonly clientSecret: string;
    /**
     * @stability stable
     */
    readonly issuer: string;
    /**
     * @stability stable
     */
    readonly onUnauthenticatedRequest?: string;
    /**
     * @stability stable
     */
    readonly scope?: string;
    /**
     * @stability stable
     */
    readonly sessionCookieName?: string;
    /**
     * @stability stable
     */
    readonly sessionTimeout?: number;
    /**
     * @stability stable
     */
    readonly tokenEndpoint: string;
    /**
     * @stability stable
     */
    readonly userInfoEndpoint: string;
}
/**
 * @stability stable
 */
export interface LbListenerRuleActionFixedResponse {
    /**
     * @stability stable
     */
    readonly contentType: string;
    /**
     * @stability stable
     */
    readonly messageBody?: string;
    /**
     * @stability stable
     */
    readonly statusCode?: string;
}
/**
 * @stability stable
 */
export interface LbListenerRuleActionForwardStickiness {
    /**
     * @stability stable
     */
    readonly duration: number;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
}
/**
 * @stability stable
 */
export interface LbListenerRuleActionForwardTargetGroup {
    /**
     * @stability stable
     */
    readonly arn: string;
    /**
     * @stability stable
     */
    readonly weight?: number;
}
/**
 * @stability stable
 */
export interface LbListenerRuleActionForward {
    /**
     * stickiness block.
     *
     * @stability stable
     */
    readonly stickiness?: LbListenerRuleActionForwardStickiness[];
    /**
     * target_group block.
     *
     * @stability stable
     */
    readonly targetGroup: LbListenerRuleActionForwardTargetGroup[];
}
/**
 * @stability stable
 */
export interface LbListenerRuleActionRedirect {
    /**
     * @stability stable
     */
    readonly host?: string;
    /**
     * @stability stable
     */
    readonly path?: string;
    /**
     * @stability stable
     */
    readonly port?: string;
    /**
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * @stability stable
     */
    readonly query?: string;
    /**
     * @stability stable
     */
    readonly statusCode: string;
}
/**
 * @stability stable
 */
export interface LbListenerRuleAction {
    /**
     * @stability stable
     */
    readonly order?: number;
    /**
     * @stability stable
     */
    readonly targetGroupArn?: string;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * authenticate_cognito block.
     *
     * @stability stable
     */
    readonly authenticateCognito?: LbListenerRuleActionAuthenticateCognito[];
    /**
     * authenticate_oidc block.
     *
     * @stability stable
     */
    readonly authenticateOidc?: LbListenerRuleActionAuthenticateOidc[];
    /**
     * fixed_response block.
     *
     * @stability stable
     */
    readonly fixedResponse?: LbListenerRuleActionFixedResponse[];
    /**
     * forward block.
     *
     * @stability stable
     */
    readonly forward?: LbListenerRuleActionForward[];
    /**
     * redirect block.
     *
     * @stability stable
     */
    readonly redirect?: LbListenerRuleActionRedirect[];
}
/**
 * @stability stable
 */
export interface LbListenerRuleConditionHostHeader {
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface LbListenerRuleConditionHttpHeader {
    /**
     * @stability stable
     */
    readonly httpHeaderName: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface LbListenerRuleConditionHttpRequestMethod {
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface LbListenerRuleConditionPathPattern {
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface LbListenerRuleConditionQueryString {
    /**
     * @stability stable
     */
    readonly key?: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface LbListenerRuleConditionSourceIp {
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface LbListenerRuleCondition {
    /**
     * host_header block.
     *
     * @stability stable
     */
    readonly hostHeader?: LbListenerRuleConditionHostHeader[];
    /**
     * http_header block.
     *
     * @stability stable
     */
    readonly httpHeader?: LbListenerRuleConditionHttpHeader[];
    /**
     * http_request_method block.
     *
     * @stability stable
     */
    readonly httpRequestMethod?: LbListenerRuleConditionHttpRequestMethod[];
    /**
     * path_pattern block.
     *
     * @stability stable
     */
    readonly pathPattern?: LbListenerRuleConditionPathPattern[];
    /**
     * query_string block.
     *
     * @stability stable
     */
    readonly queryString?: LbListenerRuleConditionQueryString[];
    /**
     * source_ip block.
     *
     * @stability stable
     */
    readonly sourceIp?: LbListenerRuleConditionSourceIp[];
}
/**
 * @stability stable
 */
export declare class LbListenerRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LbListenerRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _listenerArn;
    /**
     * @stability stable
     */
    get listenerArn(): string;
    /**
     * @stability stable
     */
    set listenerArn(value: string);
    /**
     * @stability stable
     */
    get listenerArnInput(): string;
    private _priority?;
    /**
     * @stability stable
     */
    get priority(): number;
    /**
     * @stability stable
     */
    set priority(value: number);
    /**
     * @stability stable
     */
    resetPriority(): void;
    /**
     * @stability stable
     */
    get priorityInput(): number | undefined;
    private _action;
    /**
     * @stability stable
     */
    get action(): LbListenerRuleAction[];
    /**
     * @stability stable
     */
    set action(value: LbListenerRuleAction[]);
    /**
     * @stability stable
     */
    get actionInput(): LbListenerRuleAction[];
    private _condition;
    /**
     * @stability stable
     */
    get condition(): LbListenerRuleCondition[];
    /**
     * @stability stable
     */
    set condition(value: LbListenerRuleCondition[]);
    /**
     * @stability stable
     */
    get conditionInput(): LbListenerRuleCondition[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
