import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LbSslNegotiationPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly lbPort: number;
    /**
     * @stability stable
     */
    readonly loadBalancer: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * attribute block.
     *
     * @stability stable
     */
    readonly attribute?: LbSslNegotiationPolicyAttribute[];
}
/**
 * @stability stable
 */
export interface LbSslNegotiationPolicyAttribute {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export declare class LbSslNegotiationPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LbSslNegotiationPolicyConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _lbPort;
    /**
     * @stability stable
     */
    get lbPort(): number;
    /**
     * @stability stable
     */
    set lbPort(value: number);
    /**
     * @stability stable
     */
    get lbPortInput(): number;
    private _loadBalancer;
    /**
     * @stability stable
     */
    get loadBalancer(): string;
    /**
     * @stability stable
     */
    set loadBalancer(value: string);
    /**
     * @stability stable
     */
    get loadBalancerInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _attribute?;
    /**
     * @stability stable
     */
    get attribute(): LbSslNegotiationPolicyAttribute[];
    /**
     * @stability stable
     */
    set attribute(value: LbSslNegotiationPolicyAttribute[]);
    /**
     * @stability stable
     */
    resetAttribute(): void;
    /**
     * @stability stable
     */
    get attributeInput(): LbSslNegotiationPolicyAttribute[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
