import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LbTargetGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly deregistrationDelay?: number;
    /**
     * @stability stable
     */
    readonly lambdaMultiValueHeadersEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly loadBalancingAlgorithmType?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly port?: number;
    /**
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * @stability stable
     */
    readonly protocolVersion?: string;
    /**
     * @stability stable
     */
    readonly proxyProtocolV2?: boolean;
    /**
     * @stability stable
     */
    readonly slowStart?: number;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly targetType?: string;
    /**
     * @stability stable
     */
    readonly vpcId?: string;
    /**
     * health_check block.
     *
     * @stability stable
     */
    readonly healthCheck?: LbTargetGroupHealthCheck[];
    /**
     * stickiness block.
     *
     * @stability stable
     */
    readonly stickiness?: LbTargetGroupStickiness[];
}
/**
 * @stability stable
 */
export interface LbTargetGroupHealthCheck {
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly healthyThreshold?: number;
    /**
     * @stability stable
     */
    readonly interval?: number;
    /**
     * @stability stable
     */
    readonly matcher?: string;
    /**
     * @stability stable
     */
    readonly path?: string;
    /**
     * @stability stable
     */
    readonly port?: string;
    /**
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * @stability stable
     */
    readonly timeout?: number;
    /**
     * @stability stable
     */
    readonly unhealthyThreshold?: number;
}
/**
 * @stability stable
 */
export interface LbTargetGroupStickiness {
    /**
     * @stability stable
     */
    readonly cookieDuration?: number;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export declare class LbTargetGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: LbTargetGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get arnSuffix(): string;
    private _deregistrationDelay?;
    /**
     * @stability stable
     */
    get deregistrationDelay(): number;
    /**
     * @stability stable
     */
    set deregistrationDelay(value: number);
    /**
     * @stability stable
     */
    resetDeregistrationDelay(): void;
    /**
     * @stability stable
     */
    get deregistrationDelayInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _lambdaMultiValueHeadersEnabled?;
    /**
     * @stability stable
     */
    get lambdaMultiValueHeadersEnabled(): boolean;
    /**
     * @stability stable
     */
    set lambdaMultiValueHeadersEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetLambdaMultiValueHeadersEnabled(): void;
    /**
     * @stability stable
     */
    get lambdaMultiValueHeadersEnabledInput(): boolean | undefined;
    private _loadBalancingAlgorithmType?;
    /**
     * @stability stable
     */
    get loadBalancingAlgorithmType(): string;
    /**
     * @stability stable
     */
    set loadBalancingAlgorithmType(value: string);
    /**
     * @stability stable
     */
    resetLoadBalancingAlgorithmType(): void;
    /**
     * @stability stable
     */
    get loadBalancingAlgorithmTypeInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    private _protocol?;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    set protocol(value: string);
    /**
     * @stability stable
     */
    resetProtocol(): void;
    /**
     * @stability stable
     */
    get protocolInput(): string | undefined;
    private _protocolVersion?;
    /**
     * @stability stable
     */
    get protocolVersion(): string;
    /**
     * @stability stable
     */
    set protocolVersion(value: string);
    /**
     * @stability stable
     */
    resetProtocolVersion(): void;
    /**
     * @stability stable
     */
    get protocolVersionInput(): string | undefined;
    private _proxyProtocolV2?;
    /**
     * @stability stable
     */
    get proxyProtocolV2(): boolean;
    /**
     * @stability stable
     */
    set proxyProtocolV2(value: boolean);
    /**
     * @stability stable
     */
    resetProxyProtocolV2(): void;
    /**
     * @stability stable
     */
    get proxyProtocolV2Input(): boolean | undefined;
    private _slowStart?;
    /**
     * @stability stable
     */
    get slowStart(): number;
    /**
     * @stability stable
     */
    set slowStart(value: number);
    /**
     * @stability stable
     */
    resetSlowStart(): void;
    /**
     * @stability stable
     */
    get slowStartInput(): number | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _targetType?;
    /**
     * @stability stable
     */
    get targetType(): string;
    /**
     * @stability stable
     */
    set targetType(value: string);
    /**
     * @stability stable
     */
    resetTargetType(): void;
    /**
     * @stability stable
     */
    get targetTypeInput(): string | undefined;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    resetVpcId(): void;
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    private _healthCheck?;
    /**
     * @stability stable
     */
    get healthCheck(): LbTargetGroupHealthCheck[];
    /**
     * @stability stable
     */
    set healthCheck(value: LbTargetGroupHealthCheck[]);
    /**
     * @stability stable
     */
    resetHealthCheck(): void;
    /**
     * @stability stable
     */
    get healthCheckInput(): LbTargetGroupHealthCheck[] | undefined;
    private _stickiness?;
    /**
     * @stability stable
     */
    get stickiness(): LbTargetGroupStickiness[];
    /**
     * @stability stable
     */
    set stickiness(value: LbTargetGroupStickiness[]);
    /**
     * @stability stable
     */
    resetStickiness(): void;
    /**
     * @stability stable
     */
    get stickinessInput(): LbTargetGroupStickiness[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
