import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LexBotAliasConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly botName: string;
    /**
     * @stability stable
     */
    readonly botVersion: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * conversation_logs block.
     *
     * @stability stable
     */
    readonly conversationLogs?: LexBotAliasConversationLogs[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: LexBotAliasTimeouts;
}
/**
 * @stability stable
 */
export interface LexBotAliasConversationLogsLogSettings {
    /**
     * @stability stable
     */
    readonly destination: string;
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * @stability stable
     */
    readonly logType: string;
    /**
     * @stability stable
     */
    readonly resourceArn: string;
}
/**
 * @stability stable
 */
export interface LexBotAliasConversationLogs {
    /**
     * @stability stable
     */
    readonly iamRoleArn: string;
    /**
     * log_settings block.
     *
     * @stability stable
     */
    readonly logSettings?: LexBotAliasConversationLogsLogSettings[];
}
/**
 * @stability stable
 */
export interface LexBotAliasTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class LexBotAlias extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LexBotAliasConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _botName;
    /**
     * @stability stable
     */
    get botName(): string;
    /**
     * @stability stable
     */
    set botName(value: string);
    /**
     * @stability stable
     */
    get botNameInput(): string;
    private _botVersion;
    /**
     * @stability stable
     */
    get botVersion(): string;
    /**
     * @stability stable
     */
    set botVersion(value: string);
    /**
     * @stability stable
     */
    get botVersionInput(): string;
    /**
     * @stability stable
     */
    get checksum(): string;
    /**
     * @stability stable
     */
    get createdDate(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _conversationLogs?;
    /**
     * @stability stable
     */
    get conversationLogs(): LexBotAliasConversationLogs[];
    /**
     * @stability stable
     */
    set conversationLogs(value: LexBotAliasConversationLogs[]);
    /**
     * @stability stable
     */
    resetConversationLogs(): void;
    /**
     * @stability stable
     */
    get conversationLogsInput(): LexBotAliasConversationLogs[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): LexBotAliasTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: LexBotAliasTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): LexBotAliasTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
