import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LexBotConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly childDirected: boolean;
    /**
     * @stability stable
     */
    readonly createVersion?: boolean;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly detectSentiment?: boolean;
    /**
     * @stability stable
     */
    readonly enableModelImprovements?: boolean;
    /**
     * @stability stable
     */
    readonly idleSessionTtlInSeconds?: number;
    /**
     * @stability stable
     */
    readonly locale?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly nluIntentConfidenceThreshold?: number;
    /**
     * @stability stable
     */
    readonly processBehavior?: string;
    /**
     * @stability stable
     */
    readonly voiceId?: string;
    /**
     * abort_statement block.
     *
     * @stability stable
     */
    readonly abortStatement: LexBotAbortStatement[];
    /**
     * clarification_prompt block.
     *
     * @stability stable
     */
    readonly clarificationPrompt?: LexBotClarificationPrompt[];
    /**
     * intent block.
     *
     * @stability stable
     */
    readonly intent: LexBotIntent[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: LexBotTimeouts;
}
/**
 * @stability stable
 */
export interface LexBotAbortStatementMessage {
    /**
     * @stability stable
     */
    readonly content: string;
    /**
     * @stability stable
     */
    readonly contentType: string;
    /**
     * @stability stable
     */
    readonly groupNumber?: number;
}
/**
 * @stability stable
 */
export interface LexBotAbortStatement {
    /**
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * @stability stable
     */
    readonly message: LexBotAbortStatementMessage[];
}
/**
 * @stability stable
 */
export interface LexBotClarificationPromptMessage {
    /**
     * @stability stable
     */
    readonly content: string;
    /**
     * @stability stable
     */
    readonly contentType: string;
    /**
     * @stability stable
     */
    readonly groupNumber?: number;
}
/**
 * @stability stable
 */
export interface LexBotClarificationPrompt {
    /**
     * @stability stable
     */
    readonly maxAttempts: number;
    /**
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * @stability stable
     */
    readonly message: LexBotClarificationPromptMessage[];
}
/**
 * @stability stable
 */
export interface LexBotIntent {
    /**
     * @stability stable
     */
    readonly intentName: string;
    /**
     * @stability stable
     */
    readonly intentVersion: string;
}
/**
 * @stability stable
 */
export interface LexBotTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class LexBot extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LexBotConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get checksum(): string;
    private _childDirected;
    /**
     * @stability stable
     */
    get childDirected(): boolean;
    /**
     * @stability stable
     */
    set childDirected(value: boolean);
    /**
     * @stability stable
     */
    get childDirectedInput(): boolean;
    private _createVersion?;
    /**
     * @stability stable
     */
    get createVersion(): boolean;
    /**
     * @stability stable
     */
    set createVersion(value: boolean);
    /**
     * @stability stable
     */
    resetCreateVersion(): void;
    /**
     * @stability stable
     */
    get createVersionInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get createdDate(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _detectSentiment?;
    /**
     * @stability stable
     */
    get detectSentiment(): boolean;
    /**
     * @stability stable
     */
    set detectSentiment(value: boolean);
    /**
     * @stability stable
     */
    resetDetectSentiment(): void;
    /**
     * @stability stable
     */
    get detectSentimentInput(): boolean | undefined;
    private _enableModelImprovements?;
    /**
     * @stability stable
     */
    get enableModelImprovements(): boolean;
    /**
     * @stability stable
     */
    set enableModelImprovements(value: boolean);
    /**
     * @stability stable
     */
    resetEnableModelImprovements(): void;
    /**
     * @stability stable
     */
    get enableModelImprovementsInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get failureReason(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _idleSessionTtlInSeconds?;
    /**
     * @stability stable
     */
    get idleSessionTtlInSeconds(): number;
    /**
     * @stability stable
     */
    set idleSessionTtlInSeconds(value: number);
    /**
     * @stability stable
     */
    resetIdleSessionTtlInSeconds(): void;
    /**
     * @stability stable
     */
    get idleSessionTtlInSecondsInput(): number | undefined;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _locale?;
    /**
     * @stability stable
     */
    get locale(): string;
    /**
     * @stability stable
     */
    set locale(value: string);
    /**
     * @stability stable
     */
    resetLocale(): void;
    /**
     * @stability stable
     */
    get localeInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _nluIntentConfidenceThreshold?;
    /**
     * @stability stable
     */
    get nluIntentConfidenceThreshold(): number;
    /**
     * @stability stable
     */
    set nluIntentConfidenceThreshold(value: number);
    /**
     * @stability stable
     */
    resetNluIntentConfidenceThreshold(): void;
    /**
     * @stability stable
     */
    get nluIntentConfidenceThresholdInput(): number | undefined;
    private _processBehavior?;
    /**
     * @stability stable
     */
    get processBehavior(): string;
    /**
     * @stability stable
     */
    set processBehavior(value: string);
    /**
     * @stability stable
     */
    resetProcessBehavior(): void;
    /**
     * @stability stable
     */
    get processBehaviorInput(): string | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get version(): string;
    private _voiceId?;
    /**
     * @stability stable
     */
    get voiceId(): string;
    /**
     * @stability stable
     */
    set voiceId(value: string);
    /**
     * @stability stable
     */
    resetVoiceId(): void;
    /**
     * @stability stable
     */
    get voiceIdInput(): string | undefined;
    private _abortStatement;
    /**
     * @stability stable
     */
    get abortStatement(): LexBotAbortStatement[];
    /**
     * @stability stable
     */
    set abortStatement(value: LexBotAbortStatement[]);
    /**
     * @stability stable
     */
    get abortStatementInput(): LexBotAbortStatement[];
    private _clarificationPrompt?;
    /**
     * @stability stable
     */
    get clarificationPrompt(): LexBotClarificationPrompt[];
    /**
     * @stability stable
     */
    set clarificationPrompt(value: LexBotClarificationPrompt[]);
    /**
     * @stability stable
     */
    resetClarificationPrompt(): void;
    /**
     * @stability stable
     */
    get clarificationPromptInput(): LexBotClarificationPrompt[] | undefined;
    private _intent;
    /**
     * @stability stable
     */
    get intent(): LexBotIntent[];
    /**
     * @stability stable
     */
    set intent(value: LexBotIntent[]);
    /**
     * @stability stable
     */
    get intentInput(): LexBotIntent[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): LexBotTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: LexBotTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): LexBotTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
