import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LexIntentConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly createVersion?: boolean;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly parentIntentSignature?: string;
    /**
     * @stability stable
     */
    readonly sampleUtterances?: string[];
    /**
     * conclusion_statement block.
     *
     * @stability stable
     */
    readonly conclusionStatement?: LexIntentConclusionStatement[];
    /**
     * confirmation_prompt block.
     *
     * @stability stable
     */
    readonly confirmationPrompt?: LexIntentConfirmationPrompt[];
    /**
     * dialog_code_hook block.
     *
     * @stability stable
     */
    readonly dialogCodeHook?: LexIntentDialogCodeHook[];
    /**
     * follow_up_prompt block.
     *
     * @stability stable
     */
    readonly followUpPrompt?: LexIntentFollowUpPrompt[];
    /**
     * fulfillment_activity block.
     *
     * @stability stable
     */
    readonly fulfillmentActivity: LexIntentFulfillmentActivity[];
    /**
     * rejection_statement block.
     *
     * @stability stable
     */
    readonly rejectionStatement?: LexIntentRejectionStatement[];
    /**
     * slot block.
     *
     * @stability stable
     */
    readonly slot?: LexIntentSlot[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: LexIntentTimeouts;
}
/**
 * @stability stable
 */
export interface LexIntentConclusionStatementMessage {
    /**
     * @stability stable
     */
    readonly content: string;
    /**
     * @stability stable
     */
    readonly contentType: string;
    /**
     * @stability stable
     */
    readonly groupNumber?: number;
}
/**
 * @stability stable
 */
export interface LexIntentConclusionStatement {
    /**
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * @stability stable
     */
    readonly message: LexIntentConclusionStatementMessage[];
}
/**
 * @stability stable
 */
export interface LexIntentConfirmationPromptMessage {
    /**
     * @stability stable
     */
    readonly content: string;
    /**
     * @stability stable
     */
    readonly contentType: string;
    /**
     * @stability stable
     */
    readonly groupNumber?: number;
}
/**
 * @stability stable
 */
export interface LexIntentConfirmationPrompt {
    /**
     * @stability stable
     */
    readonly maxAttempts: number;
    /**
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * @stability stable
     */
    readonly message: LexIntentConfirmationPromptMessage[];
}
/**
 * @stability stable
 */
export interface LexIntentDialogCodeHook {
    /**
     * @stability stable
     */
    readonly messageVersion: string;
    /**
     * @stability stable
     */
    readonly uri: string;
}
/**
 * @stability stable
 */
export interface LexIntentFollowUpPromptPromptMessage {
    /**
     * @stability stable
     */
    readonly content: string;
    /**
     * @stability stable
     */
    readonly contentType: string;
    /**
     * @stability stable
     */
    readonly groupNumber?: number;
}
/**
 * @stability stable
 */
export interface LexIntentFollowUpPromptPrompt {
    /**
     * @stability stable
     */
    readonly maxAttempts: number;
    /**
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * @stability stable
     */
    readonly message: LexIntentFollowUpPromptPromptMessage[];
}
/**
 * @stability stable
 */
export interface LexIntentFollowUpPromptRejectionStatementMessage {
    /**
     * @stability stable
     */
    readonly content: string;
    /**
     * @stability stable
     */
    readonly contentType: string;
    /**
     * @stability stable
     */
    readonly groupNumber?: number;
}
/**
 * @stability stable
 */
export interface LexIntentFollowUpPromptRejectionStatement {
    /**
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * @stability stable
     */
    readonly message: LexIntentFollowUpPromptRejectionStatementMessage[];
}
/**
 * @stability stable
 */
export interface LexIntentFollowUpPrompt {
    /**
     * prompt block.
     *
     * @stability stable
     */
    readonly prompt: LexIntentFollowUpPromptPrompt[];
    /**
     * rejection_statement block.
     *
     * @stability stable
     */
    readonly rejectionStatement: LexIntentFollowUpPromptRejectionStatement[];
}
/**
 * @stability stable
 */
export interface LexIntentFulfillmentActivityCodeHook {
    /**
     * @stability stable
     */
    readonly messageVersion: string;
    /**
     * @stability stable
     */
    readonly uri: string;
}
/**
 * @stability stable
 */
export interface LexIntentFulfillmentActivity {
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * code_hook block.
     *
     * @stability stable
     */
    readonly codeHook?: LexIntentFulfillmentActivityCodeHook[];
}
/**
 * @stability stable
 */
export interface LexIntentRejectionStatementMessage {
    /**
     * @stability stable
     */
    readonly content: string;
    /**
     * @stability stable
     */
    readonly contentType: string;
    /**
     * @stability stable
     */
    readonly groupNumber?: number;
}
/**
 * @stability stable
 */
export interface LexIntentRejectionStatement {
    /**
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * @stability stable
     */
    readonly message: LexIntentRejectionStatementMessage[];
}
/**
 * @stability stable
 */
export interface LexIntentSlotValueElicitationPromptMessage {
    /**
     * @stability stable
     */
    readonly content: string;
    /**
     * @stability stable
     */
    readonly contentType: string;
    /**
     * @stability stable
     */
    readonly groupNumber?: number;
}
/**
 * @stability stable
 */
export interface LexIntentSlotValueElicitationPrompt {
    /**
     * @stability stable
     */
    readonly maxAttempts: number;
    /**
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * message block.
     *
     * @stability stable
     */
    readonly message: LexIntentSlotValueElicitationPromptMessage[];
}
/**
 * @stability stable
 */
export interface LexIntentSlot {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly priority?: number;
    /**
     * @stability stable
     */
    readonly responseCard?: string;
    /**
     * @stability stable
     */
    readonly sampleUtterances?: string[];
    /**
     * @stability stable
     */
    readonly slotConstraint: string;
    /**
     * @stability stable
     */
    readonly slotType: string;
    /**
     * @stability stable
     */
    readonly slotTypeVersion?: string;
    /**
     * value_elicitation_prompt block.
     *
     * @stability stable
     */
    readonly valueElicitationPrompt?: LexIntentSlotValueElicitationPrompt[];
}
/**
 * @stability stable
 */
export interface LexIntentTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class LexIntent extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LexIntentConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get checksum(): string;
    private _createVersion?;
    /**
     * @stability stable
     */
    get createVersion(): boolean;
    /**
     * @stability stable
     */
    set createVersion(value: boolean);
    /**
     * @stability stable
     */
    resetCreateVersion(): void;
    /**
     * @stability stable
     */
    get createVersionInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get createdDate(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _parentIntentSignature?;
    /**
     * @stability stable
     */
    get parentIntentSignature(): string;
    /**
     * @stability stable
     */
    set parentIntentSignature(value: string);
    /**
     * @stability stable
     */
    resetParentIntentSignature(): void;
    /**
     * @stability stable
     */
    get parentIntentSignatureInput(): string | undefined;
    private _sampleUtterances?;
    /**
     * @stability stable
     */
    get sampleUtterances(): string[];
    /**
     * @stability stable
     */
    set sampleUtterances(value: string[]);
    /**
     * @stability stable
     */
    resetSampleUtterances(): void;
    /**
     * @stability stable
     */
    get sampleUtterancesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get version(): string;
    private _conclusionStatement?;
    /**
     * @stability stable
     */
    get conclusionStatement(): LexIntentConclusionStatement[];
    /**
     * @stability stable
     */
    set conclusionStatement(value: LexIntentConclusionStatement[]);
    /**
     * @stability stable
     */
    resetConclusionStatement(): void;
    /**
     * @stability stable
     */
    get conclusionStatementInput(): LexIntentConclusionStatement[] | undefined;
    private _confirmationPrompt?;
    /**
     * @stability stable
     */
    get confirmationPrompt(): LexIntentConfirmationPrompt[];
    /**
     * @stability stable
     */
    set confirmationPrompt(value: LexIntentConfirmationPrompt[]);
    /**
     * @stability stable
     */
    resetConfirmationPrompt(): void;
    /**
     * @stability stable
     */
    get confirmationPromptInput(): LexIntentConfirmationPrompt[] | undefined;
    private _dialogCodeHook?;
    /**
     * @stability stable
     */
    get dialogCodeHook(): LexIntentDialogCodeHook[];
    /**
     * @stability stable
     */
    set dialogCodeHook(value: LexIntentDialogCodeHook[]);
    /**
     * @stability stable
     */
    resetDialogCodeHook(): void;
    /**
     * @stability stable
     */
    get dialogCodeHookInput(): LexIntentDialogCodeHook[] | undefined;
    private _followUpPrompt?;
    /**
     * @stability stable
     */
    get followUpPrompt(): LexIntentFollowUpPrompt[];
    /**
     * @stability stable
     */
    set followUpPrompt(value: LexIntentFollowUpPrompt[]);
    /**
     * @stability stable
     */
    resetFollowUpPrompt(): void;
    /**
     * @stability stable
     */
    get followUpPromptInput(): LexIntentFollowUpPrompt[] | undefined;
    private _fulfillmentActivity;
    /**
     * @stability stable
     */
    get fulfillmentActivity(): LexIntentFulfillmentActivity[];
    /**
     * @stability stable
     */
    set fulfillmentActivity(value: LexIntentFulfillmentActivity[]);
    /**
     * @stability stable
     */
    get fulfillmentActivityInput(): LexIntentFulfillmentActivity[];
    private _rejectionStatement?;
    /**
     * @stability stable
     */
    get rejectionStatement(): LexIntentRejectionStatement[];
    /**
     * @stability stable
     */
    set rejectionStatement(value: LexIntentRejectionStatement[]);
    /**
     * @stability stable
     */
    resetRejectionStatement(): void;
    /**
     * @stability stable
     */
    get rejectionStatementInput(): LexIntentRejectionStatement[] | undefined;
    private _slot?;
    /**
     * @stability stable
     */
    get slot(): LexIntentSlot[];
    /**
     * @stability stable
     */
    set slot(value: LexIntentSlot[]);
    /**
     * @stability stable
     */
    resetSlot(): void;
    /**
     * @stability stable
     */
    get slotInput(): LexIntentSlot[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): LexIntentTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: LexIntentTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): LexIntentTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
