import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LexSlotTypeConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly createVersion?: boolean;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly valueSelectionStrategy?: string;
    /**
     * enumeration_value block.
     *
     * @stability stable
     */
    readonly enumerationValue: LexSlotTypeEnumerationValue[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: LexSlotTypeTimeouts;
}
/**
 * @stability stable
 */
export interface LexSlotTypeEnumerationValue {
    /**
     * @stability stable
     */
    readonly synonyms?: string[];
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface LexSlotTypeTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class LexSlotType extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LexSlotTypeConfig);
    /**
     * @stability stable
     */
    get checksum(): string;
    private _createVersion?;
    /**
     * @stability stable
     */
    get createVersion(): boolean;
    /**
     * @stability stable
     */
    set createVersion(value: boolean);
    /**
     * @stability stable
     */
    resetCreateVersion(): void;
    /**
     * @stability stable
     */
    get createVersionInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get createdDate(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedDate(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _valueSelectionStrategy?;
    /**
     * @stability stable
     */
    get valueSelectionStrategy(): string;
    /**
     * @stability stable
     */
    set valueSelectionStrategy(value: string);
    /**
     * @stability stable
     */
    resetValueSelectionStrategy(): void;
    /**
     * @stability stable
     */
    get valueSelectionStrategyInput(): string | undefined;
    /**
     * @stability stable
     */
    get version(): string;
    private _enumerationValue;
    /**
     * @stability stable
     */
    get enumerationValue(): LexSlotTypeEnumerationValue[];
    /**
     * @stability stable
     */
    set enumerationValue(value: LexSlotTypeEnumerationValue[]);
    /**
     * @stability stable
     */
    get enumerationValueInput(): LexSlotTypeEnumerationValue[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): LexSlotTypeTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: LexSlotTypeTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): LexSlotTypeTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
