import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LicensemanagerLicenseConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly licenseCount?: number;
    /**
     * @stability stable
     */
    readonly licenseCountHardLimit?: boolean;
    /**
     * @stability stable
     */
    readonly licenseCountingType: string;
    /**
     * @stability stable
     */
    readonly licenseRules?: string[];
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class LicensemanagerLicenseConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LicensemanagerLicenseConfigurationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _licenseCount?;
    /**
     * @stability stable
     */
    get licenseCount(): number;
    /**
     * @stability stable
     */
    set licenseCount(value: number);
    /**
     * @stability stable
     */
    resetLicenseCount(): void;
    /**
     * @stability stable
     */
    get licenseCountInput(): number | undefined;
    private _licenseCountHardLimit?;
    /**
     * @stability stable
     */
    get licenseCountHardLimit(): boolean;
    /**
     * @stability stable
     */
    set licenseCountHardLimit(value: boolean);
    /**
     * @stability stable
     */
    resetLicenseCountHardLimit(): void;
    /**
     * @stability stable
     */
    get licenseCountHardLimitInput(): boolean | undefined;
    private _licenseCountingType;
    /**
     * @stability stable
     */
    get licenseCountingType(): string;
    /**
     * @stability stable
     */
    set licenseCountingType(value: string);
    /**
     * @stability stable
     */
    get licenseCountingTypeInput(): string;
    private _licenseRules?;
    /**
     * @stability stable
     */
    get licenseRules(): string[];
    /**
     * @stability stable
     */
    set licenseRules(value: string[]);
    /**
     * @stability stable
     */
    resetLicenseRules(): void;
    /**
     * @stability stable
     */
    get licenseRulesInput(): string[] | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get ownerAccountId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
