import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LoadBalancerBackendServerPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly instancePort: number;
    /**
     * @stability stable
     */
    readonly loadBalancerName: string;
    /**
     * @stability stable
     */
    readonly policyNames?: string[];
}
/**
 * @stability stable
 */
export declare class LoadBalancerBackendServerPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LoadBalancerBackendServerPolicyConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _instancePort;
    /**
     * @stability stable
     */
    get instancePort(): number;
    /**
     * @stability stable
     */
    set instancePort(value: number);
    /**
     * @stability stable
     */
    get instancePortInput(): number;
    private _loadBalancerName;
    /**
     * @stability stable
     */
    get loadBalancerName(): string;
    /**
     * @stability stable
     */
    set loadBalancerName(value: string);
    /**
     * @stability stable
     */
    get loadBalancerNameInput(): string;
    private _policyNames?;
    /**
     * @stability stable
     */
    get policyNames(): string[];
    /**
     * @stability stable
     */
    set policyNames(value: string[]);
    /**
     * @stability stable
     */
    resetPolicyNames(): void;
    /**
     * @stability stable
     */
    get policyNamesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
