import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LoadBalancerListenerPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly loadBalancerName: string;
    /**
     * @stability stable
     */
    readonly loadBalancerPort: number;
    /**
     * @stability stable
     */
    readonly policyNames?: string[];
}
/**
 * @stability stable
 */
export declare class LoadBalancerListenerPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LoadBalancerListenerPolicyConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _loadBalancerName;
    /**
     * @stability stable
     */
    get loadBalancerName(): string;
    /**
     * @stability stable
     */
    set loadBalancerName(value: string);
    /**
     * @stability stable
     */
    get loadBalancerNameInput(): string;
    private _loadBalancerPort;
    /**
     * @stability stable
     */
    get loadBalancerPort(): number;
    /**
     * @stability stable
     */
    set loadBalancerPort(value: number);
    /**
     * @stability stable
     */
    get loadBalancerPortInput(): number;
    private _policyNames?;
    /**
     * @stability stable
     */
    get policyNames(): string[];
    /**
     * @stability stable
     */
    set policyNames(value: string[]);
    /**
     * @stability stable
     */
    resetPolicyNames(): void;
    /**
     * @stability stable
     */
    get policyNamesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
