import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LoadBalancerPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly loadBalancerName: string;
    /**
     * @stability stable
     */
    readonly policyName: string;
    /**
     * @stability stable
     */
    readonly policyTypeName: string;
    /**
     * policy_attribute block.
     *
     * @stability stable
     */
    readonly policyAttribute?: LoadBalancerPolicyPolicyAttribute[];
}
/**
 * @stability stable
 */
export interface LoadBalancerPolicyPolicyAttribute {
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly value?: string;
}
/**
 * @stability stable
 */
export declare class LoadBalancerPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: LoadBalancerPolicyConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _loadBalancerName;
    /**
     * @stability stable
     */
    get loadBalancerName(): string;
    /**
     * @stability stable
     */
    set loadBalancerName(value: string);
    /**
     * @stability stable
     */
    get loadBalancerNameInput(): string;
    private _policyName;
    /**
     * @stability stable
     */
    get policyName(): string;
    /**
     * @stability stable
     */
    set policyName(value: string);
    /**
     * @stability stable
     */
    get policyNameInput(): string;
    private _policyTypeName;
    /**
     * @stability stable
     */
    get policyTypeName(): string;
    /**
     * @stability stable
     */
    set policyTypeName(value: string);
    /**
     * @stability stable
     */
    get policyTypeNameInput(): string;
    private _policyAttribute?;
    /**
     * @stability stable
     */
    get policyAttribute(): LoadBalancerPolicyPolicyAttribute[];
    /**
     * @stability stable
     */
    set policyAttribute(value: LoadBalancerPolicyPolicyAttribute[]);
    /**
     * @stability stable
     */
    resetPolicyAttribute(): void;
    /**
     * @stability stable
     */
    get policyAttributeInput(): LoadBalancerPolicyPolicyAttribute[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
