import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MacieS3BucketAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly bucketName: string;
    /**
     * @stability stable
     */
    readonly memberAccountId?: string;
    /**
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * classification_type block.
     *
     * @stability stable
     */
    readonly classificationType?: MacieS3BucketAssociationClassificationType[];
}
/**
 * @stability stable
 */
export interface MacieS3BucketAssociationClassificationType {
    /**
     * @stability stable
     */
    readonly continuous?: string;
    /**
     * @stability stable
     */
    readonly oneTime?: string;
}
/**
 * @stability stable
 */
export declare class MacieS3BucketAssociation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MacieS3BucketAssociationConfig);
    private _bucketName;
    /**
     * @stability stable
     */
    get bucketName(): string;
    /**
     * @stability stable
     */
    set bucketName(value: string);
    /**
     * @stability stable
     */
    get bucketNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _memberAccountId?;
    /**
     * @stability stable
     */
    get memberAccountId(): string;
    /**
     * @stability stable
     */
    set memberAccountId(value: string);
    /**
     * @stability stable
     */
    resetMemberAccountId(): void;
    /**
     * @stability stable
     */
    get memberAccountIdInput(): string | undefined;
    private _prefix?;
    /**
     * @stability stable
     */
    get prefix(): string;
    /**
     * @stability stable
     */
    set prefix(value: string);
    /**
     * @stability stable
     */
    resetPrefix(): void;
    /**
     * @stability stable
     */
    get prefixInput(): string | undefined;
    private _classificationType?;
    /**
     * @stability stable
     */
    get classificationType(): MacieS3BucketAssociationClassificationType[];
    /**
     * @stability stable
     */
    set classificationType(value: MacieS3BucketAssociationClassificationType[]);
    /**
     * @stability stable
     */
    resetClassificationType(): void;
    /**
     * @stability stable
     */
    get classificationTypeInput(): MacieS3BucketAssociationClassificationType[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
