import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MediaConvertQueueConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly pricingPlan?: string;
    /**
     * @stability stable
     */
    readonly status?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * reservation_plan_settings block.
     *
     * @stability stable
     */
    readonly reservationPlanSettings?: MediaConvertQueueReservationPlanSettings[];
}
/**
 * @stability stable
 */
export interface MediaConvertQueueReservationPlanSettings {
    /**
     * @stability stable
     */
    readonly commitment: string;
    /**
     * @stability stable
     */
    readonly renewalType: string;
    /**
     * @stability stable
     */
    readonly reservedSlots: number;
}
/**
 * @stability stable
 */
export declare class MediaConvertQueue extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MediaConvertQueueConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _pricingPlan?;
    /**
     * @stability stable
     */
    get pricingPlan(): string;
    /**
     * @stability stable
     */
    set pricingPlan(value: string);
    /**
     * @stability stable
     */
    resetPricingPlan(): void;
    /**
     * @stability stable
     */
    get pricingPlanInput(): string | undefined;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    set status(value: string);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _reservationPlanSettings?;
    /**
     * @stability stable
     */
    get reservationPlanSettings(): MediaConvertQueueReservationPlanSettings[];
    /**
     * @stability stable
     */
    set reservationPlanSettings(value: MediaConvertQueueReservationPlanSettings[]);
    /**
     * @stability stable
     */
    resetReservationPlanSettings(): void;
    /**
     * @stability stable
     */
    get reservationPlanSettingsInput(): MediaConvertQueueReservationPlanSettings[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
