import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MediaPackageChannelConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly channelId: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class MediaPackageChannelHlsIngestIngestEndpoints extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get password(): string;
    /**
     * @stability stable
     */
    get url(): string;
    /**
     * @stability stable
     */
    get username(): string;
}
/**
 * @stability stable
 */
export declare class MediaPackageChannelHlsIngest extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get ingestEndpoints(): any;
}
/**
 * @stability stable
 */
export declare class MediaPackageChannel extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MediaPackageChannelConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _channelId;
    /**
     * @stability stable
     */
    get channelId(): string;
    /**
     * @stability stable
     */
    set channelId(value: string);
    /**
     * @stability stable
     */
    get channelIdInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    hlsIngest(index: string): MediaPackageChannelHlsIngest;
    /**
     * @stability stable
     */
    get id(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
