import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface MskConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly kafkaVersions: string[];
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly serverProperties: string;
}
/**
 * @stability stable
 */
export declare class MskConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: MskConfigurationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kafkaVersions;
    /**
     * @stability stable
     */
    get kafkaVersions(): string[];
    /**
     * @stability stable
     */
    set kafkaVersions(value: string[]);
    /**
     * @stability stable
     */
    get kafkaVersionsInput(): string[];
    /**
     * @stability stable
     */
    get latestRevision(): number;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _serverProperties;
    /**
     * @stability stable
     */
    get serverProperties(): string;
    /**
     * @stability stable
     */
    set serverProperties(value: string);
    /**
     * @stability stable
     */
    get serverPropertiesInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
