import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface NeptuneClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly applyImmediately?: boolean;
    /**
     * @stability stable
     */
    readonly availabilityZones?: string[];
    /**
     * @stability stable
     */
    readonly backupRetentionPeriod?: number;
    /**
     * @stability stable
     */
    readonly clusterIdentifier?: string;
    /**
     * @stability stable
     */
    readonly clusterIdentifierPrefix?: string;
    /**
     * @stability stable
     */
    readonly deletionProtection?: boolean;
    /**
     * @stability stable
     */
    readonly enableCloudwatchLogsExports?: string[];
    /**
     * @stability stable
     */
    readonly engine?: string;
    /**
     * @stability stable
     */
    readonly engineVersion?: string;
    /**
     * @stability stable
     */
    readonly finalSnapshotIdentifier?: string;
    /**
     * @stability stable
     */
    readonly iamDatabaseAuthenticationEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly iamRoles?: string[];
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * @stability stable
     */
    readonly neptuneClusterParameterGroupName?: string;
    /**
     * @stability stable
     */
    readonly neptuneSubnetGroupName?: string;
    /**
     * @stability stable
     */
    readonly port?: number;
    /**
     * @stability stable
     */
    readonly preferredBackupWindow?: string;
    /**
     * @stability stable
     */
    readonly preferredMaintenanceWindow?: string;
    /**
     * @stability stable
     */
    readonly replicationSourceIdentifier?: string;
    /**
     * @stability stable
     */
    readonly skipFinalSnapshot?: boolean;
    /**
     * @stability stable
     */
    readonly snapshotIdentifier?: string;
    /**
     * @stability stable
     */
    readonly storageEncrypted?: boolean;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcSecurityGroupIds?: string[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: NeptuneClusterTimeouts;
}
/**
 * @stability stable
 */
export interface NeptuneClusterTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class NeptuneCluster extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: NeptuneClusterConfig);
    private _applyImmediately?;
    /**
     * @stability stable
     */
    get applyImmediately(): boolean;
    /**
     * @stability stable
     */
    set applyImmediately(value: boolean);
    /**
     * @stability stable
     */
    resetApplyImmediately(): void;
    /**
     * @stability stable
     */
    get applyImmediatelyInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _availabilityZones?;
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    /**
     * @stability stable
     */
    set availabilityZones(value: string[]);
    /**
     * @stability stable
     */
    resetAvailabilityZones(): void;
    /**
     * @stability stable
     */
    get availabilityZonesInput(): string[] | undefined;
    private _backupRetentionPeriod?;
    /**
     * @stability stable
     */
    get backupRetentionPeriod(): number;
    /**
     * @stability stable
     */
    set backupRetentionPeriod(value: number);
    /**
     * @stability stable
     */
    resetBackupRetentionPeriod(): void;
    /**
     * @stability stable
     */
    get backupRetentionPeriodInput(): number | undefined;
    private _clusterIdentifier?;
    /**
     * @stability stable
     */
    get clusterIdentifier(): string;
    /**
     * @stability stable
     */
    set clusterIdentifier(value: string);
    /**
     * @stability stable
     */
    resetClusterIdentifier(): void;
    /**
     * @stability stable
     */
    get clusterIdentifierInput(): string | undefined;
    private _clusterIdentifierPrefix?;
    /**
     * @stability stable
     */
    get clusterIdentifierPrefix(): string;
    /**
     * @stability stable
     */
    set clusterIdentifierPrefix(value: string);
    /**
     * @stability stable
     */
    resetClusterIdentifierPrefix(): void;
    /**
     * @stability stable
     */
    get clusterIdentifierPrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    get clusterMembers(): string[];
    /**
     * @stability stable
     */
    get clusterResourceId(): string;
    private _deletionProtection?;
    /**
     * @stability stable
     */
    get deletionProtection(): boolean;
    /**
     * @stability stable
     */
    set deletionProtection(value: boolean);
    /**
     * @stability stable
     */
    resetDeletionProtection(): void;
    /**
     * @stability stable
     */
    get deletionProtectionInput(): boolean | undefined;
    private _enableCloudwatchLogsExports?;
    /**
     * @stability stable
     */
    get enableCloudwatchLogsExports(): string[];
    /**
     * @stability stable
     */
    set enableCloudwatchLogsExports(value: string[]);
    /**
     * @stability stable
     */
    resetEnableCloudwatchLogsExports(): void;
    /**
     * @stability stable
     */
    get enableCloudwatchLogsExportsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get endpoint(): string;
    private _engine?;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    resetEngine(): void;
    /**
     * @stability stable
     */
    get engineInput(): string | undefined;
    private _engineVersion?;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    set engineVersion(value: string);
    /**
     * @stability stable
     */
    resetEngineVersion(): void;
    /**
     * @stability stable
     */
    get engineVersionInput(): string | undefined;
    private _finalSnapshotIdentifier?;
    /**
     * @stability stable
     */
    get finalSnapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set finalSnapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    resetFinalSnapshotIdentifier(): void;
    /**
     * @stability stable
     */
    get finalSnapshotIdentifierInput(): string | undefined;
    /**
     * @stability stable
     */
    get hostedZoneId(): string;
    private _iamDatabaseAuthenticationEnabled?;
    /**
     * @stability stable
     */
    get iamDatabaseAuthenticationEnabled(): boolean;
    /**
     * @stability stable
     */
    set iamDatabaseAuthenticationEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetIamDatabaseAuthenticationEnabled(): void;
    /**
     * @stability stable
     */
    get iamDatabaseAuthenticationEnabledInput(): boolean | undefined;
    private _iamRoles?;
    /**
     * @stability stable
     */
    get iamRoles(): string[];
    /**
     * @stability stable
     */
    set iamRoles(value: string[]);
    /**
     * @stability stable
     */
    resetIamRoles(): void;
    /**
     * @stability stable
     */
    get iamRolesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyArn?;
    /**
     * @stability stable
     */
    get kmsKeyArn(): string;
    /**
     * @stability stable
     */
    set kmsKeyArn(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyArn(): void;
    /**
     * @stability stable
     */
    get kmsKeyArnInput(): string | undefined;
    private _neptuneClusterParameterGroupName?;
    /**
     * @stability stable
     */
    get neptuneClusterParameterGroupName(): string;
    /**
     * @stability stable
     */
    set neptuneClusterParameterGroupName(value: string);
    /**
     * @stability stable
     */
    resetNeptuneClusterParameterGroupName(): void;
    /**
     * @stability stable
     */
    get neptuneClusterParameterGroupNameInput(): string | undefined;
    private _neptuneSubnetGroupName?;
    /**
     * @stability stable
     */
    get neptuneSubnetGroupName(): string;
    /**
     * @stability stable
     */
    set neptuneSubnetGroupName(value: string);
    /**
     * @stability stable
     */
    resetNeptuneSubnetGroupName(): void;
    /**
     * @stability stable
     */
    get neptuneSubnetGroupNameInput(): string | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    private _preferredBackupWindow?;
    /**
     * @stability stable
     */
    get preferredBackupWindow(): string;
    /**
     * @stability stable
     */
    set preferredBackupWindow(value: string);
    /**
     * @stability stable
     */
    resetPreferredBackupWindow(): void;
    /**
     * @stability stable
     */
    get preferredBackupWindowInput(): string | undefined;
    private _preferredMaintenanceWindow?;
    /**
     * @stability stable
     */
    get preferredMaintenanceWindow(): string;
    /**
     * @stability stable
     */
    set preferredMaintenanceWindow(value: string);
    /**
     * @stability stable
     */
    resetPreferredMaintenanceWindow(): void;
    /**
     * @stability stable
     */
    get preferredMaintenanceWindowInput(): string | undefined;
    /**
     * @stability stable
     */
    get readerEndpoint(): string;
    private _replicationSourceIdentifier?;
    /**
     * @stability stable
     */
    get replicationSourceIdentifier(): string;
    /**
     * @stability stable
     */
    set replicationSourceIdentifier(value: string);
    /**
     * @stability stable
     */
    resetReplicationSourceIdentifier(): void;
    /**
     * @stability stable
     */
    get replicationSourceIdentifierInput(): string | undefined;
    private _skipFinalSnapshot?;
    /**
     * @stability stable
     */
    get skipFinalSnapshot(): boolean;
    /**
     * @stability stable
     */
    set skipFinalSnapshot(value: boolean);
    /**
     * @stability stable
     */
    resetSkipFinalSnapshot(): void;
    /**
     * @stability stable
     */
    get skipFinalSnapshotInput(): boolean | undefined;
    private _snapshotIdentifier?;
    /**
     * @stability stable
     */
    get snapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set snapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    resetSnapshotIdentifier(): void;
    /**
     * @stability stable
     */
    get snapshotIdentifierInput(): string | undefined;
    private _storageEncrypted?;
    /**
     * @stability stable
     */
    get storageEncrypted(): boolean;
    /**
     * @stability stable
     */
    set storageEncrypted(value: boolean);
    /**
     * @stability stable
     */
    resetStorageEncrypted(): void;
    /**
     * @stability stable
     */
    get storageEncryptedInput(): boolean | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcSecurityGroupIds?;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set vpcSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetVpcSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIdsInput(): string[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): NeptuneClusterTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: NeptuneClusterTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): NeptuneClusterTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
