import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface NetworkAclRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly cidrBlock?: string;
    /**
     * @stability stable
     */
    readonly egress?: boolean;
    /**
     * @stability stable
     */
    readonly fromPort?: number;
    /**
     * @stability stable
     */
    readonly icmpCode?: string;
    /**
     * @stability stable
     */
    readonly icmpType?: string;
    /**
     * @stability stable
     */
    readonly ipv6CidrBlock?: string;
    /**
     * @stability stable
     */
    readonly networkAclId: string;
    /**
     * @stability stable
     */
    readonly protocol: string;
    /**
     * @stability stable
     */
    readonly ruleAction: string;
    /**
     * @stability stable
     */
    readonly ruleNumber: number;
    /**
     * @stability stable
     */
    readonly toPort?: number;
}
/**
 * @stability stable
 */
export declare class NetworkAclRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: NetworkAclRuleConfig);
    private _cidrBlock?;
    /**
     * @stability stable
     */
    get cidrBlock(): string;
    /**
     * @stability stable
     */
    set cidrBlock(value: string);
    /**
     * @stability stable
     */
    resetCidrBlock(): void;
    /**
     * @stability stable
     */
    get cidrBlockInput(): string | undefined;
    private _egress?;
    /**
     * @stability stable
     */
    get egress(): boolean;
    /**
     * @stability stable
     */
    set egress(value: boolean);
    /**
     * @stability stable
     */
    resetEgress(): void;
    /**
     * @stability stable
     */
    get egressInput(): boolean | undefined;
    private _fromPort?;
    /**
     * @stability stable
     */
    get fromPort(): number;
    /**
     * @stability stable
     */
    set fromPort(value: number);
    /**
     * @stability stable
     */
    resetFromPort(): void;
    /**
     * @stability stable
     */
    get fromPortInput(): number | undefined;
    private _icmpCode?;
    /**
     * @stability stable
     */
    get icmpCode(): string;
    /**
     * @stability stable
     */
    set icmpCode(value: string);
    /**
     * @stability stable
     */
    resetIcmpCode(): void;
    /**
     * @stability stable
     */
    get icmpCodeInput(): string | undefined;
    private _icmpType?;
    /**
     * @stability stable
     */
    get icmpType(): string;
    /**
     * @stability stable
     */
    set icmpType(value: string);
    /**
     * @stability stable
     */
    resetIcmpType(): void;
    /**
     * @stability stable
     */
    get icmpTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _ipv6CidrBlock?;
    /**
     * @stability stable
     */
    get ipv6CidrBlock(): string;
    /**
     * @stability stable
     */
    set ipv6CidrBlock(value: string);
    /**
     * @stability stable
     */
    resetIpv6CidrBlock(): void;
    /**
     * @stability stable
     */
    get ipv6CidrBlockInput(): string | undefined;
    private _networkAclId;
    /**
     * @stability stable
     */
    get networkAclId(): string;
    /**
     * @stability stable
     */
    set networkAclId(value: string);
    /**
     * @stability stable
     */
    get networkAclIdInput(): string;
    private _protocol;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    set protocol(value: string);
    /**
     * @stability stable
     */
    get protocolInput(): string;
    private _ruleAction;
    /**
     * @stability stable
     */
    get ruleAction(): string;
    /**
     * @stability stable
     */
    set ruleAction(value: string);
    /**
     * @stability stable
     */
    get ruleActionInput(): string;
    private _ruleNumber;
    /**
     * @stability stable
     */
    get ruleNumber(): number;
    /**
     * @stability stable
     */
    set ruleNumber(value: number);
    /**
     * @stability stable
     */
    get ruleNumberInput(): number;
    private _toPort?;
    /**
     * @stability stable
     */
    get toPort(): number;
    /**
     * @stability stable
     */
    set toPort(value: number);
    /**
     * @stability stable
     */
    resetToPort(): void;
    /**
     * @stability stable
     */
    get toPortInput(): number | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
