import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface NetworkAclConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly egress?: NetworkAclEgress[];
    /**
     * @stability stable
     */
    readonly ingress?: NetworkAclIngress[];
    /**
     * @stability stable
     */
    readonly subnetIds?: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcId: string;
}
/**
 * @stability stable
 */
export interface NetworkAclEgress {
    /**
     * @stability stable
     */
    readonly action?: string;
    /**
     * @stability stable
     */
    readonly cidrBlock?: string;
    /**
     * @stability stable
     */
    readonly fromPort?: number;
    /**
     * @stability stable
     */
    readonly icmpCode?: number;
    /**
     * @stability stable
     */
    readonly icmpType?: number;
    /**
     * @stability stable
     */
    readonly ipv6CidrBlock?: string;
    /**
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * @stability stable
     */
    readonly ruleNo?: number;
    /**
     * @stability stable
     */
    readonly toPort?: number;
}
/**
 * @stability stable
 */
export interface NetworkAclIngress {
    /**
     * @stability stable
     */
    readonly action?: string;
    /**
     * @stability stable
     */
    readonly cidrBlock?: string;
    /**
     * @stability stable
     */
    readonly fromPort?: number;
    /**
     * @stability stable
     */
    readonly icmpCode?: number;
    /**
     * @stability stable
     */
    readonly icmpType?: number;
    /**
     * @stability stable
     */
    readonly ipv6CidrBlock?: string;
    /**
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * @stability stable
     */
    readonly ruleNo?: number;
    /**
     * @stability stable
     */
    readonly toPort?: number;
}
/**
 * @stability stable
 */
export declare class NetworkAcl extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: NetworkAclConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _egress?;
    /**
     * @stability stable
     */
    get egress(): NetworkAclEgress[];
    /**
     * @stability stable
     */
    set egress(value: NetworkAclEgress[]);
    /**
     * @stability stable
     */
    resetEgress(): void;
    /**
     * @stability stable
     */
    get egressInput(): NetworkAclEgress[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _ingress?;
    /**
     * @stability stable
     */
    get ingress(): NetworkAclIngress[];
    /**
     * @stability stable
     */
    set ingress(value: NetworkAclIngress[]);
    /**
     * @stability stable
     */
    resetIngress(): void;
    /**
     * @stability stable
     */
    get ingressInput(): NetworkAclIngress[] | undefined;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _subnetIds?;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    resetSubnetIds(): void;
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcId;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
