import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface NetworkInterfaceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly ipv6AddressCount?: number;
    /**
     * @stability stable
     */
    readonly ipv6Addresses?: string[];
    /**
     * @stability stable
     */
    readonly privateIp?: string;
    /**
     * @stability stable
     */
    readonly privateIps?: string[];
    /**
     * @stability stable
     */
    readonly privateIpsCount?: number;
    /**
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * @stability stable
     */
    readonly sourceDestCheck?: boolean;
    /**
     * @stability stable
     */
    readonly subnetId: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * attachment block.
     *
     * @stability stable
     */
    readonly attachment?: NetworkInterfaceAttachment[];
}
/**
 * @stability stable
 */
export interface NetworkInterfaceAttachment {
    /**
     * @stability stable
     */
    readonly deviceIndex: number;
    /**
     * @stability stable
     */
    readonly instance: string;
}
/**
 * @stability stable
 */
export declare class NetworkInterface extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: NetworkInterfaceConfig);
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _ipv6AddressCount?;
    /**
     * @stability stable
     */
    get ipv6AddressCount(): number;
    /**
     * @stability stable
     */
    set ipv6AddressCount(value: number);
    /**
     * @stability stable
     */
    resetIpv6AddressCount(): void;
    /**
     * @stability stable
     */
    get ipv6AddressCountInput(): number | undefined;
    private _ipv6Addresses?;
    /**
     * @stability stable
     */
    get ipv6Addresses(): string[];
    /**
     * @stability stable
     */
    set ipv6Addresses(value: string[]);
    /**
     * @stability stable
     */
    resetIpv6Addresses(): void;
    /**
     * @stability stable
     */
    get ipv6AddressesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get macAddress(): string;
    /**
     * @stability stable
     */
    get outpostArn(): string;
    /**
     * @stability stable
     */
    get privateDnsName(): string;
    private _privateIp?;
    /**
     * @stability stable
     */
    get privateIp(): string;
    /**
     * @stability stable
     */
    set privateIp(value: string);
    /**
     * @stability stable
     */
    resetPrivateIp(): void;
    /**
     * @stability stable
     */
    get privateIpInput(): string | undefined;
    private _privateIps?;
    /**
     * @stability stable
     */
    get privateIps(): string[];
    /**
     * @stability stable
     */
    set privateIps(value: string[]);
    /**
     * @stability stable
     */
    resetPrivateIps(): void;
    /**
     * @stability stable
     */
    get privateIpsInput(): string[] | undefined;
    private _privateIpsCount?;
    /**
     * @stability stable
     */
    get privateIpsCount(): number;
    /**
     * @stability stable
     */
    set privateIpsCount(value: number);
    /**
     * @stability stable
     */
    resetPrivateIpsCount(): void;
    /**
     * @stability stable
     */
    get privateIpsCountInput(): number | undefined;
    private _securityGroups?;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    set securityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroups(): void;
    /**
     * @stability stable
     */
    get securityGroupsInput(): string[] | undefined;
    private _sourceDestCheck?;
    /**
     * @stability stable
     */
    get sourceDestCheck(): boolean;
    /**
     * @stability stable
     */
    set sourceDestCheck(value: boolean);
    /**
     * @stability stable
     */
    resetSourceDestCheck(): void;
    /**
     * @stability stable
     */
    get sourceDestCheckInput(): boolean | undefined;
    private _subnetId;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    get subnetIdInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _attachment?;
    /**
     * @stability stable
     */
    get attachment(): NetworkInterfaceAttachment[];
    /**
     * @stability stable
     */
    set attachment(value: NetworkInterfaceAttachment[]);
    /**
     * @stability stable
     */
    resetAttachment(): void;
    /**
     * @stability stable
     */
    get attachmentInput(): NetworkInterfaceAttachment[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
