import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface NetworkfirewallFirewallPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * firewall_policy block.
     *
     * @stability stable
     */
    readonly firewallPolicy: NetworkfirewallFirewallPolicyFirewallPolicy[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallFirewallPolicyFirewallPolicyStatefulRuleGroupReference {
    /**
     * @stability stable
     */
    readonly resourceArn: string;
}
/**
 * @stability stable
 */
export interface NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionPublishMetricActionDimension {
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionPublishMetricAction {
    /**
     * dimension block.
     *
     * @stability stable
     */
    readonly dimension: NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionPublishMetricActionDimension[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinition {
    /**
     * publish_metric_action block.
     *
     * @stability stable
     */
    readonly publishMetricAction: NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinitionPublishMetricAction[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomAction {
    /**
     * @stability stable
     */
    readonly actionName: string;
    /**
     * action_definition block.
     *
     * @stability stable
     */
    readonly actionDefinition: NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomActionActionDefinition[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallFirewallPolicyFirewallPolicyStatelessRuleGroupReference {
    /**
     * @stability stable
     */
    readonly priority: number;
    /**
     * @stability stable
     */
    readonly resourceArn: string;
}
/**
 * @stability stable
 */
export interface NetworkfirewallFirewallPolicyFirewallPolicy {
    /**
     * @stability stable
     */
    readonly statelessDefaultActions: string[];
    /**
     * @stability stable
     */
    readonly statelessFragmentDefaultActions: string[];
    /**
     * stateful_rule_group_reference block.
     *
     * @stability stable
     */
    readonly statefulRuleGroupReference?: NetworkfirewallFirewallPolicyFirewallPolicyStatefulRuleGroupReference[];
    /**
     * stateless_custom_action block.
     *
     * @stability stable
     */
    readonly statelessCustomAction?: NetworkfirewallFirewallPolicyFirewallPolicyStatelessCustomAction[];
    /**
     * stateless_rule_group_reference block.
     *
     * @stability stable
     */
    readonly statelessRuleGroupReference?: NetworkfirewallFirewallPolicyFirewallPolicyStatelessRuleGroupReference[];
}
/**
 * @stability stable
 */
export declare class NetworkfirewallFirewallPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: NetworkfirewallFirewallPolicyConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get updateToken(): string;
    private _firewallPolicy;
    /**
     * @stability stable
     */
    get firewallPolicy(): NetworkfirewallFirewallPolicyFirewallPolicy[];
    /**
     * @stability stable
     */
    set firewallPolicy(value: NetworkfirewallFirewallPolicyFirewallPolicy[]);
    /**
     * @stability stable
     */
    get firewallPolicyInput(): NetworkfirewallFirewallPolicyFirewallPolicy[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
