import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface NetworkfirewallFirewallConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly deleteProtection?: boolean;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly firewallPolicyArn: string;
    /**
     * @stability stable
     */
    readonly firewallPolicyChangeProtection?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly subnetChangeProtection?: boolean;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcId: string;
    /**
     * subnet_mapping block.
     *
     * @stability stable
     */
    readonly subnetMapping: NetworkfirewallFirewallSubnetMapping[];
}
/**
 * @stability stable
 */
export declare class NetworkfirewallFirewallFirewallStatusSyncStatesAttachment extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get endpointId(): string;
    /**
     * @stability stable
     */
    get subnetId(): string;
}
/**
 * @stability stable
 */
export declare class NetworkfirewallFirewallFirewallStatusSyncStates extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get attachment(): any;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
}
/**
 * @stability stable
 */
export declare class NetworkfirewallFirewallFirewallStatus extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get syncStates(): any;
}
/**
 * @stability stable
 */
export interface NetworkfirewallFirewallSubnetMapping {
    /**
     * @stability stable
     */
    readonly subnetId: string;
}
/**
 * @stability stable
 */
export declare class NetworkfirewallFirewall extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: NetworkfirewallFirewallConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _deleteProtection?;
    /**
     * @stability stable
     */
    get deleteProtection(): boolean;
    /**
     * @stability stable
     */
    set deleteProtection(value: boolean);
    /**
     * @stability stable
     */
    resetDeleteProtection(): void;
    /**
     * @stability stable
     */
    get deleteProtectionInput(): boolean | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _firewallPolicyArn;
    /**
     * @stability stable
     */
    get firewallPolicyArn(): string;
    /**
     * @stability stable
     */
    set firewallPolicyArn(value: string);
    /**
     * @stability stable
     */
    get firewallPolicyArnInput(): string;
    private _firewallPolicyChangeProtection?;
    /**
     * @stability stable
     */
    get firewallPolicyChangeProtection(): boolean;
    /**
     * @stability stable
     */
    set firewallPolicyChangeProtection(value: boolean);
    /**
     * @stability stable
     */
    resetFirewallPolicyChangeProtection(): void;
    /**
     * @stability stable
     */
    get firewallPolicyChangeProtectionInput(): boolean | undefined;
    /**
     * @stability stable
     */
    firewallStatus(index: string): NetworkfirewallFirewallFirewallStatus;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _subnetChangeProtection?;
    /**
     * @stability stable
     */
    get subnetChangeProtection(): boolean;
    /**
     * @stability stable
     */
    set subnetChangeProtection(value: boolean);
    /**
     * @stability stable
     */
    resetSubnetChangeProtection(): void;
    /**
     * @stability stable
     */
    get subnetChangeProtectionInput(): boolean | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get updateToken(): string;
    private _vpcId;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string;
    private _subnetMapping;
    /**
     * @stability stable
     */
    get subnetMapping(): NetworkfirewallFirewallSubnetMapping[];
    /**
     * @stability stable
     */
    set subnetMapping(value: NetworkfirewallFirewallSubnetMapping[]);
    /**
     * @stability stable
     */
    get subnetMappingInput(): NetworkfirewallFirewallSubnetMapping[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
