import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface NetworkfirewallLoggingConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly firewallArn: string;
    /**
     * logging_configuration block.
     *
     * @stability stable
     */
    readonly loggingConfiguration: NetworkfirewallLoggingConfigurationLoggingConfiguration[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfig {
    /**
     * @stability stable
     */
    readonly logDestination: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly logDestinationType: string;
    /**
     * @stability stable
     */
    readonly logType: string;
}
/**
 * @stability stable
 */
export interface NetworkfirewallLoggingConfigurationLoggingConfiguration {
    /**
     * log_destination_config block.
     *
     * @stability stable
     */
    readonly logDestinationConfig: NetworkfirewallLoggingConfigurationLoggingConfigurationLogDestinationConfig[];
}
/**
 * @stability stable
 */
export declare class NetworkfirewallLoggingConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: NetworkfirewallLoggingConfigurationConfig);
    private _firewallArn;
    /**
     * @stability stable
     */
    get firewallArn(): string;
    /**
     * @stability stable
     */
    set firewallArn(value: string);
    /**
     * @stability stable
     */
    get firewallArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _loggingConfiguration;
    /**
     * @stability stable
     */
    get loggingConfiguration(): NetworkfirewallLoggingConfigurationLoggingConfiguration[];
    /**
     * @stability stable
     */
    set loggingConfiguration(value: NetworkfirewallLoggingConfigurationLoggingConfiguration[]);
    /**
     * @stability stable
     */
    get loggingConfigurationInput(): NetworkfirewallLoggingConfigurationLoggingConfiguration[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
