import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly capacity: number;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly rules?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * rule_group block.
     *
     * @stability stable
     */
    readonly ruleGroup?: NetworkfirewallRuleGroupRuleGroup[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRuleVariablesIpSetsIpSet {
    /**
     * @stability stable
     */
    readonly definition: string[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRuleVariablesIpSets {
    /**
     * @stability stable
     */
    readonly key: string;
    /**
     * ip_set block.
     *
     * @stability stable
     */
    readonly ipSet: NetworkfirewallRuleGroupRuleGroupRuleVariablesIpSetsIpSet[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRuleVariablesPortSetsPortSet {
    /**
     * @stability stable
     */
    readonly definition: string[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRuleVariablesPortSets {
    /**
     * @stability stable
     */
    readonly key: string;
    /**
     * port_set block.
     *
     * @stability stable
     */
    readonly portSet: NetworkfirewallRuleGroupRuleGroupRuleVariablesPortSetsPortSet[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRuleVariables {
    /**
     * ip_sets block.
     *
     * @stability stable
     */
    readonly ipSets?: NetworkfirewallRuleGroupRuleGroupRuleVariablesIpSets[];
    /**
     * port_sets block.
     *
     * @stability stable
     */
    readonly portSets?: NetworkfirewallRuleGroupRuleGroupRuleVariablesPortSets[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceRulesSourceList {
    /**
     * @stability stable
     */
    readonly generatedRulesType: string;
    /**
     * @stability stable
     */
    readonly targetTypes: string[];
    /**
     * @stability stable
     */
    readonly targets: string[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRuleHeader {
    /**
     * @stability stable
     */
    readonly destination: string;
    /**
     * @stability stable
     */
    readonly destinationPort: string;
    /**
     * @stability stable
     */
    readonly direction: string;
    /**
     * @stability stable
     */
    readonly protocol: string;
    /**
     * @stability stable
     */
    readonly source: string;
    /**
     * @stability stable
     */
    readonly sourcePort: string;
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRuleRuleOption {
    /**
     * @stability stable
     */
    readonly keyword: string;
    /**
     * @stability stable
     */
    readonly settings?: string[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRule {
    /**
     * @stability stable
     */
    readonly action: string;
    /**
     * header block.
     *
     * @stability stable
     */
    readonly header: NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRuleHeader[];
    /**
     * rule_option block.
     *
     * @stability stable
     */
    readonly ruleOption: NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRuleRuleOption[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionPublishMetricActionDimension {
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionPublishMetricAction {
    /**
     * dimension block.
     *
     * @stability stable
     */
    readonly dimension: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionPublishMetricActionDimension[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinition {
    /**
     * publish_metric_action block.
     *
     * @stability stable
     */
    readonly publishMetricAction: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinitionPublishMetricAction[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomAction {
    /**
     * @stability stable
     */
    readonly actionName: string;
    /**
     * action_definition block.
     *
     * @stability stable
     */
    readonly actionDefinition: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomActionActionDefinition[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesDestination {
    /**
     * @stability stable
     */
    readonly addressDefinition: string;
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesDestinationPort {
    /**
     * @stability stable
     */
    readonly fromPort: number;
    /**
     * @stability stable
     */
    readonly toPort?: number;
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesSource {
    /**
     * @stability stable
     */
    readonly addressDefinition: string;
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesSourcePort {
    /**
     * @stability stable
     */
    readonly fromPort: number;
    /**
     * @stability stable
     */
    readonly toPort?: number;
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesTcpFlag {
    /**
     * @stability stable
     */
    readonly flags: string[];
    /**
     * @stability stable
     */
    readonly masks?: string[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributes {
    /**
     * @stability stable
     */
    readonly protocols?: number[];
    /**
     * destination block.
     *
     * @stability stable
     */
    readonly destination?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesDestination[];
    /**
     * destination_port block.
     *
     * @stability stable
     */
    readonly destinationPort?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesDestinationPort[];
    /**
     * source block.
     *
     * @stability stable
     */
    readonly source?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesSource[];
    /**
     * source_port block.
     *
     * @stability stable
     */
    readonly sourcePort?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesSourcePort[];
    /**
     * tcp_flag block.
     *
     * @stability stable
     */
    readonly tcpFlag?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributesTcpFlag[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinition {
    /**
     * @stability stable
     */
    readonly actions: string[];
    /**
     * match_attributes block.
     *
     * @stability stable
     */
    readonly matchAttributes: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinitionMatchAttributes[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRule {
    /**
     * @stability stable
     */
    readonly priority: number;
    /**
     * rule_definition block.
     *
     * @stability stable
     */
    readonly ruleDefinition: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRuleRuleDefinition[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActions {
    /**
     * custom_action block.
     *
     * @stability stable
     */
    readonly customAction?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsCustomAction[];
    /**
     * stateless_rule block.
     *
     * @stability stable
     */
    readonly statelessRule: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActionsStatelessRule[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroupRulesSource {
    /**
     * @stability stable
     */
    readonly rulesString?: string;
    /**
     * rules_source_list block.
     *
     * @stability stable
     */
    readonly rulesSourceList?: NetworkfirewallRuleGroupRuleGroupRulesSourceRulesSourceList[];
    /**
     * stateful_rule block.
     *
     * @stability stable
     */
    readonly statefulRule?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatefulRule[];
    /**
     * stateless_rules_and_custom_actions block.
     *
     * @stability stable
     */
    readonly statelessRulesAndCustomActions?: NetworkfirewallRuleGroupRuleGroupRulesSourceStatelessRulesAndCustomActions[];
}
/**
 * @stability stable
 */
export interface NetworkfirewallRuleGroupRuleGroup {
    /**
     * rule_variables block.
     *
     * @stability stable
     */
    readonly ruleVariables?: NetworkfirewallRuleGroupRuleGroupRuleVariables[];
    /**
     * rules_source block.
     *
     * @stability stable
     */
    readonly rulesSource: NetworkfirewallRuleGroupRuleGroupRulesSource[];
}
/**
 * @stability stable
 */
export declare class NetworkfirewallRuleGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: NetworkfirewallRuleGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _capacity;
    /**
     * @stability stable
     */
    get capacity(): number;
    /**
     * @stability stable
     */
    set capacity(value: number);
    /**
     * @stability stable
     */
    get capacityInput(): number;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _rules?;
    /**
     * @stability stable
     */
    get rules(): string;
    /**
     * @stability stable
     */
    set rules(value: string);
    /**
     * @stability stable
     */
    resetRules(): void;
    /**
     * @stability stable
     */
    get rulesInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    /**
     * @stability stable
     */
    get updateToken(): string;
    private _ruleGroup?;
    /**
     * @stability stable
     */
    get ruleGroup(): NetworkfirewallRuleGroupRuleGroup[];
    /**
     * @stability stable
     */
    set ruleGroup(value: NetworkfirewallRuleGroupRuleGroup[]);
    /**
     * @stability stable
     */
    resetRuleGroup(): void;
    /**
     * @stability stable
     */
    get ruleGroupInput(): NetworkfirewallRuleGroupRuleGroup[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
