import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface OpsworksApplicationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly autoBundleOnDeploy?: string;
    /**
     * @stability stable
     */
    readonly awsFlowRubySettings?: string;
    /**
     * @stability stable
     */
    readonly dataSourceArn?: string;
    /**
     * @stability stable
     */
    readonly dataSourceDatabaseName?: string;
    /**
     * @stability stable
     */
    readonly dataSourceType?: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly documentRoot?: string;
    /**
     * @stability stable
     */
    readonly domains?: string[];
    /**
     * @stability stable
     */
    readonly enableSsl?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly railsEnv?: string;
    /**
     * @stability stable
     */
    readonly shortName?: string;
    /**
     * @stability stable
     */
    readonly stackId: string;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * app_source block.
     *
     * @stability stable
     */
    readonly appSource?: OpsworksApplicationAppSource[];
    /**
     * environment block.
     *
     * @stability stable
     */
    readonly environment?: OpsworksApplicationEnvironment[];
    /**
     * ssl_configuration block.
     *
     * @stability stable
     */
    readonly sslConfiguration?: OpsworksApplicationSslConfiguration[];
}
/**
 * @stability stable
 */
export interface OpsworksApplicationAppSource {
    /**
     * @stability stable
     */
    readonly password?: string;
    /**
     * @stability stable
     */
    readonly revision?: string;
    /**
     * @stability stable
     */
    readonly sshKey?: string;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly url?: string;
    /**
     * @stability stable
     */
    readonly username?: string;
}
/**
 * @stability stable
 */
export interface OpsworksApplicationEnvironment {
    /**
     * @stability stable
     */
    readonly key: string;
    /**
     * @stability stable
     */
    readonly secure?: boolean;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface OpsworksApplicationSslConfiguration {
    /**
     * @stability stable
     */
    readonly certificate: string;
    /**
     * @stability stable
     */
    readonly chain?: string;
    /**
     * @stability stable
     */
    readonly privateKey: string;
}
/**
 * @stability stable
 */
export declare class OpsworksApplication extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OpsworksApplicationConfig);
    private _autoBundleOnDeploy?;
    /**
     * @stability stable
     */
    get autoBundleOnDeploy(): string;
    /**
     * @stability stable
     */
    set autoBundleOnDeploy(value: string);
    /**
     * @stability stable
     */
    resetAutoBundleOnDeploy(): void;
    /**
     * @stability stable
     */
    get autoBundleOnDeployInput(): string | undefined;
    private _awsFlowRubySettings?;
    /**
     * @stability stable
     */
    get awsFlowRubySettings(): string;
    /**
     * @stability stable
     */
    set awsFlowRubySettings(value: string);
    /**
     * @stability stable
     */
    resetAwsFlowRubySettings(): void;
    /**
     * @stability stable
     */
    get awsFlowRubySettingsInput(): string | undefined;
    private _dataSourceArn?;
    /**
     * @stability stable
     */
    get dataSourceArn(): string;
    /**
     * @stability stable
     */
    set dataSourceArn(value: string);
    /**
     * @stability stable
     */
    resetDataSourceArn(): void;
    /**
     * @stability stable
     */
    get dataSourceArnInput(): string | undefined;
    private _dataSourceDatabaseName?;
    /**
     * @stability stable
     */
    get dataSourceDatabaseName(): string;
    /**
     * @stability stable
     */
    set dataSourceDatabaseName(value: string);
    /**
     * @stability stable
     */
    resetDataSourceDatabaseName(): void;
    /**
     * @stability stable
     */
    get dataSourceDatabaseNameInput(): string | undefined;
    private _dataSourceType?;
    /**
     * @stability stable
     */
    get dataSourceType(): string;
    /**
     * @stability stable
     */
    set dataSourceType(value: string);
    /**
     * @stability stable
     */
    resetDataSourceType(): void;
    /**
     * @stability stable
     */
    get dataSourceTypeInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _documentRoot?;
    /**
     * @stability stable
     */
    get documentRoot(): string;
    /**
     * @stability stable
     */
    set documentRoot(value: string);
    /**
     * @stability stable
     */
    resetDocumentRoot(): void;
    /**
     * @stability stable
     */
    get documentRootInput(): string | undefined;
    private _domains?;
    /**
     * @stability stable
     */
    get domains(): string[];
    /**
     * @stability stable
     */
    set domains(value: string[]);
    /**
     * @stability stable
     */
    resetDomains(): void;
    /**
     * @stability stable
     */
    get domainsInput(): string[] | undefined;
    private _enableSsl?;
    /**
     * @stability stable
     */
    get enableSsl(): boolean;
    /**
     * @stability stable
     */
    set enableSsl(value: boolean);
    /**
     * @stability stable
     */
    resetEnableSsl(): void;
    /**
     * @stability stable
     */
    get enableSslInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _railsEnv?;
    /**
     * @stability stable
     */
    get railsEnv(): string;
    /**
     * @stability stable
     */
    set railsEnv(value: string);
    /**
     * @stability stable
     */
    resetRailsEnv(): void;
    /**
     * @stability stable
     */
    get railsEnvInput(): string | undefined;
    private _shortName?;
    /**
     * @stability stable
     */
    get shortName(): string;
    /**
     * @stability stable
     */
    set shortName(value: string);
    /**
     * @stability stable
     */
    resetShortName(): void;
    /**
     * @stability stable
     */
    get shortNameInput(): string | undefined;
    private _stackId;
    /**
     * @stability stable
     */
    get stackId(): string;
    /**
     * @stability stable
     */
    set stackId(value: string);
    /**
     * @stability stable
     */
    get stackIdInput(): string;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    private _appSource?;
    /**
     * @stability stable
     */
    get appSource(): OpsworksApplicationAppSource[];
    /**
     * @stability stable
     */
    set appSource(value: OpsworksApplicationAppSource[]);
    /**
     * @stability stable
     */
    resetAppSource(): void;
    /**
     * @stability stable
     */
    get appSourceInput(): OpsworksApplicationAppSource[] | undefined;
    private _environment?;
    /**
     * @stability stable
     */
    get environment(): OpsworksApplicationEnvironment[];
    /**
     * @stability stable
     */
    set environment(value: OpsworksApplicationEnvironment[]);
    /**
     * @stability stable
     */
    resetEnvironment(): void;
    /**
     * @stability stable
     */
    get environmentInput(): OpsworksApplicationEnvironment[] | undefined;
    private _sslConfiguration?;
    /**
     * @stability stable
     */
    get sslConfiguration(): OpsworksApplicationSslConfiguration[];
    /**
     * @stability stable
     */
    set sslConfiguration(value: OpsworksApplicationSslConfiguration[]);
    /**
     * @stability stable
     */
    resetSslConfiguration(): void;
    /**
     * @stability stable
     */
    get sslConfigurationInput(): OpsworksApplicationSslConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
