import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface OpsworksInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly agentVersion?: string;
    /**
     * @stability stable
     */
    readonly amiId?: string;
    /**
     * @stability stable
     */
    readonly architecture?: string;
    /**
     * @stability stable
     */
    readonly autoScalingType?: string;
    /**
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * @stability stable
     */
    readonly createdAt?: string;
    /**
     * @stability stable
     */
    readonly deleteEbs?: boolean;
    /**
     * @stability stable
     */
    readonly deleteEip?: boolean;
    /**
     * @stability stable
     */
    readonly ebsOptimized?: boolean;
    /**
     * @stability stable
     */
    readonly ecsClusterArn?: string;
    /**
     * @stability stable
     */
    readonly elasticIp?: string;
    /**
     * @stability stable
     */
    readonly hostname?: string;
    /**
     * @stability stable
     */
    readonly infrastructureClass?: string;
    /**
     * @stability stable
     */
    readonly installUpdatesOnBoot?: boolean;
    /**
     * @stability stable
     */
    readonly instanceProfileArn?: string;
    /**
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * @stability stable
     */
    readonly lastServiceErrorId?: string;
    /**
     * @stability stable
     */
    readonly layerIds: string[];
    /**
     * @stability stable
     */
    readonly os?: string;
    /**
     * @stability stable
     */
    readonly platform?: string;
    /**
     * @stability stable
     */
    readonly privateDns?: string;
    /**
     * @stability stable
     */
    readonly privateIp?: string;
    /**
     * @stability stable
     */
    readonly publicDns?: string;
    /**
     * @stability stable
     */
    readonly publicIp?: string;
    /**
     * @stability stable
     */
    readonly registeredBy?: string;
    /**
     * @stability stable
     */
    readonly reportedAgentVersion?: string;
    /**
     * @stability stable
     */
    readonly reportedOsFamily?: string;
    /**
     * @stability stable
     */
    readonly reportedOsName?: string;
    /**
     * @stability stable
     */
    readonly reportedOsVersion?: string;
    /**
     * @stability stable
     */
    readonly rootDeviceType?: string;
    /**
     * @stability stable
     */
    readonly rootDeviceVolumeId?: string;
    /**
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * @stability stable
     */
    readonly sshHostDsaKeyFingerprint?: string;
    /**
     * @stability stable
     */
    readonly sshHostRsaKeyFingerprint?: string;
    /**
     * @stability stable
     */
    readonly sshKeyName?: string;
    /**
     * @stability stable
     */
    readonly stackId: string;
    /**
     * @stability stable
     */
    readonly state?: string;
    /**
     * @stability stable
     */
    readonly status?: string;
    /**
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * @stability stable
     */
    readonly tenancy?: string;
    /**
     * @stability stable
     */
    readonly virtualizationType?: string;
    /**
     * ebs_block_device block.
     *
     * @stability stable
     */
    readonly ebsBlockDevice?: OpsworksInstanceEbsBlockDevice[];
    /**
     * ephemeral_block_device block.
     *
     * @stability stable
     */
    readonly ephemeralBlockDevice?: OpsworksInstanceEphemeralBlockDevice[];
    /**
     * root_block_device block.
     *
     * @stability stable
     */
    readonly rootBlockDevice?: OpsworksInstanceRootBlockDevice[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: OpsworksInstanceTimeouts;
}
/**
 * @stability stable
 */
export interface OpsworksInstanceEbsBlockDevice {
    /**
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly snapshotId?: string;
    /**
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface OpsworksInstanceEphemeralBlockDevice {
    /**
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * @stability stable
     */
    readonly virtualName: string;
}
/**
 * @stability stable
 */
export interface OpsworksInstanceRootBlockDevice {
    /**
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface OpsworksInstanceTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class OpsworksInstance extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OpsworksInstanceConfig);
    private _agentVersion?;
    /**
     * @stability stable
     */
    get agentVersion(): string;
    /**
     * @stability stable
     */
    set agentVersion(value: string);
    /**
     * @stability stable
     */
    resetAgentVersion(): void;
    /**
     * @stability stable
     */
    get agentVersionInput(): string | undefined;
    private _amiId?;
    /**
     * @stability stable
     */
    get amiId(): string;
    /**
     * @stability stable
     */
    set amiId(value: string);
    /**
     * @stability stable
     */
    resetAmiId(): void;
    /**
     * @stability stable
     */
    get amiIdInput(): string | undefined;
    private _architecture?;
    /**
     * @stability stable
     */
    get architecture(): string;
    /**
     * @stability stable
     */
    set architecture(value: string);
    /**
     * @stability stable
     */
    resetArchitecture(): void;
    /**
     * @stability stable
     */
    get architectureInput(): string | undefined;
    private _autoScalingType?;
    /**
     * @stability stable
     */
    get autoScalingType(): string;
    /**
     * @stability stable
     */
    set autoScalingType(value: string);
    /**
     * @stability stable
     */
    resetAutoScalingType(): void;
    /**
     * @stability stable
     */
    get autoScalingTypeInput(): string | undefined;
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    private _createdAt?;
    /**
     * @stability stable
     */
    get createdAt(): string;
    /**
     * @stability stable
     */
    set createdAt(value: string);
    /**
     * @stability stable
     */
    resetCreatedAt(): void;
    /**
     * @stability stable
     */
    get createdAtInput(): string | undefined;
    private _deleteEbs?;
    /**
     * @stability stable
     */
    get deleteEbs(): boolean;
    /**
     * @stability stable
     */
    set deleteEbs(value: boolean);
    /**
     * @stability stable
     */
    resetDeleteEbs(): void;
    /**
     * @stability stable
     */
    get deleteEbsInput(): boolean | undefined;
    private _deleteEip?;
    /**
     * @stability stable
     */
    get deleteEip(): boolean;
    /**
     * @stability stable
     */
    set deleteEip(value: boolean);
    /**
     * @stability stable
     */
    resetDeleteEip(): void;
    /**
     * @stability stable
     */
    get deleteEipInput(): boolean | undefined;
    private _ebsOptimized?;
    /**
     * @stability stable
     */
    get ebsOptimized(): boolean;
    /**
     * @stability stable
     */
    set ebsOptimized(value: boolean);
    /**
     * @stability stable
     */
    resetEbsOptimized(): void;
    /**
     * @stability stable
     */
    get ebsOptimizedInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get ec2InstanceId(): string;
    private _ecsClusterArn?;
    /**
     * @stability stable
     */
    get ecsClusterArn(): string;
    /**
     * @stability stable
     */
    set ecsClusterArn(value: string);
    /**
     * @stability stable
     */
    resetEcsClusterArn(): void;
    /**
     * @stability stable
     */
    get ecsClusterArnInput(): string | undefined;
    private _elasticIp?;
    /**
     * @stability stable
     */
    get elasticIp(): string;
    /**
     * @stability stable
     */
    set elasticIp(value: string);
    /**
     * @stability stable
     */
    resetElasticIp(): void;
    /**
     * @stability stable
     */
    get elasticIpInput(): string | undefined;
    private _hostname?;
    /**
     * @stability stable
     */
    get hostname(): string;
    /**
     * @stability stable
     */
    set hostname(value: string);
    /**
     * @stability stable
     */
    resetHostname(): void;
    /**
     * @stability stable
     */
    get hostnameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _infrastructureClass?;
    /**
     * @stability stable
     */
    get infrastructureClass(): string;
    /**
     * @stability stable
     */
    set infrastructureClass(value: string);
    /**
     * @stability stable
     */
    resetInfrastructureClass(): void;
    /**
     * @stability stable
     */
    get infrastructureClassInput(): string | undefined;
    private _installUpdatesOnBoot?;
    /**
     * @stability stable
     */
    get installUpdatesOnBoot(): boolean;
    /**
     * @stability stable
     */
    set installUpdatesOnBoot(value: boolean);
    /**
     * @stability stable
     */
    resetInstallUpdatesOnBoot(): void;
    /**
     * @stability stable
     */
    get installUpdatesOnBootInput(): boolean | undefined;
    private _instanceProfileArn?;
    /**
     * @stability stable
     */
    get instanceProfileArn(): string;
    /**
     * @stability stable
     */
    set instanceProfileArn(value: string);
    /**
     * @stability stable
     */
    resetInstanceProfileArn(): void;
    /**
     * @stability stable
     */
    get instanceProfileArnInput(): string | undefined;
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    resetInstanceType(): void;
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    private _lastServiceErrorId?;
    /**
     * @stability stable
     */
    get lastServiceErrorId(): string;
    /**
     * @stability stable
     */
    set lastServiceErrorId(value: string);
    /**
     * @stability stable
     */
    resetLastServiceErrorId(): void;
    /**
     * @stability stable
     */
    get lastServiceErrorIdInput(): string | undefined;
    private _layerIds;
    /**
     * @stability stable
     */
    get layerIds(): string[];
    /**
     * @stability stable
     */
    set layerIds(value: string[]);
    /**
     * @stability stable
     */
    get layerIdsInput(): string[];
    private _os?;
    /**
     * @stability stable
     */
    get os(): string;
    /**
     * @stability stable
     */
    set os(value: string);
    /**
     * @stability stable
     */
    resetOs(): void;
    /**
     * @stability stable
     */
    get osInput(): string | undefined;
    private _platform?;
    /**
     * @stability stable
     */
    get platform(): string;
    /**
     * @stability stable
     */
    set platform(value: string);
    /**
     * @stability stable
     */
    resetPlatform(): void;
    /**
     * @stability stable
     */
    get platformInput(): string | undefined;
    private _privateDns?;
    /**
     * @stability stable
     */
    get privateDns(): string;
    /**
     * @stability stable
     */
    set privateDns(value: string);
    /**
     * @stability stable
     */
    resetPrivateDns(): void;
    /**
     * @stability stable
     */
    get privateDnsInput(): string | undefined;
    private _privateIp?;
    /**
     * @stability stable
     */
    get privateIp(): string;
    /**
     * @stability stable
     */
    set privateIp(value: string);
    /**
     * @stability stable
     */
    resetPrivateIp(): void;
    /**
     * @stability stable
     */
    get privateIpInput(): string | undefined;
    private _publicDns?;
    /**
     * @stability stable
     */
    get publicDns(): string;
    /**
     * @stability stable
     */
    set publicDns(value: string);
    /**
     * @stability stable
     */
    resetPublicDns(): void;
    /**
     * @stability stable
     */
    get publicDnsInput(): string | undefined;
    private _publicIp?;
    /**
     * @stability stable
     */
    get publicIp(): string;
    /**
     * @stability stable
     */
    set publicIp(value: string);
    /**
     * @stability stable
     */
    resetPublicIp(): void;
    /**
     * @stability stable
     */
    get publicIpInput(): string | undefined;
    private _registeredBy?;
    /**
     * @stability stable
     */
    get registeredBy(): string;
    /**
     * @stability stable
     */
    set registeredBy(value: string);
    /**
     * @stability stable
     */
    resetRegisteredBy(): void;
    /**
     * @stability stable
     */
    get registeredByInput(): string | undefined;
    private _reportedAgentVersion?;
    /**
     * @stability stable
     */
    get reportedAgentVersion(): string;
    /**
     * @stability stable
     */
    set reportedAgentVersion(value: string);
    /**
     * @stability stable
     */
    resetReportedAgentVersion(): void;
    /**
     * @stability stable
     */
    get reportedAgentVersionInput(): string | undefined;
    private _reportedOsFamily?;
    /**
     * @stability stable
     */
    get reportedOsFamily(): string;
    /**
     * @stability stable
     */
    set reportedOsFamily(value: string);
    /**
     * @stability stable
     */
    resetReportedOsFamily(): void;
    /**
     * @stability stable
     */
    get reportedOsFamilyInput(): string | undefined;
    private _reportedOsName?;
    /**
     * @stability stable
     */
    get reportedOsName(): string;
    /**
     * @stability stable
     */
    set reportedOsName(value: string);
    /**
     * @stability stable
     */
    resetReportedOsName(): void;
    /**
     * @stability stable
     */
    get reportedOsNameInput(): string | undefined;
    private _reportedOsVersion?;
    /**
     * @stability stable
     */
    get reportedOsVersion(): string;
    /**
     * @stability stable
     */
    set reportedOsVersion(value: string);
    /**
     * @stability stable
     */
    resetReportedOsVersion(): void;
    /**
     * @stability stable
     */
    get reportedOsVersionInput(): string | undefined;
    private _rootDeviceType?;
    /**
     * @stability stable
     */
    get rootDeviceType(): string;
    /**
     * @stability stable
     */
    set rootDeviceType(value: string);
    /**
     * @stability stable
     */
    resetRootDeviceType(): void;
    /**
     * @stability stable
     */
    get rootDeviceTypeInput(): string | undefined;
    private _rootDeviceVolumeId?;
    /**
     * @stability stable
     */
    get rootDeviceVolumeId(): string;
    /**
     * @stability stable
     */
    set rootDeviceVolumeId(value: string);
    /**
     * @stability stable
     */
    resetRootDeviceVolumeId(): void;
    /**
     * @stability stable
     */
    get rootDeviceVolumeIdInput(): string | undefined;
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _sshHostDsaKeyFingerprint?;
    /**
     * @stability stable
     */
    get sshHostDsaKeyFingerprint(): string;
    /**
     * @stability stable
     */
    set sshHostDsaKeyFingerprint(value: string);
    /**
     * @stability stable
     */
    resetSshHostDsaKeyFingerprint(): void;
    /**
     * @stability stable
     */
    get sshHostDsaKeyFingerprintInput(): string | undefined;
    private _sshHostRsaKeyFingerprint?;
    /**
     * @stability stable
     */
    get sshHostRsaKeyFingerprint(): string;
    /**
     * @stability stable
     */
    set sshHostRsaKeyFingerprint(value: string);
    /**
     * @stability stable
     */
    resetSshHostRsaKeyFingerprint(): void;
    /**
     * @stability stable
     */
    get sshHostRsaKeyFingerprintInput(): string | undefined;
    private _sshKeyName?;
    /**
     * @stability stable
     */
    get sshKeyName(): string;
    /**
     * @stability stable
     */
    set sshKeyName(value: string);
    /**
     * @stability stable
     */
    resetSshKeyName(): void;
    /**
     * @stability stable
     */
    get sshKeyNameInput(): string | undefined;
    private _stackId;
    /**
     * @stability stable
     */
    get stackId(): string;
    /**
     * @stability stable
     */
    set stackId(value: string);
    /**
     * @stability stable
     */
    get stackIdInput(): string;
    private _state?;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    set state(value: string);
    /**
     * @stability stable
     */
    resetState(): void;
    /**
     * @stability stable
     */
    get stateInput(): string | undefined;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    set status(value: string);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    private _subnetId?;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    resetSubnetId(): void;
    /**
     * @stability stable
     */
    get subnetIdInput(): string | undefined;
    private _tenancy?;
    /**
     * @stability stable
     */
    get tenancy(): string;
    /**
     * @stability stable
     */
    set tenancy(value: string);
    /**
     * @stability stable
     */
    resetTenancy(): void;
    /**
     * @stability stable
     */
    get tenancyInput(): string | undefined;
    private _virtualizationType?;
    /**
     * @stability stable
     */
    get virtualizationType(): string;
    /**
     * @stability stable
     */
    set virtualizationType(value: string);
    /**
     * @stability stable
     */
    resetVirtualizationType(): void;
    /**
     * @stability stable
     */
    get virtualizationTypeInput(): string | undefined;
    private _ebsBlockDevice?;
    /**
     * @stability stable
     */
    get ebsBlockDevice(): OpsworksInstanceEbsBlockDevice[];
    /**
     * @stability stable
     */
    set ebsBlockDevice(value: OpsworksInstanceEbsBlockDevice[]);
    /**
     * @stability stable
     */
    resetEbsBlockDevice(): void;
    /**
     * @stability stable
     */
    get ebsBlockDeviceInput(): OpsworksInstanceEbsBlockDevice[] | undefined;
    private _ephemeralBlockDevice?;
    /**
     * @stability stable
     */
    get ephemeralBlockDevice(): OpsworksInstanceEphemeralBlockDevice[];
    /**
     * @stability stable
     */
    set ephemeralBlockDevice(value: OpsworksInstanceEphemeralBlockDevice[]);
    /**
     * @stability stable
     */
    resetEphemeralBlockDevice(): void;
    /**
     * @stability stable
     */
    get ephemeralBlockDeviceInput(): OpsworksInstanceEphemeralBlockDevice[] | undefined;
    private _rootBlockDevice?;
    /**
     * @stability stable
     */
    get rootBlockDevice(): OpsworksInstanceRootBlockDevice[];
    /**
     * @stability stable
     */
    set rootBlockDevice(value: OpsworksInstanceRootBlockDevice[]);
    /**
     * @stability stable
     */
    resetRootBlockDevice(): void;
    /**
     * @stability stable
     */
    get rootBlockDeviceInput(): OpsworksInstanceRootBlockDevice[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): OpsworksInstanceTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: OpsworksInstanceTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): OpsworksInstanceTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
