import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface OpsworksJavaAppLayerConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly appServer?: string;
    /**
     * @stability stable
     */
    readonly appServerVersion?: string;
    /**
     * @stability stable
     */
    readonly autoAssignElasticIps?: boolean;
    /**
     * @stability stable
     */
    readonly autoAssignPublicIps?: boolean;
    /**
     * @stability stable
     */
    readonly autoHealing?: boolean;
    /**
     * @stability stable
     */
    readonly customConfigureRecipes?: string[];
    /**
     * @stability stable
     */
    readonly customDeployRecipes?: string[];
    /**
     * @stability stable
     */
    readonly customInstanceProfileArn?: string;
    /**
     * @stability stable
     */
    readonly customJson?: string;
    /**
     * @stability stable
     */
    readonly customSecurityGroupIds?: string[];
    /**
     * @stability stable
     */
    readonly customSetupRecipes?: string[];
    /**
     * @stability stable
     */
    readonly customShutdownRecipes?: string[];
    /**
     * @stability stable
     */
    readonly customUndeployRecipes?: string[];
    /**
     * @stability stable
     */
    readonly drainElbOnShutdown?: boolean;
    /**
     * @stability stable
     */
    readonly elasticLoadBalancer?: string;
    /**
     * @stability stable
     */
    readonly installUpdatesOnBoot?: boolean;
    /**
     * @stability stable
     */
    readonly instanceShutdownTimeout?: number;
    /**
     * @stability stable
     */
    readonly jvmOptions?: string;
    /**
     * @stability stable
     */
    readonly jvmType?: string;
    /**
     * @stability stable
     */
    readonly jvmVersion?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly stackId: string;
    /**
     * @stability stable
     */
    readonly systemPackages?: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly useEbsOptimizedInstances?: boolean;
    /**
     * ebs_volume block.
     *
     * @stability stable
     */
    readonly ebsVolume?: OpsworksJavaAppLayerEbsVolume[];
}
/**
 * @stability stable
 */
export interface OpsworksJavaAppLayerEbsVolume {
    /**
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly mountPoint: string;
    /**
     * @stability stable
     */
    readonly numberOfDisks: number;
    /**
     * @stability stable
     */
    readonly raidLevel?: string;
    /**
     * @stability stable
     */
    readonly size: number;
    /**
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export declare class OpsworksJavaAppLayer extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OpsworksJavaAppLayerConfig);
    private _appServer?;
    /**
     * @stability stable
     */
    get appServer(): string;
    /**
     * @stability stable
     */
    set appServer(value: string);
    /**
     * @stability stable
     */
    resetAppServer(): void;
    /**
     * @stability stable
     */
    get appServerInput(): string | undefined;
    private _appServerVersion?;
    /**
     * @stability stable
     */
    get appServerVersion(): string;
    /**
     * @stability stable
     */
    set appServerVersion(value: string);
    /**
     * @stability stable
     */
    resetAppServerVersion(): void;
    /**
     * @stability stable
     */
    get appServerVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoAssignElasticIps?;
    /**
     * @stability stable
     */
    get autoAssignElasticIps(): boolean;
    /**
     * @stability stable
     */
    set autoAssignElasticIps(value: boolean);
    /**
     * @stability stable
     */
    resetAutoAssignElasticIps(): void;
    /**
     * @stability stable
     */
    get autoAssignElasticIpsInput(): boolean | undefined;
    private _autoAssignPublicIps?;
    /**
     * @stability stable
     */
    get autoAssignPublicIps(): boolean;
    /**
     * @stability stable
     */
    set autoAssignPublicIps(value: boolean);
    /**
     * @stability stable
     */
    resetAutoAssignPublicIps(): void;
    /**
     * @stability stable
     */
    get autoAssignPublicIpsInput(): boolean | undefined;
    private _autoHealing?;
    /**
     * @stability stable
     */
    get autoHealing(): boolean;
    /**
     * @stability stable
     */
    set autoHealing(value: boolean);
    /**
     * @stability stable
     */
    resetAutoHealing(): void;
    /**
     * @stability stable
     */
    get autoHealingInput(): boolean | undefined;
    private _customConfigureRecipes?;
    /**
     * @stability stable
     */
    get customConfigureRecipes(): string[];
    /**
     * @stability stable
     */
    set customConfigureRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomConfigureRecipes(): void;
    /**
     * @stability stable
     */
    get customConfigureRecipesInput(): string[] | undefined;
    private _customDeployRecipes?;
    /**
     * @stability stable
     */
    get customDeployRecipes(): string[];
    /**
     * @stability stable
     */
    set customDeployRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomDeployRecipes(): void;
    /**
     * @stability stable
     */
    get customDeployRecipesInput(): string[] | undefined;
    private _customInstanceProfileArn?;
    /**
     * @stability stable
     */
    get customInstanceProfileArn(): string;
    /**
     * @stability stable
     */
    set customInstanceProfileArn(value: string);
    /**
     * @stability stable
     */
    resetCustomInstanceProfileArn(): void;
    /**
     * @stability stable
     */
    get customInstanceProfileArnInput(): string | undefined;
    private _customJson?;
    /**
     * @stability stable
     */
    get customJson(): string;
    /**
     * @stability stable
     */
    set customJson(value: string);
    /**
     * @stability stable
     */
    resetCustomJson(): void;
    /**
     * @stability stable
     */
    get customJsonInput(): string | undefined;
    private _customSecurityGroupIds?;
    /**
     * @stability stable
     */
    get customSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set customSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetCustomSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get customSecurityGroupIdsInput(): string[] | undefined;
    private _customSetupRecipes?;
    /**
     * @stability stable
     */
    get customSetupRecipes(): string[];
    /**
     * @stability stable
     */
    set customSetupRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomSetupRecipes(): void;
    /**
     * @stability stable
     */
    get customSetupRecipesInput(): string[] | undefined;
    private _customShutdownRecipes?;
    /**
     * @stability stable
     */
    get customShutdownRecipes(): string[];
    /**
     * @stability stable
     */
    set customShutdownRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomShutdownRecipes(): void;
    /**
     * @stability stable
     */
    get customShutdownRecipesInput(): string[] | undefined;
    private _customUndeployRecipes?;
    /**
     * @stability stable
     */
    get customUndeployRecipes(): string[];
    /**
     * @stability stable
     */
    set customUndeployRecipes(value: string[]);
    /**
     * @stability stable
     */
    resetCustomUndeployRecipes(): void;
    /**
     * @stability stable
     */
    get customUndeployRecipesInput(): string[] | undefined;
    private _drainElbOnShutdown?;
    /**
     * @stability stable
     */
    get drainElbOnShutdown(): boolean;
    /**
     * @stability stable
     */
    set drainElbOnShutdown(value: boolean);
    /**
     * @stability stable
     */
    resetDrainElbOnShutdown(): void;
    /**
     * @stability stable
     */
    get drainElbOnShutdownInput(): boolean | undefined;
    private _elasticLoadBalancer?;
    /**
     * @stability stable
     */
    get elasticLoadBalancer(): string;
    /**
     * @stability stable
     */
    set elasticLoadBalancer(value: string);
    /**
     * @stability stable
     */
    resetElasticLoadBalancer(): void;
    /**
     * @stability stable
     */
    get elasticLoadBalancerInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _installUpdatesOnBoot?;
    /**
     * @stability stable
     */
    get installUpdatesOnBoot(): boolean;
    /**
     * @stability stable
     */
    set installUpdatesOnBoot(value: boolean);
    /**
     * @stability stable
     */
    resetInstallUpdatesOnBoot(): void;
    /**
     * @stability stable
     */
    get installUpdatesOnBootInput(): boolean | undefined;
    private _instanceShutdownTimeout?;
    /**
     * @stability stable
     */
    get instanceShutdownTimeout(): number;
    /**
     * @stability stable
     */
    set instanceShutdownTimeout(value: number);
    /**
     * @stability stable
     */
    resetInstanceShutdownTimeout(): void;
    /**
     * @stability stable
     */
    get instanceShutdownTimeoutInput(): number | undefined;
    private _jvmOptions?;
    /**
     * @stability stable
     */
    get jvmOptions(): string;
    /**
     * @stability stable
     */
    set jvmOptions(value: string);
    /**
     * @stability stable
     */
    resetJvmOptions(): void;
    /**
     * @stability stable
     */
    get jvmOptionsInput(): string | undefined;
    private _jvmType?;
    /**
     * @stability stable
     */
    get jvmType(): string;
    /**
     * @stability stable
     */
    set jvmType(value: string);
    /**
     * @stability stable
     */
    resetJvmType(): void;
    /**
     * @stability stable
     */
    get jvmTypeInput(): string | undefined;
    private _jvmVersion?;
    /**
     * @stability stable
     */
    get jvmVersion(): string;
    /**
     * @stability stable
     */
    set jvmVersion(value: string);
    /**
     * @stability stable
     */
    resetJvmVersion(): void;
    /**
     * @stability stable
     */
    get jvmVersionInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _stackId;
    /**
     * @stability stable
     */
    get stackId(): string;
    /**
     * @stability stable
     */
    set stackId(value: string);
    /**
     * @stability stable
     */
    get stackIdInput(): string;
    private _systemPackages?;
    /**
     * @stability stable
     */
    get systemPackages(): string[];
    /**
     * @stability stable
     */
    set systemPackages(value: string[]);
    /**
     * @stability stable
     */
    resetSystemPackages(): void;
    /**
     * @stability stable
     */
    get systemPackagesInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _useEbsOptimizedInstances?;
    /**
     * @stability stable
     */
    get useEbsOptimizedInstances(): boolean;
    /**
     * @stability stable
     */
    set useEbsOptimizedInstances(value: boolean);
    /**
     * @stability stable
     */
    resetUseEbsOptimizedInstances(): void;
    /**
     * @stability stable
     */
    get useEbsOptimizedInstancesInput(): boolean | undefined;
    private _ebsVolume?;
    /**
     * @stability stable
     */
    get ebsVolume(): OpsworksJavaAppLayerEbsVolume[];
    /**
     * @stability stable
     */
    set ebsVolume(value: OpsworksJavaAppLayerEbsVolume[]);
    /**
     * @stability stable
     */
    resetEbsVolume(): void;
    /**
     * @stability stable
     */
    get ebsVolumeInput(): OpsworksJavaAppLayerEbsVolume[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
