import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface OpsworksPermissionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly allowSsh?: boolean;
    /**
     * @stability stable
     */
    readonly allowSudo?: boolean;
    /**
     * @stability stable
     */
    readonly level?: string;
    /**
     * @stability stable
     */
    readonly stackId?: string;
    /**
     * @stability stable
     */
    readonly userArn: string;
}
/**
 * @stability stable
 */
export declare class OpsworksPermission extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OpsworksPermissionConfig);
    private _allowSsh?;
    /**
     * @stability stable
     */
    get allowSsh(): boolean;
    /**
     * @stability stable
     */
    set allowSsh(value: boolean);
    /**
     * @stability stable
     */
    resetAllowSsh(): void;
    /**
     * @stability stable
     */
    get allowSshInput(): boolean | undefined;
    private _allowSudo?;
    /**
     * @stability stable
     */
    get allowSudo(): boolean;
    /**
     * @stability stable
     */
    set allowSudo(value: boolean);
    /**
     * @stability stable
     */
    resetAllowSudo(): void;
    /**
     * @stability stable
     */
    get allowSudoInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _level?;
    /**
     * @stability stable
     */
    get level(): string;
    /**
     * @stability stable
     */
    set level(value: string);
    /**
     * @stability stable
     */
    resetLevel(): void;
    /**
     * @stability stable
     */
    get levelInput(): string | undefined;
    private _stackId?;
    /**
     * @stability stable
     */
    get stackId(): string;
    /**
     * @stability stable
     */
    set stackId(value: string);
    /**
     * @stability stable
     */
    resetStackId(): void;
    /**
     * @stability stable
     */
    get stackIdInput(): string | undefined;
    private _userArn;
    /**
     * @stability stable
     */
    get userArn(): string;
    /**
     * @stability stable
     */
    set userArn(value: string);
    /**
     * @stability stable
     */
    get userArnInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
