import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface OpsworksStackConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly agentVersion?: string;
    /**
     * @stability stable
     */
    readonly berkshelfVersion?: string;
    /**
     * @stability stable
     */
    readonly color?: string;
    /**
     * @stability stable
     */
    readonly configurationManagerName?: string;
    /**
     * @stability stable
     */
    readonly configurationManagerVersion?: string;
    /**
     * @stability stable
     */
    readonly customJson?: string;
    /**
     * @stability stable
     */
    readonly defaultAvailabilityZone?: string;
    /**
     * @stability stable
     */
    readonly defaultInstanceProfileArn: string;
    /**
     * @stability stable
     */
    readonly defaultOs?: string;
    /**
     * @stability stable
     */
    readonly defaultRootDeviceType?: string;
    /**
     * @stability stable
     */
    readonly defaultSshKeyName?: string;
    /**
     * @stability stable
     */
    readonly defaultSubnetId?: string;
    /**
     * @stability stable
     */
    readonly hostnameTheme?: string;
    /**
     * @stability stable
     */
    readonly manageBerkshelf?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly region: string;
    /**
     * @stability stable
     */
    readonly serviceRoleArn: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly useCustomCookbooks?: boolean;
    /**
     * @stability stable
     */
    readonly useOpsworksSecurityGroups?: boolean;
    /**
     * @stability stable
     */
    readonly vpcId?: string;
    /**
     * custom_cookbooks_source block.
     *
     * @stability stable
     */
    readonly customCookbooksSource?: OpsworksStackCustomCookbooksSource[];
}
/**
 * @stability stable
 */
export interface OpsworksStackCustomCookbooksSource {
    /**
     * @stability stable
     */
    readonly password?: string;
    /**
     * @stability stable
     */
    readonly revision?: string;
    /**
     * @stability stable
     */
    readonly sshKey?: string;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly url: string;
    /**
     * @stability stable
     */
    readonly username?: string;
}
/**
 * @stability stable
 */
export declare class OpsworksStack extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OpsworksStackConfig);
    private _agentVersion?;
    /**
     * @stability stable
     */
    get agentVersion(): string;
    /**
     * @stability stable
     */
    set agentVersion(value: string);
    /**
     * @stability stable
     */
    resetAgentVersion(): void;
    /**
     * @stability stable
     */
    get agentVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _berkshelfVersion?;
    /**
     * @stability stable
     */
    get berkshelfVersion(): string;
    /**
     * @stability stable
     */
    set berkshelfVersion(value: string);
    /**
     * @stability stable
     */
    resetBerkshelfVersion(): void;
    /**
     * @stability stable
     */
    get berkshelfVersionInput(): string | undefined;
    private _color?;
    /**
     * @stability stable
     */
    get color(): string;
    /**
     * @stability stable
     */
    set color(value: string);
    /**
     * @stability stable
     */
    resetColor(): void;
    /**
     * @stability stable
     */
    get colorInput(): string | undefined;
    private _configurationManagerName?;
    /**
     * @stability stable
     */
    get configurationManagerName(): string;
    /**
     * @stability stable
     */
    set configurationManagerName(value: string);
    /**
     * @stability stable
     */
    resetConfigurationManagerName(): void;
    /**
     * @stability stable
     */
    get configurationManagerNameInput(): string | undefined;
    private _configurationManagerVersion?;
    /**
     * @stability stable
     */
    get configurationManagerVersion(): string;
    /**
     * @stability stable
     */
    set configurationManagerVersion(value: string);
    /**
     * @stability stable
     */
    resetConfigurationManagerVersion(): void;
    /**
     * @stability stable
     */
    get configurationManagerVersionInput(): string | undefined;
    private _customJson?;
    /**
     * @stability stable
     */
    get customJson(): string;
    /**
     * @stability stable
     */
    set customJson(value: string);
    /**
     * @stability stable
     */
    resetCustomJson(): void;
    /**
     * @stability stable
     */
    get customJsonInput(): string | undefined;
    private _defaultAvailabilityZone?;
    /**
     * @stability stable
     */
    get defaultAvailabilityZone(): string;
    /**
     * @stability stable
     */
    set defaultAvailabilityZone(value: string);
    /**
     * @stability stable
     */
    resetDefaultAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get defaultAvailabilityZoneInput(): string | undefined;
    private _defaultInstanceProfileArn;
    /**
     * @stability stable
     */
    get defaultInstanceProfileArn(): string;
    /**
     * @stability stable
     */
    set defaultInstanceProfileArn(value: string);
    /**
     * @stability stable
     */
    get defaultInstanceProfileArnInput(): string;
    private _defaultOs?;
    /**
     * @stability stable
     */
    get defaultOs(): string;
    /**
     * @stability stable
     */
    set defaultOs(value: string);
    /**
     * @stability stable
     */
    resetDefaultOs(): void;
    /**
     * @stability stable
     */
    get defaultOsInput(): string | undefined;
    private _defaultRootDeviceType?;
    /**
     * @stability stable
     */
    get defaultRootDeviceType(): string;
    /**
     * @stability stable
     */
    set defaultRootDeviceType(value: string);
    /**
     * @stability stable
     */
    resetDefaultRootDeviceType(): void;
    /**
     * @stability stable
     */
    get defaultRootDeviceTypeInput(): string | undefined;
    private _defaultSshKeyName?;
    /**
     * @stability stable
     */
    get defaultSshKeyName(): string;
    /**
     * @stability stable
     */
    set defaultSshKeyName(value: string);
    /**
     * @stability stable
     */
    resetDefaultSshKeyName(): void;
    /**
     * @stability stable
     */
    get defaultSshKeyNameInput(): string | undefined;
    private _defaultSubnetId?;
    /**
     * @stability stable
     */
    get defaultSubnetId(): string;
    /**
     * @stability stable
     */
    set defaultSubnetId(value: string);
    /**
     * @stability stable
     */
    resetDefaultSubnetId(): void;
    /**
     * @stability stable
     */
    get defaultSubnetIdInput(): string | undefined;
    private _hostnameTheme?;
    /**
     * @stability stable
     */
    get hostnameTheme(): string;
    /**
     * @stability stable
     */
    set hostnameTheme(value: string);
    /**
     * @stability stable
     */
    resetHostnameTheme(): void;
    /**
     * @stability stable
     */
    get hostnameThemeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _manageBerkshelf?;
    /**
     * @stability stable
     */
    get manageBerkshelf(): boolean;
    /**
     * @stability stable
     */
    set manageBerkshelf(value: boolean);
    /**
     * @stability stable
     */
    resetManageBerkshelf(): void;
    /**
     * @stability stable
     */
    get manageBerkshelfInput(): boolean | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _region;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    get regionInput(): string;
    private _serviceRoleArn;
    /**
     * @stability stable
     */
    get serviceRoleArn(): string;
    /**
     * @stability stable
     */
    set serviceRoleArn(value: string);
    /**
     * @stability stable
     */
    get serviceRoleArnInput(): string;
    /**
     * @stability stable
     */
    get stackEndpoint(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _useCustomCookbooks?;
    /**
     * @stability stable
     */
    get useCustomCookbooks(): boolean;
    /**
     * @stability stable
     */
    set useCustomCookbooks(value: boolean);
    /**
     * @stability stable
     */
    resetUseCustomCookbooks(): void;
    /**
     * @stability stable
     */
    get useCustomCookbooksInput(): boolean | undefined;
    private _useOpsworksSecurityGroups?;
    /**
     * @stability stable
     */
    get useOpsworksSecurityGroups(): boolean;
    /**
     * @stability stable
     */
    set useOpsworksSecurityGroups(value: boolean);
    /**
     * @stability stable
     */
    resetUseOpsworksSecurityGroups(): void;
    /**
     * @stability stable
     */
    get useOpsworksSecurityGroupsInput(): boolean | undefined;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    resetVpcId(): void;
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    private _customCookbooksSource?;
    /**
     * @stability stable
     */
    get customCookbooksSource(): OpsworksStackCustomCookbooksSource[];
    /**
     * @stability stable
     */
    set customCookbooksSource(value: OpsworksStackCustomCookbooksSource[]);
    /**
     * @stability stable
     */
    resetCustomCookbooksSource(): void;
    /**
     * @stability stable
     */
    get customCookbooksSourceInput(): OpsworksStackCustomCookbooksSource[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
