import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface OpsworksUserProfileConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly allowSelfManagement?: boolean;
    /**
     * @stability stable
     */
    readonly sshPublicKey?: string;
    /**
     * @stability stable
     */
    readonly sshUsername: string;
    /**
     * @stability stable
     */
    readonly userArn: string;
}
/**
 * @stability stable
 */
export declare class OpsworksUserProfile extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OpsworksUserProfileConfig);
    private _allowSelfManagement?;
    /**
     * @stability stable
     */
    get allowSelfManagement(): boolean;
    /**
     * @stability stable
     */
    set allowSelfManagement(value: boolean);
    /**
     * @stability stable
     */
    resetAllowSelfManagement(): void;
    /**
     * @stability stable
     */
    get allowSelfManagementInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _sshPublicKey?;
    /**
     * @stability stable
     */
    get sshPublicKey(): string;
    /**
     * @stability stable
     */
    set sshPublicKey(value: string);
    /**
     * @stability stable
     */
    resetSshPublicKey(): void;
    /**
     * @stability stable
     */
    get sshPublicKeyInput(): string | undefined;
    private _sshUsername;
    /**
     * @stability stable
     */
    get sshUsername(): string;
    /**
     * @stability stable
     */
    set sshUsername(value: string);
    /**
     * @stability stable
     */
    get sshUsernameInput(): string;
    private _userArn;
    /**
     * @stability stable
     */
    get userArn(): string;
    /**
     * @stability stable
     */
    set userArn(value: string);
    /**
     * @stability stable
     */
    get userArnInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
