import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface OrganizationsOrganizationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly awsServiceAccessPrincipals?: string[];
    /**
     * @stability stable
     */
    readonly enabledPolicyTypes?: string[];
    /**
     * @stability stable
     */
    readonly featureSet?: string;
}
/**
 * @stability stable
 */
export declare class OrganizationsOrganizationAccounts extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get email(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get status(): string;
}
/**
 * @stability stable
 */
export declare class OrganizationsOrganizationNonMasterAccounts extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get email(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get status(): string;
}
/**
 * @stability stable
 */
export declare class OrganizationsOrganizationRootsPolicyTypes extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    get type(): string;
}
/**
 * @stability stable
 */
export declare class OrganizationsOrganizationRoots extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get policyTypes(): any;
}
/**
 * @stability stable
 */
export declare class OrganizationsOrganization extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: OrganizationsOrganizationConfig);
    /**
     * @stability stable
     */
    accounts(index: string): OrganizationsOrganizationAccounts;
    /**
     * @stability stable
     */
    get arn(): string;
    private _awsServiceAccessPrincipals?;
    /**
     * @stability stable
     */
    get awsServiceAccessPrincipals(): string[];
    /**
     * @stability stable
     */
    set awsServiceAccessPrincipals(value: string[]);
    /**
     * @stability stable
     */
    resetAwsServiceAccessPrincipals(): void;
    /**
     * @stability stable
     */
    get awsServiceAccessPrincipalsInput(): string[] | undefined;
    private _enabledPolicyTypes?;
    /**
     * @stability stable
     */
    get enabledPolicyTypes(): string[];
    /**
     * @stability stable
     */
    set enabledPolicyTypes(value: string[]);
    /**
     * @stability stable
     */
    resetEnabledPolicyTypes(): void;
    /**
     * @stability stable
     */
    get enabledPolicyTypesInput(): string[] | undefined;
    private _featureSet?;
    /**
     * @stability stable
     */
    get featureSet(): string;
    /**
     * @stability stable
     */
    set featureSet(value: string);
    /**
     * @stability stable
     */
    resetFeatureSet(): void;
    /**
     * @stability stable
     */
    get featureSetInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get masterAccountArn(): string;
    /**
     * @stability stable
     */
    get masterAccountEmail(): string;
    /**
     * @stability stable
     */
    get masterAccountId(): string;
    /**
     * @stability stable
     */
    nonMasterAccounts(index: string): OrganizationsOrganizationNonMasterAccounts;
    /**
     * @stability stable
     */
    roots(index: string): OrganizationsOrganizationRoots;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
