import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface OrganizationsOrganizationalUnitConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly parentId: string;
}
/**
 * @stability stable
 */
export declare class OrganizationsOrganizationalUnitAccounts extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get email(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get name(): string;
}
/**
 * @stability stable
 */
export declare class OrganizationsOrganizationalUnit extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: OrganizationsOrganizationalUnitConfig);
    /**
     * @stability stable
     */
    accounts(index: string): OrganizationsOrganizationalUnitAccounts;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _parentId;
    /**
     * @stability stable
     */
    get parentId(): string;
    /**
     * @stability stable
     */
    set parentId(value: string);
    /**
     * @stability stable
     */
    get parentIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
