import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface PinpointApnsSandboxChannelConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly applicationId: string;
    /**
     * @stability stable
     */
    readonly bundleId?: string;
    /**
     * @stability stable
     */
    readonly certificate?: string;
    /**
     * @stability stable
     */
    readonly defaultAuthenticationMethod?: string;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly privateKey?: string;
    /**
     * @stability stable
     */
    readonly teamId?: string;
    /**
     * @stability stable
     */
    readonly tokenKey?: string;
    /**
     * @stability stable
     */
    readonly tokenKeyId?: string;
}
/**
 * @stability stable
 */
export declare class PinpointApnsSandboxChannel extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: PinpointApnsSandboxChannelConfig);
    private _applicationId;
    /**
     * @stability stable
     */
    get applicationId(): string;
    /**
     * @stability stable
     */
    set applicationId(value: string);
    /**
     * @stability stable
     */
    get applicationIdInput(): string;
    private _bundleId?;
    /**
     * @stability stable
     */
    get bundleId(): string;
    /**
     * @stability stable
     */
    set bundleId(value: string);
    /**
     * @stability stable
     */
    resetBundleId(): void;
    /**
     * @stability stable
     */
    get bundleIdInput(): string | undefined;
    private _certificate?;
    /**
     * @stability stable
     */
    get certificate(): string;
    /**
     * @stability stable
     */
    set certificate(value: string);
    /**
     * @stability stable
     */
    resetCertificate(): void;
    /**
     * @stability stable
     */
    get certificateInput(): string | undefined;
    private _defaultAuthenticationMethod?;
    /**
     * @stability stable
     */
    get defaultAuthenticationMethod(): string;
    /**
     * @stability stable
     */
    set defaultAuthenticationMethod(value: string);
    /**
     * @stability stable
     */
    resetDefaultAuthenticationMethod(): void;
    /**
     * @stability stable
     */
    get defaultAuthenticationMethodInput(): string | undefined;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _privateKey?;
    /**
     * @stability stable
     */
    get privateKey(): string;
    /**
     * @stability stable
     */
    set privateKey(value: string);
    /**
     * @stability stable
     */
    resetPrivateKey(): void;
    /**
     * @stability stable
     */
    get privateKeyInput(): string | undefined;
    private _teamId?;
    /**
     * @stability stable
     */
    get teamId(): string;
    /**
     * @stability stable
     */
    set teamId(value: string);
    /**
     * @stability stable
     */
    resetTeamId(): void;
    /**
     * @stability stable
     */
    get teamIdInput(): string | undefined;
    private _tokenKey?;
    /**
     * @stability stable
     */
    get tokenKey(): string;
    /**
     * @stability stable
     */
    set tokenKey(value: string);
    /**
     * @stability stable
     */
    resetTokenKey(): void;
    /**
     * @stability stable
     */
    get tokenKeyInput(): string | undefined;
    private _tokenKeyId?;
    /**
     * @stability stable
     */
    get tokenKeyId(): string;
    /**
     * @stability stable
     */
    set tokenKeyId(value: string);
    /**
     * @stability stable
     */
    resetTokenKeyId(): void;
    /**
     * @stability stable
     */
    get tokenKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
