import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface PinpointAppConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * campaign_hook block.
     *
     * @stability stable
     */
    readonly campaignHook?: PinpointAppCampaignHook[];
    /**
     * limits block.
     *
     * @stability stable
     */
    readonly limits?: PinpointAppLimits[];
    /**
     * quiet_time block.
     *
     * @stability stable
     */
    readonly quietTime?: PinpointAppQuietTime[];
}
/**
 * @stability stable
 */
export interface PinpointAppCampaignHook {
    /**
     * @stability stable
     */
    readonly lambdaFunctionName?: string;
    /**
     * @stability stable
     */
    readonly mode?: string;
    /**
     * @stability stable
     */
    readonly webUrl?: string;
}
/**
 * @stability stable
 */
export interface PinpointAppLimits {
    /**
     * @stability stable
     */
    readonly daily?: number;
    /**
     * @stability stable
     */
    readonly maximumDuration?: number;
    /**
     * @stability stable
     */
    readonly messagesPerSecond?: number;
    /**
     * @stability stable
     */
    readonly total?: number;
}
/**
 * @stability stable
 */
export interface PinpointAppQuietTime {
    /**
     * @stability stable
     */
    readonly end?: string;
    /**
     * @stability stable
     */
    readonly start?: string;
}
/**
 * @stability stable
 */
export declare class PinpointApp extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: PinpointAppConfig);
    /**
     * @stability stable
     */
    get applicationId(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _campaignHook?;
    /**
     * @stability stable
     */
    get campaignHook(): PinpointAppCampaignHook[];
    /**
     * @stability stable
     */
    set campaignHook(value: PinpointAppCampaignHook[]);
    /**
     * @stability stable
     */
    resetCampaignHook(): void;
    /**
     * @stability stable
     */
    get campaignHookInput(): PinpointAppCampaignHook[] | undefined;
    private _limits?;
    /**
     * @stability stable
     */
    get limits(): PinpointAppLimits[];
    /**
     * @stability stable
     */
    set limits(value: PinpointAppLimits[]);
    /**
     * @stability stable
     */
    resetLimits(): void;
    /**
     * @stability stable
     */
    get limitsInput(): PinpointAppLimits[] | undefined;
    private _quietTime?;
    /**
     * @stability stable
     */
    get quietTime(): PinpointAppQuietTime[];
    /**
     * @stability stable
     */
    set quietTime(value: PinpointAppQuietTime[]);
    /**
     * @stability stable
     */
    resetQuietTime(): void;
    /**
     * @stability stable
     */
    get quietTimeInput(): PinpointAppQuietTime[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
