import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface PinpointBaiduChannelConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly apiKey: string;
    /**
     * @stability stable
     */
    readonly applicationId: string;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly secretKey: string;
}
/**
 * @stability stable
 */
export declare class PinpointBaiduChannel extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: PinpointBaiduChannelConfig);
    private _apiKey;
    /**
     * @stability stable
     */
    get apiKey(): string;
    /**
     * @stability stable
     */
    set apiKey(value: string);
    /**
     * @stability stable
     */
    get apiKeyInput(): string;
    private _applicationId;
    /**
     * @stability stable
     */
    get applicationId(): string;
    /**
     * @stability stable
     */
    set applicationId(value: string);
    /**
     * @stability stable
     */
    get applicationIdInput(): string;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _secretKey;
    /**
     * @stability stable
     */
    get secretKey(): string;
    /**
     * @stability stable
     */
    set secretKey(value: string);
    /**
     * @stability stable
     */
    get secretKeyInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
