import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface PinpointSmsChannelConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly applicationId: string;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly senderId?: string;
    /**
     * @stability stable
     */
    readonly shortCode?: string;
}
/**
 * @stability stable
 */
export declare class PinpointSmsChannel extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: PinpointSmsChannelConfig);
    private _applicationId;
    /**
     * @stability stable
     */
    get applicationId(): string;
    /**
     * @stability stable
     */
    set applicationId(value: string);
    /**
     * @stability stable
     */
    get applicationIdInput(): string;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get promotionalMessagesPerSecond(): number;
    private _senderId?;
    /**
     * @stability stable
     */
    get senderId(): string;
    /**
     * @stability stable
     */
    set senderId(value: string);
    /**
     * @stability stable
     */
    resetSenderId(): void;
    /**
     * @stability stable
     */
    get senderIdInput(): string | undefined;
    private _shortCode?;
    /**
     * @stability stable
     */
    get shortCode(): string;
    /**
     * @stability stable
     */
    set shortCode(value: string);
    /**
     * @stability stable
     */
    resetShortCode(): void;
    /**
     * @stability stable
     */
    get shortCodeInput(): string | undefined;
    /**
     * @stability stable
     */
    get transactionalMessagesPerSecond(): number;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
