import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface QuicksightGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly awsAccountId?: string;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly groupName: string;
    /**
     * @stability stable
     */
    readonly namespace?: string;
}
/**
 * @stability stable
 */
export declare class QuicksightGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: QuicksightGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _awsAccountId?;
    /**
     * @stability stable
     */
    get awsAccountId(): string;
    /**
     * @stability stable
     */
    set awsAccountId(value: string);
    /**
     * @stability stable
     */
    resetAwsAccountId(): void;
    /**
     * @stability stable
     */
    get awsAccountIdInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _groupName;
    /**
     * @stability stable
     */
    get groupName(): string;
    /**
     * @stability stable
     */
    set groupName(value: string);
    /**
     * @stability stable
     */
    get groupNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _namespace?;
    /**
     * @stability stable
     */
    get namespace(): string;
    /**
     * @stability stable
     */
    set namespace(value: string);
    /**
     * @stability stable
     */
    resetNamespace(): void;
    /**
     * @stability stable
     */
    get namespaceInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
