import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface QuicksightUserConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly awsAccountId?: string;
    /**
     * @stability stable
     */
    readonly email: string;
    /**
     * @stability stable
     */
    readonly iamArn?: string;
    /**
     * @stability stable
     */
    readonly identityType: string;
    /**
     * @stability stable
     */
    readonly namespace?: string;
    /**
     * @stability stable
     */
    readonly sessionName?: string;
    /**
     * @stability stable
     */
    readonly userName?: string;
    /**
     * @stability stable
     */
    readonly userRole: string;
}
/**
 * @stability stable
 */
export declare class QuicksightUser extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: QuicksightUserConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _awsAccountId?;
    /**
     * @stability stable
     */
    get awsAccountId(): string;
    /**
     * @stability stable
     */
    set awsAccountId(value: string);
    /**
     * @stability stable
     */
    resetAwsAccountId(): void;
    /**
     * @stability stable
     */
    get awsAccountIdInput(): string | undefined;
    private _email;
    /**
     * @stability stable
     */
    get email(): string;
    /**
     * @stability stable
     */
    set email(value: string);
    /**
     * @stability stable
     */
    get emailInput(): string;
    private _iamArn?;
    /**
     * @stability stable
     */
    get iamArn(): string;
    /**
     * @stability stable
     */
    set iamArn(value: string);
    /**
     * @stability stable
     */
    resetIamArn(): void;
    /**
     * @stability stable
     */
    get iamArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _identityType;
    /**
     * @stability stable
     */
    get identityType(): string;
    /**
     * @stability stable
     */
    set identityType(value: string);
    /**
     * @stability stable
     */
    get identityTypeInput(): string;
    private _namespace?;
    /**
     * @stability stable
     */
    get namespace(): string;
    /**
     * @stability stable
     */
    set namespace(value: string);
    /**
     * @stability stable
     */
    resetNamespace(): void;
    /**
     * @stability stable
     */
    get namespaceInput(): string | undefined;
    private _sessionName?;
    /**
     * @stability stable
     */
    get sessionName(): string;
    /**
     * @stability stable
     */
    set sessionName(value: string);
    /**
     * @stability stable
     */
    resetSessionName(): void;
    /**
     * @stability stable
     */
    get sessionNameInput(): string | undefined;
    private _userName?;
    /**
     * @stability stable
     */
    get userName(): string;
    /**
     * @stability stable
     */
    set userName(value: string);
    /**
     * @stability stable
     */
    resetUserName(): void;
    /**
     * @stability stable
     */
    get userNameInput(): string | undefined;
    private _userRole;
    /**
     * @stability stable
     */
    get userRole(): string;
    /**
     * @stability stable
     */
    set userRole(value: string);
    /**
     * @stability stable
     */
    get userRoleInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
