import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface RamResourceShareAccepterConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly shareArn: string;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: RamResourceShareAccepterTimeouts;
}
/**
 * @stability stable
 */
export interface RamResourceShareAccepterTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export declare class RamResourceShareAccepter extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: RamResourceShareAccepterConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get invitationArn(): string;
    /**
     * @stability stable
     */
    get receiverAccountId(): string;
    /**
     * @stability stable
     */
    get resources(): string[];
    /**
     * @stability stable
     */
    get senderAccountId(): string;
    private _shareArn;
    /**
     * @stability stable
     */
    get shareArn(): string;
    /**
     * @stability stable
     */
    set shareArn(value: string);
    /**
     * @stability stable
     */
    get shareArnInput(): string;
    /**
     * @stability stable
     */
    get shareId(): string;
    /**
     * @stability stable
     */
    get shareName(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): RamResourceShareAccepterTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: RamResourceShareAccepterTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): RamResourceShareAccepterTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
