import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface RdsClusterEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly clusterEndpointIdentifier: string;
    /**
     * @stability stable
     */
    readonly clusterIdentifier: string;
    /**
     * @stability stable
     */
    readonly customEndpointType: string;
    /**
     * @stability stable
     */
    readonly excludedMembers?: string[];
    /**
     * @stability stable
     */
    readonly staticMembers?: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class RdsClusterEndpoint extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: RdsClusterEndpointConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _clusterEndpointIdentifier;
    /**
     * @stability stable
     */
    get clusterEndpointIdentifier(): string;
    /**
     * @stability stable
     */
    set clusterEndpointIdentifier(value: string);
    /**
     * @stability stable
     */
    get clusterEndpointIdentifierInput(): string;
    private _clusterIdentifier;
    /**
     * @stability stable
     */
    get clusterIdentifier(): string;
    /**
     * @stability stable
     */
    set clusterIdentifier(value: string);
    /**
     * @stability stable
     */
    get clusterIdentifierInput(): string;
    private _customEndpointType;
    /**
     * @stability stable
     */
    get customEndpointType(): string;
    /**
     * @stability stable
     */
    set customEndpointType(value: string);
    /**
     * @stability stable
     */
    get customEndpointTypeInput(): string;
    /**
     * @stability stable
     */
    get endpoint(): string;
    private _excludedMembers?;
    /**
     * @stability stable
     */
    get excludedMembers(): string[];
    /**
     * @stability stable
     */
    set excludedMembers(value: string[]);
    /**
     * @stability stable
     */
    resetExcludedMembers(): void;
    /**
     * @stability stable
     */
    get excludedMembersInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _staticMembers?;
    /**
     * @stability stable
     */
    get staticMembers(): string[];
    /**
     * @stability stable
     */
    set staticMembers(value: string[]);
    /**
     * @stability stable
     */
    resetStaticMembers(): void;
    /**
     * @stability stable
     */
    get staticMembersInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
