import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface RdsGlobalClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly databaseName?: string;
    /**
     * @stability stable
     */
    readonly deletionProtection?: boolean;
    /**
     * @stability stable
     */
    readonly engine?: string;
    /**
     * @stability stable
     */
    readonly engineVersion?: string;
    /**
     * @stability stable
     */
    readonly forceDestroy?: boolean;
    /**
     * @stability stable
     */
    readonly globalClusterIdentifier: string;
    /**
     * @stability stable
     */
    readonly sourceDbClusterIdentifier?: string;
    /**
     * @stability stable
     */
    readonly storageEncrypted?: boolean;
}
/**
 * @stability stable
 */
export declare class RdsGlobalClusterGlobalClusterMembers extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get dbClusterArn(): string;
    /**
     * @stability stable
     */
    get isWriter(): boolean;
}
/**
 * @stability stable
 */
export declare class RdsGlobalCluster extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: RdsGlobalClusterConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _databaseName?;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    resetDatabaseName(): void;
    /**
     * @stability stable
     */
    get databaseNameInput(): string | undefined;
    private _deletionProtection?;
    /**
     * @stability stable
     */
    get deletionProtection(): boolean;
    /**
     * @stability stable
     */
    set deletionProtection(value: boolean);
    /**
     * @stability stable
     */
    resetDeletionProtection(): void;
    /**
     * @stability stable
     */
    get deletionProtectionInput(): boolean | undefined;
    private _engine?;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    resetEngine(): void;
    /**
     * @stability stable
     */
    get engineInput(): string | undefined;
    private _engineVersion?;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    set engineVersion(value: string);
    /**
     * @stability stable
     */
    resetEngineVersion(): void;
    /**
     * @stability stable
     */
    get engineVersionInput(): string | undefined;
    private _forceDestroy?;
    /**
     * @stability stable
     */
    get forceDestroy(): boolean;
    /**
     * @stability stable
     */
    set forceDestroy(value: boolean);
    /**
     * @stability stable
     */
    resetForceDestroy(): void;
    /**
     * @stability stable
     */
    get forceDestroyInput(): boolean | undefined;
    private _globalClusterIdentifier;
    /**
     * @stability stable
     */
    get globalClusterIdentifier(): string;
    /**
     * @stability stable
     */
    set globalClusterIdentifier(value: string);
    /**
     * @stability stable
     */
    get globalClusterIdentifierInput(): string;
    /**
     * @stability stable
     */
    globalClusterMembers(index: string): RdsGlobalClusterGlobalClusterMembers;
    /**
     * @stability stable
     */
    get globalClusterResourceId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _sourceDbClusterIdentifier?;
    /**
     * @stability stable
     */
    get sourceDbClusterIdentifier(): string;
    /**
     * @stability stable
     */
    set sourceDbClusterIdentifier(value: string);
    /**
     * @stability stable
     */
    resetSourceDbClusterIdentifier(): void;
    /**
     * @stability stable
     */
    get sourceDbClusterIdentifierInput(): string | undefined;
    private _storageEncrypted?;
    /**
     * @stability stable
     */
    get storageEncrypted(): boolean;
    /**
     * @stability stable
     */
    set storageEncrypted(value: boolean);
    /**
     * @stability stable
     */
    resetStorageEncrypted(): void;
    /**
     * @stability stable
     */
    get storageEncryptedInput(): boolean | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
