import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface RedshiftClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly allowVersionUpgrade?: boolean;
    /**
     * @stability stable
     */
    readonly automatedSnapshotRetentionPeriod?: number;
    /**
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * @stability stable
     */
    readonly clusterIdentifier: string;
    /**
     * @stability stable
     */
    readonly clusterParameterGroupName?: string;
    /**
     * @stability stable
     */
    readonly clusterPublicKey?: string;
    /**
     * @stability stable
     */
    readonly clusterRevisionNumber?: string;
    /**
     * @stability stable
     */
    readonly clusterSecurityGroups?: string[];
    /**
     * @stability stable
     */
    readonly clusterSubnetGroupName?: string;
    /**
     * @stability stable
     */
    readonly clusterType?: string;
    /**
     * @stability stable
     */
    readonly clusterVersion?: string;
    /**
     * @stability stable
     */
    readonly databaseName?: string;
    /**
     * @stability stable
     */
    readonly elasticIp?: string;
    /**
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * @stability stable
     */
    readonly endpoint?: string;
    /**
     * @stability stable
     */
    readonly enhancedVpcRouting?: boolean;
    /**
     * @stability stable
     */
    readonly finalSnapshotIdentifier?: string;
    /**
     * @stability stable
     */
    readonly iamRoles?: string[];
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly masterPassword?: string;
    /**
     * @stability stable
     */
    readonly masterUsername?: string;
    /**
     * @stability stable
     */
    readonly nodeType: string;
    /**
     * @stability stable
     */
    readonly numberOfNodes?: number;
    /**
     * @stability stable
     */
    readonly ownerAccount?: string;
    /**
     * @stability stable
     */
    readonly port?: number;
    /**
     * @stability stable
     */
    readonly preferredMaintenanceWindow?: string;
    /**
     * @stability stable
     */
    readonly publiclyAccessible?: boolean;
    /**
     * @stability stable
     */
    readonly skipFinalSnapshot?: boolean;
    /**
     * @stability stable
     */
    readonly snapshotClusterIdentifier?: string;
    /**
     * @stability stable
     */
    readonly snapshotIdentifier?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcSecurityGroupIds?: string[];
    /**
     * logging block.
     *
     * @stability stable
     */
    readonly logging?: RedshiftClusterLogging[];
    /**
     * snapshot_copy block.
     *
     * @stability stable
     */
    readonly snapshotCopy?: RedshiftClusterSnapshotCopy[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: RedshiftClusterTimeouts;
}
/**
 * @stability stable
 */
export interface RedshiftClusterLogging {
    /**
     * @stability stable
     */
    readonly bucketName?: string;
    /**
     * @stability stable
     */
    readonly enable: boolean;
    /**
     * @stability stable
     */
    readonly s3KeyPrefix?: string;
}
/**
 * @stability stable
 */
export interface RedshiftClusterSnapshotCopy {
    /**
     * @stability stable
     */
    readonly destinationRegion: string;
    /**
     * @stability stable
     */
    readonly grantName?: string;
    /**
     * @stability stable
     */
    readonly retentionPeriod?: number;
}
/**
 * @stability stable
 */
export interface RedshiftClusterTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class RedshiftCluster extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: RedshiftClusterConfig);
    private _allowVersionUpgrade?;
    /**
     * @stability stable
     */
    get allowVersionUpgrade(): boolean;
    /**
     * @stability stable
     */
    set allowVersionUpgrade(value: boolean);
    /**
     * @stability stable
     */
    resetAllowVersionUpgrade(): void;
    /**
     * @stability stable
     */
    get allowVersionUpgradeInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _automatedSnapshotRetentionPeriod?;
    /**
     * @stability stable
     */
    get automatedSnapshotRetentionPeriod(): number;
    /**
     * @stability stable
     */
    set automatedSnapshotRetentionPeriod(value: number);
    /**
     * @stability stable
     */
    resetAutomatedSnapshotRetentionPeriod(): void;
    /**
     * @stability stable
     */
    get automatedSnapshotRetentionPeriodInput(): number | undefined;
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    private _clusterIdentifier;
    /**
     * @stability stable
     */
    get clusterIdentifier(): string;
    /**
     * @stability stable
     */
    set clusterIdentifier(value: string);
    /**
     * @stability stable
     */
    get clusterIdentifierInput(): string;
    private _clusterParameterGroupName?;
    /**
     * @stability stable
     */
    get clusterParameterGroupName(): string;
    /**
     * @stability stable
     */
    set clusterParameterGroupName(value: string);
    /**
     * @stability stable
     */
    resetClusterParameterGroupName(): void;
    /**
     * @stability stable
     */
    get clusterParameterGroupNameInput(): string | undefined;
    private _clusterPublicKey?;
    /**
     * @stability stable
     */
    get clusterPublicKey(): string;
    /**
     * @stability stable
     */
    set clusterPublicKey(value: string);
    /**
     * @stability stable
     */
    resetClusterPublicKey(): void;
    /**
     * @stability stable
     */
    get clusterPublicKeyInput(): string | undefined;
    private _clusterRevisionNumber?;
    /**
     * @stability stable
     */
    get clusterRevisionNumber(): string;
    /**
     * @stability stable
     */
    set clusterRevisionNumber(value: string);
    /**
     * @stability stable
     */
    resetClusterRevisionNumber(): void;
    /**
     * @stability stable
     */
    get clusterRevisionNumberInput(): string | undefined;
    private _clusterSecurityGroups?;
    /**
     * @stability stable
     */
    get clusterSecurityGroups(): string[];
    /**
     * @stability stable
     */
    set clusterSecurityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetClusterSecurityGroups(): void;
    /**
     * @stability stable
     */
    get clusterSecurityGroupsInput(): string[] | undefined;
    private _clusterSubnetGroupName?;
    /**
     * @stability stable
     */
    get clusterSubnetGroupName(): string;
    /**
     * @stability stable
     */
    set clusterSubnetGroupName(value: string);
    /**
     * @stability stable
     */
    resetClusterSubnetGroupName(): void;
    /**
     * @stability stable
     */
    get clusterSubnetGroupNameInput(): string | undefined;
    private _clusterType?;
    /**
     * @stability stable
     */
    get clusterType(): string;
    /**
     * @stability stable
     */
    set clusterType(value: string);
    /**
     * @stability stable
     */
    resetClusterType(): void;
    /**
     * @stability stable
     */
    get clusterTypeInput(): string | undefined;
    private _clusterVersion?;
    /**
     * @stability stable
     */
    get clusterVersion(): string;
    /**
     * @stability stable
     */
    set clusterVersion(value: string);
    /**
     * @stability stable
     */
    resetClusterVersion(): void;
    /**
     * @stability stable
     */
    get clusterVersionInput(): string | undefined;
    private _databaseName?;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    resetDatabaseName(): void;
    /**
     * @stability stable
     */
    get databaseNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get dnsName(): string;
    private _elasticIp?;
    /**
     * @stability stable
     */
    get elasticIp(): string;
    /**
     * @stability stable
     */
    set elasticIp(value: string);
    /**
     * @stability stable
     */
    resetElasticIp(): void;
    /**
     * @stability stable
     */
    get elasticIpInput(): string | undefined;
    private _encrypted?;
    /**
     * @stability stable
     */
    get encrypted(): boolean;
    /**
     * @stability stable
     */
    set encrypted(value: boolean);
    /**
     * @stability stable
     */
    resetEncrypted(): void;
    /**
     * @stability stable
     */
    get encryptedInput(): boolean | undefined;
    private _endpoint?;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    set endpoint(value: string);
    /**
     * @stability stable
     */
    resetEndpoint(): void;
    /**
     * @stability stable
     */
    get endpointInput(): string | undefined;
    private _enhancedVpcRouting?;
    /**
     * @stability stable
     */
    get enhancedVpcRouting(): boolean;
    /**
     * @stability stable
     */
    set enhancedVpcRouting(value: boolean);
    /**
     * @stability stable
     */
    resetEnhancedVpcRouting(): void;
    /**
     * @stability stable
     */
    get enhancedVpcRoutingInput(): boolean | undefined;
    private _finalSnapshotIdentifier?;
    /**
     * @stability stable
     */
    get finalSnapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set finalSnapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    resetFinalSnapshotIdentifier(): void;
    /**
     * @stability stable
     */
    get finalSnapshotIdentifierInput(): string | undefined;
    private _iamRoles?;
    /**
     * @stability stable
     */
    get iamRoles(): string[];
    /**
     * @stability stable
     */
    set iamRoles(value: string[]);
    /**
     * @stability stable
     */
    resetIamRoles(): void;
    /**
     * @stability stable
     */
    get iamRolesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    private _masterPassword?;
    /**
     * @stability stable
     */
    get masterPassword(): string;
    /**
     * @stability stable
     */
    set masterPassword(value: string);
    /**
     * @stability stable
     */
    resetMasterPassword(): void;
    /**
     * @stability stable
     */
    get masterPasswordInput(): string | undefined;
    private _masterUsername?;
    /**
     * @stability stable
     */
    get masterUsername(): string;
    /**
     * @stability stable
     */
    set masterUsername(value: string);
    /**
     * @stability stable
     */
    resetMasterUsername(): void;
    /**
     * @stability stable
     */
    get masterUsernameInput(): string | undefined;
    private _nodeType;
    /**
     * @stability stable
     */
    get nodeType(): string;
    /**
     * @stability stable
     */
    set nodeType(value: string);
    /**
     * @stability stable
     */
    get nodeTypeInput(): string;
    private _numberOfNodes?;
    /**
     * @stability stable
     */
    get numberOfNodes(): number;
    /**
     * @stability stable
     */
    set numberOfNodes(value: number);
    /**
     * @stability stable
     */
    resetNumberOfNodes(): void;
    /**
     * @stability stable
     */
    get numberOfNodesInput(): number | undefined;
    private _ownerAccount?;
    /**
     * @stability stable
     */
    get ownerAccount(): string;
    /**
     * @stability stable
     */
    set ownerAccount(value: string);
    /**
     * @stability stable
     */
    resetOwnerAccount(): void;
    /**
     * @stability stable
     */
    get ownerAccountInput(): string | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    private _preferredMaintenanceWindow?;
    /**
     * @stability stable
     */
    get preferredMaintenanceWindow(): string;
    /**
     * @stability stable
     */
    set preferredMaintenanceWindow(value: string);
    /**
     * @stability stable
     */
    resetPreferredMaintenanceWindow(): void;
    /**
     * @stability stable
     */
    get preferredMaintenanceWindowInput(): string | undefined;
    private _publiclyAccessible?;
    /**
     * @stability stable
     */
    get publiclyAccessible(): boolean;
    /**
     * @stability stable
     */
    set publiclyAccessible(value: boolean);
    /**
     * @stability stable
     */
    resetPubliclyAccessible(): void;
    /**
     * @stability stable
     */
    get publiclyAccessibleInput(): boolean | undefined;
    private _skipFinalSnapshot?;
    /**
     * @stability stable
     */
    get skipFinalSnapshot(): boolean;
    /**
     * @stability stable
     */
    set skipFinalSnapshot(value: boolean);
    /**
     * @stability stable
     */
    resetSkipFinalSnapshot(): void;
    /**
     * @stability stable
     */
    get skipFinalSnapshotInput(): boolean | undefined;
    private _snapshotClusterIdentifier?;
    /**
     * @stability stable
     */
    get snapshotClusterIdentifier(): string;
    /**
     * @stability stable
     */
    set snapshotClusterIdentifier(value: string);
    /**
     * @stability stable
     */
    resetSnapshotClusterIdentifier(): void;
    /**
     * @stability stable
     */
    get snapshotClusterIdentifierInput(): string | undefined;
    private _snapshotIdentifier?;
    /**
     * @stability stable
     */
    get snapshotIdentifier(): string;
    /**
     * @stability stable
     */
    set snapshotIdentifier(value: string);
    /**
     * @stability stable
     */
    resetSnapshotIdentifier(): void;
    /**
     * @stability stable
     */
    get snapshotIdentifierInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcSecurityGroupIds?;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set vpcSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetVpcSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIdsInput(): string[] | undefined;
    private _logging?;
    /**
     * @stability stable
     */
    get logging(): RedshiftClusterLogging[];
    /**
     * @stability stable
     */
    set logging(value: RedshiftClusterLogging[]);
    /**
     * @stability stable
     */
    resetLogging(): void;
    /**
     * @stability stable
     */
    get loggingInput(): RedshiftClusterLogging[] | undefined;
    private _snapshotCopy?;
    /**
     * @stability stable
     */
    get snapshotCopy(): RedshiftClusterSnapshotCopy[];
    /**
     * @stability stable
     */
    set snapshotCopy(value: RedshiftClusterSnapshotCopy[]);
    /**
     * @stability stable
     */
    resetSnapshotCopy(): void;
    /**
     * @stability stable
     */
    get snapshotCopyInput(): RedshiftClusterSnapshotCopy[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): RedshiftClusterTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: RedshiftClusterTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): RedshiftClusterTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
