import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface RouteTableConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly propagatingVgws?: string[];
    /**
     * @stability stable
     */
    readonly route?: RouteTableRoute[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcId: string;
}
/**
 * @stability stable
 */
export interface RouteTableRoute {
    /**
     * @stability stable
     */
    readonly cidrBlock?: string;
    /**
     * @stability stable
     */
    readonly egressOnlyGatewayId?: string;
    /**
     * @stability stable
     */
    readonly gatewayId?: string;
    /**
     * @stability stable
     */
    readonly instanceId?: string;
    /**
     * @stability stable
     */
    readonly ipv6CidrBlock?: string;
    /**
     * @stability stable
     */
    readonly localGatewayId?: string;
    /**
     * @stability stable
     */
    readonly natGatewayId?: string;
    /**
     * @stability stable
     */
    readonly networkInterfaceId?: string;
    /**
     * @stability stable
     */
    readonly transitGatewayId?: string;
    /**
     * @stability stable
     */
    readonly vpcEndpointId?: string;
    /**
     * @stability stable
     */
    readonly vpcPeeringConnectionId?: string;
}
/**
 * @stability stable
 */
export declare class RouteTable extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: RouteTableConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _propagatingVgws?;
    /**
     * @stability stable
     */
    get propagatingVgws(): string[];
    /**
     * @stability stable
     */
    set propagatingVgws(value: string[]);
    /**
     * @stability stable
     */
    resetPropagatingVgws(): void;
    /**
     * @stability stable
     */
    get propagatingVgwsInput(): string[] | undefined;
    private _route?;
    /**
     * @stability stable
     */
    get route(): RouteTableRoute[];
    /**
     * @stability stable
     */
    set route(value: RouteTableRoute[]);
    /**
     * @stability stable
     */
    resetRoute(): void;
    /**
     * @stability stable
     */
    get routeInput(): RouteTableRoute[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcId;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
