import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Route53HealthCheckConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly childHealthThreshold?: number;
    /**
     * @stability stable
     */
    readonly childHealthchecks?: string[];
    /**
     * @stability stable
     */
    readonly cloudwatchAlarmName?: string;
    /**
     * @stability stable
     */
    readonly cloudwatchAlarmRegion?: string;
    /**
     * @stability stable
     */
    readonly disabled?: boolean;
    /**
     * @stability stable
     */
    readonly enableSni?: boolean;
    /**
     * @stability stable
     */
    readonly failureThreshold?: number;
    /**
     * @stability stable
     */
    readonly fqdn?: string;
    /**
     * @stability stable
     */
    readonly insufficientDataHealthStatus?: string;
    /**
     * @stability stable
     */
    readonly invertHealthcheck?: boolean;
    /**
     * @stability stable
     */
    readonly ipAddress?: string;
    /**
     * @stability stable
     */
    readonly measureLatency?: boolean;
    /**
     * @stability stable
     */
    readonly port?: number;
    /**
     * @stability stable
     */
    readonly referenceName?: string;
    /**
     * @stability stable
     */
    readonly regions?: string[];
    /**
     * @stability stable
     */
    readonly requestInterval?: number;
    /**
     * @stability stable
     */
    readonly resourcePath?: string;
    /**
     * @stability stable
     */
    readonly searchString?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export declare class Route53HealthCheck extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53HealthCheckConfig);
    private _childHealthThreshold?;
    /**
     * @stability stable
     */
    get childHealthThreshold(): number;
    /**
     * @stability stable
     */
    set childHealthThreshold(value: number);
    /**
     * @stability stable
     */
    resetChildHealthThreshold(): void;
    /**
     * @stability stable
     */
    get childHealthThresholdInput(): number | undefined;
    private _childHealthchecks?;
    /**
     * @stability stable
     */
    get childHealthchecks(): string[];
    /**
     * @stability stable
     */
    set childHealthchecks(value: string[]);
    /**
     * @stability stable
     */
    resetChildHealthchecks(): void;
    /**
     * @stability stable
     */
    get childHealthchecksInput(): string[] | undefined;
    private _cloudwatchAlarmName?;
    /**
     * @stability stable
     */
    get cloudwatchAlarmName(): string;
    /**
     * @stability stable
     */
    set cloudwatchAlarmName(value: string);
    /**
     * @stability stable
     */
    resetCloudwatchAlarmName(): void;
    /**
     * @stability stable
     */
    get cloudwatchAlarmNameInput(): string | undefined;
    private _cloudwatchAlarmRegion?;
    /**
     * @stability stable
     */
    get cloudwatchAlarmRegion(): string;
    /**
     * @stability stable
     */
    set cloudwatchAlarmRegion(value: string);
    /**
     * @stability stable
     */
    resetCloudwatchAlarmRegion(): void;
    /**
     * @stability stable
     */
    get cloudwatchAlarmRegionInput(): string | undefined;
    private _disabled?;
    /**
     * @stability stable
     */
    get disabled(): boolean;
    /**
     * @stability stable
     */
    set disabled(value: boolean);
    /**
     * @stability stable
     */
    resetDisabled(): void;
    /**
     * @stability stable
     */
    get disabledInput(): boolean | undefined;
    private _enableSni?;
    /**
     * @stability stable
     */
    get enableSni(): boolean;
    /**
     * @stability stable
     */
    set enableSni(value: boolean);
    /**
     * @stability stable
     */
    resetEnableSni(): void;
    /**
     * @stability stable
     */
    get enableSniInput(): boolean | undefined;
    private _failureThreshold?;
    /**
     * @stability stable
     */
    get failureThreshold(): number;
    /**
     * @stability stable
     */
    set failureThreshold(value: number);
    /**
     * @stability stable
     */
    resetFailureThreshold(): void;
    /**
     * @stability stable
     */
    get failureThresholdInput(): number | undefined;
    private _fqdn?;
    /**
     * @stability stable
     */
    get fqdn(): string;
    /**
     * @stability stable
     */
    set fqdn(value: string);
    /**
     * @stability stable
     */
    resetFqdn(): void;
    /**
     * @stability stable
     */
    get fqdnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _insufficientDataHealthStatus?;
    /**
     * @stability stable
     */
    get insufficientDataHealthStatus(): string;
    /**
     * @stability stable
     */
    set insufficientDataHealthStatus(value: string);
    /**
     * @stability stable
     */
    resetInsufficientDataHealthStatus(): void;
    /**
     * @stability stable
     */
    get insufficientDataHealthStatusInput(): string | undefined;
    private _invertHealthcheck?;
    /**
     * @stability stable
     */
    get invertHealthcheck(): boolean;
    /**
     * @stability stable
     */
    set invertHealthcheck(value: boolean);
    /**
     * @stability stable
     */
    resetInvertHealthcheck(): void;
    /**
     * @stability stable
     */
    get invertHealthcheckInput(): boolean | undefined;
    private _ipAddress?;
    /**
     * @stability stable
     */
    get ipAddress(): string;
    /**
     * @stability stable
     */
    set ipAddress(value: string);
    /**
     * @stability stable
     */
    resetIpAddress(): void;
    /**
     * @stability stable
     */
    get ipAddressInput(): string | undefined;
    private _measureLatency?;
    /**
     * @stability stable
     */
    get measureLatency(): boolean;
    /**
     * @stability stable
     */
    set measureLatency(value: boolean);
    /**
     * @stability stable
     */
    resetMeasureLatency(): void;
    /**
     * @stability stable
     */
    get measureLatencyInput(): boolean | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    private _referenceName?;
    /**
     * @stability stable
     */
    get referenceName(): string;
    /**
     * @stability stable
     */
    set referenceName(value: string);
    /**
     * @stability stable
     */
    resetReferenceName(): void;
    /**
     * @stability stable
     */
    get referenceNameInput(): string | undefined;
    private _regions?;
    /**
     * @stability stable
     */
    get regions(): string[];
    /**
     * @stability stable
     */
    set regions(value: string[]);
    /**
     * @stability stable
     */
    resetRegions(): void;
    /**
     * @stability stable
     */
    get regionsInput(): string[] | undefined;
    private _requestInterval?;
    /**
     * @stability stable
     */
    get requestInterval(): number;
    /**
     * @stability stable
     */
    set requestInterval(value: number);
    /**
     * @stability stable
     */
    resetRequestInterval(): void;
    /**
     * @stability stable
     */
    get requestIntervalInput(): number | undefined;
    private _resourcePath?;
    /**
     * @stability stable
     */
    get resourcePath(): string;
    /**
     * @stability stable
     */
    set resourcePath(value: string);
    /**
     * @stability stable
     */
    resetResourcePath(): void;
    /**
     * @stability stable
     */
    get resourcePathInput(): string | undefined;
    private _searchString?;
    /**
     * @stability stable
     */
    get searchString(): string;
    /**
     * @stability stable
     */
    set searchString(value: string);
    /**
     * @stability stable
     */
    resetSearchString(): void;
    /**
     * @stability stable
     */
    get searchStringInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
