import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Route53HostedZoneDnssecConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly hostedZoneId: string;
    /**
     * @stability stable
     */
    readonly signingStatus?: string;
}
/**
 * @stability stable
 */
export declare class Route53HostedZoneDnssec extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53HostedZoneDnssecConfig);
    private _hostedZoneId;
    /**
     * @stability stable
     */
    get hostedZoneId(): string;
    /**
     * @stability stable
     */
    set hostedZoneId(value: string);
    /**
     * @stability stable
     */
    get hostedZoneIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _signingStatus?;
    /**
     * @stability stable
     */
    get signingStatus(): string;
    /**
     * @stability stable
     */
    set signingStatus(value: string);
    /**
     * @stability stable
     */
    resetSigningStatus(): void;
    /**
     * @stability stable
     */
    get signingStatusInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
