import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Route53KeySigningKeyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly hostedZoneId: string;
    /**
     * @stability stable
     */
    readonly keyManagementServiceArn: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly status?: string;
}
/**
 * @stability stable
 */
export declare class Route53KeySigningKey extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53KeySigningKeyConfig);
    /**
     * @stability stable
     */
    get digestAlgorithmMnemonic(): string;
    /**
     * @stability stable
     */
    get digestAlgorithmType(): number;
    /**
     * @stability stable
     */
    get digestValue(): string;
    /**
     * @stability stable
     */
    get dnskeyRecord(): string;
    /**
     * @stability stable
     */
    get dsRecord(): string;
    /**
     * @stability stable
     */
    get flag(): number;
    private _hostedZoneId;
    /**
     * @stability stable
     */
    get hostedZoneId(): string;
    /**
     * @stability stable
     */
    set hostedZoneId(value: string);
    /**
     * @stability stable
     */
    get hostedZoneIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _keyManagementServiceArn;
    /**
     * @stability stable
     */
    get keyManagementServiceArn(): string;
    /**
     * @stability stable
     */
    set keyManagementServiceArn(value: string);
    /**
     * @stability stable
     */
    get keyManagementServiceArnInput(): string;
    /**
     * @stability stable
     */
    get keyTag(): number;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get publicKey(): string;
    /**
     * @stability stable
     */
    get signingAlgorithmMnemonic(): string;
    /**
     * @stability stable
     */
    get signingAlgorithmType(): number;
    private _status?;
    /**
     * @stability stable
     */
    get status(): string;
    /**
     * @stability stable
     */
    set status(value: string);
    /**
     * @stability stable
     */
    resetStatus(): void;
    /**
     * @stability stable
     */
    get statusInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
