import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Route53RecordConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly allowOverwrite?: boolean;
    /**
     * @stability stable
     */
    readonly healthCheckId?: string;
    /**
     * @stability stable
     */
    readonly multivalueAnswerRoutingPolicy?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly records?: string[];
    /**
     * @stability stable
     */
    readonly setIdentifier?: string;
    /**
     * @stability stable
     */
    readonly ttl?: number;
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly zoneId: string;
    /**
     * alias block.
     *
     * @stability stable
     */
    readonly alias?: Route53RecordAlias[];
    /**
     * failover_routing_policy block.
     *
     * @stability stable
     */
    readonly failoverRoutingPolicy?: Route53RecordFailoverRoutingPolicy[];
    /**
     * geolocation_routing_policy block.
     *
     * @stability stable
     */
    readonly geolocationRoutingPolicy?: Route53RecordGeolocationRoutingPolicy[];
    /**
     * latency_routing_policy block.
     *
     * @stability stable
     */
    readonly latencyRoutingPolicy?: Route53RecordLatencyRoutingPolicy[];
    /**
     * weighted_routing_policy block.
     *
     * @stability stable
     */
    readonly weightedRoutingPolicy?: Route53RecordWeightedRoutingPolicy[];
}
/**
 * @stability stable
 */
export interface Route53RecordAlias {
    /**
     * @stability stable
     */
    readonly evaluateTargetHealth: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly zoneId: string;
}
/**
 * @stability stable
 */
export interface Route53RecordFailoverRoutingPolicy {
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface Route53RecordGeolocationRoutingPolicy {
    /**
     * @stability stable
     */
    readonly continent?: string;
    /**
     * @stability stable
     */
    readonly country?: string;
    /**
     * @stability stable
     */
    readonly subdivision?: string;
}
/**
 * @stability stable
 */
export interface Route53RecordLatencyRoutingPolicy {
    /**
     * @stability stable
     */
    readonly region: string;
}
/**
 * @stability stable
 */
export interface Route53RecordWeightedRoutingPolicy {
    /**
     * @stability stable
     */
    readonly weight: number;
}
/**
 * @stability stable
 */
export declare class Route53Record extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53RecordConfig);
    private _allowOverwrite?;
    /**
     * @stability stable
     */
    get allowOverwrite(): boolean;
    /**
     * @stability stable
     */
    set allowOverwrite(value: boolean);
    /**
     * @stability stable
     */
    resetAllowOverwrite(): void;
    /**
     * @stability stable
     */
    get allowOverwriteInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get fqdn(): string;
    private _healthCheckId?;
    /**
     * @stability stable
     */
    get healthCheckId(): string;
    /**
     * @stability stable
     */
    set healthCheckId(value: string);
    /**
     * @stability stable
     */
    resetHealthCheckId(): void;
    /**
     * @stability stable
     */
    get healthCheckIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _multivalueAnswerRoutingPolicy?;
    /**
     * @stability stable
     */
    get multivalueAnswerRoutingPolicy(): boolean;
    /**
     * @stability stable
     */
    set multivalueAnswerRoutingPolicy(value: boolean);
    /**
     * @stability stable
     */
    resetMultivalueAnswerRoutingPolicy(): void;
    /**
     * @stability stable
     */
    get multivalueAnswerRoutingPolicyInput(): boolean | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _records?;
    /**
     * @stability stable
     */
    get records(): string[];
    /**
     * @stability stable
     */
    set records(value: string[]);
    /**
     * @stability stable
     */
    resetRecords(): void;
    /**
     * @stability stable
     */
    get recordsInput(): string[] | undefined;
    private _setIdentifier?;
    /**
     * @stability stable
     */
    get setIdentifier(): string;
    /**
     * @stability stable
     */
    set setIdentifier(value: string);
    /**
     * @stability stable
     */
    resetSetIdentifier(): void;
    /**
     * @stability stable
     */
    get setIdentifierInput(): string | undefined;
    private _ttl?;
    /**
     * @stability stable
     */
    get ttl(): number;
    /**
     * @stability stable
     */
    set ttl(value: number);
    /**
     * @stability stable
     */
    resetTtl(): void;
    /**
     * @stability stable
     */
    get ttlInput(): number | undefined;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    private _zoneId;
    /**
     * @stability stable
     */
    get zoneId(): string;
    /**
     * @stability stable
     */
    set zoneId(value: string);
    /**
     * @stability stable
     */
    get zoneIdInput(): string;
    private _alias?;
    /**
     * @stability stable
     */
    get alias(): Route53RecordAlias[];
    /**
     * @stability stable
     */
    set alias(value: Route53RecordAlias[]);
    /**
     * @stability stable
     */
    resetAlias(): void;
    /**
     * @stability stable
     */
    get aliasInput(): Route53RecordAlias[] | undefined;
    private _failoverRoutingPolicy?;
    /**
     * @stability stable
     */
    get failoverRoutingPolicy(): Route53RecordFailoverRoutingPolicy[];
    /**
     * @stability stable
     */
    set failoverRoutingPolicy(value: Route53RecordFailoverRoutingPolicy[]);
    /**
     * @stability stable
     */
    resetFailoverRoutingPolicy(): void;
    /**
     * @stability stable
     */
    get failoverRoutingPolicyInput(): Route53RecordFailoverRoutingPolicy[] | undefined;
    private _geolocationRoutingPolicy?;
    /**
     * @stability stable
     */
    get geolocationRoutingPolicy(): Route53RecordGeolocationRoutingPolicy[];
    /**
     * @stability stable
     */
    set geolocationRoutingPolicy(value: Route53RecordGeolocationRoutingPolicy[]);
    /**
     * @stability stable
     */
    resetGeolocationRoutingPolicy(): void;
    /**
     * @stability stable
     */
    get geolocationRoutingPolicyInput(): Route53RecordGeolocationRoutingPolicy[] | undefined;
    private _latencyRoutingPolicy?;
    /**
     * @stability stable
     */
    get latencyRoutingPolicy(): Route53RecordLatencyRoutingPolicy[];
    /**
     * @stability stable
     */
    set latencyRoutingPolicy(value: Route53RecordLatencyRoutingPolicy[]);
    /**
     * @stability stable
     */
    resetLatencyRoutingPolicy(): void;
    /**
     * @stability stable
     */
    get latencyRoutingPolicyInput(): Route53RecordLatencyRoutingPolicy[] | undefined;
    private _weightedRoutingPolicy?;
    /**
     * @stability stable
     */
    get weightedRoutingPolicy(): Route53RecordWeightedRoutingPolicy[];
    /**
     * @stability stable
     */
    set weightedRoutingPolicy(value: Route53RecordWeightedRoutingPolicy[]);
    /**
     * @stability stable
     */
    resetWeightedRoutingPolicy(): void;
    /**
     * @stability stable
     */
    get weightedRoutingPolicyInput(): Route53RecordWeightedRoutingPolicy[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
