import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Route53ResolverEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly direction: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly securityGroupIds: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * ip_address block.
     *
     * @stability stable
     */
    readonly ipAddress: Route53ResolverEndpointIpAddress[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: Route53ResolverEndpointTimeouts;
}
/**
 * @stability stable
 */
export interface Route53ResolverEndpointIpAddress {
    /**
     * @stability stable
     */
    readonly ip?: string;
    /**
     * @stability stable
     */
    readonly subnetId: string;
}
/**
 * @stability stable
 */
export interface Route53ResolverEndpointTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class Route53ResolverEndpoint extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53ResolverEndpointConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _direction;
    /**
     * @stability stable
     */
    get direction(): string;
    /**
     * @stability stable
     */
    set direction(value: string);
    /**
     * @stability stable
     */
    get directionInput(): string;
    /**
     * @stability stable
     */
    get hostVpcId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _securityGroupIds;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _ipAddress;
    /**
     * @stability stable
     */
    get ipAddress(): Route53ResolverEndpointIpAddress[];
    /**
     * @stability stable
     */
    set ipAddress(value: Route53ResolverEndpointIpAddress[]);
    /**
     * @stability stable
     */
    get ipAddressInput(): Route53ResolverEndpointIpAddress[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): Route53ResolverEndpointTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: Route53ResolverEndpointTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): Route53ResolverEndpointTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
