import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Route53ResolverRuleAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly resolverRuleId: string;
    /**
     * @stability stable
     */
    readonly vpcId: string;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: Route53ResolverRuleAssociationTimeouts;
}
/**
 * @stability stable
 */
export interface Route53ResolverRuleAssociationTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export declare class Route53ResolverRuleAssociation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53ResolverRuleAssociationConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _resolverRuleId;
    /**
     * @stability stable
     */
    get resolverRuleId(): string;
    /**
     * @stability stable
     */
    set resolverRuleId(value: string);
    /**
     * @stability stable
     */
    get resolverRuleIdInput(): string;
    private _vpcId;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): Route53ResolverRuleAssociationTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: Route53ResolverRuleAssociationTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): Route53ResolverRuleAssociationTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
