import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Route53ResolverRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly domainName: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly resolverEndpointId?: string;
    /**
     * @stability stable
     */
    readonly ruleType: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * target_ip block.
     *
     * @stability stable
     */
    readonly targetIp?: Route53ResolverRuleTargetIp[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: Route53ResolverRuleTimeouts;
}
/**
 * @stability stable
 */
export interface Route53ResolverRuleTargetIp {
    /**
     * @stability stable
     */
    readonly ip: string;
    /**
     * @stability stable
     */
    readonly port?: number;
}
/**
 * @stability stable
 */
export interface Route53ResolverRuleTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class Route53ResolverRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53ResolverRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _domainName;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _resolverEndpointId?;
    /**
     * @stability stable
     */
    get resolverEndpointId(): string;
    /**
     * @stability stable
     */
    set resolverEndpointId(value: string);
    /**
     * @stability stable
     */
    resetResolverEndpointId(): void;
    /**
     * @stability stable
     */
    get resolverEndpointIdInput(): string | undefined;
    private _ruleType;
    /**
     * @stability stable
     */
    get ruleType(): string;
    /**
     * @stability stable
     */
    set ruleType(value: string);
    /**
     * @stability stable
     */
    get ruleTypeInput(): string;
    /**
     * @stability stable
     */
    get shareStatus(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _targetIp?;
    /**
     * @stability stable
     */
    get targetIp(): Route53ResolverRuleTargetIp[];
    /**
     * @stability stable
     */
    set targetIp(value: Route53ResolverRuleTargetIp[]);
    /**
     * @stability stable
     */
    resetTargetIp(): void;
    /**
     * @stability stable
     */
    get targetIpInput(): Route53ResolverRuleTargetIp[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): Route53ResolverRuleTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: Route53ResolverRuleTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): Route53ResolverRuleTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
