import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Route53ZoneConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly comment?: string;
    /**
     * @stability stable
     */
    readonly delegationSetId?: string;
    /**
     * @stability stable
     */
    readonly forceDestroy?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * vpc block.
     *
     * @stability stable
     */
    readonly vpc?: Route53ZoneVpc[];
}
/**
 * @stability stable
 */
export interface Route53ZoneVpc {
    /**
     * @stability stable
     */
    readonly vpcId: string;
    /**
     * @stability stable
     */
    readonly vpcRegion?: string;
}
/**
 * @stability stable
 */
export declare class Route53Zone extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53ZoneConfig);
    private _comment?;
    /**
     * @stability stable
     */
    get comment(): string;
    /**
     * @stability stable
     */
    set comment(value: string);
    /**
     * @stability stable
     */
    resetComment(): void;
    /**
     * @stability stable
     */
    get commentInput(): string | undefined;
    private _delegationSetId?;
    /**
     * @stability stable
     */
    get delegationSetId(): string;
    /**
     * @stability stable
     */
    set delegationSetId(value: string);
    /**
     * @stability stable
     */
    resetDelegationSetId(): void;
    /**
     * @stability stable
     */
    get delegationSetIdInput(): string | undefined;
    private _forceDestroy?;
    /**
     * @stability stable
     */
    get forceDestroy(): boolean;
    /**
     * @stability stable
     */
    set forceDestroy(value: boolean);
    /**
     * @stability stable
     */
    resetForceDestroy(): void;
    /**
     * @stability stable
     */
    get forceDestroyInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get nameServers(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get zoneId(): string;
    private _vpc?;
    /**
     * @stability stable
     */
    get vpc(): Route53ZoneVpc[];
    /**
     * @stability stable
     */
    set vpc(value: Route53ZoneVpc[]);
    /**
     * @stability stable
     */
    resetVpc(): void;
    /**
     * @stability stable
     */
    get vpcInput(): Route53ZoneVpc[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
