import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface S3AccessPointConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly accountId?: string;
    /**
     * @stability stable
     */
    readonly bucket: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly policy?: string;
    /**
     * public_access_block_configuration block.
     *
     * @stability stable
     */
    readonly publicAccessBlockConfiguration?: S3AccessPointPublicAccessBlockConfiguration[];
    /**
     * vpc_configuration block.
     *
     * @stability stable
     */
    readonly vpcConfiguration?: S3AccessPointVpcConfiguration[];
}
/**
 * @stability stable
 */
export interface S3AccessPointPublicAccessBlockConfiguration {
    /**
     * @stability stable
     */
    readonly blockPublicAcls?: boolean;
    /**
     * @stability stable
     */
    readonly blockPublicPolicy?: boolean;
    /**
     * @stability stable
     */
    readonly ignorePublicAcls?: boolean;
    /**
     * @stability stable
     */
    readonly restrictPublicBuckets?: boolean;
}
/**
 * @stability stable
 */
export interface S3AccessPointVpcConfiguration {
    /**
     * @stability stable
     */
    readonly vpcId: string;
}
/**
 * @stability stable
 */
export declare class S3AccessPoint extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: S3AccessPointConfig);
    private _accountId?;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    resetAccountId(): void;
    /**
     * @stability stable
     */
    get accountIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _bucket;
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    set bucket(value: string);
    /**
     * @stability stable
     */
    get bucketInput(): string;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    get hasPublicAccessPolicy(): boolean;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get networkOrigin(): string;
    private _policy?;
    /**
     * @stability stable
     */
    get policy(): string;
    /**
     * @stability stable
     */
    set policy(value: string);
    /**
     * @stability stable
     */
    resetPolicy(): void;
    /**
     * @stability stable
     */
    get policyInput(): string | undefined;
    private _publicAccessBlockConfiguration?;
    /**
     * @stability stable
     */
    get publicAccessBlockConfiguration(): S3AccessPointPublicAccessBlockConfiguration[];
    /**
     * @stability stable
     */
    set publicAccessBlockConfiguration(value: S3AccessPointPublicAccessBlockConfiguration[]);
    /**
     * @stability stable
     */
    resetPublicAccessBlockConfiguration(): void;
    /**
     * @stability stable
     */
    get publicAccessBlockConfigurationInput(): S3AccessPointPublicAccessBlockConfiguration[] | undefined;
    private _vpcConfiguration?;
    /**
     * @stability stable
     */
    get vpcConfiguration(): S3AccessPointVpcConfiguration[];
    /**
     * @stability stable
     */
    set vpcConfiguration(value: S3AccessPointVpcConfiguration[]);
    /**
     * @stability stable
     */
    resetVpcConfiguration(): void;
    /**
     * @stability stable
     */
    get vpcConfigurationInput(): S3AccessPointVpcConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
