import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface S3AccountPublicAccessBlockConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly accountId?: string;
    /**
     * @stability stable
     */
    readonly blockPublicAcls?: boolean;
    /**
     * @stability stable
     */
    readonly blockPublicPolicy?: boolean;
    /**
     * @stability stable
     */
    readonly ignorePublicAcls?: boolean;
    /**
     * @stability stable
     */
    readonly restrictPublicBuckets?: boolean;
}
/**
 * @stability stable
 */
export declare class S3AccountPublicAccessBlock extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: S3AccountPublicAccessBlockConfig);
    private _accountId?;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    resetAccountId(): void;
    /**
     * @stability stable
     */
    get accountIdInput(): string | undefined;
    private _blockPublicAcls?;
    /**
     * @stability stable
     */
    get blockPublicAcls(): boolean;
    /**
     * @stability stable
     */
    set blockPublicAcls(value: boolean);
    /**
     * @stability stable
     */
    resetBlockPublicAcls(): void;
    /**
     * @stability stable
     */
    get blockPublicAclsInput(): boolean | undefined;
    private _blockPublicPolicy?;
    /**
     * @stability stable
     */
    get blockPublicPolicy(): boolean;
    /**
     * @stability stable
     */
    set blockPublicPolicy(value: boolean);
    /**
     * @stability stable
     */
    resetBlockPublicPolicy(): void;
    /**
     * @stability stable
     */
    get blockPublicPolicyInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _ignorePublicAcls?;
    /**
     * @stability stable
     */
    get ignorePublicAcls(): boolean;
    /**
     * @stability stable
     */
    set ignorePublicAcls(value: boolean);
    /**
     * @stability stable
     */
    resetIgnorePublicAcls(): void;
    /**
     * @stability stable
     */
    get ignorePublicAclsInput(): boolean | undefined;
    private _restrictPublicBuckets?;
    /**
     * @stability stable
     */
    get restrictPublicBuckets(): boolean;
    /**
     * @stability stable
     */
    set restrictPublicBuckets(value: boolean);
    /**
     * @stability stable
     */
    resetRestrictPublicBuckets(): void;
    /**
     * @stability stable
     */
    get restrictPublicBucketsInput(): boolean | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
