import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface S3BucketAnalyticsConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly bucket: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: S3BucketAnalyticsConfigurationFilter[];
    /**
     * storage_class_analysis block.
     *
     * @stability stable
     */
    readonly storageClassAnalysis?: S3BucketAnalyticsConfigurationStorageClassAnalysis[];
}
/**
 * @stability stable
 */
export interface S3BucketAnalyticsConfigurationFilter {
    /**
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export interface S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationS3BucketDestination {
    /**
     * @stability stable
     */
    readonly bucketAccountId?: string;
    /**
     * @stability stable
     */
    readonly bucketArn: string;
    /**
     * @stability stable
     */
    readonly format?: string;
    /**
     * @stability stable
     */
    readonly prefix?: string;
}
/**
 * @stability stable
 */
export interface S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestination {
    /**
     * s3_bucket_destination block.
     *
     * @stability stable
     */
    readonly s3BucketDestination: S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestinationS3BucketDestination[];
}
/**
 * @stability stable
 */
export interface S3BucketAnalyticsConfigurationStorageClassAnalysisDataExport {
    /**
     * @stability stable
     */
    readonly outputSchemaVersion?: string;
    /**
     * destination block.
     *
     * @stability stable
     */
    readonly destination: S3BucketAnalyticsConfigurationStorageClassAnalysisDataExportDestination[];
}
/**
 * @stability stable
 */
export interface S3BucketAnalyticsConfigurationStorageClassAnalysis {
    /**
     * data_export block.
     *
     * @stability stable
     */
    readonly dataExport: S3BucketAnalyticsConfigurationStorageClassAnalysisDataExport[];
}
/**
 * @stability stable
 */
export declare class S3BucketAnalyticsConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: S3BucketAnalyticsConfigurationConfig);
    private _bucket;
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    set bucket(value: string);
    /**
     * @stability stable
     */
    get bucketInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): S3BucketAnalyticsConfigurationFilter[];
    /**
     * @stability stable
     */
    set filter(value: S3BucketAnalyticsConfigurationFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): S3BucketAnalyticsConfigurationFilter[] | undefined;
    private _storageClassAnalysis?;
    /**
     * @stability stable
     */
    get storageClassAnalysis(): S3BucketAnalyticsConfigurationStorageClassAnalysis[];
    /**
     * @stability stable
     */
    set storageClassAnalysis(value: S3BucketAnalyticsConfigurationStorageClassAnalysis[]);
    /**
     * @stability stable
     */
    resetStorageClassAnalysis(): void;
    /**
     * @stability stable
     */
    get storageClassAnalysisInput(): S3BucketAnalyticsConfigurationStorageClassAnalysis[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
