import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface S3BucketInventoryConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly bucket: string;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly includedObjectVersions: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly optionalFields?: string[];
    /**
     * destination block.
     *
     * @stability stable
     */
    readonly destination: S3BucketInventoryDestination[];
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: S3BucketInventoryFilter[];
    /**
     * schedule block.
     *
     * @stability stable
     */
    readonly schedule: S3BucketInventorySchedule[];
}
/**
 * @stability stable
 */
export interface S3BucketInventoryDestinationBucketEncryptionSseKms {
    /**
     * @stability stable
     */
    readonly keyId: string;
}
/**
 * @stability stable
 */
export interface S3BucketInventoryDestinationBucketEncryptionSseS3 {
}
/**
 * @stability stable
 */
export interface S3BucketInventoryDestinationBucketEncryption {
    /**
     * sse_kms block.
     *
     * @stability stable
     */
    readonly sseKms?: S3BucketInventoryDestinationBucketEncryptionSseKms[];
    /**
     * sse_s3 block.
     *
     * @stability stable
     */
    readonly sseS3?: S3BucketInventoryDestinationBucketEncryptionSseS3[];
}
/**
 * @stability stable
 */
export interface S3BucketInventoryDestinationBucket {
    /**
     * @stability stable
     */
    readonly accountId?: string;
    /**
     * @stability stable
     */
    readonly bucketArn: string;
    /**
     * @stability stable
     */
    readonly format: string;
    /**
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * encryption block.
     *
     * @stability stable
     */
    readonly encryption?: S3BucketInventoryDestinationBucketEncryption[];
}
/**
 * @stability stable
 */
export interface S3BucketInventoryDestination {
    /**
     * bucket block.
     *
     * @stability stable
     */
    readonly bucket: S3BucketInventoryDestinationBucket[];
}
/**
 * @stability stable
 */
export interface S3BucketInventoryFilter {
    /**
     * @stability stable
     */
    readonly prefix?: string;
}
/**
 * @stability stable
 */
export interface S3BucketInventorySchedule {
    /**
     * @stability stable
     */
    readonly frequency: string;
}
/**
 * @stability stable
 */
export declare class S3BucketInventory extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: S3BucketInventoryConfig);
    private _bucket;
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    set bucket(value: string);
    /**
     * @stability stable
     */
    get bucketInput(): string;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _includedObjectVersions;
    /**
     * @stability stable
     */
    get includedObjectVersions(): string;
    /**
     * @stability stable
     */
    set includedObjectVersions(value: string);
    /**
     * @stability stable
     */
    get includedObjectVersionsInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _optionalFields?;
    /**
     * @stability stable
     */
    get optionalFields(): string[];
    /**
     * @stability stable
     */
    set optionalFields(value: string[]);
    /**
     * @stability stable
     */
    resetOptionalFields(): void;
    /**
     * @stability stable
     */
    get optionalFieldsInput(): string[] | undefined;
    private _destination;
    /**
     * @stability stable
     */
    get destination(): S3BucketInventoryDestination[];
    /**
     * @stability stable
     */
    set destination(value: S3BucketInventoryDestination[]);
    /**
     * @stability stable
     */
    get destinationInput(): S3BucketInventoryDestination[];
    private _filter?;
    /**
     * @stability stable
     */
    get filter(): S3BucketInventoryFilter[];
    /**
     * @stability stable
     */
    set filter(value: S3BucketInventoryFilter[]);
    /**
     * @stability stable
     */
    resetFilter(): void;
    /**
     * @stability stable
     */
    get filterInput(): S3BucketInventoryFilter[] | undefined;
    private _schedule;
    /**
     * @stability stable
     */
    get schedule(): S3BucketInventorySchedule[];
    /**
     * @stability stable
     */
    set schedule(value: S3BucketInventorySchedule[]);
    /**
     * @stability stable
     */
    get scheduleInput(): S3BucketInventorySchedule[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
