import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface S3BucketNotificationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly bucket: string;
    /**
     * lambda_function block.
     *
     * @stability stable
     */
    readonly lambdaFunction?: S3BucketNotificationLambdaFunction[];
    /**
     * queue block.
     *
     * @stability stable
     */
    readonly queue?: S3BucketNotificationQueue[];
    /**
     * topic block.
     *
     * @stability stable
     */
    readonly topic?: S3BucketNotificationTopic[];
}
/**
 * @stability stable
 */
export interface S3BucketNotificationLambdaFunction {
    /**
     * @stability stable
     */
    readonly events: string[];
    /**
     * @stability stable
     */
    readonly filterPrefix?: string;
    /**
     * @stability stable
     */
    readonly filterSuffix?: string;
    /**
     * @stability stable
     */
    readonly id?: string;
    /**
     * @stability stable
     */
    readonly lambdaFunctionArn?: string;
}
/**
 * @stability stable
 */
export interface S3BucketNotificationQueue {
    /**
     * @stability stable
     */
    readonly events: string[];
    /**
     * @stability stable
     */
    readonly filterPrefix?: string;
    /**
     * @stability stable
     */
    readonly filterSuffix?: string;
    /**
     * @stability stable
     */
    readonly id?: string;
    /**
     * @stability stable
     */
    readonly queueArn: string;
}
/**
 * @stability stable
 */
export interface S3BucketNotificationTopic {
    /**
     * @stability stable
     */
    readonly events: string[];
    /**
     * @stability stable
     */
    readonly filterPrefix?: string;
    /**
     * @stability stable
     */
    readonly filterSuffix?: string;
    /**
     * @stability stable
     */
    readonly id?: string;
    /**
     * @stability stable
     */
    readonly topicArn: string;
}
/**
 * @stability stable
 */
export declare class S3BucketNotification extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: S3BucketNotificationConfig);
    private _bucket;
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    set bucket(value: string);
    /**
     * @stability stable
     */
    get bucketInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _lambdaFunction?;
    /**
     * @stability stable
     */
    get lambdaFunction(): S3BucketNotificationLambdaFunction[];
    /**
     * @stability stable
     */
    set lambdaFunction(value: S3BucketNotificationLambdaFunction[]);
    /**
     * @stability stable
     */
    resetLambdaFunction(): void;
    /**
     * @stability stable
     */
    get lambdaFunctionInput(): S3BucketNotificationLambdaFunction[] | undefined;
    private _queue?;
    /**
     * @stability stable
     */
    get queue(): S3BucketNotificationQueue[];
    /**
     * @stability stable
     */
    set queue(value: S3BucketNotificationQueue[]);
    /**
     * @stability stable
     */
    resetQueue(): void;
    /**
     * @stability stable
     */
    get queueInput(): S3BucketNotificationQueue[] | undefined;
    private _topic?;
    /**
     * @stability stable
     */
    get topic(): S3BucketNotificationTopic[];
    /**
     * @stability stable
     */
    set topic(value: S3BucketNotificationTopic[]);
    /**
     * @stability stable
     */
    resetTopic(): void;
    /**
     * @stability stable
     */
    get topicInput(): S3BucketNotificationTopic[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
