import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface S3BucketOwnershipControlsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly bucket: string;
    /**
     * rule block.
     *
     * @stability stable
     */
    readonly rule: S3BucketOwnershipControlsRule[];
}
/**
 * @stability stable
 */
export interface S3BucketOwnershipControlsRule {
    /**
     * @stability stable
     */
    readonly objectOwnership: string;
}
/**
 * @stability stable
 */
export declare class S3BucketOwnershipControls extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: S3BucketOwnershipControlsConfig);
    private _bucket;
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    set bucket(value: string);
    /**
     * @stability stable
     */
    get bucketInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _rule;
    /**
     * @stability stable
     */
    get rule(): S3BucketOwnershipControlsRule[];
    /**
     * @stability stable
     */
    set rule(value: S3BucketOwnershipControlsRule[]);
    /**
     * @stability stable
     */
    get ruleInput(): S3BucketOwnershipControlsRule[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
