import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface S3ObjectCopyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly acl?: string;
    /**
     * @stability stable
     */
    readonly bucket: string;
    /**
     * @stability stable
     */
    readonly cacheControl?: string;
    /**
     * @stability stable
     */
    readonly contentDisposition?: string;
    /**
     * @stability stable
     */
    readonly contentEncoding?: string;
    /**
     * @stability stable
     */
    readonly contentLanguage?: string;
    /**
     * @stability stable
     */
    readonly contentType?: string;
    /**
     * @stability stable
     */
    readonly copyIfMatch?: string;
    /**
     * @stability stable
     */
    readonly copyIfModifiedSince?: string;
    /**
     * @stability stable
     */
    readonly copyIfNoneMatch?: string;
    /**
     * @stability stable
     */
    readonly copyIfUnmodifiedSince?: string;
    /**
     * @stability stable
     */
    readonly customerAlgorithm?: string;
    /**
     * @stability stable
     */
    readonly customerKey?: string;
    /**
     * @stability stable
     */
    readonly customerKeyMd5?: string;
    /**
     * @stability stable
     */
    readonly expectedBucketOwner?: string;
    /**
     * @stability stable
     */
    readonly expectedSourceBucketOwner?: string;
    /**
     * @stability stable
     */
    readonly expires?: string;
    /**
     * @stability stable
     */
    readonly forceDestroy?: boolean;
    /**
     * @stability stable
     */
    readonly key: string;
    /**
     * @stability stable
     */
    readonly kmsEncryptionContext?: string;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly metadata?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly metadataDirective?: string;
    /**
     * @stability stable
     */
    readonly objectLockLegalHoldStatus?: string;
    /**
     * @stability stable
     */
    readonly objectLockMode?: string;
    /**
     * @stability stable
     */
    readonly objectLockRetainUntilDate?: string;
    /**
     * @stability stable
     */
    readonly requestPayer?: string;
    /**
     * @stability stable
     */
    readonly serverSideEncryption?: string;
    /**
     * @stability stable
     */
    readonly source: string;
    /**
     * @stability stable
     */
    readonly sourceCustomerAlgorithm?: string;
    /**
     * @stability stable
     */
    readonly sourceCustomerKey?: string;
    /**
     * @stability stable
     */
    readonly sourceCustomerKeyMd5?: string;
    /**
     * @stability stable
     */
    readonly storageClass?: string;
    /**
     * @stability stable
     */
    readonly taggingDirective?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly websiteRedirect?: string;
    /**
     * grant block.
     *
     * @stability stable
     */
    readonly grant?: S3ObjectCopyGrant[];
}
/**
 * @stability stable
 */
export interface S3ObjectCopyGrant {
    /**
     * @stability stable
     */
    readonly email?: string;
    /**
     * @stability stable
     */
    readonly id?: string;
    /**
     * @stability stable
     */
    readonly permissions: string[];
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly uri?: string;
}
/**
 * @stability stable
 */
export declare class S3ObjectCopy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: S3ObjectCopyConfig);
    private _acl?;
    /**
     * @stability stable
     */
    get acl(): string;
    /**
     * @stability stable
     */
    set acl(value: string);
    /**
     * @stability stable
     */
    resetAcl(): void;
    /**
     * @stability stable
     */
    get aclInput(): string | undefined;
    private _bucket;
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    set bucket(value: string);
    /**
     * @stability stable
     */
    get bucketInput(): string;
    private _cacheControl?;
    /**
     * @stability stable
     */
    get cacheControl(): string;
    /**
     * @stability stable
     */
    set cacheControl(value: string);
    /**
     * @stability stable
     */
    resetCacheControl(): void;
    /**
     * @stability stable
     */
    get cacheControlInput(): string | undefined;
    private _contentDisposition?;
    /**
     * @stability stable
     */
    get contentDisposition(): string;
    /**
     * @stability stable
     */
    set contentDisposition(value: string);
    /**
     * @stability stable
     */
    resetContentDisposition(): void;
    /**
     * @stability stable
     */
    get contentDispositionInput(): string | undefined;
    private _contentEncoding?;
    /**
     * @stability stable
     */
    get contentEncoding(): string;
    /**
     * @stability stable
     */
    set contentEncoding(value: string);
    /**
     * @stability stable
     */
    resetContentEncoding(): void;
    /**
     * @stability stable
     */
    get contentEncodingInput(): string | undefined;
    private _contentLanguage?;
    /**
     * @stability stable
     */
    get contentLanguage(): string;
    /**
     * @stability stable
     */
    set contentLanguage(value: string);
    /**
     * @stability stable
     */
    resetContentLanguage(): void;
    /**
     * @stability stable
     */
    get contentLanguageInput(): string | undefined;
    private _contentType?;
    /**
     * @stability stable
     */
    get contentType(): string;
    /**
     * @stability stable
     */
    set contentType(value: string);
    /**
     * @stability stable
     */
    resetContentType(): void;
    /**
     * @stability stable
     */
    get contentTypeInput(): string | undefined;
    private _copyIfMatch?;
    /**
     * @stability stable
     */
    get copyIfMatch(): string;
    /**
     * @stability stable
     */
    set copyIfMatch(value: string);
    /**
     * @stability stable
     */
    resetCopyIfMatch(): void;
    /**
     * @stability stable
     */
    get copyIfMatchInput(): string | undefined;
    private _copyIfModifiedSince?;
    /**
     * @stability stable
     */
    get copyIfModifiedSince(): string;
    /**
     * @stability stable
     */
    set copyIfModifiedSince(value: string);
    /**
     * @stability stable
     */
    resetCopyIfModifiedSince(): void;
    /**
     * @stability stable
     */
    get copyIfModifiedSinceInput(): string | undefined;
    private _copyIfNoneMatch?;
    /**
     * @stability stable
     */
    get copyIfNoneMatch(): string;
    /**
     * @stability stable
     */
    set copyIfNoneMatch(value: string);
    /**
     * @stability stable
     */
    resetCopyIfNoneMatch(): void;
    /**
     * @stability stable
     */
    get copyIfNoneMatchInput(): string | undefined;
    private _copyIfUnmodifiedSince?;
    /**
     * @stability stable
     */
    get copyIfUnmodifiedSince(): string;
    /**
     * @stability stable
     */
    set copyIfUnmodifiedSince(value: string);
    /**
     * @stability stable
     */
    resetCopyIfUnmodifiedSince(): void;
    /**
     * @stability stable
     */
    get copyIfUnmodifiedSinceInput(): string | undefined;
    private _customerAlgorithm?;
    /**
     * @stability stable
     */
    get customerAlgorithm(): string;
    /**
     * @stability stable
     */
    set customerAlgorithm(value: string);
    /**
     * @stability stable
     */
    resetCustomerAlgorithm(): void;
    /**
     * @stability stable
     */
    get customerAlgorithmInput(): string | undefined;
    private _customerKey?;
    /**
     * @stability stable
     */
    get customerKey(): string;
    /**
     * @stability stable
     */
    set customerKey(value: string);
    /**
     * @stability stable
     */
    resetCustomerKey(): void;
    /**
     * @stability stable
     */
    get customerKeyInput(): string | undefined;
    private _customerKeyMd5?;
    /**
     * @stability stable
     */
    get customerKeyMd5(): string;
    /**
     * @stability stable
     */
    set customerKeyMd5(value: string);
    /**
     * @stability stable
     */
    resetCustomerKeyMd5(): void;
    /**
     * @stability stable
     */
    get customerKeyMd5Input(): string | undefined;
    /**
     * @stability stable
     */
    get etag(): string;
    private _expectedBucketOwner?;
    /**
     * @stability stable
     */
    get expectedBucketOwner(): string;
    /**
     * @stability stable
     */
    set expectedBucketOwner(value: string);
    /**
     * @stability stable
     */
    resetExpectedBucketOwner(): void;
    /**
     * @stability stable
     */
    get expectedBucketOwnerInput(): string | undefined;
    private _expectedSourceBucketOwner?;
    /**
     * @stability stable
     */
    get expectedSourceBucketOwner(): string;
    /**
     * @stability stable
     */
    set expectedSourceBucketOwner(value: string);
    /**
     * @stability stable
     */
    resetExpectedSourceBucketOwner(): void;
    /**
     * @stability stable
     */
    get expectedSourceBucketOwnerInput(): string | undefined;
    /**
     * @stability stable
     */
    get expiration(): string;
    private _expires?;
    /**
     * @stability stable
     */
    get expires(): string;
    /**
     * @stability stable
     */
    set expires(value: string);
    /**
     * @stability stable
     */
    resetExpires(): void;
    /**
     * @stability stable
     */
    get expiresInput(): string | undefined;
    private _forceDestroy?;
    /**
     * @stability stable
     */
    get forceDestroy(): boolean;
    /**
     * @stability stable
     */
    set forceDestroy(value: boolean);
    /**
     * @stability stable
     */
    resetForceDestroy(): void;
    /**
     * @stability stable
     */
    get forceDestroyInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _key;
    /**
     * @stability stable
     */
    get key(): string;
    /**
     * @stability stable
     */
    set key(value: string);
    /**
     * @stability stable
     */
    get keyInput(): string;
    private _kmsEncryptionContext?;
    /**
     * @stability stable
     */
    get kmsEncryptionContext(): string;
    /**
     * @stability stable
     */
    set kmsEncryptionContext(value: string);
    /**
     * @stability stable
     */
    resetKmsEncryptionContext(): void;
    /**
     * @stability stable
     */
    get kmsEncryptionContextInput(): string | undefined;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get lastModified(): string;
    private _metadata?;
    /**
     * @stability stable
     */
    get metadata(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set metadata(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetMetadata(): void;
    /**
     * @stability stable
     */
    get metadataInput(): {
        [key: string]: string;
    } | undefined;
    private _metadataDirective?;
    /**
     * @stability stable
     */
    get metadataDirective(): string;
    /**
     * @stability stable
     */
    set metadataDirective(value: string);
    /**
     * @stability stable
     */
    resetMetadataDirective(): void;
    /**
     * @stability stable
     */
    get metadataDirectiveInput(): string | undefined;
    private _objectLockLegalHoldStatus?;
    /**
     * @stability stable
     */
    get objectLockLegalHoldStatus(): string;
    /**
     * @stability stable
     */
    set objectLockLegalHoldStatus(value: string);
    /**
     * @stability stable
     */
    resetObjectLockLegalHoldStatus(): void;
    /**
     * @stability stable
     */
    get objectLockLegalHoldStatusInput(): string | undefined;
    private _objectLockMode?;
    /**
     * @stability stable
     */
    get objectLockMode(): string;
    /**
     * @stability stable
     */
    set objectLockMode(value: string);
    /**
     * @stability stable
     */
    resetObjectLockMode(): void;
    /**
     * @stability stable
     */
    get objectLockModeInput(): string | undefined;
    private _objectLockRetainUntilDate?;
    /**
     * @stability stable
     */
    get objectLockRetainUntilDate(): string;
    /**
     * @stability stable
     */
    set objectLockRetainUntilDate(value: string);
    /**
     * @stability stable
     */
    resetObjectLockRetainUntilDate(): void;
    /**
     * @stability stable
     */
    get objectLockRetainUntilDateInput(): string | undefined;
    /**
     * @stability stable
     */
    get requestCharged(): boolean;
    private _requestPayer?;
    /**
     * @stability stable
     */
    get requestPayer(): string;
    /**
     * @stability stable
     */
    set requestPayer(value: string);
    /**
     * @stability stable
     */
    resetRequestPayer(): void;
    /**
     * @stability stable
     */
    get requestPayerInput(): string | undefined;
    private _serverSideEncryption?;
    /**
     * @stability stable
     */
    get serverSideEncryption(): string;
    /**
     * @stability stable
     */
    set serverSideEncryption(value: string);
    /**
     * @stability stable
     */
    resetServerSideEncryption(): void;
    /**
     * @stability stable
     */
    get serverSideEncryptionInput(): string | undefined;
    private _source;
    /**
     * @stability stable
     */
    get source(): string;
    /**
     * @stability stable
     */
    set source(value: string);
    /**
     * @stability stable
     */
    get sourceInput(): string;
    private _sourceCustomerAlgorithm?;
    /**
     * @stability stable
     */
    get sourceCustomerAlgorithm(): string;
    /**
     * @stability stable
     */
    set sourceCustomerAlgorithm(value: string);
    /**
     * @stability stable
     */
    resetSourceCustomerAlgorithm(): void;
    /**
     * @stability stable
     */
    get sourceCustomerAlgorithmInput(): string | undefined;
    private _sourceCustomerKey?;
    /**
     * @stability stable
     */
    get sourceCustomerKey(): string;
    /**
     * @stability stable
     */
    set sourceCustomerKey(value: string);
    /**
     * @stability stable
     */
    resetSourceCustomerKey(): void;
    /**
     * @stability stable
     */
    get sourceCustomerKeyInput(): string | undefined;
    private _sourceCustomerKeyMd5?;
    /**
     * @stability stable
     */
    get sourceCustomerKeyMd5(): string;
    /**
     * @stability stable
     */
    set sourceCustomerKeyMd5(value: string);
    /**
     * @stability stable
     */
    resetSourceCustomerKeyMd5(): void;
    /**
     * @stability stable
     */
    get sourceCustomerKeyMd5Input(): string | undefined;
    /**
     * @stability stable
     */
    get sourceVersionId(): string;
    private _storageClass?;
    /**
     * @stability stable
     */
    get storageClass(): string;
    /**
     * @stability stable
     */
    set storageClass(value: string);
    /**
     * @stability stable
     */
    resetStorageClass(): void;
    /**
     * @stability stable
     */
    get storageClassInput(): string | undefined;
    private _taggingDirective?;
    /**
     * @stability stable
     */
    get taggingDirective(): string;
    /**
     * @stability stable
     */
    set taggingDirective(value: string);
    /**
     * @stability stable
     */
    resetTaggingDirective(): void;
    /**
     * @stability stable
     */
    get taggingDirectiveInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get versionId(): string;
    private _websiteRedirect?;
    /**
     * @stability stable
     */
    get websiteRedirect(): string;
    /**
     * @stability stable
     */
    set websiteRedirect(value: string);
    /**
     * @stability stable
     */
    resetWebsiteRedirect(): void;
    /**
     * @stability stable
     */
    get websiteRedirectInput(): string | undefined;
    private _grant?;
    /**
     * @stability stable
     */
    get grant(): S3ObjectCopyGrant[];
    /**
     * @stability stable
     */
    set grant(value: S3ObjectCopyGrant[]);
    /**
     * @stability stable
     */
    resetGrant(): void;
    /**
     * @stability stable
     */
    get grantInput(): S3ObjectCopyGrant[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
