import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface S3ControlBucketLifecycleConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly bucket: string;
    /**
     * rule block.
     *
     * @stability stable
     */
    readonly rule: S3ControlBucketLifecycleConfigurationRule[];
}
/**
 * @stability stable
 */
export interface S3ControlBucketLifecycleConfigurationRuleAbortIncompleteMultipartUpload {
    /**
     * @stability stable
     */
    readonly daysAfterInitiation: number;
}
/**
 * @stability stable
 */
export interface S3ControlBucketLifecycleConfigurationRuleExpiration {
    /**
     * @stability stable
     */
    readonly date?: string;
    /**
     * @stability stable
     */
    readonly days?: number;
    /**
     * @stability stable
     */
    readonly expiredObjectDeleteMarker?: boolean;
}
/**
 * @stability stable
 */
export interface S3ControlBucketLifecycleConfigurationRuleFilter {
    /**
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export interface S3ControlBucketLifecycleConfigurationRule {
    /**
     * @stability stable
     */
    readonly id: string;
    /**
     * @stability stable
     */
    readonly status?: string;
    /**
     * abort_incomplete_multipart_upload block.
     *
     * @stability stable
     */
    readonly abortIncompleteMultipartUpload?: S3ControlBucketLifecycleConfigurationRuleAbortIncompleteMultipartUpload[];
    /**
     * expiration block.
     *
     * @stability stable
     */
    readonly expiration?: S3ControlBucketLifecycleConfigurationRuleExpiration[];
    /**
     * filter block.
     *
     * @stability stable
     */
    readonly filter?: S3ControlBucketLifecycleConfigurationRuleFilter[];
}
/**
 * @stability stable
 */
export declare class S3ControlBucketLifecycleConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: S3ControlBucketLifecycleConfigurationConfig);
    private _bucket;
    /**
     * @stability stable
     */
    get bucket(): string;
    /**
     * @stability stable
     */
    set bucket(value: string);
    /**
     * @stability stable
     */
    get bucketInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _rule;
    /**
     * @stability stable
     */
    get rule(): S3ControlBucketLifecycleConfigurationRule[];
    /**
     * @stability stable
     */
    set rule(value: S3ControlBucketLifecycleConfigurationRule[]);
    /**
     * @stability stable
     */
    get ruleInput(): S3ControlBucketLifecycleConfigurationRule[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
