import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface S3OutpostsEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly outpostId: string;
    /**
     * @stability stable
     */
    readonly securityGroupId: string;
    /**
     * @stability stable
     */
    readonly subnetId: string;
}
/**
 * @stability stable
 */
export declare class S3OutpostsEndpointNetworkInterfaces extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get networkInterfaceId(): string;
}
/**
 * @stability stable
 */
export declare class S3OutpostsEndpoint extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: S3OutpostsEndpointConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get cidrBlock(): string;
    /**
     * @stability stable
     */
    get creationTime(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    networkInterfaces(index: string): S3OutpostsEndpointNetworkInterfaces;
    private _outpostId;
    /**
     * @stability stable
     */
    get outpostId(): string;
    /**
     * @stability stable
     */
    set outpostId(value: string);
    /**
     * @stability stable
     */
    get outpostIdInput(): string;
    private _securityGroupId;
    /**
     * @stability stable
     */
    get securityGroupId(): string;
    /**
     * @stability stable
     */
    set securityGroupId(value: string);
    /**
     * @stability stable
     */
    get securityGroupIdInput(): string;
    private _subnetId;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    get subnetIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
