import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerAppImageConfigConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly appImageConfigName: string;
    /**
     * kernel_gateway_image_config block.
     *
     * @stability stable
     */
    readonly kernelGatewayImageConfig?: SagemakerAppImageConfigKernelGatewayImageConfig[];
}
/**
 * @stability stable
 */
export interface SagemakerAppImageConfigKernelGatewayImageConfigFileSystemConfig {
    /**
     * @stability stable
     */
    readonly defaultGid?: number;
    /**
     * @stability stable
     */
    readonly defaultUid?: number;
    /**
     * @stability stable
     */
    readonly mountPath?: string;
}
/**
 * @stability stable
 */
export interface SagemakerAppImageConfigKernelGatewayImageConfigKernelSpec {
    /**
     * @stability stable
     */
    readonly displayName?: string;
    /**
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface SagemakerAppImageConfigKernelGatewayImageConfig {
    /**
     * file_system_config block.
     *
     * @stability stable
     */
    readonly fileSystemConfig?: SagemakerAppImageConfigKernelGatewayImageConfigFileSystemConfig[];
    /**
     * kernel_spec block.
     *
     * @stability stable
     */
    readonly kernelSpec: SagemakerAppImageConfigKernelGatewayImageConfigKernelSpec[];
}
/**
 * @stability stable
 */
export declare class SagemakerAppImageConfig extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerAppImageConfigConfig);
    private _appImageConfigName;
    /**
     * @stability stable
     */
    get appImageConfigName(): string;
    /**
     * @stability stable
     */
    set appImageConfigName(value: string);
    /**
     * @stability stable
     */
    get appImageConfigNameInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _kernelGatewayImageConfig?;
    /**
     * @stability stable
     */
    get kernelGatewayImageConfig(): SagemakerAppImageConfigKernelGatewayImageConfig[];
    /**
     * @stability stable
     */
    set kernelGatewayImageConfig(value: SagemakerAppImageConfigKernelGatewayImageConfig[]);
    /**
     * @stability stable
     */
    resetKernelGatewayImageConfig(): void;
    /**
     * @stability stable
     */
    get kernelGatewayImageConfigInput(): SagemakerAppImageConfigKernelGatewayImageConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
