import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerAppConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly appName: string;
    /**
     * @stability stable
     */
    readonly appType: string;
    /**
     * @stability stable
     */
    readonly domainId: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly userProfileName: string;
    /**
     * resource_spec block.
     *
     * @stability stable
     */
    readonly resourceSpec?: SagemakerAppResourceSpec[];
}
/**
 * @stability stable
 */
export interface SagemakerAppResourceSpec {
    /**
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * @stability stable
     */
    readonly sagemakerImageArn?: string;
}
/**
 * @stability stable
 */
export declare class SagemakerApp extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerAppConfig);
    private _appName;
    /**
     * @stability stable
     */
    get appName(): string;
    /**
     * @stability stable
     */
    set appName(value: string);
    /**
     * @stability stable
     */
    get appNameInput(): string;
    private _appType;
    /**
     * @stability stable
     */
    get appType(): string;
    /**
     * @stability stable
     */
    set appType(value: string);
    /**
     * @stability stable
     */
    get appTypeInput(): string;
    /**
     * @stability stable
     */
    get arn(): string;
    private _domainId;
    /**
     * @stability stable
     */
    get domainId(): string;
    /**
     * @stability stable
     */
    set domainId(value: string);
    /**
     * @stability stable
     */
    get domainIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _userProfileName;
    /**
     * @stability stable
     */
    get userProfileName(): string;
    /**
     * @stability stable
     */
    set userProfileName(value: string);
    /**
     * @stability stable
     */
    get userProfileNameInput(): string;
    private _resourceSpec?;
    /**
     * @stability stable
     */
    get resourceSpec(): SagemakerAppResourceSpec[];
    /**
     * @stability stable
     */
    set resourceSpec(value: SagemakerAppResourceSpec[]);
    /**
     * @stability stable
     */
    resetResourceSpec(): void;
    /**
     * @stability stable
     */
    get resourceSpecInput(): SagemakerAppResourceSpec[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
