import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerCodeRepositoryConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly codeRepositoryName: string;
    /**
     * git_config block.
     *
     * @stability stable
     */
    readonly gitConfig: SagemakerCodeRepositoryGitConfig[];
}
/**
 * @stability stable
 */
export interface SagemakerCodeRepositoryGitConfig {
    /**
     * @stability stable
     */
    readonly branch?: string;
    /**
     * @stability stable
     */
    readonly repositoryUrl: string;
    /**
     * @stability stable
     */
    readonly secretArn?: string;
}
/**
 * @stability stable
 */
export declare class SagemakerCodeRepository extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerCodeRepositoryConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _codeRepositoryName;
    /**
     * @stability stable
     */
    get codeRepositoryName(): string;
    /**
     * @stability stable
     */
    set codeRepositoryName(value: string);
    /**
     * @stability stable
     */
    get codeRepositoryNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _gitConfig;
    /**
     * @stability stable
     */
    get gitConfig(): SagemakerCodeRepositoryGitConfig[];
    /**
     * @stability stable
     */
    set gitConfig(value: SagemakerCodeRepositoryGitConfig[]);
    /**
     * @stability stable
     */
    get gitConfigInput(): SagemakerCodeRepositoryGitConfig[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
