import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerDomainConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly appNetworkAccessType?: string;
    /**
     * @stability stable
     */
    readonly authMode: string;
    /**
     * @stability stable
     */
    readonly domainName: string;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcId: string;
    /**
     * default_user_settings block.
     *
     * @stability stable
     */
    readonly defaultUserSettings: SagemakerDomainDefaultUserSettings[];
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsJupyterServerAppSettingsDefaultResourceSpec {
    /**
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * @stability stable
     */
    readonly sagemakerImageArn?: string;
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsJupyterServerAppSettings {
    /**
     * default_resource_spec block.
     *
     * @stability stable
     */
    readonly defaultResourceSpec?: SagemakerDomainDefaultUserSettingsJupyterServerAppSettingsDefaultResourceSpec[];
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsCustomImage {
    /**
     * @stability stable
     */
    readonly appImageConfigName: string;
    /**
     * @stability stable
     */
    readonly imageName: string;
    /**
     * @stability stable
     */
    readonly imageVersionNumber?: number;
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsDefaultResourceSpec {
    /**
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * @stability stable
     */
    readonly sagemakerImageArn?: string;
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsKernelGatewayAppSettings {
    /**
     * custom_image block.
     *
     * @stability stable
     */
    readonly customImage?: SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsCustomImage[];
    /**
     * default_resource_spec block.
     *
     * @stability stable
     */
    readonly defaultResourceSpec?: SagemakerDomainDefaultUserSettingsKernelGatewayAppSettingsDefaultResourceSpec[];
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsSharingSettings {
    /**
     * @stability stable
     */
    readonly notebookOutputOption?: string;
    /**
     * @stability stable
     */
    readonly s3KmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly s3OutputPath?: string;
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsTensorBoardAppSettingsDefaultResourceSpec {
    /**
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * @stability stable
     */
    readonly sagemakerImageArn?: string;
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettingsTensorBoardAppSettings {
    /**
     * default_resource_spec block.
     *
     * @stability stable
     */
    readonly defaultResourceSpec?: SagemakerDomainDefaultUserSettingsTensorBoardAppSettingsDefaultResourceSpec[];
}
/**
 * @stability stable
 */
export interface SagemakerDomainDefaultUserSettings {
    /**
     * @stability stable
     */
    readonly executionRole: string;
    /**
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * jupyter_server_app_settings block.
     *
     * @stability stable
     */
    readonly jupyterServerAppSettings?: SagemakerDomainDefaultUserSettingsJupyterServerAppSettings[];
    /**
     * kernel_gateway_app_settings block.
     *
     * @stability stable
     */
    readonly kernelGatewayAppSettings?: SagemakerDomainDefaultUserSettingsKernelGatewayAppSettings[];
    /**
     * sharing_settings block.
     *
     * @stability stable
     */
    readonly sharingSettings?: SagemakerDomainDefaultUserSettingsSharingSettings[];
    /**
     * tensor_board_app_settings block.
     *
     * @stability stable
     */
    readonly tensorBoardAppSettings?: SagemakerDomainDefaultUserSettingsTensorBoardAppSettings[];
}
/**
 * @stability stable
 */
export declare class SagemakerDomain extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerDomainConfig);
    private _appNetworkAccessType?;
    /**
     * @stability stable
     */
    get appNetworkAccessType(): string;
    /**
     * @stability stable
     */
    set appNetworkAccessType(value: string);
    /**
     * @stability stable
     */
    resetAppNetworkAccessType(): void;
    /**
     * @stability stable
     */
    get appNetworkAccessTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _authMode;
    /**
     * @stability stable
     */
    get authMode(): string;
    /**
     * @stability stable
     */
    set authMode(value: string);
    /**
     * @stability stable
     */
    get authModeInput(): string;
    private _domainName;
    /**
     * @stability stable
     */
    get domainName(): string;
    /**
     * @stability stable
     */
    set domainName(value: string);
    /**
     * @stability stable
     */
    get domainNameInput(): string;
    /**
     * @stability stable
     */
    get homeEfsFileSystemId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get singleSignOnManagedApplicationInstanceId(): string;
    private _subnetIds;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[];
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get url(): string;
    private _vpcId;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string;
    private _defaultUserSettings;
    /**
     * @stability stable
     */
    get defaultUserSettings(): SagemakerDomainDefaultUserSettings[];
    /**
     * @stability stable
     */
    set defaultUserSettings(value: SagemakerDomainDefaultUserSettings[]);
    /**
     * @stability stable
     */
    get defaultUserSettingsInput(): SagemakerDomainDefaultUserSettings[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
