import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerEndpointConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * data_capture_config block.
     *
     * @stability stable
     */
    readonly dataCaptureConfig?: SagemakerEndpointConfigurationDataCaptureConfig[];
    /**
     * production_variants block.
     *
     * @stability stable
     */
    readonly productionVariants: SagemakerEndpointConfigurationProductionVariants[];
}
/**
 * @stability stable
 */
export interface SagemakerEndpointConfigurationDataCaptureConfigCaptureContentTypeHeader {
    /**
     * @stability stable
     */
    readonly csvContentTypes?: string[];
    /**
     * @stability stable
     */
    readonly jsonContentTypes?: string[];
}
/**
 * @stability stable
 */
export interface SagemakerEndpointConfigurationDataCaptureConfigCaptureOptions {
    /**
     * @stability stable
     */
    readonly captureMode: string;
}
/**
 * @stability stable
 */
export interface SagemakerEndpointConfigurationDataCaptureConfig {
    /**
     * @stability stable
     */
    readonly destinationS3Uri: string;
    /**
     * @stability stable
     */
    readonly enableCapture?: boolean;
    /**
     * @stability stable
     */
    readonly initialSamplingPercentage: number;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * capture_content_type_header block.
     *
     * @stability stable
     */
    readonly captureContentTypeHeader?: SagemakerEndpointConfigurationDataCaptureConfigCaptureContentTypeHeader[];
    /**
     * capture_options block.
     *
     * @stability stable
     */
    readonly captureOptions: SagemakerEndpointConfigurationDataCaptureConfigCaptureOptions[];
}
/**
 * @stability stable
 */
export interface SagemakerEndpointConfigurationProductionVariants {
    /**
     * @stability stable
     */
    readonly acceleratorType?: string;
    /**
     * @stability stable
     */
    readonly initialInstanceCount: number;
    /**
     * @stability stable
     */
    readonly initialVariantWeight?: number;
    /**
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * @stability stable
     */
    readonly modelName: string;
    /**
     * @stability stable
     */
    readonly variantName?: string;
}
/**
 * @stability stable
 */
export declare class SagemakerEndpointConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerEndpointConfigurationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyArn?;
    /**
     * @stability stable
     */
    get kmsKeyArn(): string;
    /**
     * @stability stable
     */
    set kmsKeyArn(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyArn(): void;
    /**
     * @stability stable
     */
    get kmsKeyArnInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _dataCaptureConfig?;
    /**
     * @stability stable
     */
    get dataCaptureConfig(): SagemakerEndpointConfigurationDataCaptureConfig[];
    /**
     * @stability stable
     */
    set dataCaptureConfig(value: SagemakerEndpointConfigurationDataCaptureConfig[]);
    /**
     * @stability stable
     */
    resetDataCaptureConfig(): void;
    /**
     * @stability stable
     */
    get dataCaptureConfigInput(): SagemakerEndpointConfigurationDataCaptureConfig[] | undefined;
    private _productionVariants;
    /**
     * @stability stable
     */
    get productionVariants(): SagemakerEndpointConfigurationProductionVariants[];
    /**
     * @stability stable
     */
    set productionVariants(value: SagemakerEndpointConfigurationProductionVariants[]);
    /**
     * @stability stable
     */
    get productionVariantsInput(): SagemakerEndpointConfigurationProductionVariants[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
