import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerFeatureGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly eventTimeFeatureName: string;
    /**
     * @stability stable
     */
    readonly featureGroupName: string;
    /**
     * @stability stable
     */
    readonly recordIdentifierFeatureName: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * feature_definition block.
     *
     * @stability stable
     */
    readonly featureDefinition: SagemakerFeatureGroupFeatureDefinition[];
    /**
     * offline_store_config block.
     *
     * @stability stable
     */
    readonly offlineStoreConfig?: SagemakerFeatureGroupOfflineStoreConfig[];
    /**
     * online_store_config block.
     *
     * @stability stable
     */
    readonly onlineStoreConfig?: SagemakerFeatureGroupOnlineStoreConfig[];
}
/**
 * @stability stable
 */
export interface SagemakerFeatureGroupFeatureDefinition {
    /**
     * @stability stable
     */
    readonly featureName?: string;
    /**
     * @stability stable
     */
    readonly featureType?: string;
}
/**
 * @stability stable
 */
export interface SagemakerFeatureGroupOfflineStoreConfigDataCatalogConfig {
    /**
     * @stability stable
     */
    readonly catalog?: string;
    /**
     * @stability stable
     */
    readonly database?: string;
    /**
     * @stability stable
     */
    readonly tableName?: string;
}
/**
 * @stability stable
 */
export interface SagemakerFeatureGroupOfflineStoreConfigS3StorageConfig {
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly s3Uri: string;
}
/**
 * @stability stable
 */
export interface SagemakerFeatureGroupOfflineStoreConfig {
    /**
     * @stability stable
     */
    readonly disableGlueTableCreation?: boolean;
    /**
     * data_catalog_config block.
     *
     * @stability stable
     */
    readonly dataCatalogConfig?: SagemakerFeatureGroupOfflineStoreConfigDataCatalogConfig[];
    /**
     * s3_storage_config block.
     *
     * @stability stable
     */
    readonly s3StorageConfig: SagemakerFeatureGroupOfflineStoreConfigS3StorageConfig[];
}
/**
 * @stability stable
 */
export interface SagemakerFeatureGroupOnlineStoreConfigSecurityConfig {
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
}
/**
 * @stability stable
 */
export interface SagemakerFeatureGroupOnlineStoreConfig {
    /**
     * @stability stable
     */
    readonly enableOnlineStore?: boolean;
    /**
     * security_config block.
     *
     * @stability stable
     */
    readonly securityConfig?: SagemakerFeatureGroupOnlineStoreConfigSecurityConfig[];
}
/**
 * @stability stable
 */
export declare class SagemakerFeatureGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerFeatureGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _eventTimeFeatureName;
    /**
     * @stability stable
     */
    get eventTimeFeatureName(): string;
    /**
     * @stability stable
     */
    set eventTimeFeatureName(value: string);
    /**
     * @stability stable
     */
    get eventTimeFeatureNameInput(): string;
    private _featureGroupName;
    /**
     * @stability stable
     */
    get featureGroupName(): string;
    /**
     * @stability stable
     */
    set featureGroupName(value: string);
    /**
     * @stability stable
     */
    get featureGroupNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _recordIdentifierFeatureName;
    /**
     * @stability stable
     */
    get recordIdentifierFeatureName(): string;
    /**
     * @stability stable
     */
    set recordIdentifierFeatureName(value: string);
    /**
     * @stability stable
     */
    get recordIdentifierFeatureNameInput(): string;
    private _roleArn;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _featureDefinition;
    /**
     * @stability stable
     */
    get featureDefinition(): SagemakerFeatureGroupFeatureDefinition[];
    /**
     * @stability stable
     */
    set featureDefinition(value: SagemakerFeatureGroupFeatureDefinition[]);
    /**
     * @stability stable
     */
    get featureDefinitionInput(): SagemakerFeatureGroupFeatureDefinition[];
    private _offlineStoreConfig?;
    /**
     * @stability stable
     */
    get offlineStoreConfig(): SagemakerFeatureGroupOfflineStoreConfig[];
    /**
     * @stability stable
     */
    set offlineStoreConfig(value: SagemakerFeatureGroupOfflineStoreConfig[]);
    /**
     * @stability stable
     */
    resetOfflineStoreConfig(): void;
    /**
     * @stability stable
     */
    get offlineStoreConfigInput(): SagemakerFeatureGroupOfflineStoreConfig[] | undefined;
    private _onlineStoreConfig?;
    /**
     * @stability stable
     */
    get onlineStoreConfig(): SagemakerFeatureGroupOnlineStoreConfig[];
    /**
     * @stability stable
     */
    set onlineStoreConfig(value: SagemakerFeatureGroupOnlineStoreConfig[]);
    /**
     * @stability stable
     */
    resetOnlineStoreConfig(): void;
    /**
     * @stability stable
     */
    get onlineStoreConfigInput(): SagemakerFeatureGroupOnlineStoreConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
