import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerImageVersionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly baseImage: string;
    /**
     * @stability stable
     */
    readonly imageName: string;
}
/**
 * @stability stable
 */
export declare class SagemakerImageVersion extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerImageVersionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _baseImage;
    /**
     * @stability stable
     */
    get baseImage(): string;
    /**
     * @stability stable
     */
    set baseImage(value: string);
    /**
     * @stability stable
     */
    get baseImageInput(): string;
    /**
     * @stability stable
     */
    get containerImage(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get imageArn(): string;
    private _imageName;
    /**
     * @stability stable
     */
    get imageName(): string;
    /**
     * @stability stable
     */
    set imageName(value: string);
    /**
     * @stability stable
     */
    get imageNameInput(): string;
    /**
     * @stability stable
     */
    get version(): number;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
