import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerModelPackageGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly modelPackageGroupDescription?: string;
    /**
     * @stability stable
     */
    readonly modelPackageGroupName: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class SagemakerModelPackageGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerModelPackageGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _modelPackageGroupDescription?;
    /**
     * @stability stable
     */
    get modelPackageGroupDescription(): string;
    /**
     * @stability stable
     */
    set modelPackageGroupDescription(value: string);
    /**
     * @stability stable
     */
    resetModelPackageGroupDescription(): void;
    /**
     * @stability stable
     */
    get modelPackageGroupDescriptionInput(): string | undefined;
    private _modelPackageGroupName;
    /**
     * @stability stable
     */
    get modelPackageGroupName(): string;
    /**
     * @stability stable
     */
    set modelPackageGroupName(value: string);
    /**
     * @stability stable
     */
    get modelPackageGroupNameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
