import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerModelConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly enableNetworkIsolation?: boolean;
    /**
     * @stability stable
     */
    readonly executionRoleArn: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * container block.
     *
     * @stability stable
     */
    readonly container?: SagemakerModelContainer[];
    /**
     * primary_container block.
     *
     * @stability stable
     */
    readonly primaryContainer?: SagemakerModelPrimaryContainer[];
    /**
     * vpc_config block.
     *
     * @stability stable
     */
    readonly vpcConfig?: SagemakerModelVpcConfig[];
}
/**
 * @stability stable
 */
export interface SagemakerModelContainerImageConfig {
    /**
     * @stability stable
     */
    readonly repositoryAccessMode: string;
}
/**
 * @stability stable
 */
export interface SagemakerModelContainer {
    /**
     * @stability stable
     */
    readonly containerHostname?: string;
    /**
     * @stability stable
     */
    readonly environment?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly image: string;
    /**
     * @stability stable
     */
    readonly mode?: string;
    /**
     * @stability stable
     */
    readonly modelDataUrl?: string;
    /**
     * image_config block.
     *
     * @stability stable
     */
    readonly imageConfig?: SagemakerModelContainerImageConfig[];
}
/**
 * @stability stable
 */
export interface SagemakerModelPrimaryContainerImageConfig {
    /**
     * @stability stable
     */
    readonly repositoryAccessMode: string;
}
/**
 * @stability stable
 */
export interface SagemakerModelPrimaryContainer {
    /**
     * @stability stable
     */
    readonly containerHostname?: string;
    /**
     * @stability stable
     */
    readonly environment?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly image: string;
    /**
     * @stability stable
     */
    readonly mode?: string;
    /**
     * @stability stable
     */
    readonly modelDataUrl?: string;
    /**
     * image_config block.
     *
     * @stability stable
     */
    readonly imageConfig?: SagemakerModelPrimaryContainerImageConfig[];
}
/**
 * @stability stable
 */
export interface SagemakerModelVpcConfig {
    /**
     * @stability stable
     */
    readonly securityGroupIds: string[];
    /**
     * @stability stable
     */
    readonly subnets: string[];
}
/**
 * @stability stable
 */
export declare class SagemakerModel extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerModelConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _enableNetworkIsolation?;
    /**
     * @stability stable
     */
    get enableNetworkIsolation(): boolean;
    /**
     * @stability stable
     */
    set enableNetworkIsolation(value: boolean);
    /**
     * @stability stable
     */
    resetEnableNetworkIsolation(): void;
    /**
     * @stability stable
     */
    get enableNetworkIsolationInput(): boolean | undefined;
    private _executionRoleArn;
    /**
     * @stability stable
     */
    get executionRoleArn(): string;
    /**
     * @stability stable
     */
    set executionRoleArn(value: string);
    /**
     * @stability stable
     */
    get executionRoleArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _container?;
    /**
     * @stability stable
     */
    get container(): SagemakerModelContainer[];
    /**
     * @stability stable
     */
    set container(value: SagemakerModelContainer[]);
    /**
     * @stability stable
     */
    resetContainer(): void;
    /**
     * @stability stable
     */
    get containerInput(): SagemakerModelContainer[] | undefined;
    private _primaryContainer?;
    /**
     * @stability stable
     */
    get primaryContainer(): SagemakerModelPrimaryContainer[];
    /**
     * @stability stable
     */
    set primaryContainer(value: SagemakerModelPrimaryContainer[]);
    /**
     * @stability stable
     */
    resetPrimaryContainer(): void;
    /**
     * @stability stable
     */
    get primaryContainerInput(): SagemakerModelPrimaryContainer[] | undefined;
    private _vpcConfig?;
    /**
     * @stability stable
     */
    get vpcConfig(): SagemakerModelVpcConfig[];
    /**
     * @stability stable
     */
    set vpcConfig(value: SagemakerModelVpcConfig[]);
    /**
     * @stability stable
     */
    resetVpcConfig(): void;
    /**
     * @stability stable
     */
    get vpcConfigInput(): SagemakerModelVpcConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
