import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerNotebookInstanceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly additionalCodeRepositories?: string[];
    /**
     * @stability stable
     */
    readonly defaultCodeRepository?: string;
    /**
     * @stability stable
     */
    readonly directInternetAccess?: string;
    /**
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly lifecycleConfigName?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly rootAccess?: string;
    /**
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly volumeSize?: number;
}
/**
 * @stability stable
 */
export declare class SagemakerNotebookInstance extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerNotebookInstanceConfig);
    private _additionalCodeRepositories?;
    /**
     * @stability stable
     */
    get additionalCodeRepositories(): string[];
    /**
     * @stability stable
     */
    set additionalCodeRepositories(value: string[]);
    /**
     * @stability stable
     */
    resetAdditionalCodeRepositories(): void;
    /**
     * @stability stable
     */
    get additionalCodeRepositoriesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _defaultCodeRepository?;
    /**
     * @stability stable
     */
    get defaultCodeRepository(): string;
    /**
     * @stability stable
     */
    set defaultCodeRepository(value: string);
    /**
     * @stability stable
     */
    resetDefaultCodeRepository(): void;
    /**
     * @stability stable
     */
    get defaultCodeRepositoryInput(): string | undefined;
    private _directInternetAccess?;
    /**
     * @stability stable
     */
    get directInternetAccess(): string;
    /**
     * @stability stable
     */
    set directInternetAccess(value: string);
    /**
     * @stability stable
     */
    resetDirectInternetAccess(): void;
    /**
     * @stability stable
     */
    get directInternetAccessInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceType;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    get instanceTypeInput(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    private _lifecycleConfigName?;
    /**
     * @stability stable
     */
    get lifecycleConfigName(): string;
    /**
     * @stability stable
     */
    set lifecycleConfigName(value: string);
    /**
     * @stability stable
     */
    resetLifecycleConfigName(): void;
    /**
     * @stability stable
     */
    get lifecycleConfigNameInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get networkInterfaceId(): string;
    private _roleArn;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string;
    private _rootAccess?;
    /**
     * @stability stable
     */
    get rootAccess(): string;
    /**
     * @stability stable
     */
    set rootAccess(value: string);
    /**
     * @stability stable
     */
    resetRootAccess(): void;
    /**
     * @stability stable
     */
    get rootAccessInput(): string | undefined;
    private _securityGroups?;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    set securityGroups(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroups(): void;
    /**
     * @stability stable
     */
    get securityGroupsInput(): string[] | undefined;
    private _subnetId?;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    resetSubnetId(): void;
    /**
     * @stability stable
     */
    get subnetIdInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get url(): string;
    private _volumeSize?;
    /**
     * @stability stable
     */
    get volumeSize(): number;
    /**
     * @stability stable
     */
    set volumeSize(value: number);
    /**
     * @stability stable
     */
    resetVolumeSize(): void;
    /**
     * @stability stable
     */
    get volumeSizeInput(): number | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
