import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SagemakerUserProfileConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly domainId: string;
    /**
     * @stability stable
     */
    readonly singleSignOnUserIdentifier?: string;
    /**
     * @stability stable
     */
    readonly singleSignOnUserValue?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly userProfileName: string;
    /**
     * user_settings block.
     *
     * @stability stable
     */
    readonly userSettings?: SagemakerUserProfileUserSettings[];
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsJupyterServerAppSettingsDefaultResourceSpec {
    /**
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * @stability stable
     */
    readonly sagemakerImageArn?: string;
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsJupyterServerAppSettings {
    /**
     * default_resource_spec block.
     *
     * @stability stable
     */
    readonly defaultResourceSpec: SagemakerUserProfileUserSettingsJupyterServerAppSettingsDefaultResourceSpec[];
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsKernelGatewayAppSettingsCustomImage {
    /**
     * @stability stable
     */
    readonly appImageConfigName: string;
    /**
     * @stability stable
     */
    readonly imageName: string;
    /**
     * @stability stable
     */
    readonly imageVersionNumber?: number;
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsKernelGatewayAppSettingsDefaultResourceSpec {
    /**
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * @stability stable
     */
    readonly sagemakerImageArn?: string;
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsKernelGatewayAppSettings {
    /**
     * custom_image block.
     *
     * @stability stable
     */
    readonly customImage?: SagemakerUserProfileUserSettingsKernelGatewayAppSettingsCustomImage[];
    /**
     * default_resource_spec block.
     *
     * @stability stable
     */
    readonly defaultResourceSpec: SagemakerUserProfileUserSettingsKernelGatewayAppSettingsDefaultResourceSpec[];
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsSharingSettings {
    /**
     * @stability stable
     */
    readonly notebookOutputOption?: string;
    /**
     * @stability stable
     */
    readonly s3KmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly s3OutputPath?: string;
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsTensorBoardAppSettingsDefaultResourceSpec {
    /**
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * @stability stable
     */
    readonly sagemakerImageArn?: string;
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettingsTensorBoardAppSettings {
    /**
     * default_resource_spec block.
     *
     * @stability stable
     */
    readonly defaultResourceSpec: SagemakerUserProfileUserSettingsTensorBoardAppSettingsDefaultResourceSpec[];
}
/**
 * @stability stable
 */
export interface SagemakerUserProfileUserSettings {
    /**
     * @stability stable
     */
    readonly executionRole: string;
    /**
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * jupyter_server_app_settings block.
     *
     * @stability stable
     */
    readonly jupyterServerAppSettings?: SagemakerUserProfileUserSettingsJupyterServerAppSettings[];
    /**
     * kernel_gateway_app_settings block.
     *
     * @stability stable
     */
    readonly kernelGatewayAppSettings?: SagemakerUserProfileUserSettingsKernelGatewayAppSettings[];
    /**
     * sharing_settings block.
     *
     * @stability stable
     */
    readonly sharingSettings?: SagemakerUserProfileUserSettingsSharingSettings[];
    /**
     * tensor_board_app_settings block.
     *
     * @stability stable
     */
    readonly tensorBoardAppSettings?: SagemakerUserProfileUserSettingsTensorBoardAppSettings[];
}
/**
 * @stability stable
 */
export declare class SagemakerUserProfile extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SagemakerUserProfileConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _domainId;
    /**
     * @stability stable
     */
    get domainId(): string;
    /**
     * @stability stable
     */
    set domainId(value: string);
    /**
     * @stability stable
     */
    get domainIdInput(): string;
    /**
     * @stability stable
     */
    get homeEfsFileSystemUid(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _singleSignOnUserIdentifier?;
    /**
     * @stability stable
     */
    get singleSignOnUserIdentifier(): string;
    /**
     * @stability stable
     */
    set singleSignOnUserIdentifier(value: string);
    /**
     * @stability stable
     */
    resetSingleSignOnUserIdentifier(): void;
    /**
     * @stability stable
     */
    get singleSignOnUserIdentifierInput(): string | undefined;
    private _singleSignOnUserValue?;
    /**
     * @stability stable
     */
    get singleSignOnUserValue(): string;
    /**
     * @stability stable
     */
    set singleSignOnUserValue(value: string);
    /**
     * @stability stable
     */
    resetSingleSignOnUserValue(): void;
    /**
     * @stability stable
     */
    get singleSignOnUserValueInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _userProfileName;
    /**
     * @stability stable
     */
    get userProfileName(): string;
    /**
     * @stability stable
     */
    set userProfileName(value: string);
    /**
     * @stability stable
     */
    get userProfileNameInput(): string;
    private _userSettings?;
    /**
     * @stability stable
     */
    get userSettings(): SagemakerUserProfileUserSettings[];
    /**
     * @stability stable
     */
    set userSettings(value: SagemakerUserProfileUserSettings[]);
    /**
     * @stability stable
     */
    resetUserSettings(): void;
    /**
     * @stability stable
     */
    get userSettingsInput(): SagemakerUserProfileUserSettings[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
