import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SecretsmanagerSecretPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly blockPublicPolicy?: boolean;
    /**
     * @stability stable
     */
    readonly policy: string;
    /**
     * @stability stable
     */
    readonly secretArn: string;
}
/**
 * @stability stable
 */
export declare class SecretsmanagerSecretPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SecretsmanagerSecretPolicyConfig);
    private _blockPublicPolicy?;
    /**
     * @stability stable
     */
    get blockPublicPolicy(): boolean;
    /**
     * @stability stable
     */
    set blockPublicPolicy(value: boolean);
    /**
     * @stability stable
     */
    resetBlockPublicPolicy(): void;
    /**
     * @stability stable
     */
    get blockPublicPolicyInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _policy;
    /**
     * @stability stable
     */
    get policy(): string;
    /**
     * @stability stable
     */
    set policy(value: string);
    /**
     * @stability stable
     */
    get policyInput(): string;
    private _secretArn;
    /**
     * @stability stable
     */
    get secretArn(): string;
    /**
     * @stability stable
     */
    set secretArn(value: string);
    /**
     * @stability stable
     */
    get secretArnInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
