import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SecretsmanagerSecretRotationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly rotationLambdaArn: string;
    /**
     * @stability stable
     */
    readonly secretId: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * rotation_rules block.
     *
     * @stability stable
     */
    readonly rotationRules: SecretsmanagerSecretRotationRotationRules[];
}
/**
 * @stability stable
 */
export interface SecretsmanagerSecretRotationRotationRules {
    /**
     * @stability stable
     */
    readonly automaticallyAfterDays: number;
}
/**
 * @stability stable
 */
export declare class SecretsmanagerSecretRotation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SecretsmanagerSecretRotationConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get rotationEnabled(): boolean;
    private _rotationLambdaArn;
    /**
     * @stability stable
     */
    get rotationLambdaArn(): string;
    /**
     * @stability stable
     */
    set rotationLambdaArn(value: string);
    /**
     * @stability stable
     */
    get rotationLambdaArnInput(): string;
    private _secretId;
    /**
     * @stability stable
     */
    get secretId(): string;
    /**
     * @stability stable
     */
    set secretId(value: string);
    /**
     * @stability stable
     */
    get secretIdInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _rotationRules;
    /**
     * @stability stable
     */
    get rotationRules(): SecretsmanagerSecretRotationRotationRules[];
    /**
     * @stability stable
     */
    set rotationRules(value: SecretsmanagerSecretRotationRotationRules[]);
    /**
     * @stability stable
     */
    get rotationRulesInput(): SecretsmanagerSecretRotationRotationRules[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
