import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SecretsmanagerSecretVersionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly secretBinary?: string;
    /**
     * @stability stable
     */
    readonly secretId: string;
    /**
     * @stability stable
     */
    readonly secretString?: string;
    /**
     * @stability stable
     */
    readonly versionStages?: string[];
}
/**
 * @stability stable
 */
export declare class SecretsmanagerSecretVersion extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SecretsmanagerSecretVersionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _secretBinary?;
    /**
     * @stability stable
     */
    get secretBinary(): string;
    /**
     * @stability stable
     */
    set secretBinary(value: string);
    /**
     * @stability stable
     */
    resetSecretBinary(): void;
    /**
     * @stability stable
     */
    get secretBinaryInput(): string | undefined;
    private _secretId;
    /**
     * @stability stable
     */
    get secretId(): string;
    /**
     * @stability stable
     */
    set secretId(value: string);
    /**
     * @stability stable
     */
    get secretIdInput(): string;
    private _secretString?;
    /**
     * @stability stable
     */
    get secretString(): string;
    /**
     * @stability stable
     */
    set secretString(value: string);
    /**
     * @stability stable
     */
    resetSecretString(): void;
    /**
     * @stability stable
     */
    get secretStringInput(): string | undefined;
    /**
     * @stability stable
     */
    get versionId(): string;
    private _versionStages?;
    /**
     * @stability stable
     */
    get versionStages(): string[];
    /**
     * @stability stable
     */
    set versionStages(value: string[]);
    /**
     * @stability stable
     */
    resetVersionStages(): void;
    /**
     * @stability stable
     */
    get versionStagesInput(): string[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
