import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SecretsmanagerSecretConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly policy?: string;
    /**
     * @stability stable
     */
    readonly recoveryWindowInDays?: number;
    /**
     * @stability stable
     */
    readonly rotationLambdaArn?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * rotation_rules block.
     *
     * @stability stable
     */
    readonly rotationRules?: SecretsmanagerSecretRotationRules[];
}
/**
 * @stability stable
 */
export interface SecretsmanagerSecretRotationRules {
    /**
     * @stability stable
     */
    readonly automaticallyAfterDays: number;
}
/**
 * @stability stable
 */
export declare class SecretsmanagerSecret extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: SecretsmanagerSecretConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsKeyId?;
    /**
     * @stability stable
     */
    get kmsKeyId(): string;
    /**
     * @stability stable
     */
    set kmsKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyId(): void;
    /**
     * @stability stable
     */
    get kmsKeyIdInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _policy?;
    /**
     * @stability stable
     */
    get policy(): string;
    /**
     * @stability stable
     */
    set policy(value: string);
    /**
     * @stability stable
     */
    resetPolicy(): void;
    /**
     * @stability stable
     */
    get policyInput(): string | undefined;
    private _recoveryWindowInDays?;
    /**
     * @stability stable
     */
    get recoveryWindowInDays(): number;
    /**
     * @stability stable
     */
    set recoveryWindowInDays(value: number);
    /**
     * @stability stable
     */
    resetRecoveryWindowInDays(): void;
    /**
     * @stability stable
     */
    get recoveryWindowInDaysInput(): number | undefined;
    /**
     * @stability stable
     */
    get rotationEnabled(): boolean;
    private _rotationLambdaArn?;
    /**
     * @stability stable
     */
    get rotationLambdaArn(): string;
    /**
     * @stability stable
     */
    set rotationLambdaArn(value: string);
    /**
     * @stability stable
     */
    resetRotationLambdaArn(): void;
    /**
     * @stability stable
     */
    get rotationLambdaArnInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _rotationRules?;
    /**
     * @stability stable
     */
    get rotationRules(): SecretsmanagerSecretRotationRules[];
    /**
     * @stability stable
     */
    set rotationRules(value: SecretsmanagerSecretRotationRules[]);
    /**
     * @stability stable
     */
    resetRotationRules(): void;
    /**
     * @stability stable
     */
    get rotationRulesInput(): SecretsmanagerSecretRotationRules[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
