import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SecurityGroupRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly cidrBlocks?: string[];
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly fromPort: number;
    /**
     * @stability stable
     */
    readonly ipv6CidrBlocks?: string[];
    /**
     * @stability stable
     */
    readonly prefixListIds?: string[];
    /**
     * @stability stable
     */
    readonly protocol: string;
    /**
     * @stability stable
     */
    readonly securityGroupId: string;
    /**
     * @stability stable
     */
    readonly selfAttribute?: boolean;
    /**
     * @stability stable
     */
    readonly sourceSecurityGroupId?: string;
    /**
     * @stability stable
     */
    readonly toPort: number;
    /**
     * Type of rule, ingress (inbound) or egress (outbound).
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export declare class SecurityGroupRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SecurityGroupRuleConfig);
    private _cidrBlocks?;
    /**
     * @stability stable
     */
    get cidrBlocks(): string[];
    /**
     * @stability stable
     */
    set cidrBlocks(value: string[]);
    /**
     * @stability stable
     */
    resetCidrBlocks(): void;
    /**
     * @stability stable
     */
    get cidrBlocksInput(): string[] | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _fromPort;
    /**
     * @stability stable
     */
    get fromPort(): number;
    /**
     * @stability stable
     */
    set fromPort(value: number);
    /**
     * @stability stable
     */
    get fromPortInput(): number;
    /**
     * @stability stable
     */
    get id(): string;
    private _ipv6CidrBlocks?;
    /**
     * @stability stable
     */
    get ipv6CidrBlocks(): string[];
    /**
     * @stability stable
     */
    set ipv6CidrBlocks(value: string[]);
    /**
     * @stability stable
     */
    resetIpv6CidrBlocks(): void;
    /**
     * @stability stable
     */
    get ipv6CidrBlocksInput(): string[] | undefined;
    private _prefixListIds?;
    /**
     * @stability stable
     */
    get prefixListIds(): string[];
    /**
     * @stability stable
     */
    set prefixListIds(value: string[]);
    /**
     * @stability stable
     */
    resetPrefixListIds(): void;
    /**
     * @stability stable
     */
    get prefixListIdsInput(): string[] | undefined;
    private _protocol;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    set protocol(value: string);
    /**
     * @stability stable
     */
    get protocolInput(): string;
    private _securityGroupId;
    /**
     * @stability stable
     */
    get securityGroupId(): string;
    /**
     * @stability stable
     */
    set securityGroupId(value: string);
    /**
     * @stability stable
     */
    get securityGroupIdInput(): string;
    private _self?;
    /**
     * @stability stable
     */
    get selfAttribute(): boolean;
    /**
     * @stability stable
     */
    set selfAttribute(value: boolean);
    /**
     * @stability stable
     */
    resetSelfAttribute(): void;
    /**
     * @stability stable
     */
    get selfAttributeInput(): boolean | undefined;
    private _sourceSecurityGroupId?;
    /**
     * @stability stable
     */
    get sourceSecurityGroupId(): string;
    /**
     * @stability stable
     */
    set sourceSecurityGroupId(value: string);
    /**
     * @stability stable
     */
    resetSourceSecurityGroupId(): void;
    /**
     * @stability stable
     */
    get sourceSecurityGroupIdInput(): string | undefined;
    private _toPort;
    /**
     * @stability stable
     */
    get toPort(): number;
    /**
     * @stability stable
     */
    set toPort(value: number);
    /**
     * @stability stable
     */
    get toPortInput(): number;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
