import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SecurityGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly egress?: SecurityGroupEgress[];
    /**
     * @stability stable
     */
    readonly ingress?: SecurityGroupIngress[];
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly revokeRulesOnDelete?: boolean;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcId?: string;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: SecurityGroupTimeouts;
}
/**
 * @stability stable
 */
export interface SecurityGroupEgress {
    /**
     * @stability stable
     */
    readonly cidrBlocks?: string[];
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly fromPort?: number;
    /**
     * @stability stable
     */
    readonly ipv6CidrBlocks?: string[];
    /**
     * @stability stable
     */
    readonly prefixListIds?: string[];
    /**
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * @stability stable
     */
    readonly selfAttribute?: boolean;
    /**
     * @stability stable
     */
    readonly toPort?: number;
}
/**
 * @stability stable
 */
export interface SecurityGroupIngress {
    /**
     * @stability stable
     */
    readonly cidrBlocks?: string[];
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly fromPort?: number;
    /**
     * @stability stable
     */
    readonly ipv6CidrBlocks?: string[];
    /**
     * @stability stable
     */
    readonly prefixListIds?: string[];
    /**
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * @stability stable
     */
    readonly selfAttribute?: boolean;
    /**
     * @stability stable
     */
    readonly toPort?: number;
}
/**
 * @stability stable
 */
export interface SecurityGroupTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export declare class SecurityGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: SecurityGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _egress?;
    /**
     * @stability stable
     */
    get egress(): SecurityGroupEgress[];
    /**
     * @stability stable
     */
    set egress(value: SecurityGroupEgress[]);
    /**
     * @stability stable
     */
    resetEgress(): void;
    /**
     * @stability stable
     */
    get egressInput(): SecurityGroupEgress[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _ingress?;
    /**
     * @stability stable
     */
    get ingress(): SecurityGroupIngress[];
    /**
     * @stability stable
     */
    set ingress(value: SecurityGroupIngress[]);
    /**
     * @stability stable
     */
    resetIngress(): void;
    /**
     * @stability stable
     */
    get ingressInput(): SecurityGroupIngress[] | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _revokeRulesOnDelete?;
    /**
     * @stability stable
     */
    get revokeRulesOnDelete(): boolean;
    /**
     * @stability stable
     */
    set revokeRulesOnDelete(value: boolean);
    /**
     * @stability stable
     */
    resetRevokeRulesOnDelete(): void;
    /**
     * @stability stable
     */
    get revokeRulesOnDeleteInput(): boolean | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    resetVpcId(): void;
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): SecurityGroupTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: SecurityGroupTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): SecurityGroupTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
