import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SecurityhubMemberConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly accountId: string;
    /**
     * @stability stable
     */
    readonly email: string;
    /**
     * @stability stable
     */
    readonly invite?: boolean;
}
/**
 * @stability stable
 */
export declare class SecurityhubMember extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SecurityhubMemberConfig);
    private _accountId;
    /**
     * @stability stable
     */
    get accountId(): string;
    /**
     * @stability stable
     */
    set accountId(value: string);
    /**
     * @stability stable
     */
    get accountIdInput(): string;
    private _email;
    /**
     * @stability stable
     */
    get email(): string;
    /**
     * @stability stable
     */
    set email(value: string);
    /**
     * @stability stable
     */
    get emailInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _invite?;
    /**
     * @stability stable
     */
    get invite(): boolean;
    /**
     * @stability stable
     */
    set invite(value: boolean);
    /**
     * @stability stable
     */
    resetInvite(): void;
    /**
     * @stability stable
     */
    get inviteInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get masterId(): string;
    /**
     * @stability stable
     */
    get memberStatus(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
