import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ServiceDiscoveryServiceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly namespaceId?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * dns_config block.
     *
     * @stability stable
     */
    readonly dnsConfig?: ServiceDiscoveryServiceDnsConfig[];
    /**
     * health_check_config block.
     *
     * @stability stable
     */
    readonly healthCheckConfig?: ServiceDiscoveryServiceHealthCheckConfig[];
    /**
     * health_check_custom_config block.
     *
     * @stability stable
     */
    readonly healthCheckCustomConfig?: ServiceDiscoveryServiceHealthCheckCustomConfig[];
}
/**
 * @stability stable
 */
export interface ServiceDiscoveryServiceDnsConfigDnsRecords {
    /**
     * @stability stable
     */
    readonly ttl: number;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface ServiceDiscoveryServiceDnsConfig {
    /**
     * @stability stable
     */
    readonly namespaceId: string;
    /**
     * @stability stable
     */
    readonly routingPolicy?: string;
    /**
     * dns_records block.
     *
     * @stability stable
     */
    readonly dnsRecords: ServiceDiscoveryServiceDnsConfigDnsRecords[];
}
/**
 * @stability stable
 */
export interface ServiceDiscoveryServiceHealthCheckConfig {
    /**
     * @stability stable
     */
    readonly failureThreshold?: number;
    /**
     * @stability stable
     */
    readonly resourcePath?: string;
    /**
     * @stability stable
     */
    readonly type?: string;
}
/**
 * @stability stable
 */
export interface ServiceDiscoveryServiceHealthCheckCustomConfig {
    /**
     * @stability stable
     */
    readonly failureThreshold?: number;
}
/**
 * @stability stable
 */
export declare class ServiceDiscoveryService extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ServiceDiscoveryServiceConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _namespaceId?;
    /**
     * @stability stable
     */
    get namespaceId(): string;
    /**
     * @stability stable
     */
    set namespaceId(value: string);
    /**
     * @stability stable
     */
    resetNamespaceId(): void;
    /**
     * @stability stable
     */
    get namespaceIdInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _dnsConfig?;
    /**
     * @stability stable
     */
    get dnsConfig(): ServiceDiscoveryServiceDnsConfig[];
    /**
     * @stability stable
     */
    set dnsConfig(value: ServiceDiscoveryServiceDnsConfig[]);
    /**
     * @stability stable
     */
    resetDnsConfig(): void;
    /**
     * @stability stable
     */
    get dnsConfigInput(): ServiceDiscoveryServiceDnsConfig[] | undefined;
    private _healthCheckConfig?;
    /**
     * @stability stable
     */
    get healthCheckConfig(): ServiceDiscoveryServiceHealthCheckConfig[];
    /**
     * @stability stable
     */
    set healthCheckConfig(value: ServiceDiscoveryServiceHealthCheckConfig[]);
    /**
     * @stability stable
     */
    resetHealthCheckConfig(): void;
    /**
     * @stability stable
     */
    get healthCheckConfigInput(): ServiceDiscoveryServiceHealthCheckConfig[] | undefined;
    private _healthCheckCustomConfig?;
    /**
     * @stability stable
     */
    get healthCheckCustomConfig(): ServiceDiscoveryServiceHealthCheckCustomConfig[];
    /**
     * @stability stable
     */
    set healthCheckCustomConfig(value: ServiceDiscoveryServiceHealthCheckCustomConfig[]);
    /**
     * @stability stable
     */
    resetHealthCheckCustomConfig(): void;
    /**
     * @stability stable
     */
    get healthCheckCustomConfigInput(): ServiceDiscoveryServiceHealthCheckCustomConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
