import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SesConfigurationSetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * delivery_options block.
     *
     * @stability stable
     */
    readonly deliveryOptions?: SesConfigurationSetDeliveryOptions[];
}
/**
 * @stability stable
 */
export interface SesConfigurationSetDeliveryOptions {
    /**
     * @stability stable
     */
    readonly tlsPolicy?: string;
}
/**
 * @stability stable
 */
export declare class SesConfigurationSet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SesConfigurationSetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _deliveryOptions?;
    /**
     * @stability stable
     */
    get deliveryOptions(): SesConfigurationSetDeliveryOptions[];
    /**
     * @stability stable
     */
    set deliveryOptions(value: SesConfigurationSetDeliveryOptions[]);
    /**
     * @stability stable
     */
    resetDeliveryOptions(): void;
    /**
     * @stability stable
     */
    get deliveryOptionsInput(): SesConfigurationSetDeliveryOptions[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
