import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SesDomainIdentityVerificationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly domain: string;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: SesDomainIdentityVerificationTimeouts;
}
/**
 * @stability stable
 */
export interface SesDomainIdentityVerificationTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
}
/**
 * @stability stable
 */
export declare class SesDomainIdentityVerification extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SesDomainIdentityVerificationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _domain;
    /**
     * @stability stable
     */
    get domain(): string;
    /**
     * @stability stable
     */
    set domain(value: string);
    /**
     * @stability stable
     */
    get domainInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): SesDomainIdentityVerificationTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: SesDomainIdentityVerificationTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): SesDomainIdentityVerificationTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
