import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SesDomainMailFromConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly behaviorOnMxFailure?: string;
    /**
     * @stability stable
     */
    readonly domain: string;
    /**
     * @stability stable
     */
    readonly mailFromDomain: string;
}
/**
 * @stability stable
 */
export declare class SesDomainMailFrom extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SesDomainMailFromConfig);
    private _behaviorOnMxFailure?;
    /**
     * @stability stable
     */
    get behaviorOnMxFailure(): string;
    /**
     * @stability stable
     */
    set behaviorOnMxFailure(value: string);
    /**
     * @stability stable
     */
    resetBehaviorOnMxFailure(): void;
    /**
     * @stability stable
     */
    get behaviorOnMxFailureInput(): string | undefined;
    private _domain;
    /**
     * @stability stable
     */
    get domain(): string;
    /**
     * @stability stable
     */
    set domain(value: string);
    /**
     * @stability stable
     */
    get domainInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _mailFromDomain;
    /**
     * @stability stable
     */
    get mailFromDomain(): string;
    /**
     * @stability stable
     */
    set mailFromDomain(value: string);
    /**
     * @stability stable
     */
    get mailFromDomainInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
