import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SesEventDestinationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly configurationSetName: string;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly matchingTypes: string[];
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * cloudwatch_destination block.
     *
     * @stability stable
     */
    readonly cloudwatchDestination?: SesEventDestinationCloudwatchDestination[];
    /**
     * kinesis_destination block.
     *
     * @stability stable
     */
    readonly kinesisDestination?: SesEventDestinationKinesisDestination[];
    /**
     * sns_destination block.
     *
     * @stability stable
     */
    readonly snsDestination?: SesEventDestinationSnsDestination[];
}
/**
 * @stability stable
 */
export interface SesEventDestinationCloudwatchDestination {
    /**
     * @stability stable
     */
    readonly defaultValue: string;
    /**
     * @stability stable
     */
    readonly dimensionName: string;
    /**
     * @stability stable
     */
    readonly valueSource: string;
}
/**
 * @stability stable
 */
export interface SesEventDestinationKinesisDestination {
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly streamArn: string;
}
/**
 * @stability stable
 */
export interface SesEventDestinationSnsDestination {
    /**
     * @stability stable
     */
    readonly topicArn: string;
}
/**
 * @stability stable
 */
export declare class SesEventDestination extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SesEventDestinationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _configurationSetName;
    /**
     * @stability stable
     */
    get configurationSetName(): string;
    /**
     * @stability stable
     */
    set configurationSetName(value: string);
    /**
     * @stability stable
     */
    get configurationSetNameInput(): string;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _matchingTypes;
    /**
     * @stability stable
     */
    get matchingTypes(): string[];
    /**
     * @stability stable
     */
    set matchingTypes(value: string[]);
    /**
     * @stability stable
     */
    get matchingTypesInput(): string[];
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _cloudwatchDestination?;
    /**
     * @stability stable
     */
    get cloudwatchDestination(): SesEventDestinationCloudwatchDestination[];
    /**
     * @stability stable
     */
    set cloudwatchDestination(value: SesEventDestinationCloudwatchDestination[]);
    /**
     * @stability stable
     */
    resetCloudwatchDestination(): void;
    /**
     * @stability stable
     */
    get cloudwatchDestinationInput(): SesEventDestinationCloudwatchDestination[] | undefined;
    private _kinesisDestination?;
    /**
     * @stability stable
     */
    get kinesisDestination(): SesEventDestinationKinesisDestination[];
    /**
     * @stability stable
     */
    set kinesisDestination(value: SesEventDestinationKinesisDestination[]);
    /**
     * @stability stable
     */
    resetKinesisDestination(): void;
    /**
     * @stability stable
     */
    get kinesisDestinationInput(): SesEventDestinationKinesisDestination[] | undefined;
    private _snsDestination?;
    /**
     * @stability stable
     */
    get snsDestination(): SesEventDestinationSnsDestination[];
    /**
     * @stability stable
     */
    set snsDestination(value: SesEventDestinationSnsDestination[]);
    /**
     * @stability stable
     */
    resetSnsDestination(): void;
    /**
     * @stability stable
     */
    get snsDestinationInput(): SesEventDestinationSnsDestination[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
