import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SesReceiptRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly after?: string;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly recipients?: string[];
    /**
     * @stability stable
     */
    readonly ruleSetName: string;
    /**
     * @stability stable
     */
    readonly scanEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly tlsPolicy?: string;
    /**
     * add_header_action block.
     *
     * @stability stable
     */
    readonly addHeaderAction?: SesReceiptRuleAddHeaderAction[];
    /**
     * bounce_action block.
     *
     * @stability stable
     */
    readonly bounceAction?: SesReceiptRuleBounceAction[];
    /**
     * lambda_action block.
     *
     * @stability stable
     */
    readonly lambdaAction?: SesReceiptRuleLambdaAction[];
    /**
     * s3_action block.
     *
     * @stability stable
     */
    readonly s3Action?: SesReceiptRuleS3Action[];
    /**
     * sns_action block.
     *
     * @stability stable
     */
    readonly snsAction?: SesReceiptRuleSnsAction[];
    /**
     * stop_action block.
     *
     * @stability stable
     */
    readonly stopAction?: SesReceiptRuleStopAction[];
    /**
     * workmail_action block.
     *
     * @stability stable
     */
    readonly workmailAction?: SesReceiptRuleWorkmailAction[];
}
/**
 * @stability stable
 */
export interface SesReceiptRuleAddHeaderAction {
    /**
     * @stability stable
     */
    readonly headerName: string;
    /**
     * @stability stable
     */
    readonly headerValue: string;
    /**
     * @stability stable
     */
    readonly position: number;
}
/**
 * @stability stable
 */
export interface SesReceiptRuleBounceAction {
    /**
     * @stability stable
     */
    readonly message: string;
    /**
     * @stability stable
     */
    readonly position: number;
    /**
     * @stability stable
     */
    readonly sender: string;
    /**
     * @stability stable
     */
    readonly smtpReplyCode: string;
    /**
     * @stability stable
     */
    readonly statusCode?: string;
    /**
     * @stability stable
     */
    readonly topicArn?: string;
}
/**
 * @stability stable
 */
export interface SesReceiptRuleLambdaAction {
    /**
     * @stability stable
     */
    readonly functionArn: string;
    /**
     * @stability stable
     */
    readonly invocationType?: string;
    /**
     * @stability stable
     */
    readonly position: number;
    /**
     * @stability stable
     */
    readonly topicArn?: string;
}
/**
 * @stability stable
 */
export interface SesReceiptRuleS3Action {
    /**
     * @stability stable
     */
    readonly bucketName: string;
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * @stability stable
     */
    readonly objectKeyPrefix?: string;
    /**
     * @stability stable
     */
    readonly position: number;
    /**
     * @stability stable
     */
    readonly topicArn?: string;
}
/**
 * @stability stable
 */
export interface SesReceiptRuleSnsAction {
    /**
     * @stability stable
     */
    readonly position: number;
    /**
     * @stability stable
     */
    readonly topicArn: string;
}
/**
 * @stability stable
 */
export interface SesReceiptRuleStopAction {
    /**
     * @stability stable
     */
    readonly position: number;
    /**
     * @stability stable
     */
    readonly scope: string;
    /**
     * @stability stable
     */
    readonly topicArn?: string;
}
/**
 * @stability stable
 */
export interface SesReceiptRuleWorkmailAction {
    /**
     * @stability stable
     */
    readonly organizationArn: string;
    /**
     * @stability stable
     */
    readonly position: number;
    /**
     * @stability stable
     */
    readonly topicArn?: string;
}
/**
 * @stability stable
 */
export declare class SesReceiptRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SesReceiptRuleConfig);
    private _after?;
    /**
     * @stability stable
     */
    get after(): string;
    /**
     * @stability stable
     */
    set after(value: string);
    /**
     * @stability stable
     */
    resetAfter(): void;
    /**
     * @stability stable
     */
    get afterInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _recipients?;
    /**
     * @stability stable
     */
    get recipients(): string[];
    /**
     * @stability stable
     */
    set recipients(value: string[]);
    /**
     * @stability stable
     */
    resetRecipients(): void;
    /**
     * @stability stable
     */
    get recipientsInput(): string[] | undefined;
    private _ruleSetName;
    /**
     * @stability stable
     */
    get ruleSetName(): string;
    /**
     * @stability stable
     */
    set ruleSetName(value: string);
    /**
     * @stability stable
     */
    get ruleSetNameInput(): string;
    private _scanEnabled?;
    /**
     * @stability stable
     */
    get scanEnabled(): boolean;
    /**
     * @stability stable
     */
    set scanEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetScanEnabled(): void;
    /**
     * @stability stable
     */
    get scanEnabledInput(): boolean | undefined;
    private _tlsPolicy?;
    /**
     * @stability stable
     */
    get tlsPolicy(): string;
    /**
     * @stability stable
     */
    set tlsPolicy(value: string);
    /**
     * @stability stable
     */
    resetTlsPolicy(): void;
    /**
     * @stability stable
     */
    get tlsPolicyInput(): string | undefined;
    private _addHeaderAction?;
    /**
     * @stability stable
     */
    get addHeaderAction(): SesReceiptRuleAddHeaderAction[];
    /**
     * @stability stable
     */
    set addHeaderAction(value: SesReceiptRuleAddHeaderAction[]);
    /**
     * @stability stable
     */
    resetAddHeaderAction(): void;
    /**
     * @stability stable
     */
    get addHeaderActionInput(): SesReceiptRuleAddHeaderAction[] | undefined;
    private _bounceAction?;
    /**
     * @stability stable
     */
    get bounceAction(): SesReceiptRuleBounceAction[];
    /**
     * @stability stable
     */
    set bounceAction(value: SesReceiptRuleBounceAction[]);
    /**
     * @stability stable
     */
    resetBounceAction(): void;
    /**
     * @stability stable
     */
    get bounceActionInput(): SesReceiptRuleBounceAction[] | undefined;
    private _lambdaAction?;
    /**
     * @stability stable
     */
    get lambdaAction(): SesReceiptRuleLambdaAction[];
    /**
     * @stability stable
     */
    set lambdaAction(value: SesReceiptRuleLambdaAction[]);
    /**
     * @stability stable
     */
    resetLambdaAction(): void;
    /**
     * @stability stable
     */
    get lambdaActionInput(): SesReceiptRuleLambdaAction[] | undefined;
    private _s3Action?;
    /**
     * @stability stable
     */
    get s3Action(): SesReceiptRuleS3Action[];
    /**
     * @stability stable
     */
    set s3Action(value: SesReceiptRuleS3Action[]);
    /**
     * @stability stable
     */
    resetS3Action(): void;
    /**
     * @stability stable
     */
    get s3ActionInput(): SesReceiptRuleS3Action[] | undefined;
    private _snsAction?;
    /**
     * @stability stable
     */
    get snsAction(): SesReceiptRuleSnsAction[];
    /**
     * @stability stable
     */
    set snsAction(value: SesReceiptRuleSnsAction[]);
    /**
     * @stability stable
     */
    resetSnsAction(): void;
    /**
     * @stability stable
     */
    get snsActionInput(): SesReceiptRuleSnsAction[] | undefined;
    private _stopAction?;
    /**
     * @stability stable
     */
    get stopAction(): SesReceiptRuleStopAction[];
    /**
     * @stability stable
     */
    set stopAction(value: SesReceiptRuleStopAction[]);
    /**
     * @stability stable
     */
    resetStopAction(): void;
    /**
     * @stability stable
     */
    get stopActionInput(): SesReceiptRuleStopAction[] | undefined;
    private _workmailAction?;
    /**
     * @stability stable
     */
    get workmailAction(): SesReceiptRuleWorkmailAction[];
    /**
     * @stability stable
     */
    set workmailAction(value: SesReceiptRuleWorkmailAction[]);
    /**
     * @stability stable
     */
    resetWorkmailAction(): void;
    /**
     * @stability stable
     */
    get workmailActionInput(): SesReceiptRuleWorkmailAction[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
