import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SesTemplateConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly html?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly subject?: string;
    /**
     * @stability stable
     */
    readonly text?: string;
}
/**
 * @stability stable
 */
export declare class SesTemplate extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SesTemplateConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _html?;
    /**
     * @stability stable
     */
    get html(): string;
    /**
     * @stability stable
     */
    set html(value: string);
    /**
     * @stability stable
     */
    resetHtml(): void;
    /**
     * @stability stable
     */
    get htmlInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _subject?;
    /**
     * @stability stable
     */
    get subject(): string;
    /**
     * @stability stable
     */
    set subject(value: string);
    /**
     * @stability stable
     */
    resetSubject(): void;
    /**
     * @stability stable
     */
    get subjectInput(): string | undefined;
    private _text?;
    /**
     * @stability stable
     */
    get text(): string;
    /**
     * @stability stable
     */
    set text(value: string);
    /**
     * @stability stable
     */
    resetText(): void;
    /**
     * @stability stable
     */
    get textInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
