import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SfnStateMachineConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly definition: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly type?: string;
    /**
     * logging_configuration block.
     *
     * @stability stable
     */
    readonly loggingConfiguration?: SfnStateMachineLoggingConfiguration[];
}
/**
 * @stability stable
 */
export interface SfnStateMachineLoggingConfiguration {
    /**
     * @stability stable
     */
    readonly includeExecutionData?: boolean;
    /**
     * @stability stable
     */
    readonly level?: string;
    /**
     * @stability stable
     */
    readonly logDestination?: string;
}
/**
 * @stability stable
 */
export declare class SfnStateMachine extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SfnStateMachineConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get creationDate(): string;
    private _definition;
    /**
     * @stability stable
     */
    get definition(): string;
    /**
     * @stability stable
     */
    set definition(value: string);
    /**
     * @stability stable
     */
    get definitionInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _roleArn;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _loggingConfiguration?;
    /**
     * @stability stable
     */
    get loggingConfiguration(): SfnStateMachineLoggingConfiguration[];
    /**
     * @stability stable
     */
    set loggingConfiguration(value: SfnStateMachineLoggingConfiguration[]);
    /**
     * @stability stable
     */
    resetLoggingConfiguration(): void;
    /**
     * @stability stable
     */
    get loggingConfigurationInput(): SfnStateMachineLoggingConfiguration[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
