import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SignerSigningProfilePermissionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly action: string;
    /**
     * @stability stable
     */
    readonly principal: string;
    /**
     * @stability stable
     */
    readonly profileName: string;
    /**
     * @stability stable
     */
    readonly profileVersion?: string;
    /**
     * @stability stable
     */
    readonly statementId?: string;
    /**
     * @stability stable
     */
    readonly statementIdPrefix?: string;
}
/**
 * @stability stable
 */
export declare class SignerSigningProfilePermission extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SignerSigningProfilePermissionConfig);
    private _action;
    /**
     * @stability stable
     */
    get action(): string;
    /**
     * @stability stable
     */
    set action(value: string);
    /**
     * @stability stable
     */
    get actionInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _principal;
    /**
     * @stability stable
     */
    get principal(): string;
    /**
     * @stability stable
     */
    set principal(value: string);
    /**
     * @stability stable
     */
    get principalInput(): string;
    private _profileName;
    /**
     * @stability stable
     */
    get profileName(): string;
    /**
     * @stability stable
     */
    set profileName(value: string);
    /**
     * @stability stable
     */
    get profileNameInput(): string;
    private _profileVersion?;
    /**
     * @stability stable
     */
    get profileVersion(): string;
    /**
     * @stability stable
     */
    set profileVersion(value: string);
    /**
     * @stability stable
     */
    resetProfileVersion(): void;
    /**
     * @stability stable
     */
    get profileVersionInput(): string | undefined;
    private _statementId?;
    /**
     * @stability stable
     */
    get statementId(): string;
    /**
     * @stability stable
     */
    set statementId(value: string);
    /**
     * @stability stable
     */
    resetStatementId(): void;
    /**
     * @stability stable
     */
    get statementIdInput(): string | undefined;
    private _statementIdPrefix?;
    /**
     * @stability stable
     */
    get statementIdPrefix(): string;
    /**
     * @stability stable
     */
    set statementIdPrefix(value: string);
    /**
     * @stability stable
     */
    resetStatementIdPrefix(): void;
    /**
     * @stability stable
     */
    get statementIdPrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
