import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SignerSigningProfileConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly platformId: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * signature_validity_period block.
     *
     * @stability stable
     */
    readonly signatureValidityPeriod?: SignerSigningProfileSignatureValidityPeriod[];
}
/**
 * @stability stable
 */
export declare class SignerSigningProfileRevocationRecord extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get revocationEffectiveFrom(): string;
    /**
     * @stability stable
     */
    get revokedAt(): string;
    /**
     * @stability stable
     */
    get revokedBy(): string;
}
/**
 * @stability stable
 */
export interface SignerSigningProfileSignatureValidityPeriod {
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly value: number;
}
/**
 * @stability stable
 */
export declare class SignerSigningProfile extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SignerSigningProfileConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    /**
     * @stability stable
     */
    get platformDisplayName(): string;
    private _platformId;
    /**
     * @stability stable
     */
    get platformId(): string;
    /**
     * @stability stable
     */
    set platformId(value: string);
    /**
     * @stability stable
     */
    get platformIdInput(): string;
    /**
     * @stability stable
     */
    revocationRecord(index: string): SignerSigningProfileRevocationRecord;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get version(): string;
    /**
     * @stability stable
     */
    get versionArn(): string;
    private _signatureValidityPeriod?;
    /**
     * @stability stable
     */
    get signatureValidityPeriod(): SignerSigningProfileSignatureValidityPeriod[];
    /**
     * @stability stable
     */
    set signatureValidityPeriod(value: SignerSigningProfileSignatureValidityPeriod[]);
    /**
     * @stability stable
     */
    resetSignatureValidityPeriod(): void;
    /**
     * @stability stable
     */
    get signatureValidityPeriodInput(): SignerSigningProfileSignatureValidityPeriod[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
