import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SnsSmsPreferencesConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly defaultSenderId?: string;
    /**
     * @stability stable
     */
    readonly defaultSmsType?: string;
    /**
     * @stability stable
     */
    readonly deliveryStatusIamRoleArn?: string;
    /**
     * @stability stable
     */
    readonly deliveryStatusSuccessSamplingRate?: string;
    /**
     * @stability stable
     */
    readonly monthlySpendLimit?: string;
    /**
     * @stability stable
     */
    readonly usageReportS3Bucket?: string;
}
/**
 * @stability stable
 */
export declare class SnsSmsPreferences extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: SnsSmsPreferencesConfig);
    private _defaultSenderId?;
    /**
     * @stability stable
     */
    get defaultSenderId(): string;
    /**
     * @stability stable
     */
    set defaultSenderId(value: string);
    /**
     * @stability stable
     */
    resetDefaultSenderId(): void;
    /**
     * @stability stable
     */
    get defaultSenderIdInput(): string | undefined;
    private _defaultSmsType?;
    /**
     * @stability stable
     */
    get defaultSmsType(): string;
    /**
     * @stability stable
     */
    set defaultSmsType(value: string);
    /**
     * @stability stable
     */
    resetDefaultSmsType(): void;
    /**
     * @stability stable
     */
    get defaultSmsTypeInput(): string | undefined;
    private _deliveryStatusIamRoleArn?;
    /**
     * @stability stable
     */
    get deliveryStatusIamRoleArn(): string;
    /**
     * @stability stable
     */
    set deliveryStatusIamRoleArn(value: string);
    /**
     * @stability stable
     */
    resetDeliveryStatusIamRoleArn(): void;
    /**
     * @stability stable
     */
    get deliveryStatusIamRoleArnInput(): string | undefined;
    private _deliveryStatusSuccessSamplingRate?;
    /**
     * @stability stable
     */
    get deliveryStatusSuccessSamplingRate(): string;
    /**
     * @stability stable
     */
    set deliveryStatusSuccessSamplingRate(value: string);
    /**
     * @stability stable
     */
    resetDeliveryStatusSuccessSamplingRate(): void;
    /**
     * @stability stable
     */
    get deliveryStatusSuccessSamplingRateInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _monthlySpendLimit?;
    /**
     * @stability stable
     */
    get monthlySpendLimit(): string;
    /**
     * @stability stable
     */
    set monthlySpendLimit(value: string);
    /**
     * @stability stable
     */
    resetMonthlySpendLimit(): void;
    /**
     * @stability stable
     */
    get monthlySpendLimitInput(): string | undefined;
    private _usageReportS3Bucket?;
    /**
     * @stability stable
     */
    get usageReportS3Bucket(): string;
    /**
     * @stability stable
     */
    set usageReportS3Bucket(value: string);
    /**
     * @stability stable
     */
    resetUsageReportS3Bucket(): void;
    /**
     * @stability stable
     */
    get usageReportS3BucketInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
