import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SnsTopicSubscriptionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly confirmationTimeoutInMinutes?: number;
    /**
     * @stability stable
     */
    readonly deliveryPolicy?: string;
    /**
     * @stability stable
     */
    readonly endpoint: string;
    /**
     * @stability stable
     */
    readonly endpointAutoConfirms?: boolean;
    /**
     * @stability stable
     */
    readonly filterPolicy?: string;
    /**
     * @stability stable
     */
    readonly protocol: string;
    /**
     * @stability stable
     */
    readonly rawMessageDelivery?: boolean;
    /**
     * @stability stable
     */
    readonly redrivePolicy?: string;
    /**
     * @stability stable
     */
    readonly subscriptionRoleArn?: string;
    /**
     * @stability stable
     */
    readonly topicArn: string;
}
/**
 * @stability stable
 */
export declare class SnsTopicSubscription extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SnsTopicSubscriptionConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _confirmationTimeoutInMinutes?;
    /**
     * @stability stable
     */
    get confirmationTimeoutInMinutes(): number;
    /**
     * @stability stable
     */
    set confirmationTimeoutInMinutes(value: number);
    /**
     * @stability stable
     */
    resetConfirmationTimeoutInMinutes(): void;
    /**
     * @stability stable
     */
    get confirmationTimeoutInMinutesInput(): number | undefined;
    /**
     * @stability stable
     */
    get confirmationWasAuthenticated(): boolean;
    private _deliveryPolicy?;
    /**
     * @stability stable
     */
    get deliveryPolicy(): string;
    /**
     * @stability stable
     */
    set deliveryPolicy(value: string);
    /**
     * @stability stable
     */
    resetDeliveryPolicy(): void;
    /**
     * @stability stable
     */
    get deliveryPolicyInput(): string | undefined;
    private _endpoint;
    /**
     * @stability stable
     */
    get endpoint(): string;
    /**
     * @stability stable
     */
    set endpoint(value: string);
    /**
     * @stability stable
     */
    get endpointInput(): string;
    private _endpointAutoConfirms?;
    /**
     * @stability stable
     */
    get endpointAutoConfirms(): boolean;
    /**
     * @stability stable
     */
    set endpointAutoConfirms(value: boolean);
    /**
     * @stability stable
     */
    resetEndpointAutoConfirms(): void;
    /**
     * @stability stable
     */
    get endpointAutoConfirmsInput(): boolean | undefined;
    private _filterPolicy?;
    /**
     * @stability stable
     */
    get filterPolicy(): string;
    /**
     * @stability stable
     */
    set filterPolicy(value: string);
    /**
     * @stability stable
     */
    resetFilterPolicy(): void;
    /**
     * @stability stable
     */
    get filterPolicyInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ownerId(): string;
    /**
     * @stability stable
     */
    get pendingConfirmation(): boolean;
    private _protocol;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    set protocol(value: string);
    /**
     * @stability stable
     */
    get protocolInput(): string;
    private _rawMessageDelivery?;
    /**
     * @stability stable
     */
    get rawMessageDelivery(): boolean;
    /**
     * @stability stable
     */
    set rawMessageDelivery(value: boolean);
    /**
     * @stability stable
     */
    resetRawMessageDelivery(): void;
    /**
     * @stability stable
     */
    get rawMessageDeliveryInput(): boolean | undefined;
    private _redrivePolicy?;
    /**
     * @stability stable
     */
    get redrivePolicy(): string;
    /**
     * @stability stable
     */
    set redrivePolicy(value: string);
    /**
     * @stability stable
     */
    resetRedrivePolicy(): void;
    /**
     * @stability stable
     */
    get redrivePolicyInput(): string | undefined;
    private _subscriptionRoleArn?;
    /**
     * @stability stable
     */
    get subscriptionRoleArn(): string;
    /**
     * @stability stable
     */
    set subscriptionRoleArn(value: string);
    /**
     * @stability stable
     */
    resetSubscriptionRoleArn(): void;
    /**
     * @stability stable
     */
    get subscriptionRoleArnInput(): string | undefined;
    private _topicArn;
    /**
     * @stability stable
     */
    get topicArn(): string;
    /**
     * @stability stable
     */
    set topicArn(value: string);
    /**
     * @stability stable
     */
    get topicArnInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
