import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SnsTopicConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly applicationFailureFeedbackRoleArn?: string;
    /**
     * @stability stable
     */
    readonly applicationSuccessFeedbackRoleArn?: string;
    /**
     * @stability stable
     */
    readonly applicationSuccessFeedbackSampleRate?: number;
    /**
     * @stability stable
     */
    readonly deliveryPolicy?: string;
    /**
     * @stability stable
     */
    readonly displayName?: string;
    /**
     * @stability stable
     */
    readonly httpFailureFeedbackRoleArn?: string;
    /**
     * @stability stable
     */
    readonly httpSuccessFeedbackRoleArn?: string;
    /**
     * @stability stable
     */
    readonly httpSuccessFeedbackSampleRate?: number;
    /**
     * @stability stable
     */
    readonly kmsMasterKeyId?: string;
    /**
     * @stability stable
     */
    readonly lambdaFailureFeedbackRoleArn?: string;
    /**
     * @stability stable
     */
    readonly lambdaSuccessFeedbackRoleArn?: string;
    /**
     * @stability stable
     */
    readonly lambdaSuccessFeedbackSampleRate?: number;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly policy?: string;
    /**
     * @stability stable
     */
    readonly sqsFailureFeedbackRoleArn?: string;
    /**
     * @stability stable
     */
    readonly sqsSuccessFeedbackRoleArn?: string;
    /**
     * @stability stable
     */
    readonly sqsSuccessFeedbackSampleRate?: number;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class SnsTopic extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: SnsTopicConfig);
    private _applicationFailureFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get applicationFailureFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set applicationFailureFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetApplicationFailureFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get applicationFailureFeedbackRoleArnInput(): string | undefined;
    private _applicationSuccessFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get applicationSuccessFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set applicationSuccessFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetApplicationSuccessFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get applicationSuccessFeedbackRoleArnInput(): string | undefined;
    private _applicationSuccessFeedbackSampleRate?;
    /**
     * @stability stable
     */
    get applicationSuccessFeedbackSampleRate(): number;
    /**
     * @stability stable
     */
    set applicationSuccessFeedbackSampleRate(value: number);
    /**
     * @stability stable
     */
    resetApplicationSuccessFeedbackSampleRate(): void;
    /**
     * @stability stable
     */
    get applicationSuccessFeedbackSampleRateInput(): number | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _deliveryPolicy?;
    /**
     * @stability stable
     */
    get deliveryPolicy(): string;
    /**
     * @stability stable
     */
    set deliveryPolicy(value: string);
    /**
     * @stability stable
     */
    resetDeliveryPolicy(): void;
    /**
     * @stability stable
     */
    get deliveryPolicyInput(): string | undefined;
    private _displayName?;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    resetDisplayName(): void;
    /**
     * @stability stable
     */
    get displayNameInput(): string | undefined;
    private _httpFailureFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get httpFailureFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set httpFailureFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetHttpFailureFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get httpFailureFeedbackRoleArnInput(): string | undefined;
    private _httpSuccessFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get httpSuccessFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set httpSuccessFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetHttpSuccessFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get httpSuccessFeedbackRoleArnInput(): string | undefined;
    private _httpSuccessFeedbackSampleRate?;
    /**
     * @stability stable
     */
    get httpSuccessFeedbackSampleRate(): number;
    /**
     * @stability stable
     */
    set httpSuccessFeedbackSampleRate(value: number);
    /**
     * @stability stable
     */
    resetHttpSuccessFeedbackSampleRate(): void;
    /**
     * @stability stable
     */
    get httpSuccessFeedbackSampleRateInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsMasterKeyId?;
    /**
     * @stability stable
     */
    get kmsMasterKeyId(): string;
    /**
     * @stability stable
     */
    set kmsMasterKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsMasterKeyId(): void;
    /**
     * @stability stable
     */
    get kmsMasterKeyIdInput(): string | undefined;
    private _lambdaFailureFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get lambdaFailureFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set lambdaFailureFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetLambdaFailureFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get lambdaFailureFeedbackRoleArnInput(): string | undefined;
    private _lambdaSuccessFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get lambdaSuccessFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set lambdaSuccessFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetLambdaSuccessFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get lambdaSuccessFeedbackRoleArnInput(): string | undefined;
    private _lambdaSuccessFeedbackSampleRate?;
    /**
     * @stability stable
     */
    get lambdaSuccessFeedbackSampleRate(): number;
    /**
     * @stability stable
     */
    set lambdaSuccessFeedbackSampleRate(value: number);
    /**
     * @stability stable
     */
    resetLambdaSuccessFeedbackSampleRate(): void;
    /**
     * @stability stable
     */
    get lambdaSuccessFeedbackSampleRateInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _policy?;
    /**
     * @stability stable
     */
    get policy(): string;
    /**
     * @stability stable
     */
    set policy(value: string);
    /**
     * @stability stable
     */
    resetPolicy(): void;
    /**
     * @stability stable
     */
    get policyInput(): string | undefined;
    private _sqsFailureFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get sqsFailureFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set sqsFailureFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetSqsFailureFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get sqsFailureFeedbackRoleArnInput(): string | undefined;
    private _sqsSuccessFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get sqsSuccessFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set sqsSuccessFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetSqsSuccessFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get sqsSuccessFeedbackRoleArnInput(): string | undefined;
    private _sqsSuccessFeedbackSampleRate?;
    /**
     * @stability stable
     */
    get sqsSuccessFeedbackSampleRate(): number;
    /**
     * @stability stable
     */
    set sqsSuccessFeedbackSampleRate(value: number);
    /**
     * @stability stable
     */
    resetSqsSuccessFeedbackSampleRate(): void;
    /**
     * @stability stable
     */
    get sqsSuccessFeedbackSampleRateInput(): number | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
