import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SpotFleetRequestConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly allocationStrategy?: string;
    /**
     * @stability stable
     */
    readonly excessCapacityTerminationPolicy?: string;
    /**
     * @stability stable
     */
    readonly fleetType?: string;
    /**
     * @stability stable
     */
    readonly iamFleetRole: string;
    /**
     * @stability stable
     */
    readonly instanceInterruptionBehaviour?: string;
    /**
     * @stability stable
     */
    readonly instancePoolsToUseCount?: number;
    /**
     * @stability stable
     */
    readonly loadBalancers?: string[];
    /**
     * @stability stable
     */
    readonly replaceUnhealthyInstances?: boolean;
    /**
     * @stability stable
     */
    readonly spotPrice?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly targetCapacity: number;
    /**
     * @stability stable
     */
    readonly targetGroupArns?: string[];
    /**
     * @stability stable
     */
    readonly terminateInstancesWithExpiration?: boolean;
    /**
     * @stability stable
     */
    readonly validFrom?: string;
    /**
     * @stability stable
     */
    readonly validUntil?: string;
    /**
     * @stability stable
     */
    readonly waitForFulfillment?: boolean;
    /**
     * launch_specification block.
     *
     * @stability stable
     */
    readonly launchSpecification?: SpotFleetRequestLaunchSpecification[];
    /**
     * launch_template_config block.
     *
     * @stability stable
     */
    readonly launchTemplateConfig?: SpotFleetRequestLaunchTemplateConfig[];
    /**
     * spot_maintenance_strategies block.
     *
     * @stability stable
     */
    readonly spotMaintenanceStrategies?: SpotFleetRequestSpotMaintenanceStrategies[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: SpotFleetRequestTimeouts;
}
/**
 * @stability stable
 */
export interface SpotFleetRequestLaunchSpecificationEbsBlockDevice {
    /**
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly snapshotId?: string;
    /**
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface SpotFleetRequestLaunchSpecificationEphemeralBlockDevice {
    /**
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * @stability stable
     */
    readonly virtualName: string;
}
/**
 * @stability stable
 */
export interface SpotFleetRequestLaunchSpecificationRootBlockDevice {
    /**
     * @stability stable
     */
    readonly deleteOnTermination?: boolean;
    /**
     * @stability stable
     */
    readonly encrypted?: boolean;
    /**
     * @stability stable
     */
    readonly iops?: number;
    /**
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface SpotFleetRequestLaunchSpecification {
    /**
     * @stability stable
     */
    readonly ami: string;
    /**
     * @stability stable
     */
    readonly associatePublicIpAddress?: boolean;
    /**
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * @stability stable
     */
    readonly ebsOptimized?: boolean;
    /**
     * @stability stable
     */
    readonly iamInstanceProfile?: string;
    /**
     * @stability stable
     */
    readonly iamInstanceProfileArn?: string;
    /**
     * @stability stable
     */
    readonly instanceType: string;
    /**
     * @stability stable
     */
    readonly keyName?: string;
    /**
     * @stability stable
     */
    readonly monitoring?: boolean;
    /**
     * @stability stable
     */
    readonly placementGroup?: string;
    /**
     * @stability stable
     */
    readonly placementTenancy?: string;
    /**
     * @stability stable
     */
    readonly spotPrice?: string;
    /**
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly userData?: string;
    /**
     * @stability stable
     */
    readonly vpcSecurityGroupIds?: string[];
    /**
     * @stability stable
     */
    readonly weightedCapacity?: string;
    /**
     * ebs_block_device block.
     *
     * @stability stable
     */
    readonly ebsBlockDevice?: SpotFleetRequestLaunchSpecificationEbsBlockDevice[];
    /**
     * ephemeral_block_device block.
     *
     * @stability stable
     */
    readonly ephemeralBlockDevice?: SpotFleetRequestLaunchSpecificationEphemeralBlockDevice[];
    /**
     * root_block_device block.
     *
     * @stability stable
     */
    readonly rootBlockDevice?: SpotFleetRequestLaunchSpecificationRootBlockDevice[];
}
/**
 * @stability stable
 */
export interface SpotFleetRequestLaunchTemplateConfigLaunchTemplateSpecification {
    /**
     * @stability stable
     */
    readonly id?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly version?: string;
}
/**
 * @stability stable
 */
export interface SpotFleetRequestLaunchTemplateConfigOverrides {
    /**
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * @stability stable
     */
    readonly priority?: number;
    /**
     * @stability stable
     */
    readonly spotPrice?: string;
    /**
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * @stability stable
     */
    readonly weightedCapacity?: number;
}
/**
 * @stability stable
 */
export interface SpotFleetRequestLaunchTemplateConfig {
    /**
     * launch_template_specification block.
     *
     * @stability stable
     */
    readonly launchTemplateSpecification: SpotFleetRequestLaunchTemplateConfigLaunchTemplateSpecification[];
    /**
     * overrides block.
     *
     * @stability stable
     */
    readonly overrides?: SpotFleetRequestLaunchTemplateConfigOverrides[];
}
/**
 * @stability stable
 */
export interface SpotFleetRequestSpotMaintenanceStrategiesCapacityRebalance {
    /**
     * @stability stable
     */
    readonly replacementStrategy?: string;
}
/**
 * @stability stable
 */
export interface SpotFleetRequestSpotMaintenanceStrategies {
    /**
     * capacity_rebalance block.
     *
     * @stability stable
     */
    readonly capacityRebalance?: SpotFleetRequestSpotMaintenanceStrategiesCapacityRebalance[];
}
/**
 * @stability stable
 */
export interface SpotFleetRequestTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export declare class SpotFleetRequest extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SpotFleetRequestConfig);
    private _allocationStrategy?;
    /**
     * @stability stable
     */
    get allocationStrategy(): string;
    /**
     * @stability stable
     */
    set allocationStrategy(value: string);
    /**
     * @stability stable
     */
    resetAllocationStrategy(): void;
    /**
     * @stability stable
     */
    get allocationStrategyInput(): string | undefined;
    /**
     * @stability stable
     */
    get clientToken(): string;
    private _excessCapacityTerminationPolicy?;
    /**
     * @stability stable
     */
    get excessCapacityTerminationPolicy(): string;
    /**
     * @stability stable
     */
    set excessCapacityTerminationPolicy(value: string);
    /**
     * @stability stable
     */
    resetExcessCapacityTerminationPolicy(): void;
    /**
     * @stability stable
     */
    get excessCapacityTerminationPolicyInput(): string | undefined;
    private _fleetType?;
    /**
     * @stability stable
     */
    get fleetType(): string;
    /**
     * @stability stable
     */
    set fleetType(value: string);
    /**
     * @stability stable
     */
    resetFleetType(): void;
    /**
     * @stability stable
     */
    get fleetTypeInput(): string | undefined;
    private _iamFleetRole;
    /**
     * @stability stable
     */
    get iamFleetRole(): string;
    /**
     * @stability stable
     */
    set iamFleetRole(value: string);
    /**
     * @stability stable
     */
    get iamFleetRoleInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceInterruptionBehaviour?;
    /**
     * @stability stable
     */
    get instanceInterruptionBehaviour(): string;
    /**
     * @stability stable
     */
    set instanceInterruptionBehaviour(value: string);
    /**
     * @stability stable
     */
    resetInstanceInterruptionBehaviour(): void;
    /**
     * @stability stable
     */
    get instanceInterruptionBehaviourInput(): string | undefined;
    private _instancePoolsToUseCount?;
    /**
     * @stability stable
     */
    get instancePoolsToUseCount(): number;
    /**
     * @stability stable
     */
    set instancePoolsToUseCount(value: number);
    /**
     * @stability stable
     */
    resetInstancePoolsToUseCount(): void;
    /**
     * @stability stable
     */
    get instancePoolsToUseCountInput(): number | undefined;
    private _loadBalancers?;
    /**
     * @stability stable
     */
    get loadBalancers(): string[];
    /**
     * @stability stable
     */
    set loadBalancers(value: string[]);
    /**
     * @stability stable
     */
    resetLoadBalancers(): void;
    /**
     * @stability stable
     */
    get loadBalancersInput(): string[] | undefined;
    private _replaceUnhealthyInstances?;
    /**
     * @stability stable
     */
    get replaceUnhealthyInstances(): boolean;
    /**
     * @stability stable
     */
    set replaceUnhealthyInstances(value: boolean);
    /**
     * @stability stable
     */
    resetReplaceUnhealthyInstances(): void;
    /**
     * @stability stable
     */
    get replaceUnhealthyInstancesInput(): boolean | undefined;
    private _spotPrice?;
    /**
     * @stability stable
     */
    get spotPrice(): string;
    /**
     * @stability stable
     */
    set spotPrice(value: string);
    /**
     * @stability stable
     */
    resetSpotPrice(): void;
    /**
     * @stability stable
     */
    get spotPriceInput(): string | undefined;
    /**
     * @stability stable
     */
    get spotRequestState(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _targetCapacity;
    /**
     * @stability stable
     */
    get targetCapacity(): number;
    /**
     * @stability stable
     */
    set targetCapacity(value: number);
    /**
     * @stability stable
     */
    get targetCapacityInput(): number;
    private _targetGroupArns?;
    /**
     * @stability stable
     */
    get targetGroupArns(): string[];
    /**
     * @stability stable
     */
    set targetGroupArns(value: string[]);
    /**
     * @stability stable
     */
    resetTargetGroupArns(): void;
    /**
     * @stability stable
     */
    get targetGroupArnsInput(): string[] | undefined;
    private _terminateInstancesWithExpiration?;
    /**
     * @stability stable
     */
    get terminateInstancesWithExpiration(): boolean;
    /**
     * @stability stable
     */
    set terminateInstancesWithExpiration(value: boolean);
    /**
     * @stability stable
     */
    resetTerminateInstancesWithExpiration(): void;
    /**
     * @stability stable
     */
    get terminateInstancesWithExpirationInput(): boolean | undefined;
    private _validFrom?;
    /**
     * @stability stable
     */
    get validFrom(): string;
    /**
     * @stability stable
     */
    set validFrom(value: string);
    /**
     * @stability stable
     */
    resetValidFrom(): void;
    /**
     * @stability stable
     */
    get validFromInput(): string | undefined;
    private _validUntil?;
    /**
     * @stability stable
     */
    get validUntil(): string;
    /**
     * @stability stable
     */
    set validUntil(value: string);
    /**
     * @stability stable
     */
    resetValidUntil(): void;
    /**
     * @stability stable
     */
    get validUntilInput(): string | undefined;
    private _waitForFulfillment?;
    /**
     * @stability stable
     */
    get waitForFulfillment(): boolean;
    /**
     * @stability stable
     */
    set waitForFulfillment(value: boolean);
    /**
     * @stability stable
     */
    resetWaitForFulfillment(): void;
    /**
     * @stability stable
     */
    get waitForFulfillmentInput(): boolean | undefined;
    private _launchSpecification?;
    /**
     * @stability stable
     */
    get launchSpecification(): SpotFleetRequestLaunchSpecification[];
    /**
     * @stability stable
     */
    set launchSpecification(value: SpotFleetRequestLaunchSpecification[]);
    /**
     * @stability stable
     */
    resetLaunchSpecification(): void;
    /**
     * @stability stable
     */
    get launchSpecificationInput(): SpotFleetRequestLaunchSpecification[] | undefined;
    private _launchTemplateConfig?;
    /**
     * @stability stable
     */
    get launchTemplateConfig(): SpotFleetRequestLaunchTemplateConfig[];
    /**
     * @stability stable
     */
    set launchTemplateConfig(value: SpotFleetRequestLaunchTemplateConfig[]);
    /**
     * @stability stable
     */
    resetLaunchTemplateConfig(): void;
    /**
     * @stability stable
     */
    get launchTemplateConfigInput(): SpotFleetRequestLaunchTemplateConfig[] | undefined;
    private _spotMaintenanceStrategies?;
    /**
     * @stability stable
     */
    get spotMaintenanceStrategies(): SpotFleetRequestSpotMaintenanceStrategies[];
    /**
     * @stability stable
     */
    set spotMaintenanceStrategies(value: SpotFleetRequestSpotMaintenanceStrategies[]);
    /**
     * @stability stable
     */
    resetSpotMaintenanceStrategies(): void;
    /**
     * @stability stable
     */
    get spotMaintenanceStrategiesInput(): SpotFleetRequestSpotMaintenanceStrategies[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): SpotFleetRequestTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: SpotFleetRequestTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): SpotFleetRequestTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
