import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SqsQueueConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly contentBasedDeduplication?: boolean;
    /**
     * @stability stable
     */
    readonly delaySeconds?: number;
    /**
     * @stability stable
     */
    readonly fifoQueue?: boolean;
    /**
     * @stability stable
     */
    readonly kmsDataKeyReusePeriodSeconds?: number;
    /**
     * @stability stable
     */
    readonly kmsMasterKeyId?: string;
    /**
     * @stability stable
     */
    readonly maxMessageSize?: number;
    /**
     * @stability stable
     */
    readonly messageRetentionSeconds?: number;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * @stability stable
     */
    readonly policy?: string;
    /**
     * @stability stable
     */
    readonly receiveWaitTimeSeconds?: number;
    /**
     * @stability stable
     */
    readonly redrivePolicy?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly visibilityTimeoutSeconds?: number;
}
/**
 * @stability stable
 */
export declare class SqsQueue extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: SqsQueueConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _contentBasedDeduplication?;
    /**
     * @stability stable
     */
    get contentBasedDeduplication(): boolean;
    /**
     * @stability stable
     */
    set contentBasedDeduplication(value: boolean);
    /**
     * @stability stable
     */
    resetContentBasedDeduplication(): void;
    /**
     * @stability stable
     */
    get contentBasedDeduplicationInput(): boolean | undefined;
    private _delaySeconds?;
    /**
     * @stability stable
     */
    get delaySeconds(): number;
    /**
     * @stability stable
     */
    set delaySeconds(value: number);
    /**
     * @stability stable
     */
    resetDelaySeconds(): void;
    /**
     * @stability stable
     */
    get delaySecondsInput(): number | undefined;
    private _fifoQueue?;
    /**
     * @stability stable
     */
    get fifoQueue(): boolean;
    /**
     * @stability stable
     */
    set fifoQueue(value: boolean);
    /**
     * @stability stable
     */
    resetFifoQueue(): void;
    /**
     * @stability stable
     */
    get fifoQueueInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsDataKeyReusePeriodSeconds?;
    /**
     * @stability stable
     */
    get kmsDataKeyReusePeriodSeconds(): number;
    /**
     * @stability stable
     */
    set kmsDataKeyReusePeriodSeconds(value: number);
    /**
     * @stability stable
     */
    resetKmsDataKeyReusePeriodSeconds(): void;
    /**
     * @stability stable
     */
    get kmsDataKeyReusePeriodSecondsInput(): number | undefined;
    private _kmsMasterKeyId?;
    /**
     * @stability stable
     */
    get kmsMasterKeyId(): string;
    /**
     * @stability stable
     */
    set kmsMasterKeyId(value: string);
    /**
     * @stability stable
     */
    resetKmsMasterKeyId(): void;
    /**
     * @stability stable
     */
    get kmsMasterKeyIdInput(): string | undefined;
    private _maxMessageSize?;
    /**
     * @stability stable
     */
    get maxMessageSize(): number;
    /**
     * @stability stable
     */
    set maxMessageSize(value: number);
    /**
     * @stability stable
     */
    resetMaxMessageSize(): void;
    /**
     * @stability stable
     */
    get maxMessageSizeInput(): number | undefined;
    private _messageRetentionSeconds?;
    /**
     * @stability stable
     */
    get messageRetentionSeconds(): number;
    /**
     * @stability stable
     */
    set messageRetentionSeconds(value: number);
    /**
     * @stability stable
     */
    resetMessageRetentionSeconds(): void;
    /**
     * @stability stable
     */
    get messageRetentionSecondsInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _policy?;
    /**
     * @stability stable
     */
    get policy(): string;
    /**
     * @stability stable
     */
    set policy(value: string);
    /**
     * @stability stable
     */
    resetPolicy(): void;
    /**
     * @stability stable
     */
    get policyInput(): string | undefined;
    private _receiveWaitTimeSeconds?;
    /**
     * @stability stable
     */
    get receiveWaitTimeSeconds(): number;
    /**
     * @stability stable
     */
    set receiveWaitTimeSeconds(value: number);
    /**
     * @stability stable
     */
    resetReceiveWaitTimeSeconds(): void;
    /**
     * @stability stable
     */
    get receiveWaitTimeSecondsInput(): number | undefined;
    private _redrivePolicy?;
    /**
     * @stability stable
     */
    get redrivePolicy(): string;
    /**
     * @stability stable
     */
    set redrivePolicy(value: string);
    /**
     * @stability stable
     */
    resetRedrivePolicy(): void;
    /**
     * @stability stable
     */
    get redrivePolicyInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _visibilityTimeoutSeconds?;
    /**
     * @stability stable
     */
    get visibilityTimeoutSeconds(): number;
    /**
     * @stability stable
     */
    set visibilityTimeoutSeconds(value: number);
    /**
     * @stability stable
     */
    resetVisibilityTimeoutSeconds(): void;
    /**
     * @stability stable
     */
    get visibilityTimeoutSecondsInput(): number | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
