import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SsmAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly applyOnlyAtCronInterval?: boolean;
    /**
     * @stability stable
     */
    readonly associationName?: string;
    /**
     * @stability stable
     */
    readonly automationTargetParameterName?: string;
    /**
     * @stability stable
     */
    readonly complianceSeverity?: string;
    /**
     * @stability stable
     */
    readonly documentVersion?: string;
    /**
     * @stability stable
     */
    readonly instanceId?: string;
    /**
     * @stability stable
     */
    readonly maxConcurrency?: string;
    /**
     * @stability stable
     */
    readonly maxErrors?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly parameters?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly scheduleExpression?: string;
    /**
     * output_location block.
     *
     * @stability stable
     */
    readonly outputLocation?: SsmAssociationOutputLocation[];
    /**
     * targets block.
     *
     * @stability stable
     */
    readonly targets?: SsmAssociationTargets[];
}
/**
 * @stability stable
 */
export interface SsmAssociationOutputLocation {
    /**
     * @stability stable
     */
    readonly s3BucketName: string;
    /**
     * @stability stable
     */
    readonly s3KeyPrefix?: string;
}
/**
 * @stability stable
 */
export interface SsmAssociationTargets {
    /**
     * @stability stable
     */
    readonly key: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class SsmAssociation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SsmAssociationConfig);
    private _applyOnlyAtCronInterval?;
    /**
     * @stability stable
     */
    get applyOnlyAtCronInterval(): boolean;
    /**
     * @stability stable
     */
    set applyOnlyAtCronInterval(value: boolean);
    /**
     * @stability stable
     */
    resetApplyOnlyAtCronInterval(): void;
    /**
     * @stability stable
     */
    get applyOnlyAtCronIntervalInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get associationId(): string;
    private _associationName?;
    /**
     * @stability stable
     */
    get associationName(): string;
    /**
     * @stability stable
     */
    set associationName(value: string);
    /**
     * @stability stable
     */
    resetAssociationName(): void;
    /**
     * @stability stable
     */
    get associationNameInput(): string | undefined;
    private _automationTargetParameterName?;
    /**
     * @stability stable
     */
    get automationTargetParameterName(): string;
    /**
     * @stability stable
     */
    set automationTargetParameterName(value: string);
    /**
     * @stability stable
     */
    resetAutomationTargetParameterName(): void;
    /**
     * @stability stable
     */
    get automationTargetParameterNameInput(): string | undefined;
    private _complianceSeverity?;
    /**
     * @stability stable
     */
    get complianceSeverity(): string;
    /**
     * @stability stable
     */
    set complianceSeverity(value: string);
    /**
     * @stability stable
     */
    resetComplianceSeverity(): void;
    /**
     * @stability stable
     */
    get complianceSeverityInput(): string | undefined;
    private _documentVersion?;
    /**
     * @stability stable
     */
    get documentVersion(): string;
    /**
     * @stability stable
     */
    set documentVersion(value: string);
    /**
     * @stability stable
     */
    resetDocumentVersion(): void;
    /**
     * @stability stable
     */
    get documentVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceId?;
    /**
     * @stability stable
     */
    get instanceId(): string;
    /**
     * @stability stable
     */
    set instanceId(value: string);
    /**
     * @stability stable
     */
    resetInstanceId(): void;
    /**
     * @stability stable
     */
    get instanceIdInput(): string | undefined;
    private _maxConcurrency?;
    /**
     * @stability stable
     */
    get maxConcurrency(): string;
    /**
     * @stability stable
     */
    set maxConcurrency(value: string);
    /**
     * @stability stable
     */
    resetMaxConcurrency(): void;
    /**
     * @stability stable
     */
    get maxConcurrencyInput(): string | undefined;
    private _maxErrors?;
    /**
     * @stability stable
     */
    get maxErrors(): string;
    /**
     * @stability stable
     */
    set maxErrors(value: string);
    /**
     * @stability stable
     */
    resetMaxErrors(): void;
    /**
     * @stability stable
     */
    get maxErrorsInput(): string | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _parameters?;
    /**
     * @stability stable
     */
    get parameters(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set parameters(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetParameters(): void;
    /**
     * @stability stable
     */
    get parametersInput(): {
        [key: string]: string;
    } | undefined;
    private _scheduleExpression?;
    /**
     * @stability stable
     */
    get scheduleExpression(): string;
    /**
     * @stability stable
     */
    set scheduleExpression(value: string);
    /**
     * @stability stable
     */
    resetScheduleExpression(): void;
    /**
     * @stability stable
     */
    get scheduleExpressionInput(): string | undefined;
    private _outputLocation?;
    /**
     * @stability stable
     */
    get outputLocation(): SsmAssociationOutputLocation[];
    /**
     * @stability stable
     */
    set outputLocation(value: SsmAssociationOutputLocation[]);
    /**
     * @stability stable
     */
    resetOutputLocation(): void;
    /**
     * @stability stable
     */
    get outputLocationInput(): SsmAssociationOutputLocation[] | undefined;
    private _targets?;
    /**
     * @stability stable
     */
    get targets(): SsmAssociationTargets[];
    /**
     * @stability stable
     */
    set targets(value: SsmAssociationTargets[]);
    /**
     * @stability stable
     */
    resetTargets(): void;
    /**
     * @stability stable
     */
    get targetsInput(): SsmAssociationTargets[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
