import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SsmDocumentConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly content: string;
    /**
     * @stability stable
     */
    readonly documentFormat?: string;
    /**
     * @stability stable
     */
    readonly documentType: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly permissions?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly targetType?: string;
    /**
     * @stability stable
     */
    readonly versionName?: string;
    /**
     * attachments_source block.
     *
     * @stability stable
     */
    readonly attachmentsSource?: SsmDocumentAttachmentsSource[];
}
/**
 * @stability stable
 */
export declare class SsmDocumentParameter extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get defaultValue(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get type(): string;
}
/**
 * @stability stable
 */
export interface SsmDocumentAttachmentsSource {
    /**
     * @stability stable
     */
    readonly key: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class SsmDocument extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SsmDocumentConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _content;
    /**
     * @stability stable
     */
    get content(): string;
    /**
     * @stability stable
     */
    set content(value: string);
    /**
     * @stability stable
     */
    get contentInput(): string;
    /**
     * @stability stable
     */
    get createdDate(): string;
    /**
     * @stability stable
     */
    get defaultVersion(): string;
    /**
     * @stability stable
     */
    get description(): string;
    private _documentFormat?;
    /**
     * @stability stable
     */
    get documentFormat(): string;
    /**
     * @stability stable
     */
    set documentFormat(value: string);
    /**
     * @stability stable
     */
    resetDocumentFormat(): void;
    /**
     * @stability stable
     */
    get documentFormatInput(): string | undefined;
    private _documentType;
    /**
     * @stability stable
     */
    get documentType(): string;
    /**
     * @stability stable
     */
    set documentType(value: string);
    /**
     * @stability stable
     */
    get documentTypeInput(): string;
    /**
     * @stability stable
     */
    get documentVersion(): string;
    /**
     * @stability stable
     */
    get hash(): string;
    /**
     * @stability stable
     */
    get hashType(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get latestVersion(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get owner(): string;
    /**
     * @stability stable
     */
    parameter(index: string): SsmDocumentParameter;
    private _permissions?;
    /**
     * @stability stable
     */
    get permissions(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set permissions(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetPermissions(): void;
    /**
     * @stability stable
     */
    get permissionsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get platformTypes(): string[];
    /**
     * @stability stable
     */
    get schemaVersion(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _targetType?;
    /**
     * @stability stable
     */
    get targetType(): string;
    /**
     * @stability stable
     */
    set targetType(value: string);
    /**
     * @stability stable
     */
    resetTargetType(): void;
    /**
     * @stability stable
     */
    get targetTypeInput(): string | undefined;
    private _versionName?;
    /**
     * @stability stable
     */
    get versionName(): string;
    /**
     * @stability stable
     */
    set versionName(value: string);
    /**
     * @stability stable
     */
    resetVersionName(): void;
    /**
     * @stability stable
     */
    get versionNameInput(): string | undefined;
    private _attachmentsSource?;
    /**
     * @stability stable
     */
    get attachmentsSource(): SsmDocumentAttachmentsSource[];
    /**
     * @stability stable
     */
    set attachmentsSource(value: SsmDocumentAttachmentsSource[]);
    /**
     * @stability stable
     */
    resetAttachmentsSource(): void;
    /**
     * @stability stable
     */
    get attachmentsSourceInput(): SsmDocumentAttachmentsSource[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
