import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SsmMaintenanceWindowTargetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly ownerInformation?: string;
    /**
     * @stability stable
     */
    readonly resourceType: string;
    /**
     * @stability stable
     */
    readonly windowId: string;
    /**
     * targets block.
     *
     * @stability stable
     */
    readonly targets: SsmMaintenanceWindowTargetTargets[];
}
/**
 * @stability stable
 */
export interface SsmMaintenanceWindowTargetTargets {
    /**
     * @stability stable
     */
    readonly key: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export declare class SsmMaintenanceWindowTarget extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SsmMaintenanceWindowTargetConfig);
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _ownerInformation?;
    /**
     * @stability stable
     */
    get ownerInformation(): string;
    /**
     * @stability stable
     */
    set ownerInformation(value: string);
    /**
     * @stability stable
     */
    resetOwnerInformation(): void;
    /**
     * @stability stable
     */
    get ownerInformationInput(): string | undefined;
    private _resourceType;
    /**
     * @stability stable
     */
    get resourceType(): string;
    /**
     * @stability stable
     */
    set resourceType(value: string);
    /**
     * @stability stable
     */
    get resourceTypeInput(): string;
    private _windowId;
    /**
     * @stability stable
     */
    get windowId(): string;
    /**
     * @stability stable
     */
    set windowId(value: string);
    /**
     * @stability stable
     */
    get windowIdInput(): string;
    private _targets;
    /**
     * @stability stable
     */
    get targets(): SsmMaintenanceWindowTargetTargets[];
    /**
     * @stability stable
     */
    set targets(value: SsmMaintenanceWindowTargetTargets[]);
    /**
     * @stability stable
     */
    get targetsInput(): SsmMaintenanceWindowTargetTargets[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
