import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SsmMaintenanceWindowTaskConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly maxConcurrency: string;
    /**
     * @stability stable
     */
    readonly maxErrors: string;
    /**
     * @stability stable
     */
    readonly name?: string;
    /**
     * @stability stable
     */
    readonly priority?: number;
    /**
     * @stability stable
     */
    readonly serviceRoleArn?: string;
    /**
     * @stability stable
     */
    readonly taskArn: string;
    /**
     * @stability stable
     */
    readonly taskType: string;
    /**
     * @stability stable
     */
    readonly windowId: string;
    /**
     * targets block.
     *
     * @stability stable
     */
    readonly targets?: SsmMaintenanceWindowTaskTargets[];
    /**
     * task_invocation_parameters block.
     *
     * @stability stable
     */
    readonly taskInvocationParameters?: SsmMaintenanceWindowTaskTaskInvocationParameters[];
}
/**
 * @stability stable
 */
export interface SsmMaintenanceWindowTaskTargets {
    /**
     * @stability stable
     */
    readonly key: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface SsmMaintenanceWindowTaskTaskInvocationParametersAutomationParametersParameter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface SsmMaintenanceWindowTaskTaskInvocationParametersAutomationParameters {
    /**
     * @stability stable
     */
    readonly documentVersion?: string;
    /**
     * parameter block.
     *
     * @stability stable
     */
    readonly parameter?: SsmMaintenanceWindowTaskTaskInvocationParametersAutomationParametersParameter[];
}
/**
 * @stability stable
 */
export interface SsmMaintenanceWindowTaskTaskInvocationParametersLambdaParameters {
    /**
     * @stability stable
     */
    readonly clientContext?: string;
    /**
     * @stability stable
     */
    readonly payload?: string;
    /**
     * @stability stable
     */
    readonly qualifier?: string;
}
/**
 * @stability stable
 */
export interface SsmMaintenanceWindowTaskTaskInvocationParametersRunCommandParametersCloudwatchConfig {
    /**
     * @stability stable
     */
    readonly cloudwatchLogGroupName?: string;
    /**
     * @stability stable
     */
    readonly cloudwatchOutputEnabled?: boolean;
}
/**
 * @stability stable
 */
export interface SsmMaintenanceWindowTaskTaskInvocationParametersRunCommandParametersNotificationConfig {
    /**
     * @stability stable
     */
    readonly notificationArn?: string;
    /**
     * @stability stable
     */
    readonly notificationEvents?: string[];
    /**
     * @stability stable
     */
    readonly notificationType?: string;
}
/**
 * @stability stable
 */
export interface SsmMaintenanceWindowTaskTaskInvocationParametersRunCommandParametersParameter {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly values: string[];
}
/**
 * @stability stable
 */
export interface SsmMaintenanceWindowTaskTaskInvocationParametersRunCommandParameters {
    /**
     * @stability stable
     */
    readonly comment?: string;
    /**
     * @stability stable
     */
    readonly documentHash?: string;
    /**
     * @stability stable
     */
    readonly documentHashType?: string;
    /**
     * @stability stable
     */
    readonly documentVersion?: string;
    /**
     * @stability stable
     */
    readonly outputS3Bucket?: string;
    /**
     * @stability stable
     */
    readonly outputS3KeyPrefix?: string;
    /**
     * @stability stable
     */
    readonly serviceRoleArn?: string;
    /**
     * @stability stable
     */
    readonly timeoutSeconds?: number;
    /**
     * cloudwatch_config block.
     *
     * @stability stable
     */
    readonly cloudwatchConfig?: SsmMaintenanceWindowTaskTaskInvocationParametersRunCommandParametersCloudwatchConfig[];
    /**
     * notification_config block.
     *
     * @stability stable
     */
    readonly notificationConfig?: SsmMaintenanceWindowTaskTaskInvocationParametersRunCommandParametersNotificationConfig[];
    /**
     * parameter block.
     *
     * @stability stable
     */
    readonly parameter?: SsmMaintenanceWindowTaskTaskInvocationParametersRunCommandParametersParameter[];
}
/**
 * @stability stable
 */
export interface SsmMaintenanceWindowTaskTaskInvocationParametersStepFunctionsParameters {
    /**
     * @stability stable
     */
    readonly input?: string;
    /**
     * @stability stable
     */
    readonly name?: string;
}
/**
 * @stability stable
 */
export interface SsmMaintenanceWindowTaskTaskInvocationParameters {
    /**
     * automation_parameters block.
     *
     * @stability stable
     */
    readonly automationParameters?: SsmMaintenanceWindowTaskTaskInvocationParametersAutomationParameters[];
    /**
     * lambda_parameters block.
     *
     * @stability stable
     */
    readonly lambdaParameters?: SsmMaintenanceWindowTaskTaskInvocationParametersLambdaParameters[];
    /**
     * run_command_parameters block.
     *
     * @stability stable
     */
    readonly runCommandParameters?: SsmMaintenanceWindowTaskTaskInvocationParametersRunCommandParameters[];
    /**
     * step_functions_parameters block.
     *
     * @stability stable
     */
    readonly stepFunctionsParameters?: SsmMaintenanceWindowTaskTaskInvocationParametersStepFunctionsParameters[];
}
/**
 * @stability stable
 */
export declare class SsmMaintenanceWindowTask extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SsmMaintenanceWindowTaskConfig);
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _maxConcurrency;
    /**
     * @stability stable
     */
    get maxConcurrency(): string;
    /**
     * @stability stable
     */
    set maxConcurrency(value: string);
    /**
     * @stability stable
     */
    get maxConcurrencyInput(): string;
    private _maxErrors;
    /**
     * @stability stable
     */
    get maxErrors(): string;
    /**
     * @stability stable
     */
    set maxErrors(value: string);
    /**
     * @stability stable
     */
    get maxErrorsInput(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _priority?;
    /**
     * @stability stable
     */
    get priority(): number;
    /**
     * @stability stable
     */
    set priority(value: number);
    /**
     * @stability stable
     */
    resetPriority(): void;
    /**
     * @stability stable
     */
    get priorityInput(): number | undefined;
    private _serviceRoleArn?;
    /**
     * @stability stable
     */
    get serviceRoleArn(): string;
    /**
     * @stability stable
     */
    set serviceRoleArn(value: string);
    /**
     * @stability stable
     */
    resetServiceRoleArn(): void;
    /**
     * @stability stable
     */
    get serviceRoleArnInput(): string | undefined;
    private _taskArn;
    /**
     * @stability stable
     */
    get taskArn(): string;
    /**
     * @stability stable
     */
    set taskArn(value: string);
    /**
     * @stability stable
     */
    get taskArnInput(): string;
    private _taskType;
    /**
     * @stability stable
     */
    get taskType(): string;
    /**
     * @stability stable
     */
    set taskType(value: string);
    /**
     * @stability stable
     */
    get taskTypeInput(): string;
    private _windowId;
    /**
     * @stability stable
     */
    get windowId(): string;
    /**
     * @stability stable
     */
    set windowId(value: string);
    /**
     * @stability stable
     */
    get windowIdInput(): string;
    private _targets?;
    /**
     * @stability stable
     */
    get targets(): SsmMaintenanceWindowTaskTargets[];
    /**
     * @stability stable
     */
    set targets(value: SsmMaintenanceWindowTaskTargets[]);
    /**
     * @stability stable
     */
    resetTargets(): void;
    /**
     * @stability stable
     */
    get targetsInput(): SsmMaintenanceWindowTaskTargets[] | undefined;
    private _taskInvocationParameters?;
    /**
     * @stability stable
     */
    get taskInvocationParameters(): SsmMaintenanceWindowTaskTaskInvocationParameters[];
    /**
     * @stability stable
     */
    set taskInvocationParameters(value: SsmMaintenanceWindowTaskTaskInvocationParameters[]);
    /**
     * @stability stable
     */
    resetTaskInvocationParameters(): void;
    /**
     * @stability stable
     */
    get taskInvocationParametersInput(): SsmMaintenanceWindowTaskTaskInvocationParameters[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
