import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SsmMaintenanceWindowConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly allowUnassociatedTargets?: boolean;
    /**
     * @stability stable
     */
    readonly cutoff: number;
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly duration: number;
    /**
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * @stability stable
     */
    readonly endDate?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly schedule: string;
    /**
     * @stability stable
     */
    readonly scheduleOffset?: number;
    /**
     * @stability stable
     */
    readonly scheduleTimezone?: string;
    /**
     * @stability stable
     */
    readonly startDate?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class SsmMaintenanceWindow extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SsmMaintenanceWindowConfig);
    private _allowUnassociatedTargets?;
    /**
     * @stability stable
     */
    get allowUnassociatedTargets(): boolean;
    /**
     * @stability stable
     */
    set allowUnassociatedTargets(value: boolean);
    /**
     * @stability stable
     */
    resetAllowUnassociatedTargets(): void;
    /**
     * @stability stable
     */
    get allowUnassociatedTargetsInput(): boolean | undefined;
    private _cutoff;
    /**
     * @stability stable
     */
    get cutoff(): number;
    /**
     * @stability stable
     */
    set cutoff(value: number);
    /**
     * @stability stable
     */
    get cutoffInput(): number;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _duration;
    /**
     * @stability stable
     */
    get duration(): number;
    /**
     * @stability stable
     */
    set duration(value: number);
    /**
     * @stability stable
     */
    get durationInput(): number;
    private _enabled?;
    /**
     * @stability stable
     */
    get enabled(): boolean;
    /**
     * @stability stable
     */
    set enabled(value: boolean);
    /**
     * @stability stable
     */
    resetEnabled(): void;
    /**
     * @stability stable
     */
    get enabledInput(): boolean | undefined;
    private _endDate?;
    /**
     * @stability stable
     */
    get endDate(): string;
    /**
     * @stability stable
     */
    set endDate(value: string);
    /**
     * @stability stable
     */
    resetEndDate(): void;
    /**
     * @stability stable
     */
    get endDateInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _schedule;
    /**
     * @stability stable
     */
    get schedule(): string;
    /**
     * @stability stable
     */
    set schedule(value: string);
    /**
     * @stability stable
     */
    get scheduleInput(): string;
    private _scheduleOffset?;
    /**
     * @stability stable
     */
    get scheduleOffset(): number;
    /**
     * @stability stable
     */
    set scheduleOffset(value: number);
    /**
     * @stability stable
     */
    resetScheduleOffset(): void;
    /**
     * @stability stable
     */
    get scheduleOffsetInput(): number | undefined;
    private _scheduleTimezone?;
    /**
     * @stability stable
     */
    get scheduleTimezone(): string;
    /**
     * @stability stable
     */
    set scheduleTimezone(value: string);
    /**
     * @stability stable
     */
    resetScheduleTimezone(): void;
    /**
     * @stability stable
     */
    get scheduleTimezoneInput(): string | undefined;
    private _startDate?;
    /**
     * @stability stable
     */
    get startDate(): string;
    /**
     * @stability stable
     */
    set startDate(value: string);
    /**
     * @stability stable
     */
    resetStartDate(): void;
    /**
     * @stability stable
     */
    get startDateInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
