import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SsmResourceDataSyncConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * s3_destination block.
     *
     * @stability stable
     */
    readonly s3Destination: SsmResourceDataSyncS3Destination[];
}
/**
 * @stability stable
 */
export interface SsmResourceDataSyncS3Destination {
    /**
     * @stability stable
     */
    readonly bucketName: string;
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * @stability stable
     */
    readonly prefix?: string;
    /**
     * @stability stable
     */
    readonly region: string;
    /**
     * @stability stable
     */
    readonly syncFormat?: string;
}
/**
 * @stability stable
 */
export declare class SsmResourceDataSync extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SsmResourceDataSyncConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _s3Destination;
    /**
     * @stability stable
     */
    get s3Destination(): SsmResourceDataSyncS3Destination[];
    /**
     * @stability stable
     */
    set s3Destination(value: SsmResourceDataSyncS3Destination[]);
    /**
     * @stability stable
     */
    get s3DestinationInput(): SsmResourceDataSyncS3Destination[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
