import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SsoadminAccountAssignmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly instanceArn: string;
    /**
     * @stability stable
     */
    readonly permissionSetArn: string;
    /**
     * @stability stable
     */
    readonly principalId: string;
    /**
     * @stability stable
     */
    readonly principalType: string;
    /**
     * @stability stable
     */
    readonly targetId: string;
    /**
     * @stability stable
     */
    readonly targetType?: string;
}
/**
 * @stability stable
 */
export declare class SsoadminAccountAssignment extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SsoadminAccountAssignmentConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceArn;
    /**
     * @stability stable
     */
    get instanceArn(): string;
    /**
     * @stability stable
     */
    set instanceArn(value: string);
    /**
     * @stability stable
     */
    get instanceArnInput(): string;
    private _permissionSetArn;
    /**
     * @stability stable
     */
    get permissionSetArn(): string;
    /**
     * @stability stable
     */
    set permissionSetArn(value: string);
    /**
     * @stability stable
     */
    get permissionSetArnInput(): string;
    private _principalId;
    /**
     * @stability stable
     */
    get principalId(): string;
    /**
     * @stability stable
     */
    set principalId(value: string);
    /**
     * @stability stable
     */
    get principalIdInput(): string;
    private _principalType;
    /**
     * @stability stable
     */
    get principalType(): string;
    /**
     * @stability stable
     */
    set principalType(value: string);
    /**
     * @stability stable
     */
    get principalTypeInput(): string;
    private _targetId;
    /**
     * @stability stable
     */
    get targetId(): string;
    /**
     * @stability stable
     */
    set targetId(value: string);
    /**
     * @stability stable
     */
    get targetIdInput(): string;
    private _targetType?;
    /**
     * @stability stable
     */
    get targetType(): string;
    /**
     * @stability stable
     */
    set targetType(value: string);
    /**
     * @stability stable
     */
    resetTargetType(): void;
    /**
     * @stability stable
     */
    get targetTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
