import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface StoragegatewayCachedIscsiVolumeConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly gatewayArn: string;
    /**
     * @stability stable
     */
    readonly kmsEncrypted?: boolean;
    /**
     * @stability stable
     */
    readonly kmsKey?: string;
    /**
     * @stability stable
     */
    readonly networkInterfaceId: string;
    /**
     * @stability stable
     */
    readonly snapshotId?: string;
    /**
     * @stability stable
     */
    readonly sourceVolumeArn?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly targetName: string;
    /**
     * @stability stable
     */
    readonly volumeSizeInBytes: number;
}
/**
 * @stability stable
 */
export declare class StoragegatewayCachedIscsiVolume extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: StoragegatewayCachedIscsiVolumeConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get chapEnabled(): boolean;
    private _gatewayArn;
    /**
     * @stability stable
     */
    get gatewayArn(): string;
    /**
     * @stability stable
     */
    set gatewayArn(value: string);
    /**
     * @stability stable
     */
    get gatewayArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsEncrypted?;
    /**
     * @stability stable
     */
    get kmsEncrypted(): boolean;
    /**
     * @stability stable
     */
    set kmsEncrypted(value: boolean);
    /**
     * @stability stable
     */
    resetKmsEncrypted(): void;
    /**
     * @stability stable
     */
    get kmsEncryptedInput(): boolean | undefined;
    private _kmsKey?;
    /**
     * @stability stable
     */
    get kmsKey(): string;
    /**
     * @stability stable
     */
    set kmsKey(value: string);
    /**
     * @stability stable
     */
    resetKmsKey(): void;
    /**
     * @stability stable
     */
    get kmsKeyInput(): string | undefined;
    /**
     * @stability stable
     */
    get lunNumber(): number;
    private _networkInterfaceId;
    /**
     * @stability stable
     */
    get networkInterfaceId(): string;
    /**
     * @stability stable
     */
    set networkInterfaceId(value: string);
    /**
     * @stability stable
     */
    get networkInterfaceIdInput(): string;
    /**
     * @stability stable
     */
    get networkInterfacePort(): number;
    private _snapshotId?;
    /**
     * @stability stable
     */
    get snapshotId(): string;
    /**
     * @stability stable
     */
    set snapshotId(value: string);
    /**
     * @stability stable
     */
    resetSnapshotId(): void;
    /**
     * @stability stable
     */
    get snapshotIdInput(): string | undefined;
    private _sourceVolumeArn?;
    /**
     * @stability stable
     */
    get sourceVolumeArn(): string;
    /**
     * @stability stable
     */
    set sourceVolumeArn(value: string);
    /**
     * @stability stable
     */
    resetSourceVolumeArn(): void;
    /**
     * @stability stable
     */
    get sourceVolumeArnInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get targetArn(): string;
    private _targetName;
    /**
     * @stability stable
     */
    get targetName(): string;
    /**
     * @stability stable
     */
    set targetName(value: string);
    /**
     * @stability stable
     */
    get targetNameInput(): string;
    /**
     * @stability stable
     */
    get volumeArn(): string;
    /**
     * @stability stable
     */
    get volumeId(): string;
    private _volumeSizeInBytes;
    /**
     * @stability stable
     */
    get volumeSizeInBytes(): number;
    /**
     * @stability stable
     */
    set volumeSizeInBytes(value: number);
    /**
     * @stability stable
     */
    get volumeSizeInBytesInput(): number;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
