import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface StoragegatewayGatewayConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly activationKey?: string;
    /**
     * @stability stable
     */
    readonly averageDownloadRateLimitInBitsPerSec?: number;
    /**
     * @stability stable
     */
    readonly averageUploadRateLimitInBitsPerSec?: number;
    /**
     * @stability stable
     */
    readonly cloudwatchLogGroupArn?: string;
    /**
     * @stability stable
     */
    readonly gatewayIpAddress?: string;
    /**
     * @stability stable
     */
    readonly gatewayName: string;
    /**
     * @stability stable
     */
    readonly gatewayTimezone: string;
    /**
     * @stability stable
     */
    readonly gatewayType?: string;
    /**
     * @stability stable
     */
    readonly gatewayVpcEndpoint?: string;
    /**
     * @stability stable
     */
    readonly mediumChangerType?: string;
    /**
     * @stability stable
     */
    readonly smbFileShareVisibility?: boolean;
    /**
     * @stability stable
     */
    readonly smbGuestPassword?: string;
    /**
     * @stability stable
     */
    readonly smbSecurityStrategy?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly tapeDriveType?: string;
    /**
     * smb_active_directory_settings block.
     *
     * @stability stable
     */
    readonly smbActiveDirectorySettings?: StoragegatewayGatewaySmbActiveDirectorySettings[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: StoragegatewayGatewayTimeouts;
}
/**
 * @stability stable
 */
export declare class StoragegatewayGatewayGatewayNetworkInterface extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get ipv4Address(): string;
}
/**
 * @stability stable
 */
export interface StoragegatewayGatewaySmbActiveDirectorySettings {
    /**
     * @stability stable
     */
    readonly domainControllers?: string[];
    /**
     * @stability stable
     */
    readonly domainName: string;
    /**
     * @stability stable
     */
    readonly organizationalUnit?: string;
    /**
     * @stability stable
     */
    readonly password: string;
    /**
     * @stability stable
     */
    readonly timeoutInSeconds?: number;
    /**
     * @stability stable
     */
    readonly username: string;
}
/**
 * @stability stable
 */
export interface StoragegatewayGatewayTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
}
/**
 * @stability stable
 */
export declare class StoragegatewayGateway extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: StoragegatewayGatewayConfig);
    private _activationKey?;
    /**
     * @stability stable
     */
    get activationKey(): string;
    /**
     * @stability stable
     */
    set activationKey(value: string);
    /**
     * @stability stable
     */
    resetActivationKey(): void;
    /**
     * @stability stable
     */
    get activationKeyInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _averageDownloadRateLimitInBitsPerSec?;
    /**
     * @stability stable
     */
    get averageDownloadRateLimitInBitsPerSec(): number;
    /**
     * @stability stable
     */
    set averageDownloadRateLimitInBitsPerSec(value: number);
    /**
     * @stability stable
     */
    resetAverageDownloadRateLimitInBitsPerSec(): void;
    /**
     * @stability stable
     */
    get averageDownloadRateLimitInBitsPerSecInput(): number | undefined;
    private _averageUploadRateLimitInBitsPerSec?;
    /**
     * @stability stable
     */
    get averageUploadRateLimitInBitsPerSec(): number;
    /**
     * @stability stable
     */
    set averageUploadRateLimitInBitsPerSec(value: number);
    /**
     * @stability stable
     */
    resetAverageUploadRateLimitInBitsPerSec(): void;
    /**
     * @stability stable
     */
    get averageUploadRateLimitInBitsPerSecInput(): number | undefined;
    private _cloudwatchLogGroupArn?;
    /**
     * @stability stable
     */
    get cloudwatchLogGroupArn(): string;
    /**
     * @stability stable
     */
    set cloudwatchLogGroupArn(value: string);
    /**
     * @stability stable
     */
    resetCloudwatchLogGroupArn(): void;
    /**
     * @stability stable
     */
    get cloudwatchLogGroupArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get ec2InstanceId(): string;
    /**
     * @stability stable
     */
    get endpointType(): string;
    /**
     * @stability stable
     */
    get gatewayId(): string;
    private _gatewayIpAddress?;
    /**
     * @stability stable
     */
    get gatewayIpAddress(): string;
    /**
     * @stability stable
     */
    set gatewayIpAddress(value: string);
    /**
     * @stability stable
     */
    resetGatewayIpAddress(): void;
    /**
     * @stability stable
     */
    get gatewayIpAddressInput(): string | undefined;
    private _gatewayName;
    /**
     * @stability stable
     */
    get gatewayName(): string;
    /**
     * @stability stable
     */
    set gatewayName(value: string);
    /**
     * @stability stable
     */
    get gatewayNameInput(): string;
    /**
     * @stability stable
     */
    gatewayNetworkInterface(index: string): StoragegatewayGatewayGatewayNetworkInterface;
    private _gatewayTimezone;
    /**
     * @stability stable
     */
    get gatewayTimezone(): string;
    /**
     * @stability stable
     */
    set gatewayTimezone(value: string);
    /**
     * @stability stable
     */
    get gatewayTimezoneInput(): string;
    private _gatewayType?;
    /**
     * @stability stable
     */
    get gatewayType(): string;
    /**
     * @stability stable
     */
    set gatewayType(value: string);
    /**
     * @stability stable
     */
    resetGatewayType(): void;
    /**
     * @stability stable
     */
    get gatewayTypeInput(): string | undefined;
    private _gatewayVpcEndpoint?;
    /**
     * @stability stable
     */
    get gatewayVpcEndpoint(): string;
    /**
     * @stability stable
     */
    set gatewayVpcEndpoint(value: string);
    /**
     * @stability stable
     */
    resetGatewayVpcEndpoint(): void;
    /**
     * @stability stable
     */
    get gatewayVpcEndpointInput(): string | undefined;
    /**
     * @stability stable
     */
    get hostEnvironment(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _mediumChangerType?;
    /**
     * @stability stable
     */
    get mediumChangerType(): string;
    /**
     * @stability stable
     */
    set mediumChangerType(value: string);
    /**
     * @stability stable
     */
    resetMediumChangerType(): void;
    /**
     * @stability stable
     */
    get mediumChangerTypeInput(): string | undefined;
    private _smbFileShareVisibility?;
    /**
     * @stability stable
     */
    get smbFileShareVisibility(): boolean;
    /**
     * @stability stable
     */
    set smbFileShareVisibility(value: boolean);
    /**
     * @stability stable
     */
    resetSmbFileShareVisibility(): void;
    /**
     * @stability stable
     */
    get smbFileShareVisibilityInput(): boolean | undefined;
    private _smbGuestPassword?;
    /**
     * @stability stable
     */
    get smbGuestPassword(): string;
    /**
     * @stability stable
     */
    set smbGuestPassword(value: string);
    /**
     * @stability stable
     */
    resetSmbGuestPassword(): void;
    /**
     * @stability stable
     */
    get smbGuestPasswordInput(): string | undefined;
    private _smbSecurityStrategy?;
    /**
     * @stability stable
     */
    get smbSecurityStrategy(): string;
    /**
     * @stability stable
     */
    set smbSecurityStrategy(value: string);
    /**
     * @stability stable
     */
    resetSmbSecurityStrategy(): void;
    /**
     * @stability stable
     */
    get smbSecurityStrategyInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tapeDriveType?;
    /**
     * @stability stable
     */
    get tapeDriveType(): string;
    /**
     * @stability stable
     */
    set tapeDriveType(value: string);
    /**
     * @stability stable
     */
    resetTapeDriveType(): void;
    /**
     * @stability stable
     */
    get tapeDriveTypeInput(): string | undefined;
    private _smbActiveDirectorySettings?;
    /**
     * @stability stable
     */
    get smbActiveDirectorySettings(): StoragegatewayGatewaySmbActiveDirectorySettings[];
    /**
     * @stability stable
     */
    set smbActiveDirectorySettings(value: StoragegatewayGatewaySmbActiveDirectorySettings[]);
    /**
     * @stability stable
     */
    resetSmbActiveDirectorySettings(): void;
    /**
     * @stability stable
     */
    get smbActiveDirectorySettingsInput(): StoragegatewayGatewaySmbActiveDirectorySettings[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): StoragegatewayGatewayTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: StoragegatewayGatewayTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): StoragegatewayGatewayTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
