import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface StoragegatewayNfsFileShareConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly clientList: string[];
    /**
     * @stability stable
     */
    readonly defaultStorageClass?: string;
    /**
     * @stability stable
     */
    readonly fileShareName?: string;
    /**
     * @stability stable
     */
    readonly gatewayArn: string;
    /**
     * @stability stable
     */
    readonly guessMimeTypeEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly kmsEncrypted?: boolean;
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * @stability stable
     */
    readonly locationArn: string;
    /**
     * @stability stable
     */
    readonly notificationPolicy?: string;
    /**
     * @stability stable
     */
    readonly objectAcl?: string;
    /**
     * @stability stable
     */
    readonly readOnly?: boolean;
    /**
     * @stability stable
     */
    readonly requesterPays?: boolean;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly squash?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * cache_attributes block.
     *
     * @stability stable
     */
    readonly cacheAttributes?: StoragegatewayNfsFileShareCacheAttributes[];
    /**
     * nfs_file_share_defaults block.
     *
     * @stability stable
     */
    readonly nfsFileShareDefaults?: StoragegatewayNfsFileShareNfsFileShareDefaults[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: StoragegatewayNfsFileShareTimeouts;
}
/**
 * @stability stable
 */
export interface StoragegatewayNfsFileShareCacheAttributes {
    /**
     * @stability stable
     */
    readonly cacheStaleTimeoutInSeconds?: number;
}
/**
 * @stability stable
 */
export interface StoragegatewayNfsFileShareNfsFileShareDefaults {
    /**
     * @stability stable
     */
    readonly directoryMode?: string;
    /**
     * @stability stable
     */
    readonly fileMode?: string;
    /**
     * @stability stable
     */
    readonly groupId?: string;
    /**
     * @stability stable
     */
    readonly ownerId?: string;
}
/**
 * @stability stable
 */
export interface StoragegatewayNfsFileShareTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class StoragegatewayNfsFileShare extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: StoragegatewayNfsFileShareConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _clientList;
    /**
     * @stability stable
     */
    get clientList(): string[];
    /**
     * @stability stable
     */
    set clientList(value: string[]);
    /**
     * @stability stable
     */
    get clientListInput(): string[];
    private _defaultStorageClass?;
    /**
     * @stability stable
     */
    get defaultStorageClass(): string;
    /**
     * @stability stable
     */
    set defaultStorageClass(value: string);
    /**
     * @stability stable
     */
    resetDefaultStorageClass(): void;
    /**
     * @stability stable
     */
    get defaultStorageClassInput(): string | undefined;
    private _fileShareName?;
    /**
     * @stability stable
     */
    get fileShareName(): string;
    /**
     * @stability stable
     */
    set fileShareName(value: string);
    /**
     * @stability stable
     */
    resetFileShareName(): void;
    /**
     * @stability stable
     */
    get fileShareNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get fileshareId(): string;
    private _gatewayArn;
    /**
     * @stability stable
     */
    get gatewayArn(): string;
    /**
     * @stability stable
     */
    set gatewayArn(value: string);
    /**
     * @stability stable
     */
    get gatewayArnInput(): string;
    private _guessMimeTypeEnabled?;
    /**
     * @stability stable
     */
    get guessMimeTypeEnabled(): boolean;
    /**
     * @stability stable
     */
    set guessMimeTypeEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetGuessMimeTypeEnabled(): void;
    /**
     * @stability stable
     */
    get guessMimeTypeEnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _kmsEncrypted?;
    /**
     * @stability stable
     */
    get kmsEncrypted(): boolean;
    /**
     * @stability stable
     */
    set kmsEncrypted(value: boolean);
    /**
     * @stability stable
     */
    resetKmsEncrypted(): void;
    /**
     * @stability stable
     */
    get kmsEncryptedInput(): boolean | undefined;
    private _kmsKeyArn?;
    /**
     * @stability stable
     */
    get kmsKeyArn(): string;
    /**
     * @stability stable
     */
    set kmsKeyArn(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyArn(): void;
    /**
     * @stability stable
     */
    get kmsKeyArnInput(): string | undefined;
    private _locationArn;
    /**
     * @stability stable
     */
    get locationArn(): string;
    /**
     * @stability stable
     */
    set locationArn(value: string);
    /**
     * @stability stable
     */
    get locationArnInput(): string;
    private _notificationPolicy?;
    /**
     * @stability stable
     */
    get notificationPolicy(): string;
    /**
     * @stability stable
     */
    set notificationPolicy(value: string);
    /**
     * @stability stable
     */
    resetNotificationPolicy(): void;
    /**
     * @stability stable
     */
    get notificationPolicyInput(): string | undefined;
    private _objectAcl?;
    /**
     * @stability stable
     */
    get objectAcl(): string;
    /**
     * @stability stable
     */
    set objectAcl(value: string);
    /**
     * @stability stable
     */
    resetObjectAcl(): void;
    /**
     * @stability stable
     */
    get objectAclInput(): string | undefined;
    /**
     * @stability stable
     */
    get path(): string;
    private _readOnly?;
    /**
     * @stability stable
     */
    get readOnly(): boolean;
    /**
     * @stability stable
     */
    set readOnly(value: boolean);
    /**
     * @stability stable
     */
    resetReadOnly(): void;
    /**
     * @stability stable
     */
    get readOnlyInput(): boolean | undefined;
    private _requesterPays?;
    /**
     * @stability stable
     */
    get requesterPays(): boolean;
    /**
     * @stability stable
     */
    set requesterPays(value: boolean);
    /**
     * @stability stable
     */
    resetRequesterPays(): void;
    /**
     * @stability stable
     */
    get requesterPaysInput(): boolean | undefined;
    private _roleArn;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string;
    private _squash?;
    /**
     * @stability stable
     */
    get squash(): string;
    /**
     * @stability stable
     */
    set squash(value: string);
    /**
     * @stability stable
     */
    resetSquash(): void;
    /**
     * @stability stable
     */
    get squashInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _cacheAttributes?;
    /**
     * @stability stable
     */
    get cacheAttributes(): StoragegatewayNfsFileShareCacheAttributes[];
    /**
     * @stability stable
     */
    set cacheAttributes(value: StoragegatewayNfsFileShareCacheAttributes[]);
    /**
     * @stability stable
     */
    resetCacheAttributes(): void;
    /**
     * @stability stable
     */
    get cacheAttributesInput(): StoragegatewayNfsFileShareCacheAttributes[] | undefined;
    private _nfsFileShareDefaults?;
    /**
     * @stability stable
     */
    get nfsFileShareDefaults(): StoragegatewayNfsFileShareNfsFileShareDefaults[];
    /**
     * @stability stable
     */
    set nfsFileShareDefaults(value: StoragegatewayNfsFileShareNfsFileShareDefaults[]);
    /**
     * @stability stable
     */
    resetNfsFileShareDefaults(): void;
    /**
     * @stability stable
     */
    get nfsFileShareDefaultsInput(): StoragegatewayNfsFileShareNfsFileShareDefaults[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): StoragegatewayNfsFileShareTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: StoragegatewayNfsFileShareTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): StoragegatewayNfsFileShareTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
