import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface StoragegatewaySmbFileShareConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly accessBasedEnumeration?: boolean;
    /**
     * @stability stable
     */
    readonly adminUserList?: string[];
    /**
     * @stability stable
     */
    readonly auditDestinationArn?: string;
    /**
     * @stability stable
     */
    readonly authentication?: string;
    /**
     * @stability stable
     */
    readonly caseSensitivity?: string;
    /**
     * @stability stable
     */
    readonly defaultStorageClass?: string;
    /**
     * @stability stable
     */
    readonly fileShareName?: string;
    /**
     * @stability stable
     */
    readonly gatewayArn: string;
    /**
     * @stability stable
     */
    readonly guessMimeTypeEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly invalidUserList?: string[];
    /**
     * @stability stable
     */
    readonly kmsEncrypted?: boolean;
    /**
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * @stability stable
     */
    readonly locationArn: string;
    /**
     * @stability stable
     */
    readonly notificationPolicy?: string;
    /**
     * @stability stable
     */
    readonly objectAcl?: string;
    /**
     * @stability stable
     */
    readonly readOnly?: boolean;
    /**
     * @stability stable
     */
    readonly requesterPays?: boolean;
    /**
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * @stability stable
     */
    readonly smbAclEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly validUserList?: string[];
    /**
     * cache_attributes block.
     *
     * @stability stable
     */
    readonly cacheAttributes?: StoragegatewaySmbFileShareCacheAttributes[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: StoragegatewaySmbFileShareTimeouts;
}
/**
 * @stability stable
 */
export interface StoragegatewaySmbFileShareCacheAttributes {
    /**
     * @stability stable
     */
    readonly cacheStaleTimeoutInSeconds?: number;
}
/**
 * @stability stable
 */
export interface StoragegatewaySmbFileShareTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class StoragegatewaySmbFileShare extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: StoragegatewaySmbFileShareConfig);
    private _accessBasedEnumeration?;
    /**
     * @stability stable
     */
    get accessBasedEnumeration(): boolean;
    /**
     * @stability stable
     */
    set accessBasedEnumeration(value: boolean);
    /**
     * @stability stable
     */
    resetAccessBasedEnumeration(): void;
    /**
     * @stability stable
     */
    get accessBasedEnumerationInput(): boolean | undefined;
    private _adminUserList?;
    /**
     * @stability stable
     */
    get adminUserList(): string[];
    /**
     * @stability stable
     */
    set adminUserList(value: string[]);
    /**
     * @stability stable
     */
    resetAdminUserList(): void;
    /**
     * @stability stable
     */
    get adminUserListInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _auditDestinationArn?;
    /**
     * @stability stable
     */
    get auditDestinationArn(): string;
    /**
     * @stability stable
     */
    set auditDestinationArn(value: string);
    /**
     * @stability stable
     */
    resetAuditDestinationArn(): void;
    /**
     * @stability stable
     */
    get auditDestinationArnInput(): string | undefined;
    private _authentication?;
    /**
     * @stability stable
     */
    get authentication(): string;
    /**
     * @stability stable
     */
    set authentication(value: string);
    /**
     * @stability stable
     */
    resetAuthentication(): void;
    /**
     * @stability stable
     */
    get authenticationInput(): string | undefined;
    private _caseSensitivity?;
    /**
     * @stability stable
     */
    get caseSensitivity(): string;
    /**
     * @stability stable
     */
    set caseSensitivity(value: string);
    /**
     * @stability stable
     */
    resetCaseSensitivity(): void;
    /**
     * @stability stable
     */
    get caseSensitivityInput(): string | undefined;
    private _defaultStorageClass?;
    /**
     * @stability stable
     */
    get defaultStorageClass(): string;
    /**
     * @stability stable
     */
    set defaultStorageClass(value: string);
    /**
     * @stability stable
     */
    resetDefaultStorageClass(): void;
    /**
     * @stability stable
     */
    get defaultStorageClassInput(): string | undefined;
    private _fileShareName?;
    /**
     * @stability stable
     */
    get fileShareName(): string;
    /**
     * @stability stable
     */
    set fileShareName(value: string);
    /**
     * @stability stable
     */
    resetFileShareName(): void;
    /**
     * @stability stable
     */
    get fileShareNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get fileshareId(): string;
    private _gatewayArn;
    /**
     * @stability stable
     */
    get gatewayArn(): string;
    /**
     * @stability stable
     */
    set gatewayArn(value: string);
    /**
     * @stability stable
     */
    get gatewayArnInput(): string;
    private _guessMimeTypeEnabled?;
    /**
     * @stability stable
     */
    get guessMimeTypeEnabled(): boolean;
    /**
     * @stability stable
     */
    set guessMimeTypeEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetGuessMimeTypeEnabled(): void;
    /**
     * @stability stable
     */
    get guessMimeTypeEnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _invalidUserList?;
    /**
     * @stability stable
     */
    get invalidUserList(): string[];
    /**
     * @stability stable
     */
    set invalidUserList(value: string[]);
    /**
     * @stability stable
     */
    resetInvalidUserList(): void;
    /**
     * @stability stable
     */
    get invalidUserListInput(): string[] | undefined;
    private _kmsEncrypted?;
    /**
     * @stability stable
     */
    get kmsEncrypted(): boolean;
    /**
     * @stability stable
     */
    set kmsEncrypted(value: boolean);
    /**
     * @stability stable
     */
    resetKmsEncrypted(): void;
    /**
     * @stability stable
     */
    get kmsEncryptedInput(): boolean | undefined;
    private _kmsKeyArn?;
    /**
     * @stability stable
     */
    get kmsKeyArn(): string;
    /**
     * @stability stable
     */
    set kmsKeyArn(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyArn(): void;
    /**
     * @stability stable
     */
    get kmsKeyArnInput(): string | undefined;
    private _locationArn;
    /**
     * @stability stable
     */
    get locationArn(): string;
    /**
     * @stability stable
     */
    set locationArn(value: string);
    /**
     * @stability stable
     */
    get locationArnInput(): string;
    private _notificationPolicy?;
    /**
     * @stability stable
     */
    get notificationPolicy(): string;
    /**
     * @stability stable
     */
    set notificationPolicy(value: string);
    /**
     * @stability stable
     */
    resetNotificationPolicy(): void;
    /**
     * @stability stable
     */
    get notificationPolicyInput(): string | undefined;
    private _objectAcl?;
    /**
     * @stability stable
     */
    get objectAcl(): string;
    /**
     * @stability stable
     */
    set objectAcl(value: string);
    /**
     * @stability stable
     */
    resetObjectAcl(): void;
    /**
     * @stability stable
     */
    get objectAclInput(): string | undefined;
    /**
     * @stability stable
     */
    get path(): string;
    private _readOnly?;
    /**
     * @stability stable
     */
    get readOnly(): boolean;
    /**
     * @stability stable
     */
    set readOnly(value: boolean);
    /**
     * @stability stable
     */
    resetReadOnly(): void;
    /**
     * @stability stable
     */
    get readOnlyInput(): boolean | undefined;
    private _requesterPays?;
    /**
     * @stability stable
     */
    get requesterPays(): boolean;
    /**
     * @stability stable
     */
    set requesterPays(value: boolean);
    /**
     * @stability stable
     */
    resetRequesterPays(): void;
    /**
     * @stability stable
     */
    get requesterPaysInput(): boolean | undefined;
    private _roleArn;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string;
    private _smbAclEnabled?;
    /**
     * @stability stable
     */
    get smbAclEnabled(): boolean;
    /**
     * @stability stable
     */
    set smbAclEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetSmbAclEnabled(): void;
    /**
     * @stability stable
     */
    get smbAclEnabledInput(): boolean | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _validUserList?;
    /**
     * @stability stable
     */
    get validUserList(): string[];
    /**
     * @stability stable
     */
    set validUserList(value: string[]);
    /**
     * @stability stable
     */
    resetValidUserList(): void;
    /**
     * @stability stable
     */
    get validUserListInput(): string[] | undefined;
    private _cacheAttributes?;
    /**
     * @stability stable
     */
    get cacheAttributes(): StoragegatewaySmbFileShareCacheAttributes[];
    /**
     * @stability stable
     */
    set cacheAttributes(value: StoragegatewaySmbFileShareCacheAttributes[]);
    /**
     * @stability stable
     */
    resetCacheAttributes(): void;
    /**
     * @stability stable
     */
    get cacheAttributesInput(): StoragegatewaySmbFileShareCacheAttributes[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): StoragegatewaySmbFileShareTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: StoragegatewaySmbFileShareTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): StoragegatewaySmbFileShareTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
