import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface StoragegatewayTapePoolConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly poolName: string;
    /**
     * @stability stable
     */
    readonly retentionLockTimeInDays?: number;
    /**
     * @stability stable
     */
    readonly retentionLockType?: string;
    /**
     * @stability stable
     */
    readonly storageClass: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class StoragegatewayTapePool extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: StoragegatewayTapePoolConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _poolName;
    /**
     * @stability stable
     */
    get poolName(): string;
    /**
     * @stability stable
     */
    set poolName(value: string);
    /**
     * @stability stable
     */
    get poolNameInput(): string;
    private _retentionLockTimeInDays?;
    /**
     * @stability stable
     */
    get retentionLockTimeInDays(): number;
    /**
     * @stability stable
     */
    set retentionLockTimeInDays(value: number);
    /**
     * @stability stable
     */
    resetRetentionLockTimeInDays(): void;
    /**
     * @stability stable
     */
    get retentionLockTimeInDaysInput(): number | undefined;
    private _retentionLockType?;
    /**
     * @stability stable
     */
    get retentionLockType(): string;
    /**
     * @stability stable
     */
    set retentionLockType(value: string);
    /**
     * @stability stable
     */
    resetRetentionLockType(): void;
    /**
     * @stability stable
     */
    get retentionLockTypeInput(): string | undefined;
    private _storageClass;
    /**
     * @stability stable
     */
    get storageClass(): string;
    /**
     * @stability stable
     */
    set storageClass(value: string);
    /**
     * @stability stable
     */
    get storageClassInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
