import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SyntheticsCanaryConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly artifactS3Location: string;
    /**
     * @stability stable
     */
    readonly executionRoleArn: string;
    /**
     * @stability stable
     */
    readonly failureRetentionPeriod?: number;
    /**
     * @stability stable
     */
    readonly handler: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly runtimeVersion: string;
    /**
     * @stability stable
     */
    readonly s3Bucket?: string;
    /**
     * @stability stable
     */
    readonly s3Key?: string;
    /**
     * @stability stable
     */
    readonly s3Version?: string;
    /**
     * @stability stable
     */
    readonly startCanary?: boolean;
    /**
     * @stability stable
     */
    readonly successRetentionPeriod?: number;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly zipFile?: string;
    /**
     * run_config block.
     *
     * @stability stable
     */
    readonly runConfig?: SyntheticsCanaryRunConfig[];
    /**
     * schedule block.
     *
     * @stability stable
     */
    readonly schedule: SyntheticsCanarySchedule[];
    /**
     * vpc_config block.
     *
     * @stability stable
     */
    readonly vpcConfig?: SyntheticsCanaryVpcConfig[];
}
/**
 * @stability stable
 */
export declare class SyntheticsCanaryTimeline extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get created(): string;
    /**
     * @stability stable
     */
    get lastModified(): string;
    /**
     * @stability stable
     */
    get lastStarted(): string;
    /**
     * @stability stable
     */
    get lastStopped(): string;
}
/**
 * @stability stable
 */
export interface SyntheticsCanaryRunConfig {
    /**
     * @stability stable
     */
    readonly activeTracing?: boolean;
    /**
     * @stability stable
     */
    readonly memoryInMb?: number;
    /**
     * @stability stable
     */
    readonly timeoutInSeconds?: number;
}
/**
 * @stability stable
 */
export interface SyntheticsCanarySchedule {
    /**
     * @stability stable
     */
    readonly durationInSeconds?: number;
    /**
     * @stability stable
     */
    readonly expression: string;
}
/**
 * @stability stable
 */
export interface SyntheticsCanaryVpcConfig {
    /**
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * @stability stable
     */
    readonly subnetIds?: string[];
}
/**
 * @stability stable
 */
export declare class SyntheticsCanary extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SyntheticsCanaryConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _artifactS3Location;
    /**
     * @stability stable
     */
    get artifactS3Location(): string;
    /**
     * @stability stable
     */
    set artifactS3Location(value: string);
    /**
     * @stability stable
     */
    get artifactS3LocationInput(): string;
    /**
     * @stability stable
     */
    get engineArn(): string;
    private _executionRoleArn;
    /**
     * @stability stable
     */
    get executionRoleArn(): string;
    /**
     * @stability stable
     */
    set executionRoleArn(value: string);
    /**
     * @stability stable
     */
    get executionRoleArnInput(): string;
    private _failureRetentionPeriod?;
    /**
     * @stability stable
     */
    get failureRetentionPeriod(): number;
    /**
     * @stability stable
     */
    set failureRetentionPeriod(value: number);
    /**
     * @stability stable
     */
    resetFailureRetentionPeriod(): void;
    /**
     * @stability stable
     */
    get failureRetentionPeriodInput(): number | undefined;
    private _handler;
    /**
     * @stability stable
     */
    get handler(): string;
    /**
     * @stability stable
     */
    set handler(value: string);
    /**
     * @stability stable
     */
    get handlerInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _runtimeVersion;
    /**
     * @stability stable
     */
    get runtimeVersion(): string;
    /**
     * @stability stable
     */
    set runtimeVersion(value: string);
    /**
     * @stability stable
     */
    get runtimeVersionInput(): string;
    private _s3Bucket?;
    /**
     * @stability stable
     */
    get s3Bucket(): string;
    /**
     * @stability stable
     */
    set s3Bucket(value: string);
    /**
     * @stability stable
     */
    resetS3Bucket(): void;
    /**
     * @stability stable
     */
    get s3BucketInput(): string | undefined;
    private _s3Key?;
    /**
     * @stability stable
     */
    get s3Key(): string;
    /**
     * @stability stable
     */
    set s3Key(value: string);
    /**
     * @stability stable
     */
    resetS3Key(): void;
    /**
     * @stability stable
     */
    get s3KeyInput(): string | undefined;
    private _s3Version?;
    /**
     * @stability stable
     */
    get s3Version(): string;
    /**
     * @stability stable
     */
    set s3Version(value: string);
    /**
     * @stability stable
     */
    resetS3Version(): void;
    /**
     * @stability stable
     */
    get s3VersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get sourceLocationArn(): string;
    private _startCanary?;
    /**
     * @stability stable
     */
    get startCanary(): boolean;
    /**
     * @stability stable
     */
    set startCanary(value: boolean);
    /**
     * @stability stable
     */
    resetStartCanary(): void;
    /**
     * @stability stable
     */
    get startCanaryInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get status(): string;
    private _successRetentionPeriod?;
    /**
     * @stability stable
     */
    get successRetentionPeriod(): number;
    /**
     * @stability stable
     */
    set successRetentionPeriod(value: number);
    /**
     * @stability stable
     */
    resetSuccessRetentionPeriod(): void;
    /**
     * @stability stable
     */
    get successRetentionPeriodInput(): number | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    timeline(index: string): SyntheticsCanaryTimeline;
    private _zipFile?;
    /**
     * @stability stable
     */
    get zipFile(): string;
    /**
     * @stability stable
     */
    set zipFile(value: string);
    /**
     * @stability stable
     */
    resetZipFile(): void;
    /**
     * @stability stable
     */
    get zipFileInput(): string | undefined;
    private _runConfig?;
    /**
     * @stability stable
     */
    get runConfig(): SyntheticsCanaryRunConfig[];
    /**
     * @stability stable
     */
    set runConfig(value: SyntheticsCanaryRunConfig[]);
    /**
     * @stability stable
     */
    resetRunConfig(): void;
    /**
     * @stability stable
     */
    get runConfigInput(): SyntheticsCanaryRunConfig[] | undefined;
    private _schedule;
    /**
     * @stability stable
     */
    get schedule(): SyntheticsCanarySchedule[];
    /**
     * @stability stable
     */
    set schedule(value: SyntheticsCanarySchedule[]);
    /**
     * @stability stable
     */
    get scheduleInput(): SyntheticsCanarySchedule[];
    private _vpcConfig?;
    /**
     * @stability stable
     */
    get vpcConfig(): SyntheticsCanaryVpcConfig[];
    /**
     * @stability stable
     */
    set vpcConfig(value: SyntheticsCanaryVpcConfig[]);
    /**
     * @stability stable
     */
    resetVpcConfig(): void;
    /**
     * @stability stable
     */
    get vpcConfigInput(): SyntheticsCanaryVpcConfig[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
