import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface TransferServerConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly endpointType?: string;
    /**
     * @stability stable
     */
    readonly forceDestroy?: boolean;
    /**
     * @stability stable
     */
    readonly hostKey?: string;
    /**
     * @stability stable
     */
    readonly identityProviderType?: string;
    /**
     * @stability stable
     */
    readonly invocationRole?: string;
    /**
     * @stability stable
     */
    readonly loggingRole?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly url?: string;
    /**
     * endpoint_details block.
     *
     * @stability stable
     */
    readonly endpointDetails?: TransferServerEndpointDetails[];
}
/**
 * @stability stable
 */
export interface TransferServerEndpointDetails {
    /**
     * @stability stable
     */
    readonly addressAllocationIds?: string[];
    /**
     * @stability stable
     */
    readonly subnetIds?: string[];
    /**
     * @stability stable
     */
    readonly vpcEndpointId?: string;
    /**
     * @stability stable
     */
    readonly vpcId?: string;
}
/**
 * @stability stable
 */
export declare class TransferServer extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: TransferServerConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get endpoint(): string;
    private _endpointType?;
    /**
     * @stability stable
     */
    get endpointType(): string;
    /**
     * @stability stable
     */
    set endpointType(value: string);
    /**
     * @stability stable
     */
    resetEndpointType(): void;
    /**
     * @stability stable
     */
    get endpointTypeInput(): string | undefined;
    private _forceDestroy?;
    /**
     * @stability stable
     */
    get forceDestroy(): boolean;
    /**
     * @stability stable
     */
    set forceDestroy(value: boolean);
    /**
     * @stability stable
     */
    resetForceDestroy(): void;
    /**
     * @stability stable
     */
    get forceDestroyInput(): boolean | undefined;
    private _hostKey?;
    /**
     * @stability stable
     */
    get hostKey(): string;
    /**
     * @stability stable
     */
    set hostKey(value: string);
    /**
     * @stability stable
     */
    resetHostKey(): void;
    /**
     * @stability stable
     */
    get hostKeyInput(): string | undefined;
    /**
     * @stability stable
     */
    get hostKeyFingerprint(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _identityProviderType?;
    /**
     * @stability stable
     */
    get identityProviderType(): string;
    /**
     * @stability stable
     */
    set identityProviderType(value: string);
    /**
     * @stability stable
     */
    resetIdentityProviderType(): void;
    /**
     * @stability stable
     */
    get identityProviderTypeInput(): string | undefined;
    private _invocationRole?;
    /**
     * @stability stable
     */
    get invocationRole(): string;
    /**
     * @stability stable
     */
    set invocationRole(value: string);
    /**
     * @stability stable
     */
    resetInvocationRole(): void;
    /**
     * @stability stable
     */
    get invocationRoleInput(): string | undefined;
    private _loggingRole?;
    /**
     * @stability stable
     */
    get loggingRole(): string;
    /**
     * @stability stable
     */
    set loggingRole(value: string);
    /**
     * @stability stable
     */
    resetLoggingRole(): void;
    /**
     * @stability stable
     */
    get loggingRoleInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _url?;
    /**
     * @stability stable
     */
    get url(): string;
    /**
     * @stability stable
     */
    set url(value: string);
    /**
     * @stability stable
     */
    resetUrl(): void;
    /**
     * @stability stable
     */
    get urlInput(): string | undefined;
    private _endpointDetails?;
    /**
     * @stability stable
     */
    get endpointDetails(): TransferServerEndpointDetails[];
    /**
     * @stability stable
     */
    set endpointDetails(value: TransferServerEndpointDetails[]);
    /**
     * @stability stable
     */
    resetEndpointDetails(): void;
    /**
     * @stability stable
     */
    get endpointDetailsInput(): TransferServerEndpointDetails[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
