import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VolumeAttachmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * @stability stable
     */
    readonly forceDetach?: boolean;
    /**
     * @stability stable
     */
    readonly instanceId: string;
    /**
     * @stability stable
     */
    readonly skipDestroy?: boolean;
    /**
     * @stability stable
     */
    readonly volumeId: string;
}
/**
 * @stability stable
 */
export declare class VolumeAttachment extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VolumeAttachmentConfig);
    private _deviceName;
    /**
     * @stability stable
     */
    get deviceName(): string;
    /**
     * @stability stable
     */
    set deviceName(value: string);
    /**
     * @stability stable
     */
    get deviceNameInput(): string;
    private _forceDetach?;
    /**
     * @stability stable
     */
    get forceDetach(): boolean;
    /**
     * @stability stable
     */
    set forceDetach(value: boolean);
    /**
     * @stability stable
     */
    resetForceDetach(): void;
    /**
     * @stability stable
     */
    get forceDetachInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceId;
    /**
     * @stability stable
     */
    get instanceId(): string;
    /**
     * @stability stable
     */
    set instanceId(value: string);
    /**
     * @stability stable
     */
    get instanceIdInput(): string;
    private _skipDestroy?;
    /**
     * @stability stable
     */
    get skipDestroy(): boolean;
    /**
     * @stability stable
     */
    set skipDestroy(value: boolean);
    /**
     * @stability stable
     */
    resetSkipDestroy(): void;
    /**
     * @stability stable
     */
    get skipDestroyInput(): boolean | undefined;
    private _volumeId;
    /**
     * @stability stable
     */
    get volumeId(): string;
    /**
     * @stability stable
     */
    set volumeId(value: string);
    /**
     * @stability stable
     */
    get volumeIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
