import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VpcEndpointConnectionNotificationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly connectionEvents: string[];
    /**
     * @stability stable
     */
    readonly connectionNotificationArn: string;
    /**
     * @stability stable
     */
    readonly vpcEndpointId?: string;
    /**
     * @stability stable
     */
    readonly vpcEndpointServiceId?: string;
}
/**
 * @stability stable
 */
export declare class VpcEndpointConnectionNotification extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VpcEndpointConnectionNotificationConfig);
    private _connectionEvents;
    /**
     * @stability stable
     */
    get connectionEvents(): string[];
    /**
     * @stability stable
     */
    set connectionEvents(value: string[]);
    /**
     * @stability stable
     */
    get connectionEventsInput(): string[];
    private _connectionNotificationArn;
    /**
     * @stability stable
     */
    get connectionNotificationArn(): string;
    /**
     * @stability stable
     */
    set connectionNotificationArn(value: string);
    /**
     * @stability stable
     */
    get connectionNotificationArnInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get notificationType(): string;
    /**
     * @stability stable
     */
    get state(): string;
    private _vpcEndpointId?;
    /**
     * @stability stable
     */
    get vpcEndpointId(): string;
    /**
     * @stability stable
     */
    set vpcEndpointId(value: string);
    /**
     * @stability stable
     */
    resetVpcEndpointId(): void;
    /**
     * @stability stable
     */
    get vpcEndpointIdInput(): string | undefined;
    private _vpcEndpointServiceId?;
    /**
     * @stability stable
     */
    get vpcEndpointServiceId(): string;
    /**
     * @stability stable
     */
    set vpcEndpointServiceId(value: string);
    /**
     * @stability stable
     */
    resetVpcEndpointServiceId(): void;
    /**
     * @stability stable
     */
    get vpcEndpointServiceIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
