import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VpcEndpointServiceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly acceptanceRequired: boolean;
    /**
     * @stability stable
     */
    readonly allowedPrincipals?: string[];
    /**
     * @stability stable
     */
    readonly gatewayLoadBalancerArns?: string[];
    /**
     * @stability stable
     */
    readonly networkLoadBalancerArns?: string[];
    /**
     * @stability stable
     */
    readonly privateDnsName?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class VpcEndpointServicePrivateDnsNameConfiguration extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    get value(): string;
}
/**
 * @stability stable
 */
export declare class VpcEndpointService extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VpcEndpointServiceConfig);
    private _acceptanceRequired;
    /**
     * @stability stable
     */
    get acceptanceRequired(): boolean;
    /**
     * @stability stable
     */
    set acceptanceRequired(value: boolean);
    /**
     * @stability stable
     */
    get acceptanceRequiredInput(): boolean;
    private _allowedPrincipals?;
    /**
     * @stability stable
     */
    get allowedPrincipals(): string[];
    /**
     * @stability stable
     */
    set allowedPrincipals(value: string[]);
    /**
     * @stability stable
     */
    resetAllowedPrincipals(): void;
    /**
     * @stability stable
     */
    get allowedPrincipalsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    /**
     * @stability stable
     */
    get baseEndpointDnsNames(): string[];
    private _gatewayLoadBalancerArns?;
    /**
     * @stability stable
     */
    get gatewayLoadBalancerArns(): string[];
    /**
     * @stability stable
     */
    set gatewayLoadBalancerArns(value: string[]);
    /**
     * @stability stable
     */
    resetGatewayLoadBalancerArns(): void;
    /**
     * @stability stable
     */
    get gatewayLoadBalancerArnsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get managesVpcEndpoints(): boolean;
    private _networkLoadBalancerArns?;
    /**
     * @stability stable
     */
    get networkLoadBalancerArns(): string[];
    /**
     * @stability stable
     */
    set networkLoadBalancerArns(value: string[]);
    /**
     * @stability stable
     */
    resetNetworkLoadBalancerArns(): void;
    /**
     * @stability stable
     */
    get networkLoadBalancerArnsInput(): string[] | undefined;
    private _privateDnsName?;
    /**
     * @stability stable
     */
    get privateDnsName(): string;
    /**
     * @stability stable
     */
    set privateDnsName(value: string);
    /**
     * @stability stable
     */
    resetPrivateDnsName(): void;
    /**
     * @stability stable
     */
    get privateDnsNameInput(): string | undefined;
    /**
     * @stability stable
     */
    privateDnsNameConfiguration(index: string): VpcEndpointServicePrivateDnsNameConfiguration;
    /**
     * @stability stable
     */
    get serviceName(): string;
    /**
     * @stability stable
     */
    get serviceType(): string;
    /**
     * @stability stable
     */
    get state(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
