import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VpcEndpointSubnetAssociationConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly subnetId: string;
    /**
     * @stability stable
     */
    readonly vpcEndpointId: string;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: VpcEndpointSubnetAssociationTimeouts;
}
/**
 * @stability stable
 */
export interface VpcEndpointSubnetAssociationTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export declare class VpcEndpointSubnetAssociation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VpcEndpointSubnetAssociationConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _subnetId;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    get subnetIdInput(): string;
    private _vpcEndpointId;
    /**
     * @stability stable
     */
    get vpcEndpointId(): string;
    /**
     * @stability stable
     */
    set vpcEndpointId(value: string);
    /**
     * @stability stable
     */
    get vpcEndpointIdInput(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): VpcEndpointSubnetAssociationTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: VpcEndpointSubnetAssociationTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): VpcEndpointSubnetAssociationTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
