import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VpcEndpointConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly autoAccept?: boolean;
    /**
     * @stability stable
     */
    readonly policy?: string;
    /**
     * @stability stable
     */
    readonly privateDnsEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly routeTableIds?: string[];
    /**
     * @stability stable
     */
    readonly securityGroupIds?: string[];
    /**
     * @stability stable
     */
    readonly serviceName: string;
    /**
     * @stability stable
     */
    readonly subnetIds?: string[];
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcEndpointType?: string;
    /**
     * @stability stable
     */
    readonly vpcId: string;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: VpcEndpointTimeouts;
}
/**
 * @stability stable
 */
export declare class VpcEndpointDnsEntry extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get dnsName(): string;
    /**
     * @stability stable
     */
    get hostedZoneId(): string;
}
/**
 * @stability stable
 */
export interface VpcEndpointTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class VpcEndpoint extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VpcEndpointConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _autoAccept?;
    /**
     * @stability stable
     */
    get autoAccept(): boolean;
    /**
     * @stability stable
     */
    set autoAccept(value: boolean);
    /**
     * @stability stable
     */
    resetAutoAccept(): void;
    /**
     * @stability stable
     */
    get autoAcceptInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get cidrBlocks(): string[];
    /**
     * @stability stable
     */
    dnsEntry(index: string): VpcEndpointDnsEntry;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get networkInterfaceIds(): string[];
    /**
     * @stability stable
     */
    get ownerId(): string;
    private _policy?;
    /**
     * @stability stable
     */
    get policy(): string;
    /**
     * @stability stable
     */
    set policy(value: string);
    /**
     * @stability stable
     */
    resetPolicy(): void;
    /**
     * @stability stable
     */
    get policyInput(): string | undefined;
    /**
     * @stability stable
     */
    get prefixListId(): string;
    private _privateDnsEnabled?;
    /**
     * @stability stable
     */
    get privateDnsEnabled(): boolean;
    /**
     * @stability stable
     */
    set privateDnsEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetPrivateDnsEnabled(): void;
    /**
     * @stability stable
     */
    get privateDnsEnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get requesterManaged(): boolean;
    private _routeTableIds?;
    /**
     * @stability stable
     */
    get routeTableIds(): string[];
    /**
     * @stability stable
     */
    set routeTableIds(value: string[]);
    /**
     * @stability stable
     */
    resetRouteTableIds(): void;
    /**
     * @stability stable
     */
    get routeTableIdsInput(): string[] | undefined;
    private _securityGroupIds?;
    /**
     * @stability stable
     */
    get securityGroupIds(): string[];
    /**
     * @stability stable
     */
    set securityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get securityGroupIdsInput(): string[] | undefined;
    private _serviceName;
    /**
     * @stability stable
     */
    get serviceName(): string;
    /**
     * @stability stable
     */
    set serviceName(value: string);
    /**
     * @stability stable
     */
    get serviceNameInput(): string;
    /**
     * @stability stable
     */
    get state(): string;
    private _subnetIds?;
    /**
     * @stability stable
     */
    get subnetIds(): string[];
    /**
     * @stability stable
     */
    set subnetIds(value: string[]);
    /**
     * @stability stable
     */
    resetSubnetIds(): void;
    /**
     * @stability stable
     */
    get subnetIdsInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcEndpointType?;
    /**
     * @stability stable
     */
    get vpcEndpointType(): string;
    /**
     * @stability stable
     */
    set vpcEndpointType(value: string);
    /**
     * @stability stable
     */
    resetVpcEndpointType(): void;
    /**
     * @stability stable
     */
    get vpcEndpointTypeInput(): string | undefined;
    private _vpcId;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): VpcEndpointTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: VpcEndpointTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): VpcEndpointTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
