import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VpcPeeringConnectionAccepterAConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly autoAccept?: boolean;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcPeeringConnectionId: string;
    /**
     * accepter block.
     *
     * @stability stable
     */
    readonly accepter?: VpcPeeringConnectionAccepterAccepter[];
    /**
     * requester block.
     *
     * @stability stable
     */
    readonly requester?: VpcPeeringConnectionAccepterRequester[];
}
/**
 * @stability stable
 */
export interface VpcPeeringConnectionAccepterAccepter {
    /**
     * @stability stable
     */
    readonly allowClassicLinkToRemoteVpc?: boolean;
    /**
     * @stability stable
     */
    readonly allowRemoteVpcDnsResolution?: boolean;
    /**
     * @stability stable
     */
    readonly allowVpcToRemoteClassicLink?: boolean;
}
/**
 * @stability stable
 */
export interface VpcPeeringConnectionAccepterRequester {
    /**
     * @stability stable
     */
    readonly allowClassicLinkToRemoteVpc?: boolean;
    /**
     * @stability stable
     */
    readonly allowRemoteVpcDnsResolution?: boolean;
    /**
     * @stability stable
     */
    readonly allowVpcToRemoteClassicLink?: boolean;
}
/**
 * @stability stable
 */
export declare class VpcPeeringConnectionAccepterA extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VpcPeeringConnectionAccepterAConfig);
    /**
     * @stability stable
     */
    get acceptStatus(): string;
    private _autoAccept?;
    /**
     * @stability stable
     */
    get autoAccept(): boolean;
    /**
     * @stability stable
     */
    set autoAccept(value: boolean);
    /**
     * @stability stable
     */
    resetAutoAccept(): void;
    /**
     * @stability stable
     */
    get autoAcceptInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get peerOwnerId(): string;
    /**
     * @stability stable
     */
    get peerRegion(): string;
    /**
     * @stability stable
     */
    get peerVpcId(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    get vpcId(): string;
    private _vpcPeeringConnectionId;
    /**
     * @stability stable
     */
    get vpcPeeringConnectionId(): string;
    /**
     * @stability stable
     */
    set vpcPeeringConnectionId(value: string);
    /**
     * @stability stable
     */
    get vpcPeeringConnectionIdInput(): string;
    private _accepter?;
    /**
     * @stability stable
     */
    get accepter(): VpcPeeringConnectionAccepterAccepter[];
    /**
     * @stability stable
     */
    set accepter(value: VpcPeeringConnectionAccepterAccepter[]);
    /**
     * @stability stable
     */
    resetAccepter(): void;
    /**
     * @stability stable
     */
    get accepterInput(): VpcPeeringConnectionAccepterAccepter[] | undefined;
    private _requester?;
    /**
     * @stability stable
     */
    get requester(): VpcPeeringConnectionAccepterRequester[];
    /**
     * @stability stable
     */
    set requester(value: VpcPeeringConnectionAccepterRequester[]);
    /**
     * @stability stable
     */
    resetRequester(): void;
    /**
     * @stability stable
     */
    get requesterInput(): VpcPeeringConnectionAccepterRequester[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
