import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VpcPeeringConnectionOptionsConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly vpcPeeringConnectionId: string;
    /**
     * accepter block.
     *
     * @stability stable
     */
    readonly accepter?: VpcPeeringConnectionOptionsAccepter[];
    /**
     * requester block.
     *
     * @stability stable
     */
    readonly requester?: VpcPeeringConnectionOptionsRequester[];
}
/**
 * @stability stable
 */
export interface VpcPeeringConnectionOptionsAccepter {
    /**
     * @stability stable
     */
    readonly allowClassicLinkToRemoteVpc?: boolean;
    /**
     * @stability stable
     */
    readonly allowRemoteVpcDnsResolution?: boolean;
    /**
     * @stability stable
     */
    readonly allowVpcToRemoteClassicLink?: boolean;
}
/**
 * @stability stable
 */
export interface VpcPeeringConnectionOptionsRequester {
    /**
     * @stability stable
     */
    readonly allowClassicLinkToRemoteVpc?: boolean;
    /**
     * @stability stable
     */
    readonly allowRemoteVpcDnsResolution?: boolean;
    /**
     * @stability stable
     */
    readonly allowVpcToRemoteClassicLink?: boolean;
}
/**
 * @stability stable
 */
export declare class VpcPeeringConnectionOptions extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VpcPeeringConnectionOptionsConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _vpcPeeringConnectionId;
    /**
     * @stability stable
     */
    get vpcPeeringConnectionId(): string;
    /**
     * @stability stable
     */
    set vpcPeeringConnectionId(value: string);
    /**
     * @stability stable
     */
    get vpcPeeringConnectionIdInput(): string;
    private _accepter?;
    /**
     * @stability stable
     */
    get accepter(): VpcPeeringConnectionOptionsAccepter[];
    /**
     * @stability stable
     */
    set accepter(value: VpcPeeringConnectionOptionsAccepter[]);
    /**
     * @stability stable
     */
    resetAccepter(): void;
    /**
     * @stability stable
     */
    get accepterInput(): VpcPeeringConnectionOptionsAccepter[] | undefined;
    private _requester?;
    /**
     * @stability stable
     */
    get requester(): VpcPeeringConnectionOptionsRequester[];
    /**
     * @stability stable
     */
    set requester(value: VpcPeeringConnectionOptionsRequester[]);
    /**
     * @stability stable
     */
    resetRequester(): void;
    /**
     * @stability stable
     */
    get requesterInput(): VpcPeeringConnectionOptionsRequester[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
