import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VpcPeeringConnectionConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly autoAccept?: boolean;
    /**
     * @stability stable
     */
    readonly peerOwnerId?: string;
    /**
     * @stability stable
     */
    readonly peerRegion?: string;
    /**
     * @stability stable
     */
    readonly peerVpcId: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcId: string;
    /**
     * accepter block.
     *
     * @stability stable
     */
    readonly accepter?: VpcPeeringConnectionAccepter[];
    /**
     * requester block.
     *
     * @stability stable
     */
    readonly requester?: VpcPeeringConnectionRequester[];
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: VpcPeeringConnectionTimeouts;
}
/**
 * @stability stable
 */
export interface VpcPeeringConnectionAccepter {
    /**
     * @stability stable
     */
    readonly allowClassicLinkToRemoteVpc?: boolean;
    /**
     * @stability stable
     */
    readonly allowRemoteVpcDnsResolution?: boolean;
    /**
     * @stability stable
     */
    readonly allowVpcToRemoteClassicLink?: boolean;
}
/**
 * @stability stable
 */
export interface VpcPeeringConnectionRequester {
    /**
     * @stability stable
     */
    readonly allowClassicLinkToRemoteVpc?: boolean;
    /**
     * @stability stable
     */
    readonly allowRemoteVpcDnsResolution?: boolean;
    /**
     * @stability stable
     */
    readonly allowVpcToRemoteClassicLink?: boolean;
}
/**
 * @stability stable
 */
export interface VpcPeeringConnectionTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export declare class VpcPeeringConnection extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VpcPeeringConnectionConfig);
    /**
     * @stability stable
     */
    get acceptStatus(): string;
    private _autoAccept?;
    /**
     * @stability stable
     */
    get autoAccept(): boolean;
    /**
     * @stability stable
     */
    set autoAccept(value: boolean);
    /**
     * @stability stable
     */
    resetAutoAccept(): void;
    /**
     * @stability stable
     */
    get autoAcceptInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _peerOwnerId?;
    /**
     * @stability stable
     */
    get peerOwnerId(): string;
    /**
     * @stability stable
     */
    set peerOwnerId(value: string);
    /**
     * @stability stable
     */
    resetPeerOwnerId(): void;
    /**
     * @stability stable
     */
    get peerOwnerIdInput(): string | undefined;
    private _peerRegion?;
    /**
     * @stability stable
     */
    get peerRegion(): string;
    /**
     * @stability stable
     */
    set peerRegion(value: string);
    /**
     * @stability stable
     */
    resetPeerRegion(): void;
    /**
     * @stability stable
     */
    get peerRegionInput(): string | undefined;
    private _peerVpcId;
    /**
     * @stability stable
     */
    get peerVpcId(): string;
    /**
     * @stability stable
     */
    set peerVpcId(value: string);
    /**
     * @stability stable
     */
    get peerVpcIdInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcId;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string;
    private _accepter?;
    /**
     * @stability stable
     */
    get accepter(): VpcPeeringConnectionAccepter[];
    /**
     * @stability stable
     */
    set accepter(value: VpcPeeringConnectionAccepter[]);
    /**
     * @stability stable
     */
    resetAccepter(): void;
    /**
     * @stability stable
     */
    get accepterInput(): VpcPeeringConnectionAccepter[] | undefined;
    private _requester?;
    /**
     * @stability stable
     */
    get requester(): VpcPeeringConnectionRequester[];
    /**
     * @stability stable
     */
    set requester(value: VpcPeeringConnectionRequester[]);
    /**
     * @stability stable
     */
    resetRequester(): void;
    /**
     * @stability stable
     */
    get requesterInput(): VpcPeeringConnectionRequester[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): VpcPeeringConnectionTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: VpcPeeringConnectionTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): VpcPeeringConnectionTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
