import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VpnGatewayConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly amazonSideAsn?: string;
    /**
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly vpcId?: string;
}
/**
 * @stability stable
 */
export declare class VpnGateway extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: VpnGatewayConfig);
    private _amazonSideAsn?;
    /**
     * @stability stable
     */
    get amazonSideAsn(): string;
    /**
     * @stability stable
     */
    set amazonSideAsn(value: string);
    /**
     * @stability stable
     */
    resetAmazonSideAsn(): void;
    /**
     * @stability stable
     */
    get amazonSideAsnInput(): string | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    resetVpcId(): void;
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
