import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafGeoMatchSetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * geo_match_constraint block.
     *
     * @stability stable
     */
    readonly geoMatchConstraint?: WafGeoMatchSetGeoMatchConstraint[];
}
/**
 * @stability stable
 */
export interface WafGeoMatchSetGeoMatchConstraint {
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export declare class WafGeoMatchSet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafGeoMatchSetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _geoMatchConstraint?;
    /**
     * @stability stable
     */
    get geoMatchConstraint(): WafGeoMatchSetGeoMatchConstraint[];
    /**
     * @stability stable
     */
    set geoMatchConstraint(value: WafGeoMatchSetGeoMatchConstraint[]);
    /**
     * @stability stable
     */
    resetGeoMatchConstraint(): void;
    /**
     * @stability stable
     */
    get geoMatchConstraintInput(): WafGeoMatchSetGeoMatchConstraint[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
