import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafIpsetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * ip_set_descriptors block.
     *
     * @stability stable
     */
    readonly ipSetDescriptors?: WafIpsetIpSetDescriptors[];
}
/**
 * @stability stable
 */
export interface WafIpsetIpSetDescriptors {
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export declare class WafIpset extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafIpsetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _ipSetDescriptors?;
    /**
     * @stability stable
     */
    get ipSetDescriptors(): WafIpsetIpSetDescriptors[];
    /**
     * @stability stable
     */
    set ipSetDescriptors(value: WafIpsetIpSetDescriptors[]);
    /**
     * @stability stable
     */
    resetIpSetDescriptors(): void;
    /**
     * @stability stable
     */
    get ipSetDescriptorsInput(): WafIpsetIpSetDescriptors[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
