import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafRateBasedRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly metricName: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly rateKey: string;
    /**
     * @stability stable
     */
    readonly rateLimit: number;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * predicates block.
     *
     * @stability stable
     */
    readonly predicates?: WafRateBasedRulePredicates[];
}
/**
 * @stability stable
 */
export interface WafRateBasedRulePredicates {
    /**
     * @stability stable
     */
    readonly dataId: string;
    /**
     * @stability stable
     */
    readonly negated: boolean;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export declare class WafRateBasedRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafRateBasedRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _metricName;
    /**
     * @stability stable
     */
    get metricName(): string;
    /**
     * @stability stable
     */
    set metricName(value: string);
    /**
     * @stability stable
     */
    get metricNameInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _rateKey;
    /**
     * @stability stable
     */
    get rateKey(): string;
    /**
     * @stability stable
     */
    set rateKey(value: string);
    /**
     * @stability stable
     */
    get rateKeyInput(): string;
    private _rateLimit;
    /**
     * @stability stable
     */
    get rateLimit(): number;
    /**
     * @stability stable
     */
    set rateLimit(value: number);
    /**
     * @stability stable
     */
    get rateLimitInput(): number;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _predicates?;
    /**
     * @stability stable
     */
    get predicates(): WafRateBasedRulePredicates[];
    /**
     * @stability stable
     */
    set predicates(value: WafRateBasedRulePredicates[]);
    /**
     * @stability stable
     */
    resetPredicates(): void;
    /**
     * @stability stable
     */
    get predicatesInput(): WafRateBasedRulePredicates[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
