import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafRegexMatchSetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * regex_match_tuple block.
     *
     * @stability stable
     */
    readonly regexMatchTuple?: WafRegexMatchSetRegexMatchTuple[];
}
/**
 * @stability stable
 */
export interface WafRegexMatchSetRegexMatchTupleFieldToMatch {
    /**
     * @stability stable
     */
    readonly data?: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafRegexMatchSetRegexMatchTuple {
    /**
     * @stability stable
     */
    readonly regexPatternSetId: string;
    /**
     * @stability stable
     */
    readonly textTransformation: string;
    /**
     * field_to_match block.
     *
     * @stability stable
     */
    readonly fieldToMatch: WafRegexMatchSetRegexMatchTupleFieldToMatch[];
}
/**
 * @stability stable
 */
export declare class WafRegexMatchSet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafRegexMatchSetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _regexMatchTuple?;
    /**
     * @stability stable
     */
    get regexMatchTuple(): WafRegexMatchSetRegexMatchTuple[];
    /**
     * @stability stable
     */
    set regexMatchTuple(value: WafRegexMatchSetRegexMatchTuple[]);
    /**
     * @stability stable
     */
    resetRegexMatchTuple(): void;
    /**
     * @stability stable
     */
    get regexMatchTupleInput(): WafRegexMatchSetRegexMatchTuple[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
