import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafRuleGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly metricName: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * activated_rule block.
     *
     * @stability stable
     */
    readonly activatedRule?: WafRuleGroupActivatedRule[];
}
/**
 * @stability stable
 */
export interface WafRuleGroupActivatedRuleAction {
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafRuleGroupActivatedRule {
    /**
     * @stability stable
     */
    readonly priority: number;
    /**
     * @stability stable
     */
    readonly ruleId: string;
    /**
     * @stability stable
     */
    readonly type?: string;
    /**
     * action block.
     *
     * @stability stable
     */
    readonly action: WafRuleGroupActivatedRuleAction[];
}
/**
 * @stability stable
 */
export declare class WafRuleGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafRuleGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _metricName;
    /**
     * @stability stable
     */
    get metricName(): string;
    /**
     * @stability stable
     */
    set metricName(value: string);
    /**
     * @stability stable
     */
    get metricNameInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _activatedRule?;
    /**
     * @stability stable
     */
    get activatedRule(): WafRuleGroupActivatedRule[];
    /**
     * @stability stable
     */
    set activatedRule(value: WafRuleGroupActivatedRule[]);
    /**
     * @stability stable
     */
    resetActivatedRule(): void;
    /**
     * @stability stable
     */
    get activatedRuleInput(): WafRuleGroupActivatedRule[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
