import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly metricName: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * predicates block.
     *
     * @stability stable
     */
    readonly predicates?: WafRulePredicates[];
}
/**
 * @stability stable
 */
export interface WafRulePredicates {
    /**
     * @stability stable
     */
    readonly dataId: string;
    /**
     * @stability stable
     */
    readonly negated: boolean;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export declare class WafRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _metricName;
    /**
     * @stability stable
     */
    get metricName(): string;
    /**
     * @stability stable
     */
    set metricName(value: string);
    /**
     * @stability stable
     */
    get metricNameInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _predicates?;
    /**
     * @stability stable
     */
    get predicates(): WafRulePredicates[];
    /**
     * @stability stable
     */
    set predicates(value: WafRulePredicates[]);
    /**
     * @stability stable
     */
    resetPredicates(): void;
    /**
     * @stability stable
     */
    get predicatesInput(): WafRulePredicates[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
