import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafSizeConstraintSetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * size_constraints block.
     *
     * @stability stable
     */
    readonly sizeConstraints?: WafSizeConstraintSetSizeConstraints[];
}
/**
 * @stability stable
 */
export interface WafSizeConstraintSetSizeConstraintsFieldToMatch {
    /**
     * @stability stable
     */
    readonly data?: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafSizeConstraintSetSizeConstraints {
    /**
     * @stability stable
     */
    readonly comparisonOperator: string;
    /**
     * @stability stable
     */
    readonly size: number;
    /**
     * @stability stable
     */
    readonly textTransformation: string;
    /**
     * field_to_match block.
     *
     * @stability stable
     */
    readonly fieldToMatch: WafSizeConstraintSetSizeConstraintsFieldToMatch[];
}
/**
 * @stability stable
 */
export declare class WafSizeConstraintSet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafSizeConstraintSetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _sizeConstraints?;
    /**
     * @stability stable
     */
    get sizeConstraints(): WafSizeConstraintSetSizeConstraints[];
    /**
     * @stability stable
     */
    set sizeConstraints(value: WafSizeConstraintSetSizeConstraints[]);
    /**
     * @stability stable
     */
    resetSizeConstraints(): void;
    /**
     * @stability stable
     */
    get sizeConstraintsInput(): WafSizeConstraintSetSizeConstraints[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
