import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafSqlInjectionMatchSetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * sql_injection_match_tuples block.
     *
     * @stability stable
     */
    readonly sqlInjectionMatchTuples?: WafSqlInjectionMatchSetSqlInjectionMatchTuples[];
}
/**
 * @stability stable
 */
export interface WafSqlInjectionMatchSetSqlInjectionMatchTuplesFieldToMatch {
    /**
     * @stability stable
     */
    readonly data?: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafSqlInjectionMatchSetSqlInjectionMatchTuples {
    /**
     * @stability stable
     */
    readonly textTransformation: string;
    /**
     * field_to_match block.
     *
     * @stability stable
     */
    readonly fieldToMatch: WafSqlInjectionMatchSetSqlInjectionMatchTuplesFieldToMatch[];
}
/**
 * @stability stable
 */
export declare class WafSqlInjectionMatchSet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafSqlInjectionMatchSetConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _sqlInjectionMatchTuples?;
    /**
     * @stability stable
     */
    get sqlInjectionMatchTuples(): WafSqlInjectionMatchSetSqlInjectionMatchTuples[];
    /**
     * @stability stable
     */
    set sqlInjectionMatchTuples(value: WafSqlInjectionMatchSetSqlInjectionMatchTuples[]);
    /**
     * @stability stable
     */
    resetSqlInjectionMatchTuples(): void;
    /**
     * @stability stable
     */
    get sqlInjectionMatchTuplesInput(): WafSqlInjectionMatchSetSqlInjectionMatchTuples[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
