import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafWebAclConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly metricName: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * default_action block.
     *
     * @stability stable
     */
    readonly defaultAction: WafWebAclDefaultAction[];
    /**
     * logging_configuration block.
     *
     * @stability stable
     */
    readonly loggingConfiguration?: WafWebAclLoggingConfiguration[];
    /**
     * rules block.
     *
     * @stability stable
     */
    readonly rules?: WafWebAclRules[];
}
/**
 * @stability stable
 */
export interface WafWebAclDefaultAction {
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafWebAclLoggingConfigurationRedactedFieldsFieldToMatch {
    /**
     * @stability stable
     */
    readonly data?: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafWebAclLoggingConfigurationRedactedFields {
    /**
     * field_to_match block.
     *
     * @stability stable
     */
    readonly fieldToMatch: WafWebAclLoggingConfigurationRedactedFieldsFieldToMatch[];
}
/**
 * @stability stable
 */
export interface WafWebAclLoggingConfiguration {
    /**
     * @stability stable
     */
    readonly logDestination: string;
    /**
     * redacted_fields block.
     *
     * @stability stable
     */
    readonly redactedFields?: WafWebAclLoggingConfigurationRedactedFields[];
}
/**
 * @stability stable
 */
export interface WafWebAclRulesAction {
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafWebAclRulesOverrideAction {
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafWebAclRules {
    /**
     * @stability stable
     */
    readonly priority: number;
    /**
     * @stability stable
     */
    readonly ruleId: string;
    /**
     * @stability stable
     */
    readonly type?: string;
    /**
     * action block.
     *
     * @stability stable
     */
    readonly action?: WafWebAclRulesAction[];
    /**
     * override_action block.
     *
     * @stability stable
     */
    readonly overrideAction?: WafWebAclRulesOverrideAction[];
}
/**
 * @stability stable
 */
export declare class WafWebAcl extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafWebAclConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _metricName;
    /**
     * @stability stable
     */
    get metricName(): string;
    /**
     * @stability stable
     */
    set metricName(value: string);
    /**
     * @stability stable
     */
    get metricNameInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _defaultAction;
    /**
     * @stability stable
     */
    get defaultAction(): WafWebAclDefaultAction[];
    /**
     * @stability stable
     */
    set defaultAction(value: WafWebAclDefaultAction[]);
    /**
     * @stability stable
     */
    get defaultActionInput(): WafWebAclDefaultAction[];
    private _loggingConfiguration?;
    /**
     * @stability stable
     */
    get loggingConfiguration(): WafWebAclLoggingConfiguration[];
    /**
     * @stability stable
     */
    set loggingConfiguration(value: WafWebAclLoggingConfiguration[]);
    /**
     * @stability stable
     */
    resetLoggingConfiguration(): void;
    /**
     * @stability stable
     */
    get loggingConfigurationInput(): WafWebAclLoggingConfiguration[] | undefined;
    private _rules?;
    /**
     * @stability stable
     */
    get rules(): WafWebAclRules[];
    /**
     * @stability stable
     */
    set rules(value: WafWebAclRules[]);
    /**
     * @stability stable
     */
    resetRules(): void;
    /**
     * @stability stable
     */
    get rulesInput(): WafWebAclRules[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
