import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafregionalGeoMatchSetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * geo_match_constraint block.
     *
     * @stability stable
     */
    readonly geoMatchConstraint?: WafregionalGeoMatchSetGeoMatchConstraint[];
}
/**
 * @stability stable
 */
export interface WafregionalGeoMatchSetGeoMatchConstraint {
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export declare class WafregionalGeoMatchSet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafregionalGeoMatchSetConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _geoMatchConstraint?;
    /**
     * @stability stable
     */
    get geoMatchConstraint(): WafregionalGeoMatchSetGeoMatchConstraint[];
    /**
     * @stability stable
     */
    set geoMatchConstraint(value: WafregionalGeoMatchSetGeoMatchConstraint[]);
    /**
     * @stability stable
     */
    resetGeoMatchConstraint(): void;
    /**
     * @stability stable
     */
    get geoMatchConstraintInput(): WafregionalGeoMatchSetGeoMatchConstraint[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
