import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafregionalIpsetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * ip_set_descriptor block.
     *
     * @stability stable
     */
    readonly ipSetDescriptor?: WafregionalIpsetIpSetDescriptor[];
}
/**
 * @stability stable
 */
export interface WafregionalIpsetIpSetDescriptor {
    /**
     * @stability stable
     */
    readonly type: string;
    /**
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export declare class WafregionalIpset extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafregionalIpsetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _ipSetDescriptor?;
    /**
     * @stability stable
     */
    get ipSetDescriptor(): WafregionalIpsetIpSetDescriptor[];
    /**
     * @stability stable
     */
    set ipSetDescriptor(value: WafregionalIpsetIpSetDescriptor[]);
    /**
     * @stability stable
     */
    resetIpSetDescriptor(): void;
    /**
     * @stability stable
     */
    get ipSetDescriptorInput(): WafregionalIpsetIpSetDescriptor[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
