import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafregionalRegexMatchSetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * regex_match_tuple block.
     *
     * @stability stable
     */
    readonly regexMatchTuple?: WafregionalRegexMatchSetRegexMatchTuple[];
}
/**
 * @stability stable
 */
export interface WafregionalRegexMatchSetRegexMatchTupleFieldToMatch {
    /**
     * @stability stable
     */
    readonly data?: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafregionalRegexMatchSetRegexMatchTuple {
    /**
     * @stability stable
     */
    readonly regexPatternSetId: string;
    /**
     * @stability stable
     */
    readonly textTransformation: string;
    /**
     * field_to_match block.
     *
     * @stability stable
     */
    readonly fieldToMatch: WafregionalRegexMatchSetRegexMatchTupleFieldToMatch[];
}
/**
 * @stability stable
 */
export declare class WafregionalRegexMatchSet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafregionalRegexMatchSetConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _regexMatchTuple?;
    /**
     * @stability stable
     */
    get regexMatchTuple(): WafregionalRegexMatchSetRegexMatchTuple[];
    /**
     * @stability stable
     */
    set regexMatchTuple(value: WafregionalRegexMatchSetRegexMatchTuple[]);
    /**
     * @stability stable
     */
    resetRegexMatchTuple(): void;
    /**
     * @stability stable
     */
    get regexMatchTupleInput(): WafregionalRegexMatchSetRegexMatchTuple[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
