import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafregionalRuleGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly metricName: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * activated_rule block.
     *
     * @stability stable
     */
    readonly activatedRule?: WafregionalRuleGroupActivatedRule[];
}
/**
 * @stability stable
 */
export interface WafregionalRuleGroupActivatedRuleAction {
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafregionalRuleGroupActivatedRule {
    /**
     * @stability stable
     */
    readonly priority: number;
    /**
     * @stability stable
     */
    readonly ruleId: string;
    /**
     * @stability stable
     */
    readonly type?: string;
    /**
     * action block.
     *
     * @stability stable
     */
    readonly action: WafregionalRuleGroupActivatedRuleAction[];
}
/**
 * @stability stable
 */
export declare class WafregionalRuleGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafregionalRuleGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _metricName;
    /**
     * @stability stable
     */
    get metricName(): string;
    /**
     * @stability stable
     */
    set metricName(value: string);
    /**
     * @stability stable
     */
    get metricNameInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _activatedRule?;
    /**
     * @stability stable
     */
    get activatedRule(): WafregionalRuleGroupActivatedRule[];
    /**
     * @stability stable
     */
    set activatedRule(value: WafregionalRuleGroupActivatedRule[]);
    /**
     * @stability stable
     */
    resetActivatedRule(): void;
    /**
     * @stability stable
     */
    get activatedRuleInput(): WafregionalRuleGroupActivatedRule[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
