import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafregionalRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly metricName: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * predicate block.
     *
     * @stability stable
     */
    readonly predicate?: WafregionalRulePredicate[];
}
/**
 * @stability stable
 */
export interface WafregionalRulePredicate {
    /**
     * @stability stable
     */
    readonly dataId: string;
    /**
     * @stability stable
     */
    readonly negated: boolean;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export declare class WafregionalRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafregionalRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _metricName;
    /**
     * @stability stable
     */
    get metricName(): string;
    /**
     * @stability stable
     */
    set metricName(value: string);
    /**
     * @stability stable
     */
    get metricNameInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _predicate?;
    /**
     * @stability stable
     */
    get predicate(): WafregionalRulePredicate[];
    /**
     * @stability stable
     */
    set predicate(value: WafregionalRulePredicate[]);
    /**
     * @stability stable
     */
    resetPredicate(): void;
    /**
     * @stability stable
     */
    get predicateInput(): WafregionalRulePredicate[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
