import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafregionalSizeConstraintSetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * size_constraints block.
     *
     * @stability stable
     */
    readonly sizeConstraints?: WafregionalSizeConstraintSetSizeConstraints[];
}
/**
 * @stability stable
 */
export interface WafregionalSizeConstraintSetSizeConstraintsFieldToMatch {
    /**
     * @stability stable
     */
    readonly data?: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafregionalSizeConstraintSetSizeConstraints {
    /**
     * @stability stable
     */
    readonly comparisonOperator: string;
    /**
     * @stability stable
     */
    readonly size: number;
    /**
     * @stability stable
     */
    readonly textTransformation: string;
    /**
     * field_to_match block.
     *
     * @stability stable
     */
    readonly fieldToMatch: WafregionalSizeConstraintSetSizeConstraintsFieldToMatch[];
}
/**
 * @stability stable
 */
export declare class WafregionalSizeConstraintSet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafregionalSizeConstraintSetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _sizeConstraints?;
    /**
     * @stability stable
     */
    get sizeConstraints(): WafregionalSizeConstraintSetSizeConstraints[];
    /**
     * @stability stable
     */
    set sizeConstraints(value: WafregionalSizeConstraintSetSizeConstraints[]);
    /**
     * @stability stable
     */
    resetSizeConstraints(): void;
    /**
     * @stability stable
     */
    get sizeConstraintsInput(): WafregionalSizeConstraintSetSizeConstraints[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
