import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafregionalSqlInjectionMatchSetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * sql_injection_match_tuple block.
     *
     * @stability stable
     */
    readonly sqlInjectionMatchTuple?: WafregionalSqlInjectionMatchSetSqlInjectionMatchTuple[];
}
/**
 * @stability stable
 */
export interface WafregionalSqlInjectionMatchSetSqlInjectionMatchTupleFieldToMatch {
    /**
     * @stability stable
     */
    readonly data?: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafregionalSqlInjectionMatchSetSqlInjectionMatchTuple {
    /**
     * @stability stable
     */
    readonly textTransformation: string;
    /**
     * field_to_match block.
     *
     * @stability stable
     */
    readonly fieldToMatch: WafregionalSqlInjectionMatchSetSqlInjectionMatchTupleFieldToMatch[];
}
/**
 * @stability stable
 */
export declare class WafregionalSqlInjectionMatchSet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafregionalSqlInjectionMatchSetConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _sqlInjectionMatchTuple?;
    /**
     * @stability stable
     */
    get sqlInjectionMatchTuple(): WafregionalSqlInjectionMatchSetSqlInjectionMatchTuple[];
    /**
     * @stability stable
     */
    set sqlInjectionMatchTuple(value: WafregionalSqlInjectionMatchSetSqlInjectionMatchTuple[]);
    /**
     * @stability stable
     */
    resetSqlInjectionMatchTuple(): void;
    /**
     * @stability stable
     */
    get sqlInjectionMatchTupleInput(): WafregionalSqlInjectionMatchSetSqlInjectionMatchTuple[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
