import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafregionalWebAclConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly metricName: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * default_action block.
     *
     * @stability stable
     */
    readonly defaultAction: WafregionalWebAclDefaultAction[];
    /**
     * logging_configuration block.
     *
     * @stability stable
     */
    readonly loggingConfiguration?: WafregionalWebAclLoggingConfiguration[];
    /**
     * rule block.
     *
     * @stability stable
     */
    readonly rule?: WafregionalWebAclRule[];
}
/**
 * @stability stable
 */
export interface WafregionalWebAclDefaultAction {
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafregionalWebAclLoggingConfigurationRedactedFieldsFieldToMatch {
    /**
     * @stability stable
     */
    readonly data?: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafregionalWebAclLoggingConfigurationRedactedFields {
    /**
     * field_to_match block.
     *
     * @stability stable
     */
    readonly fieldToMatch: WafregionalWebAclLoggingConfigurationRedactedFieldsFieldToMatch[];
}
/**
 * @stability stable
 */
export interface WafregionalWebAclLoggingConfiguration {
    /**
     * @stability stable
     */
    readonly logDestination: string;
    /**
     * redacted_fields block.
     *
     * @stability stable
     */
    readonly redactedFields?: WafregionalWebAclLoggingConfigurationRedactedFields[];
}
/**
 * @stability stable
 */
export interface WafregionalWebAclRuleAction {
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafregionalWebAclRuleOverrideAction {
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafregionalWebAclRule {
    /**
     * @stability stable
     */
    readonly priority: number;
    /**
     * @stability stable
     */
    readonly ruleId: string;
    /**
     * @stability stable
     */
    readonly type?: string;
    /**
     * action block.
     *
     * @stability stable
     */
    readonly action?: WafregionalWebAclRuleAction[];
    /**
     * override_action block.
     *
     * @stability stable
     */
    readonly overrideAction?: WafregionalWebAclRuleOverrideAction[];
}
/**
 * @stability stable
 */
export declare class WafregionalWebAcl extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafregionalWebAclConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _metricName;
    /**
     * @stability stable
     */
    get metricName(): string;
    /**
     * @stability stable
     */
    set metricName(value: string);
    /**
     * @stability stable
     */
    get metricNameInput(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _defaultAction;
    /**
     * @stability stable
     */
    get defaultAction(): WafregionalWebAclDefaultAction[];
    /**
     * @stability stable
     */
    set defaultAction(value: WafregionalWebAclDefaultAction[]);
    /**
     * @stability stable
     */
    get defaultActionInput(): WafregionalWebAclDefaultAction[];
    private _loggingConfiguration?;
    /**
     * @stability stable
     */
    get loggingConfiguration(): WafregionalWebAclLoggingConfiguration[];
    /**
     * @stability stable
     */
    set loggingConfiguration(value: WafregionalWebAclLoggingConfiguration[]);
    /**
     * @stability stable
     */
    resetLoggingConfiguration(): void;
    /**
     * @stability stable
     */
    get loggingConfigurationInput(): WafregionalWebAclLoggingConfiguration[] | undefined;
    private _rule?;
    /**
     * @stability stable
     */
    get rule(): WafregionalWebAclRule[];
    /**
     * @stability stable
     */
    set rule(value: WafregionalWebAclRule[]);
    /**
     * @stability stable
     */
    resetRule(): void;
    /**
     * @stability stable
     */
    get ruleInput(): WafregionalWebAclRule[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
