import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WafregionalXssMatchSetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * xss_match_tuple block.
     *
     * @stability stable
     */
    readonly xssMatchTuple?: WafregionalXssMatchSetXssMatchTuple[];
}
/**
 * @stability stable
 */
export interface WafregionalXssMatchSetXssMatchTupleFieldToMatch {
    /**
     * @stability stable
     */
    readonly data?: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WafregionalXssMatchSetXssMatchTuple {
    /**
     * @stability stable
     */
    readonly textTransformation: string;
    /**
     * field_to_match block.
     *
     * @stability stable
     */
    readonly fieldToMatch: WafregionalXssMatchSetXssMatchTupleFieldToMatch[];
}
/**
 * @stability stable
 */
export declare class WafregionalXssMatchSet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WafregionalXssMatchSetConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _xssMatchTuple?;
    /**
     * @stability stable
     */
    get xssMatchTuple(): WafregionalXssMatchSetXssMatchTuple[];
    /**
     * @stability stable
     */
    set xssMatchTuple(value: WafregionalXssMatchSetXssMatchTuple[]);
    /**
     * @stability stable
     */
    resetXssMatchTuple(): void;
    /**
     * @stability stable
     */
    get xssMatchTupleInput(): WafregionalXssMatchSetXssMatchTuple[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
