import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Wafv2RegexPatternSetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly description?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly scope: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * regular_expression block.
     *
     * @stability stable
     */
    readonly regularExpression?: Wafv2RegexPatternSetRegularExpression[];
}
/**
 * @stability stable
 */
export interface Wafv2RegexPatternSetRegularExpression {
    /**
     * @stability stable
     */
    readonly regexString: string;
}
/**
 * @stability stable
 */
export declare class Wafv2RegexPatternSet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Wafv2RegexPatternSetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lockToken(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _scope;
    /**
     * @stability stable
     */
    get scope(): string;
    /**
     * @stability stable
     */
    set scope(value: string);
    /**
     * @stability stable
     */
    get scopeInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _regularExpression?;
    /**
     * @stability stable
     */
    get regularExpression(): Wafv2RegexPatternSetRegularExpression[];
    /**
     * @stability stable
     */
    set regularExpression(value: Wafv2RegexPatternSetRegularExpression[]);
    /**
     * @stability stable
     */
    resetRegularExpression(): void;
    /**
     * @stability stable
     */
    get regularExpressionInput(): Wafv2RegexPatternSetRegularExpression[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
