import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * AWS Kinesis Firehose Delivery Stream ARNs.
     *
     * @stability stable
     */
    readonly logDestinationConfigs: string[];
    /**
     * AWS WebACL ARN.
     *
     * @stability stable
     */
    readonly resourceArn: string;
    /**
     * redacted_fields block.
     *
     * @stability stable
     */
    readonly redactedFields?: Wafv2WebAclLoggingConfigurationRedactedFields[];
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFieldsAllQueryArguments {
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFieldsBody {
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFieldsMethod {
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFieldsQueryString {
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFieldsSingleHeader {
    /**
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFieldsSingleQueryArgument {
    /**
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFieldsUriPath {
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFields {
    /**
     * all_query_arguments block.
     *
     * @stability stable
     */
    readonly allQueryArguments?: Wafv2WebAclLoggingConfigurationRedactedFieldsAllQueryArguments[];
    /**
     * body block.
     *
     * @stability stable
     */
    readonly body?: Wafv2WebAclLoggingConfigurationRedactedFieldsBody[];
    /**
     * method block.
     *
     * @stability stable
     */
    readonly method?: Wafv2WebAclLoggingConfigurationRedactedFieldsMethod[];
    /**
     * query_string block.
     *
     * @stability stable
     */
    readonly queryString?: Wafv2WebAclLoggingConfigurationRedactedFieldsQueryString[];
    /**
     * single_header block.
     *
     * @stability stable
     */
    readonly singleHeader?: Wafv2WebAclLoggingConfigurationRedactedFieldsSingleHeader[];
    /**
     * single_query_argument block.
     *
     * @stability stable
     */
    readonly singleQueryArgument?: Wafv2WebAclLoggingConfigurationRedactedFieldsSingleQueryArgument[];
    /**
     * uri_path block.
     *
     * @stability stable
     */
    readonly uriPath?: Wafv2WebAclLoggingConfigurationRedactedFieldsUriPath[];
}
/**
 * @stability stable
 */
export declare class Wafv2WebAclLoggingConfiguration extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Wafv2WebAclLoggingConfigurationConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _logDestinationConfigs;
    /**
     * @stability stable
     */
    get logDestinationConfigs(): string[];
    /**
     * @stability stable
     */
    set logDestinationConfigs(value: string[]);
    /**
     * @stability stable
     */
    get logDestinationConfigsInput(): string[];
    private _resourceArn;
    /**
     * @stability stable
     */
    get resourceArn(): string;
    /**
     * @stability stable
     */
    set resourceArn(value: string);
    /**
     * @stability stable
     */
    get resourceArnInput(): string;
    private _redactedFields?;
    /**
     * @stability stable
     */
    get redactedFields(): Wafv2WebAclLoggingConfigurationRedactedFields[];
    /**
     * @stability stable
     */
    set redactedFields(value: Wafv2WebAclLoggingConfigurationRedactedFields[]);
    /**
     * @stability stable
     */
    resetRedactedFields(): void;
    /**
     * @stability stable
     */
    get redactedFieldsInput(): Wafv2WebAclLoggingConfigurationRedactedFields[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
