import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WorklinkFleetConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly auditStreamArn?: string;
    /**
     * @stability stable
     */
    readonly deviceCaCertificate?: string;
    /**
     * @stability stable
     */
    readonly displayName?: string;
    /**
     * @stability stable
     */
    readonly name: string;
    /**
     * @stability stable
     */
    readonly optimizeForEndUserLocation?: boolean;
    /**
     * identity_provider block.
     *
     * @stability stable
     */
    readonly identityProvider?: WorklinkFleetIdentityProvider[];
    /**
     * network block.
     *
     * @stability stable
     */
    readonly network?: WorklinkFleetNetwork[];
}
/**
 * @stability stable
 */
export interface WorklinkFleetIdentityProvider {
    /**
     * @stability stable
     */
    readonly samlMetadata: string;
    /**
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WorklinkFleetNetwork {
    /**
     * @stability stable
     */
    readonly securityGroupIds: string[];
    /**
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * @stability stable
     */
    readonly vpcId: string;
}
/**
 * @stability stable
 */
export declare class WorklinkFleet extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WorklinkFleetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _auditStreamArn?;
    /**
     * @stability stable
     */
    get auditStreamArn(): string;
    /**
     * @stability stable
     */
    set auditStreamArn(value: string);
    /**
     * @stability stable
     */
    resetAuditStreamArn(): void;
    /**
     * @stability stable
     */
    get auditStreamArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get companyCode(): string;
    /**
     * @stability stable
     */
    get createdTime(): string;
    private _deviceCaCertificate?;
    /**
     * @stability stable
     */
    get deviceCaCertificate(): string;
    /**
     * @stability stable
     */
    set deviceCaCertificate(value: string);
    /**
     * @stability stable
     */
    resetDeviceCaCertificate(): void;
    /**
     * @stability stable
     */
    get deviceCaCertificateInput(): string | undefined;
    private _displayName?;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    resetDisplayName(): void;
    /**
     * @stability stable
     */
    get displayNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedTime(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _optimizeForEndUserLocation?;
    /**
     * @stability stable
     */
    get optimizeForEndUserLocation(): boolean;
    /**
     * @stability stable
     */
    set optimizeForEndUserLocation(value: boolean);
    /**
     * @stability stable
     */
    resetOptimizeForEndUserLocation(): void;
    /**
     * @stability stable
     */
    get optimizeForEndUserLocationInput(): boolean | undefined;
    private _identityProvider?;
    /**
     * @stability stable
     */
    get identityProvider(): WorklinkFleetIdentityProvider[];
    /**
     * @stability stable
     */
    set identityProvider(value: WorklinkFleetIdentityProvider[]);
    /**
     * @stability stable
     */
    resetIdentityProvider(): void;
    /**
     * @stability stable
     */
    get identityProviderInput(): WorklinkFleetIdentityProvider[] | undefined;
    private _network?;
    /**
     * @stability stable
     */
    get network(): WorklinkFleetNetwork[];
    /**
     * @stability stable
     */
    set network(value: WorklinkFleetNetwork[]);
    /**
     * @stability stable
     */
    resetNetwork(): void;
    /**
     * @stability stable
     */
    get networkInput(): WorklinkFleetNetwork[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
