import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WorkspacesWorkspaceConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly bundleId: string;
    /**
     * @stability stable
     */
    readonly directoryId: string;
    /**
     * @stability stable
     */
    readonly rootVolumeEncryptionEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly userName: string;
    /**
     * @stability stable
     */
    readonly userVolumeEncryptionEnabled?: boolean;
    /**
     * @stability stable
     */
    readonly volumeEncryptionKey?: string;
    /**
     * timeouts block.
     *
     * @stability stable
     */
    readonly timeouts?: WorkspacesWorkspaceTimeouts;
    /**
     * workspace_properties block.
     *
     * @stability stable
     */
    readonly workspaceProperties?: WorkspacesWorkspaceWorkspaceProperties[];
}
/**
 * @stability stable
 */
export interface WorkspacesWorkspaceTimeouts {
    /**
     * @stability stable
     */
    readonly create?: string;
    /**
     * @stability stable
     */
    readonly delete?: string;
    /**
     * @stability stable
     */
    readonly update?: string;
}
/**
 * @stability stable
 */
export interface WorkspacesWorkspaceWorkspaceProperties {
    /**
     * @stability stable
     */
    readonly computeTypeName?: string;
    /**
     * @stability stable
     */
    readonly rootVolumeSizeGib?: number;
    /**
     * @stability stable
     */
    readonly runningMode?: string;
    /**
     * @stability stable
     */
    readonly runningModeAutoStopTimeoutInMinutes?: number;
    /**
     * @stability stable
     */
    readonly userVolumeSizeGib?: number;
}
/**
 * @stability stable
 */
export declare class WorkspacesWorkspace extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WorkspacesWorkspaceConfig);
    private _bundleId;
    /**
     * @stability stable
     */
    get bundleId(): string;
    /**
     * @stability stable
     */
    set bundleId(value: string);
    /**
     * @stability stable
     */
    get bundleIdInput(): string;
    /**
     * @stability stable
     */
    get computerName(): string;
    private _directoryId;
    /**
     * @stability stable
     */
    get directoryId(): string;
    /**
     * @stability stable
     */
    set directoryId(value: string);
    /**
     * @stability stable
     */
    get directoryIdInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ipAddress(): string;
    private _rootVolumeEncryptionEnabled?;
    /**
     * @stability stable
     */
    get rootVolumeEncryptionEnabled(): boolean;
    /**
     * @stability stable
     */
    set rootVolumeEncryptionEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetRootVolumeEncryptionEnabled(): void;
    /**
     * @stability stable
     */
    get rootVolumeEncryptionEnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get state(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _userName;
    /**
     * @stability stable
     */
    get userName(): string;
    /**
     * @stability stable
     */
    set userName(value: string);
    /**
     * @stability stable
     */
    get userNameInput(): string;
    private _userVolumeEncryptionEnabled?;
    /**
     * @stability stable
     */
    get userVolumeEncryptionEnabled(): boolean;
    /**
     * @stability stable
     */
    set userVolumeEncryptionEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetUserVolumeEncryptionEnabled(): void;
    /**
     * @stability stable
     */
    get userVolumeEncryptionEnabledInput(): boolean | undefined;
    private _volumeEncryptionKey?;
    /**
     * @stability stable
     */
    get volumeEncryptionKey(): string;
    /**
     * @stability stable
     */
    set volumeEncryptionKey(value: string);
    /**
     * @stability stable
     */
    resetVolumeEncryptionKey(): void;
    /**
     * @stability stable
     */
    get volumeEncryptionKeyInput(): string | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): WorkspacesWorkspaceTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: WorkspacesWorkspaceTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): WorkspacesWorkspaceTimeouts | undefined;
    private _workspaceProperties?;
    /**
     * @stability stable
     */
    get workspaceProperties(): WorkspacesWorkspaceWorkspaceProperties[];
    /**
     * @stability stable
     */
    set workspaceProperties(value: WorkspacesWorkspaceWorkspaceProperties[]);
    /**
     * @stability stable
     */
    resetWorkspaceProperties(): void;
    /**
     * @stability stable
     */
    get workspacePropertiesInput(): WorkspacesWorkspaceWorkspaceProperties[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
