import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface XrayGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly filterExpression: string;
    /**
     * @stability stable
     */
    readonly groupName: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * @stability stable
 */
export declare class XrayGroup extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: XrayGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _filterExpression;
    /**
     * @stability stable
     */
    get filterExpression(): string;
    /**
     * @stability stable
     */
    set filterExpression(value: string);
    /**
     * @stability stable
     */
    get filterExpressionInput(): string;
    private _groupName;
    /**
     * @stability stable
     */
    get groupName(): string;
    /**
     * @stability stable
     */
    set groupName(value: string);
    /**
     * @stability stable
     */
    get groupNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
