import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface XraySamplingRuleConfig extends cdktf.TerraformMetaArguments {
    /**
     * @stability stable
     */
    readonly attributes?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly fixedRate: number;
    /**
     * @stability stable
     */
    readonly host: string;
    /**
     * @stability stable
     */
    readonly httpMethod: string;
    /**
     * @stability stable
     */
    readonly priority: number;
    /**
     * @stability stable
     */
    readonly reservoirSize: number;
    /**
     * @stability stable
     */
    readonly resourceArn: string;
    /**
     * @stability stable
     */
    readonly ruleName?: string;
    /**
     * @stability stable
     */
    readonly serviceName: string;
    /**
     * @stability stable
     */
    readonly serviceType: string;
    /**
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    readonly urlPath: string;
    /**
     * @stability stable
     */
    readonly version: number;
}
/**
 * @stability stable
 */
export declare class XraySamplingRule extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: XraySamplingRuleConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _attributes?;
    /**
     * @stability stable
     */
    get attributes(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set attributes(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetAttributes(): void;
    /**
     * @stability stable
     */
    get attributesInput(): {
        [key: string]: string;
    } | undefined;
    private _fixedRate;
    /**
     * @stability stable
     */
    get fixedRate(): number;
    /**
     * @stability stable
     */
    set fixedRate(value: number);
    /**
     * @stability stable
     */
    get fixedRateInput(): number;
    private _host;
    /**
     * @stability stable
     */
    get host(): string;
    /**
     * @stability stable
     */
    set host(value: string);
    /**
     * @stability stable
     */
    get hostInput(): string;
    private _httpMethod;
    /**
     * @stability stable
     */
    get httpMethod(): string;
    /**
     * @stability stable
     */
    set httpMethod(value: string);
    /**
     * @stability stable
     */
    get httpMethodInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _priority;
    /**
     * @stability stable
     */
    get priority(): number;
    /**
     * @stability stable
     */
    set priority(value: number);
    /**
     * @stability stable
     */
    get priorityInput(): number;
    private _reservoirSize;
    /**
     * @stability stable
     */
    get reservoirSize(): number;
    /**
     * @stability stable
     */
    set reservoirSize(value: number);
    /**
     * @stability stable
     */
    get reservoirSizeInput(): number;
    private _resourceArn;
    /**
     * @stability stable
     */
    get resourceArn(): string;
    /**
     * @stability stable
     */
    set resourceArn(value: string);
    /**
     * @stability stable
     */
    get resourceArnInput(): string;
    private _ruleName?;
    /**
     * @stability stable
     */
    get ruleName(): string;
    /**
     * @stability stable
     */
    set ruleName(value: string);
    /**
     * @stability stable
     */
    resetRuleName(): void;
    /**
     * @stability stable
     */
    get ruleNameInput(): string | undefined;
    private _serviceName;
    /**
     * @stability stable
     */
    get serviceName(): string;
    /**
     * @stability stable
     */
    set serviceName(value: string);
    /**
     * @stability stable
     */
    get serviceNameInput(): string;
    private _serviceType;
    /**
     * @stability stable
     */
    get serviceType(): string;
    /**
     * @stability stable
     */
    set serviceType(value: string);
    /**
     * @stability stable
     */
    get serviceTypeInput(): string;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _urlPath;
    /**
     * @stability stable
     */
    get urlPath(): string;
    /**
     * @stability stable
     */
    set urlPath(value: string);
    /**
     * @stability stable
     */
    get urlPathInput(): string;
    private _version;
    /**
     * @stability stable
     */
    get version(): number;
    /**
     * @stability stable
     */
    set version(value: number);
    /**
     * @stability stable
     */
    get versionInput(): number;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
